/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/extensions/common/extensions","vs/base/common/extpath","vs/base/common/glob","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","fs","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/codicons","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],pe=function(Y){for(var e=[],m=0,L=Y.length;m<L;m++)e[m]=ge[Y[m]];return e};define(ge[56],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(L,D){if(!L)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=m}),define(ge[73],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function L(T){const I=[];for(let a in T)m.call(T,a)&&I.push(T[a]);return I}e.values=L;function D(T,I){for(let a in T)if(m.call(T,a)&&I({key:a,value:T[a]},function(){delete T[a]})===!1)return}e.forEach=D;function C(T,I){const a=Object.create(null);for(const b of T){const f=I(b);let w=a[f];w||(w=a[f]=[]),w.push(b)}return a}e.groupBy=C;function i(T){const I=Object.create(null);return T&&T.forEach((a,b)=>{I[b]=a}),I}e.fromMap=i;function k(T,I){const a=[],b=[];for(let f of T)I.has(f)||a.push(f);for(let f of I)T.has(f)||b.push(f);return{removed:a,added:b}}e.diffSets=k;function S(T,I){const a=[],b=[];for(let[f,w]of T)I.has(f)||a.push(w);for(let[f,w]of I)T.has(f)||b.push(w);return{removed:a,added:b}}e.diffMaps=S;class y{constructor(){this.map=new Map}add(I,a){let b=this.map.get(I);b||(b=new Set,this.map.set(I,b)),b.add(a)}delete(I,a){const b=this.map.get(I);!b||(b.delete(a),b.size===0&&this.map.delete(I))}forEach(I,a){const b=this.map.get(I);!b||b.forEach(a)}}e.SetMap=y}),define(ge[57],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(i){return(k,S,y)=>{let T=null,I=null;if(typeof y.value=="function"?(T="value",I=y.value):typeof y.get=="function"&&(T="get",I=y.get),!I)throw new Error("not supported");y[T]=i(I,S)}}e.createDecorator=m;function L(i,k,S){let y=null,T=null;if(typeof S.value=="function"?(y="value",T=S.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(y="get",T=S.get),!T)throw new Error("not supported");const I=`$memoize$${k}`;S[y]=function(...a){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,a)}),this[I]}}e.memoize=L;function D(i,k,S){return m((y,T)=>{const I=`$debounce$${T}`,a=`$debounce$result$${T}`;return function(...b){this[a]||(this[a]=S?S():void 0),clearTimeout(this[I]),k&&(this[a]=k(this[a],...b),b=[this[a]]),this[I]=setTimeout(()=>{y.apply(this,b),this[a]=S?S():void 0},i)}})}e.debounce=D;function C(i,k,S){return m((y,T)=>{const I=`$throttle$timer$${T}`,a=`$throttle$result$${T}`,b=`$throttle$lastRun$${T}`,f=`$throttle$pending$${T}`;return function(...w){if(this[a]||(this[a]=S?S():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),k&&(this[a]=k(this[a],...w)),this[f])return;const E=this[b]+i;E<=Date.now()?(this[b]=Date.now(),y.apply(this,[this[a]]),this[a]=S?S():void 0):(this[f]=!0,this[I]=setTimeout(()=>{this[f]=!1,this[b]=Date.now(),y.apply(this,[this[a]]),this[a]=S?S():void 0},E-Date.now()))}})}e.throttle=C}),define(ge[15],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(v=>{v(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=m,e.errorHandler=new m;function L(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=L;function D(g){S(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=D;function C(g){S(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=C;function i(g){if(g instanceof Error){let{name:s,message:v}=g;const n=g.stacktrace||g.stack;return{$isError:!0,name:s,message:v,stack:n}}return g}e.transformErrorForSerialization=i;const k="Canceled";function S(g){return g instanceof Error&&g.name===k&&g.message===k}e.isPromiseCanceledError=S;class y extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=y;function T(){const g=new Error(k);return g.name=g.message,g}e.canceled=T;function I(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=I;function a(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=a;function b(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function f(g){const s=new Error(`${g} has been disposed`);return s.name="DISPOSED",s}e.disposed=f;function w(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=w;class E extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=E;class P extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=P;class p extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=p;function o(g){const s=g;return s instanceof Error&&Array.isArray(s.actions)}e.isErrorWithActions=o;function r(g,s=Object.create(null)){const v=new Error(g);return s.actions&&(v.actions=s.actions),v}e.createErrorWithActions=r}),define(ge[17],pe([0,1,15]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(H,V=0){return H[H.length-(1+V)]}e.tail=L;function D(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.tail2=D;function C(H,V,q=(te,fe)=>te===fe){if(H===V)return!0;if(!H||!V||H.length!==V.length)return!1;for(let te=0,fe=H.length;te<fe;te++)if(!q(H[te],V[te]))return!1;return!0}e.equals=C;function i(H,V,q){let te=0,fe=H.length-1;for(;te<=fe;){const Ce=(te+fe)/2|0,ke=q(H[Ce],V);if(ke<0)te=Ce+1;else if(ke>0)fe=Ce-1;else return Ce}return-(te+1)}e.binarySearch=i;function k(H,V){let q=0,te=H.length;if(te===0)return 0;for(;q<te;){const fe=Math.floor((q+te)/2);V(H[fe])?te=fe:q=fe+1}return q}e.findFirstInSorted=k;function S(H,V,q){if(H=H|0,H>=V.length)throw new TypeError("invalid index");let te=V[Math.floor(V.length*Math.random())],fe=[],Ce=[],ke=[];for(let Ue of V){const xe=q(Ue,te);xe<0?fe.push(Ue):xe>0?Ce.push(Ue):ke.push(Ue)}return H<fe.length?S(H,fe,q):H<fe.length+ke.length?ke[0]:S(H-(fe.length+ke.length),Ce,q)}e.quickSelect=S;function y(H,V){const q=[];let te;for(const fe of H.slice(0).sort(V))!te||V(te[0],fe)!==0?(te=[fe],q.push(te)):te.push(fe);return q}e.groupBy=y;function T(H,V,q){const te=[];function fe(Ue,xe,ze){if(xe===0&&ze.length===0)return;const Q=te[te.length-1];Q&&Q.start+Q.deleteCount===Ue?(Q.deleteCount+=xe,Q.toInsert.push(...ze)):te.push({start:Ue,deleteCount:xe,toInsert:ze})}let Ce=0,ke=0;for(;;){if(Ce===H.length){fe(Ce,0,V.slice(ke));break}if(ke===V.length){fe(Ce,H.length-Ce,[]);break}const Ue=H[Ce],xe=V[ke],ze=q(Ue,xe);ze===0?(Ce+=1,ke+=1):ze<0?(fe(Ce,1,[]),Ce+=1):ze>0&&(fe(Ce,0,[xe]),ke+=1)}return te}e.sortedDiff=T;function I(H,V,q){const te=T(H,V,q),fe=[],Ce=[];for(const ke of te)fe.push(...H.slice(ke.start,ke.start+ke.deleteCount)),Ce.push(...ke.toInsert);return{removed:fe,added:Ce}}e.delta=I;function a(H,V,q){if(q===0)return[];const te=H.slice(0,q).sort(V);return f(H,V,te,q,H.length),te}e.top=a;function b(H,V,q,te,fe){return q===0?Promise.resolve([]):new Promise((Ce,ke)=>{(async()=>{const Ue=H.length,xe=H.slice(0,q).sort(V);for(let ze=q,Q=Math.min(q+te,Ue);ze<Ue;ze=Q,Q=Math.min(Q+te,Ue)){if(ze>q&&await new Promise(Z=>setTimeout(Z)),fe&&fe.isCancellationRequested)throw(0,m.canceled)();f(H,V,xe,ze,Q)}return xe})().then(Ce,ke)})}e.topAsync=b;function f(H,V,q,te,fe){for(const Ce=q.length;te<fe;te++){const ke=H[te];if(V(ke,q[Ce-1])<0){q.pop();const Ue=k(q,xe=>V(ke,xe)<0);q.splice(Ue,0,ke)}}}function w(H){return H.filter(V=>!!V)}e.coalesce=w;function E(H){let V=0;for(let q=0;q<H.length;q++)H[q]&&(H[V]=H[q],V+=1);H.length=V}e.coalesceInPlace=E;function P(H,V,q){H.splice(q,0,H.splice(V,1)[0])}e.move=P;function p(H){return!Array.isArray(H)||H.length===0}e.isFalsyOrEmpty=p;function o(H){return Array.isArray(H)&&H.length>0}e.isNonEmptyArray=o;function r(H,V=q=>q){const q=new Set;return H.filter(te=>{const fe=V(te);return q.has(fe)?!1:(q.add(fe),!0)})}e.distinct=r;function g(H){const V=Object.create(null);return q=>{const te=H(q);return V[te]?!1:(V[te]=!0,!0)}}e.uniqueFilter=g;function s(H,V){const q=v(H,V);if(q!==-1)return H[q]}e.findLast=s;function v(H,V){for(let q=H.length-1;q>=0;q--){const te=H[q];if(V(te))return q}return-1}e.lastIndex=v;function n(H,V){return H.length>0?H[0]:V}e.firstOrDefault=n;function t(H,V,q=(te,fe)=>te===fe){let te=0;for(let fe=0,Ce=Math.min(H.length,V.length);fe<Ce&&q(H[fe],V[fe]);fe++)te++;return te}e.commonPrefixLength=t;function u(H){return[].concat(...H)}e.flatten=u;function d(H,V){let q=typeof V=="number"?H:0;typeof V=="number"?q=H:(q=0,V=H);const te=[];if(q<=V)for(let fe=q;fe<V;fe++)te.push(fe);else for(let fe=q;fe>V;fe--)te.push(fe);return te}e.range=d;function l(H,V,q){return H.reduce((te,fe)=>(te[V(fe)]=q?q(fe):fe,te),Object.create(null))}e.index=l;function h(H,V){return H.push(V),()=>c(H,V)}e.insert=h;function c(H,V){const q=H.indexOf(V);if(q>-1)return H.splice(q,1),V}e.remove=c;function _(H,V,q){const te=H.slice(0,V),fe=H.slice(V);return te.concat(q,fe)}e.arrayInsert=_;function A(H,V){let q;if(typeof V=="number"){let te=V;q=()=>{const fe=Math.sin(te++)*179426549;return fe-Math.floor(fe)}}else q=Math.random;for(let te=H.length-1;te>0;te-=1){const fe=Math.floor(q()*(te+1)),Ce=H[te];H[te]=H[fe],H[fe]=Ce}}e.shuffle=A;function R(H,V){const q=H.indexOf(V);q>-1&&(H.splice(q,1),H.unshift(V))}e.pushToStart=R;function x(H,V){const q=H.indexOf(V);q>-1&&(H.splice(q,1),H.push(V))}e.pushToEnd=x;function O(H,V){return Array.isArray(H)?H.map(V):V(H)}e.mapArrayOrNot=O;function F(H){return Array.isArray(H)?H:[H]}e.asArray=F;function $(H){return H[Math.floor(Math.random()*H.length)]}e.getRandomElement=$;function M(H,V){for(const q of H){const te=V(q);if(te!==void 0)return te}}e.mapFind=M;function B(H,V,q){const te=z(H,V),fe=H.length,Ce=q.length;H.length=fe+Ce;for(let ke=fe-1;ke>=te;ke--)H[ke+Ce]=H[ke];for(let ke=0;ke<Ce;ke++)H[ke+te]=q[ke]}e.insertInto=B;function U(H,V,q,te){const fe=z(H,V),Ce=H.splice(fe,q);return B(H,fe,te),Ce}e.splice=U;function z(H,V){return V<0?Math.max(V+H.length,0):Math.min(V,H.length)}function K(H,V){let q=Number.MAX_SAFE_INTEGER,te=0;return H.forEach((fe,Ce)=>{const ke=V(fe);ke<q&&(q=ke,te=Ce)}),te}e.minIndex=K;function N(H,V){let q=Number.MIN_SAFE_INTEGER,te=0;return H.forEach((fe,Ce)=>{const ke=V(fe);ke>q&&(q=ke,te=Ce)}),te}e.maxIndex=N;class j{constructor(V){this.items=V,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(V){let q=this.firstIdx;for(;q<this.items.length&&V(this.items[q]);)q++;const te=q===this.firstIdx?null:this.items.slice(this.firstIdx,q);return this.firstIdx=q,te}takeFromEndWhile(V){let q=this.lastIdx;for(;q>=0&&V(this.items[q]);)q--;const te=q===this.lastIdx?null:this.items.slice(q+1,this.lastIdx+1);return this.lastIdx=q,te}peek(){return this.items[this.firstIdx]}dequeue(){const V=this.items[this.firstIdx];return this.firstIdx++,V}takeCount(V){const q=this.items.slice(this.firstIdx,this.firstIdx+V);return this.firstIdx+=V,q}}e.ArrayQueue=j}),define(ge[74],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(L){const D=this;let C=!1,i;return function(){return C||(C=!0,i=L.apply(D,arguments)),i}}e.once=m}),define(ge[75],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(ge[76],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(L){function D(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}L.is=D;const C=Object.freeze([]);function i(){return C}L.empty=i;function*k(g){yield g}L.single=k;function S(g){return g||C}L.from=S;function y(g){return!g||g[Symbol.iterator]().next().done===!0}L.isEmpty=y;function T(g){return g[Symbol.iterator]().next().value}L.first=T;function I(g,s){for(const v of g)if(s(v))return!0;return!1}L.some=I;function a(g,s){for(const v of g)if(s(v))return v}L.find=a;function*b(g,s){for(const v of g)s(v)&&(yield v)}L.filter=b;function*f(g,s){let v=0;for(const n of g)yield s(n,v++)}L.map=f;function*w(...g){for(const s of g)for(const v of s)yield v}L.concat=w;function*E(g){for(const s of g)for(const v of s)yield v}L.concatNested=E;function P(g,s,v){let n=v;for(const t of g)n=s(n,t);return n}L.reduce=P;function*p(g,s,v=g.length){for(s<0&&(s+=g.length),v<0?v+=g.length:v>g.length&&(v=g.length);s<v;s++)yield g[s]}L.slice=p;function o(g,s=Number.POSITIVE_INFINITY){const v=[];if(s===0)return[v,g];const n=g[Symbol.iterator]();for(let t=0;t<s;t++){const u=n.next();if(u.done)return[v,L.empty()];v.push(u.value)}return[v,{[Symbol.iterator](){return n}}]}L.consume=o;function r(g,s,v=(n,t)=>n===t){const n=g[Symbol.iterator](),t=s[Symbol.iterator]();for(;;){const u=n.next(),d=t.next();if(u.done!==d.done)return!1;if(u.done)return!0;if(!v(u.value,d.value))return!1}}L.equals=r})(m=e.Iterable||(e.Iterable={}))}),define(ge[58],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var L;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(s){s.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function i(s,v=!1){let n=0,t=s.length,u="",d=0,l=16,h=0;function c($){let M=0,B=0;for(;M<$;){const U=s.charCodeAt(n);if(U>=48&&U<=57)B=B*16+U-48;else if(U>=65&&U<=70)B=B*16+U-65+10;else if(U>=97&&U<=102)B=B*16+U-97+10;else break;n++,M++}return M<$&&(B=-1),B}function _($){n=$,u="",d=0,l=16,h=0}function A(){const $=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&y(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&y(s.charCodeAt(n)))for(n++;n<s.length&&y(s.charCodeAt(n));)n++;else return h=3,s.substring($,n);let M=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&y(s.charCodeAt(n))){for(n++;n<s.length&&y(s.charCodeAt(n));)n++;M=n}else h=3;return s.substring($,M)}function R(){let $="",M=n;for(;;){if(n>=t){$+=s.substring(M,n),h=2;break}const B=s.charCodeAt(n);if(B===34){$+=s.substring(M,n),n++;break}if(B===92){if($+=s.substring(M,n),n++,n>=t){h=2;break}switch(s.charCodeAt(n++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const z=c(4);z>=0?$+=String.fromCharCode(z):h=4;break;default:h=5}M=n;continue}if(B>=0&&B<=31)if(S(B)){$+=s.substring(M,n),h=2;break}else h=6;n++}return $}function x(){if(u="",h=0,d=n,n>=t)return d=t,l=17;let $=s.charCodeAt(n);if(k($)){do n++,u+=String.fromCharCode($),$=s.charCodeAt(n);while(k($));return l=15}if(S($))return n++,u+=String.fromCharCode($),$===13&&s.charCodeAt(n)===10&&(n++,u+=`
`),l=14;switch($){case 123:return n++,l=1;case 125:return n++,l=2;case 91:return n++,l=3;case 93:return n++,l=4;case 58:return n++,l=6;case 44:return n++,l=5;case 34:return n++,u=R(),l=10;case 47:const M=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<t&&!S(s.charCodeAt(n));)n++;return u=s.substring(M,n),l=12}if(s.charCodeAt(n+1)===42){n+=2;const B=t-1;let U=!1;for(;n<B;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,U=!0;break}n++}return U||(n++,h=1),u=s.substring(M,n),l=13}return u+=String.fromCharCode($),n++,l=16;case 45:if(u+=String.fromCharCode($),n++,n===t||!y(s.charCodeAt(n)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=A(),l=11;default:for(;n<t&&O($);)n++,$=s.charCodeAt(n);if(d!==n){switch(u=s.substring(d,n),u){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return u+=String.fromCharCode($),n++,l=16}}function O($){if(k($)||S($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let $;do $=x();while($>=12&&$<=15);return $}return{setPosition:_,getPosition:()=>n,scan:v?F:x,getToken:()=>l,getTokenValue:()=>u,getTokenOffset:()=>d,getTokenLength:()=>n-d,getTokenError:()=>h}}e.createScanner=i;function k(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function S(s){return s===10||s===13||s===8232||s===8233}function y(s){return s>=48&&s<=57}var T;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(T||(T={}));function I(s,v){const n=[],t=new Object;let u;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function h(c,_,A,R){d.value=c,d.offset=_,d.length=A,d.type=R,d.colonOffset=void 0,u=d}try{o(s,{onObjectBegin:(c,_)=>{if(v<=c)throw t;u=void 0,l=v>c,n.push("")},onObjectProperty:(c,_,A)=>{if(v<_||(h(c,_,A,"property"),n[n.length-1]=c,v<=_+A))throw t},onObjectEnd:(c,_)=>{if(v<=c)throw t;u=void 0,n.pop()},onArrayBegin:(c,_)=>{if(v<=c)throw t;u=void 0,n.push(0)},onArrayEnd:(c,_)=>{if(v<=c)throw t;u=void 0,n.pop()},onLiteralValue:(c,_,A)=>{if(v<_||(h(c,_,A,g(c)),v<=_+A))throw t},onSeparator:(c,_,A)=>{if(v<=_)throw t;if(c===":"&&u&&u.type==="property")u.colonOffset=_,l=!1,u=void 0;else if(c===","){const R=n[n.length-1];typeof R=="number"?n[n.length-1]=R+1:(l=!0,n[n.length-1]=""),u=void 0}}})}catch(c){if(c!==t)throw c}return{path:n,previousNode:u,isAtPropertyKey:l,matches:c=>{let _=0;for(let A=0;_<c.length&&A<n.length;A++)if(c[_]===n[A]||c[_]==="*")_++;else if(c[_]!=="**")return!1;return _===c.length}}}e.getLocation=I;function a(s,v=[],n=C.DEFAULT){let t=null,u=[];const d=[];function l(c){Array.isArray(u)?u.push(c):t!==null&&(u[t]=c)}return o(s,{onObjectBegin:()=>{const c={};l(c),d.push(u),u=c,t=null},onObjectProperty:c=>{t=c},onObjectEnd:()=>{u=d.pop()},onArrayBegin:()=>{const c=[];l(c),d.push(u),u=c,t=null},onArrayEnd:()=>{u=d.pop()},onLiteralValue:l,onError:(c,_,A)=>{v.push({error:c,offset:_,length:A})}},n),u[0]}e.parse=a;function b(s,v=[],n=C.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(c){t.type==="property"&&(t.length=c-t.offset,t=t.parent)}function d(c){return t.children.push(c),c}o(s,{onObjectBegin:c=>{t=d({type:"object",offset:c,length:-1,parent:t,children:[]})},onObjectProperty:(c,_,A)=>{t=d({type:"property",offset:_,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:c,offset:_,length:A,parent:t})},onObjectEnd:(c,_)=>{t.length=c+_-t.offset,t=t.parent,u(c+_)},onArrayBegin:(c,_)=>{t=d({type:"array",offset:c,length:-1,parent:t,children:[]})},onArrayEnd:(c,_)=>{t.length=c+_-t.offset,t=t.parent,u(c+_)},onLiteralValue:(c,_,A)=>{d({type:g(c),offset:_,length:A,parent:t,value:c}),u(_+A)},onSeparator:(c,_,A)=>{t.type==="property"&&(c===":"?t.colonOffset=_:c===","&&u(_))},onError:(c,_,A)=>{v.push({error:c,offset:_,length:A})}},n);const h=t.children[0];return h&&delete h.parent,h}e.parseTree=b;function f(s,v){if(!s)return;let n=s;for(let t of v)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let u=!1;for(const d of n.children)if(Array.isArray(d.children)&&d.children[0].value===t){n=d.children[1],u=!0;break}if(!u)return}else{const u=t;if(n.type!=="array"||u<0||!Array.isArray(n.children)||u>=n.children.length)return;n=n.children[u]}return n}e.findNodeAtLocation=f;function w(s){if(!s.parent||!s.parent.children)return[];const v=w(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;v.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&v.push(n)}return v}e.getNodePath=w;function E(s){switch(s.type){case"array":return s.children.map(E);case"object":const v=Object.create(null);for(let n of s.children){const t=n.children[1];t&&(v[n.children[0].value]=E(t))}return v;case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=E;function P(s,v,n=!1){return v>=s.offset&&v<s.offset+s.length||n&&v===s.offset+s.length}e.contains=P;function p(s,v,n=!1){if(P(s,v,n)){const t=s.children;if(Array.isArray(t))for(let u=0;u<t.length&&t[u].offset<=v;u++){const d=p(t[u],v,n);if(d)return d}return s}}e.findNodeAtOffset=p;function o(s,v,n=C.DEFAULT){const t=i(s,!1);function u(q){return q?()=>q(t.getTokenOffset(),t.getTokenLength()):()=>!0}function d(q){return q?te=>q(te,t.getTokenOffset(),t.getTokenLength()):()=>!0}const l=u(v.onObjectBegin),h=d(v.onObjectProperty),c=u(v.onObjectEnd),_=u(v.onArrayBegin),A=u(v.onArrayEnd),R=d(v.onLiteralValue),x=d(v.onSeparator),O=u(v.onComment),F=d(v.onError),$=n&&n.disallowComments,M=n&&n.allowTrailingComma;function B(){for(;;){const q=t.scan();switch(t.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:$||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(q){case 12:case 13:$?U(10):O();break;case 16:U(1);break;case 15:case 14:break;default:return q}}}function U(q,te=[],fe=[]){if(F(q),te.length+fe.length>0){let Ce=t.getToken();for(;Ce!==17;){if(te.indexOf(Ce)!==-1){B();break}else if(fe.indexOf(Ce)!==-1)break;Ce=B()}}}function z(q){const te=t.getTokenValue();return q?R(te):h(te),B(),!0}function K(){switch(t.getToken()){case 11:let q=0;try{q=JSON.parse(t.getTokenValue()),typeof q!="number"&&(U(2),q=0)}catch(te){U(2)}R(q);break;case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return B(),!0}function N(){return t.getToken()!==10?(U(3,[],[2,5]),!1):(z(!1),t.getToken()===6?(x(":"),B(),V()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function j(){l(),B();let q=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(q||U(4,[],[]),x(","),B(),t.getToken()===2&&M)break}else q&&U(6,[],[]);N()||U(4,[],[2,5]),q=!0}return c(),t.getToken()!==2?U(7,[2],[]):B(),!0}function H(){_(),B();let q=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(q||U(4,[],[]),x(","),B(),t.getToken()===4&&M)break}else q&&U(6,[],[]);V()||U(4,[],[4,5]),q=!0}return A(),t.getToken()!==4?U(8,[4],[]):B(),!0}function V(){switch(t.getToken()){case 3:return H();case 1:return j();case 10:return z(!0);default:return K()}}return B(),t.getToken()===17?n.allowEmptyContent?!0:(U(4,[],[]),!1):V()?(t.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=o;function r(s,v){let n=i(s),t=[],u,d=0,l;do switch(l=n.getPosition(),u=n.scan(),u){case 12:case 13:case 17:d!==l&&t.push(s.substring(d,l)),v!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,v)),d=n.getPosition();break}while(u!==17);return t.join("")}e.stripComments=r;function g(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(ge[138],pe([0,1,58]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(S,y,T){let I,a,b,f,w;if(y){for(f=y.offset,w=f+y.length,b=f;b>0&&!k(S,b-1);)b--;let d=w;for(;d<S.length&&!k(S,d);)d++;a=S.substring(b,d),I=C(a,T)}else a=S,I=0,b=0,f=0,w=S.length;const E=i(T,S);let P=!1,p=0,o;T.insertSpaces?o=D(" ",T.tabSize||4):o="	";const r=(0,m.createScanner)(a,!1);let g=!1;function s(){return E+D(o,I+p)}function v(){let d=r.scan();for(P=!1;d===15||d===14;)P=P||d===14,d=r.scan();return g=d===16||r.getTokenError()!==0,d}const n=[];function t(d,l,h){!g&&l<w&&h>f&&S.substring(l,h)!==d&&n.push({offset:l,length:h-l,content:d})}let u=v();if(u!==17){const d=r.getTokenOffset()+b,l=D(o,I);t(l,b,d)}for(;u!==17;){let d=r.getTokenOffset()+r.getTokenLength()+b,l=v(),h="";for(;!P&&(l===12||l===13);){const _=r.getTokenOffset()+b;t(" ",d,_),d=r.getTokenOffset()+r.getTokenLength()+b,h=l===12?s():"",l=v()}if(l===2)u!==1&&(p--,h=s());else if(l===4)u!==3&&(p--,h=s());else{switch(u){case 3:case 1:p++,h=s();break;case 5:case 12:h=s();break;case 13:P?h=s():h=" ";break;case 6:h=" ";break;case 10:if(l===6){h="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?h=" ":l!==5&&l!==17&&(g=!0);break;case 16:g=!0;break}P&&(l===12||l===13)&&(h=s())}const c=r.getTokenOffset()+b;t(h,d,c),u=l}return n}e.format=L;function D(S,y){let T="";for(let I=0;I<y;I++)T+=S;return T}function C(S,y){let T=0,I=0;const a=y.tabSize||4;for(;T<S.length;){const b=S.charAt(T);if(b===" ")I++;else if(b==="	")I+=a;else break;T++}return Math.floor(I/a)}function i(S,y){for(let T=0;T<y.length;T++){const I=y.charAt(T);if(I==="\r")return T+1<y.length&&y.charAt(T+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=i;function k(S,y){return`\r
`.indexOf(S.charAt(y))!==-1}e.isEOL=k}),define(ge[139],pe([0,1,58,138]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(y,T,I){return C(y,T,void 0,I)}e.removeProperty=D;function C(y,T,I,a,b){const f=T.slice(),w=[],E=(0,m.parseTree)(y,w);let P,p;for(;f.length>0&&(p=f.pop(),P=(0,m.findNodeAtLocation)(E,f),P===void 0&&I!==void 0);)typeof p=="string"?I={[p]:I}:I=[I];if(P)if(P.type==="object"&&typeof p=="string"&&Array.isArray(P.children)){const o=(0,m.findNodeAtLocation)(P,[p]);if(o!==void 0)if(I===void 0){if(!o.parent)throw new Error("Malformed AST");const r=P.children.indexOf(o.parent);let g,s=o.parent.offset+o.parent.length;if(r>0){const v=P.children[r-1];g=v.offset+v.length}else g=P.offset+1,P.children.length>1&&(s=P.children[1].offset);return i(y,{offset:g,length:s-g,content:""},a)}else return i(y,{offset:o.offset,length:o.length,content:JSON.stringify(I)},a);else{if(I===void 0)return[];const r=`${JSON.stringify(p)}: ${JSON.stringify(I)}`,g=b?b(P.children.map(v=>v.children[0].value)):P.children.length;let s;if(g>0){const v=P.children[g-1];s={offset:v.offset+v.length,length:0,content:","+r}}else P.children.length===0?s={offset:P.offset+1,length:0,content:r}:s={offset:P.offset+1,length:0,content:r+","};return i(y,s,a)}}else if(P.type==="array"&&typeof p=="number"&&Array.isArray(P.children))if(I!==void 0){const o=`${JSON.stringify(I)}`;let r;if(P.children.length===0||p===0)r={offset:P.offset+1,length:0,content:P.children.length===0?o:o+","};else{const g=p===-1||p>P.children.length?P.children.length:p,s=P.children[g-1];r={offset:s.offset+s.length,length:0,content:","+o}}return i(y,r,a)}else{const o=p,r=P.children[o];let g;if(P.children.length===1)g={offset:P.offset+1,length:P.length-2,content:""};else if(P.children.length-1===o){const s=P.children[o-1],v=s.offset+s.length,n=P.offset+P.length;g={offset:v,length:n-2-v,content:""}}else g={offset:r.offset,length:P.children[o+1].offset-r.offset,content:""};return i(y,g,a)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${P.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return i(y,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(I)},a)}}e.setProperty=C;function i(y,T,I){let a=k(y,T),b=T.offset,f=T.offset+T.content.length;if(T.length===0||T.content.length===0){for(;b>0&&!(0,L.isEOL)(a,b-1);)b--;for(;f<a.length&&!(0,L.isEOL)(a,f);)f++}const w=(0,L.format)(a,{offset:b,length:f-b},I);for(let P=w.length-1;P>=0;P--){const p=w[P];a=k(a,p),b=Math.min(b,p.offset),f=Math.max(f,p.offset+p.length),f+=p.content.length-p.length}const E=y.length-(a.length-f)-b;return[{offset:b,length:E,content:a.substring(b,f)}]}e.withFormatting=i;function k(y,T){return y.substring(0,T.offset)+T.content+y.substring(T.offset+T.length)}e.applyEdit=k;function S(y,T){let I=T.slice(0).sort((b,f)=>{const w=b.offset-f.offset;return w===0?b.length-f.length:w}),a=y.length;for(let b=I.length-1;b>=0;b--){let f=I[b];if(f.offset+f.length<=a)y=k(y,f);else throw new Error("Overlapping edit");a=f.offset}return y}e.applyEdits=S}),define(ge[140],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new m(()=>D(this.getValue()))}}e.Lazy=m}),define(ge[6],pe([0,1,74,76]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let C=null;function i(t){C=t}if(e.setDisposableTracker=i,D){const t="__is_disposable_tracked__";i(new class{trackDisposable(u){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[t]||console.log(d)},3e3)}setParent(u,d){if(u&&u!==p.None)try{u[t]=!0}catch{}}markAsDisposed(u){if(u&&u!==p.None)try{u[t]=!0}catch{}}markAsSingleton(u){}})}function k(t){return C?.trackDisposable(t),t}function S(t){C?.markAsDisposed(t)}function y(t,u){C?.setParent(t,u)}function T(t,u){if(!!C)for(const d of t)C.setParent(d,u)}function I(t){return C?.markAsSingleton(t),t}e.markAsSingleton=I;class a extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}e.MultiDisposeError=a;function b(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=b;function f(t){if(L.Iterable.is(t)){let u=[];for(const d of t)if(d)try{d.dispose()}catch(l){u.push(l)}if(u.length===1)throw u[0];if(u.length>1)throw new a(u);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=f;function w(...t){const u=E(()=>f(t));return T(t,u),u}e.combinedDisposable=w;function E(t){const u=k({dispose:(0,m.once)(()=>{S(u),t()})});return u}e.toDisposable=E;class P{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{f(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return y(u,this),this._isDisposed?P.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=P,P.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new P,k(this),y(this._store,this)}dispose(){S(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class o{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){this._isDisposed||u===this._value||(this._value?.dispose(),u&&y(u,this),this._value=u)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const u=this._value;return this._value=void 0,u&&y(u,null),u}}e.MutableDisposable=o;class r{constructor(u){this._disposable=u,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=r;class g{constructor(){this.references=new Map}acquire(u,...d){let l=this.references.get(u);l||(l={counter:0,object:this.createReferencedObject(u,...d)},this.references.set(u,l));const{object:h}=l,c=(0,m.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(u,l.object),this.references.delete(u))});return l.counter++,{object:h,dispose:c}}}e.ReferenceCollection=g;class s{constructor(u){this.referenceCollection=u}async acquire(u,...d){const l=this.referenceCollection.acquire(u,...d);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(h){throw l.dispose(),h}}}e.AsyncReferenceCollection=s;class v{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=v;function n(t){const u=new P;try{t(u)}finally{u.dispose()}}e.disposeOnReturn=n}),define(ge[93],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(C){this.element=C,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class L{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let C=this._first;for(;C!==m.Undefined;){const i=C.next;C.prev=m.Undefined,C.next=m.Undefined,C=i}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,i){const k=new m(C);if(this._first===m.Undefined)this._first=k,this._last=k;else if(i){const y=this._last;this._last=k,k.prev=y,y.next=k}else{const y=this._first;this._first=k,k.next=y,y.prev=k}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(k))}}shift(){if(this._first!==m.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==m.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==m.Undefined&&C.next!==m.Undefined){const i=C.prev;i.next=C.next,C.next.prev=i}else C.prev===m.Undefined&&C.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):C.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):C.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==m.Undefined;)yield C.element,C=C.next}}e.LinkedList=L}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(Te,ye){for(var be=0;be<ye.length;be++){var ae=ye[be];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(Te,ae.key,ae)}}function e(Te,ye,be){return ye&&Y(Te.prototype,ye),be&&Y(Te,be),Te}function m(Te,ye){if(!!Te){if(typeof Te=="string")return L(Te,ye);var be=Object.prototype.toString.call(Te).slice(8,-1);if(be==="Object"&&Te.constructor&&(be=Te.constructor.name),be==="Map"||be==="Set")return Array.from(Te);if(be==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(be))return L(Te,ye)}}function L(Te,ye){(ye==null||ye>Te.length)&&(ye=Te.length);for(var be=0,ae=new Array(ye);be<ye;be++)ae[be]=Te[be];return ae}function D(Te,ye){var be=typeof Symbol!="undefined"&&Te[Symbol.iterator]||Te["@@iterator"];if(be)return(be=be.call(Te)).next.bind(be);if(Array.isArray(Te)||(be=m(Te))||ye&&Te&&typeof Te.length=="number"){be&&(Te=be);var ae=0;return function(){return ae>=Te.length?{done:!0}:{done:!1,value:Te[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var C={exports:{}};function i(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Te){C.exports.defaults=Te}C.exports={defaults:i(),getDefaults:i,changeDefaults:k};var S=/[&<>"']/,y=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(ye){return a[ye]};function f(Te,ye){if(ye){if(S.test(Te))return Te.replace(y,b)}else if(T.test(Te))return Te.replace(I,b);return Te}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function E(Te){return Te.replace(w,function(ye,be){return be=be.toLowerCase(),be==="colon"?":":be.charAt(0)==="#"?be.charAt(1)==="x"?String.fromCharCode(parseInt(be.substring(2),16)):String.fromCharCode(+be.substring(1)):""})}var P=/(^|[^\[])\^/g;function p(Te,ye){Te=Te.source||Te,ye=ye||"";var be={replace:function(de,ve){return ve=ve.source||ve,ve=ve.replace(P,"$1"),Te=Te.replace(de,ve),be},getRegex:function(){return new RegExp(Te,ye)}};return be}var o=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(Te,ye,be){if(Te){var ae;try{ae=decodeURIComponent(E(be)).replace(o,"").toLowerCase()}catch(de){return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}ye&&!r.test(be)&&(be=u(ye,be));try{be=encodeURI(be).replace(/%25/g,"%")}catch(de){return null}return be}var s={},v=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(Te,ye){s[" "+Te]||(v.test(Te)?s[" "+Te]=Te+"/":s[" "+Te]=c(Te,"/",!0)),Te=s[" "+Te];var be=Te.indexOf(":")===-1;return ye.substring(0,2)==="//"?be?ye:Te.replace(n,"$1")+ye:ye.charAt(0)==="/"?be?ye:Te.replace(t,"$1")+ye:Te+ye}var d={exec:function(){}};function l(Te){for(var ye=1,be,ae;ye<arguments.length;ye++){be=arguments[ye];for(ae in be)Object.prototype.hasOwnProperty.call(be,ae)&&(Te[ae]=be[ae])}return Te}function h(Te,ye){var be=Te.replace(/\|/g,function(ve,Ee,Fe){for(var Qe=!1,$e=Ee;--$e>=0&&Fe[$e]==="\\";)Qe=!Qe;return Qe?"|":" |"}),ae=be.split(/ \|/),de=0;if(ae[0].trim()||ae.shift(),ae[ae.length-1].trim()||ae.pop(),ae.length>ye)ae.splice(ye);else for(;ae.length<ye;)ae.push("");for(;de<ae.length;de++)ae[de]=ae[de].trim().replace(/\\\|/g,"|");return ae}function c(Te,ye,be){var ae=Te.length;if(ae===0)return"";for(var de=0;de<ae;){var ve=Te.charAt(ae-de-1);if(ve===ye&&!be)de++;else if(ve!==ye&&be)de++;else break}return Te.substr(0,ae-de)}function _(Te,ye){if(Te.indexOf(ye[1])===-1)return-1;for(var be=Te.length,ae=0,de=0;de<be;de++)if(Te[de]==="\\")de++;else if(Te[de]===ye[0])ae++;else if(Te[de]===ye[1]&&(ae--,ae<0))return de;return-1}function A(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Te,ye){if(ye<1)return"";for(var be="";ye>1;)ye&1&&(be+=Te),ye>>=1,Te+=Te;return be+Te}var x={escape:f,unescape:E,edit:p,cleanUrl:g,resolveUrl:u,noopTest:d,merge:l,splitCells:h,rtrim:c,findClosingBracket:_,checkSanitizeDeprecation:A,repeatString:R},O=C.exports.defaults,F=x.rtrim,$=x.splitCells,M=x.escape,B=x.findClosingBracket;function U(Te,ye,be,ae){var de=ye.href,ve=ye.title?M(ye.title):null,Ee=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){ae.state.inLink=!0;var Fe={type:"link",raw:be,href:de,title:ve,text:Ee,tokens:ae.inlineTokens(Ee,[])};return ae.state.inLink=!1,Fe}else return{type:"image",raw:be,href:de,title:ve,text:M(Ee)}}function z(Te,ye){var be=Te.match(/^(\s+)(?:```)/);if(be===null)return ye;var ae=be[1];return ye.split(`
`).map(function(de){var ve=de.match(/^\s+/);if(ve===null)return de;var Ee=ve[0];return Ee.length>=ae.length?de.slice(ae.length):de}).join(`
`)}var K=function(){function Te(be){this.options=be||O}var ye=Te.prototype;return ye.space=function(ae){var de=this.rules.block.newline.exec(ae);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},ye.code=function(ae){var de=this.rules.block.code.exec(ae);if(de){var ve=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?ve:F(ve,`
`)}}},ye.fences=function(ae){var de=this.rules.block.fences.exec(ae);if(de){var ve=de[0],Ee=z(ve,de[3]||"");return{type:"code",raw:ve,lang:de[2]?de[2].trim():de[2],text:Ee}}},ye.heading=function(ae){var de=this.rules.block.heading.exec(ae);if(de){var ve=de[2].trim();if(/#$/.test(ve)){var Ee=F(ve,"#");(this.options.pedantic||!Ee||/ $/.test(Ee))&&(ve=Ee.trim())}var Fe={type:"heading",raw:de[0],depth:de[1].length,text:ve,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},ye.hr=function(ae){var de=this.rules.block.hr.exec(ae);if(de)return{type:"hr",raw:de[0]}},ye.blockquote=function(ae){var de=this.rules.block.blockquote.exec(ae);if(de){var ve=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(ve,[]),text:ve}}},ye.list=function(ae){var de=this.rules.block.list.exec(ae);if(de){var ve,Ee,Fe,Qe,$e,Xe,at,ct,ce,_e,le=de[1].trim(),X=le.length>1,De={type:"list",raw:"",ordered:X,start:X?+le.slice(0,-1):"",loose:!1,items:[]};le=X?"\\d{1,9}\\"+le.slice(-1):"\\"+le,this.options.pedantic&&(le=X?le:"[*+-]");for(var Le=new RegExp("^( {0,3}"+le+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ae&&!(this.rules.block.hr.test(ae)||!(de=Le.exec(ae)));){ce=de[2].split(`
`),this.options.pedantic?(Qe=2,_e=ce[0].trimLeft()):(Qe=de[2].search(/[^ ]/),Qe=de[1].length+(Qe>4?1:Qe),_e=ce[0].slice(Qe-de[1].length)),Xe=!1,ve=de[0],!ce[0]&&/^ *$/.test(ce[1])&&(ve=de[1]+ce.slice(0,2).join(`
`)+`
`,De.loose=!0,ce=[]);var et=new RegExp("^ {0,"+Math.min(3,Qe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for($e=1;$e<ce.length;$e++){if(ct=ce[$e],this.options.pedantic&&(ct=ct.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),et.test(ct)){ve=de[1]+ce.slice(0,$e).join(`
`)+`
`;break}if(!Xe){ct.trim()||(Xe=!0),ct.search(/[^ ]/)>=Qe?_e+=`
`+ct.slice(Qe):_e+=`
`+ct;continue}if(ct.search(/[^ ]/)>=Qe||!ct.trim()){_e+=`
`+ct.slice(Qe);continue}else{ve=de[1]+ce.slice(0,$e).join(`
`)+`
`;break}}De.loose||(at?De.loose=!0:/\n *\n *$/.test(ve)&&(at=!0)),this.options.gfm&&(Ee=/^\[[ xX]\] /.exec(_e),Ee&&(Fe=Ee[0]!=="[ ] ",_e=_e.replace(/^\[[ xX]\] +/,""))),De.items.push({type:"list_item",raw:ve,task:!!Ee,checked:Fe,loose:!1,text:_e}),De.raw+=ve,ae=ae.slice(ve.length)}De.items[De.items.length-1].raw=ve.trimRight(),De.items[De.items.length-1].text=_e.trimRight(),De.raw=De.raw.trimRight();var qe=De.items.length;for($e=0;$e<qe;$e++)this.lexer.state.top=!1,De.items[$e].tokens=this.lexer.blockTokens(De.items[$e].text,[]),De.items[$e].tokens.some(function(mt){return mt.type==="space"})&&(De.loose=!0,De.items[$e].loose=!0);return De}},ye.html=function(ae){var de=this.rules.block.html.exec(ae);if(de){var ve={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};return this.options.sanitize&&(ve.type="paragraph",ve.text=this.options.sanitizer?this.options.sanitizer(de[0]):M(de[0]),ve.tokens=[],this.lexer.inline(ve.text,ve.tokens)),ve}},ye.def=function(ae){var de=this.rules.block.def.exec(ae);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var ve=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ve,raw:de[0],href:de[2],title:de[3]}}},ye.table=function(ae){var de=this.rules.block.table.exec(ae);if(de){var ve={type:"table",header:$(de[1]).map(function(at){return{text:at}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(ve.header.length===ve.align.length){ve.raw=de[0];var Ee=ve.align.length,Fe,Qe,$e,Xe;for(Fe=0;Fe<Ee;Fe++)/^ *-+: *$/.test(ve.align[Fe])?ve.align[Fe]="right":/^ *:-+: *$/.test(ve.align[Fe])?ve.align[Fe]="center":/^ *:-+ *$/.test(ve.align[Fe])?ve.align[Fe]="left":ve.align[Fe]=null;for(Ee=ve.rows.length,Fe=0;Fe<Ee;Fe++)ve.rows[Fe]=$(ve.rows[Fe],ve.header.length).map(function(at){return{text:at}});for(Ee=ve.header.length,Qe=0;Qe<Ee;Qe++)ve.header[Qe].tokens=[],this.lexer.inlineTokens(ve.header[Qe].text,ve.header[Qe].tokens);for(Ee=ve.rows.length,Qe=0;Qe<Ee;Qe++)for(Xe=ve.rows[Qe],$e=0;$e<Xe.length;$e++)Xe[$e].tokens=[],this.lexer.inlineTokens(Xe[$e].text,Xe[$e].tokens);return ve}}},ye.lheading=function(ae){var de=this.rules.block.lheading.exec(ae);if(de){var ve={type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:[]};return this.lexer.inline(ve.text,ve.tokens),ve}},ye.paragraph=function(ae){var de=this.rules.block.paragraph.exec(ae);if(de){var ve={type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1],tokens:[]};return this.lexer.inline(ve.text,ve.tokens),ve}},ye.text=function(ae){var de=this.rules.block.text.exec(ae);if(de){var ve={type:"text",raw:de[0],text:de[0],tokens:[]};return this.lexer.inline(ve.text,ve.tokens),ve}},ye.escape=function(ae){var de=this.rules.inline.escape.exec(ae);if(de)return{type:"escape",raw:de[0],text:M(de[1])}},ye.tag=function(ae){var de=this.rules.inline.tag.exec(ae);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):M(de[0]):de[0]}},ye.link=function(ae){var de=this.rules.inline.link.exec(ae);if(de){var ve=de[2].trim();if(!this.options.pedantic&&/^</.test(ve)){if(!/>$/.test(ve))return;var Ee=F(ve.slice(0,-1),"\\");if((ve.length-Ee.length)%2==0)return}else{var Fe=B(de[2],"()");if(Fe>-1){var Qe=de[0].indexOf("!")===0?5:4,$e=Qe+de[1].length+Fe;de[2]=de[2].substring(0,Fe),de[0]=de[0].substring(0,$e).trim(),de[3]=""}}var Xe=de[2],at="";if(this.options.pedantic){var ct=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Xe);ct&&(Xe=ct[1],at=ct[3])}else at=de[3]?de[3].slice(1,-1):"";return Xe=Xe.trim(),/^</.test(Xe)&&(this.options.pedantic&&!/>$/.test(ve)?Xe=Xe.slice(1):Xe=Xe.slice(1,-1)),U(de,{href:Xe&&Xe.replace(this.rules.inline._escapes,"$1"),title:at&&at.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},ye.reflink=function(ae,de){var ve;if((ve=this.rules.inline.reflink.exec(ae))||(ve=this.rules.inline.nolink.exec(ae))){var Ee=(ve[2]||ve[1]).replace(/\s+/g," ");if(Ee=de[Ee.toLowerCase()],!Ee||!Ee.href){var Fe=ve[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return U(ve,Ee,ve[0],this.lexer)}},ye.emStrong=function(ae,de,ve){ve===void 0&&(ve="");var Ee=this.rules.inline.emStrong.lDelim.exec(ae);if(!!Ee&&!(Ee[3]&&ve.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=Ee[1]||Ee[2]||"";if(!Fe||Fe&&(ve===""||this.rules.inline.punctuation.exec(ve))){var Qe=Ee[0].length-1,$e,Xe,at=Qe,ct=0,ce=Ee[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ce.lastIndex=0,de=de.slice(-1*ae.length+Qe);(Ee=ce.exec(de))!=null;)if($e=Ee[1]||Ee[2]||Ee[3]||Ee[4]||Ee[5]||Ee[6],!!$e){if(Xe=$e.length,Ee[3]||Ee[4]){at+=Xe;continue}else if((Ee[5]||Ee[6])&&Qe%3&&!((Qe+Xe)%3)){ct+=Xe;continue}if(at-=Xe,!(at>0)){if(Xe=Math.min(Xe,Xe+at+ct),Math.min(Qe,Xe)%2){var _e=ae.slice(1,Qe+Ee.index+Xe);return{type:"em",raw:ae.slice(0,Qe+Ee.index+Xe+1),text:_e,tokens:this.lexer.inlineTokens(_e,[])}}var le=ae.slice(2,Qe+Ee.index+Xe-1);return{type:"strong",raw:ae.slice(0,Qe+Ee.index+Xe+1),text:le,tokens:this.lexer.inlineTokens(le,[])}}}}}},ye.codespan=function(ae){var de=this.rules.inline.code.exec(ae);if(de){var ve=de[2].replace(/\n/g," "),Ee=/[^ ]/.test(ve),Fe=/^ /.test(ve)&&/ $/.test(ve);return Ee&&Fe&&(ve=ve.substring(1,ve.length-1)),ve=M(ve,!0),{type:"codespan",raw:de[0],text:ve}}},ye.br=function(ae){var de=this.rules.inline.br.exec(ae);if(de)return{type:"br",raw:de[0]}},ye.del=function(ae){var de=this.rules.inline.del.exec(ae);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2],[])}},ye.autolink=function(ae,de){var ve=this.rules.inline.autolink.exec(ae);if(ve){var Ee,Fe;return ve[2]==="@"?(Ee=M(this.options.mangle?de(ve[1]):ve[1]),Fe="mailto:"+Ee):(Ee=M(ve[1]),Fe=Ee),{type:"link",raw:ve[0],text:Ee,href:Fe,tokens:[{type:"text",raw:Ee,text:Ee}]}}},ye.url=function(ae,de){var ve;if(ve=this.rules.inline.url.exec(ae)){var Ee,Fe;if(ve[2]==="@")Ee=M(this.options.mangle?de(ve[0]):ve[0]),Fe="mailto:"+Ee;else{var Qe;do Qe=ve[0],ve[0]=this.rules.inline._backpedal.exec(ve[0])[0];while(Qe!==ve[0]);Ee=M(ve[0]),ve[1]==="www."?Fe="http://"+Ee:Fe=Ee}return{type:"link",raw:ve[0],text:Ee,href:Fe,tokens:[{type:"text",raw:Ee,text:Ee}]}}},ye.inlineText=function(ae,de){var ve=this.rules.inline.text.exec(ae);if(ve){var Ee;return this.lexer.state.inRawBlock?Ee=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):M(ve[0]):ve[0]:Ee=M(this.options.smartypants?de(ve[0]):ve[0]),{type:"text",raw:ve[0],text:Ee}}},Te}(),N=x.noopTest,j=x.edit,H=x.merge,V={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:N,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};V._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,V._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,V.def=j(V.def).replace("label",V._label).replace("title",V._title).getRegex(),V.bullet=/(?:[*+-]|\d{1,9}[.)])/,V.listItemStart=j(/^( *)(bull) */).replace("bull",V.bullet).getRegex(),V.list=j(V.list).replace(/bull/g,V.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+V.def.source+")").getRegex(),V._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",V._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,V.html=j(V.html,"i").replace("comment",V._comment).replace("tag",V._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),V.paragraph=j(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.blockquote=j(V.blockquote).replace("paragraph",V.paragraph).getRegex(),V.normal=H({},V),V.gfm=H({},V.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),V.gfm.table=j(V.gfm.table).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.pedantic=H({},V.normal,{html:j(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",V._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:N,paragraph:j(V.normal._paragraph).replace("hr",V.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",V.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:N,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:N,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",q.punctuation=j(q.punctuation).replace(/punctuation/g,q._punctuation).getRegex(),q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,q.escapedEmSt=/\\\*|\\_/g,q._comment=j(V._comment).replace("(?:-->|$)","-->").getRegex(),q.emStrong.lDelim=j(q.emStrong.lDelim).replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimAst=j(q.emStrong.rDelimAst,"g").replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimUnd=j(q.emStrong.rDelimUnd,"g").replace(/punct/g,q._punctuation).getRegex(),q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,q.autolink=j(q.autolink).replace("scheme",q._scheme).replace("email",q._email).getRegex(),q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,q.tag=j(q.tag).replace("comment",q._comment).replace("attribute",q._attribute).getRegex(),q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,q.link=j(q.link).replace("label",q._label).replace("href",q._href).replace("title",q._title).getRegex(),q.reflink=j(q.reflink).replace("label",q._label).getRegex(),q.reflinkSearch=j(q.reflinkSearch,"g").replace("reflink",q.reflink).replace("nolink",q.nolink).getRegex(),q.normal=H({},q),q.pedantic=H({},q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:j(/^!?\[(label)\]\((.*?)\)/).replace("label",q._label).getRegex(),reflink:j(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",q._label).getRegex()}),q.gfm=H({},q.normal,{escape:j(q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),q.gfm.url=j(q.gfm.url,"i").replace("email",q.gfm._extended_email).getRegex(),q.breaks=H({},q.gfm,{br:j(q.br).replace("{2,}","*").getRegex(),text:j(q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var te={block:V,inline:q},fe=K,Ce=C.exports.defaults,ke=te.block,Ue=te.inline,xe=x.repeatString;function ze(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Q(Te){var ye="",be,ae,de=Te.length;for(be=0;be<de;be++)ae=Te.charCodeAt(be),Math.random()>.5&&(ae="x"+ae.toString(16)),ye+="&#"+ae+";";return ye}var Z=function(){function Te(be){this.tokens=[],this.tokens.links=Object.create(null),this.options=be||Ce,this.options.tokenizer=this.options.tokenizer||new fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:ke.normal,inline:Ue.normal};this.options.pedantic?(ae.block=ke.pedantic,ae.inline=Ue.pedantic):this.options.gfm&&(ae.block=ke.gfm,this.options.breaks?ae.inline=Ue.breaks:ae.inline=Ue.gfm),this.tokenizer.rules=ae}Te.lex=function(ae,de){var ve=new Te(de);return ve.lex(ae)},Te.lexInline=function(ae,de){var ve=new Te(de);return ve.inlineTokens(ae)};var ye=Te.prototype;return ye.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ae,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},ye.blockTokens=function(ae,de){var ve=this;de===void 0&&(de=[]),this.options.pedantic&&(ae=ae.replace(/^ +$/gm,""));for(var Ee,Fe,Qe,$e;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(at){return(Ee=at.call({lexer:ve},ae,de))?(ae=ae.substring(Ee.raw.length),de.push(Ee),!0):!1}))){if(Ee=this.tokenizer.space(ae)){ae=ae.substring(Ee.raw.length),Ee.type&&de.push(Ee);continue}if(Ee=this.tokenizer.code(ae)){ae=ae.substring(Ee.raw.length),Fe=de[de.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+Ee.raw,Fe.text+=`
`+Ee.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(Ee);continue}if(Ee=this.tokenizer.fences(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.heading(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.hr(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.blockquote(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.list(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.html(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.def(ae)){ae=ae.substring(Ee.raw.length),Fe=de[de.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+Ee.raw,Fe.text+=`
`+Ee.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[Ee.tag]||(this.tokens.links[Ee.tag]={href:Ee.href,title:Ee.title});continue}if(Ee=this.tokenizer.table(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.lheading(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Qe=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var at=Infinity,ct=ae.slice(1),ce=void 0;ve.options.extensions.startBlock.forEach(function(_e){ce=_e.call({lexer:this},ct),typeof ce=="number"&&ce>=0&&(at=Math.min(at,ce))}),at<Infinity&&at>=0&&(Qe=ae.substring(0,at+1))}(),this.state.top&&(Ee=this.tokenizer.paragraph(Qe))){Fe=de[de.length-1],$e&&Fe.type==="paragraph"?(Fe.raw+=`
`+Ee.raw,Fe.text+=`
`+Ee.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(Ee),$e=Qe.length!==ae.length,ae=ae.substring(Ee.raw.length);continue}if(Ee=this.tokenizer.text(ae)){ae=ae.substring(Ee.raw.length),Fe=de[de.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+Ee.raw,Fe.text+=`
`+Ee.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(Ee);continue}if(ae){var Xe="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(Xe);break}else throw new Error(Xe)}}return this.state.top=!0,de},ye.inline=function(ae,de){this.inlineQueue.push({src:ae,tokens:de})},ye.inlineTokens=function(ae,de){var ve=this;de===void 0&&(de=[]);var Ee,Fe,Qe,$e=ae,Xe,at,ct;if(this.tokens.links){var ce=Object.keys(this.tokens.links);if(ce.length>0)for(;(Xe=this.tokenizer.rules.inline.reflinkSearch.exec($e))!=null;)ce.includes(Xe[0].slice(Xe[0].lastIndexOf("[")+1,-1))&&($e=$e.slice(0,Xe.index)+"["+xe("a",Xe[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Xe=this.tokenizer.rules.inline.blockSkip.exec($e))!=null;)$e=$e.slice(0,Xe.index)+"["+xe("a",Xe[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Xe=this.tokenizer.rules.inline.escapedEmSt.exec($e))!=null;)$e=$e.slice(0,Xe.index)+"++"+$e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(at||(ct=""),at=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(le){return(Ee=le.call({lexer:ve},ae,de))?(ae=ae.substring(Ee.raw.length),de.push(Ee),!0):!1}))){if(Ee=this.tokenizer.escape(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.tag(ae)){ae=ae.substring(Ee.raw.length),Fe=de[de.length-1],Fe&&Ee.type==="text"&&Fe.type==="text"?(Fe.raw+=Ee.raw,Fe.text+=Ee.text):de.push(Ee);continue}if(Ee=this.tokenizer.link(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(Ee.raw.length),Fe=de[de.length-1],Fe&&Ee.type==="text"&&Fe.type==="text"?(Fe.raw+=Ee.raw,Fe.text+=Ee.text):de.push(Ee);continue}if(Ee=this.tokenizer.emStrong(ae,$e,ct)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.codespan(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.br(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.del(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.autolink(ae,Q)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(!this.state.inLink&&(Ee=this.tokenizer.url(ae,Q))){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Qe=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var le=Infinity,X=ae.slice(1),De=void 0;ve.options.extensions.startInline.forEach(function(Le){De=Le.call({lexer:this},X),typeof De=="number"&&De>=0&&(le=Math.min(le,De))}),le<Infinity&&le>=0&&(Qe=ae.substring(0,le+1))}(),Ee=this.tokenizer.inlineText(Qe,ze)){ae=ae.substring(Ee.raw.length),Ee.raw.slice(-1)!=="_"&&(ct=Ee.raw.slice(-1)),at=!0,Fe=de[de.length-1],Fe&&Fe.type==="text"?(Fe.raw+=Ee.raw,Fe.text+=Ee.text):de.push(Ee);continue}if(ae){var _e="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(_e);break}else throw new Error(_e)}}return de},e(Te,null,[{key:"rules",get:function(){return{block:ke,inline:Ue}}}]),Te}(),re=C.exports.defaults,ue=x.cleanUrl,J=x.escape,ie=function(){function Te(be){this.options=be||re}var ye=Te.prototype;return ye.code=function(ae,de,ve){var Ee=(de||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(ae,Ee);Fe!=null&&Fe!==ae&&(ve=!0,ae=Fe)}return ae=ae.replace(/\n$/,"")+`
`,Ee?'<pre><code class="'+this.options.langPrefix+J(Ee,!0)+'">'+(ve?ae:J(ae,!0))+`</code></pre>
`:"<pre><code>"+(ve?ae:J(ae,!0))+`</code></pre>
`},ye.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},ye.html=function(ae){return ae},ye.heading=function(ae,de,ve,Ee){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+Ee.slug(ve)+'">'+ae+"</h"+de+`>
`:"<h"+de+">"+ae+"</h"+de+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(ae,de,ve){var Ee=de?"ol":"ul",Fe=de&&ve!==1?' start="'+ve+'"':"";return"<"+Ee+Fe+`>
`+ae+"</"+Ee+`>
`},ye.listitem=function(ae){return"<li>"+ae+`</li>
`},ye.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(ae){return"<p>"+ae+`</p>
`},ye.table=function(ae,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+de+`</table>
`},ye.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},ye.tablecell=function(ae,de){var ve=de.header?"th":"td",Ee=de.align?"<"+ve+' align="'+de.align+'">':"<"+ve+">";return Ee+ae+"</"+ve+`>
`},ye.strong=function(ae){return"<strong>"+ae+"</strong>"},ye.em=function(ae){return"<em>"+ae+"</em>"},ye.codespan=function(ae){return"<code>"+ae+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(ae){return"<del>"+ae+"</del>"},ye.link=function(ae,de,ve){if(ae=ue(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ve;var Ee='<a href="'+J(ae)+'"';return de&&(Ee+=' title="'+de+'"'),Ee+=">"+ve+"</a>",Ee},ye.image=function(ae,de,ve){if(ae=ue(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ve;var Ee='<img src="'+ae+'" alt="'+ve+'"';return de&&(Ee+=' title="'+de+'"'),Ee+=this.options.xhtml?"/>":">",Ee},ye.text=function(ae){return ae},Te}(),we=function(){function Te(){}var ye=Te.prototype;return ye.strong=function(ae){return ae},ye.em=function(ae){return ae},ye.codespan=function(ae){return ae},ye.del=function(ae){return ae},ye.html=function(ae){return ae},ye.text=function(ae){return ae},ye.link=function(ae,de,ve){return""+ve},ye.image=function(ae,de,ve){return""+ve},ye.br=function(){return""},Te}(),Me=function(){function Te(){this.seen={}}var ye=Te.prototype;return ye.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(ae,de){var ve=ae,Ee=0;if(this.seen.hasOwnProperty(ve)){Ee=this.seen[ae];do Ee++,ve=ae+"-"+Ee;while(this.seen.hasOwnProperty(ve))}return de||(this.seen[ae]=Ee,this.seen[ve]=0),ve},ye.slug=function(ae,de){de===void 0&&(de={});var ve=this.serialize(ae);return this.getNextSafeSlug(ve,de.dryrun)},Te}(),je=ie,Ke=we,Ze=Me,rt=C.exports.defaults,ut=x.unescape,it=function(){function Te(be){this.options=be||rt,this.options.renderer=this.options.renderer||new je,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ke,this.slugger=new Ze}Te.parse=function(ae,de){var ve=new Te(de);return ve.parse(ae)},Te.parseInline=function(ae,de){var ve=new Te(de);return ve.parseInline(ae)};var ye=Te.prototype;return ye.parse=function(ae,de){de===void 0&&(de=!0);var ve="",Ee,Fe,Qe,$e,Xe,at,ct,ce,_e,le,X,De,Le,et,qe,mt,_t,kt,bt,gt=ae.length;for(Ee=0;Ee<gt;Ee++){if(le=ae[Ee],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[le.type]&&(bt=this.options.extensions.renderers[le.type].call({parser:this},le),bt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(le.type))){ve+=bt||"";continue}switch(le.type){case"space":continue;case"hr":{ve+=this.renderer.hr();continue}case"heading":{ve+=this.renderer.heading(this.parseInline(le.tokens),le.depth,ut(this.parseInline(le.tokens,this.textRenderer)),this.slugger);continue}case"code":{ve+=this.renderer.code(le.text,le.lang,le.escaped);continue}case"table":{for(ce="",ct="",$e=le.header.length,Fe=0;Fe<$e;Fe++)ct+=this.renderer.tablecell(this.parseInline(le.header[Fe].tokens),{header:!0,align:le.align[Fe]});for(ce+=this.renderer.tablerow(ct),_e="",$e=le.rows.length,Fe=0;Fe<$e;Fe++){for(at=le.rows[Fe],ct="",Xe=at.length,Qe=0;Qe<Xe;Qe++)ct+=this.renderer.tablecell(this.parseInline(at[Qe].tokens),{header:!1,align:le.align[Qe]});_e+=this.renderer.tablerow(ct)}ve+=this.renderer.table(ce,_e);continue}case"blockquote":{_e=this.parse(le.tokens),ve+=this.renderer.blockquote(_e);continue}case"list":{for(X=le.ordered,De=le.start,Le=le.loose,$e=le.items.length,_e="",Fe=0;Fe<$e;Fe++)qe=le.items[Fe],mt=qe.checked,_t=qe.task,et="",qe.task&&(kt=this.renderer.checkbox(mt),Le?qe.tokens.length>0&&qe.tokens[0].type==="paragraph"?(qe.tokens[0].text=kt+" "+qe.tokens[0].text,qe.tokens[0].tokens&&qe.tokens[0].tokens.length>0&&qe.tokens[0].tokens[0].type==="text"&&(qe.tokens[0].tokens[0].text=kt+" "+qe.tokens[0].tokens[0].text)):qe.tokens.unshift({type:"text",text:kt}):et+=kt),et+=this.parse(qe.tokens,Le),_e+=this.renderer.listitem(et,_t,mt);ve+=this.renderer.list(_e,X,De);continue}case"html":{ve+=this.renderer.html(le.text);continue}case"paragraph":{ve+=this.renderer.paragraph(this.parseInline(le.tokens));continue}case"text":{for(_e=le.tokens?this.parseInline(le.tokens):le.text;Ee+1<gt&&ae[Ee+1].type==="text";)le=ae[++Ee],_e+=`
`+(le.tokens?this.parseInline(le.tokens):le.text);ve+=de?this.renderer.paragraph(_e):_e;continue}default:{var Et='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(Et);return}else throw new Error(Et)}}}return ve},ye.parseInline=function(ae,de){de=de||this.renderer;var ve="",Ee,Fe,Qe,$e=ae.length;for(Ee=0;Ee<$e;Ee++){if(Fe=ae[Ee],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Qe=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Qe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){ve+=Qe||"";continue}switch(Fe.type){case"escape":{ve+=de.text(Fe.text);break}case"html":{ve+=de.html(Fe.text);break}case"link":{ve+=de.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,de));break}case"image":{ve+=de.image(Fe.href,Fe.title,Fe.text);break}case"strong":{ve+=de.strong(this.parseInline(Fe.tokens,de));break}case"em":{ve+=de.em(this.parseInline(Fe.tokens,de));break}case"codespan":{ve+=de.codespan(Fe.text);break}case"br":{ve+=de.br();break}case"del":{ve+=de.del(this.parseInline(Fe.tokens,de));break}case"text":{ve+=de.text(Fe.text);break}default:{var Xe='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}}return ve},Te}(),st=Z,Ae=it,wt=K,ee=ie,se=we,Se=Me,Ge=x.merge,Ye=x.checkSanitizeDeprecation,nt=x.escape,he=C.exports.getDefaults,Ie=C.exports.changeDefaults,Be=C.exports.defaults;function We(Te,ye,be){if(typeof Te=="undefined"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof ye=="function"&&(be=ye,ye=null),ye=Ge({},We.defaults,ye||{}),Ye(ye),be){var ae=ye.highlight,de;try{de=st.lex(Te,ye)}catch(Qe){return be(Qe)}var ve=function($e){var Xe;if(!$e)try{ye.walkTokens&&We.walkTokens(de,ye.walkTokens),Xe=Ae.parse(de,ye)}catch(at){$e=at}return ye.highlight=ae,$e?be($e):be(null,Xe)};if(!ae||ae.length<3||(delete ye.highlight,!de.length))return ve();var Ee=0;We.walkTokens(de,function(Qe){Qe.type==="code"&&(Ee++,setTimeout(function(){ae(Qe.text,Qe.lang,function($e,Xe){if($e)return ve($e);Xe!=null&&Xe!==Qe.text&&(Qe.text=Xe,Qe.escaped=!0),Ee--,Ee===0&&ve()})},0))}),Ee===0&&ve();return}try{var Fe=st.lex(Te,ye);return ye.walkTokens&&We.walkTokens(Fe,ye.walkTokens),Ae.parse(Fe,ye)}catch(Qe){if(Qe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+nt(Qe.message+"",!0)+"</pre>";throw Qe}}We.options=We.setOptions=function(Te){return Ge(We.defaults,Te),Ie(We.defaults),We},We.getDefaults=he,We.defaults=Be,We.use=function(){for(var Te=this,ye=arguments.length,be=new Array(ye),ae=0;ae<ye;ae++)be[ae]=arguments[ae];var de=Ge.apply(void 0,[{}].concat(be)),ve=We.defaults.extensions||{renderers:{},childTokens:{}},Ee;be.forEach(function(Fe){if(Fe.extensions&&(Ee=!0,Fe.extensions.forEach(function($e){if(!$e.name)throw new Error("extension name required");if($e.renderer){var Xe=ve.renderers?ve.renderers[$e.name]:null;Xe?ve.renderers[$e.name]=function(){for(var at=arguments.length,ct=new Array(at),ce=0;ce<at;ce++)ct[ce]=arguments[ce];var _e=$e.renderer.apply(this,ct);return _e===!1&&(_e=Xe.apply(this,ct)),_e}:ve.renderers[$e.name]=$e.renderer}if($e.tokenizer){if(!$e.level||$e.level!=="block"&&$e.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ve[$e.level]?ve[$e.level].unshift($e.tokenizer):ve[$e.level]=[$e.tokenizer],$e.start&&($e.level==="block"?ve.startBlock?ve.startBlock.push($e.start):ve.startBlock=[$e.start]:$e.level==="inline"&&(ve.startInline?ve.startInline.push($e.start):ve.startInline=[$e.start]))}$e.childTokens&&(ve.childTokens[$e.name]=$e.childTokens)})),Fe.renderer&&function(){var $e=We.defaults.renderer||new ee,Xe=function(ce){var _e=$e[ce];$e[ce]=function(){for(var le=arguments.length,X=new Array(le),De=0;De<le;De++)X[De]=arguments[De];var Le=Fe.renderer[ce].apply($e,X);return Le===!1&&(Le=_e.apply($e,X)),Le}};for(var at in Fe.renderer)Xe(at);de.renderer=$e}(),Fe.tokenizer&&function(){var $e=We.defaults.tokenizer||new wt,Xe=function(ce){var _e=$e[ce];$e[ce]=function(){for(var le=arguments.length,X=new Array(le),De=0;De<le;De++)X[De]=arguments[De];var Le=Fe.tokenizer[ce].apply($e,X);return Le===!1&&(Le=_e.apply($e,X)),Le}};for(var at in Fe.tokenizer)Xe(at);de.tokenizer=$e}(),Fe.walkTokens){var Qe=We.defaults.walkTokens;de.walkTokens=function($e){Fe.walkTokens.call(Te,$e),Qe&&Qe($e)}}Ee&&(de.extensions=ve),We.setOptions(de)})},We.walkTokens=function(Te,ye){for(var be=function(){var Ee=de.value;switch(ye(Ee),Ee.type){case"table":{for(var Fe=D(Ee.header),Qe;!(Qe=Fe()).done;){var $e=Qe.value;We.walkTokens($e.tokens,ye)}for(var Xe=D(Ee.rows),at;!(at=Xe()).done;)for(var ct=at.value,ce=D(ct),_e;!(_e=ce()).done;){var le=_e.value;We.walkTokens(le.tokens,ye)}break}case"list":{We.walkTokens(Ee.items,ye);break}default:We.defaults.extensions&&We.defaults.extensions.childTokens&&We.defaults.extensions.childTokens[Ee.type]?We.defaults.extensions.childTokens[Ee.type].forEach(function(X){We.walkTokens(Ee[X],ye)}):Ee.tokens&&We.walkTokens(Ee.tokens,ye)}},ae=D(Te),de;!(de=ae()).done;)be()},We.parseInline=function(Te,ye){if(typeof Te=="undefined"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");ye=Ge({},We.defaults,ye||{}),Ye(ye);try{var be=st.lexInline(Te,ye);return ye.walkTokens&&We.walkTokens(be,ye.walkTokens),Ae.parseInline(be,ye)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+nt(ae.message+"",!0)+"</pre>";throw ae}},We.Parser=Ae,We.parser=Ae.parse,We.Renderer=ee,We.TextRenderer=se,We.Lexer=st,We.lexer=st.lex,We.Tokenizer=wt,We.Slugger=Se,We.parse=We;var tt=We;return tt}),define(ge[77],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(i,k,S){return Math.min(Math.max(i,k),S)}e.clamp=m;function L(i,k){return(k+i%k)%k}e.rot=L;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class C{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=C}),function(){function Y(D){const C=[];typeof D=="number"&&C.push("code/timeOrigin",D);function i(S){C.push(S,Date.now())}function k(){const S=[];for(let y=0;y<C.length;y+=2)S.push({name:C[y],startTime:C[y+1]});return S}return{mark:i,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const i of performance.getEntriesByType("mark"))C.push({name:i.name,startTime:Math.round(D+i.startTime)});return C}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function m(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=m(L))}(),define(ge[12],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const m="en";let L=!1,D=!1,C=!1,i=!1,k=!1,S=!1,y=!1,T,I=m,a,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const w=typeof f?.versions?.electron=="string"&&f.type==="renderer";if(e.isElectronSandboxed=w&&f?.sandboxed,typeof navigator=="object"&&!w)b=navigator.userAgent,L=b.indexOf("Windows")>=0,D=b.indexOf("Macintosh")>=0,y=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=b.indexOf("Linux")>=0,S=!0,T=navigator.language,I=T;else if(typeof f=="object"){L=f.platform==="win32",D=f.platform==="darwin",C=f.platform==="linux",i=C&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,T=m,I=m;const n=f.env.VSCODE_NLS_CONFIG;if(n)try{const t=JSON.parse(n),u=t.availableLanguages["*"];T=t.locale,I=u||m,a=t._translationsConfigFile}catch(t){}k=!0}else console.error("Unable to resolve platform.");var E;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function P(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=P;let p=0;D?p=1:L?p=3:C&&(p=2),e.isWindows=L,e.isMacintosh=D,e.isLinux=C,e.isLinuxSnap=i,e.isNative=k,e.isWeb=S,e.isIOS=y,e.platform=p,e.userAgent=b,e.language=I;var o;(function(n){function t(){return e.language}n.value=t;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=u;function d(){return e.language==="en"}n.isDefault=d})(o=e.Language||(e.Language={})),e.locale=T,e.translationsConfigFile=a,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let n=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeScheduleAsyncWork)for(let d=0,l=n.length;d<l;d++){const h=n[d];if(h.id===u.data.vscodeScheduleAsyncWork){n.splice(d,1),h.callback();return}}});let t=0;return u=>{const d=++t;n.push({id:d,callback:u}),e.globals.postMessage({vscodeScheduleAsyncWork:d},"*")}}return n=>setTimeout(n)})();var r;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||y?2:L?1:3;let g=!0,s=!1;function v(){if(!s){s=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,g=new Uint16Array(n.buffer)[0]===(2<<8)+1}return g}e.isLittleEndian=v}),define(ge[40],pe([0,1,12]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const D=m.globals.vscode.process;L={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(ge[9],pe([0,1,40]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,D=97,C=90,i=122,k=46,S=47,y=92,T=58,I=63;class a extends Error{constructor(r,g,s){let v;typeof g=="string"&&g.indexOf("not ")===0?(v="must not be",g=g.replace(/^not /,"")):v="must be";const n=r.indexOf(".")!==-1?"property":"argument";let t=`The "${r}" ${n} ${v} of type ${g}`;t+=`. Received type ${typeof s}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function b(o,r){if(typeof o!="string")throw new a(r,"string",o)}function f(o){return o===S||o===y}function w(o){return o===S}function E(o){return o>=L&&o<=C||o>=D&&o<=i}function P(o,r,g,s){let v="",n=0,t=-1,u=0,d=0;for(let l=0;l<=o.length;++l){if(l<o.length)d=o.charCodeAt(l);else{if(s(d))break;d=S}if(s(d)){if(!(t===l-1||u===1))if(u===2){if(v.length<2||n!==2||v.charCodeAt(v.length-1)!==k||v.charCodeAt(v.length-2)!==k){if(v.length>2){const h=v.lastIndexOf(g);h===-1?(v="",n=0):(v=v.slice(0,h),n=v.length-1-v.lastIndexOf(g)),t=l,u=0;continue}else if(v.length!==0){v="",n=0,t=l,u=0;continue}}r&&(v+=v.length>0?`${g}..`:"..",n=2)}else v.length>0?v+=`${g}${o.slice(t+1,l)}`:v=o.slice(t+1,l),n=l-t-1;t=l,u=0}else d===k&&u!==-1?++u:u=-1}return v}function p(o,r){if(r===null||typeof r!="object")throw new a("pathObject","Object",r);const g=r.dir||r.root,s=r.base||`${r.name||""}${r.ext||""}`;return g?g===r.root?`${g}${s}`:`${g}${o}${s}`:s}e.win32={resolve(...o){let r="",g="",s=!1;for(let v=o.length-1;v>=-1;v--){let n;if(v>=0){if(n=o[v],b(n,"path"),n.length===0)continue}else r.length===0?n=m.cwd():(n=m.env[`=${r}`]||m.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==r.toLowerCase()&&n.charCodeAt(2)===y)&&(n=`${r}\\`));const t=n.length;let u=0,d="",l=!1;const h=n.charCodeAt(0);if(t===1)f(h)&&(u=1,l=!0);else if(f(h))if(l=!0,f(n.charCodeAt(1))){let c=2,_=c;for(;c<t&&!f(n.charCodeAt(c));)c++;if(c<t&&c!==_){const A=n.slice(_,c);for(_=c;c<t&&f(n.charCodeAt(c));)c++;if(c<t&&c!==_){for(_=c;c<t&&!f(n.charCodeAt(c));)c++;(c===t||c!==_)&&(d=`\\\\${A}\\${n.slice(_,c)}`,u=c)}}}else u=1;else E(h)&&n.charCodeAt(1)===T&&(d=n.slice(0,2),u=2,t>2&&f(n.charCodeAt(2))&&(l=!0,u=3));if(d.length>0)if(r.length>0){if(d.toLowerCase()!==r.toLowerCase())continue}else r=d;if(s){if(r.length>0)break}else if(g=`${n.slice(u)}\\${g}`,s=l,l&&r.length>0)break}return g=P(g,!s,"\\",f),s?`${r}\\${g}`:`${r}${g}`||"."},normalize(o){b(o,"path");const r=o.length;if(r===0)return".";let g=0,s,v=!1;const n=o.charCodeAt(0);if(r===1)return w(n)?"\\":o;if(f(n))if(v=!0,f(o.charCodeAt(1))){let u=2,d=u;for(;u<r&&!f(o.charCodeAt(u));)u++;if(u<r&&u!==d){const l=o.slice(d,u);for(d=u;u<r&&f(o.charCodeAt(u));)u++;if(u<r&&u!==d){for(d=u;u<r&&!f(o.charCodeAt(u));)u++;if(u===r)return`\\\\${l}\\${o.slice(d)}\\`;u!==d&&(s=`\\\\${l}\\${o.slice(d,u)}`,g=u)}}}else g=1;else E(n)&&o.charCodeAt(1)===T&&(s=o.slice(0,2),g=2,r>2&&f(o.charCodeAt(2))&&(v=!0,g=3));let t=g<r?P(o.slice(g),!v,"\\",f):"";return t.length===0&&!v&&(t="."),t.length>0&&f(o.charCodeAt(r-1))&&(t+="\\"),s===void 0?v?`\\${t}`:t:v?`${s}\\${t}`:`${s}${t}`},isAbsolute(o){b(o,"path");const r=o.length;if(r===0)return!1;const g=o.charCodeAt(0);return f(g)||r>2&&E(g)&&o.charCodeAt(1)===T&&f(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let r,g;for(let n=0;n<o.length;++n){const t=o[n];b(t,"path"),t.length>0&&(r===void 0?r=g=t:r+=`\\${t}`)}if(r===void 0)return".";let s=!0,v=0;if(typeof g=="string"&&f(g.charCodeAt(0))){++v;const n=g.length;n>1&&f(g.charCodeAt(1))&&(++v,n>2&&(f(g.charCodeAt(2))?++v:s=!1))}if(s){for(;v<r.length&&f(r.charCodeAt(v));)v++;v>=2&&(r=`\\${r.slice(v)}`)}return e.win32.normalize(r)},relative(o,r){if(b(o,"from"),b(r,"to"),o===r)return"";const g=e.win32.resolve(o),s=e.win32.resolve(r);if(g===s||(o=g.toLowerCase(),r=s.toLowerCase(),o===r))return"";let v=0;for(;v<o.length&&o.charCodeAt(v)===y;)v++;let n=o.length;for(;n-1>v&&o.charCodeAt(n-1)===y;)n--;const t=n-v;let u=0;for(;u<r.length&&r.charCodeAt(u)===y;)u++;let d=r.length;for(;d-1>u&&r.charCodeAt(d-1)===y;)d--;const l=d-u,h=t<l?t:l;let c=-1,_=0;for(;_<h;_++){const R=o.charCodeAt(v+_);if(R!==r.charCodeAt(u+_))break;R===y&&(c=_)}if(_!==h){if(c===-1)return s}else{if(l>h){if(r.charCodeAt(u+_)===y)return s.slice(u+_+1);if(_===2)return s.slice(u+_)}t>h&&(o.charCodeAt(v+_)===y?c=_:_===2&&(c=3)),c===-1&&(c=0)}let A="";for(_=v+c+1;_<=n;++_)(_===n||o.charCodeAt(_)===y)&&(A+=A.length===0?"..":"\\..");return u+=c,A.length>0?`${A}${s.slice(u,d)}`:(s.charCodeAt(u)===y&&++u,s.slice(u,d))},toNamespacedPath(o){if(typeof o!="string")return o;if(o.length===0)return"";const r=e.win32.resolve(o);if(r.length<=2)return o;if(r.charCodeAt(0)===y){if(r.charCodeAt(1)===y){const g=r.charCodeAt(2);if(g!==I&&g!==k)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(E(r.charCodeAt(0))&&r.charCodeAt(1)===T&&r.charCodeAt(2)===y)return`\\\\?\\${r}`;return o},dirname(o){b(o,"path");const r=o.length;if(r===0)return".";let g=-1,s=0;const v=o.charCodeAt(0);if(r===1)return f(v)?o:".";if(f(v)){if(g=s=1,f(o.charCodeAt(1))){let u=2,d=u;for(;u<r&&!f(o.charCodeAt(u));)u++;if(u<r&&u!==d){for(d=u;u<r&&f(o.charCodeAt(u));)u++;if(u<r&&u!==d){for(d=u;u<r&&!f(o.charCodeAt(u));)u++;if(u===r)return o;u!==d&&(g=s=u+1)}}}}else E(v)&&o.charCodeAt(1)===T&&(g=r>2&&f(o.charCodeAt(2))?3:2,s=g);let n=-1,t=!0;for(let u=r-1;u>=s;--u)if(f(o.charCodeAt(u))){if(!t){n=u;break}}else t=!1;if(n===-1){if(g===-1)return".";n=g}return o.slice(0,n)},basename(o,r){r!==void 0&&b(r,"ext"),b(o,"path");let g=0,s=-1,v=!0,n;if(o.length>=2&&E(o.charCodeAt(0))&&o.charCodeAt(1)===T&&(g=2),r!==void 0&&r.length>0&&r.length<=o.length){if(r===o)return"";let t=r.length-1,u=-1;for(n=o.length-1;n>=g;--n){const d=o.charCodeAt(n);if(f(d)){if(!v){g=n+1;break}}else u===-1&&(v=!1,u=n+1),t>=0&&(d===r.charCodeAt(t)?--t==-1&&(s=n):(t=-1,s=u))}return g===s?s=u:s===-1&&(s=o.length),o.slice(g,s)}for(n=o.length-1;n>=g;--n)if(f(o.charCodeAt(n))){if(!v){g=n+1;break}}else s===-1&&(v=!1,s=n+1);return s===-1?"":o.slice(g,s)},extname(o){b(o,"path");let r=0,g=-1,s=0,v=-1,n=!0,t=0;o.length>=2&&o.charCodeAt(1)===T&&E(o.charCodeAt(0))&&(r=s=2);for(let u=o.length-1;u>=r;--u){const d=o.charCodeAt(u);if(f(d)){if(!n){s=u+1;break}continue}v===-1&&(n=!1,v=u+1),d===k?g===-1?g=u:t!==1&&(t=1):g!==-1&&(t=-1)}return g===-1||v===-1||t===0||t===1&&g===v-1&&g===s+1?"":o.slice(g,v)},format:p.bind(null,"\\"),parse(o){b(o,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return r;const g=o.length;let s=0,v=o.charCodeAt(0);if(g===1)return f(v)?(r.root=r.dir=o,r):(r.base=r.name=o,r);if(f(v)){if(s=1,f(o.charCodeAt(1))){let c=2,_=c;for(;c<g&&!f(o.charCodeAt(c));)c++;if(c<g&&c!==_){for(_=c;c<g&&f(o.charCodeAt(c));)c++;if(c<g&&c!==_){for(_=c;c<g&&!f(o.charCodeAt(c));)c++;c===g?s=c:c!==_&&(s=c+1)}}}}else if(E(v)&&o.charCodeAt(1)===T){if(g<=2)return r.root=r.dir=o,r;if(s=2,f(o.charCodeAt(2))){if(g===3)return r.root=r.dir=o,r;s=3}}s>0&&(r.root=o.slice(0,s));let n=-1,t=s,u=-1,d=!0,l=o.length-1,h=0;for(;l>=s;--l){if(v=o.charCodeAt(l),f(v)){if(!d){t=l+1;break}continue}u===-1&&(d=!1,u=l+1),v===k?n===-1?n=l:h!==1&&(h=1):n!==-1&&(h=-1)}return u!==-1&&(n===-1||h===0||h===1&&n===u-1&&n===t+1?r.base=r.name=o.slice(t,u):(r.name=o.slice(t,n),r.base=o.slice(t,u),r.ext=o.slice(n,u))),t>0&&t!==s?r.dir=o.slice(0,t-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...o){let r="",g=!1;for(let s=o.length-1;s>=-1&&!g;s--){const v=s>=0?o[s]:m.cwd();b(v,"path"),v.length!==0&&(r=`${v}/${r}`,g=v.charCodeAt(0)===S)}return r=P(r,!g,"/",w),g?`/${r}`:r.length>0?r:"."},normalize(o){if(b(o,"path"),o.length===0)return".";const r=o.charCodeAt(0)===S,g=o.charCodeAt(o.length-1)===S;return o=P(o,!r,"/",w),o.length===0?r?"/":g?"./":".":(g&&(o+="/"),r?`/${o}`:o)},isAbsolute(o){return b(o,"path"),o.length>0&&o.charCodeAt(0)===S},join(...o){if(o.length===0)return".";let r;for(let g=0;g<o.length;++g){const s=o[g];b(s,"path"),s.length>0&&(r===void 0?r=s:r+=`/${s}`)}return r===void 0?".":e.posix.normalize(r)},relative(o,r){if(b(o,"from"),b(r,"to"),o===r||(o=e.posix.resolve(o),r=e.posix.resolve(r),o===r))return"";const g=1,s=o.length,v=s-g,n=1,t=r.length-n,u=v<t?v:t;let d=-1,l=0;for(;l<u;l++){const c=o.charCodeAt(g+l);if(c!==r.charCodeAt(n+l))break;c===S&&(d=l)}if(l===u)if(t>u){if(r.charCodeAt(n+l)===S)return r.slice(n+l+1);if(l===0)return r.slice(n+l)}else v>u&&(o.charCodeAt(g+l)===S?d=l:l===0&&(d=0));let h="";for(l=g+d+1;l<=s;++l)(l===s||o.charCodeAt(l)===S)&&(h+=h.length===0?"..":"/..");return`${h}${r.slice(n+d)}`},toNamespacedPath(o){return o},dirname(o){if(b(o,"path"),o.length===0)return".";const r=o.charCodeAt(0)===S;let g=-1,s=!0;for(let v=o.length-1;v>=1;--v)if(o.charCodeAt(v)===S){if(!s){g=v;break}}else s=!1;return g===-1?r?"/":".":r&&g===1?"//":o.slice(0,g)},basename(o,r){r!==void 0&&b(r,"ext"),b(o,"path");let g=0,s=-1,v=!0,n;if(r!==void 0&&r.length>0&&r.length<=o.length){if(r===o)return"";let t=r.length-1,u=-1;for(n=o.length-1;n>=0;--n){const d=o.charCodeAt(n);if(d===S){if(!v){g=n+1;break}}else u===-1&&(v=!1,u=n+1),t>=0&&(d===r.charCodeAt(t)?--t==-1&&(s=n):(t=-1,s=u))}return g===s?s=u:s===-1&&(s=o.length),o.slice(g,s)}for(n=o.length-1;n>=0;--n)if(o.charCodeAt(n)===S){if(!v){g=n+1;break}}else s===-1&&(v=!1,s=n+1);return s===-1?"":o.slice(g,s)},extname(o){b(o,"path");let r=-1,g=0,s=-1,v=!0,n=0;for(let t=o.length-1;t>=0;--t){const u=o.charCodeAt(t);if(u===S){if(!v){g=t+1;break}continue}s===-1&&(v=!1,s=t+1),u===k?r===-1?r=t:n!==1&&(n=1):r!==-1&&(n=-1)}return r===-1||s===-1||n===0||n===1&&r===s-1&&r===g+1?"":o.slice(r,s)},format:p.bind(null,"/"),parse(o){b(o,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return r;const g=o.charCodeAt(0)===S;let s;g?(r.root="/",s=1):s=0;let v=-1,n=0,t=-1,u=!0,d=o.length-1,l=0;for(;d>=s;--d){const h=o.charCodeAt(d);if(h===S){if(!u){n=d+1;break}continue}t===-1&&(u=!1,t=d+1),h===k?v===-1?v=d:l!==1&&(l=1):v!==-1&&(l=-1)}if(t!==-1){const h=n===0&&g?1:n;v===-1||l===0||l===1&&v===t-1&&v===n+1?r.base=r.name=o.slice(h,t):(r.name=o.slice(h,v),r.base=o.slice(h,t),r.ext=o.slice(v,t))}return n>0?r.dir=o.slice(0,n-1):g&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[94],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var L;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(C,...i){const k=i.reduce((T,I)=>(T[I]=!0,T),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(T=>!k[T]).forEach(T=>{for(let I=0;I<S.length;I++)if(T.search(S[I])!==-1){delete C[T];break}})}e.sanitizeProcessEnvironment=D}),define(ge[46],pe([0,1,12]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=m.globals.performance&&typeof m.globals.performance.now=="function";class D{constructor(i){this._highResolution=L&&i,this._startTime=this._now(),this._stopTime=-1}static create(i=!0){return new D(i)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=D}),define(ge[3],pe([0,1,15,74,6,93,46]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(r){r.None=()=>D.Disposable.None;function g(M){return(B,U=null,z)=>{let K=!1,N;return N=M(j=>{if(!K)return N?N.dispose():K=!0,B.call(U,j)},null,z),K&&N.dispose(),N}}r.once=g;function s(M,B){return l((U,z=null,K)=>M(N=>U.call(z,B(N)),null,K))}r.map=s;function v(M,B){return l((U,z=null,K)=>M(N=>{B(N),U.call(z,N)},null,K))}r.forEach=v;function n(M,B){return l((U,z=null,K)=>M(N=>B(N)&&U.call(z,N),null,K))}r.filter=n;function t(M){return M}r.signal=t;function u(...M){return(B,U=null,z)=>(0,D.combinedDisposable)(...M.map(K=>K(N=>B.call(U,N),null,z)))}r.any=u;function d(M,B,U){let z=U;return s(M,K=>(z=B(z,K),z))}r.reduce=d;function l(M){let B;const U=new a({onFirstListenerAdd(){B=M(U.fire,U)},onLastListenerRemove(){B.dispose()}});return U.event}function h(M,B,U=100,z=!1,K){let N,j,H,V=0;const q=new a({leakWarningThreshold:K,onFirstListenerAdd(){N=M(te=>{V++,j=B(j,te),z&&!H&&(q.fire(j),j=void 0),clearTimeout(H),H=setTimeout(()=>{const fe=j;j=void 0,H=void 0,(!z||V>1)&&q.fire(fe),V=0},U)})},onLastListenerRemove(){N.dispose()}});return q.event}r.debounce=h;function c(M,B=(U,z)=>U===z){let U=!0,z;return n(M,K=>{const N=U||!B(K,z);return U=!1,z=K,N})}r.latch=c;function _(M,B){return[r.filter(M,B),r.filter(M,U=>!B(U))]}r.split=_;function A(M,B=!1,U=[]){let z=U.slice(),K=M(H=>{z?z.push(H):j.fire(H)});const N=()=>{z&&z.forEach(H=>j.fire(H)),z=null},j=new a({onFirstListenerAdd(){K||(K=M(H=>j.fire(H)))},onFirstListenerDidAdd(){z&&(B?setTimeout(N):N())},onLastListenerRemove(){K&&K.dispose(),K=null}});return j.event}r.buffer=A;class R{constructor(B){this.event=B}map(B){return new R(s(this.event,B))}forEach(B){return new R(v(this.event,B))}filter(B){return new R(n(this.event,B))}reduce(B,U){return new R(d(this.event,B,U))}latch(){return new R(c(this.event))}debounce(B,U=100,z=!1,K){return new R(h(this.event,B,U,z,K))}on(B,U,z){return this.event(B,U,z)}once(B,U,z){return g(this.event)(B,U,z)}}function x(M){return new R(M)}r.chain=x;function O(M,B,U=z=>z){const z=(...H)=>j.fire(U(...H)),K=()=>M.on(B,z),N=()=>M.removeListener(B,z),j=new a({onFirstListenerAdd:K,onLastListenerRemove:N});return j.event}r.fromNodeEventEmitter=O;function F(M,B,U=z=>z){const z=(...H)=>j.fire(U(...H)),K=()=>M.addEventListener(B,z),N=()=>M.removeEventListener(B,z),j=new a({onFirstListenerAdd:K,onLastListenerRemove:N});return j.event}r.fromDOMEventEmitter=F;function $(M){return new Promise(B=>g(M)(B))}r.toPromise=$})(k=e.Event||(e.Event={}));class S{constructor(g){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${g}_${S._idPool++}`}start(g){this._stopWatch=new i.StopWatch(!0),this._listenerCount=g}stop(){if(this._stopWatch){const g=this._stopWatch.elapsed();this._elapsedOverall+=g,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${g.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let y=-1;function T(r){const g=y;return y=r,{dispose(){y=g}}}e.setGlobalLeakWarningThreshold=T;class I{constructor(g,s=Math.random().toString(18).slice(2,5)){this.customThreshold=g,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(g){let s=y;if(typeof this.customThreshold=="number"&&(s=this.customThreshold),s<=0||g<s)return;this._stacks||(this._stacks=new Map);const v=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(v)||0;if(this._stacks.set(v,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=s*.5;let t,u=0;for(const[d,l]of this._stacks)(!t||u<l)&&(t=d,u=l);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${u}):`),console.warn(t)}return()=>{const t=this._stacks.get(v)||0;this._stacks.set(v,t-1)}}}class a{constructor(g){this._disposed=!1,this._options=g,this._leakageMon=y>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(g,s,v)=>{this._listeners||(this._listeners=new C.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(s?[g,s]:g);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,g,s);const u=this._leakageMon?.check(this._listeners.size),d=(0,D.toDisposable)(()=>{u&&u(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return v instanceof D.DisposableStore?v.add(d):Array.isArray(v)&&v.push(d),d}),this._event}fire(g){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,g]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,v]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,v):s[0].call(s[1],v)}catch(n){(0,m.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=a;class b extends a{async fireAsync(g,s,v){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,g]);for(;this._asyncDeliveryQueue.size>0&&!s.isCancellationRequested;){const[n,t]=this._asyncDeliveryQueue.shift(),u=[],d={...t,waitUntil:l=>{if(Object.isFrozen(u))throw new Error("waitUntil can NOT be called asynchronous");v&&(l=v(l,typeof n=="function"?n:n[0])),u.push(l)}};try{typeof n=="function"?n.call(void 0,d):n[0].call(n[1],d)}catch(l){(0,m.onUnexpectedError)(l);continue}Object.freeze(u),await Promise.allSettled(u).then(l=>{for(const h of l)h.status==="rejected"&&(0,m.onUnexpectedError)(h.reason)})}}}}e.AsyncEmitter=b;class f extends a{constructor(g){super(g);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=g?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const g=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(g))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(g){this._listeners&&(this._isPaused!==0?this._eventQueue.push(g):super.fire(g))}}e.PauseableEmitter=f;class w extends f{constructor(g){super(g);this._delay=g.delay??100}fire(g){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(g)}}e.DebounceEmitter=w;class E extends a{constructor(g){super(g);this._queuedEvents=[],this._mergeFn=g?.merge}fire(g){this._queuedEvents.push(g),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(s=>super.fire(s)),this._queuedEvents=[]})}}e.MicrotaskEmitter=E;class P{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new a({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(g){const s={event:g,listener:null};this.events.push(s),this.hasListeners&&this.hook(s);const v=()=>{this.hasListeners&&this.unhook(s);const n=this.events.indexOf(s);this.events.splice(n,1)};return(0,D.toDisposable)((0,L.once)(v))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(g=>this.hook(g))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(g=>this.unhook(g))}hook(g){g.listener=g.event(s=>this.emitter.fire(s))}unhook(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=P;class p{constructor(){this.buffers=[]}wrapEvent(g){return(s,v,n)=>g(t=>{const u=this.buffers[this.buffers.length-1];u?u.push(()=>s.call(v,t)):s.call(v,t)},void 0,n)}bufferEvents(g){const s=[];this.buffers.push(s);const v=g();return this.buffers.pop(),s.forEach(n=>n()),v}}e.EventBufferer=p;class o{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=D.Disposable.None,this.emitter=new a({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(g){this.inputEvent=g,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=g(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(ge[21],pe([0,1,3]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(k,S){const y=setTimeout(k.bind(S),0);return{dispose(){clearTimeout(y)}}});var D;(function(k){function S(y){return y===k.None||y===k.Cancelled||y instanceof C?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}k.isCancellationToken=S,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(D=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class i{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=D.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=i}),define(ge[78],pe([0,1,3]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(T){const I=this._icons.get(T.id);I?T.description?I.description=T.description:console.error(`Duplicate registration of codicon ${T.id}`):(this._icons.set(T.id,T),this._onDidRegister.fire(T))}get(T){return this._icons.get(T)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new L;e.iconRegistry=D;function C(y){return y?y.replace(/\$\((.*?)\)/g,(T,I)=>` ${I} `).trim():""}e.getCodiconAriaLabel=C;class i{constructor(T,I,a){this.id=T,this.definition=I,this.description=a,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=i,i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function k(y,T){const I=["codicon","codicon-"+y];return T&&I.push("codicon-modifier-"+T),I}e.getClassNamesArray=k;var S;(function(y){y.iconNameSegment="[A-Za-z0-9]+",y.iconNameExpression="[A-Za-z0-9-]+",y.iconModifierExpression="~[A-Za-z]+",y.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${y.iconNameExpression})(${y.iconModifierExpression})?$`);function I(f){if(f instanceof i)return["codicon","codicon-"+f.id];const w=T.exec(f.id);if(!w)return I(i.error);let[,E,P]=w;const p=["codicon","codicon-"+E];return P&&p.push("codicon-modifier-"+P.substr(1)),p}y.asClassNameArray=I;function a(f){return I(f).join(" ")}y.asClassName=a;function b(f){return"."+I(f).join(".")}y.asCSSSelector=b})(S=e.CSSIcon||(e.CSSIcon={}))}),define(ge[95],pe([0,1,15,6]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(o){const r=o;return r?[r.on,r.pause,r.resume,r.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=D;function C(o){const r=o;return r?D(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}e.isReadableBufferedStream=C;function i(o,r){return new k(o,r)}e.newWriteableStream=i;class k{constructor(r,g){this.reducer=r,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(r){if(!this.state.destroyed){if(this.state.flowing)this.emitData(r);else if(this.buffer.data.push(r),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(g=>this.pendingWritePromises.push(g))}}error(r){this.state.destroyed||(this.state.flowing?this.emitError(r):this.buffer.error.push(r))}end(r){this.state.destroyed||(typeof r!="undefined"&&this.write(r),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(r){this.listeners.data.slice(0).forEach(g=>g(r))}emitError(r){this.listeners.error.length===0?(0,m.onUnexpectedError)(r):this.listeners.error.slice(0).forEach(g=>g(r))}emitEnd(){this.listeners.end.slice(0).forEach(r=>r())}on(r,g){if(!this.state.destroyed)switch(r){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(r,g){if(this.state.destroyed)return;let s;switch(r){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const v=s.indexOf(g);v>=0&&s.splice(v,1)}}flowData(){if(this.buffer.data.length>0){const r=this.reducer(this.buffer.data);this.emitData(r),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const r of this.buffer.error)this.emitError(r);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(o,r){const g=[];let s;for(;(s=o.read())!==null;)g.push(s);return r(g)}e.consumeReadable=S;function y(o,r,g){const s=[];let v;for(;(v=o.read())!==null&&s.length<g;)s.push(v);return v===null&&s.length>0?r(s):{read:()=>{if(s.length>0)return s.shift();if(typeof v!="undefined"){const n=v;return v=void 0,n}return o.read()}}}e.peekReadable=y;function T(o,r){return new Promise((g,s)=>{const v=[];I(o,{onData:n=>{r&&v.push(n)},onError:n=>{r?s(n):g(void 0)},onEnd:()=>{g(r?r(v):void 0)}})})}e.consumeStream=T;function I(o,r){o.on("error",g=>r.onError(g)),o.on("end",()=>r.onEnd()),o.on("data",g=>r.onData(g))}e.listenStream=I;function a(o,r){return new Promise((g,s)=>{const v=new L.DisposableStore,n=[],t=l=>{if(n.push(l),n.length>r)return v.dispose(),o.pause(),g({stream:o,buffer:n,ended:!1})},u=l=>s(l),d=()=>g({stream:o,buffer:n,ended:!0});v.add((0,L.toDisposable)(()=>o.removeListener("error",u))),o.on("error",u),v.add((0,L.toDisposable)(()=>o.removeListener("end",d))),o.on("end",d),v.add((0,L.toDisposable)(()=>o.removeListener("data",t))),o.on("data",t)})}e.peekStream=a;function b(o,r){const g=i(r);return g.end(o),g}e.toStream=b;function f(){const o=i(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=f;function w(o){let r=!1;return{read:()=>r?null:(r=!0,o)}}e.toReadable=w;function E(o,r,g){const s=i(g);return I(o,{onData:v=>s.write(r.data(v)),onError:v=>s.error(r.error?r.error(v):v),onEnd:()=>s.end()}),s}e.transform=E;function P(o,r,g){let s=!1;return{read:()=>{const v=r.read();return s?v:(s=!0,v!==null?g([o,v]):o)}}}e.prefixedReadable=P;function p(o,r,g){let s=!1;const v=i(g);return I(r,{onData:n=>s?v.write(n):(s=!0,v.write(g([o,n]))),onError:n=>v.error(n),onEnd:()=>{s||(s=!0,v.write(o)),v.end()}}),v}e.prefixedStream=p}),define(ge[22],pe([0,1,95]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let D,C;class i{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return L?new i(Buffer.allocUnsafe(t)):new i(new Uint8Array(t))}static wrap(t){return L&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new i(t)}static fromString(t,u){return!(u?.dontUseNodeBuffer||!1)&&L?new i(Buffer.from(t)):(D||(D=new TextEncoder),new i(D.encode(t)))}static concat(t,u){if(typeof u=="undefined"){u=0;for(let h=0,c=t.length;h<c;h++)u+=t[h].byteLength}const d=i.alloc(u);let l=0;for(let h=0,c=t.length;h<c;h++){const _=t[h];d.set(_,l),l+=_.byteLength}return d}toString(){return L?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(t,u){return new i(this.buffer.subarray(t,u))}set(t,u){t instanceof i?this.buffer.set(t.buffer,u):this.buffer.set(t,u)}readUInt32BE(t){return y(this.buffer,t)}writeUInt32BE(t,u){T(this.buffer,t,u)}readUInt32LE(t){return I(this.buffer,t)}writeUInt32LE(t,u){a(this.buffer,t,u)}readUInt8(t){return b(this.buffer,t)}writeUInt8(t,u){f(this.buffer,t,u)}}e.VSBuffer=i;function k(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=k;function S(n,t,u){n[u+0]=t&255,t=t>>>8,n[u+1]=t&255}e.writeUInt16LE=S;function y(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=y;function T(n,t,u){n[u+3]=t,t=t>>>8,n[u+2]=t,t=t>>>8,n[u+1]=t,t=t>>>8,n[u]=t}e.writeUInt32BE=T;function I(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=I;function a(n,t,u){n[u+0]=t&255,t=t>>>8,n[u+1]=t&255,t=t>>>8,n[u+2]=t&255,t=t>>>8,n[u+3]=t&255}e.writeUInt32LE=a;function b(n,t){return n[t]}e.readUInt8=b;function f(n,t,u){n[u]=t}e.writeUInt8=f;function w(n){return m.consumeReadable(n,t=>i.concat(t))}e.readableToBuffer=w;function E(n){return m.toReadable(n)}e.bufferToReadable=E;function P(n){return m.consumeStream(n,t=>i.concat(t))}e.streamToBuffer=P;async function p(n){return n.ended?i.concat(n.buffer):i.concat([...n.buffer,await P(n.stream)])}e.bufferedStreamToBuffer=p;function o(n){return m.toStream(n,t=>i.concat(t))}e.bufferToStream=o;function r(n){return m.transform(n,{data:t=>typeof t=="string"?i.fromString(t):i.wrap(t)},t=>i.concat(t))}e.streamToBufferReadableStream=r;function g(n){return m.newWriteableStream(t=>i.concat(t),n)}e.newWriteableBufferStream=g;function s(n,t){return m.prefixedReadable(n,t,u=>i.concat(u))}e.prefixedBufferReadable=s;function v(n,t){return m.prefixedStream(n,t,u=>i.concat(u))}e.prefixedBufferStream=v}),define(ge[8],pe([0,1,12]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(he){return!he||typeof he!="string"?!0:he.trim().length===0}e.isFalsyOrWhitespace=L;const D=/{(\d+)}/g;function C(he,...Ie){return Ie.length===0?he:he.replace(D,function(Be,We){const tt=parseInt(We,10);return isNaN(tt)||tt<0||tt>=Ie.length?Be:Ie[tt]})}e.format=C;const i=/{([^}]+)}/g;function k(he,Ie){return he.replace(i,(Be,We)=>Ie[We]??Be)}e.format2=k;function S(he){return he.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=S;function y(he){return he.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function T(he,Ie){let Be=0;const We=Ie.charCodeAt(0);for(let tt=he.length-1;tt>=0;tt--)he.charCodeAt(tt)===We&&Be++;return Be}e.count=T;function I(he,Ie,Be="\u2026"){return he.length<=Ie?he:`${he.substr(0,Ie)}${Be}`}e.truncate=I;function a(he,Ie=" "){const Be=b(he,Ie);return f(Be,Ie)}e.trim=a;function b(he,Ie){if(!he||!Ie)return he;const Be=Ie.length;if(Be===0||he.length===0)return he;let We=0;for(;he.indexOf(Ie,We)===We;)We=We+Be;return he.substring(We)}e.ltrim=b;function f(he,Ie){if(!he||!Ie)return he;const Be=Ie.length,We=he.length;if(Be===0||We===0)return he;let tt=We,Te=-1;for(;Te=he.lastIndexOf(Ie,tt-1),!(Te===-1||Te+Be!==tt);){if(Te===0)return"";tt=Te}return he.substring(0,tt)}e.rtrim=f;function w(he){return he.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=w;function E(he){return he.replace(/\*/g,"")}e.stripWildcards=E;function P(he,Ie,Be={}){if(!he)throw new Error("Cannot create regex from empty string");Ie||(he=y(he)),Be.wholeWord&&(/\B/.test(he.charAt(0))||(he="\\b"+he),/\B/.test(he.charAt(he.length-1))||(he=he+"\\b"));let We="";return Be.global&&(We+="g"),Be.matchCase||(We+="i"),Be.multiline&&(We+="m"),Be.unicode&&(We+="u"),new RegExp(he,We)}e.createRegExp=P;function p(he){return he.source==="^"||he.source==="^$"||he.source==="$"||he.source==="^\\s*$"?!1:!!(he.exec("")&&he.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function o(he){return!!he.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=o;function r(he){return(he.global?"g":"")+(he.ignoreCase?"i":"")+(he.multiline?"m":"")+(he.unicode?"u":"")}e.regExpFlags=r;function g(he){return he.split(/\r\n|\r|\n/)}e.splitLines=g;function s(he){for(let Ie=0,Be=he.length;Ie<Be;Ie++){const We=he.charCodeAt(Ie);if(We!==32&&We!==9)return Ie}return-1}e.firstNonWhitespaceIndex=s;function v(he,Ie=0,Be=he.length){for(let We=Ie;We<Be;We++){const tt=he.charCodeAt(We);if(tt!==32&&tt!==9)return he.substring(Ie,We)}return he.substring(Ie,Be)}e.getLeadingWhitespace=v;function n(he,Ie=he.length-1){for(let Be=Ie;Be>=0;Be--){const We=he.charCodeAt(Be);if(We!==32&&We!==9)return Be}return-1}e.lastNonWhitespaceIndex=n;function t(he,Ie){return he<Ie?-1:he>Ie?1:0}e.compare=t;function u(he,Ie,Be=0,We=he.length,tt=0,Te=Ie.length){for(;Be<We&&tt<Te;Be++,tt++){let ae=he.charCodeAt(Be),de=Ie.charCodeAt(tt);if(ae<de)return-1;if(ae>de)return 1}const ye=We-Be,be=Te-tt;return ye<be?-1:ye>be?1:0}e.compareSubstring=u;function d(he,Ie){return l(he,Ie,0,he.length,0,Ie.length)}e.compareIgnoreCase=d;function l(he,Ie,Be=0,We=he.length,tt=0,Te=Ie.length){for(;Be<We&&tt<Te;Be++,tt++){let ae=he.charCodeAt(Be),de=Ie.charCodeAt(tt);if(ae===de)continue;if(ae>=128||de>=128)return u(he.toLowerCase(),Ie.toLowerCase(),Be,We,tt,Te);h(ae)&&(ae-=32),h(de)&&(de-=32);const ve=ae-de;if(ve!==0)return ve}const ye=We-Be,be=Te-tt;return ye<be?-1:ye>be?1:0}e.compareSubstringIgnoreCase=l;function h(he){return he>=97&&he<=122}e.isLowerAsciiLetter=h;function c(he){return he>=65&&he<=90}e.isUpperAsciiLetter=c;function _(he,Ie){return he.length===Ie.length&&l(he,Ie)===0}e.equalsIgnoreCase=_;function A(he,Ie){const Be=Ie.length;return Ie.length>he.length?!1:l(he,Ie,0,Be)===0}e.startsWithIgnoreCase=A;function R(he,Ie){let Be,We=Math.min(he.length,Ie.length);for(Be=0;Be<We;Be++)if(he.charCodeAt(Be)!==Ie.charCodeAt(Be))return Be;return We}e.commonPrefixLength=R;function x(he,Ie){let Be,We=Math.min(he.length,Ie.length);const tt=he.length-1,Te=Ie.length-1;for(Be=0;Be<We;Be++)if(he.charCodeAt(tt-Be)!==Ie.charCodeAt(Te-Be))return Be;return We}e.commonSuffixLength=x;function O(he){return 55296<=he&&he<=56319}e.isHighSurrogate=O;function F(he){return 56320<=he&&he<=57343}e.isLowSurrogate=F;function $(he,Ie){return(he-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=$;function M(he,Ie,Be){const We=he.charCodeAt(Be);if(O(We)&&Be+1<Ie){const tt=he.charCodeAt(Be+1);if(F(tt))return $(We,tt)}return We}e.getNextCodePoint=M;function B(he,Ie){const Be=he.charCodeAt(Ie-1);if(F(Be)&&Ie>1){const We=he.charCodeAt(Ie-2);if(O(We))return $(We,Be)}return Be}function U(he,Ie){const Be=st.getInstance(),We=Ie,tt=he.length,Te=M(he,tt,Ie);Ie+=Te>=65536?2:1;let ye=Be.getGraphemeBreakType(Te);for(;Ie<tt;){const be=M(he,tt,Ie),ae=Be.getGraphemeBreakType(be);if(ut(ye,ae))break;Ie+=be>=65536?2:1,ye=ae}return Ie-We}e.nextCharLength=U;function z(he,Ie){const Be=st.getInstance(),We=Ie,tt=B(he,Ie);Ie-=tt>=65536?2:1;let Te=Be.getGraphemeBreakType(tt);for(;Ie>0;){const ye=B(he,Ie),be=Be.getGraphemeBreakType(ye);if(ut(be,Te))break;Ie-=ye>=65536?2:1,Te=be}return We-Ie}e.prevCharLength=z;function K(he,Ie){const Be=st.getInstance(),We=he.length,tt=Ie,Te=M(he,We,Ie),ye=Be.getGraphemeBreakType(Te);Ie+=Te>=65536?2:1;let be=ye;for(;Ie<We;){const de=M(he,We,Ie),ve=Be.getGraphemeBreakType(de);if(ut(be,ve))break;Ie+=de>=65536?2:1,be=ve}const ae=Ie;for(Ie=tt,be=ye;Ie>0;){const de=B(he,Ie),ve=Be.getGraphemeBreakType(de);if(ut(ve,be))break;Ie-=de>=65536?2:1,be=ve}return[Ie,ae]}function N(he,Ie){return Ie>0&&F(he.charCodeAt(Ie))?K(he,Ie-1):K(he,Ie)}e.getCharContainingOffset=N;const j=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function H(he){return j.test(he)}e.containsRTL=H;const V=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function q(he){return V.test(he)}e.containsEmoji=q;const te=/^[\t\n\r\x20-\x7E]*$/;function fe(he){return te.test(he)}e.isBasicASCII=fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ce(he){return e.UNUSUAL_LINE_TERMINATORS.test(he)}e.containsUnusualLineTerminators=Ce;function ke(he){for(let Ie=0,Be=he.length;Ie<Be;Ie++)if(Ue(he.charCodeAt(Ie)))return!0;return!1}e.containsFullWidthCharacter=ke;function Ue(he){return he>=11904&&he<=55215||he>=63744&&he<=64255||he>=65281&&he<=65374}e.isFullWidthCharacter=Ue;function xe(he){return he>=127462&&he<=127487||he===8986||he===8987||he===9200||he===9203||he>=9728&&he<=10175||he===11088||he===11093||he>=127744&&he<=128591||he>=128640&&he<=128764||he>=128992&&he<=129008||he>=129280&&he<=129535||he>=129648&&he<=129782}e.isEmojiImprecise=xe;function ze(he,Ie){if(he.length<Ie)return he;const Be=/\b/g;let We=0;for(;Be.test(he)&&!(he.length-Be.lastIndex<Ie);)We=Be.lastIndex,Be.lastIndex+=1;return he.substring(We).replace(/^\s/,"")}e.lcut=ze;const Q=/\x1B\x5B[12]?K/g,Z=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function ue(he){return he&&(he=he.replace(Q,""),he=he.replace(Z,""),he=he.replace(re,"")),he}e.removeAnsiEscapeCodes=ue,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function J(he){return!!(he&&he.length>0&&he.charCodeAt(0)===65279)}e.startsWithUTF8BOM=J;function ie(he){return J(he)?he.substr(1):he}e.stripUTF8BOM=ie;function we(he,Ie){if(!he||!Ie||he.length<Ie.length)return!1;const Be=Ie.length,We=he.toLowerCase();let tt=0,Te=-1;for(;tt<Be;){const ye=We.indexOf(Ie[tt],Te+1);if(ye<0)return!1;Te=ye,tt++}return!0}e.fuzzyContains=we;function Me(he,Ie=!1){return he?(Ie&&(he=he.replace(/\\./g,"")),he.toLowerCase()!==he):!1}e.containsUppercaseCharacter=Me;function je(he){return he.charAt(0).toUpperCase()+he.slice(1)}e.uppercaseFirstLetter=je;function Ke(he,Ie=1){if(Ie===0)return"";let Be=-1;do Be=he.indexOf(`
`,Be+1),Ie--;while(Ie>0&&Be>=0);return Be===-1?he:(he[Be-1]==="\r"&&Be--,he.substr(0,Be))}e.getNLines=Ke;function Ze(he){const Ie=90-65+1;return he=he%(2*Ie),he<Ie?String.fromCharCode(97+he):String.fromCharCode(65+he-Ie)}e.singleLetterHash=Ze;function rt(he){return st.getInstance().getGraphemeBreakType(he)}e.getGraphemeBreakType=rt;function ut(he,Ie){return he===0?Ie!==5&&Ie!==7:he===2&&Ie===3?!1:he===4||he===2||he===3||Ie===4||Ie===2||Ie===3?!0:!(he===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(he===11||he===9)&&(Ie===9||Ie===10)||(he===12||he===10)&&Ie===10||Ie===5||Ie===13||Ie===7||he===1||he===13&&Ie===14||he===6&&Ie===6)}e.breakBetweenGraphemeBreakType=ut;var it;(function(he){he[he.Other=0]="Other",he[he.Prepend=1]="Prepend",he[he.CR=2]="CR",he[he.LF=3]="LF",he[he.Control=4]="Control",he[he.Extend=5]="Extend",he[he.Regional_Indicator=6]="Regional_Indicator",he[he.SpacingMark=7]="SpacingMark",he[he.L=8]="L",he[he.V=9]="V",he[he.T=10]="T",he[he.LV=11]="LV",he[he.LVT=12]="LVT",he[he.ZWJ=13]="ZWJ",he[he.Extended_Pictographic=14]="Extended_Pictographic"})(it=e.GraphemeBreakType||(e.GraphemeBreakType={}));class st{constructor(){this._data=Ae()}static getInstance(){return st._INSTANCE||(st._INSTANCE=new st),st._INSTANCE}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Be=this._data,We=Be.length/3;let tt=1;for(;tt<=We;)if(Ie<Be[3*tt])tt=2*tt;else if(Ie>Be[3*tt+1])tt=2*tt+1;else return Be[3*tt+2];return 0}}st._INSTANCE=null;function Ae(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function wt(he,Ie){if(he===0)return 0;const Be=ee(he,Ie);if(Be!==void 0)return Be;const We=B(Ie,he);return he-=se(We),he}e.getLeftDeleteOffset=wt;function ee(he,Ie){let Be=B(Ie,he);for(he-=se(Be);Se(Be)||Be===65039||Be===8419;){if(he===0)return;Be=B(Ie,he),he-=se(Be)}if(!!xe(Be)){if(he>=0){const We=B(Ie,he);We===8205&&(he-=se(We))}return he}}function se(he){return he>=65536?2:1}function Se(he){return 127995<=he&&he<=127999}var Ge;(function(he){he[he.zwj=8205]="zwj",he[he.emojiVariantSelector=65039]="emojiVariantSelector",he[he.enclosingKeyCap=8419]="enclosingKeyCap"})(Ge||(Ge={})),e.noBreakWhitespace="\xA0";class Ye{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!Ye.map){let We=function(ye){const be=new Map;for(let ae=0;ae<ye.length;ae+=2)be.set(ye[ae],ye[ae+1]);return be};const Ie=Ye.getData();let Be=m.locale;(!Be||!(Be in Ie))&&(Be=m.language),(!Be||!(Be in Ie))&&(Be="_default");const tt=We(Ie._common),Te=We(Ie[Be]);for(const[ye,be]of Te)tt.set(ye,be);Ye.map=tt}return Ye.map}static isAmbiguous(Ie){return Ye.getConfusablesForCurrentLocale().has(Ie)}static getPrimaryConfusable(Ie){return Ye.getConfusablesForCurrentLocale().get(Ie)}static getPrimaryConfusableCodePoints(){return new Set(Ye.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=Ye;class nt{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(nt.getRawData())),this._data}static isInvisibleCharacter(Ie){return nt.getData().has(Ie)}static get codePoints(){return nt.getData()}}e.InvisibleCharacters=nt,nt._data=void 0}),define(ge[47],pe([0,1,8]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(P){return D(P,0)}e.hash=L;function D(P,p){switch(typeof P){case"object":return P===null?C(349,p):Array.isArray(P)?S(P,p):y(P,p);case"string":return k(P,p);case"boolean":return i(P,p);case"number":return C(P,p);case"undefined":return C(937,p);default:return C(617,p)}}e.doHash=D;function C(P,p){return(p<<5)-p+P|0}e.numberHash=C;function i(P,p){return C(P?433:863,p)}function k(P,p){p=C(149417,p);for(let o=0,r=P.length;o<r;o++)p=C(P.charCodeAt(o),p);return p}e.stringHash=k;function S(P,p){return p=C(104579,p),P.reduce((o,r)=>D(r,o),p)}function y(P,p){return p=C(181387,p),Object.keys(P).sort().reduce((o,r)=>(o=k(r,o),D(P[r],o)),p)}class T{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=D(p,this._value),this._value}}e.Hasher=T;var I;(function(P){P[P.BLOCK_SIZE=64]="BLOCK_SIZE",P[P.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function a(P,p,o=32){const r=o-p,g=~((1<<r)-1);return(P<<p|(g&P)>>>r)>>>0}function b(P,p=0,o=P.byteLength,r=0){for(let g=0;g<o;g++)P[p+g]=r}function f(P,p,o="0"){for(;P.length<p;)P=o+P;return P}function w(P,p=32){return P instanceof ArrayBuffer?Array.from(new Uint8Array(P)).map(o=>o.toString(16).padStart(2,"0")).join(""):f((P>>>0).toString(16),p/4)}e.toHexString=w;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const o=p.length;if(o===0)return;const r=this._buff;let g=this._buffLen,s=this._leftoverHighSurrogate,v,n;for(s!==0?(v=s,n=-1,s=0):(v=p.charCodeAt(0),n=0);;){let t=v;if(m.isHighSurrogate(v))if(n+1<o){const u=p.charCodeAt(n+1);m.isLowSurrogate(u)?(n++,t=m.computeCodePoint(v,u)):t=65533}else{s=v;break}else m.isLowSurrogate(v)&&(t=65533);if(g=this._push(r,g,t),n++,n<o)v=p.charCodeAt(n);else break}this._buffLen=g,this._leftoverHighSurrogate=s}_push(p,o,r){return r<128?p[o++]=r:r<2048?(p[o++]=192|(r&1984)>>>6,p[o++]=128|(r&63)>>>0):r<65536?(p[o++]=224|(r&61440)>>>12,p[o++]=128|(r&4032)>>>6,p[o++]=128|(r&63)>>>0):(p[o++]=240|(r&1835008)>>>18,p[o++]=128|(r&258048)>>>12,p[o++]=128|(r&4032)>>>6,p[o++]=128|(r&63)>>>0),o>=64&&(this._step(),o-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),o}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=E._bigBlock32,o=this._buffDV;for(let l=0;l<64;l+=4)p.setUint32(l,o.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)p.setUint32(l,a(p.getUint32(l-12,!1)^p.getUint32(l-32,!1)^p.getUint32(l-56,!1)^p.getUint32(l-64,!1),1),!1);let r=this._h0,g=this._h1,s=this._h2,v=this._h3,n=this._h4,t,u,d;for(let l=0;l<80;l++)l<20?(t=g&s|~g&v,u=1518500249):l<40?(t=g^s^v,u=1859775393):l<60?(t=g&s|g&v|s&v,u=2400959708):(t=g^s^v,u=3395469782),d=a(r,5)+t+n+u+p.getUint32(l*4,!1)&4294967295,n=v,v=s,s=a(g,30),g=r,r=d;this._h0=this._h0+r&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+v&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[24],pe([0,1,17,8]),function(Y,e,m,L){"use strict";var D,C,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(n,t,u){let d=n.get(t);return d===void 0&&(d=u,n.set(t,d)),d}e.getOrSet=k;function S(n){const t=[];return n.forEach((u,d)=>{t.push(`${d} => ${u}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=S;function y(n){const t=[];return n.forEach(u=>{t.push(u)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=y;class T{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const u=t.charCodeAt(0),d=this._value.charCodeAt(this._pos);return u-d}value(){return this._value[this._pos]}}e.StringIterator=T;class I{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class a{constructor(t=!0,u=!0){this._splitOnBackslash=t,this._caseSensitive=u}reset(t){return this._value=t.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++){const u=this._value.charCodeAt(this._to);if(u===47||this._splitOnBackslash&&u===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=a;var b;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(b||(b={}));class f{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new a(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,L.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(E||(E={}));class P{constructor(t){this._iter=t}static forUris(t=()=>!1){return new P(new f(t))}static forPaths(){return new P(new a)}static forStrings(){return new P(new T)}static forConfigKeys(){return new P(new I)}clear(){this._root=void 0}fill(t,u){if(u){const d=u.slice(0);(0,m.shuffle)(d);for(let l of d)this.set(l,t)}else{const d=t.slice(0);(0,m.shuffle)(d);for(let l of d)this.set(l[0],l[1])}}set(t,u){const d=this._iter.reset(t);let l;this._root||(this._root=new w,this._root.segment=d.value());const h=[];for(l=this._root;;){const _=d.cmp(l.segment);if(_>0)l.left||(l.left=new w,l.left.segment=d.value()),h.push([-1,l]),l=l.left;else if(_<0)l.right||(l.right=new w,l.right.segment=d.value()),h.push([1,l]),l=l.right;else if(d.hasNext())d.next(),l.mid||(l.mid=new w,l.mid.segment=d.value()),h.push([0,l]),l=l.mid;else break}const c=l.value;l.value=u,l.key=t;for(let _=h.length-1;_>=0;_--){const A=h[_][1];A.updateHeight();const R=A.balanceFactor();if(R<-1||R>1){const x=h[_][0],O=h[_+1][0];if(x===1&&O===1)h[_][1]=A.rotateLeft();else if(x===-1&&O===-1)h[_][1]=A.rotateRight();else if(x===1&&O===-1)A.right=h[_+1][1]=h[_+1][1].rotateRight(),h[_][1]=A.rotateLeft();else if(x===-1&&O===1)A.left=h[_+1][1]=h[_+1][1].rotateLeft(),h[_][1]=A.rotateRight();else throw new Error;if(_>0)switch(h[_-1][0]){case-1:h[_-1][1].left=h[_][1];break;case 1:h[_-1][1].right=h[_][1];break;case 0:h[_-1][1].mid=h[_][1];break}else this._root=h[0][1]}}return c}get(t){return this._getNode(t)?.value}_getNode(t){const u=this._iter.reset(t);let d=this._root;for(;d;){const l=u.cmp(d.segment);if(l>0)d=d.left;else if(l<0)d=d.right;else if(u.hasNext())u.next(),d=d.mid;else break}return d}has(t){const u=this._getNode(t);return!(u?.value===void 0&&u?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,u){const d=this._iter.reset(t),l=[];let h=this._root;for(;h;){const c=d.cmp(h.segment);if(c>0)l.push([-1,h]),h=h.left;else if(c<0)l.push([1,h]),h=h.right;else if(d.hasNext())d.next(),l.push([0,h]),h=h.mid;else break}if(!!h){if(u?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const c=this._min(h.right),{key:_,value:A,segment:R}=c;this._delete(c.key,!1),h.key=_,h.value=A,h.segment=R}else{const c=h.left??h.right;if(l.length>0){const[_,A]=l[l.length-1];switch(_){case-1:A.left=c;break;case 0:A.mid=c;break;case 1:A.right=c;break}}else this._root=c}for(let c=l.length-1;c>=0;c--){const _=l[c][1];_.updateHeight();const A=_.balanceFactor();if(A>1?(_.right.balanceFactor()>=0||(_.right=l[c+1][1]=l[c+1][1].rotateRight()),l[c][1]=_.rotateLeft()):A<-1&&(_.left.balanceFactor()<=0||(_.left=l[c+1][1]=l[c+1][1].rotateLeft()),l[c][1]=_.rotateRight()),c>0)switch(l[c-1][0]){case-1:l[c-1][1].left=l[c][1];break;case 1:l[c-1][1].right=l[c][1];break;case 0:l[c-1][1].mid=l[c][1];break}else this._root=l[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const u=this._iter.reset(t);let d=this._root,l;for(;d;){const h=u.cmp(d.segment);if(h>0)d=d.left;else if(h<0)d=d.right;else if(u.hasNext())u.next(),l=d.value||l,d=d.mid;else break}return d&&d.value||l}findSuperstr(t){const u=this._iter.reset(t);let d=this._root;for(;d;){const l=u.cmp(d.segment);if(l>0)d=d.left;else if(l<0)d=d.right;else if(u.hasNext())u.next(),d=d.mid;else return d.mid?this._entries(d.mid):void 0}}forEach(t){for(const[u,d]of this)t(d,u)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=u=>{if(!u)return!0;const d=u.balanceFactor();return d<-1||d>1?!1:t(u.left)&&t(u.right)};return t(this._root)}}e.TernarySearchTree=P;class p{constructor(t,u){this.uri=t,this.value=u}}class o{constructor(t,u){this[D]="ResourceMap",t instanceof o?(this.map=new Map(t.map),this.toKey=u??o.defaultToKey):(this.map=new Map,this.toKey=t??o.defaultToKey)}set(t,u){return this.map.set(this.toKey(t),new p(t,u)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,u){typeof u!="undefined"&&(t=t.bind(u));for(let[d,l]of this.map)t(l.value,l.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=o,o.defaultToKey=n=>n.toString();var r;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(r=e.Touch||(e.Touch={}));class g{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,u=0){const d=this._map.get(t);if(!!d)return u!==0&&this.touch(d,u),d.value}set(t,u,d=0){let l=this._map.get(t);if(l)l.value=u,d!==0&&this.touch(l,d);else{switch(l={key:t,value:u,next:void 0,previous:void 0},d){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(t,l),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const u=this._map.get(t);if(!!u)return this._map.delete(t),this.removeItem(u),this._size--,u.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,u){const d=this._state;let l=this._head;for(;l;){if(u?t.bind(u)(l.value,l.key,this):t(l.value,l.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const t=this,u=this._state;let d=this._head;const l={[Symbol.iterator](){return l},next(){if(t._state!==u)throw new Error("LinkedMap got modified during iteration.");if(d){const h={value:d.key,done:!1};return d=d.next,h}else return{value:void 0,done:!0}}};return l}values(){const t=this,u=this._state;let d=this._head;const l={[Symbol.iterator](){return l},next(){if(t._state!==u)throw new Error("LinkedMap got modified during iteration.");if(d){const h={value:d.value,done:!1};return d=d.next,h}else return{value:void 0,done:!0}}};return l}entries(){const t=this,u=this._state;let d=this._head;const l={[Symbol.iterator](){return l},next(){if(t._state!==u)throw new Error("LinkedMap got modified during iteration.");if(d){const h={value:[d.key,d.value],done:!1};return d=d.next,h}else return{value:void 0,done:!0}}};return l}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let u=this._head,d=this.size;for(;u&&d>t;)this._map.delete(u.key),u=u.next,d--;this._head=u,this._size=d,u&&(u.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const u=t.next,d=t.previous;if(!u||!d)throw new Error("Invalid list");u.previous=d,d.next=u}t.next=void 0,t.previous=void 0,this._state++}touch(t,u){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(t===this._head)return;const d=t.next,l=t.previous;t===this._tail?(l.next=void 0,this._tail=l):(d.previous=l,l.next=d),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(u===2){if(t===this._tail)return;const d=t.next,l=t.previous;t===this._head?(d.previous=void 0,this._head=d):(d.previous=l,l.next=d),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((u,d)=>{t.push([d,u])}),t}fromJSON(t){this.clear();for(const[u,d]of t)this.set(u,d)}}e.LinkedMap=g;class s extends g{constructor(t,u=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,u),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,u=2){return super.get(t,u)}peek(t){return super.get(t,0)}set(t,u){return super.set(t,u,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class v{constructor(t){i.set(this,void 0),ot(this,i,t,"f")}get size(){return Oe(this,i,"f").size}forEach(t,u){Oe(this,i,"f").forEach(t,u)}get(t){return Oe(this,i,"f").get(t)}has(t){return Oe(this,i,"f").has(t)}entries(){return Oe(this,i,"f").entries()}keys(){return Oe(this,i,"f").keys()}values(){return Oe(this,i,"f").values()}[(i=new WeakMap,Symbol.iterator)](){return Oe(this,i,"f").entries()}}e.ReadonlyMapView=v}),define(ge[96],pe([0,1,24,8]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...J){return function(ie,we){for(let Me=0,je=J.length;Me<je;Me++){const Ke=J[Me](ie,we);if(Ke)return Ke}return null}}e.or=D,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(J,ie,we){if(!we||we.length<ie.length)return null;let Me;return J?Me=L.startsWithIgnoreCase(we,ie):Me=we.indexOf(ie)===0,Me?ie.length>0?[{start:0,end:ie.length}]:[]:null}function i(J,ie){const we=ie.toLowerCase().indexOf(J.toLowerCase());return we===-1?null:[{start:we,end:we+J.length}]}e.matchesContiguousSubString=i;function k(J,ie){return S(J.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=k;function S(J,ie,we,Me){if(we===J.length)return[];if(Me===ie.length)return null;if(J[we]===ie[Me]){let je=null;return(je=S(J,ie,we+1,Me+1))?P({start:Me,end:Me+1},je):null}return S(J,ie,we,Me+1)}function y(J){return 97<=J&&J<=122}function T(J){return 65<=J&&J<=90}e.isUpper=T;function I(J){return 48<=J&&J<=57}function a(J){return J===32||J===9||J===10||J===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(J=>b.add(J.charCodeAt(0)));function f(J){return a(J)||b.has(J)}function w(J,ie){return J===ie||f(J)&&f(ie)}function E(J){return y(J)||T(J)||I(J)}function P(J,ie){return ie.length===0?ie=[J]:J.end===ie[0].start?ie[0].start=J.start:ie.unshift(J),ie}function p(J,ie){for(let we=ie;we<J.length;we++){const Me=J.charCodeAt(we);if(T(Me)||I(Me)||we>0&&!E(J.charCodeAt(we-1)))return we}return J.length}function o(J,ie,we,Me){if(we===J.length)return[];if(Me===ie.length)return null;if(J[we]!==ie[Me].toLowerCase())return null;{let je=null,Ke=Me+1;for(je=o(J,ie,we+1,Me+1);!je&&(Ke=p(ie,Ke))<ie.length;)je=o(J,ie,we+1,Ke),Ke++;return je===null?null:P({start:Me,end:Me+1},je)}}function r(J){let ie=0,we=0,Me=0,je=0,Ke=0;for(let st=0;st<J.length;st++)Ke=J.charCodeAt(st),T(Ke)&&ie++,y(Ke)&&we++,E(Ke)&&Me++,I(Ke)&&je++;const Ze=ie/J.length,rt=we/J.length,ut=Me/J.length,it=je/J.length;return{upperPercent:Ze,lowerPercent:rt,alphaPercent:ut,numericPercent:it}}function g(J){const{upperPercent:ie,lowerPercent:we}=J;return we===0&&ie>.6}function s(J){const{upperPercent:ie,lowerPercent:we,alphaPercent:Me,numericPercent:je}=J;return we>.2&&ie<.8&&Me>.6&&je<.2}function v(J){let ie=0,we=0,Me=0,je=0;for(let Ke=0;Ke<J.length;Ke++)Me=J.charCodeAt(Ke),T(Me)&&ie++,y(Me)&&we++,a(Me)&&je++;return(ie===0||we===0)&&je===0?J.length<=30:ie<=5}function n(J,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!v(J)||ie.length>60)return null;const we=r(ie);if(!s(we)){if(!g(we))return null;ie=ie.toLowerCase()}let Me=null,je=0;for(J=J.toLowerCase();je<ie.length&&(Me=o(J,ie,0,je))===null;)je=p(ie,je+1);return Me}e.matchesCamelCase=n;function t(J,ie,we=!1){if(!ie||ie.length===0)return null;let Me=null,je=0;for(J=J.toLowerCase(),ie=ie.toLowerCase();je<ie.length&&(Me=u(J,ie,0,je,we))===null;)je=d(ie,je+1);return Me}e.matchesWords=t;function u(J,ie,we,Me,je){if(we===J.length)return[];if(Me===ie.length)return null;if(w(J.charCodeAt(we),ie.charCodeAt(Me))){let Ke=null,Ze=Me+1;if(Ke=u(J,ie,we+1,Me+1,je),!je)for(;!Ke&&(Ze=d(ie,Ze))<ie.length;)Ke=u(J,ie,we+1,Ze,je),Ze++;return Ke===null?null:P({start:Me,end:Me+1},Ke)}else return null}function d(J,ie){for(let we=ie;we<J.length;we++)if(f(J.charCodeAt(we))||we>0&&f(J.charCodeAt(we-1)))return we;return J.length}const l=D(e.matchesPrefix,n,i),h=D(e.matchesPrefix,n,k),c=new m.LRUCache(1e4);function _(J,ie,we=!1){if(typeof J!="string"||typeof ie!="string")return null;let Me=c.get(J);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(J),"i"),c.set(J,Me));const je=Me.exec(ie);return je?[{start:je.index,end:je.index+je[0].length}]:we?h(J,ie):l(J,ie)}e.matchesFuzzy=_;function A(J,ie){const we=Ue(J,J.toLowerCase(),0,ie,ie.toLowerCase(),0,!0);return we?x(we):null}e.matchesFuzzy2=A;function R(J,ie,we,Me,je,Ke){const Ze=Math.min(13,J.length);for(;we<Ze;we++){const rt=Ue(J,ie,we,Me,je,Ke,!1);if(rt)return rt}return[0,Ke]}e.anyScore=R;function x(J){if(typeof J=="undefined")return[];const ie=[],we=J[1];for(let Me=J.length-1;Me>1;Me--){const je=J[Me]+we,Ke=ie[ie.length-1];Ke&&Ke.end===je?Ke.end=je+1:ie.push({start:je,end:je+1})}return ie}e.createMatches=x;const O=128;function F(){const J=[],ie=[];for(let we=0;we<=O;we++)ie[we]=0;for(let we=0;we<=O;we++)J.push(ie.slice(0));return J}function $(J){const ie=[];for(let we=0;we<=J;we++)ie[we]=0;return ie}const M=$(2*O),B=$(2*O),U=F(),z=F(),K=F(),N=!1;function j(J,ie,we,Me,je){function Ke(rt,ut,it=" "){for(;rt.length<ut;)rt=it+rt;return rt}let Ze=` |   |${Me.split("").map(rt=>Ke(rt,3)).join("|")}
`;for(let rt=0;rt<=we;rt++)rt===0?Ze+=" |":Ze+=`${ie[rt-1]}|`,Ze+=J[rt].slice(0,je+1).map(ut=>Ke(ut.toString(),3)).join("|")+`
`;return Ze}function H(J,ie,we,Me){J=J.substr(ie),we=we.substr(Me),console.log(j(z,J,J.length,we,we.length)),console.log(j(K,J,J.length,we,we.length)),console.log(j(U,J,J.length,we,we.length))}function V(J,ie){if(ie<0||ie>=J.length)return!1;const we=J.codePointAt(ie);switch(we){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(we)}}function q(J,ie){if(ie<0||ie>=J.length)return!1;switch(J.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function te(J,ie,we){return ie[J]!==we[J]}function fe(J,ie,we,Me,je,Ke,Ze=!1){for(;ie<we&&je<Ke;)J[ie]===Me[je]&&(Ze&&(M[ie]=je),ie+=1),je+=1;return ie===we}e.isPatternInWord=fe;var Ce;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var ke;(function(J){J.Default=[-100,0];function ie(we){return!we||we.length===2&&we[0]===-100&&we[1]===0}J.isDefault=ie})(ke=e.FuzzyScore||(e.FuzzyScore={}));function Ue(J,ie,we,Me,je,Ke,Ze){const rt=J.length>O?O:J.length,ut=Me.length>O?O:Me.length;if(we>=rt||Ke>=ut||rt-we>ut-Ke||!fe(ie,we,rt,je,Ke,ut,!0))return;xe(rt,ut,we,Ke,ie,je);let it=1,st=1,Ae=we,wt=Ke;const ee=[!1];for(it=1,Ae=we;Ae<rt;it++,Ae++){const nt=M[Ae],he=B[Ae],Ie=Ae+1<rt?B[Ae+1]:ut;for(st=nt-Ke+1,wt=nt;wt<Ie;st++,wt++){let Be=Number.MIN_SAFE_INTEGER,We=!1;wt<=he&&(Be=ze(J,ie,Ae,we,Me,je,wt,ut,Ke,U[it-1][st-1]===0,ee));let tt=0;Be!==Number.MAX_SAFE_INTEGER&&(We=!0,tt=Be+z[it-1][st-1]);const Te=wt>nt,ye=Te?z[it][st-1]+(U[it][st-1]>0?-5:0):0,be=wt>nt+1&&U[it][st-1]>0,ae=be?z[it][st-2]+(U[it][st-2]>0?-5:0):0;if(be&&(!Te||ae>=ye)&&(!We||ae>=tt))z[it][st]=ae,K[it][st]=3,U[it][st]=0;else if(Te&&(!We||ye>=tt))z[it][st]=ye,K[it][st]=2,U[it][st]=0;else if(We)z[it][st]=tt,K[it][st]=1,U[it][st]=U[it-1][st-1]+1;else throw new Error("not possible")}}if(N&&H(J,we,Me,Ke),!ee[0]&&!Ze)return;it--,st--;const se=[z[it][st],Ke];let Se=0,Ge=0;for(;it>=1;){let nt=st;do{const he=K[it][nt];if(he===3)nt=nt-2;else if(he===2)nt=nt-1;else break}while(nt>=1);Se>1&&ie[we+it-1]===je[Ke+st-1]&&!te(nt+Ke-1,Me,je)&&Se+1>U[it][nt]&&(nt=st),nt===st?Se++:Se=1,Ge||(Ge=nt),it--,st=nt-1,se.push(st)}ut===rt&&(se[0]+=2);const Ye=Ge-rt;return se[0]-=Ye,se}e.fuzzyScore=Ue;function xe(J,ie,we,Me,je,Ke){let Ze=J-1,rt=ie-1;for(;Ze>=we&&rt>=Me;)je[Ze]===Ke[rt]&&(B[Ze]=rt,Ze--),rt--}function ze(J,ie,we,Me,je,Ke,Ze,rt,ut,it,st){if(ie[we]!==Ke[Ze])return Number.MIN_SAFE_INTEGER;let Ae=1,wt=!1;return Ze===we-Me?Ae=J[we]===je[Ze]?7:5:te(Ze,je,Ke)&&(Ze===0||!te(Ze-1,je,Ke))?(Ae=J[we]===je[Ze]?7:5,wt=!0):V(Ke,Ze)&&(Ze===0||!V(Ke,Ze-1))?Ae=5:(V(Ke,Ze-1)||q(Ke,Ze-1))&&(Ae=5,wt=!0),Ae>1&&we===Me&&(st[0]=!0),wt||(wt=te(Ze,je,Ke)||V(Ke,Ze-1)||q(Ke,Ze-1)),we===Me?Ze>ut&&(Ae-=wt?3:5):it?Ae+=wt?2:0:Ae+=wt?0:1,Ze+1===rt&&(Ae-=wt?3:5),Ae}function Q(J,ie,we,Me,je,Ke,Ze){return re(J,ie,we,Me,je,Ke,!0,Ze)}e.fuzzyScoreGracefulAggressive=Q;function Z(J,ie,we,Me,je,Ke,Ze){return re(J,ie,we,Me,je,Ke,!1,Ze)}e.fuzzyScoreGraceful=Z;function re(J,ie,we,Me,je,Ke,Ze,rt){let ut=Ue(J,ie,we,Me,je,Ke,rt);if(ut&&!Ze)return ut;if(J.length>=3){const it=Math.min(7,J.length-1);for(let st=we+1;st<it;st++){const Ae=ue(J,st);if(Ae){const wt=Ue(Ae,Ae.toLowerCase(),we,Me,je,Ke,rt);wt&&(wt[0]-=3,(!ut||wt[0]>ut[0])&&(ut=wt))}}}return ut}function ue(J,ie){if(ie+1>=J.length)return;const we=J[ie],Me=J[ie+1];if(we!==Me)return J.slice(0,ie)+Me+we+J.slice(ie+2)}}),define(ge[141],pe([0,1,78,96,8]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),i=new RegExp(m.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${C.source}`,"g");function S(E){return E.replace(k,(P,p)=>p?P:`\\${P}`)}e.escapeIcons=S;const y=new RegExp(`\\\\${C.source}`,"g");function T(E){return E.replace(y,P=>`\\${P}`)}e.markdownEscapeEscapedIcons=T;const I=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function a(E){return E.indexOf(e.iconStartMarker)===-1?E:E.replace(I,(P,p,o,r)=>o?P:p||r||"")}e.stripIcons=a;function b(E){const P=E.indexOf(e.iconStartMarker);return P===-1?{text:E}:f(E,P)}e.parseLabelWithIcons=b;function f(E,P){const p=[];let o="";function r(l){if(l){o+=l;for(const h of l)p.push(v)}}let g=-1,s="",v=0,n,t,u=P;const d=E.length;for(r(E.substr(0,P));u<d;)n=E[u],t=E[u+1],n===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(g=u,r(s),s=e.iconStartMarker,u++):n===")"&&g!==-1?(v+=u-g+1,g=-1,s=""):g!==-1?i.test(n)?s+=n:(r(s),g=-1,s=""):r(n),u++;return r(s),{text:o,iconOffsets:p}}function w(E,P,p=!1){const{text:o,iconOffsets:r}=P;if(!r||r.length===0)return(0,L.matchesFuzzy)(E,o,p);const g=(0,D.ltrim)(o," "),s=o.length-g.length,v=(0,L.matchesFuzzy)(E,g,p);if(v)for(const n of v){const t=r[n.start+s]+s;n.start+=t,n.end+=t}return v}e.matchesFuzzyIconAware=w}),define(ge[97],pe([0,1,15,141]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(b="",f=!1){if(this.value=b,typeof this.value!="string")throw(0,m.illegalArgument)("value");typeof f=="boolean"?(this.isTrusted=f,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=f.isTrusted??void 0,this.supportThemeIcons=f.supportThemeIcons??!1,this.supportHtml=f.supportHtml??!1)}appendText(b,f=0){return this.value+=y(this.supportThemeIcons?(0,L.escapeIcons)(b):b).replace(/([ \t]+)/g,(w,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,f===1?`\\
`:`

`),this}appendMarkdown(b){return this.value+=b,this}appendCodeblock(b,f){return this.value+="\n```",this.value+=b,this.value+=`
`,this.value+=f,this.value+="\n```\n",this}}e.MarkdownString=C;function i(a){return k(a)?!a.value:Array.isArray(a)?a.every(i):!0}e.isEmptyMarkdownString=i;function k(a){return a instanceof C?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function S(a,b){return a===b?!0:!a||!b?!1:a.value===b.value&&a.isTrusted===b.isTrusted&&a.supportThemeIcons===b.supportThemeIcons}e.markdownStringEqual=S;function y(a){return a.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=y;function T(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=T;function I(a){const b=[],f=a.split("|").map(E=>E.trim());a=f[0];const w=f[1];if(w){const E=/height=(\d+)/.exec(w),P=/width=(\d+)/.exec(w),p=E?E[1]:"",o=P?P[1]:"",r=isFinite(parseInt(o)),g=isFinite(parseInt(p));r&&b.push(`width="${o}"`),g&&b.push(`height="${p}"`)}return{href:a,dimensions:b}}e.parseHrefAndDimensions=I}),define(ge[79],pe([0,1,24]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new m.LRUCache(1e4);function D(y){return S(y,"NFC",L)}e.normalizeNFC=D;const C=new m.LRUCache(1e4);function i(y){return S(y,"NFD",C)}e.normalizeNFD=i;const k=/[^\u0000-\u0080]/;function S(y,T,I){if(!y)return y;const a=I.get(y);if(a)return a;let b;return k.test(y)?b=y.normalize(T):b=y,I.set(y,b),b}e.removeAccents=function(){const y=/[\u0300-\u036f]/g;return function(T){return i(T).replace(y,"")}}()}),define(ge[48],pe([0,1,8]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(L||(L={})),function(D){const C="error",i="warning",k="warn",S="info",y="ignore";function T(a){return a?m.equalsIgnoreCase(C,a)?D.Error:m.equalsIgnoreCase(i,a)||m.equalsIgnoreCase(k,a)?D.Warning:m.equalsIgnoreCase(S,a)?D.Info:D.Ignore:D.Ignore}D.fromValue=T;function I(a){switch(a){case D.Error:return C;case D.Warning:return i;case D.Info:return S;default:return y}}D.toString=I}(L||(L={})),e.default=L}),define(ge[13],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(h){return Array.isArray(h)}e.isArray=m;function L(h){return typeof h=="string"}e.isString=L;function D(h){return Array.isArray(h)&&h.every(c=>L(c))}e.isStringArray=D;function C(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=C;function i(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=i;function k(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=k;function S(h){return h===!0||h===!1}e.isBoolean=S;function y(h){return typeof h=="undefined"}e.isUndefined=y;function T(h){return!I(h)}e.isDefined=T;function I(h){return y(h)||h===null}e.isUndefinedOrNull=I;function a(h,c){if(!h)throw new Error(c?`Unexpected type, expected '${c}'`:"Unexpected type")}e.assertType=a;function b(h){if(I(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=b;function f(...h){const c=[];for(let _=0;_<h.length;_++){const A=h[_];if(I(A))throw new Error(`Assertion Failed: argument at index ${_} is undefined or null`);c.push(A)}return c}e.assertAllDefined=f;const w=Object.prototype.hasOwnProperty;function E(h){if(!C(h))return!1;for(let c in h)if(w.call(h,c))return!1;return!0}e.isEmptyObject=E;function P(h){return typeof h=="function"}e.isFunction=P;function p(...h){return h.length>0&&h.every(P)}e.areFunctions=p;function o(h,c){const _=Math.min(h.length,c.length);for(let A=0;A<_;A++)r(h[A],c[A])}e.validateConstraints=o;function r(h,c){if(L(c)){if(typeof h!==c)throw new Error(`argument does not match constraint: typeof ${c}`)}else if(P(c)){try{if(h instanceof c)return}catch{}if(!I(h)&&h.constructor===c||c.length===1&&c.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=r;function g(h){let c=[],_=Object.getPrototypeOf(h);for(;Object.prototype!==_;)c=c.concat(Object.getOwnPropertyNames(_)),_=Object.getPrototypeOf(_);return c}e.getAllPropertyNames=g;function s(h){const c=[];for(const _ of g(h))typeof h[_]=="function"&&c.push(_);return c}e.getAllMethodNames=s;function v(h,c){const _=R=>function(){const x=Array.prototype.slice.call(arguments,0);return c(R,x)};let A={};for(const R of h)A[R]=_(R);return A}e.createProxyObject=v;function n(h){return h===null?void 0:h}e.withNullAsUndefined=n;function t(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=t;function u(h){return class{constructor(){return new Proxy({},{get(c,_){if(c[_])return c[_];throw new Error(`Not Implemented: ${h}->${String(_)}`)}})}}}e.NotImplementedProxy=u;function d(h,c="Unreachable"){throw new Error(c)}e.assertNever=d;function l(h){return!!h&&typeof h.then=="function"&&typeof h.catch=="function"}e.isPromise=l}),define(ge[30],pe([0,1,9,12,8,13]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function i(n){return n===47||n===92}e.isPathSeparator=i;function k(n){return n.replace(/[\\/]/g,m.posix.sep)}e.toSlashes=k;function S(n){return n.indexOf("/")===-1&&(n=k(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=S;function y(n,t=m.posix.sep){if(!n)return"";const u=n.length,d=n.charCodeAt(0);if(i(d)){if(i(n.charCodeAt(1))&&!i(n.charCodeAt(2))){let h=3;const c=h;for(;h<u&&!i(n.charCodeAt(h));h++);if(c!==h&&!i(n.charCodeAt(h+1))){for(h+=1;h<u;h++)if(i(n.charCodeAt(h)))return n.slice(0,h+1).replace(/[\\/]/g,t)}}return t}else if(P(d)&&n.charCodeAt(1)===58)return i(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let l=n.indexOf("://");if(l!==-1){for(l+=3;l<u;l++)if(i(n.charCodeAt(l)))return n.slice(0,l+1)}return""}e.getRoot=y;function T(n){if(!L.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let u=2;const d=u;for(;u<n.length&&(t=n.charCodeAt(u),t!==92);u++);return!(d===u||(t=n.charCodeAt(u+1),isNaN(t)||t===92))}e.isUNC=T;const I=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(n,t=L.isWindows){const u=t?I:a;return!(!n||n.length===0||/^\s+$/.test(n)||(u.lastIndex=0,u.test(n))||t&&b.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=f;function w(n,t,u){const d=n===t;return!u||d?d:!n||!t?!1:(0,D.equalsIgnoreCase)(n,t)}e.isEqual=w;function E(n,t,u,d=m.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(u){if(!(0,D.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let h=t.length;return t.charAt(t.length-1)===d&&h--,n.charAt(h)===d}return t.charAt(t.length-1)!==d&&(t+=d),n.indexOf(t)===0}e.isEqualOrParent=E;function P(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=P;function p(n,t){return L.isWindows&&n.endsWith(":")&&(n+=m.sep),(0,m.isAbsolute)(n)||(n=(0,m.join)(t,n)),n=(0,m.normalize)(n),L.isWindows?(n=(0,D.rtrim)(n,m.sep),n.endsWith(":")&&(n+=m.sep)):(n=(0,D.rtrim)(n,m.sep),n||(n=m.sep)),n}e.sanitizeFilePath=p;function o(n){const t=(0,m.normalize)(n);return L.isWindows?n.length>3?!1:r(t)&&(n.length===2||t.charCodeAt(2)===92):t===m.posix.sep}e.isRootOrDriveLetter=o;function r(n,t){return(t!==void 0?t:L.isWindows)?P(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=r;function g(n){return r(n)?n[0]:void 0}e.getDriveLetter=g;function s(n,t,u){return t.length>n.length?-1:n===t?0:(u&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=s;function v(n){const t=n.split(":");let u,d,l;if(t.forEach(h=>{const c=Number(h);(0,C.isNumber)(c)?d===void 0?d=c:l===void 0&&(l=c):u=u?[u,h].join(":"):h}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:d!==void 0?d:void 0,column:l!==void 0?l:d!==void 0?1:void 0}}e.parseLineAndColumnAware=v}),define(ge[25],pe([0,1,13]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const E=Array.isArray(w)?[]:{};return Object.keys(w).forEach(P=>{w[P]&&typeof w[P]=="object"?E[P]=L(w[P]):E[P]=w[P]}),E}e.deepClone=L;function D(w){if(!w||typeof w!="object")return w;const E=[w];for(;E.length>0;){const P=E.shift();Object.freeze(P);for(const p in P)if(C.call(P,p)){const o=P[p];typeof o=="object"&&!Object.isFrozen(o)&&E.push(o)}}return w}e.deepFreeze=D;const C=Object.prototype.hasOwnProperty;function i(w,E){return k(w,E,new Set)}e.cloneAndChange=i;function k(w,E,P){if((0,m.isUndefinedOrNull)(w))return w;const p=E(w);if(typeof p!="undefined")return p;if((0,m.isArray)(w)){const o=[];for(const r of w)o.push(k(r,E,P));return o}if((0,m.isObject)(w)){if(P.has(w))throw new Error("Cannot clone recursive data-structure");P.add(w);const o={};for(let r in w)C.call(w,r)&&(o[r]=k(w[r],E,P));return P.delete(w),o}return w}function S(w,E,P=!0){return(0,m.isObject)(w)?((0,m.isObject)(E)&&Object.keys(E).forEach(p=>{p in w?P&&((0,m.isObject)(w[p])&&(0,m.isObject)(E[p])?S(w[p],E[p],P):w[p]=E[p]):w[p]=E[p]}),w):E}e.mixin=S;function y(w,E){if(w===E)return!0;if(w==null||E===null||E===void 0||typeof w!=typeof E||typeof w!="object"||Array.isArray(w)!==Array.isArray(E))return!1;let P,p;if(Array.isArray(w)){if(w.length!==E.length)return!1;for(P=0;P<w.length;P++)if(!y(w[P],E[P]))return!1}else{const o=[];for(p in w)o.push(p);o.sort();const r=[];for(p in E)r.push(p);if(r.sort(),!y(o,r))return!1;for(P=0;P<o.length;P++)if(!y(w[o[P]],E[o[P]]))return!1}return!0}e.equals=y;function T(w){const E=new Set;return JSON.stringify(w,(P,p)=>{if((0,m.isObject)(p)||Array.isArray(p)){if(E.has(p))return"[Circular]";E.add(p)}return p})}e.safeStringify=T;function I(w,E,P){const p=E(w);return typeof p=="undefined"?P:p}e.getOrDefault=I;function a(w,E){const P=Object.create(null);return!w||!E||Object.keys(E).forEach(o=>{const r=w[o],g=E[o];y(r,g)||(P[o]=g)}),P}e.distinct=a;function b(w,E){const P=E.toLowerCase(),p=Object.keys(w).find(o=>o.toLowerCase()===P);return p?w[p]:w[E]}e.getCaseInsensitive=b;function f(w,E){const P=Object.create(null);for(const[p,o]of Object.entries(w))E(p,o)&&(P[p]=o);return P}e.filter=f}),define(ge[98],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function L(C){return C<0?0:C>255?255:C|0}e.toUint8=L;function D(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=D}),define(ge[2],pe([0,1,9,12]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,C=/^\//,i=/^\/\//;function k(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!D.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!C.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(i.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(n,t){return!n&&!t?"file":n}function y(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==I&&(t=I+t):t=I;break}return t}const T="",I="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(t,u,d,l,h,c=!1){typeof t=="object"?(this.scheme=t.scheme||T,this.authority=t.authority||T,this.path=t.path||T,this.query=t.query||T,this.fragment=t.fragment||T):(this.scheme=S(t,c),this.authority=u||T,this.path=y(this.scheme,d||T),this.query=l||T,this.fragment=h||T,k(this,c))}static isUri(t){return t instanceof b?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return o(this,!1)}with(t){if(!t)return this;let{scheme:u,authority:d,path:l,query:h,fragment:c}=t;return u===void 0?u=this.scheme:u===null&&(u=T),d===void 0?d=this.authority:d===null&&(d=T),l===void 0?l=this.path:l===null&&(l=T),h===void 0?h=this.query:h===null&&(h=T),c===void 0?c=this.fragment:c===null&&(c=T),u===this.scheme&&d===this.authority&&l===this.path&&h===this.query&&c===this.fragment?this:new w(u,d,l,h,c)}static parse(t,u=!1){const d=a.exec(t);return d?new w(d[2]||T,v(d[4]||T),v(d[5]||T),v(d[7]||T),v(d[9]||T),u):new w(T,T,T,T,T)}static file(t){let u=T;if(L.isWindows&&(t=t.replace(/\\/g,I)),t[0]===I&&t[1]===I){const d=t.indexOf(I,2);d===-1?(u=t.substring(2),t=I):(u=t.substring(2,d),t=t.substring(d)||I)}return new w("file",u,t,T,T)}static from(t){const u=new w(t.scheme,t.authority,t.path,t.query,t.fragment);return k(u,!0),u}static joinPath(t,...u){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return L.isWindows&&t.scheme==="file"?d=b.file(m.win32.join(o(t,!0),...u)).path:d=m.posix.join(t.path,...u),t.with({path:d})}toString(t=!1){return r(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof b)return t;{const u=new w(t);return u._formatted=t.external,u._fsPath=t._sep===f?t.fsPath:null,u}}else return t}}e.URI=b;const f=L.isWindows?1:void 0;class w extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(t=!1){return t?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=f),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function P(n,t){let u,d=-1;for(let l=0;l<n.length;l++){const h=n.charCodeAt(l);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||t&&h===47)d!==-1&&(u+=encodeURIComponent(n.substring(d,l)),d=-1),u!==void 0&&(u+=n.charAt(l));else{u===void 0&&(u=n.substr(0,l));const c=E[h];c!==void 0?(d!==-1&&(u+=encodeURIComponent(n.substring(d,l)),d=-1),u+=c):d===-1&&(d=l)}}return d!==-1&&(u+=encodeURIComponent(n.substring(d))),u!==void 0?u:n}function p(n){let t;for(let u=0;u<n.length;u++){const d=n.charCodeAt(u);d===35||d===63?(t===void 0&&(t=n.substr(0,u)),t+=E[d]):t!==void 0&&(t+=n[u])}return t!==void 0?t:n}function o(n,t){let u;return n.authority&&n.path.length>1&&n.scheme==="file"?u=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?u=n.path.substr(1):u=n.path[1].toLowerCase()+n.path.substr(2):u=n.path,L.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=o;function r(n,t){const u=t?p:P;let d="",{scheme:l,authority:h,path:c,query:_,fragment:A}=n;if(l&&(d+=l,d+=":"),(h||l==="file")&&(d+=I,d+=I),h){let R=h.indexOf("@");if(R!==-1){const x=h.substr(0,R);h=h.substr(R+1),R=x.indexOf(":"),R===-1?d+=u(x,!1):(d+=u(x.substr(0,R),!1),d+=":",d+=u(x.substr(R+1),!1)),d+="@"}h=h.toLowerCase(),R=h.indexOf(":"),R===-1?d+=u(h,!1):(d+=u(h.substr(0,R),!1),d+=h.substr(R))}if(c){if(c.length>=3&&c.charCodeAt(0)===47&&c.charCodeAt(2)===58){const R=c.charCodeAt(1);R>=65&&R<=90&&(c=`/${String.fromCharCode(R+32)}:${c.substr(3)}`)}else if(c.length>=2&&c.charCodeAt(1)===58){const R=c.charCodeAt(0);R>=65&&R<=90&&(c=`${String.fromCharCode(R+32)}:${c.substr(2)}`)}d+=u(c,!0)}return _&&(d+="?",d+=u(_,!1)),A&&(d+="#",d+=t?A:P(A,!1)),d}function g(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+g(n.substr(3)):n}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function v(n){return n.match(s)?n.replace(s,t=>g(t)):n}}),define(ge[59],pe([0,1,22,8,2]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(T){return JSON.stringify(T,S)}e.stringify=C;function i(T){let I=JSON.parse(T);return I=y(I),I}e.parse=i;var k;(function(T){T[T.Uri=1]="Uri",T[T.Regexp=2]="Regexp",T[T.ScmResource=3]="ScmResource",T[T.ScmResourceGroup=4]="ScmResourceGroup",T[T.ScmProvider=5]="ScmProvider",T[T.CommentController=6]="CommentController",T[T.CommentThread=7]="CommentThread",T[T.CommentThreadReply=8]="CommentThreadReply",T[T.CommentNode=9]="CommentNode",T[T.CommentThreadNode=10]="CommentThreadNode",T[T.TimelineActionContext=11]="TimelineActionContext",T[T.NotebookCellActionContext=12]="NotebookCellActionContext",T[T.TestItemContext=13]="TestItemContext"})(k=e.MarshalledId||(e.MarshalledId={}));function S(T,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function y(T,I=0){if(!T||I>200)return T;if(typeof T=="object"){switch(T.$mid){case 1:return D.URI.revive(T);case 2:return new RegExp(T.source,T.flags)}if(T instanceof m.VSBuffer||T instanceof Uint8Array)return T;if(Array.isArray(T))for(let a=0;a<T.length;++a)T[a]=y(T[a],I+1);else for(const a in T)Object.hasOwnProperty.call(T,a)&&(T[a]=y(T[a],I+1))}return T}e.revive=y}),define(ge[10],pe([0,1,12,2]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,y,T){this._hosts[S]=y,this._ports[S]=T}setConnectionToken(S,y){this._connectionTokens[S]=y}rewrite(S){if(this._delegate)return this._delegate(S);const y=S.authority;let T=this._hosts[y];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const I=this._ports[y],a=this._connectionTokens[y];let b=`path=${encodeURIComponent(S.path)}`;return typeof a=="string"&&(b+=`&tkn=${encodeURIComponent(a)}`),L.URI.from({scheme:m.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${T}:${I}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new C;class i{asBrowserUri(S,y){const T=this.toUri(S,y);return T.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(T):T.scheme===D.file&&(m.isNative||typeof m.globals.importScripts=="function"&&m.globals.origin===`${D.vscodeFileResource}://${i.FALLBACK_AUTHORITY}`)?T.with({scheme:D.vscodeFileResource,authority:T.authority||i.FALLBACK_AUTHORITY,query:null,fragment:null}):T}asFileUri(S,y){const T=this.toUri(S,y);return T.scheme===D.vscodeFileResource?T.with({scheme:D.file,authority:T.authority!==i.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(S,y){return L.URI.isUri(S)?S:L.URI.parse(y.toUrl(S))}}i.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new i}),define(ge[23],pe([0,1,30,10,9,12,8,2]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(b){return(0,k.uriToFsPath)(b,!0)}e.originalFSPath=S;class y{constructor(f){this._ignorePathCasing=f}compare(f,w,E=!1){return f===w?0:(0,i.compare)(this.getComparisonKey(f,E),this.getComparisonKey(w,E))}isEqual(f,w,E=!1){return f===w?!0:!f||!w?!1:this.getComparisonKey(f,E)===this.getComparisonKey(w,E)}getComparisonKey(f,w=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,w,E=!1){if(f.scheme===w.scheme){if(f.scheme===L.Schemas.file)return m.isEqualOrParent(S(f),S(w),this._ignorePathCasing(f))&&f.query===w.query&&(E||f.fragment===w.fragment);if((0,e.isEqualAuthority)(f.authority,w.authority))return m.isEqualOrParent(f.path,w.path,this._ignorePathCasing(f),"/")&&f.query===w.query&&(E||f.fragment===w.fragment)}return!1}joinPath(f,...w){return k.URI.joinPath(f,...w)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return D.posix.basename(f.path)}extname(f){return D.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let w;return f.scheme===L.Schemas.file?w=k.URI.file(D.dirname(S(f))).path:(w=D.posix.dirname(f.path),f.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),w="/")),f.with({path:w})}normalizePath(f){if(!f.path.length)return f;let w;return f.scheme===L.Schemas.file?w=k.URI.file(D.normalize(S(f))).path:w=D.posix.normalize(f.path),f.with({path:w})}relativePath(f,w){if(f.scheme!==w.scheme||!(0,e.isEqualAuthority)(f.authority,w.authority))return;if(f.scheme===L.Schemas.file){const p=D.relative(S(f),S(w));return C.isWindows?m.toSlashes(p):p}let E=f.path||"/",P=w.path||"/";if(this._ignorePathCasing(f)){let p=0;for(const o=Math.min(E.length,P.length);p<o&&!(E.charCodeAt(p)!==P.charCodeAt(p)&&E.charAt(p).toLowerCase()!==P.charAt(p).toLowerCase());p++);E=P.substr(0,p)+E.substr(p)}return D.posix.relative(E,P)}resolvePath(f,w){if(f.scheme===L.Schemas.file){const E=k.URI.file(D.resolve(S(f),w));return f.with({authority:E.authority,path:E.path})}return w=m.toPosixPath(w),f.with({path:D.posix.resolve(f.path,w)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,w){return f===w||f!==void 0&&w!==void 0&&(0,i.equalsIgnoreCase)(f,w)}hasTrailingPathSeparator(f,w=D.sep){if(f.scheme===L.Schemas.file){const E=S(f);return E.length>m.getRoot(E).length&&E[E.length-1]===w}else{const E=f.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,w=D.sep){return(0,e.hasTrailingPathSeparator)(f,w)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,w=D.sep){let E=!1;if(f.scheme===L.Schemas.file){const P=S(f);E=P!==void 0&&P.length===m.getRoot(P).length&&P[P.length-1]===w}else{w="/";const P=f.path;E=P.length===1&&P.charCodeAt(P.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(f,w)?f.with({path:f.path+"/"}):f}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(b=>b.scheme===L.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new y(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(b,f){const w=[];for(let E=0;E<b.length;E++){const P=f(b[E]);b.some((p,o)=>o===E?!1:(0,e.isEqualOrParent)(P,f(p)))||w.push(b[E])}return w}e.distinctParents=T;var I;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function f(w){const E=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(o=>{const[r,g]=o.split(":");r&&g&&E.set(r,g)});const p=w.path.substring(0,w.path.indexOf(";"));return p&&E.set(b.META_DATA_MIME,p),E}b.parseMetaData=f})(I=e.DataUri||(e.DataUri={}));function a(b,f,w){if(f){let E=b.path;return E&&E[0]!==D.posix.sep&&(E=D.posix.sep+E),b.with({scheme:w,authority:f,path:E})}return b.with({scheme:w})}e.toLocalResource=a}),define(ge[18],pe([0,1,21,15,3,6,23,12]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(H){return!!H&&typeof H.then=="function"}e.isThenable=S;function y(H){const V=new m.CancellationTokenSource,q=H(V.token),te=new Promise((fe,Ce)=>{const ke=V.token.onCancellationRequested(()=>{ke.dispose(),V.dispose(),Ce((0,L.canceled)())});Promise.resolve(q).then(Ue=>{ke.dispose(),V.dispose(),fe(Ue)},Ue=>{ke.dispose(),V.dispose(),Ce(Ue)})});return new class{cancel(){V.cancel()}then(fe,Ce){return te.then(fe,Ce)}catch(fe){return this.then(void 0,fe)}finally(fe){return te.finally(fe)}}}e.createCancelablePromise=y;function T(H,V,q){return Promise.race([H,new Promise(te=>V.onCancellationRequested(()=>te(q)))])}e.raceCancellation=T;async function I(H){let V=-1;const q=H.map((fe,Ce)=>fe.then(ke=>(V=Ce,ke))),te=await Promise.race(q);return H.forEach((fe,Ce)=>{Ce!==V&&fe.cancel()}),te}e.raceCancellablePromises=I;function a(H,V,q){let te;const fe=setTimeout(()=>{te?.(void 0),q?.()},V);return Promise.race([H.finally(()=>clearTimeout(fe)),new Promise(Ce=>te=Ce)])}e.raceTimeout=a;function b(H){return new Promise((V,q)=>{const te=H();S(te)?te.then(V,q):V(te)})}e.asPromise=b;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(V){if(this.activePromise){if(this.queuedPromiseFactory=V,!this.queuedPromise){const q=()=>{this.queuedPromise=null;const te=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,te};this.queuedPromise=new Promise(te=>{this.activePromise.then(q,q).then(te)})}return new Promise((q,te)=>{this.queuedPromise.then(q,te)})}return this.activePromise=V(),new Promise((q,te)=>{this.activePromise.then(fe=>{this.activePromise=null,q(fe)},fe=>{this.activePromise=null,te(fe)})})}}e.Throttler=f;class w{constructor(){this.current=Promise.resolve(null)}queue(V){return this.current=this.current.then(()=>V(),()=>V())}}e.Sequencer=w;class E{constructor(){this.promiseMap=new Map}queue(V,q){const fe=(this.promiseMap.get(V)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.promiseMap.get(V)===fe&&this.promiseMap.delete(V)});return this.promiseMap.set(V,fe),fe}}e.SequencerByKey=E;class P{constructor(V){this.defaultDelay=V,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(V,q=this.defaultDelay){return this.task=V,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((te,fe)=>{this.doResolve=te,this.doReject=fe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const te=this.task;return this.task=null,te()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=P;class p{constructor(V){this.delayer=new P(V),this.throttler=new f}trigger(V,q){return this.delayer.trigger(()=>this.throttler.queue(V),q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=p;class o{constructor(){this._isOpen=!1,this._promise=new Promise((V,q)=>{this._completePromise=V})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class r extends o{constructor(V){super();this._timeout=setTimeout(()=>this.open(),V)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function g(H,V){return V?new Promise((q,te)=>{const fe=setTimeout(()=>{Ce.dispose(),q()},H),Ce=V.onCancellationRequested(()=>{clearTimeout(fe),Ce.dispose(),te((0,L.canceled)())})}):y(q=>g(H,q))}e.timeout=g;function s(H,V=0){const q=setTimeout(H,V);return(0,C.toDisposable)(()=>clearTimeout(q))}e.disposableTimeout=s;function v(H){const V=[];let q=0;const te=H.length;function fe(){return q<te?H[q++]():null}function Ce(ke){ke!=null&&V.push(ke);const Ue=fe();return Ue?Ue.then(Ce):Promise.resolve(V)}return Promise.resolve(null).then(Ce)}e.sequence=v;function n(H,V=te=>!!te,q=null){let te=0;const fe=H.length,Ce=()=>{if(te>=fe)return Promise.resolve(q);const ke=H[te++];return Promise.resolve(ke()).then(xe=>V(xe)?Promise.resolve(xe):Ce())};return Ce()}e.first=n;function t(H,V=te=>!!te,q=null){if(H.length===0)return Promise.resolve(q);let te=H.length;const fe=()=>{te=-1;for(const Ce of H)Ce.cancel?.()};return new Promise((Ce,ke)=>{for(const Ue of H)Ue.then(xe=>{--te>=0&&V(xe)?(fe(),Ce(xe)):te===0&&Ce(q)}).catch(xe=>{--te>=0&&(fe(),ke(xe))})})}e.firstParallel=t;class u{constructor(V){this._size=0,this.maxDegreeOfParalellism=V,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(V){return this._size++,new Promise((q,te)=>{this.outstandingPromises.push({factory:V,c:q,e:te}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const V=this.outstandingPromises.shift();this.runningPromises++;const q=V.factory();q.then(V.c,V.e),q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=u;class d extends u{constructor(){super(1)}}e.Queue=d;class l{constructor(){this.queues=new Map}queueFor(V,q=i.extUri){const te=q.getComparisonKey(V);let fe=this.queues.get(te);return fe||(fe=new d,D.Event.once(fe.onFinished)(()=>{fe?.dispose(),this.queues.delete(te)}),this.queues.set(te,fe)),fe}dispose(){this.queues.forEach(V=>V.dispose()),this.queues.clear()}}e.ResourceQueue=l;class h{constructor(V,q){this._token=-1,typeof V=="function"&&typeof q=="number"&&this.setIfNotSet(V,q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(V,q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,V()},q)}setIfNotSet(V,q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,V()},q))}}e.TimeoutTimer=h;class c{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(V,q){this.cancel(),this._token=setInterval(()=>{V()},q)}}e.IntervalTimer=c;class _{constructor(V,q){this.timeoutToken=-1,this.runner=V,this.timeout=q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(V=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,V)}get delay(){return this.timeout}set delay(V){this.timeout=V}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=_;class A{constructor(V,q){q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.runner=V,this.timeout=q,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(V=this.timeout){V%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(V/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class R extends _{constructor(V,q){super(V,q);this.units=[]}work(V){this.units.push(V),this.isScheduled()||this.schedule()}doRun(){const V=this.units;this.units=[],this.runner&&this.runner(V)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=R;class x extends C.Disposable{constructor(V,q,te,fe){super();this.maxWorkChunkSize=V,this.maxPendingWork=q,this.throttleDelay=te,this.handler=fe,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(V){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+V.length>this.maxPendingWork)return!1}else if(this.pending+V.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...V),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new _(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=x,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{(0,k.setTimeout0)(()=>{if(V)return;const q=Date.now()+3;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,q-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0)}}}:e.runWhenIdle=(H,V)=>{const q=requestIdleCallback(H,typeof V=="number"?{timeout:V}:void 0);let te=!1;return{dispose(){te||(te=!0,cancelIdleCallback(q))}}}}();class O{constructor(V){this._didRun=!1,this._executor=()=>{try{this._value=V()}catch(q){this._error=q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=O;async function F(H,V,q){let te;for(let fe=0;fe<q;fe++)try{return await H()}catch(Ce){te=Ce,await g(V)}throw te}e.retry=F;class ${hasPending(V){return this._pending?typeof V=="number"?this._pending.taskId===V:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(V,q,te){return this._pending={taskId:V,cancel:()=>te?.(),promise:q},q.then(()=>this.donePending(V),()=>this.donePending(V)),q}donePending(V){this._pending&&V===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const V=this._next;this._next=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}setNext(V){if(this._next)this._next.run=V;else{let q,te;const fe=new Promise((Ce,ke)=>{q=Ce,te=ke});this._next={run:V,promise:fe,promiseResolve:q,promiseReject:te}}return this._next.promise}}e.TaskSequentializer=$;class M{constructor(V,q=()=>Date.now()){this.interval=V,this.nowFn=q,this.lastIncrementTime=0,this.value=0}increment(){const V=this.nowFn();return V-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=V,this.value=0),this.value++,this.value}}e.IntervalCounter=M;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((V,q)=>{this.completeCallback=V,this.errorCallback=q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(V){return new Promise(q=>{this.completeCallback(V),this.resolved=!0,q()})}error(V){return new Promise(q=>{this.errorCallback(V),this.rejected=!0,q()})}cancel(){new Promise(V=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,V()})}}e.DeferredPromise=B;var U;(function(H){async function V(te){let fe;const Ce=await Promise.all(te.map(ke=>ke.then(Ue=>Ue,Ue=>{fe||(fe=Ue)})));if(typeof fe!="undefined")throw fe;return Ce}H.settled=V;function q(te){return new Promise(async(fe,Ce)=>{try{await te(fe,Ce)}catch(ke){Ce(ke)}})}H.withAsyncBody=q})(U=e.Promises||(e.Promises={}));var z;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(z||(z={}));class K{constructor(V){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const q={emitOne:te=>this.emitOne(te),emitMany:te=>this.emitMany(te),reject:te=>this.reject(te)};try{await Promise.resolve(V(q)),this.resolve()}catch(te){this.reject(te)}finally{q.emitOne=void 0,q.emitMany=void 0,q.reject=void 0}})}static fromArray(V){return new K(q=>{q.emitMany(V)})}static fromPromise(V){return new K(async q=>{q.emitMany(await V)})}static fromPromises(V){return new K(async q=>{await Promise.all(V.map(async te=>q.emitOne(await te)))})}static merge(V){return new K(async q=>{await Promise.all(V.map(async te=>{for await(const fe of te)q.emitOne(fe)}))})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(V<this._results.length)return{done:!1,value:this._results[V++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(V,q){return new K(async te=>{for await(const fe of V)te.emitOne(q(fe))})}map(V){return K.map(this,V)}static filter(V,q){return new K(async te=>{for await(const fe of V)q(fe)&&te.emitOne(fe)})}filter(V){return K.filter(this,V)}static coalesce(V){return K.filter(V,q=>!!q)}coalesce(){return K.coalesce(this)}static async toPromise(V){const q=[];for await(const te of V)q.push(te);return q}toPromise(){return K.toPromise(this)}emitOne(V){this._state===0&&(this._results.push(V),this._onStateChanged.fire())}emitMany(V){this._state===0&&(this._results=this._results.concat(V),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(V){this._state===0&&(this._state=2,this._error=V,this._onStateChanged.fire())}}e.AsyncIterableObject=K,K.EMPTY=K.fromArray([]);class N extends K{constructor(V,q){super(q);this._source=V}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=N;function j(H){const V=new m.CancellationTokenSource,q=H(V.token);return new N(V,async te=>{const fe=V.token.onCancellationRequested(()=>{fe.dispose(),V.dispose(),te.reject((0,L.canceled)())});try{for await(const Ce of q){if(V.token.isCancellationRequested)return;te.emitOne(Ce)}fe.dispose(),V.dispose()}catch(Ce){fe.dispose(),V.dispose(),te.reject(Ce)}})}e.createCancelableAsyncIterable=j}),define(ge[99],pe([0,1,18,9]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new m.IdleValue(()=>{const c=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:c,collatorIsNumeric:c.resolvedOptions().numeric}}),C=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),i=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(c,_,A=!1){const R=c||"",x=_||"",O=D.value.collator.compare(R,x);return D.value.collatorIsNumeric&&O===0&&R!==x?R<x?-1:1:O}e.compareFileNames=k;function S(c,_){const A=C.value.collator;return c=c||"",_=_||"",g(A,c,_)}e.compareFileNamesDefault=S;function y(c,_){const A=C.value.collator;return c=c||"",_=_||"",t(c,_)||g(A,c,_)}e.compareFileNamesUpper=y;function T(c,_){const A=C.value.collator;return c=c||"",_=_||"",n(c,_)||g(A,c,_)}e.compareFileNamesLower=T;function I(c,_){return c=c||"",_=_||"",c===_?0:c<_?-1:1}e.compareFileNamesUnicode=I;function a(c,_,A=!1){A||(c=c&&c.toLowerCase(),_=_&&_.toLowerCase());const[R,x]=o(c),[O,F]=o(_);return R!==O?R<O?-1:1:x===F?0:x<F?-1:1}e.noIntlCompareFileNames=a;function b(c,_){const[A,R]=o(c),[x,O]=o(_);let F=D.value.collator.compare(R,O);if(F===0){if(D.value.collatorIsNumeric&&R!==O)return R<O?-1:1;if(F=D.value.collator.compare(A,x),D.value.collatorIsNumeric&&F===0&&A!==x)return A<x?-1:1}return F}e.compareFileExtensions=b;function f(c,_){c=c||"",_=_||"";const A=r(c),R=r(_),x=C.value.collator,O=i.value.collator;return g(O,A,R)||g(x,c,_)}e.compareFileExtensionsDefault=f;function w(c,_){c=c||"",_=_||"";const A=r(c),R=r(_),x=C.value.collator,O=i.value.collator;return g(O,A,R)||t(c,_)||g(x,c,_)}e.compareFileExtensionsUpper=w;function E(c,_){c=c||"",_=_||"";const A=r(c),R=r(_),x=C.value.collator,O=i.value.collator;return g(O,A,R)||n(c,_)||g(x,c,_)}e.compareFileExtensionsLower=E;function P(c,_){c=c||"",_=_||"";const A=r(c).toLowerCase(),R=r(_).toLowerCase();return A!==R?A<R?-1:1:c!==_?c<_?-1:1:0}e.compareFileExtensionsUnicode=P;const p=/^(.*?)(\.([^.]*))?$/;function o(c,_=!1){const A=c?p.exec(c):[];let R=[A&&A[1]||"",A&&A[3]||""];return _&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function r(c){const _=c?p.exec(c):[];return _&&_[1]&&_[1].charAt(0)!=="."&&_[3]||""}function g(c,_,A){let R=c.compare(_,A);return R!==0?R:_.length!==A.length?_.length<A.length?-1:1:0}function s(c){const _=c.charAt(0);return _.toLocaleUpperCase()!==_}function v(c){const _=c.charAt(0);return _.toLocaleLowerCase()!==_}function n(c,_){return s(c)&&v(_)?-1:v(c)&&s(_)?1:0}function t(c,_){return v(c)&&s(_)?-1:s(c)&&v(_)?1:0}function u(c,_,A=!1){return A||(c=c&&c.toLowerCase(),_=_&&_.toLowerCase()),c===_?0:c<_?-1:1}function d(c,_,A=!1){const R=c.split(L.sep),x=_.split(L.sep),O=R.length-1,F=x.length-1;let $,M;for(let B=0;;B++){if($=O===B,M=F===B,$&&M)return k(R[B],x[B],A);if($)return-1;if(M)return 1;const U=u(R[B],x[B],A);if(U!==0)return U}}e.comparePaths=d;function l(c,_,A){const R=c.toLowerCase(),x=_.toLowerCase(),O=h(c,_,A);if(O)return O;const F=R.endsWith(A),$=x.endsWith(A);if(F!==$)return F?-1:1;const M=k(R,x);return M!==0?M:R.localeCompare(x)}e.compareAnything=l;function h(c,_,A){const R=c.toLowerCase(),x=_.toLowerCase(),O=R.startsWith(A),F=x.startsWith(A);if(O!==F)return O?-1:1;if(O&&F){if(R.length<x.length)return-1;if(R.length>x.length)return 1}return 0}e.compareByPrefix=h}),define(ge[100],pe([0,1,99,96,47,9,12,8]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,y=[S,[]];function T(U,z,K,N){if(!U||!z)return y;const j=U.length,H=z.length;if(j<H)return y;const V=U.toLowerCase();return I(z,K,H,U,V,j,N)}e.scoreFuzzy=T;function I(U,z,K,N,j,H,V){const q=[],te=[];for(let Ue=0;Ue<K;Ue++){const xe=Ue*H,ze=xe-H,Q=Ue>0,Z=U[Ue],re=z[Ue];for(let ue=0;ue<H;ue++){const J=ue>0,ie=xe+ue,we=ie-1,Me=ze+ue-1,je=J?q[we]:0,Ke=Q&&J?q[Me]:0,Ze=Q&&J?te[Me]:0;let rt;!Ke&&Q?rt=0:rt=a(Z,re,N,j,ue,Ze),rt&&Ke+rt>=je&&(V||Q||j.startsWith(z,ue))?(te[ie]=Ze+1,q[ie]=Ke+rt):(te[ie]=S,q[ie]=je)}}const fe=[];let Ce=K-1,ke=H-1;for(;Ce>=0&&ke>=0;){const Ue=Ce*H+ke;te[Ue]===S||(fe.push(ke),Ce--),ke--}return[q[K*H-1],fe.reverse()]}function a(U,z,K,N,j,H){let V=0;if(!b(z,N[j]))return V;if(V+=1,H>0&&(V+=H*5),U===K[j]&&(V+=1),j===0)V+=8;else{const q=f(K.charCodeAt(j-1));q?V+=q:(0,L.isUpper)(K.charCodeAt(j))&&H===0&&(V+=2)}return V}function b(U,z){return U===z?!0:U==="/"||U==="\\"?z==="/"||z==="\\":!1}function f(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function E(U,z,K=0,N=0){const j=z;return j.values&&j.values.length>1?P(U,j.values,K,N):p(U,z,K,N)}e.scoreFuzzy2=E;function P(U,z,K,N){let j=0;const H=[];for(const V of z){const[q,te]=p(U,V,K,N);if(typeof q!="number")return w;j+=q,H.push(...te)}return[j,h(H)]}function p(U,z,K,N){const j=(0,L.fuzzyScore)(z.original,z.originalLowercase,K,U,U.toLowerCase(),N,!0);return j?[j[0],(0,L.createMatches)(j)]:w}const o=Object.freeze({score:0}),r=1<<18,g=1<<17,s=1<<16;function v(U,z,K,N){const j=N.values?N.values:[N];return(0,D.hash)({[N.normalized]:{values:j.map(V=>({value:V.normalized,expectContiguousMatch:V.expectContiguousMatch})),label:U,description:z,allowNonContiguousMatches:K}})}function n(U,z,K,N,j){if(!U||!z.normalized)return o;const H=N.getItemLabel(U);if(!H)return o;const V=N.getItemDescription(U),q=v(H,V,K,z),te=j[q];if(te)return te;const fe=t(H,V,N.getItemPath(U),z,K);return j[q]=fe,fe}e.scoreItemFuzzy=n;function t(U,z,K,N,j){const H=!K||!N.containsPathSeparator;return K&&(i.isLinux?N.pathNormalized===K:(0,k.equalsIgnoreCase)(N.pathNormalized,K))?{score:r,labelMatch:[{start:0,end:U.length}],descriptionMatch:z?[{start:0,end:z.length}]:void 0}:N.values&&N.values.length>1?u(U,z,K,N.values,H,j):d(U,z,K,N,H,j)}function u(U,z,K,N,j,H){let V=0;const q=[],te=[];for(const fe of N){const{score:Ce,labelMatch:ke,descriptionMatch:Ue}=d(U,z,K,fe,j,H);if(Ce===S)return o;V+=Ce,ke&&q.push(...ke),Ue&&te.push(...Ue)}return{score:V,labelMatch:h(q),descriptionMatch:h(te)}}function d(U,z,K,N,j,H){if(j||!z){const[V,q]=T(U,N.normalized,N.normalizedLowercase,H&&!N.expectContiguousMatch);if(V){const te=(0,L.matchesPrefix)(N.normalized,U);let fe;return te?(fe=g,fe+=Math.round(N.normalized.length/U.length*100)):fe=s,{score:fe+V,labelMatch:te||l(q)}}}if(z){let V=z;K&&(V=`${z}${C.sep}`);const q=V.length,te=`${V}${U}`,[fe,Ce]=T(te,N.normalized,N.normalizedLowercase,H&&!N.expectContiguousMatch);if(fe){const ke=l(Ce),Ue=[],xe=[];return ke.forEach(ze=>{ze.start<q&&ze.end>q?(Ue.push({start:0,end:ze.end-q}),xe.push({start:ze.start,end:q})):ze.start>=q?Ue.push({start:ze.start-q,end:ze.end-q}):xe.push(ze)}),{score:fe,labelMatch:Ue,descriptionMatch:xe}}}return o}function l(U){const z=[];if(!U)return z;let K;for(const N of U)K&&K.end===N?K.end+=1:(K={start:N,end:N+1},z.push(K));return z}function h(U){const z=U.sort((j,H)=>j.start-H.start),K=[];let N;for(const j of z)!N||!c(N,j)?(N=j,K.push(j)):(N.start=Math.min(N.start,j.start),N.end=Math.max(N.end,j.end));return K}function c(U,z){return!(U.end<z.start||z.end<U.start)}function _(U,z,K,N,j,H){const V=n(U,K,N,j,H),q=n(z,K,N,j,H),te=V.score,fe=q.score;if((te===r||fe===r)&&te!==fe)return te===r?-1:1;if(te>s||fe>s){if(te!==fe)return te>fe?-1:1;if(te<g&&fe<g){const Z=R(V.labelMatch,q.labelMatch);if(Z!==0)return Z}const ze=j.getItemLabel(U)||"",Q=j.getItemLabel(z)||"";if(ze.length!==Q.length)return ze.length-Q.length}if(te!==fe)return te>fe?-1:1;const Ce=Array.isArray(V.labelMatch)&&V.labelMatch.length>0,ke=Array.isArray(q.labelMatch)&&q.labelMatch.length>0;if(Ce&&!ke)return-1;if(ke&&!Ce)return 1;const Ue=A(U,V,j),xe=A(z,q,j);return Ue&&xe&&Ue!==xe?xe>Ue?-1:1:x(U,z,K,j)}e.compareItemsByFuzzyScore=_;function A(U,z,K){let N=-1,j=-1;if(z.descriptionMatch&&z.descriptionMatch.length?N=z.descriptionMatch[0].start:z.labelMatch&&z.labelMatch.length&&(N=z.labelMatch[0].start),z.labelMatch&&z.labelMatch.length){if(j=z.labelMatch[z.labelMatch.length-1].end,z.descriptionMatch&&z.descriptionMatch.length){const H=K.getItemDescription(U);H&&(j+=H.length)}}else z.descriptionMatch&&z.descriptionMatch.length&&(j=z.descriptionMatch[z.descriptionMatch.length-1].end);return j-N}function R(U,z){if(!U&&!z||(!U||!U.length)&&(!z||!z.length))return 0;if(!z||!z.length)return-1;if(!U||!U.length)return 1;const K=U[0].start,j=U[U.length-1].end-K,H=z[0].start,q=z[z.length-1].end-H;return j===q?0:q<j?1:-1}function x(U,z,K,N){const j=N.getItemLabel(U)||"",H=N.getItemLabel(z)||"",V=N.getItemDescription(U),q=N.getItemDescription(z),te=j.length+(V?V.length:0),fe=H.length+(q?q.length:0);if(te!==fe)return te-fe;const Ce=N.getItemPath(U),ke=N.getItemPath(z);return Ce&&ke&&Ce.length!==ke.length?Ce.length-ke.length:j!==H?(0,m.compareAnything)(j,H,K.normalized):V&&q&&V!==q?(0,m.compareAnything)(V,q,K.normalized):Ce&&ke&&Ce!==ke?(0,m.compareAnything)(Ce,ke,K.normalized):0}function O(U){return U.startsWith('"')&&U.endsWith('"')}const F=" ";function $(U){typeof U!="string"&&(U="");const z=U.toLowerCase(),{pathNormalized:K,normalized:N,normalizedLowercase:j}=M(U),H=K.indexOf(C.sep)>=0,V=O(U);let q;const te=U.split(F);if(te.length>1)for(const fe of te){const Ce=O(fe),{pathNormalized:ke,normalized:Ue,normalizedLowercase:xe}=M(fe);Ue&&(q||(q=[]),q.push({original:fe,originalLowercase:fe.toLowerCase(),pathNormalized:ke,normalized:Ue,normalizedLowercase:xe,expectContiguousMatch:Ce}))}return{original:U,originalLowercase:z,pathNormalized:K,normalized:N,normalizedLowercase:j,values:q,containsPathSeparator:H,expectContiguousMatch:V}}e.prepareQuery=$;function M(U){let z;i.isWindows?z=U.replace(/\//g,C.sep):z=U.replace(/\\/g,C.sep);const K=(0,k.stripWildcards)(z).replace(/\s|"/g,"");return{pathNormalized:z,normalized:K,normalizedLowercase:K.toLowerCase()}}function B(U){return Array.isArray(U)?$(U.map(z=>z.original).join(F)):$(U.original)}e.pieceToQuery=B}),define(ge[31],pe([0,1,18,30,24,9,8]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const S="**",y="/",T="[/\\\\]",I="[^/\\\\]",a=/\//g;function b(N){switch(N){case 0:return"";case 1:return`${I}*?`;default:return`(?:${T}|${I}+${T}|${T}${I}+)*?`}}function f(N,j){if(!N)return[];const H=[];let V=!1,q=!1,te="";for(const fe of N){switch(fe){case j:if(!V&&!q){H.push(te),te="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":q=!0;break;case"]":q=!1;break}te+=fe}return te&&H.push(te),H}e.splitGlobAware=f;function w(N){if(!N)return"";let j="";const H=f(N,y);if(H.every(V=>V===S))j=".*";else{let V=!1;H.forEach((q,te)=>{if(q===S){V||(j+=b(2),V=!0);return}let fe=!1,Ce="",ke=!1,Ue="";for(const xe of q){if(xe!=="}"&&fe){Ce+=xe;continue}if(ke&&(xe!=="]"||!Ue)){let ze;xe==="-"?ze=xe:(xe==="^"||xe==="!")&&!Ue?ze="^":xe===y?ze="":ze=i.escapeRegExpCharacters(xe),Ue+=ze;continue}switch(xe){case"{":fe=!0;continue;case"[":ke=!0;continue;case"}":j+=`(?:${f(Ce,",").map(Z=>w(Z)).join("|")})`,fe=!1,Ce="";break;case"]":j+="["+Ue+"]",ke=!1,Ue="";break;case"?":j+=I;continue;case"*":j+=b(1);continue;default:j+=i.escapeRegExpCharacters(xe)}}te<H.length-1&&(H[te+1]!==S||te+2<H.length)&&(j+=T),V=!1})}return j}const E=/^\*\*\/\*\.[\w\.-]+$/,P=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new D.LRUCache(1e4),v=function(){return!1},n=function(){return null};function t(N,j){if(!N)return n;let H;typeof N!="string"?H=N.pattern:H=N,H=H.trim();const V=`${H}_${!!j.trimForExclusions}`;let q=s.get(V);if(q)return u(q,N);let te;if(E.test(H)){const fe=H.substr(4);q=function(Ce,ke){return typeof Ce=="string"&&Ce.endsWith(fe)?H:null}}else(te=P.exec(d(H,j)))?q=l(te[1],H):(j.trimForExclusions?o:p).test(H)?q=h(H,j):(te=r.exec(d(H,j)))?q=c(te[1].substr(1),H,!0):(te=g.exec(d(H,j)))?q=c(te[1],H,!1):q=_(H);return s.set(V,q),u(q,N)}function u(N,j){return typeof j=="string"?N:function(H,V){return L.isEqualOrParent(H,j.base)?N(C.relative(j.base,H),V):null}}function d(N,j){return j.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function l(N,j){const H=`/${N}`,V=`\\${N}`,q=function(fe,Ce){return typeof fe!="string"?null:Ce?Ce===N?j:null:fe===N||fe.endsWith(H)||fe.endsWith(V)?j:null},te=[N];return q.basenames=te,q.patterns=[j],q.allBasenames=te,q}function h(N,j){const H=K(N.slice(1,-1).split(",").map(Ce=>t(Ce,j)).filter(Ce=>Ce!==n),N),V=H.length;if(!V)return n;if(V===1)return H[0];const q=function(Ce,ke){for(let Ue=0,xe=H.length;Ue<xe;Ue++)if(H[Ue](Ce,ke))return N;return null},te=H.find(Ce=>!!Ce.allBasenames);te&&(q.allBasenames=te.allBasenames);const fe=H.reduce((Ce,ke)=>ke.allPaths?Ce.concat(ke.allPaths):Ce,[]);return fe.length&&(q.allPaths=fe),q}function c(N,j,H){const V=C.sep===C.posix.sep,q=V?N:N.replace(a,C.sep),te=C.sep+q,fe=C.posix.sep+N,Ce=H?function(ke,Ue){return typeof ke=="string"&&(ke===q||ke.endsWith(te)||!V&&(ke===N||ke.endsWith(fe)))?j:null}:function(ke,Ue){return typeof ke=="string"&&(ke===q||!V&&ke===N)?j:null};return Ce.allPaths=[(H?"*/":"./")+N],Ce}function _(N){try{const j=new RegExp(`^${w(N)}$`);return function(H){return j.lastIndex=0,typeof H=="string"&&j.test(H)?N:null}}catch(j){return n}}function A(N,j,H){return!N||typeof j!="string"?!1:R(N)(j,void 0,H)}e.match=A;function R(N,j={}){if(!N)return v;if(typeof N=="string"||$(N)){const H=t(N,j);if(H===n)return v;const V=function(q,te){return!!H(q,te)};return H.allBasenames&&(V.allBasenames=H.allBasenames),H.allPaths&&(V.allPaths=H.allPaths),V}return U(N,j)}e.parse=R;function x(N){if(!N)return;let j;return H=>(j||(j=(N()||Promise.resolve([])).then(V=>V?F(V):{})),j.then(V=>!!V[H]))}e.hasSiblingPromiseFn=x;function O(N){if(!N)return;let j;return H=>{if(!j){const V=N();j=V?F(V):{}}return!!j[H]}}e.hasSiblingFn=O;function F(N){const j={};for(const H of N)j[H]=!0;return j}function $(N){const j=N;return j&&typeof j.base=="string"&&typeof j.pattern=="string"}e.isRelativePattern=$;function M(N){return N.allBasenames||[]}e.getBasenameTerms=M;function B(N){return N.allPaths||[]}e.getPathTerms=B;function U(N,j){const H=K(Object.getOwnPropertyNames(N).map(Ce=>z(Ce,N[Ce],j)).filter(Ce=>Ce!==n)),V=H.length;if(!V)return n;if(!H.some(Ce=>!!Ce.requiresSiblings)){if(V===1)return H[0];const Ce=function(xe,ze){for(let Q=0,Z=H.length;Q<Z;Q++){const re=H[Q](xe,ze);if(re)return re}return null},ke=H.find(xe=>!!xe.allBasenames);ke&&(Ce.allBasenames=ke.allBasenames);const Ue=H.reduce((xe,ze)=>ze.allPaths?xe.concat(ze.allPaths):xe,[]);return Ue.length&&(Ce.allPaths=Ue),Ce}const q=function(Ce,ke,Ue){let xe;for(let ze=0,Q=H.length;ze<Q;ze++){const Z=H[ze];Z.requiresSiblings&&Ue&&(ke||(ke=C.basename(Ce)),xe||(xe=ke.substr(0,ke.length-C.extname(Ce).length)));const re=Z(Ce,ke,xe,Ue);if(re)return re}return null},te=H.find(Ce=>!!Ce.allBasenames);te&&(q.allBasenames=te.allBasenames);const fe=H.reduce((Ce,ke)=>ke.allPaths?Ce.concat(ke.allPaths):Ce,[]);return fe.length&&(q.allPaths=fe),q}function z(N,j,H){if(j===!1)return n;const V=t(N,H);if(V===n)return n;if(typeof j=="boolean")return V;if(j){const q=j.when;if(typeof q=="string"){const te=(fe,Ce,ke,Ue)=>{if(!Ue||!V(fe,Ce))return null;const xe=q.replace("$(basename)",ke),ze=Ue(xe);return(0,m.isThenable)(ze)?ze.then(Q=>Q?N:null):ze?N:null};return te.requiresSiblings=!0,te}}return V}function K(N,j){const H=N.filter(Ce=>!!Ce.basenames);if(H.length<2)return N;const V=H.reduce((Ce,ke)=>{const Ue=ke.basenames;return Ue?Ce.concat(Ue):Ce},[]);let q;if(j){q=[];for(let Ce=0,ke=V.length;Ce<ke;Ce++)q.push(j)}else q=H.reduce((Ce,ke)=>{const Ue=ke.patterns;return Ue?Ce.concat(Ue):Ce},[]);const te=function(Ce,ke){if(typeof Ce!="string")return null;if(!ke){let xe;for(xe=Ce.length;xe>0;xe--){const ze=Ce.charCodeAt(xe-1);if(ze===47||ze===92)break}ke=Ce.substr(xe)}const Ue=V.indexOf(ke);return Ue!==-1?q[Ue]:null};te.basenames=V,te.patterns=q,te.allBasenames=V;const fe=N.filter(Ce=>!Ce.basenames);return fe.push(te),fe}}),define(ge[80],pe([0,1,30,10,9,12,23,8,2]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function y(t,u,d){if(typeof t=="string"&&(t=S.URI.file(t)),d){const h=d.getWorkspaceFolder(t);if(h){const c=d.getWorkspace().folders.length>1;let _;if((0,i.isEqual)(h.uri,t)?_="":_=(0,i.relativePath)(h.uri,t),c){const A=h.name?h.name:(0,i.basename)(h.uri);_=_?A+" \u2022 "+_:A}return _}}if(t.scheme!==L.Schemas.file&&t.scheme!==L.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,m.hasDriveLetter)(t.fsPath))return(0,D.normalize)(I(t.fsPath));let l=(0,D.normalize)(t.fsPath);return!C.isWindows&&u?.userHome&&(l=b(l,u.userHome.fsPath)),l}e.getPathLabel=y;function T(t){if(!t)return;typeof t=="string"&&(t=S.URI.file(t));const u=(0,i.basename)(t)||(t.scheme===L.Schemas.file?t.fsPath:t.path);return C.isWindows&&(0,m.isRootOrDriveLetter)(u)?I(u):u}e.getBaseLabel=T;function I(t,u){return(0,m.hasDriveLetter)(t,u)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=I;let a=Object.create(null);function b(t,u){if(C.isWindows||!t||!u)return t;let d=a.original===u?a.normalized:void 0;return d||(d=`${(0,k.rtrim)(u,D.posix.sep)}${D.posix.sep}`,a={original:u,normalized:d}),(C.isLinux?t.startsWith(d):(0,k.startsWithIgnoreCase)(t,d))&&(t=`~/${t.substr(d.length)}`),t}e.tildify=b;function f(t,u){return t.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=f;const w="\u2026",E="\\\\",P="~";function p(t,u=D.sep){const d=new Array(t.length);let l=!1;for(let h=0;h<t.length;h++){let c=t[h];if(c===""){d[h]=`.${u}`;continue}if(!c){d[h]=c;continue}l=!0;let _="";c.indexOf(E)===0?(_=c.substr(0,c.indexOf(E)+E.length),c=c.substr(c.indexOf(E)+E.length)):c.indexOf(u)===0?(_=c.substr(0,c.indexOf(u)+u.length),c=c.substr(c.indexOf(u)+u.length)):c.indexOf(P)===0&&(_=c.substr(0,c.indexOf(P)+P.length),c=c.substr(c.indexOf(P)+P.length));const A=c.split(u);for(let R=1;l&&R<=A.length;R++)for(let x=A.length-R;l&&x>=0;x--){l=!1;let O=A.slice(x,x+R).join(u);for(let F=0;!l&&F<t.length;F++)if(F!==h&&t[F]&&t[F].indexOf(O)>-1){const $=x+R===A.length,M=x>0&&t[F].indexOf(u)>-1?u+O:O,B=t[F].endsWith(M);l=!$||B}if(!l){let F="";(A[0].endsWith(":")||_!=="")&&(x===1&&(x=0,R++,O=A[0]+u+O),x>0&&(F=A[0]+u),F=_+F),x>0&&(F=F+w+u),F=F+O,x+R<A.length&&(F=F+u+w),d[h]=F}}l&&(d[h]=c)}return d}e.shorten=p;var o;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function r(t,u=Object.create(null)){const d=[];let l=!1,h="";for(const c of t)if(c==="$"||l&&c==="{")h&&d.push({value:h,type:o.TEXT}),h="",l=!0;else if(c==="}"&&l){const _=u[h];if(typeof _=="string")_.length&&d.push({value:_,type:o.VARIABLE});else if(_){const A=d[d.length-1];(!A||A.type!==o.SEPARATOR)&&d.push({value:_.label,type:o.SEPARATOR})}h="",l=!1}else h+=c;return h&&!l&&d.push({value:h,type:o.TEXT}),d.filter((c,_)=>{if(c.type===o.SEPARATOR){const A=d[_-1],R=d[_+1];return[A,R].every(x=>x&&(x.type===o.VARIABLE||x.type===o.TEXT)&&x.value.length>0)}return!0}).map(c=>c.value).join("")}e.template=r;function g(t,u){return C.isMacintosh||u?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):t.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function s(t,u){return C.isMacintosh||u?t.replace(/\(&&\w\)|&&/g,""):C.isWindows?t.replace(/&&|&/g,d=>d==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=s;function v(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=v;function n(t){const u=t.indexOf("/")!==-1?D.posix:D.win32,d=u.basename(t),l=u.dirname(t);return d.length?{name:d,parentPath:l}:{name:l,parentPath:""}}e.splitName=n}),define(ge[101],pe([0,1,31,10,9,23,8]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var k;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(k=e.Mimes||(e.Mimes={}));let S=[],y=[],T=[];function I(t,u=!1){const d=a(t);S.push(d),d.userConfigured?T.push(d):y.push(d),u&&!d.userConfigured&&S.forEach(l=>{l.mime===d.mime||l.userConfigured||(d.extension&&l.extension===d.extension&&console.warn(`Overwriting extension <<${d.extension}>> to now point to mime <<${d.mime}>>`),d.filename&&l.filename===d.filename&&console.warn(`Overwriting filename <<${d.filename}>> to now point to mime <<${d.mime}>>`),d.filepattern&&l.filepattern===d.filepattern&&console.warn(`Overwriting filepattern <<${d.filepattern}>> to now point to mime <<${d.mime}>>`),d.firstline&&l.firstline===d.firstline&&console.warn(`Overwriting firstline <<${d.firstline}>> to now point to mime <<${d.mime}>>`))})}e.registerTextMime=I;function a(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,m.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(D.posix.sep)>=0:!1}}function b(t){t?(S=S.filter(u=>!u.userConfigured),T=[]):(S=[],y=[],T=[])}e.clearTextMimes=b;function f(t,u){let d;if(t)switch(t.scheme){case L.Schemas.file:d=t.fsPath;break;case L.Schemas.data:d=C.DataUri.parseMetaData(t).get(C.DataUri.META_DATA_LABEL);break;default:d=t.path}if(!d)return[k.unknown];d=d.toLowerCase();const l=(0,D.basename)(d),h=w(d,l,T);if(h)return[h,k.text];const c=w(d,l,y);if(c)return[c,k.text];if(u){const _=E(u);if(_)return[_,k.text]}return[k.unknown]}e.guessMimeTypes=f;function w(t,u,d){let l=null,h=null,c=null;for(let _=d.length-1;_>=0;_--){const A=d[_];if(u===A.filenameLowercase){l=A;break}if(A.filepattern&&(!h||A.filepattern.length>h.filepattern.length)){const R=A.filepatternOnPath?t:u;A.filepatternLowercase?.(R)&&(h=A)}A.extension&&(!c||A.extension.length>c.extension.length)&&u.endsWith(A.extensionLowercase)&&(c=A)}return l?l.mime:h?h.mime:c?c.mime:null}function E(t){if((0,i.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let u=S.length-1;u>=0;u--){const d=S[u];if(!d.firstline)continue;const l=t.match(d.firstline);if(l&&l.length>0)return d.mime}return null}function P(t){return t?typeof t=="string"?t===k.binary||t===k.text||t===k.unknown:t.length===1&&P(t[0]):!0}e.isUnspecific=P;const p={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function r(t){const u=(0,D.extname)(t),d=p[u.toLowerCase()];return d!==void 0?d:g(t)}e.getMediaOrTextMime=r;function g(t){const u=(0,D.extname)(t);return o[u.toLowerCase()]}e.getMediaMime=g;function s(t){for(const u in o)if(o[u]===t)return u}e.getExtensionForMimeType=s;const v=/^(.+)\/(.+?)(;.+)?$/;function n(t,u){const d=v.exec(t);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:u?void 0:t}e.normalizeMimeType=n}),define(ge[102],pe([0,1,2]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(T){return T.toJSON()}class D{constructor(I){this._uriTransformer=I}transformIncoming(I){const a=this._uriTransformer.transformIncoming(I);return a===I?I:L(m.URI.from(a))}transformOutgoing(I){const a=this._uriTransformer.transformOutgoing(I);return a===I?I:L(m.URI.from(a))}transformOutgoingURI(I){const a=this._uriTransformer.transformOutgoing(I);return a===I?I:m.URI.from(a)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function C(T,I,a){if(!T||a>200)return null;if(typeof T=="object"){if(T instanceof m.URI)return I.transformOutgoing(T);for(let b in T)if(Object.hasOwnProperty.call(T,b)){const f=C(T[b],I,a+1);f!==null&&(T[b]=f)}}return null}function i(T,I){const a=C(T,I,0);return a===null?T:a}e.transformOutgoingURIs=i;function k(T,I,a,b){if(!T||b>200)return null;if(typeof T=="object"){if(T.$mid===1)return a?m.URI.revive(I.transformIncoming(T)):I.transformIncoming(T);for(let f in T)if(Object.hasOwnProperty.call(T,f)){const w=k(T[f],I,a,b+1);w!==null&&(T[f]=w)}}return null}function S(T,I){const a=k(T,I,!1,0);return a===null?T:a}e.transformIncomingURIs=S;function y(T,I){const a=k(T,I,!0,0);return a===null?T:a}e.transformAndReviveIncomingURIs=y}),define(ge[32],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(S){return m.test(S)}e.isUUID=L;const D=new Uint8Array(16),C=[];for(let S=0;S<256;S++)C.push(S.toString(16).padStart(2,"0"));let i;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?i=crypto.getRandomValues.bind(crypto):i=function(S){for(let y=0;y<S.length;y++)S[y]=Math.floor(Math.random()*256);return S};function k(){i(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let S=0,y="";return y+=C[D[S++]],y+=C[D[S++]],y+=C[D[S++]],y+=C[D[S++]],y+="-",y+=C[D[S++]],y+=C[D[S++]],y+="-",y+=C[D[S++]],y+=C[D[S++]],y+="-",y+=C[D[S++]],y+=C[D[S++]],y+="-",y+=C[D[S++]],y+=C[D[S++]],y+=C[D[S++]],y+=C[D[S++]],y+=C[D[S++]],y+=C[D[S++]],y}e.generateUuid=k}),define(ge[142],pe([0,1,103]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(C="utf8"){this.stringDecoder=new m.StringDecoder(C),this.remaining=null}write(C){const i=[],k=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(k.length<1)return i;let S=0,y,T=S;for(;T<k.length;)if(y=k.charCodeAt(T),y===13||y===10){if(i.push(k.substring(S,T)),T++,T<k.length){const I=y;y=k.charCodeAt(T),(I===13&&y===10||I===10&&y===13)&&T++}S=T}else T++;return this.remaining=S<k.length?k.substr(S):null,i}end(){return this.remaining}}e.LineDecoder=L}),define(ge[28],pe([0,1,60,81,289,18,30,79,9,12,23,2,32]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function f(M,B=b.UNLINK){if((0,i.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return B===b.UNLINK?E(M):w(M)}async function w(M){try{const B=(0,S.join)((0,L.tmpdir)(),(0,a.generateUuid)());try{await e.Promises.rename(M,B)}catch(U){return E(M)}E(B).catch(U=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function E(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function P(M){if((0,i.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(M,{recursive:!0})}e.rimrafSync=P;async function p(M,B){return g(await(B?o(M):(0,D.promisify)(m.readdir)(M)))}async function o(M){try{return await(0,D.promisify)(m.readdir)(M,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const B=[],U=await p(M);for(const z of U){let K=!1,N=!1,j=!1;try{const H=await e.Promises.lstat((0,S.join)(M,z));K=H.isFile(),N=H.isDirectory(),j=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}B.push({name:z,isFile:()=>K,isDirectory:()=>N,isSymbolicLink:()=>j})}return B}function r(M){return g(m.readdirSync(M))}e.readdirSync=r;function g(M){return M.map(B=>typeof B=="string"?y.isMacintosh?(0,k.normalizeNFC)(B):B:(B.name=y.isMacintosh?(0,k.normalizeNFC)(B.name):B.name,B))}async function s(M){const B=await p(M),U=[];for(const z of B)await n.existsDirectory((0,S.join)(M,z))&&U.push(z);return U}function v(M,B=1e3){return new Promise(U=>{let z=!1;const K=setInterval(()=>{z||(z=!0,m.access(M,N=>{z=!1,N&&(clearInterval(K),U(void 0))}))},B)})}e.whenDeleted=v;var n;(function(M){async function B(K){let N;try{if(N=await e.Promises.lstat(K),!N.isSymbolicLink())return{stat:N}}catch(j){}try{return{stat:await e.Promises.stat(K),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(y.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(K)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw H}throw j}}M.stat=B;async function U(K){try{const{stat:N,symbolicLink:j}=await M.stat(K);return N.isFile()&&j?.dangling!==!0}catch(N){}return!1}M.existsFile=U;async function z(K){try{const{stat:N,symbolicLink:j}=await M.stat(K);return N.isDirectory()&&j?.dangling!==!0}catch(N){}return!1}M.existsDirectory=z})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new C.ResourceQueue;function u(M,B,U){return t.queueFor(I.URI.file(M),T.extUriBiasedIgnorePathCase).queue(()=>{const z=c(U);return new Promise((K,N)=>l(M,B,z,j=>j?N(j):K()))})}let d=!0;function l(M,B,U,z){if(!d)return m.writeFile(M,B,{mode:U.mode,flag:U.flag},z);m.open(M,U.flag,U.mode,(K,N)=>{if(K)return z(K);m.writeFile(N,B,j=>{if(j)return m.close(N,()=>z(j));m.fdatasync(N,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),d=!1),m.close(N,V=>z(V))))})})}function h(M,B,U){const z=c(U);if(!d)return m.writeFileSync(M,B,{mode:z.mode,flag:z.flag});const K=m.openSync(M,z.flag,z.mode);try{m.writeFileSync(K,B);try{m.fdatasyncSync(K)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),d=!1}}finally{m.closeSync(K)}}e.writeFileSync=h;function c(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function _(M,B){if(M===B)return;async function U(z){try{const K=await e.Promises.lstat(z);if(K.isDirectory()||K.isSymbolicLink())return;await e.Promises.utimes(z,K.atime,new Date)}catch(K){}}try{await e.Promises.rename(M,B),await U(B)}catch(z){if(M.toLowerCase()!==B.toLowerCase()&&z.code==="EXDEV"||M.endsWith("."))await A(M,B,{preserveSymlinks:!1}),await f(M,b.MOVE),await U(B);else throw z}}async function A(M,B,U){return x(M,B,{root:{source:M,target:B},options:U,handledSourcePaths:new Set})}const R=511;async function x(M,B,U){if(U.handledSourcePaths.has(M))return;U.handledSourcePaths.add(M);const{stat:z,symbolicLink:K}=await n.stat(M);if(K){if(U.options.preserveSymlinks)try{return await $(M,B,U)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(K.dangling)return}return z.isDirectory()?O(M,B,z.mode&R,U):F(M,B,z.mode&R)}async function O(M,B,U,z){await e.Promises.mkdir(B,{recursive:!0,mode:U});const K=await p(M);for(const N of K)await x((0,S.join)(M,N),(0,S.join)(B,N),z)}async function F(M,B,U){await e.Promises.copyFile(M,B),await e.Promises.chmod(B,U)}async function $(M,B,U){let z=await e.Promises.readlink(M);(0,i.isEqualOrParent)(z,U.root.source,!y.isLinux)&&(z=(0,S.join)(U.root.target,z.substr(U.root.source.length+1))),await e.Promises.symlink(z,B)}e.Promises=new class{get access(){return(0,D.promisify)(m.access)}get stat(){return(0,D.promisify)(m.stat)}get lstat(){return(0,D.promisify)(m.lstat)}get utimes(){return(0,D.promisify)(m.utimes)}get read(){return(0,D.promisify)(m.read)}get readFile(){return(0,D.promisify)(m.readFile)}get write(){return(0,D.promisify)(m.write)}get appendFile(){return(0,D.promisify)(m.appendFile)}get fdatasync(){return(0,D.promisify)(m.fdatasync)}get truncate(){return(0,D.promisify)(m.truncate)}get rename(){return(0,D.promisify)(m.rename)}get copyFile(){return(0,D.promisify)(m.copyFile)}get open(){return(0,D.promisify)(m.open)}get close(){return(0,D.promisify)(m.close)}get symlink(){return(0,D.promisify)(m.symlink)}get readlink(){return(0,D.promisify)(m.readlink)}get chmod(){return(0,D.promisify)(m.chmod)}get mkdir(){return(0,D.promisify)(m.mkdir)}get unlink(){return(0,D.promisify)(m.unlink)}get rmdir(){return(0,D.promisify)(m.rmdir)}get realpath(){return(0,D.promisify)(m.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return s}get writeFile(){return u}get rm(){return f}get move(){return _}get copy(){return A}}}),define(ge[104],pe([0,1,60,9,8,28]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function i(T){const I=(0,L.dirname)(T);if(T===I)return T;const a=((0,L.basename)(T)||T).toLowerCase();try{const f=(0,C.readdirSync)(I).filter(w=>w.toLowerCase()===a);if(f.length===1){const w=i(I);if(w)return(0,L.join)(w,f[0])}else if(f.length>1){const w=f.indexOf(a);if(w>=0){const E=i(I);if(E)return(0,L.join)(E,f[w])}}}catch(b){}return null}e.realcaseSync=i;async function k(T){try{return await C.Promises.realpath(T)}catch(I){const a=y(T);return await C.Promises.access(a,m.constants.R_OK),a}}e.realpath=k;function S(T){try{return m.realpathSync(T)}catch(I){const a=y(T);return m.accessSync(a,m.constants.R_OK),a}}e.realpathSync=S;function y(T){return(0,D.rtrim)((0,L.normalize)(T),L.sep)}});var Ve=this&&this.__decorate||function(Y,e,m,L){var D=arguments.length,C=D<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,m):L,i;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(Y,e,m,L);else for(var k=Y.length-1;k>=0;k--)(i=Y[k])&&(C=(D<3?i(C):D>3?i(e,m,C):i(e,m))||C);return D>3&&C&&Object.defineProperty(e,m,C),C};define(ge[105],pe([0,1,17,18,22,21,57,15,3,6,59,8,13]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(K){K[K.Promise=100]="Promise",K[K.PromiseCancel=101]="PromiseCancel",K[K.EventListen=102]="EventListen",K[K.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function f(K){switch(K){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(K){K[K.Initialize=200]="Initialize",K[K.PromiseSuccess=201]="PromiseSuccess",K[K.PromiseError=202]="PromiseError",K[K.PromiseErrorObj=203]="PromiseErrorObj",K[K.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function E(K){switch(K){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var P;(function(K){K[K.Uninitialized=0]="Uninitialized",K[K.Idle=1]="Idle"})(P||(P={}));class p{constructor(N){this.buffer=N,this.pos=0}read(N){const j=this.buffer.slice(this.pos,this.pos+N);return this.pos+=j.byteLength,j}}class o{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var r;(function(K){K[K.Undefined=0]="Undefined",K[K.String=1]="String",K[K.Buffer=2]="Buffer",K[K.VSBuffer=3]="VSBuffer",K[K.Array=4]="Array",K[K.Object=5]="Object"})(r||(r={}));function g(K){const N=D.VSBuffer.alloc(4);return N.writeUInt32BE(K,0),N}function s(K){return K.read(4).readUInt32BE(0)}function v(K){const N=D.VSBuffer.alloc(1);return N.writeUInt8(K,0),N}const n={Undefined:v(r.Undefined),String:v(r.String),Buffer:v(r.Buffer),VSBuffer:v(r.VSBuffer),Array:v(r.Array),Object:v(r.Object)},t=typeof Buffer!="undefined";function u(K,N){if(typeof N=="undefined")K.write(n.Undefined);else if(typeof N=="string"){const j=D.VSBuffer.fromString(N);K.write(n.String),K.write(g(j.byteLength)),K.write(j)}else if(t&&Buffer.isBuffer(N)){const j=D.VSBuffer.wrap(N);K.write(n.Buffer),K.write(g(j.byteLength)),K.write(j)}else if(N instanceof D.VSBuffer)K.write(n.VSBuffer),K.write(g(N.byteLength)),K.write(N);else if(Array.isArray(N)){K.write(n.Array),K.write(g(N.length));for(const j of N)u(K,j)}else{const j=D.VSBuffer.fromString(JSON.stringify(N));K.write(n.Object),K.write(g(j.byteLength)),K.write(j)}}function d(K){switch(K.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return K.read(s(K)).toString();case r.Buffer:return K.read(s(K)).buffer;case r.VSBuffer:return K.read(s(K));case r.Array:{const j=s(K),H=[];for(let V=0;V<j;V++)H.push(d(K));return H}case r.Object:return JSON.parse(K.read(s(K)).toString())}}class l{constructor(N,j,H=null,V=1e3){this.protocol=N,this.ctx=j,this.logger=H,this.timeoutDelay=V,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(q=>this.onRawMessage(q)),this.sendResponse({type:200})}registerChannel(N,j){this.channels.set(N,j),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const j=this.send([N.type]);this.logger&&this.logger.logOutgoing(j,0,1,E(N.type));return}case 201:case 202:case 204:case 203:{const j=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(j,N.id,1,E(N.type),N.data);return}}}send(N,j=void 0){const H=new o;return u(H,N),u(H,j),this.sendBuffer(H.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(j){return 0}}onRawMessage(N){const j=new p(N),H=d(j),V=d(j),q=H[0];switch(q){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,H[1],1,`${f(q)}: ${H[2]}.${H[3]}`,V),this.onPromise({type:q,id:H[1],channelName:H[2],name:H[3],arg:V});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,H[1],1,`${f(q)}: ${H[2]}.${H[3]}`,V),this.onEventListen({type:q,id:H[1],channelName:H[2],name:H[3],arg:V});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,H[1],1,`${f(q)}`),this.disposeActiveRequest({type:q,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,H[1],1,`${f(q)}`),this.disposeActiveRequest({type:q,id:H[1]})}}onPromise(N){const j=this.channels.get(N.channelName);if(!j){this.collectPendingRequest(N);return}const H=new C.CancellationTokenSource;let V;try{V=j.call(this.ctx,N.name,N.arg,H.token)}catch(fe){V=Promise.reject(fe)}const q=N.id;V.then(fe=>{this.sendResponse({id:q,data:fe,type:201}),this.activeRequests.delete(N.id)},fe=>{fe instanceof Error?this.sendResponse({id:q,data:{message:fe.message,name:fe.name,stack:fe.stack?fe.stack.split?fe.stack.split(`
`):fe.stack:void 0},type:202}):this.sendResponse({id:q,data:fe,type:203}),this.activeRequests.delete(N.id)});const te=(0,y.toDisposable)(()=>H.cancel());this.activeRequests.set(N.id,te)}onEventListen(N){const j=this.channels.get(N.channelName);if(!j){this.collectPendingRequest(N);return}const H=N.id,q=j.listen(this.ctx,N.name,N.arg)(te=>this.sendResponse({id:H,data:te,type:204}));this.activeRequests.set(N.id,q)}disposeActiveRequest(N){const j=this.activeRequests.get(N.id);j&&(j.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let j=this.pendingRequests.get(N.channelName);j||(j=[],this.pendingRequests.set(N.channelName,j));const H=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:N,timeoutTimer:H})}flushPendingRequests(N){const j=this.pendingRequests.get(N);if(j){for(const H of j)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var h;(function(K){K[K.LocalSide=0]="LocalSide",K[K.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class c{constructor(N,j=null){this.protocol=N,this.isDisposed=!1,this.state=P.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=j}getChannel(N){const j=this;return{call(H,V,q){return j.isDisposed?Promise.reject(k.canceled()):j.requestPromise(N,H,V,q)},listen(H,V){return j.isDisposed?Promise.reject(k.canceled()):j.requestEvent(N,H,V)}}}requestPromise(N,j,H,V=C.CancellationToken.None){const q=this.lastRequestId++,fe={id:q,type:100,channelName:N,name:j,arg:H};if(V.isCancellationRequested)return Promise.reject(k.canceled());let Ce;return new Promise((Ue,xe)=>{if(V.isCancellationRequested)return xe(k.canceled());const ze=()=>{const ue=J=>{switch(J.type){case 201:this.handlers.delete(q),Ue(J.data);break;case 202:this.handlers.delete(q);const ie=new Error(J.data.message);ie.stack=J.data.stack,ie.name=J.data.name,xe(ie);break;case 203:this.handlers.delete(q),xe(J.data);break}};this.handlers.set(q,ue),this.sendRequest(fe)};let Q=null;this.state===P.Idle?ze():(Q=(0,L.createCancelablePromise)(ue=>this.whenInitialized()),Q.then(()=>{Q=null,ze()}));const Z=()=>{Q?(Q.cancel(),Q=null):this.sendRequest({id:q,type:101}),xe(k.canceled())},re=V.onCancellationRequested(Z);Ce=(0,y.combinedDisposable)((0,y.toDisposable)(Z),re),this.activeRequests.add(Ce)}).finally(()=>{this.activeRequests.delete(Ce)})}requestEvent(N,j,H){const V=this.lastRequestId++,te={id:V,type:102,channelName:N,name:j,arg:H};let fe=null;const Ce=new S.Emitter({onFirstListenerAdd:()=>{fe=(0,L.createCancelablePromise)(Ue=>this.whenInitialized()),fe.then(()=>{fe=null,this.activeRequests.add(Ce),this.sendRequest(te)})},onLastListenerRemove:()=>{fe?(fe.cancel(),fe=null):(this.activeRequests.delete(Ce),this.sendRequest({id:V,type:103}))}}),ke=Ue=>Ce.fire(Ue.data);return this.handlers.set(V,ke),Ce.event}sendRequest(N){switch(N.type){case 100:case 102:{const j=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(j,N.id,0,`${f(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const j=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(j,N.id,0,f(N.type));return}}}send(N,j=void 0){const H=new o;return u(H,N),u(H,j),this.sendBuffer(H.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(j){return 0}}onBuffer(N){const j=new p(N),H=d(j),V=d(j),q=H[0];switch(q){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,E(q)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,H[1],0,E(q),V),this.onResponse({type:H[0],id:H[1],data:V})}}onResponse(N){if(N.type===200){this.state=P.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(N.id);j&&j(N)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===P.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}Ve([i.memoize],c.prototype,"onDidInitializePromise",null),e.ChannelClient=c;class _{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:j,onDidClientDisconnect:H})=>{S.Event.once(j.onMessage)(q=>{const te=new p(q),fe=d(te),Ce=new l(j,fe),ke=new c(j);this.channels.forEach((xe,ze)=>Ce.registerChannel(ze,xe));const Ue={channelServer:Ce,channelClient:ke,ctx:fe};this._connections.add(Ue),this._onDidAddConnection.fire(Ue),H(()=>{Ce.dispose(),ke.dispose(),this._connections.delete(Ue),this._onDidRemoveConnection.fire(Ue)})})})}get connections(){const N=[];return this._connections.forEach(j=>N.push(j)),N}getChannel(N,j){const H=this;return{call(V,q,te){let fe;if((0,a.isFunction)(j)){let ke=(0,m.getRandomElement)(H.connections.filter(j));fe=ke?Promise.resolve(ke):S.Event.toPromise(S.Event.filter(H.onDidAddConnection,j))}else fe=j.routeCall(H,V,q);const Ce=fe.then(ke=>ke.channelClient.getChannel(N));return R(Ce).call(V,q,te)},listen(V,q){if((0,a.isFunction)(j))return H.getMulticastEvent(N,j,V,q);const te=j.routeEvent(H,V,q).then(fe=>fe.channelClient.getChannel(N));return R(te).listen(V,q)}}}getMulticastEvent(N,j,H,V){const q=this;let te=new y.DisposableStore;const fe=new S.Emitter({onFirstListenerAdd:()=>{te=new y.DisposableStore;const Ce=new S.EventMultiplexer,ke=new Map,Ue=ze=>{const Z=ze.channelClient.getChannel(N).listen(H,V),re=Ce.add(Z);ke.set(ze,re)},xe=ze=>{const Q=ke.get(ze);!Q||(Q.dispose(),ke.delete(ze))};q.connections.filter(j).forEach(Ue),S.Event.filter(q.onDidAddConnection,j)(Ue,void 0,te),q.onDidRemoveConnection(xe,void 0,te),Ce.event(fe.fire,fe,te),te.add(Ce)},onLastListenerRemove:()=>{te.dispose()}});return fe.event}registerChannel(N,j){this.channels.set(N,j),this._connections.forEach(H=>{H.channelServer.registerChannel(N,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class A{constructor(N,j,H=null){const V=new o;u(V,j),N.send(V.buffer),this.channelClient=new c(N,H),this.channelServer=new l(N,j,H)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,j){this.channelServer.registerChannel(N,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=A;function R(K){return{call(N,j,H){return K.then(V=>V.call(N,j,H))},listen(N,j){const H=new S.Relay;return K.then(V=>H.input=V.listen(N,j)),H.event}}}e.getDelayedChannel=R;function x(K){let N=!1;return{call(j,H,V){return N?K.call(j,H,V):(0,L.timeout)(0).then(()=>N=!0).then(()=>K.call(j,H,V))},listen(j,H){if(N)return K.listen(j,H);const V=new S.Relay;return(0,L.timeout)(0).then(()=>N=!0).then(()=>V.input=K.listen(j,H)),V.event}}}e.getNextTickChannel=x;class O{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const j of N.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await S.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=O;var F;(function(K){function N(q,te){const fe=q,Ce=te&&te.disableMarshalling,ke=new Map;for(const Ue in fe)H(Ue)&&ke.set(Ue,S.Event.buffer(fe[Ue],!0));return new class{listen(Ue,xe,ze){const Q=ke.get(xe);if(Q)return Q;if(V(xe)){const Z=fe[xe];if(typeof Z=="function")return Z.call(fe,ze)}throw new Error(`Event not found: ${xe}`)}call(Ue,xe,ze){const Q=fe[xe];if(typeof Q=="function"){if(!Ce&&Array.isArray(ze))for(let Z=0;Z<ze.length;Z++)ze[Z]=(0,T.revive)(ze[Z]);return Q.apply(fe,ze)}throw new Error(`Method not found: ${xe}`)}}}K.fromService=N;function j(q,te){const fe=te&&te.disableMarshalling;return new Proxy({},{get(Ce,ke){if(typeof ke=="string")return te?.properties?.has(ke)?te.properties.get(ke):V(ke)?function(Ue){return q.listen(ke,Ue)}:H(ke)?q.listen(ke):async function(...Ue){let xe;te&&!(0,a.isUndefinedOrNull)(te.context)?xe=[te.context,...Ue]:xe=Ue;const ze=await q.call(ke,xe);return fe?ze:(0,T.revive)(ze)};throw new Error(`Property not found: ${String(ke)}`)}})}K.toService=j;function H(q){return q[0]==="o"&&q[1]==="n"&&I.isUpperAsciiLetter(q.charCodeAt(2))}function V(q){return/^onDynamic/.test(q)&&I.isUpperAsciiLetter(q.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(K){if(Array.isArray(K))return K;if(K&&typeof K=="object"&&typeof K.toString=="function"){let N=K.toString();if(N!=="[object Object]")return N}return K}function B(K){return Array.isArray(K)?K.map(M):M(K)}function U(K,N,j,H,V,q,te){te=B(te);const fe=$[V],Ce=fe[H%fe.length];let ke=[`%c[${K}]%c[${String(N).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${q}`,"color: darkgreen","color: grey","color: grey",`color: ${Ce}`];/\($/.test(q)?(ke=ke.concat(te),ke.push(")")):ke.push(te),console.log.apply(console,ke)}e.logWithColors=U;class z{constructor(N,j){this._outgoingPrefix=N,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,j,H,V,q){this._totalOutgoing+=N,U(this._outgoingPrefix,this._totalOutgoing,N,j,H,V,q)}logIncoming(N,j,H,V,q){this._totalIncoming+=N,U(this._incomingPrefix,this._totalIncoming,N,j,H,V,q)}}e.IPCLogger=z}),define(ge[106],pe([0,1,22,3,6,105]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var i;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(i=e.SocketCloseEventType||(e.SocketCloseEventType={}));let k=null;function S(){return k||(k=m.VSBuffer.alloc(0)),k}class y{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(v){this._chunks.push(v),this._totalLength+=v.byteLength}read(v){return this._read(v,!0)}peek(v){return this._read(v,!1)}_read(v,n){if(v===0)return S();if(v>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===v){const l=this._chunks[0];return n&&(this._chunks.shift(),this._totalLength-=v),l}if(this._chunks[0].byteLength>v){const l=this._chunks[0].slice(0,v);return n&&(this._chunks[0]=this._chunks[0].slice(v),this._totalLength-=v),l}let t=m.VSBuffer.alloc(v),u=0,d=0;for(;v>0;){const l=this._chunks[d];if(l.byteLength>v){const h=l.slice(0,v);t.set(h,u),u+=v,n&&(this._chunks[d]=l.slice(v),this._totalLength-=v),v-=v}else t.set(l,u),u+=l.byteLength,n?(this._chunks.shift(),this._totalLength-=l.byteLength):d++,v-=l.byteLength}return t}}e.ChunkStream=y;var T;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(T||(T={}));var I;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(I=e.ProtocolConstants||(e.ProtocolConstants={}));class a{constructor(v,n,t,u){this.type=v,this.id=n,this.ack=t,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends D.Disposable{constructor(v){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=v,this._isDisposed=!1,this._incomingData=new y,this._register(this._socket.onData(n=>this.acceptChunk(n))),this.lastReadTime=Date.now()}acceptChunk(v){if(!(!v||v.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(v);this._incomingData.byteLength>=this._state.readLen;){const n=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=n.readUInt32BE(9),this._state.messageType=n.readUInt8(0),this._state.id=n.readUInt32BE(1),this._state.ack=n.readUInt32BE(5);else{const t=this._state.messageType,u=this._state.id,d=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new a(t,u,d,n)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(v){this._isDisposed=!1,this._socket=v,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(v){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(v){if(this._isDisposed)return;v.writtenTime=Date.now(),this.lastWriteTime=Date.now();const n=m.VSBuffer.alloc(13);n.writeUInt8(v.type,0),n.writeUInt32BE(v.id,1),n.writeUInt32BE(v.ack,5),n.writeUInt32BE(v.data.byteLength,9),this._writeSoon(n,v.data)}_bufferAdd(v,n){const t=this._totalLength===0;return this._data.push(v,n),this._totalLength+=v.byteLength+n.byteLength,t}_bufferTake(){const v=m.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,v}_writeSoon(v,n){this._bufferAdd(v,n)&&setTimeout(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class w extends D.Disposable{constructor(v){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=v,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new b(this._socket)),this._register(this._socketReader.onMessage(n=>{n.type===1&&this._onMessage.fire(n.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(v){this._socketWriter.write(new a(1,0,0,v))}}e.Protocol=w;class E extends C.IPCClient{constructor(v,n,t=null){super(v,n,t);this.protocol=v}static fromSocket(v,n){return new E(new w(v),n)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const v=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),v.end()}}e.Client=E;class P{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(v){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(v):this._emitter.fire(v):this._bufferedMessages.push(v)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=P;class p{constructor(v){this.data=v,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let v=[],n=0,t=this._first;for(;t;)v[n++]=t.data,t=t.next;return v}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(v){const n=new p(v);if(!this._first){this._first=n,this._last=n;return}this._last.next=n,this._last=n}}class r{constructor(){this.lastRuns=[];const v=Date.now();for(let n=0;n<r._HISTORY_LENGTH;n++)this.lastRuns[n]=v-1e3*n;setInterval(()=>{for(let n=r._HISTORY_LENGTH;n>=1;n--)this.lastRuns[n]=this.lastRuns[n-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}load(){const v=Date.now(),n=(1+r._HISTORY_LENGTH)*1e3;let t=0;for(let u=0;u<r._HISTORY_LENGTH;u++)v-this.lastRuns[u]<=n&&t++;return 1-t/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class g{constructor(v,n=null,t=r.getInstance()){this._onControlMessage=new P,this.onControlMessage=this._onControlMessage.event,this._onMessage=new P,this.onMessage=this._onMessage.event,this._onDidDispose=new P,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new P,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new P,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=t,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=v,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),n&&this._socketReader.acceptChunk(n),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const v=new a(5,0,0,S());this._socketWriter.write(v),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const v=Date.now()-this._socketWriter.lastWriteTime;if(v>=5e3){const n=new a(4,0,0,S());this._socketWriter.write(n),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-v+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const v=Date.now()-this._socketReader.lastReadTime;if(v>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-v,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(v,n){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=v,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(t=>this._receiveMessage(t))),this._socketDisposables.push(this._socket.onClose(t=>this._onSocketClose.fire(t))),this._socketReader.acceptChunk(n)}endAcceptReconnection(){this._isReconnecting=!1;const v=this._outgoingUnackMsg.toArray();for(let n=0,t=v.length;n<t;n++)this._socketWriter.write(v[n]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(v){if(v.ack>this._outgoingAckId){this._outgoingAckId=v.ack;do{const n=this._outgoingUnackMsg.peek();if(n&&n.id<=v.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(v.type===1){if(v.id>this._incomingMsgId)if(v.id!==this._incomingMsgId+1){const n=Date.now();n-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=n,this._socketWriter.write(new a(6,0,0,S())))}else this._incomingMsgId=v.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(v.data)}else if(v.type===2)this._onControlMessage.fire(v.data);else if(v.type===5)this._onDidDispose.fire();else if(v.type===6){const n=this._outgoingUnackMsg.toArray();for(let t=0,u=n.length;t<u;t++)this._socketWriter.write(n[t]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(v){const n=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const t=new a(1,n,this._incomingAckId,v);this._outgoingUnackMsg.push(t),this._isReconnecting||(this._socketWriter.write(t),this._recvAckCheck())}sendControl(v){const n=new a(2,0,0,v);this._socketWriter.write(n)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const v=Date.now()-this._incomingMsgLastTime;if(v>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-v+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const v=this._outgoingUnackMsg.peek(),n=Date.now()-v.writtenTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-n,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const v=new a(3,0,this._incomingAckId,S());this._socketWriter.write(v)}}e.PersistentProtocol=g}),define(ge[107],pe([0,1,98]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(k){let S=(0,m.toUint8)(k);this._defaultValue=S,this._asciiMap=L._createAsciiMap(S),this._map=new Map}static _createAsciiMap(k){let S=new Uint8Array(256);for(let y=0;y<256;y++)S[y]=k;return S}set(k,S){let y=(0,m.toUint8)(S);k>=0&&k<256?this._asciiMap[k]=y:this._map.set(k,y)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=L;var D;(function(i){i[i.False=0]="False",i[i.True=1]="True"})(D||(D={}));class C{constructor(){this._actual=new L(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=C}),define(ge[143],pe([0,1,107]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(i){i[i.Regular=0]="Regular",i[i.Whitespace=1]="Whitespace",i[i.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends m.CharacterClassifier{constructor(k){super(0);for(let S=0,y=k.length;S<y;S++)this.set(k.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function C(i){let k={};return S=>(k.hasOwnProperty(S)||(k[S]=i(S)),k[S])}e.getMapForWordSeparators=C(i=>new D(i))}),define(ge[49],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(D,C){this.lineNumber=D,this.column=C}with(D=this.lineNumber,C=this.column){return D===this.lineNumber&&C===this.column?this:new m(D,C)}delta(D=0,C=0){return this.with(this.lineNumber+D,this.column+C)}equals(D){return m.equals(this,D)}static equals(D,C){return!D&&!C?!0:!!D&&!!C&&D.lineNumber===C.lineNumber&&D.column===C.column}isBefore(D){return m.isBefore(this,D)}static isBefore(D,C){return D.lineNumber<C.lineNumber?!0:C.lineNumber<D.lineNumber?!1:D.column<C.column}isBeforeOrEqual(D){return m.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,C){return D.lineNumber<C.lineNumber?!0:C.lineNumber<D.lineNumber?!1:D.column<=C.column}static compare(D,C){let i=D.lineNumber|0,k=C.lineNumber|0;if(i===k){let S=D.column|0,y=C.column|0;return S-y}return i-k}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new m(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=m}),define(ge[41],pe([0,1,49]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(C,i,k,S){C>k||C===k&&i>S?(this.startLineNumber=k,this.startColumn=S,this.endLineNumber=C,this.endColumn=i):(this.startLineNumber=C,this.startColumn=i,this.endLineNumber=k,this.endColumn=S)}isEmpty(){return L.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return L.containsPosition(this,C)}static containsPosition(C,i){return!(i.lineNumber<C.startLineNumber||i.lineNumber>C.endLineNumber||i.lineNumber===C.startLineNumber&&i.column<C.startColumn||i.lineNumber===C.endLineNumber&&i.column>C.endColumn)}static strictContainsPosition(C,i){return!(i.lineNumber<C.startLineNumber||i.lineNumber>C.endLineNumber||i.lineNumber===C.startLineNumber&&i.column<=C.startColumn||i.lineNumber===C.endLineNumber&&i.column>=C.endColumn)}containsRange(C){return L.containsRange(this,C)}static containsRange(C,i){return!(i.startLineNumber<C.startLineNumber||i.endLineNumber<C.startLineNumber||i.startLineNumber>C.endLineNumber||i.endLineNumber>C.endLineNumber||i.startLineNumber===C.startLineNumber&&i.startColumn<C.startColumn||i.endLineNumber===C.endLineNumber&&i.endColumn>C.endColumn)}strictContainsRange(C){return L.strictContainsRange(this,C)}static strictContainsRange(C,i){return!(i.startLineNumber<C.startLineNumber||i.endLineNumber<C.startLineNumber||i.startLineNumber>C.endLineNumber||i.endLineNumber>C.endLineNumber||i.startLineNumber===C.startLineNumber&&i.startColumn<=C.startColumn||i.endLineNumber===C.endLineNumber&&i.endColumn>=C.endColumn)}plusRange(C){return L.plusRange(this,C)}static plusRange(C,i){let k,S,y,T;return i.startLineNumber<C.startLineNumber?(k=i.startLineNumber,S=i.startColumn):i.startLineNumber===C.startLineNumber?(k=i.startLineNumber,S=Math.min(i.startColumn,C.startColumn)):(k=C.startLineNumber,S=C.startColumn),i.endLineNumber>C.endLineNumber?(y=i.endLineNumber,T=i.endColumn):i.endLineNumber===C.endLineNumber?(y=i.endLineNumber,T=Math.max(i.endColumn,C.endColumn)):(y=C.endLineNumber,T=C.endColumn),new L(k,S,y,T)}intersectRanges(C){return L.intersectRanges(this,C)}static intersectRanges(C,i){let k=C.startLineNumber,S=C.startColumn,y=C.endLineNumber,T=C.endColumn,I=i.startLineNumber,a=i.startColumn,b=i.endLineNumber,f=i.endColumn;return k<I?(k=I,S=a):k===I&&(S=Math.max(S,a)),y>b?(y=b,T=f):y===b&&(T=Math.min(T,f)),k>y||k===y&&S>T?null:new L(k,S,y,T)}equalsRange(C){return L.equalsRange(this,C)}static equalsRange(C,i){return!!C&&!!i&&C.startLineNumber===i.startLineNumber&&C.startColumn===i.startColumn&&C.endLineNumber===i.endLineNumber&&C.endColumn===i.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(C){return new m.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(C){return new m.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,i){return new L(this.startLineNumber,this.startColumn,C,i)}setStartPosition(C,i){return new L(C,i,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(C){return new L(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,i=C){return new L(C.lineNumber,C.column,i.lineNumber,i.column)}static lift(C){return C?new L(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,i){return!(C.endLineNumber<i.startLineNumber||C.endLineNumber===i.startLineNumber&&C.endColumn<i.startColumn||i.endLineNumber<C.startLineNumber||i.endLineNumber===C.startLineNumber&&i.endColumn<C.startColumn)}static areIntersecting(C,i){return!(C.endLineNumber<i.startLineNumber||C.endLineNumber===i.startLineNumber&&C.endColumn<=i.startColumn||i.endLineNumber<C.startLineNumber||i.endLineNumber===C.startLineNumber&&i.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,i){if(C&&i){const y=C.startLineNumber|0,T=i.startLineNumber|0;if(y===T){const I=C.startColumn|0,a=i.startColumn|0;if(I===a){const b=C.endLineNumber|0,f=i.endLineNumber|0;if(b===f){const w=C.endColumn|0,E=i.endColumn|0;return w-E}return b-f}return I-a}return y-T}return(C?1:0)-(i?1:0)}static compareRangesUsingEnds(C,i){return C.endLineNumber===i.endLineNumber?C.endColumn===i.endColumn?C.startLineNumber===i.startLineNumber?C.startColumn-i.startColumn:C.startLineNumber-i.startLineNumber:C.endColumn-i.endColumn:C.endLineNumber-i.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=L}),define(ge[144],pe([0,1,49,41]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(i){i[i.LTR=0]="LTR",i[i.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class C extends L.Range{constructor(k,S,y,T){super(k,S,y,T);this.selectionStartLineNumber=k,this.selectionStartColumn=S,this.positionLineNumber=y,this.positionColumn=T}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return C.selectionsEqual(this,k)}static selectionsEqual(k,S){return k.selectionStartLineNumber===S.selectionStartLineNumber&&k.selectionStartColumn===S.selectionStartColumn&&k.positionLineNumber===S.positionLineNumber&&k.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,S){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,k,S):new C(k,S,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new m.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,S){return this.getDirection()===0?new C(k,S,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,k,S)}static fromPositions(k,S=k){return new C(k.lineNumber,k.column,S.lineNumber,S.column)}static fromRange(k,S){return S===0?new C(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new C(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new C(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,S){if(k&&!S||!k&&S)return!1;if(!k&&!S)return!0;if(k.length!==S.length)return!1;for(let y=0,T=k.length;y<T;y++)if(!this.selectionsEqual(k[y],S[y]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,S,y,T,I){return I===0?new C(k,S,y,T):new C(y,T,k,S)}}e.Selection=C}),define(ge[108],pe([0,1,25]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var D;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(D=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var i;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(i=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),this.indentSize=o.tabSize|0,this.insertSpaces=Boolean(o.insertSpaces),this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=Boolean(o.trimAutoWhitespace),this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,m.equals)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class y{constructor(o,r){this._findMatchBrand=void 0,this.range=o,this.matches=r}}e.FindMatch=y;var T;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(T=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var I;(function(p){p[p.Disabled=0]="Disabled",p[p.EnabledForActive=1]="EnabledForActive",p[p.Enabled=2]="Enabled"})(I=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class a{constructor(o,r,g){this.visibleColumn=o,this.className=r,this.horizontalLine=g}}e.IndentGuide=a;class b{constructor(o,r){this.top=o,this.endColumn=r}}e.IndentGuideHorizontalLine=b;var f;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None"})(f=e.PositionAffinity||(e.PositionAffinity={}));var w;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w=e.ModelConstants||(e.ModelConstants={}));class E{constructor(o,r,g,s,v,n){this.identifier=o,this.range=r,this.text=g,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=v,this._isTracked=n}}e.ValidAnnotatedEditOperation=E;class P{constructor(o,r,g){this.reverseEdits=o,this.changes=r,this.trimAutoWhitespaceLineNumbers=g}}e.ApplyEditsResult=P}),define(ge[145],pe([0,1,8,143,49,41,108]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class S{constructor(o,r,g,s){this.searchString=o,this.isRegex=r,this.matchCase=g,this.wordSeparators=s}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=y(this.searchString):o=this.searchString.indexOf(`
`)>=0;let r=null;try{r=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(s){return null}if(!r)return null;let g=!this.isRegex&&!o;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new T(r,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=S;function y(p){if(!p||p.length===0)return!1;for(let o=0,r=p.length;o<r;o++)if(p.charCodeAt(o)===92){if(o++,o>=r)break;const s=p.charCodeAt(o);if(s===110||s===114||s===87)return!0}return!1}e.isMultilineRegexSource=y;class T{constructor(o,r,g){this.regex=o,this.wordSeparators=r,this.simpleSearch=g}}e.SearchData=T;function I(p,o,r){if(!r)return new i.FindMatch(p,null);let g=[];for(let s=0,v=o.length;s<v;s++)g[s]=o[s];return new i.FindMatch(p,g)}e.createFindMatch=I;class a{constructor(o){let r=[],g=0;for(let s=0,v=o.length;s<v;s++)o.charCodeAt(s)===10&&(r[g++]=s);this._lineFeedsOffsets=r}findLineFeedCountBeforeOffset(o){const r=this._lineFeedsOffsets;let g=0,s=r.length-1;if(s===-1||o<=r[0])return 0;for(;g<s;){const v=g+((s-g)/2>>0);r[v]>=o?s=v-1:r[v+1]>=o?(g=v,s=v):g=v+1}return g+1}}class b{static findMatches(o,r,g,s,v){const n=r.parseSearchRequest();return n?n.regex.multiline?this._doFindMatchesMultiline(o,g,new P(n.wordSeparators,n.regex),s,v):this._doFindMatchesLineByLine(o,g,n,s,v):[]}static _getMultilineMatchRange(o,r,g,s,v,n){let t,u=0;s?(u=s.findLineFeedCountBeforeOffset(v),t=r+v+u):t=r+v;let d;if(s){let _=s.findLineFeedCountBeforeOffset(v+n.length)-u;d=t+n.length+_}else d=t+n.length;const l=o.getPositionAt(t),h=o.getPositionAt(d);return new C.Range(l.lineNumber,l.column,h.lineNumber,h.column)}static _doFindMatchesMultiline(o,r,g,s,v){const n=o.getOffsetAt(r.getStartPosition()),t=o.getValueInRange(r,1),u=o.getEOL()===`\r
`?new a(t):null,d=[];let l=0,h;for(g.reset(0);h=g.next(t);)if(d[l++]=I(this._getMultilineMatchRange(o,n,t,u,h.index,h[0]),h,s),l>=v)return d;return d}static _doFindMatchesLineByLine(o,r,g,s,v){const n=[];let t=0;if(r.startLineNumber===r.endLineNumber){const d=o.getLineContent(r.startLineNumber).substring(r.startColumn-1,r.endColumn-1);return t=this._findMatchesInLine(g,d,r.startLineNumber,r.startColumn-1,t,n,s,v),n}const u=o.getLineContent(r.startLineNumber).substring(r.startColumn-1);t=this._findMatchesInLine(g,u,r.startLineNumber,r.startColumn-1,t,n,s,v);for(let d=r.startLineNumber+1;d<r.endLineNumber&&t<v;d++)t=this._findMatchesInLine(g,o.getLineContent(d),d,0,t,n,s,v);if(t<v){const d=o.getLineContent(r.endLineNumber).substring(0,r.endColumn-1);t=this._findMatchesInLine(g,d,r.endLineNumber,0,t,n,s,v)}return n}static _findMatchesInLine(o,r,g,s,v,n,t,u){const d=o.wordSeparators;if(!t&&o.simpleSearch){const c=o.simpleSearch,_=c.length,A=r.length;let R=-_;for(;(R=r.indexOf(c,R+_))!==-1;)if((!d||E(d,r,A,R,_))&&(n[v++]=new i.FindMatch(new C.Range(g,R+1+s,g,R+1+_+s),null),v>=u))return v;return v}const l=new P(o.wordSeparators,o.regex);let h;l.reset(0);do if(h=l.next(r),h&&(n[v++]=I(new C.Range(g,h.index+1+s,g,h.index+1+h[0].length+s),h,t),v>=u))return v;while(h);return v}static findNextMatch(o,r,g,s){const v=r.parseSearchRequest();if(!v)return null;const n=new P(v.wordSeparators,v.regex);return v.regex.multiline?this._doFindNextMatchMultiline(o,g,n,s):this._doFindNextMatchLineByLine(o,g,n,s)}static _doFindNextMatchMultiline(o,r,g,s){const v=new D.Position(r.lineNumber,1),n=o.getOffsetAt(v),t=o.getLineCount(),u=o.getValueInRange(new C.Range(v.lineNumber,v.column,t,o.getLineMaxColumn(t)),1),d=o.getEOL()===`\r
`?new a(u):null;g.reset(r.column-1);let l=g.next(u);return l?I(this._getMultilineMatchRange(o,n,u,d,l.index,l[0]),l,s):r.lineNumber!==1||r.column!==1?this._doFindNextMatchMultiline(o,new D.Position(1,1),g,s):null}static _doFindNextMatchLineByLine(o,r,g,s){const v=o.getLineCount(),n=r.lineNumber,t=o.getLineContent(n),u=this._findFirstMatchInLine(g,t,n,r.column,s);if(u)return u;for(let d=1;d<=v;d++){const l=(n+d-1)%v,h=o.getLineContent(l+1),c=this._findFirstMatchInLine(g,h,l+1,1,s);if(c)return c}return null}static _findFirstMatchInLine(o,r,g,s,v){o.reset(s-1);const n=o.next(r);return n?I(new C.Range(g,n.index+1,g,n.index+1+n[0].length),n,v):null}static findPreviousMatch(o,r,g,s){const v=r.parseSearchRequest();if(!v)return null;const n=new P(v.wordSeparators,v.regex);return v.regex.multiline?this._doFindPreviousMatchMultiline(o,g,n,s):this._doFindPreviousMatchLineByLine(o,g,n,s)}static _doFindPreviousMatchMultiline(o,r,g,s){const v=this._doFindMatchesMultiline(o,new C.Range(1,1,r.lineNumber,r.column),g,s,10*k);if(v.length>0)return v[v.length-1];const n=o.getLineCount();return r.lineNumber!==n||r.column!==o.getLineMaxColumn(n)?this._doFindPreviousMatchMultiline(o,new D.Position(n,o.getLineMaxColumn(n)),g,s):null}static _doFindPreviousMatchLineByLine(o,r,g,s){const v=o.getLineCount(),n=r.lineNumber,t=o.getLineContent(n).substring(0,r.column-1),u=this._findLastMatchInLine(g,t,n,s);if(u)return u;for(let d=1;d<=v;d++){const l=(v+n-d-1)%v,h=o.getLineContent(l+1),c=this._findLastMatchInLine(g,h,l+1,s);if(c)return c}return null}static _findLastMatchInLine(o,r,g,s){let v=null,n;for(o.reset(0);n=o.next(r);)v=I(new C.Range(g,n.index+1,g,n.index+1+n[0].length),n,s);return v}}e.TextModelSearch=b;function f(p,o,r,g,s){if(g===0)return!0;const v=o.charCodeAt(g-1);if(p.get(v)!==0||v===13||v===10)return!0;if(s>0){const n=o.charCodeAt(g);if(p.get(n)!==0)return!0}return!1}function w(p,o,r,g,s){if(g+s===r)return!0;const v=o.charCodeAt(g+s);if(p.get(v)!==0||v===13||v===10)return!0;if(s>0){const n=o.charCodeAt(g+s-1);if(p.get(n)!==0)return!0}return!1}function E(p,o,r,g,s){return f(p,o,r,g,s)&&w(p,o,r,g,s)}e.isValidMatch=E;class P{constructor(o,r){this._wordSeparators=o,this._searchRegex=r,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const r=o.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===r||(g=this._searchRegex.exec(o),!g))return null;const s=g.index,v=g[0].length;if(s===this._prevMatchStartIndex&&v===this._prevMatchLength){if(v===0){m.getNextCodePoint(o,r,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=s,this._prevMatchLength=v,!this._wordSeparators||E(this._wordSeparators,o,r,s,v))return g}while(g);return null}}e.Searcher=P}),define(ge[109],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(k=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.USUAL_WORD_SEPARATORS)k.indexOf(y)>=0||(S+="\\"+y);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=m();function L(k){let S=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)S=k;else{let y="g";k.ignoreCase&&(y+="i"),k.multiline&&(y+="m"),k.unicode&&(y+="u"),S=new RegExp(k.source,y)}return S.lastIndex=0,S}e.ensureValidWordDefinition=L;const D={maxLen:1e3,windowSize:15,timeBudget:150};function C(k,S,y,T,I=D){if(y.length>I.maxLen){let E=k-I.maxLen/2;return E<0?E=0:T+=E,y=y.substring(E,k+I.maxLen/2),C(k,S,y,T,I)}const a=Date.now(),b=k-1-T;let f=-1,w=null;for(let E=1;!(Date.now()-a>=I.timeBudget);E++){const P=b-I.windowSize*E;S.lastIndex=Math.max(0,P);const p=i(S,y,b,f);if(!p&&w||(w=p,P<=0))break;f=P}if(w){let E={word:w[0],startColumn:T+1+w.index,endColumn:T+1+w.index+w[0].length};return S.lastIndex=0,E}return null}e.getWordAtText=C;function i(k,S,y,T){let I;for(;I=k.exec(S);){const a=I.index||0;if(a<=y&&k.lastIndex>=y)return I;if(T>0&&a>T)return null}return null}}),define(ge[146],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(i){i[i.None=0]="None",i[i.Indent=1]="Indent",i[i.IndentOutdent=2]="IndentOutdent",i[i.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class L{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let S=0,y=k.notIn.length;S<y;S++)switch(k.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}shouldAutoClose(k,S){if(k.getTokenCount()===0)return!0;const y=k.findTokenIndexAtOffset(S-2),T=k.getStandardTokenType(y);return this.isOK(T)}_findNeutralCharacterInRange(k,S){for(let y=k;y<=S;y++){const T=String.fromCharCode(y);if(!this.open.includes(T)&&!this.close.includes(T))return T}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=L;class D{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of k)C(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),C(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),C(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),C(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&C(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=D;function C(i,k,S){i.has(k)?i.get(k).push(S):i.set(k,[S])}}),define(ge[82],pe([0,1,31,9]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(C,i,k,S){if(Array.isArray(C)){let y=0;for(const T of C){const I=D(T,i,k,S);if(I===10)return I;I>y&&(y=I)}return y}else{if(typeof C=="string")return S?C==="*"?5:C===k?10:0:0;if(C){const{language:y,pattern:T,scheme:I,hasAccessToAllModels:a}=C;if(!S&&!a)return 0;let b=0;if(I)if(I===i.scheme)b=10;else if(I==="*")b=5;else return 0;if(y)if(y===k)b=10;else if(y==="*")b=Math.max(b,5);else return 0;if(T){let f;if(typeof T=="string"?f=T:f={...T,base:(0,L.normalize)(T.base)},f===i.fsPath||(0,m.match)(f,i.fsPath))b=10;else return 0}return b}else return 0}}e.score=D}),define(ge[147],pe([0,1,107]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class D{constructor(f,w,E){const P=new Uint8Array(f*w);for(let p=0,o=f*w;p<o;p++)P[p]=E;this._data=P,this.rows=f,this.cols=w}get(f,w){return this._data[f*this.cols+w]}set(f,w,E){this._data[f*this.cols+w]=E}}e.Uint8Matrix=D;class C{constructor(f){let w=0,E=0;for(let p=0,o=f.length;p<o;p++){let[r,g,s]=f[p];g>w&&(w=g),r>E&&(E=r),s>E&&(E=s)}w++,E++;let P=new D(E,w,0);for(let p=0,o=f.length;p<o;p++){let[r,g,s]=f[p];P.set(r,g,s)}this._states=P,this._maxCharCode=w}nextState(f,w){return w<0||w>=this._maxCharCode?0:this._states.get(f,w)}}e.StateMachine=C;let i=null;function k(){return i===null&&(i=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),i}var S;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let y=null;function T(){if(y===null){y=new m.CharacterClassifier(0);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<b.length;w++)y.set(b.charCodeAt(w),1);const f=".,;";for(let w=0;w<f.length;w++)y.set(f.charCodeAt(w),2)}return y}class I{static _createLink(f,w,E,P,p){let o=p-1;do{const r=w.charCodeAt(o);if(f.get(r)!==2)break;o--}while(o>P);if(P>0){const r=w.charCodeAt(P-1),g=w.charCodeAt(o);(r===40&&g===41||r===91&&g===93||r===123&&g===125)&&o--}return{range:{startLineNumber:E,startColumn:P+1,endLineNumber:E,endColumn:o+2},url:w.substring(P,o+1)}}static computeLinks(f,w=k()){const E=T();let P=[];for(let p=1,o=f.getLineCount();p<=o;p++){const r=f.getLineContent(p),g=r.length;let s=0,v=0,n=0,t=1,u=!1,d=!1,l=!1,h=!1;for(;s<g;){let c=!1;const _=r.charCodeAt(s);if(t===13){let A;switch(_){case 40:u=!0,A=0;break;case 41:A=u?0:1;break;case 91:l=!0,d=!0,A=0;break;case 93:l=!1,A=d?0:1;break;case 123:h=!0,A=0;break;case 125:A=h?0:1;break;case 39:A=n===34||n===96?0:1;break;case 34:A=n===39||n===96?0:1;break;case 96:A=n===39||n===34?0:1;break;case 42:A=n===42?1:0;break;case 124:A=n===124?1:0;break;case 32:A=l?0:1;break;default:A=E.get(_)}A===1&&(P.push(I._createLink(E,r,p,v,s)),c=!0)}else if(t===12){let A;_===91?(d=!0,A=0):A=E.get(_),A===1?c=!0:t=13}else t=w.nextState(t,_),t===0&&(c=!0);c&&(t=1,u=!1,d=!1,h=!1,v=s+1,n=_),s++}t===13&&P.push(I._createLink(E,r,p,v,g))}return P}}e.LinkComputer=I;function a(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:I.computeLinks(b)}e.computeLinks=a}),define(ge[148],pe([0,1,3,6]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class D{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(i){this._onDidChange.fire({changedLanguages:i,changedColorMap:!1})}register(i,k){return this._map.set(i,k),this.fire([i]),(0,L.toDisposable)(()=>{this._map.get(i)===k&&(this._map.delete(i),this.fire([i]))})}registerPromise(i,k){let S=null,y=!1;return this._promises.set(i,k.then(T=>{this._promises.delete(i),!(y||!T)&&(S=this.register(i,T))})),(0,L.toDisposable)(()=>{y=!0,S&&S.dispose()})}getPromise(i){const k=this.get(i);if(k)return Promise.resolve(k);const S=this._promises.get(i);return S?S.then(y=>this.get(i)):null}get(i){return this._map.get(i)||null}setColorMap(i){this._colorMap=i,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=D}),define(ge[110],pe([0,1,22,12]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(D||(D={}));function C(I){for(let a=0,b=I.length;a<b;a+=4){const f=I[a+0],w=I[a+1],E=I[a+2],P=I[a+3];I[a+0]=P,I[a+1]=E,I[a+2]=w,I[a+3]=f}}function i(I){const a=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return L.isLittleEndian()||C(a),m.VSBuffer.wrap(a)}function k(I){const a=I.buffer;if(L.isLittleEndian()||C(a),a.byteOffset%4==0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const b=new Uint8Array(a.byteLength);return b.set(a),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function S(I){const a=new Uint32Array(y(I));let b=0;if(a[b++]=I.id,I.type==="full")a[b++]=1,a[b++]=I.data.length,a.set(I.data,b),b+=I.data.length;else{a[b++]=2,a[b++]=I.deltas.length;for(const f of I.deltas)a[b++]=f.start,a[b++]=f.deleteCount,f.data?(a[b++]=f.data.length,a.set(f.data,b),b+=f.data.length):a[b++]=0}return i(a)}e.encodeSemanticTokensDto=S;function y(I){let a=0;if(a+=1+1,I.type==="full")a+=1+I.data.length;else{a+=1,a+=(1+1+1)*I.deltas.length;for(const b of I.deltas)b.data&&(a+=b.data.length)}return a}function T(I){const a=k(I);let b=0;const f=a[b++];if(a[b++]===1){const p=a[b++],o=a.subarray(b,b+p);return b+=p,{id:f,type:"full",data:o}}const E=a[b++];let P=[];for(let p=0;p<E;p++){const o=a[b++],r=a[b++],g=a[b++];let s;g>0&&(s=a.subarray(b,b+g),b+=g),P[p]={start:o,deleteCount:r,data:s}}return{id:f,type:"delta",deltas:P}}e.decodeSemanticTokensDto=T}),define(ge[111],pe([0,1,17,98]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class D{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,y){S=(0,L.toUint32)(S);const T=this.values,I=this.prefixSum,a=y.length;return a===0?!1:(this.values=new Uint32Array(T.length+a),this.values.set(T.subarray(0,S),0),this.values.set(T.subarray(S),S+a),this.values.set(y,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(S,y){return S=(0,L.toUint32)(S),y=(0,L.toUint32)(y),this.values[S]===y?!1:(this.values[S]=y,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,y){S=(0,L.toUint32)(S),y=(0,L.toUint32)(y);const T=this.values,I=this.prefixSum;if(S>=T.length)return!1;let a=T.length-S;return y>=a&&(y=a),y===0?!1:(this.values=new Uint32Array(T.length-y),this.values.set(T.subarray(0,S),0),this.values.set(T.subarray(S+y),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(S){return S<0?0:(S=(0,L.toUint32)(S),this._getPrefixSum(S))}_getPrefixSum(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let y=this.prefixSumValidIndex[0]+1;y===0&&(this.prefixSum[0]=this.values[0],y++),S>=this.values.length&&(S=this.values.length-1);for(let T=y;T<=S;T++)this.prefixSum[T]=this.prefixSum[T-1]+this.values[T];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let y=0,T=this.values.length-1,I=0,a=0,b=0;for(;y<=T;)if(I=y+(T-y)/2|0,a=this.prefixSum[I],b=a-this.values[I],S<b)T=I-1;else if(S>=a)y=I+1;else break;return new i(I,S-b)}}e.PrefixSumComputer=D;class C{constructor(S){this._values=S,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(S){return this._ensureValid(),S===0?0:this._prefixSum[S-1]}getIndexOf(S){this._ensureValid();const y=this._indexBySum[S],T=y>0?this._prefixSum[y-1]:0;return new i(y,S-T)}removeValues(S,y){this._values.splice(S,y),this._invalidate(S)}insertValues(S,y){this._values=(0,m.arrayInsert)(this._values,S,y),this._invalidate(S)}_invalidate(S){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,S-1)}_ensureValid(){if(!this._isValid){for(let S=this._validEndIndex+1,y=this._values.length;S<y;S++){const T=this._values[S],I=S>0?this._prefixSum[S-1]:0;this._prefixSum[S]=I+T;for(let a=0;a<T;a++)this._indexBySum[I+a]=S}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(S,y){this._values[S]!==y&&(this._values[S]=y,this._invalidate(S))}}e.ConstantTimePrefixSumComputer=C;class i{constructor(S,y){this.index=S,this.remainder=y,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=y}}e.PrefixSumIndexOfResult=i}),define(ge[149],pe([0,1,8,49,111]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(k,S,y,T){this._uri=k,this._lines=S,this._eol=y,this._versionId=T,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const S=k.changes;for(const y of S)this._acceptDeleteRange(y.range),this._acceptInsertText(new L.Position(y.range.startLineNumber,y.range.startColumn),y.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,S=this._lines.length,y=new Uint32Array(S);for(let T=0;T<S;T++)y[T]=this._lines[T].length+k;this._lineStarts=new D.PrefixSumComputer(y)}}_setLineText(k,S){this._lines[k]=S,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,S){if(S.length===0)return;let y=(0,m.splitLines)(S);if(y.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+y[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}y[y.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+y[0]);let T=new Uint32Array(y.length-1);for(let I=1;I<y.length;I++)this._lines.splice(k.lineNumber+I-1,0,y[I]),T[I-1]=y[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,T)}}e.MirrorTextModel=C}),define(ge[150],pe([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(ge[151],pe([0,1,150]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,D=L*60,C=D*24,i=C*7,k=C*30,S=C*365;function y(I,a){typeof I!="number"&&(I=I.getTime());const b=Math.round((new Date().getTime()-I)/1e3);if(b<-30)return(0,m.localize)(0,null,y(new Date().getTime()+b*1e3,!1));if(b<30)return(0,m.localize)(1,null);let f;return b<L?(f=b,a?f===1?(0,m.localize)(2,null,f):(0,m.localize)(3,null,f):f===1?(0,m.localize)(4,null,f):(0,m.localize)(5,null,f)):b<D?(f=Math.floor(b/L),a?f===1?(0,m.localize)(6,null,f):(0,m.localize)(7,null,f):f===1?(0,m.localize)(8,null,f):(0,m.localize)(9,null,f)):b<C?(f=Math.floor(b/D),a?f===1?(0,m.localize)(10,null,f):(0,m.localize)(11,null,f):f===1?(0,m.localize)(12,null,f):(0,m.localize)(13,null,f)):b<i?(f=Math.floor(b/C),a?f===1?(0,m.localize)(14,null,f):(0,m.localize)(15,null,f):f===1?(0,m.localize)(16,null,f):(0,m.localize)(17,null,f)):b<k?(f=Math.floor(b/i),a?f===1?(0,m.localize)(18,null,f):(0,m.localize)(19,null,f):f===1?(0,m.localize)(20,null,f):(0,m.localize)(21,null,f)):b<S?(f=Math.floor(b/k),a?f===1?(0,m.localize)(22,null,f):(0,m.localize)(23,null,f):f===1?(0,m.localize)(24,null,f):(0,m.localize)(25,null,f)):(f=Math.floor(b/S),a?f===1?(0,m.localize)(26,null,f):(0,m.localize)(27,null,f):f===1?(0,m.localize)(28,null,f):(0,m.localize)(29,null,f))}e.fromNow=y;function T(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(ge[152],pe([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(ge[50],pe([0,1,17,13,152]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(y,T){return T&&(y.stack||y.stacktrace)?D.localize(0,null,k(y),i(y.stack)||i(y.stacktrace)):k(y)}function i(y){return Array.isArray(y)?y.join(`
`):y}function k(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?D.localize(1,null,y.message):y.message||D.localize(2,null)}function S(y=null,T=!1){if(!y)return D.localize(3,null);if(Array.isArray(y)){const I=m.coalesce(y),a=S(I[0],T);return I.length>1?D.localize(4,null,a,I.length):a}if(L.isString(y))return y;if(y.detail){const I=y.detail;if(I.error)return C(I.error,T);if(I.exception)return C(I.exception,T)}return y.stack?C(y,T):y.message?y.message:D.localize(5,null)}e.toErrorMessage=S}),define(ge[153],pe([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(ge[112],pe([0,1,37,30,10,25,9,12,40,94,13,142,28,153]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return y.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return y.TerminateResponseCode}});function f(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(s,v){if(k.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};v&&(n.cwd=v);const t=m.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],n);return new Promise(u=>{t.once("error",d=>{u({success:!1,error:d})}),t.once("exit",(d,l)=>{u(d===0?{success:!0}:{success:!1,code:d!==null?d:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?f(n.status):1})}else if(k.isLinux||k.isMacintosh)try{const n=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(t=>{m.execFile(n,[s.pid.toString()],{encoding:"utf8",shell:!0},(u,d,l)=>{t(u?{success:!1,error:u}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function E(s){!s||(delete s.DEBUG,k.isMacintosh&&delete s.DYLD_LIBRARY_PATH,k.isLinux&&delete s.LD_PRELOAD)}e.removeDangerousEnvVariables=E;function P(s=S.env){return s.comspec||"cmd.exe"}e.getWindowsShell=P;class p{constructor(v,n,t,u){if(n!==void 0&&t!==void 0&&u!==void 0)this.cmd=v,this.args=n,this.shell=t,this.options=u;else{const d=v;this.cmd=d.command,this.shell=d.isShellCommand,this.args=d.args.slice(0),this.options=d.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const d=Object.create(null);Object.keys(S.env).forEach(l=>{d[l]=S.env[l]}),Object.keys(this.options.env).forEach(l=>{d[l]=this.options.env[l]}),this.options.env=d}}getSanitizedCommand(){let v=this.cmd.toLowerCase();const n=v.lastIndexOf(i.sep);return n!==-1&&(v=v.substring(n+1)),p.WellKnowCommands[v]?v:"other"}start(v){return k.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(S.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(n=>{let t,u;const d=new Promise((l,h)=>{t=l,u=h});if(n){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=m.exec(l,this.options,(h,c,_)=>{this.childProcess=null;const A=h;A&&A.killed?u({killed:this.terminateRequested,stdout:c.toString(),stderr:_.toString()}):this.handleExec(t,v,h,c,_)})}else{let l=null;const h=c=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(c,t,v,u);const _={terminated:this.terminateRequested};T.isNumber(c)&&(_.cmdCode=c),t(_)};if(this.shell&&k.isWindows){const c=C.deepClone(this.options);c.windowsVerbatimArguments=!0,c.detached=!1;let _=!1,A=!1;const R=[];let x=this.ensureQuotes(this.cmd);R.push(x.value),_=x.quoted,this.args&&this.args.forEach(F=>{x=this.ensureQuotes(F),R.push(x.value),A=A&&x.quoted});const O=["/s","/c"];_?A?O.push('"'+R.join(" ")+'"'):R.length>1?O.push('"'+R[0]+'" '+R.slice(1).join(" ")):O.push('"'+R[0]+'"'):O.push(R.join(" ")),l=m.spawn(P(),O,c)}else this.cmd&&(l=m.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(T.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",c=>{this.childProcess=null,u({terminated:this.terminateRequested,error:c})}),l.pid&&(this.childProcess.on("close",h),this.handleSpawn(l,t,v,u,!0)))}return d})}handleClose(v,n,t,u){}ensureQuotes(v){return p.regexp.test(v)?{value:'"'+v+'"',quoted:!0}:{value:v,quoted:v.length>0&&v[0]==='"'&&v[v.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(v=>v.pid,v=>-1):new Promise(v=>{this.pidResolve=v})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(v=>(this.terminateRequested=!0,w(v,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),v=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(v=>{if(!this.shell||!k.isWindows)return v(!1);const n=m.spawn(P(),["/s","/c"]);n.on("error",t=>v(!0)),n.on("exit",t=>v(!1))})}}e.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class o extends p{constructor(v,n,t,u){super(v,n,t,u);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(v,n,t,u,d){[u,d].forEach((l,h)=>{const c=new I.LineDecoder;c.write(l).forEach(R=>{n({line:R,source:h===0?0:1})});const A=c.end();A&&n({line:A,source:h===0?0:1})}),v({terminated:this.terminateRequested,error:t})}handleSpawn(v,n,t,u,d){const l=new I.LineDecoder,h=new I.LineDecoder;v.stdout.on("data",c=>{l.write(c).forEach(A=>t({line:A,source:0}))}),v.stderr.on("data",c=>{h.write(c).forEach(A=>t({line:A,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=h}handleClose(v,n,t,u){const d=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;d&&t({line:d,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&t({line:l,source:1})}}e.LineProcess=o;function r(s){let v=[],n=!1;const t=function(u){if(n){v.push(u);return}(!s.send(u,l=>{if(l&&console.error(l),n=!1,v.length>0){const h=v.slice(0);v=[],h.forEach(c=>t(c))}})||k.isWindows)&&(n=!0)};return{send:t}}e.createQueuedSender=r;var g;(function(s){async function v(n,t,u){if(i.isAbsolute(n))return n;if(t===void 0&&(t=S.cwd()),i.dirname(n)!=="."||(u===void 0&&T.isString(S.env.PATH)&&(u=S.env.PATH.split(i.delimiter)),u===void 0||u.length===0))return i.join(t,n);async function l(h){if(await a.Promises.exists(h)){let c;try{c=await a.Promises.stat(h)}catch(_){_.message.startsWith("EACCES")&&(c=await a.Promises.lstat(h))}return c?!c.isDirectory():!1}return!1}for(let h of u){let c;if(i.isAbsolute(h)?c=i.join(h,n):c=i.join(t,h,n),await l(c))return c;let _=c+".com";if(await l(_)||(_=c+".exe",await l(_)))return _}return i.join(t,n)}s.findExecutable=v})(g=e.win32||(e.win32={}))}),define(ge[154],pe([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(ge[113],pe([0,1,154,12,109]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.deriveFromWorkspaceTrust=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var C;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(C=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class i{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=i;class k{constructor(){this._values=[]}_read(se){return this._values[se]}get(se){return this._values[se]}_write(se,Se){this._values[se]=Se}}e.ValidatedEditorOptions=k;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class y{constructor(se,Se,Ge,Ye){this.id=se,this.name=Se,this.defaultValue=Ge,this.schema=Ye}compute(se,Se,Ge){return Ge}}class T{constructor(se,Se=null){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0,this.deps=Se}validate(se){return this.defaultValue}}class I{constructor(se,Se,Ge,Ye){this.id=se,this.name=Se,this.defaultValue=Ge,this.schema=Ye}validate(se){return typeof se=="undefined"?this.defaultValue:se}compute(se,Se,Ge){return Ge}}function a(ee,se){return typeof ee=="undefined"?se:ee==="false"?!1:Boolean(ee)}e.boolean=a;class b extends I{constructor(se,Se,Ge,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="boolean",Ye.default=Ge),super(se,Se,Ge,Ye)}validate(se){return a(se,this.defaultValue)}}function f(ee,se,Se,Ge){if(typeof ee=="undefined")return se;let Ye=parseInt(ee,10);return isNaN(Ye)?se:(Ye=Math.max(Se,Ye),Ye=Math.min(Ge,Ye),Ye|0)}e.clampedInt=f;class w extends I{constructor(se,Se,Ge,Ye,nt,he=void 0){typeof he!="undefined"&&(he.type="integer",he.default=Ge,he.minimum=Ye,he.maximum=nt),super(se,Se,Ge,he),this.minimum=Ye,this.maximum=nt}static clampedInt(se,Se,Ge,Ye){return f(se,Se,Ge,Ye)}validate(se){return w.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class E extends I{constructor(se,Se,Ge,Ye,nt){typeof nt!="undefined"&&(nt.type="number",nt.default=Ge),super(se,Se,Ge,nt),this.validationFn=Ye}static clamp(se,Se,Ge){return se<Se?Se:se>Ge?Ge:se}static float(se,Se){if(typeof se=="number")return se;if(typeof se=="undefined")return Se;const Ge=parseFloat(se);return isNaN(Ge)?Se:Ge}validate(se){return this.validationFn(E.float(se,this.defaultValue))}}class P extends I{static string(se,Se){return typeof se!="string"?Se:se}constructor(se,Se,Ge,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.default=Ge),super(se,Se,Ge,Ye)}validate(se){return P.string(se,this.defaultValue)}}function p(ee,se,Se){return typeof ee!="string"||Se.indexOf(ee)===-1?se:ee}e.stringSet=p;class o extends I{constructor(se,Se,Ge,Ye,nt=void 0){typeof nt!="undefined"&&(nt.type="string",nt.enum=Ye,nt.default=Ge),super(se,Se,Ge,nt),this._allowedValues=Ye}validate(se){return p(se,this.defaultValue,this._allowedValues)}}class r extends y{constructor(se,Se,Ge,Ye,nt,he,Ie=void 0){typeof Ie!="undefined"&&(Ie.type="string",Ie.enum=nt,Ie.default=Ye),super(se,Se,Ge,Ie),this._allowedValues=nt,this._convert=he}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function g(ee){switch(ee){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,Se,Ge){return Ge===0?se.accessibilitySupport:Ge}}class v extends y{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:m.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{insertSpace:a(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:a(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function t(ee){switch(ee){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(u=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function d(ee){switch(ee){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=d;function l(ee){switch(ee){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class h extends T{constructor(){super(127,[65,33])}compute(se,Se,Ge){const Ye=["monaco-editor"];return Se.get(33)&&Ye.push(Se.get(33)),se.extraEditorClassName&&Ye.push(se.extraEditorClassName),Se.get(65)==="default"?Ye.push("mouse-default"):Se.get(65)==="copy"&&Ye.push("mouse-copy"),Se.get(99)&&Ye.push("showUnused"),Se.get(125)&&Ye.push("showDeprecated"),Ye.join(" ")}}class c extends b{constructor(){super(32,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(se,Se,Ge){return Ge&&se.emptySelectionClipboard}}class _ extends y{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:m.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:m.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{cursorMoveOnType:a(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":p(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":p(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:a(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:a(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:a(Se.loop,this.defaultValue.loop)}}}class A extends y{constructor(){super(44,"fontLigatures",A.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(se){return typeof se=="undefined"?this.defaultValue:typeof se=="string"?se==="false"?A.OFF:se==="true"?A.ON:se:Boolean(se)?A.ON:A.OFF}}e.EditorFontLigatures=A,A.OFF='"liga" off, "calt" off',A.ON='"liga" on, "calt" on';class R extends T{constructor(){super(43)}compute(se,Se,Ge){return se.fontInfo}}class x extends I{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(22,null)})}validate(se){let Se=E.float(se,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:E.clamp(Se,6,100)}compute(se,Se,Ge){return se.fontInfo.fontSize}}class O extends y{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:O.MINIMUM_VALUE,maximum:O.MAXIMUM_VALUE,errorMessage:m.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:O.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(24,null)})}validate(se){return se==="normal"||se==="bold"?se:String(w.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,O.MINIMUM_VALUE,O.MAXIMUM_VALUE))}}O.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],O.MINIMUM_VALUE=1,O.MAXIMUM_VALUE=1e3;class F extends y{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[m.localize(25,null),m.localize(26,null),m.localize(27,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(29,null),...Se},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(30,null),...Se},"editor.gotoLocation.multipleDeclarations":{description:m.localize(31,null),...Se},"editor.gotoLocation.multipleImplementations":{description:m.localize(32,null),...Se},"editor.gotoLocation.multipleReferences":{description:m.localize(33,null),...Se},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:Ge,description:m.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:Ge,description:m.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:Ge,description:m.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:Ge,description:m.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:Ge,description:m.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{multiple:p(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Se.multipleDefinitions??p(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Se.multipleTypeDefinitions??p(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Se.multipleDeclarations??p(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Se.multipleImplementations??p(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Se.multipleReferences??p(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:P.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:P.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:P.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:P.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:P.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends y{constructor(){const se={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:m.localize(39,null)},"editor.hover.delay":{type:"number",default:se.delay,description:m.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:m.localize(41,null)},"editor.hover.above":{type:"boolean",default:se.above,description:m.localize(42,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:a(Se.enabled,this.defaultValue.enabled),delay:w.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:a(Se.sticky,this.defaultValue.sticky),above:a(Se.above,this.defaultValue.above)}}}var M;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})(M=e.RenderMinimap||(e.RenderMinimap={}));class B extends T{constructor(){super(130,[49,57,37,64,91,59,60,93,117,120,121,122,2])}compute(se,Se,Ge){return B.computeLayout(Se,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const Se=se.height/se.lineHeight,Ge=se.scrollBeyondLastLine?Se-1:0,Ye=(se.viewLineCount+Ge)/(se.pixelRatio*se.height),nt=Math.floor(se.viewLineCount/Ye);return{typicalViewportLineCount:Se,extraLinesBeyondLastLine:Ge,desiredRatio:Ye,minimapLineCount:nt}}static _computeMinimapLayout(se,Se){const Ge=se.outerWidth,Ye=se.outerHeight,nt=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(nt*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const he=Se.stableMinimapLayoutInput,Ie=he&&se.outerHeight===he.outerHeight&&se.lineHeight===he.lineHeight&&se.typicalHalfwidthCharacterWidth===he.typicalHalfwidthCharacterWidth&&se.pixelRatio===he.pixelRatio&&se.scrollBeyondLastLine===he.scrollBeyondLastLine&&se.minimap.enabled===he.minimap.enabled&&se.minimap.side===he.minimap.side&&se.minimap.size===he.minimap.size&&se.minimap.showSlider===he.minimap.showSlider&&se.minimap.renderCharacters===he.minimap.renderCharacters&&se.minimap.maxColumn===he.minimap.maxColumn&&se.minimap.scale===he.minimap.scale&&se.verticalScrollbarWidth===he.verticalScrollbarWidth&&se.isViewportWrapping===he.isViewportWrapping,Be=se.lineHeight,We=se.typicalHalfwidthCharacterWidth,tt=se.scrollBeyondLastLine,Te=se.minimap.renderCharacters;let ye=nt>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const be=se.minimap.maxColumn,ae=se.minimap.size,de=se.minimap.side,ve=se.verticalScrollbarWidth,Ee=se.viewLineCount,Fe=se.remainingWidth,Qe=se.isViewportWrapping,$e=Te?2:3;let Xe=Math.floor(nt*Ye);const at=Xe/nt;let ct=!1,ce=!1,_e=$e*ye,le=ye/nt,X=1;if(ae==="fill"||ae==="fit"){const{typicalViewportLineCount:kt,extraLinesBeyondLastLine:bt,desiredRatio:gt,minimapLineCount:Et}=B.computeContainedMinimapLineCount({viewLineCount:Ee,scrollBeyondLastLine:tt,height:Ye,lineHeight:Be,pixelRatio:nt});if(Ee/Et>1)ct=!0,ce=!0,ye=1,_e=1,le=ye/nt;else{let Lt=!1,yt=ye+1;if(ae==="fit"){const At=Math.ceil((Ee+bt)*_e);Qe&&Ie&&Fe<=Se.stableFitRemainingWidth?(Lt=!0,yt=Se.stableFitMaxMinimapScale):Lt=At>Xe}if(ae==="fill"||Lt){ct=!0;const At=ye;_e=Math.min(Be*nt,Math.max(1,Math.floor(1/gt))),Qe&&Ie&&Fe<=Se.stableFitRemainingWidth&&(yt=Se.stableFitMaxMinimapScale),ye=Math.min(yt,Math.max(1,Math.floor(_e/$e))),ye>At&&(X=Math.min(2,ye/At)),le=ye/nt/X,Xe=Math.ceil(Math.max(kt,Ee+bt)*_e),Qe?(Se.stableMinimapLayoutInput=se,Se.stableFitRemainingWidth=Fe,Se.stableFitMaxMinimapScale=ye):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0)}}}const De=Math.floor(be*le),Le=Math.min(De,Math.max(0,Math.floor((Fe-ve-2)*le/(We+le)))+e.MINIMAP_GUTTER_WIDTH);let et=Math.floor(nt*Le);const qe=et/nt;et=Math.floor(et*X);const mt=Te?1:2,_t=de==="left"?0:Ge-Le-ve;return{renderMinimap:mt,minimapLeft:_t,minimapWidth:Le,minimapHeightIsEditorHeight:ct,minimapIsSampling:ce,minimapScale:ye,minimapLineHeight:_e,minimapCanvasInnerWidth:et,minimapCanvasInnerHeight:Xe,minimapCanvasOuterWidth:qe,minimapCanvasOuterHeight:at}}static computeLayout(se,Se){const Ge=Se.outerWidth|0,Ye=Se.outerHeight|0,nt=Se.lineHeight|0,he=Se.lineNumbersDigitCount|0,Ie=Se.typicalHalfwidthCharacterWidth,Be=Se.maxDigitWidth,We=Se.pixelRatio,tt=Se.viewLineCount,Te=se.get(122),ye=Te==="inherit"?se.get(121):Te,be=ye==="inherit"?se.get(117):ye,ae=se.get(120),de=se.get(2),ve=Se.isDominatedByLongLines,Ee=se.get(49),Fe=se.get(59).renderType!==0,Qe=se.get(60),$e=se.get(93),Xe=se.get(64),at=se.get(91),ct=at.verticalScrollbarSize,ce=at.verticalHasArrows,_e=at.arrowSize,le=at.horizontalScrollbarSize,X=se.get(57),De=se.get(37);let Le;if(typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)){const Bt=parseFloat(X.substr(0,X.length-2));Le=w.clampedInt(Bt*Ie,0,0,1e3)}else Le=w.clampedInt(X,0,0,1e3);De&&(Le+=16);let et=0;if(Fe){const Bt=Math.max(he,Qe);et=Math.round(Bt*Be)}let qe=0;Ee&&(qe=nt);let mt=0,_t=mt+qe,kt=_t+et,bt=kt+Le;const gt=Ge-qe-et-Le;let Et=!1,Ct=!1,Lt=-1;de!==2&&(ye==="inherit"&&ve?(Et=!0,Ct=!0):be==="on"||be==="bounded"?Ct=!0:be==="wordWrapColumn"&&(Lt=ae));const yt=B._computeMinimapLayout({outerWidth:Ge,outerHeight:Ye,lineHeight:nt,typicalHalfwidthCharacterWidth:Ie,pixelRatio:We,scrollBeyondLastLine:$e,minimap:Xe,verticalScrollbarWidth:ct,viewLineCount:tt,remainingWidth:gt,isViewportWrapping:Ct},Se.memory||new S);yt.renderMinimap!==0&&yt.minimapLeft===0&&(mt+=yt.minimapWidth,_t+=yt.minimapWidth,kt+=yt.minimapWidth,bt+=yt.minimapWidth);const At=gt-yt.minimapWidth,xt=Math.max(1,Math.floor((At-ct-2)/Ie)),Tt=ce?_e:0;return Ct&&(Lt=Math.max(1,xt),be==="bounded"&&(Lt=Math.min(Lt,ae))),{width:Ge,height:Ye,glyphMarginLeft:mt,glyphMarginWidth:qe,lineNumbersLeft:_t,lineNumbersWidth:et,decorationsLeft:kt,decorationsWidth:Le,contentLeft:bt,contentWidth:At,minimap:yt,viewportColumn:xt,isWordWrapMinified:Et,isViewportWrapping:Ct,wrappingColumn:Lt,verticalScrollbarWidth:ct,horizontalScrollbarHeight:le,overviewRuler:{top:Tt,width:ct,height:Ye-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=B;class U extends y{constructor(){const se={enabled:!0};super(56,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:m.localize(43,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:a(se.enabled,this.defaultValue.enabled)}}}class z extends y{constructor(){const se={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",se,{"editor.inlayHints.enabled":{type:"boolean",default:se.enabled,description:m.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:m.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:m.localize(46,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:a(Se.enabled,this.defaultValue.enabled),fontSize:w.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:P.string(Se.fontFamily,this.defaultValue.fontFamily)}}}class K extends E{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>E.clamp(se,0,150),{markdownDescription:m.localize(47,null)})}compute(se,Se,Ge){return se.fontInfo.lineHeight}}class N extends y{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:m.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(49,null),m.localize(50,null),m.localize(51,null)],default:se.size,description:m.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:m.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:m.localize(54,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:m.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:m.localize(57,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:a(Se.enabled,this.defaultValue.enabled),size:p(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:p(Se.side,this.defaultValue.side,["right","left"]),showSlider:p(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:a(Se.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(Se.scale,1,1,3),maxColumn:w.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function j(ee){return ee==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class H extends y{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(59,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{top:w.clampedInt(Se.top,0,0,1e3),bottom:w.clampedInt(Se.bottom,0,0,1e3)}}}class V extends y{constructor(){const se={enabled:!0,cycle:!1};super(75,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:m.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:m.localize(61,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:a(Se.enabled,this.defaultValue.enabled),cycle:a(Se.cycle,this.defaultValue.cycle)}}}class q extends T{constructor(){super(128)}compute(se,Se,Ge){return se.pixelRatio}}class te extends y{constructor(){const se={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",se,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:se.strings,description:m.localize(62,null)},comments:{type:"boolean",default:se.comments,description:m.localize(63,null)},other:{type:"boolean",default:se.other,description:m.localize(64,null)}}}],default:se,description:m.localize(65,null)});this.defaultValue=se}validate(se){if(typeof se=="boolean")return se;if(se&&typeof se=="object"){const Se=se,Ge={other:a(Se.other,this.defaultValue.other),comments:a(Se.comments,this.defaultValue.comments),strings:a(Se.strings,this.defaultValue.strings)};return Ge.other&&Ge.comments&&Ge.strings?!0:!Ge.other&&!Ge.comments&&!Ge.strings?!1:Ge}return this.defaultValue}}var fe;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ce extends y{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(66,null),m.localize(67,null),m.localize(68,null),m.localize(69,null)],default:"on",description:m.localize(70,null)})}validate(se){let Se=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof se!="undefined"&&(typeof se=="function"?(Se=4,Ge=se):se==="interval"?Se=3:se==="relative"?Se=2:se==="on"?Se=1:Se=0),{renderType:Se,renderFn:Ge}}}function ke(ee){const se=ee.get(86);return se==="editable"?ee.get(80):se!=="on"}e.filterValidationDecorations=ke;class Ue extends y{constructor(){const se=[],Se={type:"number",description:m.localize(71,null)};super(90,"rulers",se,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:m.localize(72,null),format:"color-hex"}}}]},default:se,description:m.localize(73,null)})}validate(se){if(Array.isArray(se)){let Se=[];for(let Ge of se)if(typeof Ge=="number")Se.push({column:w.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const Ye=Ge;Se.push({column:w.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return Se.sort((Ge,Ye)=>Ge.column-Ye.column),Se}return this.defaultValue}}function xe(ee,se){if(typeof ee!="string")return se;switch(ee){case"hidden":return 2;case"visible":return 3;default:return 1}}class ze extends y{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(74,null),m.localize(75,null),m.localize(76,null)],default:"auto",description:m.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(78,null),m.localize(79,null),m.localize(80,null)],default:"auto",description:m.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:m.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:m.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:m.localize(84,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se,Ge=w.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=w.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:xe(Se.vertical,this.defaultValue.vertical),horizontal:xe(Se.horizontal,this.defaultValue.horizontal),useShadows:a(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:a(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:a(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:a(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:a(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:w.clampedInt(Se.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:w.clampedInt(Se.verticalSliderSize,Ye,0,1e3),scrollByPage:a(Se.scrollByPage,this.defaultValue.scrollByPage)}}}e.deriveFromWorkspaceTrust="deriveFromWorkspaceTrust",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments"};class Q extends y{constructor(){const se={nonBasicASCII:e.deriveFromWorkspaceTrust,invisibleCharacters:e.deriveFromWorkspaceTrust,ambiguousCharacters:e.deriveFromWorkspaceTrust,includeComments:e.deriveFromWorkspaceTrust,allowedCharacters:""};super(112,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:se.nonBasicASCII,description:m.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:se.invisibleCharacters,description:m.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:se.ambiguousCharacters,description:m.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:se.includeComments,description:m.localize(88,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"string",default:se.allowedCharacters,description:m.localize(89,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{nonBasicASCII:ie(Se.nonBasicASCII,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),invisibleCharacters:ie(Se.invisibleCharacters,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),ambiguousCharacters:ie(Se.ambiguousCharacters,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),includeComments:ie(Se.includeComments,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),allowedCharacters:Z(Se.allowedCharacters,"")}}}function Z(ee,se){return typeof ee!="string"?se:ee}class re extends y{constructor(){const se={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:m.localize(90,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:a(Se.enabled,this.defaultValue.enabled),mode:p(Se.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ue extends y{constructor(){const se={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,description:m.localize(91,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:a(se.enabled,this.defaultValue.enabled)}}}class J extends y{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(92,null),m.localize(93,null),m.localize(94,null)],default:se.bracketPairs,description:m.localize(95,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(96,null),m.localize(97,null),m.localize(98,null)],default:se.bracketPairsHorizontal,description:m.localize(99,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:m.localize(100,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:m.localize(101,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:se.highlightActiveIndentation,description:m.localize(102,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{bracketPairs:ie(Se.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ie(Se.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:a(Se.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:a(Se.indentation,this.defaultValue.indentation),highlightActiveIndentation:a(Se.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function ie(ee,se,Se){const Ge=Se.indexOf(ee);return Ge===-1?se:Se[Ge]}class we extends y{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(103,null),m.localize(104,null)],default:se.insertMode,description:m.localize(105,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:m.localize(106,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:m.localize(107,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:m.localize(108,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:m.localize(109,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:m.localize(110,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:m.localize(111,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:m.localize(112,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:m.localize(113,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(114,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(115,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(116,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(117,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(119,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(120,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(121,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(122,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(123,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(124,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(125,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(126,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(127,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(128,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(129,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(130,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(131,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(132,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(133,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(134,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(135,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(136,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(137,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(138,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(139,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(140,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(141,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(142,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(143,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(144,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{insertMode:p(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:a(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:a(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:a(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:a(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:a(Se.showIcons,this.defaultValue.showIcons),showStatusBar:a(Se.showStatusBar,this.defaultValue.showStatusBar),preview:a(Se.preview,this.defaultValue.preview),previewMode:p(Se.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:a(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:a(Se.showMethods,this.defaultValue.showMethods),showFunctions:a(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:a(Se.showConstructors,this.defaultValue.showConstructors),showDeprecated:a(Se.showDeprecated,this.defaultValue.showDeprecated),showFields:a(Se.showFields,this.defaultValue.showFields),showVariables:a(Se.showVariables,this.defaultValue.showVariables),showClasses:a(Se.showClasses,this.defaultValue.showClasses),showStructs:a(Se.showStructs,this.defaultValue.showStructs),showInterfaces:a(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:a(Se.showModules,this.defaultValue.showModules),showProperties:a(Se.showProperties,this.defaultValue.showProperties),showEvents:a(Se.showEvents,this.defaultValue.showEvents),showOperators:a(Se.showOperators,this.defaultValue.showOperators),showUnits:a(Se.showUnits,this.defaultValue.showUnits),showValues:a(Se.showValues,this.defaultValue.showValues),showConstants:a(Se.showConstants,this.defaultValue.showConstants),showEnums:a(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:a(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:a(Se.showKeywords,this.defaultValue.showKeywords),showWords:a(Se.showWords,this.defaultValue.showWords),showColors:a(Se.showColors,this.defaultValue.showColors),showFiles:a(Se.showFiles,this.defaultValue.showFiles),showReferences:a(Se.showReferences,this.defaultValue.showReferences),showFolders:a(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:a(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:a(Se.showSnippets,this.defaultValue.showSnippets),showUsers:a(Se.showUsers,this.defaultValue.showUsers),showIssues:a(Se.showIssues,this.defaultValue.showIssues)}}}class Me extends y{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(145,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:a(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class je extends T{constructor(){super(129,[80])}compute(se,Se,Ge){return Se.get(80)?!0:se.tabFocusMode}}var Ke;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(Ke=e.WrappingIndent||(e.WrappingIndent={}));function Ze(ee){switch(ee){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class rt extends T{constructor(){super(131,[130])}compute(se,Se,Ge){const Ye=Se.get(130);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}const ut="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",st="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?it:L.isLinux?st:ut,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Ae(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var wt;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.autoClosingBrackets=5]="autoClosingBrackets",ee[ee.autoClosingDelete=6]="autoClosingDelete",ee[ee.autoClosingOvertype=7]="autoClosingOvertype",ee[ee.autoClosingQuotes=8]="autoClosingQuotes",ee[ee.autoIndent=9]="autoIndent",ee[ee.automaticLayout=10]="automaticLayout",ee[ee.autoSurround=11]="autoSurround",ee[ee.bracketPairColorization=12]="bracketPairColorization",ee[ee.guides=13]="guides",ee[ee.codeLens=14]="codeLens",ee[ee.codeLensFontFamily=15]="codeLensFontFamily",ee[ee.codeLensFontSize=16]="codeLensFontSize",ee[ee.colorDecorators=17]="colorDecorators",ee[ee.columnSelection=18]="columnSelection",ee[ee.comments=19]="comments",ee[ee.contextmenu=20]="contextmenu",ee[ee.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=22]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=24]="cursorStyle",ee[ee.cursorSurroundingLines=25]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=27]="cursorWidth",ee[ee.disableLayerHinting=28]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ee[ee.domReadOnly=30]="domReadOnly",ee[ee.dragAndDrop=31]="dragAndDrop",ee[ee.emptySelectionClipboard=32]="emptySelectionClipboard",ee[ee.extraEditorClassName=33]="extraEditorClassName",ee[ee.fastScrollSensitivity=34]="fastScrollSensitivity",ee[ee.find=35]="find",ee[ee.fixedOverflowWidgets=36]="fixedOverflowWidgets",ee[ee.folding=37]="folding",ee[ee.foldingStrategy=38]="foldingStrategy",ee[ee.foldingHighlight=39]="foldingHighlight",ee[ee.foldingImportsByDefault=40]="foldingImportsByDefault",ee[ee.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=42]="fontFamily",ee[ee.fontInfo=43]="fontInfo",ee[ee.fontLigatures=44]="fontLigatures",ee[ee.fontSize=45]="fontSize",ee[ee.fontWeight=46]="fontWeight",ee[ee.formatOnPaste=47]="formatOnPaste",ee[ee.formatOnType=48]="formatOnType",ee[ee.glyphMargin=49]="glyphMargin",ee[ee.gotoLocation=50]="gotoLocation",ee[ee.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",ee[ee.hover=52]="hover",ee[ee.inDiffEditor=53]="inDiffEditor",ee[ee.inlineSuggest=54]="inlineSuggest",ee[ee.letterSpacing=55]="letterSpacing",ee[ee.lightbulb=56]="lightbulb",ee[ee.lineDecorationsWidth=57]="lineDecorationsWidth",ee[ee.lineHeight=58]="lineHeight",ee[ee.lineNumbers=59]="lineNumbers",ee[ee.lineNumbersMinChars=60]="lineNumbersMinChars",ee[ee.linkedEditing=61]="linkedEditing",ee[ee.links=62]="links",ee[ee.matchBrackets=63]="matchBrackets",ee[ee.minimap=64]="minimap",ee[ee.mouseStyle=65]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=67]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=69]="multiCursorModifier",ee[ee.multiCursorPaste=70]="multiCursorPaste",ee[ee.occurrencesHighlight=71]="occurrencesHighlight",ee[ee.overviewRulerBorder=72]="overviewRulerBorder",ee[ee.overviewRulerLanes=73]="overviewRulerLanes",ee[ee.padding=74]="padding",ee[ee.parameterHints=75]="parameterHints",ee[ee.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",ee[ee.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=78]="quickSuggestions",ee[ee.quickSuggestionsDelay=79]="quickSuggestionsDelay",ee[ee.readOnly=80]="readOnly",ee[ee.renameOnType=81]="renameOnType",ee[ee.renderControlCharacters=82]="renderControlCharacters",ee[ee.renderFinalNewline=83]="renderFinalNewline",ee[ee.renderLineHighlight=84]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=86]="renderValidationDecorations",ee[ee.renderWhitespace=87]="renderWhitespace",ee[ee.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",ee[ee.roundedSelection=89]="roundedSelection",ee[ee.rulers=90]="rulers",ee[ee.scrollbar=91]="scrollbar",ee[ee.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=93]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=94]="scrollPredominantAxis",ee[ee.selectionClipboard=95]="selectionClipboard",ee[ee.selectionHighlight=96]="selectionHighlight",ee[ee.selectOnLineNumbers=97]="selectOnLineNumbers",ee[ee.showFoldingControls=98]="showFoldingControls",ee[ee.showUnused=99]="showUnused",ee[ee.snippetSuggestions=100]="snippetSuggestions",ee[ee.smartSelect=101]="smartSelect",ee[ee.smoothScrolling=102]="smoothScrolling",ee[ee.stickyTabStops=103]="stickyTabStops",ee[ee.stopRenderingLineAfter=104]="stopRenderingLineAfter",ee[ee.suggest=105]="suggest",ee[ee.suggestFontSize=106]="suggestFontSize",ee[ee.suggestLineHeight=107]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",ee[ee.suggestSelection=109]="suggestSelection",ee[ee.tabCompletion=110]="tabCompletion",ee[ee.tabIndex=111]="tabIndex",ee[ee.unicodeHighlighting=112]="unicodeHighlighting",ee[ee.unusualLineTerminators=113]="unusualLineTerminators",ee[ee.useShadowDOM=114]="useShadowDOM",ee[ee.useTabStops=115]="useTabStops",ee[ee.wordSeparators=116]="wordSeparators",ee[ee.wordWrap=117]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=120]="wordWrapColumn",ee[ee.wordWrapOverride1=121]="wordWrapOverride1",ee[ee.wordWrapOverride2=122]="wordWrapOverride2",ee[ee.wrappingIndent=123]="wrappingIndent",ee[ee.wrappingStrategy=124]="wrappingStrategy",ee[ee.showDeprecated=125]="showDeprecated",ee[ee.inlayHints=126]="inlayHints",ee[ee.editorClassName=127]="editorClassName",ee[ee.pixelRatio=128]="pixelRatio",ee[ee.tabFocusMode=129]="tabFocusMode",ee[ee.layoutInfo=130]="layoutInfo",ee[ee.wrappingInfo=131]="wrappingInfo"})(wt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ae(new b(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(146,null)})),acceptSuggestionOnEnter:Ae(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(147,null),""],markdownDescription:m.localize(148,null)})),accessibilitySupport:Ae(new s),accessibilityPageSize:Ae(new w(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(149,null)})),ariaLabel:Ae(new P(4,"ariaLabel",m.localize(150,null))),autoClosingBrackets:Ae(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(151,null),m.localize(152,null),""],description:m.localize(153,null)})),autoClosingDelete:Ae(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(154,null),""],description:m.localize(155,null)})),autoClosingOvertype:Ae(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(156,null),""],description:m.localize(157,null)})),autoClosingQuotes:Ae(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(158,null),m.localize(159,null),""],description:m.localize(160,null)})),autoIndent:Ae(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],g,{enumDescriptions:[m.localize(161,null),m.localize(162,null),m.localize(163,null),m.localize(164,null),m.localize(165,null)],description:m.localize(166,null)})),automaticLayout:Ae(new b(10,"automaticLayout",!1)),autoSurround:Ae(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(167,null),m.localize(168,null),m.localize(169,null),""],description:m.localize(170,null)})),bracketPairColorization:Ae(new ue),bracketPairGuides:Ae(new J),stickyTabStops:Ae(new b(103,"stickyTabStops",!1,{description:m.localize(171,null)})),codeLens:Ae(new b(14,"codeLens",!0,{description:m.localize(172,null)})),codeLensFontFamily:Ae(new P(15,"codeLensFontFamily","",{description:m.localize(173,null)})),codeLensFontSize:Ae(new w(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(174,null)})),colorDecorators:Ae(new b(17,"colorDecorators",!0,{description:m.localize(175,null)})),columnSelection:Ae(new b(18,"columnSelection",!1,{description:m.localize(176,null)})),comments:Ae(new v),contextmenu:Ae(new b(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ae(new b(21,"copyWithSyntaxHighlighting",!0,{description:m.localize(177,null)})),cursorBlinking:Ae(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],t,{description:m.localize(178,null)})),cursorSmoothCaretAnimation:Ae(new b(23,"cursorSmoothCaretAnimation",!1,{description:m.localize(179,null)})),cursorStyle:Ae(new r(24,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],l,{description:m.localize(180,null)})),cursorSurroundingLines:Ae(new w(25,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(181,null)})),cursorSurroundingLinesStyle:Ae(new o(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(182,null),m.localize(183,null)],description:m.localize(184,null)})),cursorWidth:Ae(new w(27,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(185,null)})),disableLayerHinting:Ae(new b(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ae(new b(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ae(new b(30,"domReadOnly",!1)),dragAndDrop:Ae(new b(31,"dragAndDrop",!0,{description:m.localize(186,null)})),emptySelectionClipboard:Ae(new c),extraEditorClassName:Ae(new P(33,"extraEditorClassName","")),fastScrollSensitivity:Ae(new E(34,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:m.localize(187,null)})),find:Ae(new _),fixedOverflowWidgets:Ae(new b(36,"fixedOverflowWidgets",!1)),folding:Ae(new b(37,"folding",!0,{description:m.localize(188,null)})),foldingStrategy:Ae(new o(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(189,null),m.localize(190,null)],description:m.localize(191,null)})),foldingHighlight:Ae(new b(39,"foldingHighlight",!0,{description:m.localize(192,null)})),foldingImportsByDefault:Ae(new b(40,"foldingImportsByDefault",!1,{description:m.localize(193,null)})),unfoldOnClickAfterEndOfLine:Ae(new b(41,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(194,null)})),fontFamily:Ae(new P(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(195,null)})),fontInfo:Ae(new R),fontLigatures2:Ae(new A),fontSize:Ae(new x),fontWeight:Ae(new O),formatOnPaste:Ae(new b(47,"formatOnPaste",!1,{description:m.localize(196,null)})),formatOnType:Ae(new b(48,"formatOnType",!1,{description:m.localize(197,null)})),glyphMargin:Ae(new b(49,"glyphMargin",!0,{description:m.localize(198,null)})),gotoLocation:Ae(new F),hideCursorInOverviewRuler:Ae(new b(51,"hideCursorInOverviewRuler",!1,{description:m.localize(199,null)})),hover:Ae(new $),inDiffEditor:Ae(new b(53,"inDiffEditor",!1)),letterSpacing:Ae(new E(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>E.clamp(ee,-5,20),{description:m.localize(200,null)})),lightbulb:Ae(new U),lineDecorationsWidth:Ae(new I(57,"lineDecorationsWidth",10)),lineHeight:Ae(new K),lineNumbers:Ae(new Ce),lineNumbersMinChars:Ae(new w(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Ae(new b(61,"linkedEditing",!1,{description:m.localize(201,null)})),links:Ae(new b(62,"links",!0,{description:m.localize(202,null)})),matchBrackets:Ae(new o(63,"matchBrackets","always",["always","near","never"],{description:m.localize(203,null)})),minimap:Ae(new N),mouseStyle:Ae(new o(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ae(new E(66,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:m.localize(204,null)})),mouseWheelZoom:Ae(new b(67,"mouseWheelZoom",!1,{markdownDescription:m.localize(205,null)})),multiCursorMergeOverlapping:Ae(new b(68,"multiCursorMergeOverlapping",!0,{description:m.localize(206,null)})),multiCursorModifier:Ae(new r(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],j,{markdownEnumDescriptions:[m.localize(207,null),m.localize(208,null)],markdownDescription:m.localize(209,null)})),multiCursorPaste:Ae(new o(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(210,null),m.localize(211,null)],markdownDescription:m.localize(212,null)})),occurrencesHighlight:Ae(new b(71,"occurrencesHighlight",!0,{description:m.localize(213,null)})),overviewRulerBorder:Ae(new b(72,"overviewRulerBorder",!0,{description:m.localize(214,null)})),overviewRulerLanes:Ae(new w(73,"overviewRulerLanes",3,0,3)),padding:Ae(new H),parameterHints:Ae(new V),peekWidgetDefaultFocus:Ae(new o(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(215,null),m.localize(216,null)],description:m.localize(217,null)})),definitionLinkOpensInPeek:Ae(new b(77,"definitionLinkOpensInPeek",!1,{description:m.localize(218,null)})),quickSuggestions:Ae(new te),quickSuggestionsDelay:Ae(new w(79,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(219,null)})),readOnly:Ae(new b(80,"readOnly",!1)),renameOnType:Ae(new b(81,"renameOnType",!1,{description:m.localize(220,null),markdownDeprecationMessage:m.localize(221,null)})),renderControlCharacters:Ae(new b(82,"renderControlCharacters",!0,{description:m.localize(222,null),restricted:!0})),renderFinalNewline:Ae(new b(83,"renderFinalNewline",!0,{description:m.localize(223,null)})),renderLineHighlight:Ae(new o(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(224,null)],description:m.localize(225,null)})),renderLineHighlightOnlyWhenFocus:Ae(new b(85,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(226,null)})),renderValidationDecorations:Ae(new o(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ae(new o(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(227,null),m.localize(228,null),m.localize(229,null),""],description:m.localize(230,null)})),revealHorizontalRightPadding:Ae(new w(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ae(new b(89,"roundedSelection",!0,{description:m.localize(231,null)})),rulers:Ae(new Ue),scrollbar:Ae(new ze),scrollBeyondLastColumn:Ae(new w(92,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(232,null)})),scrollBeyondLastLine:Ae(new b(93,"scrollBeyondLastLine",!0,{description:m.localize(233,null)})),scrollPredominantAxis:Ae(new b(94,"scrollPredominantAxis",!0,{description:m.localize(234,null)})),selectionClipboard:Ae(new b(95,"selectionClipboard",!0,{description:m.localize(235,null),included:L.isLinux})),selectionHighlight:Ae(new b(96,"selectionHighlight",!0,{description:m.localize(236,null)})),selectOnLineNumbers:Ae(new b(97,"selectOnLineNumbers",!0)),showFoldingControls:Ae(new o(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(237,null),m.localize(238,null)],description:m.localize(239,null)})),showUnused:Ae(new b(99,"showUnused",!0,{description:m.localize(240,null)})),showDeprecated:Ae(new b(125,"showDeprecated",!0,{description:m.localize(241,null)})),inlayHints:Ae(new z),snippetSuggestions:Ae(new o(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(242,null),m.localize(243,null),m.localize(244,null),m.localize(245,null)],description:m.localize(246,null)})),smartSelect:Ae(new Me),smoothScrolling:Ae(new b(102,"smoothScrolling",!1,{description:m.localize(247,null)})),stopRenderingLineAfter:Ae(new w(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ae(new we),inlineSuggest:Ae(new re),suggestFontSize:Ae(new w(106,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(248,null)})),suggestLineHeight:Ae(new w(107,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(249,null)})),suggestOnTriggerCharacters:Ae(new b(108,"suggestOnTriggerCharacters",!0,{description:m.localize(250,null)})),suggestSelection:Ae(new o(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(251,null),m.localize(252,null),m.localize(253,null)],description:m.localize(254,null)})),tabCompletion:Ae(new o(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(255,null),m.localize(256,null),m.localize(257,null)],description:m.localize(258,null)})),tabIndex:Ae(new w(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ae(new Q),unusualLineTerminators:Ae(new o(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(259,null),m.localize(260,null),m.localize(261,null)],description:m.localize(262,null)})),useShadowDOM:Ae(new b(114,"useShadowDOM",!0)),useTabStops:Ae(new b(115,"useTabStops",!0,{description:m.localize(263,null)})),wordSeparators:Ae(new P(116,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:m.localize(264,null)})),wordWrap:Ae(new o(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(265,null),m.localize(266,null),m.localize(267,null),m.localize(268,null)],description:m.localize(269,null)})),wordWrapBreakAfterCharacters:Ae(new P(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ae(new P(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ae(new w(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(270,null)})),wordWrapOverride1:Ae(new o(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ae(new o(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ae(new r(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ze,{enumDescriptions:[m.localize(271,null),m.localize(272,null),m.localize(273,null),m.localize(274,null)],description:m.localize(275,null)})),wrappingStrategy:Ae(new o(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(276,null),m.localize(277,null)],description:m.localize(278,null)})),editorClassName:Ae(new h),pixelRatio:Ae(new q),tabFocusMode:Ae(new je),layoutInfo:Ae(new B),wrappingInfo:Ae(new rt)}}),define(ge[155],pe([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[156],pe([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[157],pe([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(ge[158],pe([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ge[159],pe([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(ge[160],pe([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(ge[161],pe([19,20]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[162],pe([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[163],pe([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[164],pe([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[165],pe([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[166],pe([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[167],pe([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[168],pe([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[169],pe([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[170],pe([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ge[171],pe([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(ge[172],pe([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[173],pe([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[174],pe([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[175],pe([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ge[176],pe([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[177],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var m;(function(i){i[i.ACTIVATE=1]="ACTIVATE",i[i.RESTORE=2]="RESTORE",i[i.PRESERVE=3]="PRESERVE"})(m=e.EditorActivation||(e.EditorActivation={}));var L;(function(i){i[i.PICK=0]="PICK",i[i.DISABLED=1]="DISABLED",i[i.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var D;(function(i){i[i.API=0]="API",i[i.USER=1]="USER"})(D=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(i){i[i.Center=0]="Center",i[i.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",i[i.NearTop=2]="NearTop",i[i.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ge[178],pe([0,1,157]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function C(a){return a=a.trim(),a==="*"||L.test(a)}e.isValidVersionStr=C;function i(a){if(!C(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=a.match(L);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=i;function k(a){if(!a)return null;let b=a.majorBase,f=a.majorMustEqual,w=a.minorBase,E=a.minorMustEqual,P=a.patchBase,p=a.patchMustEqual;a.hasCaret&&(b===0||(E=!1),p=!1);let o=0;if(a.preRelease){const r=D.exec(a.preRelease);if(r){const[,g,s,v]=r;o=Date.UTC(Number(g),Number(s)-1,Number(v))}}return{majorBase:b,majorMustEqual:f,minorBase:w,minorMustEqual:E,patchBase:P,patchMustEqual:p,isMinimum:a.hasGreaterEquals,notBefore:o}}e.normalizeVersion=k;function S(a,b,f){let w;typeof a=="string"?w=k(i(a)):w=a;let E;b instanceof Date?E=b.getTime():typeof b=="string"&&(E=new Date(b).getTime());let P;if(typeof f=="string"?P=k(i(f)):P=f,!w||!P)return!1;let p=w.majorBase,o=w.minorBase,r=w.patchBase,g=P.majorBase,s=P.minorBase,v=P.patchBase,n=P.notBefore,t=P.majorMustEqual,u=P.minorMustEqual,d=P.patchMustEqual;return P.isMinimum?p>g?!0:p<g?!1:o>s?!0:o<s||E&&E<n?!1:r>=v:(p===1&&g===0&&(!t||!u||!d)&&(g=1,s=0,v=0,t=!0,u=!1,d=!1),p<g?!1:p>g?!t:o<s?!1:o>s?!u:r<v?!1:r>v?!d:!(E&&E<n))}e.isValidVersion=S;function y(a,b,f,w){return f.isBuiltin||typeof f.main=="undefined"?!0:I(a,b,f.engines.vscode,w)}e.isValidExtensionVersion=y;function T(a,b,f){return a==="*"||I(b,f,a)}e.isEngineValid=T;function I(a,b,f,w=[]){let E=k(i(f));if(!E)return w.push(m.localize(0,null,f)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return w.push(m.localize(1,null,f)),!1}else if(!E.majorMustEqual)return w.push(m.localize(2,null,f)),!1;return S(a,b,E)?!0:(w.push(m.localize(3,null,a,f)),!1)}}),define(ge[114],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(D,C=[],i=!1){this.ctor=D,this.staticArguments=C,this.supportsDelayedInstantiation=i}}e.SyncDescriptor=m}),define(ge[83],pe([0,1,114]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function D(i,k,S){k instanceof m.SyncDescriptor||(k=new m.SyncDescriptor(k,[],S)),L.push([i,k])}e.registerSingleton=D;function C(){return L}e.getSingletonServiceDescriptors=C}),define(ge[179],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=m;class L{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let i of this._nodes.values())i.outgoing.size===0&&C.push(i);return C}insertEdge(C,i){const k=this.lookupOrInsertNode(C),S=this.lookupOrInsertNode(i);k.outgoing.set(this._hashFn(i),S),S.incoming.set(this._hashFn(C),k)}removeNode(C){const i=this._hashFn(C);this._nodes.delete(i);for(let k of this._nodes.values())k.outgoing.delete(i),k.incoming.delete(i)}lookupOrInsertNode(C){const i=this._hashFn(C);let k=this._nodes.get(i);return k||(k=new m(C),this._nodes.set(i,k)),k}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[i,k]of this._nodes)C.push(`${i}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,i]of this._nodes){const k=new Set([C]),S=this._findCycle(i,k);if(S)return S}}_findCycle(C,i){for(let[k,S]of C.outgoing){if(i.has(k))return[...i,k].join(" -> ");i.add(k);const y=this._findCycle(S,i);if(y)return y;i.delete(k)}}}e.Graph=L}),define(ge[4],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(i){i.serviceIds=new Map,i.DI_TARGET="$di$target",i.DI_DEPENDENCIES="$di$dependencies";function k(S){return S[i.DI_DEPENDENCIES]||[]}i.getServiceDependencies=k})(m=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function L(i,k,S,y){k[m.DI_TARGET]===k?k[m.DI_DEPENDENCIES].push({id:i,index:S,optional:y}):(k[m.DI_DEPENDENCIES]=[{id:i,index:S,optional:y}],k[m.DI_TARGET]=k)}function D(i){if(m.serviceIds.has(i))return m.serviceIds.get(i);const k=function(S,y,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(k,S,T,!1)};return k.toString=()=>i,m.serviceIds.set(i,k),k}e.createDecorator=D;function C(i){return i}e.refineServiceDecorator=C}),define(ge[180],pe([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,m.createDecorator)("modelService");function L(D){return!D.isTooLargeForSyncing()&&!D.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(ge[181],pe([0,1,3,47,6,24,77,82,180]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function y(w){return typeof w=="string"?!1:Array.isArray(w)?w.every(y):!!w.exclusive}class T{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(E,P){let p={selector:E,provider:P,_score:-1,_time:this._clock++};return this._entries.push(p),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,D.toDisposable)(()=>{if(p){let o=this._entries.indexOf(p);o>=0&&(this._entries.splice(o,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),p=void 0)}})}has(E){return this.all(E).length>0}all(E){if(!E)return[];this._updateScores(E);const P=[];for(let p of this._entries)p._score>0&&P.push(p.provider);return P}ordered(E){const P=[];return this._orderedForEach(E,p=>P.push(p.provider)),P}orderedGroups(E){const P=[];let p,o;return this._orderedForEach(E,r=>{p&&o===r._score?p.push(r.provider):(o=r._score,p=[r.provider],P.push(p))}),P}_orderedForEach(E,P){if(!!E){this._updateScores(E);for(const p of this._entries)p._score>0&&P(p)}}_updateScores(E){let P={uri:E.uri.toString(),language:E.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===P.language&&this._lastCandidate.uri===P.uri)){this._lastCandidate=P;for(let p of this._entries)if(p._score=(0,k.score)(p.selector,E.uri,E.getLanguageId(),(0,S.shouldSynchronizeModel)(E)),y(p.selector)&&p._score>0){for(let o of this._entries)o._score=0;p._score=1e3;break}this._entries.sort(T._compareByScoreAndTime)}}static _compareByScoreAndTime(E,P){return E._score<P._score?1:E._score>P._score?-1:E._time<P._time?1:E._time>P._time?-1:0}}e.LanguageFeatureRegistry=T;const I=new WeakMap;let a=0;function b(w){let E=I.get(w);return E===void 0&&(E=++a,I.set(w,E)),E}class f{constructor(E,P,p=Number.MAX_SAFE_INTEGER){this._registry=E,this.min=P,this.max=p,this._cache=new C.LRUCache(50,.7)}_key(E){return E.id+this._registry.all(E).reduce((P,p)=>(0,L.doHash)(b(p),P),0)}_clamp(E){return E===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(E*1.3)))}get(E){const P=this._key(E),p=this._cache.get(P);return this._clamp(p?.value)}update(E,P){const p=this._key(E);let o=this._cache.get(p);return o||(o=new i.MovingAverage,this._cache.set(p,o)),o.update(P),this.get(E)}}e.LanguageFeatureRequestDelays=f}),define(ge[84],pe([0,1,2,41,181,148,78]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(c){c[c.Null=0]="Null",c[c.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));var S;(function(c){c[c.NotSet=-1]="NotSet",c[c.None=0]="None",c[c.Italic=1]="Italic",c[c.Bold=2]="Bold",c[c.Underline=4]="Underline"})(S=e.FontStyle||(e.FontStyle={}));var y;(function(c){c[c.None=0]="None",c[c.DefaultForeground=1]="DefaultForeground",c[c.DefaultBackground=2]="DefaultBackground"})(y=e.ColorId||(e.ColorId={}));var T;(function(c){c[c.Other=0]="Other",c[c.Comment=1]="Comment",c[c.String=2]="String",c[c.RegEx=4]="RegEx"})(T=e.StandardTokenType||(e.StandardTokenType={}));var I;(function(c){c[c.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",c[c.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",c[c.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",c[c.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",c[c.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",c[c.ITALIC_MASK=2048]="ITALIC_MASK",c[c.BOLD_MASK=4096]="BOLD_MASK",c[c.UNDERLINE_MASK=8192]="UNDERLINE_MASK",c[c.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",c[c.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",c[c.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",c[c.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",c[c.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",c[c.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",c[c.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",c[c.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",c[c.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",c[c.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(I=e.MetadataConsts||(e.MetadataConsts={}));class a{static getLanguageId(_){return(_&255)>>>0}static getTokenType(_){return(_&1792)>>>8}static getFontStyle(_){return(_&14336)>>>11}static getForeground(_){return(_&8372224)>>>14}static getBackground(_){return(_&4286578688)>>>23}static getClassNameFromMetadata(_){let A=this.getForeground(_),R="mtk"+A,x=this.getFontStyle(_);return x&1&&(R+=" mtki"),x&2&&(R+=" mtkb"),x&4&&(R+=" mtku"),R}static getInlineStyleFromMetadata(_,A){const R=this.getForeground(_),x=this.getFontStyle(_);let O=`color: ${A[R]};`;return x&1&&(O+="font-style: italic;"),x&2&&(O+="font-weight: bold;"),x&4&&(O+="text-decoration: underline;"),O}}e.TokenMetadata=a;var b;(function(c){c[c.Method=0]="Method",c[c.Function=1]="Function",c[c.Constructor=2]="Constructor",c[c.Field=3]="Field",c[c.Variable=4]="Variable",c[c.Class=5]="Class",c[c.Struct=6]="Struct",c[c.Interface=7]="Interface",c[c.Module=8]="Module",c[c.Property=9]="Property",c[c.Event=10]="Event",c[c.Operator=11]="Operator",c[c.Unit=12]="Unit",c[c.Value=13]="Value",c[c.Constant=14]="Constant",c[c.Enum=15]="Enum",c[c.EnumMember=16]="EnumMember",c[c.Keyword=17]="Keyword",c[c.Text=18]="Text",c[c.Color=19]="Color",c[c.File=20]="File",c[c.Reference=21]="Reference",c[c.Customcolor=22]="Customcolor",c[c.Folder=23]="Folder",c[c.TypeParameter=24]="TypeParameter",c[c.User=25]="User",c[c.Issue=26]="Issue",c[c.Snippet=27]="Snippet"})(b=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let c=Object.create(null);return c[0]="symbol-method",c[1]="symbol-function",c[2]="symbol-constructor",c[3]="symbol-field",c[4]="symbol-variable",c[5]="symbol-class",c[6]="symbol-struct",c[7]="symbol-interface",c[8]="symbol-module",c[9]="symbol-property",c[10]="symbol-event",c[11]="symbol-operator",c[12]="symbol-unit",c[13]="symbol-value",c[14]="symbol-constant",c[15]="symbol-enum",c[16]="symbol-enum-member",c[17]="symbol-keyword",c[27]="symbol-snippet",c[18]="symbol-text",c[19]="symbol-color",c[20]="symbol-file",c[21]="symbol-reference",c[22]="symbol-customcolor",c[23]="symbol-folder",c[24]="symbol-type-parameter",c[25]="account",c[26]="issues",function(_){const A=c[_];let R=A&&i.iconRegistry.get(A);return R||(console.info("No codicon found for CompletionItemKind "+_),R=i.Codicon.symbolProperty),R.classNames}}(),e.completionKindFromString=function(){let c=Object.create(null);return c.method=0,c.function=1,c.constructor=2,c.field=3,c.variable=4,c.class=5,c.struct=6,c.interface=7,c.module=8,c.property=9,c.event=10,c.operator=11,c.unit=12,c.value=13,c.constant=14,c.enum=15,c["enum-member"]=16,c.enumMember=16,c.keyword=17,c.snippet=27,c.text=18,c.color=19,c.file=20,c.reference=21,c.customcolor=22,c.folder=23,c["type-parameter"]=24,c.typeParameter=24,c.account=25,c.issue=26,function(_,A){let R=c[_];return typeof R=="undefined"&&!A&&(R=9),R}}();var f;(function(c){c[c.Deprecated=1]="Deprecated"})(f=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(c){c[c.KeepWhitespace=1]="KeepWhitespace",c[c.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var E;(function(c){c[c.Invoke=0]="Invoke",c[c.TriggerCharacter=1]="TriggerCharacter",c[c.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var P;(function(c){c[c.Automatic=0]="Automatic",c[c.Explicit=1]="Explicit"})(P=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var p;(function(c){c[c.Invoke=1]="Invoke",c[c.Auto=2]="Auto"})(p=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(c){c[c.Invoke=1]="Invoke",c[c.TriggerCharacter=2]="TriggerCharacter",c[c.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var r;(function(c){c[c.Text=0]="Text",c[c.Read=1]="Read",c[c.Write=2]="Write"})(r=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function g(c){return c&&m.URI.isUri(c.uri)&&L.Range.isIRange(c.range)&&(L.Range.isIRange(c.originSelectionRange)||L.Range.isIRange(c.targetSelectionRange))}e.isLocationLink=g;var s;(function(c){c[c.File=0]="File",c[c.Module=1]="Module",c[c.Namespace=2]="Namespace",c[c.Package=3]="Package",c[c.Class=4]="Class",c[c.Method=5]="Method",c[c.Property=6]="Property",c[c.Field=7]="Field",c[c.Constructor=8]="Constructor",c[c.Enum=9]="Enum",c[c.Interface=10]="Interface",c[c.Function=11]="Function",c[c.Variable=12]="Variable",c[c.Constant=13]="Constant",c[c.String=14]="String",c[c.Number=15]="Number",c[c.Boolean=16]="Boolean",c[c.Array=17]="Array",c[c.Object=18]="Object",c[c.Key=19]="Key",c[c.Null=20]="Null",c[c.EnumMember=21]="EnumMember",c[c.Struct=22]="Struct",c[c.Event=23]="Event",c[c.Operator=24]="Operator",c[c.TypeParameter=25]="TypeParameter"})(s=e.SymbolKind||(e.SymbolKind={}));var v;(function(c){c[c.Deprecated=1]="Deprecated"})(v=e.SymbolTag||(e.SymbolTag={}));var n;(function(c){const _=new Map;_.set("file",0),_.set("module",1),_.set("namespace",2),_.set("package",3),_.set("class",4),_.set("method",5),_.set("property",6),_.set("field",7),_.set("constructor",8),_.set("enum",9),_.set("interface",10),_.set("function",11),_.set("variable",12),_.set("constant",13),_.set("string",14),_.set("number",15),_.set("boolean",16),_.set("array",17),_.set("object",18),_.set("key",19),_.set("null",20),_.set("enum-member",21),_.set("struct",22),_.set("event",23),_.set("operator",24),_.set("type-parameter",25);const A=new Map;A.set(0,"file"),A.set(1,"module"),A.set(2,"namespace"),A.set(3,"package"),A.set(4,"class"),A.set(5,"method"),A.set(6,"property"),A.set(7,"field"),A.set(8,"constructor"),A.set(9,"enum"),A.set(10,"interface"),A.set(11,"function"),A.set(12,"variable"),A.set(13,"constant"),A.set(14,"string"),A.set(15,"number"),A.set(16,"boolean"),A.set(17,"array"),A.set(18,"object"),A.set(19,"key"),A.set(20,"null"),A.set(21,"enum-member"),A.set(22,"struct"),A.set(23,"event"),A.set(24,"operator"),A.set(25,"type-parameter");function R(F){return _.get(F)}c.fromString=R;function x(F){return A.get(F)}c.toString=x;function O(F,$){const M=A.get(F);let B=M&&i.iconRegistry.get("symbol-"+M);return B||(console.info("No codicon found for SymbolKind "+F),B=i.Codicon.symbolProperty),`${$?"inline":"block"} ${B.classNames}`}c.toCssClassName=O})(n=e.SymbolKinds||(e.SymbolKinds={}));class t{constructor(_){this.value=_}}e.FoldingRangeKind=t,t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region");var u;(function(c){c[c.Collapsed=0]="Collapsed",c[c.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(c){c[c.Editing=0]="Editing",c[c.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var l;(function(c){c[c.Other=0]="Other",c[c.Type=1]="Type",c[c.Parameter=2]="Parameter"})(l=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new D.LanguageFeatureRegistry,e.RenameProviderRegistry=new D.LanguageFeatureRegistry,e.CompletionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new D.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new D.LanguageFeatureRegistry,e.HoverProviderRegistry=new D.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new D.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new D.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new D.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new D.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new D.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.LinkProviderRegistry=new D.LanguageFeatureRegistry,e.ColorProviderRegistry=new D.LanguageFeatureRegistry,e.SelectionRangeRegistry=new D.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistryImpl;var h;(function(c){c[c.None=0]="None",c[c.Option=1]="Option",c[c.Default=2]="Default",c[c.Preferred=3]="Preferred"})(h=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[115],pe([0,1,13,2,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function C(E){return E&&typeof E=="object"&&(!E.overrideIdentifier||typeof E.overrideIdentifier=="string")&&(!E.resource||E.resource instanceof L.URI)}e.isConfigurationOverrides=C;function i(E){return E&&typeof E=="object"&&(!E.overrideIdentifiers||m.isArray(E.overrideIdentifiers))&&!E.overrideIdentifier&&(!E.resource||E.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=i;var k;(function(E){E[E.USER=1]="USER",E[E.USER_LOCAL=2]="USER_LOCAL",E[E.USER_REMOTE=3]="USER_REMOTE",E[E.WORKSPACE=4]="WORKSPACE",E[E.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",E[E.DEFAULT=6]="DEFAULT",E[E.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(E){switch(E){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=S;function y(E,P){const p=Object.create(null);for(let o in E)T(p,o,E[o],P);return p}e.toValuesTree=y;function T(E,P,p,o){const r=P.split("."),g=r.pop();let s=E;for(let v=0;v<r.length;v++){let n=r[v],t=s[n];switch(typeof t){case"undefined":t=s[n]=Object.create(null);break;case"object":break;default:o(`Ignoring ${P} as ${r.slice(0,v+1).join(".")} is ${JSON.stringify(t)}`);return}s=t}if(typeof s=="object"&&s!==null)try{s[g]=p}catch(v){o(`Ignoring ${P} as ${r.join(".")} is ${JSON.stringify(s)}`)}else o(`Ignoring ${P} as ${r.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=T;function I(E,P){const p=P.split(".");a(E,p)}e.removeFromValueTree=I;function a(E,P){const p=P.shift();if(P.length===0){delete E[p];return}if(Object.keys(E).indexOf(p)!==-1){const o=E[p];typeof o=="object"&&!Array.isArray(o)&&(a(o,P),Object.keys(o).length===0&&delete E[p])}}function b(E,P,p){function o(s,v){let n=s;for(const t of v){if(typeof n!="object"||n===null)return;n=n[t]}return n}const r=P.split("."),g=o(E,r);return typeof g=="undefined"?p:g}e.getConfigurationValue=b;function f(E,P,p){Object.keys(P).forEach(o=>{o!=="__proto__"&&(o in E?m.isObject(E[o])&&m.isObject(P[o])?f(E[o],P[o],p):p&&(E[o]=P[o]):E[o]=P[o])})}e.merge=f;function w(E,P,p){const o=E.inspect(P),r=E.inspect(p);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof r.userValue!="undefined"||typeof r.workspaceValue!="undefined"||typeof r.workspaceFolderValue!="undefined"?r.value:o.defaultValue}e.getMigratedSettingValue=w}),define(ge[61],pe([0,1,12,8,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let C=m.userAgent||"";const i=new Map;i.set("false",!1),i.set("true",!0),i.set("isMac",m.isMacintosh),i.set("isLinux",m.isLinux),i.set("isWindows",m.isWindows),i.set("isWeb",m.isWeb),i.set("isMacNative",m.isMacintosh&&!m.isWeb),i.set("isEdge",C.indexOf("Edg/")>=0),i.set("isFirefox",C.indexOf("Firefox")>=0),i.set("isChrome",C.indexOf("Chrome")>=0),i.set("isSafari",C.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var S;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return a.INSTANCE}static true(){return b.INSTANCE}static has(F){return f.create(F)}static equals(F,$){return w.create(F,$)}static notEquals(F,$){return p.create(F,$)}static regex(F,$){return t.create(F,$)}static in(F,$){return E.create(F,$)}static not(F){return o.create(F)}static and(...F){return l.create(F,null)}static or(...F){return h.create(F,null,!0)}static greater(F,$){return g.create(F,$)}static greaterEquals(F,$){return s.create(F,$)}static smaller(F,$){return v.create(F,$)}static smallerEquals(F,$){return n.create(F,$)}static deserialize(F,$=!1){if(!!F)return this._deserializeOrExpression(F,$)}static _deserializeOrExpression(F,$){let M=F.split("||");return h.create(M.map(B=>this._deserializeAndExpression(B,$)),null,!0)}static _deserializeAndExpression(F,$){let M=F.split("&&");return l.create(M.map(B=>this._deserializeOne(B,$)),null)}static _deserializeOne(F,$){if(F=F.trim(),F.indexOf("!=")>=0){let M=F.split("!=");return p.create(M[0].trim(),this._deserializeValue(M[1],$))}if(F.indexOf("==")>=0){let M=F.split("==");return w.create(M[0].trim(),this._deserializeValue(M[1],$))}if(F.indexOf("=~")>=0){let M=F.split("=~");return t.create(M[0].trim(),this._deserializeRegexValue(M[1],$))}if(F.indexOf(" in ")>=0){let M=F.split(" in ");return E.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const M=F.split(">=");return s.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const M=F.split(">");return g.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const M=F.split("<=");return n.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const M=F.split("<");return v.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(F)?o.create(F.substr(1).trim()):f.create(F)}static _deserializeValue(F,$){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;let M=/^'([^']*)'$/.exec(F);return M?M[1].trim():F}static _deserializeRegexValue(F,$){if((0,L.isFalsyOrWhitespace)(F)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=F.indexOf("/"),B=F.lastIndexOf("/");if(M===B||M<0){if($)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}let U=F.slice(M+1,B),z=F[B+1]==="i"?"i":"";try{return new RegExp(U,z)}catch(K){if($)throw new Error(`bad regexp-value '${F}', parse error: ${K}`);return console.warn(`bad regexp-value '${F}', parse error: ${K}`),null}}}e.ContextKeyExpr=y;function T(O,F){const $=O?O.substituteConstants():void 0,M=F?F.substituteConstants():void 0;return!$&&!M?!0:!$||!M?!1:$.equals(M)}e.expressionsAreEqualWithConstantSubstitution=T;function I(O,F){return O.cmp(F)}class a{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return b.INSTANCE}}e.ContextKeyFalseExpr=a,a.INSTANCE=new a;class b{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return a.INSTANCE}}e.ContextKeyTrueExpr=b,b.INSTANCE=new b;class f{constructor(F,$){this.key=F,this.negated=$,this.type=2}static create(F,$=null){const M=i.get(F);return typeof M=="boolean"?M?b.INSTANCE:a.INSTANCE:new f(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:_(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=i.get(this.key);return typeof F=="boolean"?F?b.INSTANCE:a.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=f;class w{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=4}static create(F,$,M=null){if(typeof $=="boolean")return $?f.create(F,M):o.create(F,M);const B=i.get(F);return typeof B=="boolean"?$===(B?"true":"false")?b.INSTANCE:a.INSTANCE:new w(F,$,M)}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=i.get(this.key);if(typeof F=="boolean"){const $=F?"true":"false";return this.value===$?b.INSTANCE:a.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class E{constructor(F,$){this.key=F,this.valueKey=$,this.type=10,this.negated=null}static create(F,$){return new E(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const $=F.getValue(this.valueKey),M=F.getValue(this.key);return Array.isArray($)?$.indexOf(M)>=0:typeof M=="string"&&typeof $=="object"&&$!==null?k.call($,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=P.create(this)),this.negated}}e.ContextKeyInExpr=E;class P{constructor(F){this._actual=F,this.type=11}static create(F){return new P(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new P(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotInExpr=P;class p{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=5}static create(F,$,M=null){if(typeof $=="boolean")return $?o.create(F,M):f.create(F,M);const B=i.get(F);return typeof B=="boolean"?$===(B?"true":"false")?a.INSTANCE:b.INSTANCE:new p(F,$,M)}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=i.get(this.key);if(typeof F=="boolean"){const $=F?"true":"false";return this.value===$?a.INSTANCE:b.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=p;class o{constructor(F,$){this.key=F,this.negated=$,this.type=3}static create(F,$=null){const M=i.get(F);return typeof M=="boolean"?M?a.INSTANCE:b.INSTANCE:new o(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:_(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=i.get(this.key);return typeof F=="boolean"?F?a.INSTANCE:b.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=o;function r(O,F){if(typeof O=="string"){const $=parseFloat(O);isNaN($)||(O=$)}return typeof O=="string"||typeof O=="number"?F(O):a.INSTANCE}class g{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=12}static create(F,$,M=null){return r($,B=>new g(F,B,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=g;class s{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=13}static create(F,$,M=null){return r($,B=>new s(F,B,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=s;class v{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=14}static create(F,$,M=null){return r($,B=>new v(F,B,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=v;class n{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=15}static create(F,$,M=null){return r($,B=>new n(F,B,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class t{constructor(F,$){this.key=F,this.regexp=$,this.type=7,this.negated=null}static create(F,$){return new t(F,$)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const $=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return $<M?-1:$>M?1:0}equals(F){if(F.type===this.type){const $=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return this.key===F.key&&$===M}return!1}substituteConstants(){return this}evaluate(F){let $=F.getValue(this.key);return this.regexp?this.regexp.test($):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=u.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class u{constructor(F){this._actual=F,this.type=8}static create(F){return new u(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new u(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=u;function d(O){let F=null;for(let $=0,M=O.length;$<M;$++){const B=O[$].substituteConstants();if(O[$]!==B&&F===null){F=[];for(let U=0;U<$;U++)F[U]=O[U]}F!==null&&(F[$]=B)}return F===null?O:F}class l{constructor(F,$){this.expr=F,this.negated=$,this.type=6}static create(F,$){return l._normalizeArr(F,$)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let $=0,M=this.expr.length;$<M;$++){const B=I(this.expr[$],F.expr[$]);if(B!==0)return B}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].equals(F.expr[$]))return!1;return!0}return!1}substituteConstants(){const F=d(this.expr);return F===this.expr?this:l.create(F,this.negated)}evaluate(F){for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].evaluate(F))return!1;return!0}static _normalizeArr(F,$){const M=[];let B=!1;for(const U of F)if(!!U){if(U.type===1){B=!0;continue}if(U.type===0)return a.INSTANCE;if(U.type===6){M.push(...U.expr);continue}M.push(U)}if(M.length===0&&B)return b.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(I);for(let U=1;U<M.length;U++)M[U-1].equals(M[U])&&(M.splice(U,1),U--);if(M.length===1)return M[0];for(;M.length>1;){const U=M[M.length-1];if(U.type!==9)break;M.pop();const z=M.pop(),K=M.length===0,N=h.create(U.expr.map(j=>l.create([j,z],null)),null,K);N&&(M.push(N),M.sort(I))}return M.length===1?M[0]:new l(M,$)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(let $ of this.expr)F.push(...$.keys());return F}map(F){return new l(this.expr.map($=>$.map(F)),null)}negate(){if(!this.negated){const F=[];for(let $ of this.expr)F.push($.negate());this.negated=h.create(F,this,!0)}return this.negated}}class h{constructor(F,$){this.expr=F,this.negated=$,this.type=9}static create(F,$,M){return h._normalizeArr(F,$,M)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let $=0,M=this.expr.length;$<M;$++){const B=I(this.expr[$],F.expr[$]);if(B!==0)return B}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].equals(F.expr[$]))return!1;return!0}return!1}substituteConstants(){const F=d(this.expr);return F===this.expr?this:h.create(F,this.negated,!1)}evaluate(F){for(let $=0,M=this.expr.length;$<M;$++)if(this.expr[$].evaluate(F))return!0;return!1}static _normalizeArr(F,$,M){let B=[],U=!1;if(F){for(let z=0,K=F.length;z<K;z++){const N=F[z];if(!!N){if(N.type===0){U=!0;continue}if(N.type===1)return b.INSTANCE;if(N.type===9){B=B.concat(N.expr);continue}B.push(N)}}if(B.length===0&&U)return a.INSTANCE;B.sort(I)}if(B.length!==0){if(B.length===1)return B[0];for(let z=1;z<B.length;z++)B[z-1].equals(B[z])&&(B.splice(z,1),z--);if(B.length===1)return B[0];if(M){for(let z=0;z<B.length;z++)for(let K=z+1;K<B.length;K++)R(B[z],B[K])&&(B.splice(K,1),K--);if(B.length===1)return B[0]}return new h(B,$)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(let $ of this.expr)F.push(...$.keys());return F}map(F){return new h(this.expr.map($=>$.map(F)),null)}negate(){if(!this.negated){let F=[];for(let $ of this.expr)F.push($.negate());for(;F.length>1;){const $=F.shift(),M=F.shift(),B=[];for(const z of x($))for(const K of x(M))B.push(l.create([z,K],null));const U=F.length===0;F.unshift(h.create(B,null,U))}this.negated=F[0]}return this.negated}}class c extends f{constructor(F,$,M){super(F,null);this._defaultValue=$,typeof M=="object"?c._info.push({...M,key:F}):M!==!0&&c._info.push({key:F,description:M,type:$!=null?typeof $:void 0})}static all(){return c._info.values()}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return w.create(this.key,F)}notEqualsTo(F){return p.create(this.key,F)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function _(O,F){return O<F?-1:O>F?1:0}function A(O,F,$,M){return O<$?-1:O>$?1:F<M?-1:F>M?1:0}function R(O,F){if(F.type===6&&O.type!==9&&O.type!==6){for(const B of F.expr)if(O.equals(B))return!0}const $=O.negate(),M=x($).concat(x(F));M.sort(I);for(let B=0;B<M.length;B++){const z=M[B].negate();for(let K=B+1;K<M.length;K++){const N=M[K];if(z.equals(N))return!0}}return!1}e.implies=R;function x(O){return O.type===9?O.expr:[O]}}),define(ge[182],pe([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(ge[183],pe([0,1,10,156,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(o){o.WIN32_X64="win32-x64",o.WIN32_IA32="win32-ia32",o.WIN32_ARM64="win32-arm64",o.LINUX_X64="linux-x64",o.LINUX_ARM64="linux-arm64",o.LINUX_ARMHF="linux-armhf",o.ALPINE_X64="alpine-x64",o.ALPINE_ARM64="alpine-arm64",o.DARWIN_X64="darwin-x64",o.DARWIN_ARM64="darwin-arm64",o.WEB="web",o.UNIVERSAL="universal",o.UNKNOWN="unknown",o.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function i(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=i;function k(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function S(o,r){switch(o){case 3:return r==="x64"?"win32-x64":r==="ia32"?"win32-ia32":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function y(o,r){return r==="web"&&!o.includes("web")}e.isNotWebExtensionInWebTargetPlatform=y;function T(o,r,g){return y(r,g)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===g?!0:I(g).includes(o)}e.isTargetPlatformCompatible=T;function I(o){switch(o){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function a(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.isIExtensionIdentifier=a;var b;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var f;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(f=e.SortOrder||(e.SortOrder={}));var w;(function(o){o.Install="install",o.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var E;(function(o){o[o.None=0]="None",o[o.Install=1]="Install",o[o.Update=2]="Update"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var P;(function(o){o.Unsupported="Unsupported",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatiblePreRelease="IncompatiblePreRelease",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Internal="Internal"})(P=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class p extends Error{constructor(r,g){super(r);this.code=g,this.name=g}}e.ExtensionManagementError=p,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=m.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(ge[184],pe([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(ge[185],pe([0,1,37,10,9,12,94,28,112,158,184]),function(Y,e,m,L,D,C,i,k,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=y.localize(0,null);class a{async getDefaultTerminalForPlatforms(){return{windows:b.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class b extends a{openTerminal(r,g){return this.spawnTerminal(m,r,S.getWindowsShell(),g)}spawnTerminal(r,g,s,v){const n=g.windowsExec||b.getDefaultTerminalWindows();v&&v[1]===":"&&(v=v[0].toUpperCase()+v.substr(1));const t=D.basename(n).toLowerCase();if(t==="cmder"||t==="cmder.exe")return r.spawn(n,v?[v]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return n.indexOf(" ")>=0&&u.push('""'),u.push(n),(t==="wt"||t==="wt.exe")&&u.push("-d ."),new Promise((d,l)=>{const h=E(process),c=r.spawn(s,u,{cwd:v,env:h});c.on("error",l),c.on("exit",()=>d())})}runInTerminal(r,g,s,v,n){const t="windowsExec"in n&&n.windowsExec?n.windowsExec:b.getDefaultTerminalWindows();return new Promise((u,d)=>{const l=`"${g} - ${I}"`,h=`""${s.join('" "')}" & pause"`,c=["/c","start",l,"/wait",t,"/c",h],_=Object.assign({},E(process),v);Object.keys(_).filter(x=>_[x]===null).forEach(x=>delete _[x]);const A={cwd:g,env:_,windowsVerbatimArguments:!0};m.spawn(b.CMD,c,A).on("error",x=>{d(P(x))}),u(void 0)})}static getDefaultTerminalWindows(){if(!b._DEFAULT_TERMINAL_WINDOWS){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");b._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return b._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=b,b.CMD="cmd.exe";class f extends a{openTerminal(r,g){return this.spawnTerminal(m,r,g)}runInTerminal(r,g,s,v,n){const t=n.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((u,d)=>{if(t===T.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const l=t===T.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",c=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,Y).fsPath,"-t",r||I,"-w",g];for(let R of s)c.push("-a"),c.push(R);if(v){const R=Object.assign({},E(process),v);for(let x in R){const O=R[x];O===null?(c.push("-u"),c.push(x)):(c.push("-e"),c.push(`${x}=${O}`))}}let _="";const A=m.spawn(f.OSASCRIPT,c);A.on("error",R=>{d(P(R))}),A.stderr.on("data",R=>{_+=R.toString()}),A.on("exit",R=>{if(R===0)u(void 0);else if(_){const x=_.split(`
`,1);d(new Error(x[0]))}else d(new Error(y.localize(1,null,l,R)))})}else d(new Error(y.localize(2,null,t)))})}spawnTerminal(r,g,s){const v=g.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((n,t)=>{const u=["-a",v];s&&u.push(s);const d=E(process),l=r.spawn("/usr/bin/open",u,{cwd:s,env:d});l.on("error",t),l.on("exit",()=>n())})}}e.MacExternalTerminalService=f,f.OSASCRIPT="/usr/bin/osascript";class w extends a{openTerminal(r,g){return this.spawnTerminal(m,r,g)}runInTerminal(r,g,s,v,n){const t=n.linuxExec?Promise.resolve(n.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((u,d)=>{let l=[];t.then(h=>{h.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const c=`${p(s)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;l.push(`''${c}''`);const _=Object.assign({},E(process),v);Object.keys(_).filter(O=>_[O]===null).forEach(O=>delete _[O]);const A={cwd:g,env:_};let R="";const x=m.spawn(h,l,A);x.on("error",O=>{d(P(O))}),x.stderr.on("data",O=>{R+=O.toString()}),x.on("exit",O=>{if(O===0)u(void 0);else if(R){const F=R.split(`
`,1);d(new Error(F[0]))}else d(new Error(y.localize(4,null,h,O)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const r=await k.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(g=>{r?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(r,g,s){const v=g.linuxExec?Promise.resolve(g.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((n,t)=>{v.then(u=>{const d=E(process),l=r.spawn(u,[],{cwd:s,env:d});l.on("error",t),l.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=w,w.WAIT_MESSAGE=y.localize(3,null);function E(o){const r={...o.env};return(0,i.sanitizeProcessEnvironment)(r),r}function P(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(y.localize(5,null,o.path)):o}function p(o){let r="";for(let g of o)g.indexOf(" ")>=0?r+='"'+g+'"':r+=g,r+=" ";return r}}),define(ge[42],pe([0,1,24,9,8,13,2,159,4]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function y(M){return M.create===!0}e.isFileOpenForWriteOptions=y;var T;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var I;(function(M){M[M.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var a;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(a=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=b;function f(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=f;function w(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function E(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=E;var P;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(B,U){super(B);this.code=U}}e.FileSystemProviderError=p;function o(M,B){const U=new p(M.toString(),B);return g(U,B),U}e.createFileSystemProviderError=o;function r(M){return M||o((0,k.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=r;function g(M,B){return M.name=B?`${B} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=g;function s(M){if(!M)return P.Unknown;if(M instanceof p)return M.code;const B=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!B)return P.Unknown;switch(B[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=s;function v(M){if(M instanceof h)return M.fileOperationResult;switch(s(M)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=v;var n;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class t{constructor(B,U,z){this.resource=B,this.operation=U,this.target=z}isOperation(B){return this.operation===B}}e.FileOperationEvent=t;var u;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class d{constructor(B,U){this.added=void 0,this.updated=void 0,this.deleted=void 0;const z=new Map;for(const K of B){const N=z.get(K.type);N?N.push([K.resource,K]):z.set(K.type,[[K.resource,K]])}for(const[K,N]of z)switch(K){case 1:this.added=m.TernarySearchTree.forUris(()=>U),this.added.fill(N);break;case 0:this.updated=m.TernarySearchTree.forUris(()=>U),this.updated.fill(N);break;case 2:this.deleted=m.TernarySearchTree.forUris(()=>U),this.deleted.fill(N);break}}contains(B,...U){return this.doContains(B,{includeChildren:!1},...U)}affects(B,...U){return this.doContains(B,{includeChildren:!0},...U)}doContains(B,U,...z){if(!B)return!1;const K=z.length>0;return!!((!K||z.includes(1))&&(this.added?.get(B)||U.includeChildren&&this.added?.findSuperstr(B))||(!K||z.includes(0))&&(this.updated?.get(B)||U.includeChildren&&this.updated?.findSuperstr(B))||(!K||z.includes(2))&&(this.deleted?.findSubstr(B)||U.includeChildren&&this.deleted?.findSuperstr(B)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function l(M,B,U){return!M||!B||M===B||B.length>M.length?!1:(B.charAt(B.length-1)!==L.sep&&(B+=L.sep),U?(0,D.startsWithIgnoreCase)(M,B):M.indexOf(B)===0)}e.isParent=l;class h extends Error{constructor(B,U,z){super(B);this.fileOperationResult=U,this.options=z}}e.FileOperationError=h;class c extends h{constructor(B,U,z){super(B,2,z);this.stat=U}}e.NotModifiedSinceFileOperationError=c;var _;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=R;async function x(M,B){if(!B.hasProvider(i.URI.from({scheme:M.scheme})))return new Promise(U=>{const z=B.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===M.scheme&&K.added&&(z.dispose(),U())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(B){return(0,C.isNumber)(B)||(B=0),B<O.KB?(0,k.localize)(1,null,B.toFixed(0)):B<O.MB?(0,k.localize)(2,null,(B/O.KB).toFixed(2)):B<O.GB?(0,k.localize)(3,null,(B/O.MB).toFixed(2)):B<O.TB?(0,k.localize)(4,null,(B/O.GB).toFixed(2)):(0,k.localize)(5,null,(B/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var F;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function $(M){return{maxFileSize:M===0?300*O.MB:16*O.GB,maxHeapSize:M===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=$}),define(ge[85],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...D){this._entries=new Map;for(let[C,i]of D)this.set(C,i)}set(D,C){const i=this._entries.get(D);return this._entries.set(D,C),i}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=m}),define(ge[186],pe([0,1,18,15,114,179,4,85]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class y extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class T{constructor(f=new k.ServiceCollection,w=!1,E){this._activeInstantiations=new Set,this._services=f,this._strict=w,this._parent=E,this._services.set(i.IInstantiationService,this)}createChild(f){return new T(f,this._strict,this)}invokeFunction(f,...w){let E=a.traceInvocation(f),P=!1;try{return f({get:o=>{if(P)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(o,E);if(!r)throw new Error(`[invokeFunction] unknown service '${o}'`);return r}},...w)}finally{P=!0,E.stop()}}createInstance(f,...w){let E,P;return f instanceof D.SyncDescriptor?(E=a.traceCreation(f.ctor),P=this._createInstance(f.ctor,f.staticArguments.concat(w),E)):(E=a.traceCreation(f),P=this._createInstance(f,w,E)),E.stop(),P}_createInstance(f,w=[],E){let P=i._util.getServiceDependencies(f).sort((r,g)=>r.index-g.index),p=[];for(const r of P){let g=this._getOrCreateServiceInstance(r.id,E);if(!g&&this._strict&&!r.optional)throw new Error(`[createInstance] ${f.name} depends on UNKNOWN service ${r.id}.`);p.push(g)}let o=P.length>0?P[0].index:w.length;if(w.length!==o){console.warn(`[createInstance] First service dependency of ${f.name} at position ${o+1} conflicts with ${w.length} static arguments`);let r=o-w.length;r>0?w=w.concat(new Array(r)):w=w.slice(0,o)}return new f(...[...w,...p])}_setServiceInstance(f,w){if(this._services.get(f)instanceof D.SyncDescriptor)this._services.set(f,w);else if(this._parent)this._parent._setServiceInstance(f,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let w=this._services.get(f);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):w}_getOrCreateServiceInstance(f,w){let E=this._getServiceInstanceOrDescriptor(f);return E instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,E,w.branch(f,!0)):(w.branch(f,!1),E)}_safeCreateAndCacheServiceInstance(f,w,E){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,w,E)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,w,E){const P=new C.Graph(r=>r.id.toString());let p=0;const o=[{id:f,desc:w,_trace:E}];for(;o.length;){const r=o.pop();if(P.lookupOrInsertNode(r),p++>1e3)throw new y(P);for(let g of i._util.getServiceDependencies(r.desc.ctor)){let s=this._getServiceInstanceOrDescriptor(g.id);if(!s&&!g.optional&&console.warn(`[createInstance] ${f} depends on ${g.id} which is NOT registered.`),s instanceof D.SyncDescriptor){const v={id:g.id,desc:s,_trace:r._trace.branch(g.id,!0)};P.insertEdge(r,v),o.push(v)}}}for(;;){const r=P.roots();if(r.length===0){if(!P.isEmpty())throw new y(P);break}for(const{data:g}of r){if(this._getServiceInstanceOrDescriptor(g.id)instanceof D.SyncDescriptor){const v=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,v)}P.removeNode(g)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,w,E=[],P,p){if(this._services.get(f)instanceof D.SyncDescriptor)return this._createServiceInstance(w,E,P,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,w,E,P,p);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(f,w=[],E,P){if(E){const p=new m.IdleValue(()=>this._createInstance(f,w,P));return new Proxy(Object.create(null),{get(o,r){if(r in o)return o[r];let g=p.value,s=g[r];return typeof s!="function"||(s=s.bind(g),o[r]=s),s},set(o,r,g){return p.value[r]=g,!0}})}else return this._createInstance(f,w,P)}}e.InstantiationService=T;var I;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(I||(I={}));class a{constructor(f,w){this.type=f,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return S?new a(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):a._None}static traceCreation(f){return S?new a(0,f.name):a._None}branch(f,w){let E=new a(2,f.toString());return this._dep.push([f,w,E]),E}stop(){let f=Date.now()-this._start;a._totals+=f;let w=!1;function E(p,o){let r=[],g=new Array(p+1).join("	");for(const[s,v,n]of o._dep)if(v&&n){w=!0,r.push(`${g}CREATES -> ${s}`);let t=E(p+1,n);t&&r.push(t)}else r.push(`${g}uses -> ${s}`);return r.join(`
`)}let P=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${a._totals.toFixed(2)}ms)`];(f>2||w)&&console.log(P.join(`
`))}}a._None=new class extends a{constructor(){super(-1,null)}stop(){}branch(){return this}},a._totals=0}),define(ge[11],pe([0,1,50,3,6,12,4]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,i.createDecorator)("logService"),e.ILoggerService=(0,i.createDecorator)("loggerService");function k(){return new Date().toISOString()}var S;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function y(v,n,t){switch(n){case S.Trace:v.trace(t);break;case S.Debug:v.debug(t);break;case S.Info:v.info(t);break;case S.Warning:v.warn(t);break;case S.Error:v.error(t);break;case S.Critical:v.critical(t);break;default:throw new Error("Invalid log level")}}e.log=y;function T(v){let n="";for(let t=0;t<v.length;t++){let u=v[t];if(typeof u=="object")try{u=JSON.stringify(u)}catch(d){}n+=(t>0?" ":"")+u}return n}e.format=T;class I extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class a extends I{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...t){this.checkLogLevel(S.Trace)&&this.log(S.Trace,T([n,...t]))}debug(n,...t){this.checkLogLevel(S.Debug)&&this.log(S.Debug,T([n,...t]))}info(n,...t){this.checkLogLevel(S.Info)&&this.log(S.Info,T([n,...t]))}warn(n,...t){this.checkLogLevel(S.Warning)&&this.log(S.Warning,T([n,...t]))}error(n,...t){if(this.checkLogLevel(S.Error))if(n instanceof Error){const u=Array.prototype.slice.call(arguments);u[0]=n.stack,this.log(S.Error,T(u))}else this.log(S.Error,T([n,...t]))}critical(n,...t){this.checkLogLevel(S.Critical)&&this.log(S.Critical,T([n,...t]))}flush(){}}e.AbstractMessageLogger=a;class b extends I{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!C.isWindows}trace(n,...t){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...t):console.log(`[main ${k()}]`,n,...t))}debug(n,...t){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...t):console.log(`[main ${k()}]`,n,...t))}info(n,...t){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...t):console.log(`[main ${k()}]`,n,...t))}warn(n,...t){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,n,...t):console.warn(`[main ${k()}]`,n,...t))}error(n,...t){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,n,...t):console.error(`[main ${k()}]`,n,...t))}critical(n,...t){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,n,...t):console.error(`[main ${k()}]`,n,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class f extends I{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...t){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",n,...t)}debug(n,...t){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...t)}info(n,...t){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",n,...t)}warn(n,...t){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",n,...t)}error(n,...t){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",n,...t)}critical(n,...t){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...t)}dispose(){}flush(){}}e.ConsoleLogger=f;class w extends I{constructor(n,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(t)}trace(n,...t){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(n),...t])}debug(n,...t){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(n),...t])}info(n,...t){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(n),...t])}warn(n,...t){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(n),...t])}error(n,...t){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(n),...t])}critical(n,...t){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(n),...t])}extractMessage(n){return typeof n=="string"?n:(0,m.toErrorMessage)(n,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class E extends I{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const t of this.logServices)t.setLevel(n);super.setLevel(n)}trace(n,...t){for(const u of this.logServices)u.trace(n,...t)}debug(n,...t){for(const u of this.logServices)u.debug(n,...t)}info(n,...t){for(const u of this.logServices)u.info(n,...t)}warn(n,...t){for(const u of this.logServices)u.warn(n,...t)}error(n,...t){for(const u of this.logServices)u.error(n,...t)}critical(n,...t){for(const u of this.logServices)u.critical(n,...t)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=E;class P extends D.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...t){this.logger.trace(n,...t)}debug(n,...t){this.logger.debug(n,...t)}info(n,...t){this.logger.info(n,...t)}warn(n,...t){this.logger.warn(n,...t)}error(n,...t){this.logger.error(n,...t)}critical(n,...t){this.logger.critical(n,...t)}flush(){this.logger.flush()}}e.LogService=P;class p extends D.Disposable{constructor(n,t){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(u=>{this.logLevel=u,this.logLevelChangeableLoggers.forEach(d=>d.setLevel(u))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,t){let u=this.loggers.get(n.toString());return u||(u=this.doCreateLogger(n,t?.always?S.Trace:this.logLevel,t),this.loggers.set(n.toString(),u),t?.always||this.logLevelChangeableLoggers.push(u)),u}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class o{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(n){}getLevel(){return S.Info}trace(n,...t){}debug(n,...t){}info(n,...t){}warn(n,...t){}error(n,...t){}critical(n,...t){}dispose(){}flush(){}}e.NullLogService=o;function r(v){if(v.verbose)return S.Trace;if(typeof v.logLevel=="string"){const n=g(v.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function g(v){switch(v){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=g;function s(v){switch(v){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=s}),define(ge[187],pe([0,1,42,11]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(k,S,y,T,I){try{const a=await new Promise((f,w)=>{Y(["spdlog"],f,w)});a.setFlushOn(L.LogLevel.Trace);const b=await a.createAsyncRotatingLogger(k,S,y,T);return I&&b.clearFormatters(),b}catch(a){console.error(a)}return null}function C(k,S,y){switch(S){case L.LogLevel.Trace:k.trace(y);break;case L.LogLevel.Debug:k.debug(y);break;case L.LogLevel.Info:k.info(y);break;case L.LogLevel.Warning:k.warn(y);break;case L.LogLevel.Error:k.error(y);break;case L.LogLevel.Critical:k.critical(y);break;default:throw new Error("Invalid log level")}}class i extends L.AbstractMessageLogger{constructor(S,y,T,I,a){super();this.buffer=[],this.setLevel(a),this._loggerCreationPromise=this._createSpdLogLogger(S,y,T,I),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}async _createSpdLogLogger(S,y,T,I){const a=T?6:1,b=30/a*m.ByteSize.MB,f=await D(S,y,b,a,I);if(f){this._logger=f,this._logger.setLevel(this.getLevel());for(const{level:w,message:E}of this.buffer)C(this._logger,w,E);this.buffer=[]}}log(S,y){this._logger?C(this._logger,S,y):this.getLevel()<=S&&this.buffer.push({level:S,message:y})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=i}),define(ge[116],pe([0,1,48,160,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var i;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(i=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function y(f,w){return w-f}S.compare=y;const T=Object.create(null);T[S.Error]=(0,L.localize)(0,null),T[S.Warning]=(0,L.localize)(1,null),T[S.Info]=(0,L.localize)(2,null);function I(f){return T[f]||""}S.toString=I;function a(f){switch(f){case m.default.Error:return S.Error;case m.default.Warning:return S.Warning;case m.default.Info:return S.Info;case m.default.Ignore:return S.Hint}}S.fromSeverity=a;function b(f){switch(f){case S.Error:return m.default.Error;case S.Warning:return m.default.Warning;case S.Info:return m.default.Info;case S.Hint:return m.default.Ignore}}S.toSeverity=b}(i=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(S){const y="";function T(a){return I(a,!0)}S.makeKey=T;function I(a,b){let f=[y];return a.source?f.push(a.source.replace("\xA6","\\\xA6")):f.push(y),a.code?typeof a.code=="string"?f.push(a.code.replace("\xA6","\\\xA6")):f.push(a.code.value.replace("\xA6","\\\xA6")):f.push(y),a.severity!==void 0&&a.severity!==null?f.push(i.toString(a.severity)):f.push(y),a.message&&b?f.push(a.message.replace("\xA6","\\\xA6")):f.push(y),a.startLineNumber!==void 0&&a.startLineNumber!==null?f.push(a.startLineNumber.toString()):f.push(y),a.startColumn!==void 0&&a.startColumn!==null?f.push(a.startColumn.toString()):f.push(y),a.endLineNumber!==void 0&&a.endLineNumber!==null?f.push(a.endLineNumber.toString()):f.push(y),a.endColumn!==void 0&&a.endColumn!==null?f.push(a.endColumn.toString()):f.push(y),f.push(y),f.join("\xA6")}S.makeKeyOptionalMessage=I})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(ge[188],pe([0,1,3,48,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,D.createDecorator)("notificationService");var C;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var i;(function(y){y[y.OFF=0]="OFF",y[y.SILENT=1]="SILENT",y[y.ERROR=2]="ERROR"})(i=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new S,this.onDidClose=m.Event.None,this.onDidChangeVisibility=m.Event.None}updateSeverity(T){}updateMessage(T){}updateActions(T){}close(){}}e.NoOpNotification=k;class S{infinite(){}done(){}total(T){}worked(T){}}e.NoOpProgress=S}),define(ge[189],pe([0,1,6,8,2,4]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(S){return{resolved:S,dispose(){}}}});function i(S,y){return D.URI.isUri(S)?(0,L.equalsIgnoreCase)(S.scheme,y):(0,L.startsWithIgnoreCase)(S,y+":")}e.matchesScheme=i;function k(S,...y){return y.some(T=>i(S,T))}e.matchesSomeScheme=k}),define(ge[190],pe([0,1,10,12,40,23]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let i;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const k=L.globals.vscode.context.configuration();if(k)i=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const k=(0,C.dirname)(m.FileAccess.asFileUri("",Y));i=Y.__$__nodeRequire((0,C.joinPath)(k,"product.json").fsPath);const S=Y.__$__nodeRequire((0,C.joinPath)(k,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(i,{nameShort:`${i.nameShort} Dev`,nameLong:`${i.nameLong} Dev`,dataFolderName:`${i.dataFolderName}-dev`}),Object.assign(i,{version:S.version})}else i={},Object.keys(i).length===0&&Object.assign(i,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=i});var He=this&&this.__param||function(Y,e){return function(m,L){e(m,L,Y)}};define(ge[117],pe([0,1,18,21,6,4]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var i;(function(T){T[T.Explorer=1]="Explorer",T[T.Scm=3]="Scm",T[T.Extensions=5]="Extensions",T[T.Window=10]="Window",T[T.Notification=15]="Notification",T[T.Dialog=20]="Dialog"})(i=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let S=class extends D.Disposable{constructor(I,a){super();this.deferred=new m.DeferredPromise,a.withProgress(I,b=>(this.reporter=b,this.lastStep&&b.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};S=Ve([He(1,e.IProgressService)],S),e.UnmanagedProgress=S;class y extends D.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(I){this.stop();const a=++this.currentOperationId,b=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{a===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>b.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:a,token:b.token,stop:()=>this.doStop(a),isCurrent:()=>this.currentOperationId===a}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=y,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(ge[51],pe([0,1,56,13]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(i,k){m.ok(L.isString(i)),m.ok(L.isObject(k)),m.ok(!this.data.has(i),"There is already an extension with this id"),this.data.set(i,k)}knows(i){return this.data.has(i)}as(i){return this.data.get(i)||null}}e.Registry=new D}),define(ge[191],pe([0,1,3,51]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class C{constructor(){this._onDidChangeSchema=new m.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,y){this.schemasById[D(S)]=y,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const i=new C;L.Registry.add(e.Extensions.JSONContribution,i)}),define(ge[118],pe([0,1,17,3,13,155,191,51]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(r){r.Multiline="multilineText",r.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.MACHINE=2]="MACHINE",r[r.WINDOW=3]="WINDOW",r[r.RESOURCE=4]="RESOURCE",r[r.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",r[r.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const T=k.Registry.as(i.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(g,s=!0){this.registerConfigurations([g],s)}registerConfigurations(g,s=!0){const v=this.doRegisterConfigurations(g,s);T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:v})}deregisterConfigurations(g){const s=this.doDeregisterConfigurations(g);T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:g,remove:s}){const v=[];v.push(...this.doDeregisterConfigurations(s)),v.push(...this.doRegisterConfigurations(g,!1)),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,m.distinct)(v)})}registerDefaultConfigurations(g){const s=[],v=[];for(const n of g)for(const t in n)if(s.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){this.configurationDefaultsOverrides[t]={...this.configurationDefaultsOverrides[t]||{},...n[t]};const u={type:"object",default:this.configurationDefaultsOverrides[t],description:C.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};v.push(...f(t)),this.configurationProperties[t]=u,this.defaultLanguageConfigurationOverridesNode.properties[t]=u}else{this.configurationDefaultsOverrides[t]=n[t];const u=this.configurationProperties[t];u&&(this.updatePropertyDefaultValue(t,u),this.updateSchema(t,u))}this.registerOverrideIdentifiers(v),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(g){const s=[];for(const v of g)for(const n in v)if(s.push(n),delete this.configurationDefaultsOverrides[n],e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const t=this.configurationProperties[n];t&&(this.updatePropertyDefaultValue(n,t),this.updateSchema(n,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...g){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(g){for(const s of g)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(g,s){const v=[];return g.forEach(n=>{v.push(...this.validateAndRegisterProperties(n,s,n.extensionInfo)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),v}doDeregisterConfigurations(g){const s=[],v=n=>{if(n.properties)for(const t in n.properties)s.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,n.properties[t]);n.allOf&&n.allOf.forEach(t=>v(t))};for(const n of g){v(n);const t=this.configurationContributors.indexOf(n);t!==-1&&this.configurationContributors.splice(t,1)}return s}validateAndRegisterProperties(g,s=!0,v,n=3){n=D.isUndefinedOrNull(g.scope)?n:g.scope;let t=[],u=g.properties;if(u)for(let l in u){if(s&&p(l)){delete u[l];continue}const h=u[l];if(this.updatePropertyDefaultValue(l,h),e.OVERRIDE_PROPERTY_REGEX.test(l)?h.scope=void 0:(h.scope=D.isUndefinedOrNull(h.scope)?n:h.scope,h.restricted=D.isUndefinedOrNull(h.restricted)?!!v?.restrictedConfigurations?.includes(l):h.restricted),u[l].hasOwnProperty("included")&&!u[l].included){this.excludedConfigurationProperties[l]=u[l],delete u[l];continue}else this.configurationProperties[l]=u[l];!u[l].deprecationMessage&&u[l].markdownDeprecationMessage&&(u[l].deprecationMessage=u[l].markdownDeprecationMessage),t.push(l)}let d=g.allOf;if(d)for(let l of d)t.push(...this.validateAndRegisterProperties(l,s,v,n));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(g){const s=v=>{let n=v.properties;if(n)for(const u in n)this.updateSchema(u,n[u]);let t=v.allOf;t&&t.forEach(s)};s(g)}updateSchema(g,s){switch(e.allSettings.properties[g]=s,s.scope){case 1:e.applicationSettings.properties[g]=s;break;case 2:e.machineSettings.properties[g]=s;break;case 6:e.machineOverridableSettings.properties[g]=s;break;case 3:e.windowSettings.properties[g]=s;break;case 4:e.resourceSettings.properties[g]=s;break;case 5:e.resourceSettings.properties[g]=s,this.resourceLanguageSettingsSchema.properties[g]=s;break}}removeFromSchema(g,s){switch(delete e.allSettings.properties[g],s.scope){case 1:delete e.applicationSettings.properties[g];break;case 2:delete e.machineSettings.properties[g];break;case 6:delete e.machineOverridableSettings.properties[g];break;case 3:delete e.windowSettings.properties[g];break;case 4:case 5:delete e.resourceSettings.properties[g],delete this.resourceLanguageSettingsSchema.properties[g];break}}updateOverridePropertyPatternKey(){for(const g of this.overrideIdentifiers.values()){const s=`[${g}]`,v={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,v),e.allSettings.properties[s]=v,e.applicationSettings.properties[s]=v,e.machineSettings.properties[s]=v,e.machineOverridableSettings.properties[s]=v,e.windowSettings.properties[s]=v,e.resourceSettings.properties[s]=v}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const g={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(g,s){let v=this.configurationDefaultsOverrides[g];D.isUndefined(v)&&(v=s.default),D.isUndefined(v)&&(v=E(s.type)),s.default=v}}const a="\\[([^\\]]+)\\]",b=new RegExp(a,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${a})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function f(r){const g=[];if(e.OVERRIDE_PROPERTY_REGEX.test(r)){let s=b.exec(r);for(;s?.length;){const v=s[1].trim();v&&g.push(v),s=b.exec(r)}}return(0,m.distinct)(g)}e.overrideIdentifiersFromKey=f;function w(r){return r.reduce((g,s)=>`${g}[${s}]`,"")}e.keyFromOverrideIdentifiers=w;function E(r){switch(Array.isArray(r)?r[0]:r){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=E;const P=new I;k.Registry.add(e.Extensions.Configuration,P);function p(r){return r.trim()?e.OVERRIDE_PROPERTY_REGEX.test(r)?C.localize(7,null,r):P.getConfigurationProperties()[r]!==void 0?C.localize(8,null,r):null:C.localize(6,null)}e.validateProperty=p;function o(){const r=[],g=P.getConfigurationProperties();for(const s of Object.keys(g))r.push([s,g[s].scope]);return r.push(["launch",4]),r.push(["task",4]),r}e.getScopes=o}),define(ge[192],pe([0,1,17,3,58,6,24,25,13,2,115,118,51]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(n={},t=[],u=[]){this._contents=n,this._keys=t,this._overrides=u,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,T.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const u=this.getContentsForOverrideIdentifer(t);return u?n?(0,T.getConfigurationValue)(u,n):u:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const u of this.overrides)u.identifiers.includes(n)&&t.push(...u.keys);return m.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return m.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=k.deepClone(this.contents),u=k.deepClone(this.overrides),d=[...this.keys];for(const l of n){this.mergeContents(t,l.contents);for(const h of l.overrides){const[c]=u.filter(_=>m.equals(_.identifiers,h.identifiers));c?(this.mergeContents(c.contents,h.contents),c.keys.push(...h.keys),c.keys=m.distinct(c.keys)):u.push(k.deepClone(h))}for(const h of l.keys)d.indexOf(h)===-1&&d.push(h)}return new b(t,d,u)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let u={};for(const d of m.distinct([...Object.keys(this.contents),...Object.keys(t)])){let l=this.contents[d],h=t[d];h&&(typeof l=="object"&&typeof h=="object"?(l=k.deepClone(l),this.mergeContents(l,h)):l=h),u[d]=l}return new b(u,this.keys,this.overrides)}mergeContents(n,t){for(const u of Object.keys(t)){if(u in n&&S.isObject(n[u])&&S.isObject(t[u])){this.mergeContents(n[u],t[u]);continue}n[u]=k.deepClone(t[u])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?k.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,u=null;const d=l=>{l&&(u?this.mergeContents(u,l):u=k.deepClone(l))};for(const l of this.overrides)m.equals(l.identifiers,[n])?t=l.contents:l.identifiers.includes(n)&&d(l.contents);return d(t),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,T.addToValueTree)(this.contents,n,t,u=>{throw new Error(u)})}removeValue(n){this.removeKey(n)&&(0,T.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let u=0;u<t;u++)n.indexOf(this.keys[u])===0&&(t=u);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=b;class f extends b{constructor(n={}){const t=a.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(t),d=Object.create(null),l=[];for(const h in t){const c=n[h],_=c!==void 0?c:t[h].default;(0,T.addToValueTree)(d,h,_,A=>console.error(`Conflict in default settings: ${A}`))}for(const h of Object.keys(d))I.OVERRIDE_PROPERTY_REGEX.test(h)&&l.push({identifiers:(0,I.overrideIdentifiersFromKey)(h),keys:Object.keys(d[h]),contents:(0,T.toValuesTree)(d[h],c=>console.error(`Conflict in default settings file: ${c}`))});super(d,u,l)}}e.DefaultConfigurationModel=f;class w{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!S.isUndefinedOrNull(n)){const u=this.doParseContent(n);this.parseRaw(u,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:u,keys:d,overrides:l,restricted:h}=this.doParseRaw(n,t);this._configurationModel=new b(u,d,l),this._restrictedConfigurations=h||[]}doParseContent(n){let t={},u=null,d=[],l=[],h=[];function c(A){Array.isArray(d)?d.push(A):u!==null&&(d[u]=A)}let _={onObjectBegin:()=>{let A={};c(A),l.push(d),d=A,u=null},onObjectProperty:A=>{u=A},onObjectEnd:()=>{d=l.pop()},onArrayBegin:()=>{let A=[];c(A),l.push(d),d=A,u=null},onArrayEnd:()=>{d=l.pop()},onLiteralValue:c,onError:(A,R,x)=>{h.push({error:A,offset:R,length:x})}};if(n)try{D.visit(n,_),t=d[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return t}doParseRaw(n,t){const u=a.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),d=this.filter(n,u,!0,t);n=d.raw;const l=(0,T.toValuesTree)(n,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),h=Object.keys(n),c=this.toOverrides(n,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:l,keys:h,overrides:c,restricted:d.restricted}}filter(n,t,u,d){if(!d?.scopes&&!d?.skipRestricted)return{raw:n,restricted:[]};const l={},h=[];for(let c in n)if(I.OVERRIDE_PROPERTY_REGEX.test(c)&&u){const _=this.filter(n[c],t,!1,d);l[c]=_.raw,h.push(..._.restricted)}else{const _=t[c],A=_?typeof _.scope!="undefined"?_.scope:3:void 0;_?.restricted&&h.push(c),(A===void 0||d.scopes===void 0||d.scopes.includes(A))&&(d.skipRestricted&&_?.restricted||(l[c]=n[c]))}return{raw:l,restricted:h}}toOverrides(n,t){const u=[];for(const d of Object.keys(n))if(I.OVERRIDE_PROPERTY_REGEX.test(d)){const l={};for(const h in n[d])l[h]=n[d][h];u.push({identifiers:(0,I.overrideIdentifiersFromKey)(d),keys:Object.keys(l),contents:(0,T.toValuesTree)(l,t)})}return u}}e.ConfigurationModelParser=w;class E extends C.Disposable{constructor(n,t,u,d){super();this.userSettingsResource=n,this.scopes=t,this.fileService=d,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(u.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class P{constructor(n,t,u=new b,d=new b,l=new i.ResourceMap,h=new b,c=new i.ResourceMap,_=!0){this._defaultConfiguration=n,this._localUserConfiguration=t,this._remoteUserConfiguration=u,this._workspaceConfiguration=d,this._folderConfigurations=l,this._memoryConfiguration=h,this._memoryConfigurationByResource=c,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new i.ResourceMap,this._userConfiguration=null}getValue(n,t,u){return this.getConsolidateConfigurationModel(t,u).getValue(n)}updateValue(n,t,u={}){let d;u.resource?(d=this._memoryConfigurationByResource.get(u.resource),d||(d=new b,this._memoryConfigurationByResource.set(u.resource,d))):d=this._memoryConfiguration,t===void 0?d.removeValue(n):d.setValue(n,t),u.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,u){const d=this.getConsolidateConfigurationModel(t,u),l=this.getFolderConfigurationModelForResource(t.resource,u),h=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,c=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),_=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),A=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),R=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),x=u?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,O=l?t.overrideIdentifier?l.freeze().override(t.overrideIdentifier).getValue(n):l.freeze().getValue(n):void 0,F=t.overrideIdentifier?h.override(t.overrideIdentifier).getValue(n):h.getValue(n),$=d.getValue(n),M=m.distinct(m.flatten(d.overrides.map(B=>B.identifiers))).filter(B=>d.getOverrideValue(n,B)!==void 0);return{defaultValue:c,userValue:_,userLocalValue:A,userRemoteValue:R,workspaceValue:x,workspaceFolderValue:O,memoryValue:F,value:$,default:c!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:R!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:x!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:l?.freeze().getValue(n),override:t.overrideIdentifier?l?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:h.getValue(n),override:t.overrideIdentifier?h.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:M.length?M:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n){const{added:t,updated:u,removed:d,overrides:l}=g(this._defaultConfiguration,n),h=[...t,...u,...d];return h.length&&this.updateDefaultConfiguration(n),{keys:h,overrides:l}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:u,removed:d,overrides:l}=g(this.localUserConfiguration,n),h=[...t,...u,...d];return h.length&&this.updateLocalUserConfiguration(n),{keys:h,overrides:l}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:u,removed:d,overrides:l}=g(this.remoteUserConfiguration,n);let h=[...t,...u,...d];return h.length&&this.updateRemoteUserConfiguration(n),{keys:h,overrides:l}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:u,removed:d,overrides:l}=g(this.workspaceConfiguration,n);let h=[...t,...u,...d];return h.length&&this.updateWorkspaceConfiguration(n),{keys:h,overrides:l}}compareAndUpdateFolderConfiguration(n,t){const u=this.folderConfigurations.get(n),{added:d,updated:l,removed:h,overrides:c}=g(u,t);let _=[...d,...l,...h];return(_.length||!u)&&this.updateFolderConfiguration(n,t),{keys:_,overrides:c}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:u,updated:d,removed:l,overrides:h}=g(t,void 0);return{keys:[...u,...d,...l],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,t){let u=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier?u.override(n.overrideIdentifier):u}getConsolidatedConfigurationModelForResource({resource:n},t){let u=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const d=t.getFolder(n);d&&(u=this.getFolderConsolidatedConfiguration(d.uri)||u);const l=this._memoryConfigurationByResource.get(n);l&&(u=u.merge(l))}return u}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const u=this.getWorkspaceConsolidatedConfiguration(),d=this._folderConfigurations.get(n);d?(t=u.merge(d),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=u}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const u=t.getFolder(n);if(u)return this._folderConfigurations.get(u.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:u,overrides:d,keys:l}=this._folderConfigurations.get(t);return n.push([t,{contents:u,overrides:d,keys:l}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(u=>n.add(u))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(u=>n.add(u))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(u=>t.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(u=>t.add(u)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(u=>t.add(u)),this._folderConfigurations.forEach(u=>u.getKeysForOverrideIdentifier(n).forEach(d=>t.add(d))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),u=this.parseConfigurationModel(n.user),d=this.parseConfigurationModel(n.workspace),l=n.folders.reduce((h,c)=>(h.set(y.URI.revive(c[0]),this.parseConfigurationModel(c[1])),h),new i.ResourceMap);return new P(t,u,new b,d,l,new b,new i.ResourceMap,!1)}static parseConfigurationModel(n){return new b(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=P;function p(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const n=new Set,t=new Map;for(const d of v)d.keys.forEach(l=>n.add(l)),d.overrides.forEach(([l,h])=>{const c=(0,i.getOrSet)(t,l,new Set);h.forEach(_=>c.add(_))});const u=[];return t.forEach((d,l)=>u.push([l,[...d.values()]])),{keys:[...n.values()],overrides:u}}e.mergeChanges=p;class o{constructor(n,t,u,d){this.change=n,this.previous=t,this.currentConfiguraiton=u,this.currentWorkspace=d,this._previousConfiguration=void 0;const l=new Set;n.keys.forEach(c=>l.add(c)),n.overrides.forEach(([,c])=>c.forEach(_=>l.add(_))),this.affectedKeys=[...l.values()];const h=new b;this.affectedKeys.forEach(c=>h.setValue(c,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=P.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const u=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,d=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!k.equals(u,d)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let u=(0,T.toValuesTree)({[t]:!0},()=>{}),d;for(;typeof u=="object"&&(d=Object.keys(u)[0]);){if(n=n[d],!n)return!1;u=u[d]}return!0}}e.ConfigurationChangeEvent=o;class r extends o{constructor(n,t,u,d){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=u,this.sourceConfig=d}}e.AllKeysConfigurationChangeEvent=r;function g(v,n){const{added:t,removed:u,updated:d}=s(n,v),l=[],h=v?.getAllOverrideIdentifiers()||[],c=n?.getAllOverrideIdentifiers()||[];if(n){const _=c.filter(A=>!h.includes(A));for(const A of _)l.push([A,n.getKeysForOverrideIdentifier(A)])}if(v){const _=h.filter(A=>!c.includes(A));for(const A of _)l.push([A,v.getKeysForOverrideIdentifier(A)])}if(n&&v){for(const _ of h)if(c.includes(_)){const A=s({contents:v.getOverrideValue(void 0,_)||{},keys:v.getKeysForOverrideIdentifier(_)},{contents:n.getOverrideValue(void 0,_)||{},keys:n.getKeysForOverrideIdentifier(_)});l.push([_,[...A.added,...A.removed,...A.updated]])}}return{added:t,removed:u,updated:d,overrides:l}}function s(v,n){const t=v?n?v.keys.filter(l=>n.keys.indexOf(l)===-1):[...v.keys]:[],u=n?v?n.keys.filter(l=>v.keys.indexOf(l)===-1):[...n.keys]:[],d=[];if(v&&n){for(const l of n.keys)if(v.keys.indexOf(l)!==-1){const h=(0,T.getConfigurationValue)(n.contents,l),c=(0,T.getConfigurationValue)(v.contents,l);k.equals(h,c)||d.push(l)}}return{added:t,removed:u,updated:d}}}),define(ge[119],pe([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var L;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(i,k=L.Unknown,S){super(i);this._message=i,this._code=k,this._detail=S,this.isHandled=k===L.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(i){return i instanceof D&&i._code===L.TemporarilyNotAvailable}static isNoResolverFound(i){return i instanceof D&&i._code===L.NoResolverFound}static isHandled(i){return i instanceof D&&i.isHandled}}e.RemoteAuthorityResolverError=D}),define(ge[62],pe([0,1,10]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(y){return y.scheme===m.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=L;function D(y){if(!y)return;const T=y.indexOf("+");return T<0?y:y.substr(0,T)}e.getRemoteName=D;function C(y){return y.scheme!==m.Schemas.file&&y.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=C;function i(y){if(y.folders.length)return y.folders.every(T=>C(T.uri))?y.folders[0].uri:void 0;if(y.configuration&&C(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=i;function k(y){return i(y)?.scheme}e.getVirtualWorkspaceScheme=k;function S(y){return i(y)!==void 0}e.isVirtualWorkspace=S}),define(ge[27],pe([0,1,8,4,62]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.getWorkspaceSupportTypeMessage=C;function i(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=i,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class S{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,f){if(typeof b=="undefined"||b===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof b=="string"||typeof f=="string"){let w=typeof b=="string"?b:b.value,E=typeof f=="string"?f:f.value;return m.equalsIgnoreCase(w,E)}return b._lower===f._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=S;function y(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function T(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=T;function I(a,b){if(b){const f=`onResolveRemoteAuthority:${(0,D.getRemoteName)(b)}`;return a.activationEvents?.indexOf(f)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(ge[193],pe([0,1,8,27]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(f,w){return f.uuid&&w.uuid?f.uuid===w.uuid:f.id===w.id?!0:(0,m.compareIgnoreCase)(f.id,w.id)===0}e.areSameExtensions=D;class C{constructor(w,E){this.version=E,this.id=w.id,this.uuid=w.uuid}key(){return`${this.id}-${this.version}`}equals(w){return w instanceof C?D(this,w)&&this.version===w.version:!1}}e.ExtensionIdentifierWithVersion=C;function i(f,w){return`${f}.${w}`}e.getExtensionId=i;function k(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function S(f,w){return k(i(f,w))}e.getGalleryExtensionId=S;function y(f,w){const E=[],P=p=>{for(const o of E)if(o.some(r=>D(w(r),w(p))))return o;return null};for(const p of f){const o=P(p);o?o.push(p):E.push([p])}return E}e.groupByExtension=y;function T(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=T;function I(f){return{id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),...f.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function a(f){const w=new Set;for(const E of f)E.malicious&&w.add(E.id.id);return w}e.getMaliciousExtensionsSet=a;function b(f,w){const E=[],P=w.manifest.extensionDependencies?.slice(0)??[];for(;P.length;){const p=P.shift();if(p&&E.every(o=>!D(o.identifier,{id:p}))){const o=f.filter(r=>D(r.identifier,{id:p}));o.length===1&&(E.push(o[0]),P.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.getExtensionDependencies=b}),define(ge[120],pe([0,1,3,12,4,11]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var i;(function(f){f.Http="http",f.Https="https"})(i=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function y(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=y,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function T(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=T,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=I;function a(f,w){return w?w!==1&&f<1024:!L.isWindows&&f<1024}e.isPortPrivileged=a;let b=class{constructor(w){this.logService=w,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w,E){return this._tunnelProvider=w,w?(this._canElevate=E.elevation,this._privacyOptions=E.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],E=Array.from(this._tunnels.values());for(let P of E){const p=Array.from(P.values());for(let o of p){const r=await o.value;r&&w.push(r)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:E}of w.values())await E.then(P=>P?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,E,P,p,o=!1,r=k.Private,g){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${E}:${P} on local port ${p}.`),!w)return;E||(E="localhost");const s=this.retainOrCreateTunnel(w,E,P,p,o,r,g);return s?s.then(v=>{if(!v){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(E,P);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(v);return(v.tunnelRemoteHost!==E||v.tunnelRemotePort!==P)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const E=this._tunnels.get(w.tunnelRemoteHost);if(E){const P=E.get(w.tunnelRemotePort);P&&(P.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,P))}}}}async tryDisposeTunnel(w,E,P){if(P.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${E}.`);const p=P.value.then(async o=>{o&&(await o.dispose(!0),this._onTunnelClosed.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(E),p}}async closeTunnel(w,E){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${E} `);const P=this._tunnels.get(w);if(P&&P.has(E)){const p=P.get(E);p.refcount=0,await this.tryDisposeTunnel(w,E,p)}}addTunnelToMap(w,E,P){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(E,{refcount:1,value:P})}async removeEmptyTunnelFromMap(w,E){const P=this._tunnels.get(w);P&&(await P.get(E)||P.delete(E),P.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,E){let P=[w];T(w)?(P.push(...e.LOCALHOST_ADDRESSES),P.push(...e.ALL_INTERFACES_ADDRESSES)):I(w)&&P.push(...e.ALL_INTERFACES_ADDRESSES);const p=P.map(o=>this._tunnels.get(o));for(const o of p){const r=o?.get(E);if(r)return r}}canTunnel(w){return!!y(w)}createWithProvider(w,E,P,p,o,r,g){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${E}:${P} on local port ${p}.`);const v={elevationRequired:o?a(p===void 0?P:p):!1},n={remoteAddress:{host:E,port:P},localAddressPort:p,privacy:r,public:r!==k.Private,protocol:g},t=w.forwardPort(n,v);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(E,P,t),t}};b=Ve([He(0,C.ILogService)],b),e.AbstractTunnelService=b}),define(ge[194],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{constructor(){this.validators=new Map}vsda(){return new Promise((D,C)=>Y(["vsda"],D,C))}async createNewMessage(D){try{const C=await this.vsda(),i=new C.validator;if(i){const k=String(m._nextId++);return this.validators.set(k,i),{id:k,data:i.createNewMessage(D)}}}catch(C){}return{id:"",data:D}}async validate(D,C){if(!D.id)return!0;const i=this.validators.get(D.id);if(!i)return!1;this.validators.delete(D.id);try{return i.validate(C)==="ok"}catch(k){return!1}}async sign(D){try{const C=await this.vsda(),i=new C.signer;if(i)return i.sign(D)}catch(C){}return D}}e.SignService=m,m._nextId=1}),define(ge[195],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,C,i=5){let k;return k=C(S=>{const y=typeof S=="string"?S:S.data;let T=this._terminalBufferMap.get(D);if(T){T.data.push(y);return}const I=setTimeout(()=>this.flushBuffer(D),i);T={data:[y],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(D),k.dispose()}},this._terminalBufferMap.set(D,T)}),k}stopBuffering(D){const C=this._terminalBufferMap.get(D);C&&C.dispose()}flushBuffer(D){const C=this._terminalBufferMap.get(D);C&&(this._terminalBufferMap.delete(D),this._callback(D,C.data.join("")))}}e.TerminalDataBufferer=m}),define(ge[196],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(ge[86],pe([0,1,78,3,6,4,51,196]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var S;(function(E){function P(p){return p&&typeof p=="object"&&typeof p.id=="string"}E.isThemeColor=P})(S=e.ThemeColor||(e.ThemeColor={}));function y(E){return{id:E}}e.themeColorFromId=y;var T;(function(E){function P(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||S.isThemeColor(n.color))}E.isThemeIcon=P;const p=new RegExp(`^\\$\\((${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?)\\)$`);function o(n){const t=p.exec(n);if(!t)return;let[,u]=t;return{id:u}}E.fromString=o;function r(n,t){let u=n.id;const d=u.lastIndexOf("~");return d!==-1&&(u=u.substring(0,d)),t&&(u=`${u}~${t}`),{id:u}}E.modify=r;function g(n){const t=n.id.lastIndexOf("~");if(t!==-1)return n.id.substring(t+1)}E.getModifier=g;function s(n,t){return n.id===t.id&&n.color?.id===t.color?.id}E.isEqual=s;function v(n,t){return{id:n.id,color:t?y(t):void 0}}E.asThemeIcon=v,E.asClassNameArray=m.CSSIcon.asClassNameArray,E.asClassName=m.CSSIcon.asClassName,E.asCSSSelector=m.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=m.Codicon.file,e.FolderThemeIcon=m.Codicon.folder;function I(E){switch(E){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class a{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(P){return this.themingParticipants.push(P),this.onThemingParticipantAddedEmitter.fire(P),(0,D.toDisposable)(()=>{const p=this.themingParticipants.indexOf(P);this.themingParticipants.splice(p,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new a;i.Registry.add(e.Extensions.ThemingContribution,b);function f(E){return b.onColorThemeChange(E)}e.registerThemingParticipant=f;class w extends D.Disposable{constructor(P){super();this.themeService=P,this.theme=P.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(p=>this.onThemeChange(p)))}onThemeChange(P){this.theme=P,this.updateStyles()}updateStyles(){}getColor(P,p){let o=this.theme.getColor(P);return o&&p&&(o=p(o,this.theme)),o?o.toString():null}}e.Themable=w}),define(ge[43],pe([0,1,24,23,2,4]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var i;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(i=e.WorkbenchState||(e.WorkbenchState={}));function k(a){const b=a;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.isWorkspace=k;function S(a){const b=a;return!!(b&&typeof b=="object"&&D.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.isWorkspaceFolder=S;class y{constructor(b,f,w,E,P){this._id=b,this._transient=w,this._configuration=E,this._ignorePathCasing=P,this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=f}update(b){this._id=b.id,this._configuration=b.configuration,this._transient=b.transient,this._ignorePathCasing=b._ignorePathCasing,this.folders=b.folders}get folders(){return this._folders}set folders(b){this._folders=b,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(b){this._configuration=b}getFolder(b){return b&&this._foldersMap.findSubstr(b.with({scheme:b.scheme,authority:b.authority,path:b.path}))||null}updateFoldersMap(){this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing);for(const b of this.folders)this._foldersMap.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=y;class T{constructor(b,f){this.raw=f,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,L.joinPath)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=T;function I(a){return new T({uri:a,index:0,name:(0,L.basenameOrAuthority)(a)},{uri:a.toString()})}e.toWorkspaceFolder=I}),define(ge[197],pe([0,1,30,58,139,80,10,9,12,23,2,161,4,62,43]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(M){return(typeof M=="string"?(0,k.extname)(M):(0,y.extname)(M))===w}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,a.createDecorator)("workspacesService");function P(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=P;function p(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=p;function o(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=o;function r(M){const B=M;return typeof B?.id=="string"&&T.URI.isUri(B.uri)}e.isSingleFolderWorkspaceIdentifier=r;function g(M){if(M.configuration)return{id:M.id,configPath:M.configuration};if(M.folders.length===1)return{id:M.id,uri:M.folders[0].uri}}e.toWorkspaceIdentifier=g;function s(M){const B=M;return typeof B?.id=="string"&&T.URI.isUri(B.configPath)}e.isWorkspaceIdentifier=s;function v(M){const B=M;if(B?.uri)return{id:B.id,uri:T.URI.revive(B.uri)};const U=M;if(U?.configPath)return{id:U.id,configPath:T.URI.revive(U.configPath)};if(M?.id)return{id:M.id}}e.reviveIdentifier=v;function n(M,B){return y.extUriBiasedIgnorePathCase.isEqualOrParent(M,B.untitledWorkspacesHome)}e.isUntitledWorkspace=n;function t(M){return u(M)||d(M)}e.isStoredWorkspaceFolder=t;function u(M){const B=M;return typeof B?.path=="string"&&(!B.name||typeof B.name=="string")}e.isRawFileWorkspaceFolder=u;function d(M){const B=M;return typeof B?.uri=="string"&&(!B.name||typeof B.name=="string")}e.isRawUriWorkspaceFolder=d;function l(M,B,U,z,K=!S.isWindows,N){if(M.scheme!==z.scheme)return{name:U,uri:M.toString(!0)};let j=B?void 0:N.relativePath(z,M);if(j!==void 0)j.length===0?j=".":S.isWindows&&M.scheme===i.Schemas.file&&!K&&(j=j.replace(/\//g,"\\"));else if(M.scheme===i.Schemas.file)j=M.fsPath,S.isWindows&&(j=(0,C.normalizeDriveLetter)(j),K&&(j=(0,m.toSlashes)(j)));else{if(!N.isEqualAuthority(M.authority,z.authority))return{name:U,uri:M.toString(!0)};j=M.path}return{name:U,path:j}}e.getStoredWorkspaceFolder=l;function h(M,B,U){let z=[],K=new Set;const N=U.dirname(B);for(let j of M){let H;if(u(j))j.path&&(H=U.resolvePath(N,j.path));else if(d(j))try{H=T.URI.parse(j.uri),H.path[0]!=="/"&&(H=H.with({path:"/"+H.path}))}catch(V){console.warn(V)}if(H){let V=U.getComparisonKey(H);if(!K.has(V)){K.add(V);const q=j.name||U.basenameOrAuthority(H);z.push(new f.WorkspaceFolder({uri:H,name:q,index:z.length},j))}}}return z}e.toWorkspaceFolders=h;function c(M,B,U,z,K){let N=_(B,M);const j=K.dirname(B),H=K.dirname(z),V=[],q=A(N.folders);for(const ke of N.folders){const Ue=u(ke)?K.resolvePath(j,ke.path):T.URI.parse(ke.uri);let xe;U?xe=!1:xe=!u(ke)||(0,k.isAbsolute)(ke.path),V.push(l(Ue,xe,ke.name,H,q,K))}const te={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},fe=D.setProperty(M,["folders"],V,te);let Ce=D.applyEdits(M,fe);return(0,y.isEqualAuthority)(N.remoteAuthority,(0,b.getRemoteAuthority)(z))&&(Ce=D.applyEdits(Ce,D.removeProperty(Ce,["remoteAuthority"],te))),Ce}e.rewriteWorkspaceFileForNewLocation=c;function _(M,B){let U=L.parse(B);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(z=>t(z));else throw new Error(`${M} looks like an invalid workspace file.`);return U}function A(M){return S.isWindows?M.some(B=>u(B)&&B.path.indexOf("/")>=0):!0}e.useSlashForPath=A;function R(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function x(M){return typeof M.folderUri=="string"}function O(M){return typeof M.fileUri=="string"}function F(M,B){const U={workspaces:[],files:[]};if(M){const z=function(N,j){for(let H=0;H<N.length;H++)try{j(N[H],H)}catch(V){B.warn(`Error restoring recent entry ${JSON.stringify(N[H])}: ${V.toString()}. Skip entry.`)}},K=M;if(Array.isArray(K.entries))z(K.entries,N=>{const j=N.label,H=N.remoteAuthority;R(N)?U.workspaces.push({label:j,remoteAuthority:H,workspace:{id:N.workspace.id,configPath:T.URI.parse(N.workspace.configPath)}}):x(N)?U.workspaces.push({label:j,remoteAuthority:H,folderUri:T.URI.parse(N.folderUri)}):O(N)&&U.files.push({label:j,remoteAuthority:H,fileUri:T.URI.parse(N.fileUri)})});else{const N=M;Array.isArray(N.workspaces3)&&z(N.workspaces3,(j,H)=>{const V=Array.isArray(N.workspaceLabels)&&N.workspaceLabels[H]||void 0;typeof j=="object"&&typeof j.id=="string"&&typeof j.configURIPath=="string"?U.workspaces.push({label:V,workspace:{id:j.id,configPath:T.URI.parse(j.configURIPath)}}):typeof j=="string"&&U.workspaces.push({label:V,folderUri:T.URI.parse(j)})}),Array.isArray(N.files2)&&z(N.files2,(j,H)=>{const V=Array.isArray(N.fileLabels)&&N.fileLabels[H]||void 0;typeof j=="string"&&U.files.push({label:V,fileUri:T.URI.parse(j)})})}}return U}e.restoreRecentlyOpened=F;function $(M){const B={entries:[]};for(const U of M.workspaces)p(U)?B.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):B.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of M.files)B.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return B}e.toStoreData=$}),define(ge[87],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const C=this._idPool++;return this._data.set(C,D),this.logDebugInfo(),C}get(D,C){return this._data.has(D)?this._data.get(D)[C]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(ge[44],pe([0,1,10,23,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(k=>{const S=this._providerInfo.get(k.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(k,S){S===null?this._providerInfo.delete(k):this._providerInfo.set(k,S)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(ge[26],pe([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,m.createDecorator)("IExtHostInitDataService")}),define(ge[198],pe([0,1,18]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(i,k,S){this._deferredPromises=new Map,this._id=i,this._shared=k,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const y=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const T of y.values())T.complete()}catch(T){for(const I of y.values())I.error(T)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,i])=>i!==void 0).map(([i])=>i)}get whenReady(){return this._init}get(i,k){let S=this._value[i];return typeof S=="undefined"&&(S=k),S}update(i,k){this._value[i]=k;let S=this._deferredPromises.get(i);if(S!==void 0)return S.p;const y=new m.DeferredPromise;return this._deferredPromises.set(i,y),this._scheduler.isScheduled()||this._scheduler.schedule(),y.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class D extends L{constructor(i,k){super(i.identifier.value,!0,k);this._extension=i}setKeysForSync(i){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},i)}}e.ExtensionGlobalMemento=D}),define(ge[199],pe([0,1,3,2,11]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(k,S){this._logService=k,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,S,y){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k)).acceptModelChanged(S.value,y)}$acceptDirtyStateChanged(k,S){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k)).acceptDirty(S)}$acceptModelSaved(k){const S=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(k,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,S);const y=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k));y.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:y.apiNotebook})}};C=Ve([He(0,D.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(ge[14],pe([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,m.createDecorator)("IExtHostRpcService");class L{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=L});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[200],pe([0,1,27,3]),function(Y,e,m,L){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(k,S){D.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(k.identifier),ot(this,D,S,"f"),Oe(this,D,"f").onDidChangePassword(y=>{y.extensionId===this._id&&this._onDidChange.fire({key:y.key})})}get(k){return Oe(this,D,"f").get(this._id,k)}store(k,S){return Oe(this,D,"f").store(this._id,k,S)}delete(k){return Oe(this,D,"f").delete(this._id,k)}}e.ExtensionSecrets=C,D=new WeakMap}),define(ge[121],pe([0,1,4,3]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(i){this._enabled=i}$onDidChangeTelemetryEnabled(i){this._enabled=i,this._onDidChangeTelemetryEnabled.fire(i)}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,m.createDecorator)("IExtHostTelemetry")}),define(ge[63],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var m;(function(p){p[p.Upsert=0]="Upsert",p[p.RemoveChild=1]="RemoveChild",p[p.Invalidated=2]="Invalidated",p[p.SetProp=3]="SetProp",p[p.Bulk=4]="Bulk"})(m=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,D=(p,o)=>{const r={controllerId:o};return L.set(p,r),r};e.createPrivateApiFor=D;const C=p=>L.get(p);e.getPrivateApiFor=C;const i=(p,o,r,g)=>{let s=r;return{enumerable:!0,configurable:!1,get(){return s},set(v){if(!g(s,v)){const n=s;s=v,p.listener?.({op:3,key:o,value:v,previous:n})}}}},k=(p,o)=>p===o,S={range:(p,o)=>p===o?!0:!p||!o?!1:p.isEqual(o),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(p,o)=>!(p.length!==o.length||p.some(r=>!o.find(g=>r.id===g.id)))},y=Object.keys(S),T=(p,o)=>({range:i(p,"range",void 0,S.range),label:i(p,"label",o,S.label),description:i(p,"description",void 0,S.description),canResolveChildren:i(p,"canResolveChildren",!1,S.canResolveChildren),busy:i(p,"busy",!1,S.busy),error:i(p,"error",void 0,S.error),tags:i(p,"tags",[],S.tags)}),I=(p,o)=>{const r=new Map;for(const g of y)S[g](p[g],o[g])||r.set(g,o[g]);return r};e.diffTestItems=I;class a extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=a;class b extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=b;class f extends Error{constructor(o,r,g){super(`TestItem with ID "${o}" is from controller "${r}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=f;const w=p=>{const o=(0,e.getPrivateApiFor)(p);let r=new Map;return{get size(){return r.size},forEach(g,s){for(const v of r.values())g.call(s,v,this)},replace(g){const s=new Map,v=new Set(r.keys()),n={op:4,ops:[]};for(const t of g){if(!(t instanceof E))throw new b(t.id);const u=(0,e.getPrivateApiFor)(t).controllerId;if(u!==o.controllerId)throw new f(t.id,u,o.controllerId);if(s.has(t.id))throw new a(t.id);s.set(t.id,t),v.delete(t.id),n.ops.push({op:0,item:t})}for(const t of v.keys())n.ops.push({op:1,id:t});o.listener?.(n),r=s},add(g){if(!(g instanceof E))throw new b(g.id);r.set(g.id,g),o.listener?.({op:0,item:g})},delete(g){r.delete(g)&&o.listener?.({op:1,id:g})},get(g){return r.get(g)},toJSON(){return Array.from(r.values())},[Symbol.iterator](){return r.values()}}};class E{constructor(o,r,g,s){if(r.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(r)} symbol`);const v=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:r,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return v.parent instanceof P?void 0:v.parent}},children:{value:w(this),enumerable:!0,writable:!1},...T(v,g)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=E;class P extends E{constructor(o,r){super(o,o,r,void 0)}}e.TestItemRootImpl=P}),define(ge[52],pe([0,1,4,120,3,14]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var i;(function(S){function y(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?L.TunnelPrivacyId.Public:L.TunnelPrivacyId.Private),protocol:I.protocol}}S.fromApiTunnel=y;function T(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==L.TunnelPrivacyId.ConstantPrivate&&I.privacy!==L.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}S.fromServiceTunnel=T})(i=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,m.createDecorator)("IExtHostTunnelService");let k=class{constructor(y){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,T){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,T){return{dispose:()=>{}}}async $providePortAttributes(y,T,I,a,b){return[]}async $forwardPort(y,T){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=Ve([He(0,C.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[7],pe([0,1,17,15,97,24,101,8,13,2,32,42,119]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a){"use strict";var b,f,w,E,P,p,o,r,g,s,v,n,t,u,d,l,h,c,_,A;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R(G){function W(){return Reflect.construct(G,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(G,"name")),Object.setPrototypeOf(W,G),Object.setPrototypeOf(W.prototype,G.prototype),W}let x=P=class{constructor(W){b.set(this,void 0),ot(this,b,W,"f")}static from(...W){let oe=W;return new P(function(){if(oe){for(const Pe of oe)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();oe=void 0}})}dispose(){typeof Oe(this,b,"f")=="function"&&(Oe(this,b,"f").call(this),ot(this,b,void 0,"f"))}};b=new WeakMap,x=P=Ve([R],x),e.Disposable=x;let O=p=class{constructor(W,oe){if(W<0)throw(0,L.illegalArgument)("line must be non-negative");if(oe<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=W,this._character=oe}static Min(...W){if(W.length===0)throw new TypeError;let oe=W[0];for(let Pe=1;Pe<W.length;Pe++){const Je=W[Pe];Je.isBefore(oe)&&(oe=Je)}return oe}static Max(...W){if(W.length===0)throw new TypeError;let oe=W[0];for(let Pe=1;Pe<W.length;Pe++){const Je=W[Pe];Je.isAfter(oe)&&(oe=Je)}return oe}static isPosition(W){if(!W)return!1;if(W instanceof p)return!0;let{line:oe,character:Pe}=W;return typeof oe=="number"&&typeof Pe=="number"}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,oe=0){if(W===null||oe===null)throw(0,L.illegalArgument)();let Pe;return typeof W=="undefined"?Pe=0:typeof W=="number"?Pe=W:(Pe=typeof W.lineDelta=="number"?W.lineDelta:0,oe=typeof W.characterDelta=="number"?W.characterDelta:0),Pe===0&&oe===0?this:new p(this.line+Pe,this.character+oe)}with(W,oe=this.character){if(W===null||oe===null)throw(0,L.illegalArgument)();let Pe;return typeof W=="undefined"?Pe=this.line:typeof W=="number"?Pe=W:(Pe=typeof W.line=="number"?W.line:this.line,oe=typeof W.character=="number"?W.character:this.character),Pe===this.line&&oe===this.character?this:new p(Pe,oe)}toJSON(){return{line:this.line,character:this.character}}};O=p=Ve([R],O),e.Position=O;let F=o=class{constructor(W,oe,Pe,Je){let lt,dt;if(typeof W=="number"&&typeof oe=="number"&&typeof Pe=="number"&&typeof Je=="number"?(lt=new O(W,oe),dt=new O(Pe,Je)):W instanceof O&&oe instanceof O&&(lt=W,dt=oe),!lt||!dt)throw new Error("Invalid arguments");lt.isBefore(dt)?(this._start=lt,this._end=dt):(this._start=dt,this._end=lt)}static isRange(W){return W instanceof o?!0:W?O.isPosition(W.start)&&O.isPosition(W.end):!1}get start(){return this._start}get end(){return this._end}contains(W){return W instanceof o?this.contains(W._start)&&this.contains(W._end):W instanceof O?!(W.isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const oe=O.Max(W.start,this._start),Pe=O.Min(W.end,this._end);if(!oe.isAfter(Pe))return new o(oe,Pe)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const oe=O.Min(W.start,this._start),Pe=O.Max(W.end,this.end);return new o(oe,Pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,oe=this.end){if(W===null||oe===null)throw(0,L.illegalArgument)();let Pe;return W?O.isPosition(W)?Pe=W:(Pe=W.start||this.start,oe=W.end||this.end):Pe=this.start,Pe.isEqual(this._start)&&oe.isEqual(this.end)?this:new o(Pe,oe)}toJSON(){return[this.start,this.end]}};F=o=Ve([R],F),e.Range=F;let $=r=class extends F{constructor(W,oe,Pe,Je){let lt,dt;if(typeof W=="number"&&typeof oe=="number"&&typeof Pe=="number"&&typeof Je=="number"?(lt=new O(W,oe),dt=new O(Pe,Je)):W instanceof O&&oe instanceof O&&(lt=W,dt=oe),!lt||!dt)throw new Error("Invalid arguments");super(lt,dt);this._anchor=lt,this._active=dt}static isSelection(W){return W instanceof r?!0:W?F.isRange(W)&&O.isPosition(W.anchor)&&O.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};$=r=Ve([R],$),e.Selection=$;class M{constructor(W,oe,Pe){if(typeof W!="string"||W.length===0)throw(0,L.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,L.illegalArgument)("port");if(typeof Pe!="undefined"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z\-]+$/.test(Pe)))throw(0,L.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(oe),this.connectionToken=Pe}}e.ResolvedAuthority=M;class B extends Error{constructor(W,oe=a.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(W);this._message=W,this._code=oe,this._detail=Pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,B.prototype)}static NotAvailable(W,oe){return new B(W,a.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(W){return new B(W,a.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=B;var U;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(U=e.EndOfLine||(e.EndOfLine={}));var z;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(z=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let K=g=class{constructor(W,oe){this._range=W,this._newText=oe}static isTextEdit(W){return W instanceof g?!0:W?F.isRange(W)&&typeof W.newText=="string":!1}static replace(W,oe){return new g(W,oe)}static insert(W,oe){return g.replace(new F(W,W),oe)}static delete(W){return g.replace(W,"")}static setEndOfLine(W){const oe=new g(new F(new O(0,0),new O(0,0)),"");return oe.newEol=W,oe}get range(){return this._range}set range(W){if(W&&!F.isRange(W))throw(0,L.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,L.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,L.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};K=g=Ve([R],K),e.TextEdit=K;var N;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace"})(N=e.FileEditType||(e.FileEditType={}));let j=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,oe,Pe,Je){this._edits.push({_type:1,from:W,to:oe,options:Pe,metadata:Je})}createFile(W,oe,Pe){this._edits.push({_type:1,from:void 0,to:W,options:oe,metadata:Pe})}deleteFile(W,oe,Pe){this._edits.push({_type:1,from:W,to:void 0,options:oe,metadata:Pe})}replaceNotebookMetadata(W,oe,Pe){this._edits.push({_type:3,metadata:Pe,uri:W,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells(W,oe,Pe,Je,lt){let dt,ft,Pt=[],Ft;if(Ne.isNotebookRange(oe)&&Ot.isNotebookCellDataArray(Pe)&&!Ot.isNotebookCellDataArray(Je)?(dt=oe.start,ft=oe.end,Pt=Pe,Ft=Je):typeof oe=="number"&&typeof Pe=="number"&&Ot.isNotebookCellDataArray(Je)&&(dt=oe,ft=Pe,Pt=Je,Ft=lt),dt===void 0||ft===void 0)throw new Error("Invalid arguments");(dt!==ft||Pt.length>0)&&this._edits.push({_type:5,uri:W,index:dt,count:ft-dt,cells:Pt,metadata:Ft})}replaceNotebookCellMetadata(W,oe,Pe,Je){this._edits.push({_type:3,metadata:Je,uri:W,edit:{editType:8,index:oe,metadata:Pe}})}replace(W,oe,Pe,Je){this._edits.push({_type:2,uri:W,edit:new K(oe,Pe),metadata:Je})}insert(W,oe,Pe,Je){this.replace(W,new F(oe,oe),Pe,Je)}delete(W,oe,Pe){this.replace(W,oe,"",Pe)}has(W){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===W.toString())}set(W,oe){if(oe)for(const Pe of oe)Pe&&this._edits.push({_type:2,uri:W,edit:Pe});else{for(let Pe=0;Pe<this._edits.length;Pe++){const Je=this._edits[Pe];Je._type===2&&Je.uri.toString()===W.toString()&&(this._edits[Pe]=void 0)}(0,m.coalesceInPlace)(this._edits)}}get(W){const oe=[];for(let Pe of this._edits)Pe._type===2&&Pe.uri.toString()===W.toString()&&oe.push(Pe.edit);return oe}entries(){const W=new C.ResourceMap;for(let oe of this._edits)if(oe._type===2){let Pe=W.get(oe.uri);Pe||(Pe=[oe.uri,[]],W.set(oe.uri,Pe)),Pe[1].push(oe.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};j=Ve([R],j),e.WorkspaceEdit=j;let H=s=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof s?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=s._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,oe=this._tabstop++){if(typeof W=="function"){const Pe=new s;Pe._tabstop=this._tabstop,W(Pe),this._tabstop=Pe._tabstop,W=Pe.value}else W=s._escape(W);return this.value+="${",this.value+=oe,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,oe=this._tabstop++){const Pe=W.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(W,oe){if(typeof oe=="function"){const Pe=new s;Pe._tabstop=this._tabstop,oe(Pe),this._tabstop=Pe._tabstop,oe=Pe.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};H=s=Ve([R],H),e.SnippetString=H;var V;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(V=e.DiagnosticTag||(e.DiagnosticTag={}));var q;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let te=v=class{constructor(W,oe){if(this.uri=W,oe)if(oe instanceof F)this.range=oe;else if(oe instanceof O)this.range=new F(oe,oe);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof v?!0:W?F.isRange(W.range)&&y.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};te=v=Ve([R],te),e.Location=te;let fe=class{constructor(W,oe){this.location=W,this.message=oe}static is(W){return W?typeof W.message=="string"&&W.location&&F.isRange(W.location.range)&&y.URI.isUri(W.location.uri):!1}static isEqual(W,oe){return W===oe?!0:!W||!oe?!1:W.message===oe.message&&W.location.range.isEqual(oe.location.range)&&W.location.uri.toString()===oe.location.uri.toString()}};fe=Ve([R],fe),e.DiagnosticRelatedInformation=fe;let Ce=class{constructor(W,oe,Pe=q.Error){if(!F.isRange(W))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=W,this.message=oe,this.severity=Pe}toJSON(){return{severity:q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,oe){return W===oe?!0:!W||!oe?!1:W.message===oe.message&&W.severity===oe.severity&&W.code===oe.code&&W.severity===oe.severity&&W.source===oe.source&&W.range.isEqual(oe.range)&&(0,m.equals)(W.tags,oe.tags)&&(0,m.equals)(W.relatedInformation,oe.relatedInformation,fe.isEqual)}};Ce=Ve([R],Ce),e.Diagnostic=Ce;let ke=class{constructor(W,oe){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=oe}};ke=Ve([R],ke),e.Hover=ke;var Ue;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(Ue=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let xe=class{constructor(W,oe=Ue.Text){this.range=W,this.kind=oe}toJSON(){return{range:this.range,kind:Ue[this.kind]}}};xe=Ve([R],xe),e.DocumentHighlight=xe;var ze;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(ze=e.SymbolKind||(e.SymbolKind={}));var Q;(function(G){G[G.Deprecated=1]="Deprecated"})(Q=e.SymbolTag||(e.SymbolTag={}));let Z=n=class{constructor(W,oe,Pe,Je,lt){this.name=W,this.kind=oe,this.containerName=lt,typeof Pe=="string"&&(this.containerName=Pe),Je instanceof te?this.location=Je:Pe instanceof F&&(this.location=new te(Je,Pe)),n.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ze[this.kind],location:this.location,containerName:this.containerName}}};Z=n=Ve([R],Z),e.SymbolInformation=Z;let re=t=class{constructor(W,oe,Pe,Je,lt){this.name=W,this.detail=oe,this.kind=Pe,this.range=Je,this.selectionRange=lt,this.children=[],t.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children&&W.children.forEach(t.validate)}};re=t=Ve([R],re),e.DocumentSymbol=re;var ue;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(ue=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let J=class{constructor(W,oe){this.title=W,this.kind=oe}};J=Ve([R],J),e.CodeAction=J;let ie=u=class{constructor(W){this.value=W}append(W){return new u(this.value?this.value+u.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+u.sep)}};ie.sep=".",ie=u=Ve([R],ie),e.CodeActionKind=ie,ie.Empty=new ie(""),ie.QuickFix=ie.Empty.append("quickfix"),ie.Refactor=ie.Empty.append("refactor"),ie.RefactorExtract=ie.Refactor.append("extract"),ie.RefactorInline=ie.Refactor.append("inline"),ie.RefactorRewrite=ie.Refactor.append("rewrite"),ie.Source=ie.Empty.append("source"),ie.SourceOrganizeImports=ie.Source.append("organizeImports"),ie.SourceFixAll=ie.Source.append("fixAll");let we=class{constructor(W,oe){if(this.range=W,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};we=Ve([R],we),e.SelectionRange=we;class Me{constructor(W,oe,Pe,Je,lt,dt){this.kind=W,this.name=oe,this.detail=Pe,this.uri=Je,this.range=lt,this.selectionRange=dt}}e.CallHierarchyItem=Me;class je{constructor(W,oe){this.fromRanges=oe,this.from=W}}e.CallHierarchyIncomingCall=je;class Ke{constructor(W,oe){this.fromRanges=oe,this.to=W}}e.CallHierarchyOutgoingCall=Ke;var Ze;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(Ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let rt=class{constructor(W,oe){this.range=W,this.command=oe}get isResolved(){return!!this.command}};rt=Ve([R],rt),e.CodeLens=rt;let ut=d=class{constructor(W,oe=!1){f.set(this,void 0),ot(this,f,new D.MarkdownString(W,{supportThemeIcons:oe}),"f")}static isMarkdownString(W){return W instanceof d?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return Oe(this,f,"f").value}set value(W){Oe(this,f,"f").value=W}get isTrusted(){return Oe(this,f,"f").isTrusted}set isTrusted(W){Oe(this,f,"f").isTrusted=W}get supportThemeIcons(){return Oe(this,f,"f").supportThemeIcons}set supportThemeIcons(W){Oe(this,f,"f").supportThemeIcons=W}get supportHtml(){return Oe(this,f,"f").supportHtml}set supportHtml(W){Oe(this,f,"f").supportHtml=W}appendText(W){return Oe(this,f,"f").appendText(W),this}appendMarkdown(W){return Oe(this,f,"f").appendMarkdown(W),this}appendCodeblock(W,oe){return Oe(this,f,"f").appendCodeblock(oe??"",W),this}};f=new WeakMap,ut=d=Ve([R],ut),e.MarkdownString=ut;let it=class{constructor(W,oe){this.label=W,this.documentation=oe}};it=Ve([R],it),e.ParameterInformation=it;let st=class{constructor(W,oe){this.label=W,this.documentation=oe,this.parameters=[]}};st=Ve([R],st),e.SignatureInformation=st;let Ae=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ae=Ve([R],Ae),e.SignatureHelp=Ae;var wt;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(wt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ee;(function(G){G[G.Other=0]="Other",G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(ee=e.InlayHintKind||(e.InlayHintKind={}));let se=class{constructor(W,oe,Pe){this.text=W,this.position=oe,this.kind=Pe}};se=Ve([R],se),e.InlayHint=se;var Se;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Se=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ge;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Ge=e.CompletionItemKind||(e.CompletionItemKind={}));var Ye;(function(G){G[G.Deprecated=1]="Deprecated"})(Ye=e.CompletionItemTag||(e.CompletionItemTag={}));let nt=class{constructor(W,oe){this.label=W,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&Ge[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};nt=Ve([R],nt),e.CompletionItem=nt;let he=class{constructor(W=[],oe=!1){this.items=W,this.isIncomplete=oe}};he=Ve([R],he),e.CompletionList=he;let Ie=class{constructor(W,oe,Pe){this.text=W,this.range=oe,this.command=Pe}};Ie=Ve([R],Ie),e.InlineSuggestion=Ie;let Be=class{constructor(W){this.items=W}};Be=Ve([R],Be),e.InlineSuggestions=Be;var We;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(We=e.ViewColumn||(e.ViewColumn={}));var tt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(tt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Te;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(Te=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ye;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var be;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(be=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ae;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(ae=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var de;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(de=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ve;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(ve=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(G){function W(oe){switch(oe){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=W}(ae=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ee=class{constructor(W,oe){if(oe&&!y.URI.isUri(oe))throw(0,L.illegalArgument)("target");if(!F.isRange(W)||W.isEmpty)throw(0,L.illegalArgument)("range");this.range=W,this.target=oe}};Ee=Ve([R],Ee),e.DocumentLink=Ee;let Fe=class{constructor(W,oe,Pe,Je){this.red=W,this.green=oe,this.blue=Pe,this.alpha=Je}};Fe=Ve([R],Fe),e.Color=Fe;let Qe=class{constructor(W,oe){if(oe&&!(oe instanceof Fe))throw(0,L.illegalArgument)("color");if(!F.isRange(W)||W.isEmpty)throw(0,L.illegalArgument)("range");this.range=W,this.color=oe}};Qe=Ve([R],Qe),e.ColorInformation=Qe;let $e=class{constructor(W){if(!W||typeof W!="string")throw(0,L.illegalArgument)("label");this.label=W}};$e=Ve([R],$e),e.ColorPresentation=$e;var Xe;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Xe=e.ColorFormat||(e.ColorFormat={}));var at;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(at=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ct{constructor(W,oe,Pe){if(this.startIndex=W,this.length=oe,this.tooltip=Pe,typeof W!="number"||W<0)throw(0,L.illegalArgument)("startIndex");if(typeof oe!="number"||oe<1)throw(0,L.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=ct;var ce;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(ce=e.TerminalLocation||(e.TerminalLocation={}));class _e{constructor(W){this.options=W,typeof W!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=_e;var le;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(le=e.TaskRevealKind||(e.TaskRevealKind={}));var X;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(X=e.TaskPanelKind||(e.TaskPanelKind={}));let De=l=class{constructor(W,oe){if(this.label=oe,typeof W!="string"||typeof oe!="string")throw(0,L.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};De.Clean=new l("clean","Clean"),De.Build=new l("build","Build"),De.Rebuild=new l("rebuild","Rebuild"),De.Test=new l("test","Test"),De=l=Ve([R],De),e.TaskGroup=De;function Le(G){let W="";for(let oe=0;oe<G.length;oe++)W+=G[oe].replace(/,/g,",,")+",";return W}let et=class{constructor(W,oe,Pe){if(typeof W!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=W,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=Pe):this._options=oe)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,L.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)W.push(oe);return Le(W)}};et=Ve([R],et),e.ProcessExecution=et;let qe=class{constructor(W,oe,Pe){if(this._args=[],Array.isArray(oe)){if(!W)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,L.illegalArgument)("command");this._command=W,this._args=oe,this._options=Pe}else{if(typeof W!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=W,this._options=oe}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,L.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)W.push(typeof oe=="string"?oe:oe.value);return Le(W)}};qe=Ve([R],qe),e.ShellExecution=qe;var mt;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(mt=e.ShellQuoting||(e.ShellQuoting={}));var _t;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(_t=e.TaskScope||(e.TaskScope={}));class kt{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=kt;let bt=h=class{constructor(W,oe,Pe,Je,lt,dt){this.__deprecated=!1,this._definition=this.definition=W;let ft;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=Pe,this.execution=Je,ft=lt,this.__deprecated=!0):oe===_t.Global||oe===_t.Workspace?(this.target=oe,this._name=this.name=Pe,this._source=this.source=Je,this.execution=lt,ft=dt):(this.target=oe,this._name=this.name=Pe,this._source=this.source=Je,this.execution=lt,ft=dt),typeof ft=="string"?(this._problemMatchers=[ft],this._hasDefinedMatchers=!0):Array.isArray(ft)?(this._problemMatchers=ft,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof et?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof qe?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof kt?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const oe=this._definition.type;(h.EmptyType===oe||h.ProcessType===oe||h.ShellType===oe||h.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=h=Ve([R],bt),e.Task=bt;var gt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(gt=e.ProgressLocation||(e.ProgressLocation={}));let Et=class{constructor(W,oe=Ct.None){this.collapsibleState=oe,y.URI.isUri(W)?this.resourceUri=W:this.label=W}};Et=Ve([R],Et),e.TreeItem=Et;var Ct;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(Ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Lt=class{constructor(W){this._value=W}async asString(){return JSON.stringify(this._value)}};Lt=Ve([R],Lt),e.TreeDataTransferItem=Lt;let yt=class{constructor(){this._items=new Map}get(W){return this._items.get(W)}set(W,oe){this._items.set(W,oe)}forEach(W){this._items.forEach(W)}};yt=Ve([R],yt),e.TreeDataTransfer=yt;let At=class{constructor(W,oe){this.id=W,this.color=oe}};At=Ve([R],At),e.ThemeIcon=At,At.File=new At("file"),At.Folder=new At("folder");let xt=class{constructor(W){this.id=W}};xt=Ve([R],xt),e.ThemeColor=xt;var Tt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(Tt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Bt=class{constructor(W,oe){if(typeof W!="string"&&(!W||!y.URI.isUri(W)&&!y.URI.isUri(W.uri)))throw(0,L.illegalArgument)("base");if(typeof oe!="string")throw(0,L.illegalArgument)("pattern");typeof W=="string"?(this.baseFolder=y.URI.file(W),this.base=W):y.URI.isUri(W)?(this.baseFolder=W,this.base=W.fsPath):(this.baseFolder=W.uri,this.base=W.uri.fsPath),this.pattern=oe}};Bt=Ve([R],Bt),e.RelativePattern=Bt;let Ht=class{constructor(W,oe,Pe,Je){this.enabled=typeof W=="boolean"?W:!0,typeof oe=="string"&&(this.condition=oe),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};Ht=Ve([R],Ht),e.Breakpoint=Ht;let St=class extends Ht{constructor(W,oe,Pe,Je,lt){super(oe,Pe,Je,lt);if(W===null)throw(0,L.illegalArgument)("location");this.location=W}};St=Ve([R],St),e.SourceBreakpoint=St;let Qt=class extends Ht{constructor(W,oe,Pe,Je,lt){super(oe,Pe,Je,lt);this.functionName=W}};Qt=Ve([R],Qt),e.FunctionBreakpoint=Qt;let Vt=class extends Ht{constructor(W,oe,Pe,Je,lt,dt,ft){super(Je,lt,dt,ft);if(!oe)throw(0,L.illegalArgument)("dataId");this.label=W,this.dataId=oe,this.canPersist=Pe}};Vt=Ve([R],Vt),e.DataBreakpoint=Vt;let si=class{constructor(W,oe,Pe){this.command=W,this.args=oe||[],this.options=Pe}};si=Ve([R],si),e.DebugAdapterExecutable=si;let oi=class{constructor(W,oe){this.port=W,this.host=oe}};oi=Ve([R],oi),e.DebugAdapterServer=oi;let Rt=class{constructor(W){this.path=W}};Rt=Ve([R],Rt),e.DebugAdapterNamedPipeServer=Rt;let Xt=class{constructor(W){this.implementation=W}};Xt=Ve([R],Xt),e.DebugAdapterInlineImplementation=Xt;let ai=class{constructor(W,oe){this.range=W,this.expression=oe}};ai=Ve([R],ai),e.EvaluatableExpression=ai;var Yt;(function(G){G[G.Automatic=0]="Automatic",G[G.Explicit=1]="Explicit"})(Yt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let zt=class{constructor(W,oe){this.range=W,this.text=oe}};zt=Ve([R],zt),e.InlineValueText=zt;let vt=class{constructor(W,oe,Pe=!0){this.range=W,this.variableName=oe,this.caseSensitiveLookup=Pe}};vt=Ve([R],vt),e.InlineValueVariableLookup=vt;let li=class{constructor(W,oe){this.range=W,this.expression=oe}};li=Ve([R],li),e.InlineValueEvaluatableExpression=li;let Mt=class{constructor(W,oe){this.frameId=W,this.stoppedLocation=oe}};Mt=Ve([R],Mt),e.InlineValueContext=Mt;var jt;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(jt=e.FileChangeType||(e.FileChangeType={}));let Jt=c=class extends Error{constructor(W,oe=I.FileSystemProviderErrorCode.Unknown,Pe){super(y.URI.isUri(W)?W.toString(!0):W);this.code=Pe?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,c.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}static FileExists(W){return new c(W,I.FileSystemProviderErrorCode.FileExists,c.FileExists)}static FileNotFound(W){return new c(W,I.FileSystemProviderErrorCode.FileNotFound,c.FileNotFound)}static FileNotADirectory(W){return new c(W,I.FileSystemProviderErrorCode.FileNotADirectory,c.FileNotADirectory)}static FileIsADirectory(W){return new c(W,I.FileSystemProviderErrorCode.FileIsADirectory,c.FileIsADirectory)}static NoPermissions(W){return new c(W,I.FileSystemProviderErrorCode.NoPermissions,c.NoPermissions)}static Unavailable(W){return new c(W,I.FileSystemProviderErrorCode.Unavailable,c.Unavailable)}};Jt=c=Ve([R],Jt),e.FileSystemError=Jt;let ci=class{constructor(W,oe,Pe){this.start=W,this.end=oe,this.kind=Pe}};ci=Ve([R],ci),e.FoldingRange=ci;var fi;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class Zt{constructor(W,oe=[]){this.tokenTypes=W,this.tokenModifiers=oe}}e.SemanticTokensLegend=Zt;function _i(G){return typeof G=="undefined"||(0,S.isStringArray)(G)}class qt{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let oe=0,Pe=W.tokenTypes.length;oe<Pe;oe++)this._tokenTypeStrToInt.set(W.tokenTypes[oe],oe);for(let oe=0,Pe=W.tokenModifiers.length;oe<Pe;oe++)this._tokenModifierStrToInt.set(W.tokenModifiers[oe],oe)}}push(W,oe,Pe,Je,lt){if(typeof W=="number"&&typeof oe=="number"&&typeof Pe=="number"&&typeof Je=="number"&&(typeof lt=="number"||typeof lt=="undefined"))return typeof lt=="undefined"&&(lt=0),this._pushEncoded(W,oe,Pe,Je,lt);if(F.isRange(W)&&typeof oe=="string"&&_i(Pe))return this._push(W,oe,Pe);throw(0,L.illegalArgument)()}_push(W,oe,Pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const Je=W.start.line,lt=W.start.character,dt=W.end.character-W.start.character,ft=this._tokenTypeStrToInt.get(oe);let Pt=0;if(Pe)for(const Ft of Pe){if(!this._tokenModifierStrToInt.has(Ft))throw new Error("`tokenModifier` is not in the provided legend");const Nt=this._tokenModifierStrToInt.get(Ft);Pt|=1<<Nt>>>0}this._pushEncoded(Je,lt,dt,ft,Pt)}_pushEncoded(W,oe,Pe,Je,lt){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Pt=this._data.length/5|0;let Ft=0,Nt=0;for(let Ut=0;Ut<Pt;Ut++){let $t=this._data[5*Ut],di=this._data[5*Ut+1];$t===0?($t=Ft,di+=Nt):$t+=Ft,this._data[5*Ut]=$t,this._data[5*Ut+1]=di,Ft=$t,Nt=di}}let dt=W,ft=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(dt-=this._prevLine,dt===0&&(ft-=this._prevChar)),this._data[this._dataLen++]=dt,this._data[this._dataLen++]=ft,this._data[this._dataLen++]=Pe,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=lt,this._prevLine=W,this._prevChar=oe}static _sortAndDeltaEncode(W){let oe=[];const Pe=W.length/5|0;for(let ft=0;ft<Pe;ft++)oe[ft]=ft;oe.sort((ft,Pt)=>{const Ft=W[5*ft],Nt=W[5*Pt];if(Ft===Nt){const Ut=W[5*ft+1],$t=W[5*Pt+1];return Ut-$t}return Ft-Nt});const Je=new Uint32Array(W.length);let lt=0,dt=0;for(let ft=0;ft<Pe;ft++){const Pt=5*oe[ft],Ft=W[Pt+0],Nt=W[Pt+1],Ut=W[Pt+2],$t=W[Pt+3],di=W[Pt+4],Wi=Ft-lt,Xi=Wi===0?Nt-dt:Nt,hi=5*ft;Je[hi+0]=Wi,Je[hi+1]=Xi,Je[hi+2]=Ut,Je[hi+3]=$t,Je[hi+4]=di,lt=Ft,dt=Nt}return Je}build(W){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),W):new Gt(qt._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=qt;class Gt{constructor(W,oe){this.resultId=oe,this.data=W}}e.SemanticTokens=Gt;class Si{constructor(W,oe,Pe){this.start=W,this.deleteCount=oe,this.data=Pe}}e.SemanticTokensEdit=Si;class Ci{constructor(W,oe){this.resultId=oe,this.edits=W}}e.SemanticTokensEdits=Ci;var Kt;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Kt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yi;(function(G){G[G.Initial=1]="Initial",G[G.Dynamic=2]="Dynamic"})(yi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new At("arrow-left")},ei=Ve([R],ei),e.QuickInputButtons=ei;var Di;(function(G){G[G.Default=1]="Default",G[G.Separator=2]="Separator"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor(W,oe,Pe){this.badge=W,this.tooltip=oe,this.color=Pe}static validate(W){if(W.badge){let oe=(0,k.nextCharLength)(W.badge,0);if(oe<W.badge.length&&(oe+=(0,k.nextCharLength)(W.badge,oe)),W.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ti=class{constructor(W){this.kind=W}};ti=Ve([R],ti),e.ColorTheme=ti;var gi;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Ne{constructor(W,oe){if(W<0)throw(0,L.illegalArgument)("start must be positive");if(oe<0)throw(0,L.illegalArgument)("end must be positive");W<=oe?(this._start=W,this._end=oe):(this._start=oe,this._end=W)}static isNotebookRange(W){return W instanceof Ne?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(W){let oe=this._start,Pe=this._end;return W.start!==void 0&&(oe=W.start),W.end!==void 0&&(Pe=W.end),oe===this._start&&Pe===this._end?this:new Ne(oe,Pe)}}e.NotebookRange=Ne;class Ot{constructor(W,oe,Pe,Je,lt,dt,ft){this.kind=W,this.value=oe,this.languageId=Pe,this.mime=Je,this.outputs=lt??[],this.metadata=dt,this.executionSummary=ft,Ot.validate(this)}static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(oe=>Ot.isNotebookCellData(oe))}static isNotebookCellData(W){return!0}}e.NotebookCellData=Ot;class pi{constructor(W){this.cells=W}}e.NotebookData=pi;class pt{constructor(W,oe){this.data=W,this.mime=oe;const Pe=(0,i.normalizeMimeType)(oe,!0);if(!Pe)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}static isNotebookCellOutputItem(W){return W instanceof pt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const oe={name:W.name,message:W.message,stack:W.stack};return pt.json(oe,"application/vnd.code.notebook.error")}static stdout(W){return pt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return pt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,oe="application/octet-stream"){return new pt(W,oe)}static text(W,oe=i.Mimes.text){const Pe=Oe(pt,w,"f",E).encode(String(W));return new pt(Pe,oe)}static json(W,oe="application/json"){const Pe=JSON.stringify(W,void 0,"	");return pt.text(Pe,oe)}}e.NotebookCellOutputItem=pt,w=pt,E={value:new TextEncoder};class ii{constructor(W,oe,Pe){this.items=ii.ensureUniqueMimeTypes(W,!0),typeof oe=="string"?(this.id=oe,this.metadata=Pe):(this.id=(0,T.generateUuid)(),this.metadata=oe??Pe)}static isNotebookCellOutput(W){return W instanceof ii?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&(0,S.isArray)(W.items)}static ensureUniqueMimeTypes(W,oe=!1){const Pe=new Set,Je=new Set;for(let lt=0;lt<W.length;lt++){const dt=W[lt],ft=(0,i.normalizeMimeType)(dt.mime);if(!Pe.has(ft)){Pe.add(ft);continue}Je.add(lt),oe&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Je.size===0?W:W.filter((lt,dt)=>!Je.has(dt))}}e.NotebookCellOutput=ii;var Ii;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var wi;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(wi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor(W,oe){this.text=W,this.alignment=oe}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor(W,oe=[]){this.uri=W,this.provides=(0,m.asArray)(oe)}}e.NotebookRendererScript=Ri;let ni=class{constructor(W,oe){this.label=W,this.timestamp=oe}};ni=Ve([R],ni),e.TimelineItem=ni;var Li;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(Li=e.ExtensionMode||(e.ExtensionMode={}));var Fi;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(Fi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Mi;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=4]="RegEx"})(Mi=e.StandardTokenType||(e.StandardTokenType={}));class Oi{constructor(W,oe){this.ranges=W,this.wordPattern=oe}}e.LinkedEditingRanges=Oi;class Ni{constructor(W,oe){this._port=W,this._autoForwardAction=oe}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var ne;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(ne=e.TestResultState||(e.TestResultState={}));var me;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(me=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Re=class{constructor(W=void 0,oe=void 0,Pe=void 0){this.include=W,this.exclude=oe,this.profile=Pe}};Re=Ve([R],Re),e.TestRunRequest=Re;let ht=_=class{constructor(W){this.message=W}static diff(W,oe,Pe){const Je=new _(W);return Je.expectedOutput=oe,Je.actualOutput=Pe,Je}};ht=_=Ve([R],ht),e.TestMessage=ht;let Dt=class{constructor(W){this.id=W}};Dt=Ve([R],Dt),e.TestTag=Dt;let It=class{constructor(W,oe){this.covered=W,this.total=oe}};It=Ve([R],It),e.CoveredCount=It;let Ui=A=class{constructor(W,oe,Pe,Je){this.uri=W,this.statementCoverage=oe,this.branchCoverage=Pe,this.functionCoverage=Je}static fromDetails(W,oe){const Pe=new It(0,0),Je=new It(0,0),lt=new It(0,0);for(const ft of oe)if("branches"in ft){Pe.total+=1,Pe.covered+=ft.executionCount>0?1:0;for(const Pt of ft.branches)Je.total+=1,Je.covered+=Pt.executionCount>0?1:0}else lt.total+=1,lt.covered+=ft.executionCount>0?1:0;const dt=new A(W,Pe,Je.total>0?Je:void 0,lt.total>0?lt:void 0);return dt.detailedCoverage=oe,dt}};Ui=A=Ve([R],Ui),e.FileCoverage=Ui;let xi=class{constructor(W,oe,Pe=[]){this.executionCount=W,this.location=oe,this.branches=Pe}};xi=Ve([R],xi),e.StatementCoverage=xi;let Bi=class{constructor(W,oe){this.executionCount=W,this.location=oe}};Bi=Ve([R],Bi),e.BranchCoverage=Bi;let $i=class{constructor(W,oe){this.executionCount=W,this.location=oe}};$i=Ve([R],$i),e.FunctionCoverage=$i;var qi;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Gi;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(Gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ki;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ki=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor(W,oe,Pe,Je,lt,dt){this.kind=W,this.name=oe,this.detail=Pe,this.uri=Je,this.range=lt,this.selectionRange=dt}}e.TypeHierarchyItem=Qi}),define(ge[122],pe([0,1,56,10,8,149,109,7,17]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const y=new Map;function T(f,w){w?y.set(f,w):y.delete(f)}e.setWordDefinitionFor=T;function I(f){return y.get(f)}e.getWordDefinitionFor=I;class a extends C.MirrorTextModel{constructor(w,E,P,p,o,r,g,s){super(E,P,p,o);this._proxy=w,this._languageId=r,this._isDirty=g,this._notebook=s,this._isDisposed=!1}dispose(){(0,m.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(w){return(0,S.equals)(this._lines,w)}get document(){if(!this._document){const w=this;this._document={get uri(){return w._uri},get fileName(){return w._uri.fsPath},get isUntitled(){return w._uri.scheme===L.Schemas.untitled},get languageId(){return w._languageId},get version(){return w._versionId},get isClosed(){return w._isDisposed},get isDirty(){return w._isDirty},get notebook(){return w._notebook},save(){return w._save()},getText(E){return E?w._getTextInRange(E):w.getText()},get eol(){return w._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return w._lines.length},lineAt(E){return w._lineAt(E)},offsetAt(E){return w._offsetAt(E)},positionAt(E){return w._positionAt(E)},validateRange(E){return w._validateRange(E)},validatePosition(E){return w._validatePosition(E)},getWordRangeAtPosition(E,P){return w._getWordRangeAtPosition(E,P)}}}return Object.freeze(this._document)}_acceptLanguageId(w){(0,m.ok)(!this._isDisposed),this._languageId=w}_acceptIsDirty(w){(0,m.ok)(!this._isDisposed),this._isDirty=w}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(w){const E=this._validateRange(w);if(E.isEmpty)return"";if(E.isSingleLine)return this._lines[E.start.line].substring(E.start.character,E.end.character);const P=this._eol,p=E.start.line,o=E.end.line,r=[];r.push(this._lines[p].substring(E.start.character));for(let g=p+1;g<o;g++)r.push(this._lines[g]);return r.push(this._lines[o].substring(0,E.end.character)),r.join(P)}_lineAt(w){let E;if(w instanceof k.Position?E=w.line:typeof w=="number"&&(E=w),typeof E!="number"||E<0||E>=this._lines.length||Math.floor(E)!==E)throw new Error("Illegal value for `line`");return new b(E,this._lines[E],E===this._lines.length-1)}_offsetAt(w){return w=this._validatePosition(w),this._ensureLineStarts(),this._lineStarts.getPrefixSum(w.line-1)+w.character}_positionAt(w){w=Math.floor(w),w=Math.max(0,w),this._ensureLineStarts();const E=this._lineStarts.getIndexOf(w),P=this._lines[E.index].length;return new k.Position(E.index,Math.min(E.remainder,P))}_validateRange(w){if(!(w instanceof k.Range))throw new Error("Invalid argument");const E=this._validatePosition(w.start),P=this._validatePosition(w.end);return E===w.start&&P===w.end?w:new k.Range(E.line,E.character,P.line,P.character)}_validatePosition(w){if(!(w instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return w.with(0,0);let{line:E,character:P}=w,p=!1;if(E<0)E=0,P=0,p=!0;else if(E>=this._lines.length)E=this._lines.length-1,P=this._lines[E].length,p=!0;else{const o=this._lines[E].length;P<0?(P=0,p=!0):P>o&&(P=o,p=!0)}return p?new k.Position(E,P):w}_getWordRangeAtPosition(w,E){const P=this._validatePosition(w);if(!E)E=I(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(E))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${E.source}' because it matches the empty string.`);const p=(0,i.getWordAtText)(P.character+1,(0,i.ensureValidWordDefinition)(E),this._lines[P.line],0);if(p)return new k.Range(P.line,p.startColumn-1,P.line,p.endColumn-1)}}e.ExtHostDocumentData=a;class b{constructor(w,E,P){this._line=w,this._text=E,this._isLastLine=P}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=b}),define(ge[201],pe([0,1,7,3,111,6,82,24,2,32]),function(Y,e,m,L,D,C,i,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class T{constructor(a,b,f,w){this._notebook=f,this._selector=w,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,y.generateUuid)()}),this._init(),this._disposables.add(b.onDidChangeDocument(P=>{const p=this._cellUris.get(P.document.uri);p!==void 0&&(this._cellLengths.setValue(p,this._cells[p].document.getText().length+1),this._cellLines.setValue(p,this._cells[p].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const E=P=>{P===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(a.onDidChangeNotebookCells(P=>E(P.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const a=[],b=[];for(const f of this._notebook.getCells())f.kind===m.NotebookCellKind.Code&&(!this._selector||(0,i.score)(this._selector,f.document.uri,f.document.languageId,!0))&&(this._cellUris.set(f.document.uri,this._cells.length),this._cells.push(f),a.push(f.document.getText().length+1),b.push(f.document.lineCount));this._cellLengths=new D.PrefixSumComputer(new Uint32Array(a)),this._cellLines=new D.PrefixSumComputer(new Uint32Array(b))}get version(){return this._versionId}getText(a){if(!a){let p="";for(const o of this._cells)p+=o.document.getText()+`
`;return p=p.slice(0,-1),p}if(a.isEmpty)return"";const b=this.locationAt(a.start),f=this.locationAt(a.end),w=this._cellUris.get(b.uri),E=this._cellUris.get(f.uri);if(w===void 0||E===void 0)return"";if(w===E)return this._cells[w].document.getText(new m.Range(b.range.start,f.range.end));const P=[this._cells[w].document.getText(new m.Range(b.range.start,new m.Position(this._cells[w].document.lineCount,0)))];for(let p=w+1;p<E;p++)P.push(this._cells[p].document.getText());return P.push(this._cells[E].document.getText(new m.Range(new m.Position(0,0),f.range.end))),P.join(`
`)}offsetAt(a){const b=this._cellLines.getIndexOf(a.line),f=this._cellLengths.getPrefixSum(b.index-1),w=this._cells[b.index].document.offsetAt(a.with(b.remainder));return f+w}positionAt(a){if(typeof a=="number"){const f=this._cellLengths.getIndexOf(a),w=this._cellLines.getPrefixSum(f.index-1);return this._cells[f.index].document.positionAt(f.remainder).translate(w)}const b=this._cellUris.get(a.uri);if(b!==void 0){const f=this._cellLines.getPrefixSum(b-1);return new m.Position(f+a.range.start.line,a.range.start.character)}return new m.Position(0,0)}locationAt(a){m.Range.isRange(a)||(a=new m.Range(a,a));const b=this._cellLines.getIndexOf(a.start.line);let f=b;a.isEmpty||(f=this._cellLines.getIndexOf(a.end.line));const w=new m.Position(b.remainder,a.start.character),E=new m.Position(f.remainder,a.end.character),P=new m.Range(w,E),p=this._cells[b.index];return new m.Location(p.document.uri,p.document.validateRange(P))}contains(a){return this._cellUris.has(a)}validateRange(a){const b=this.validatePosition(a.start),f=this.validatePosition(a.end);return a.with(b,f)}validatePosition(a){const b=this._cellLines.getIndexOf(a.line),f=new m.Position(b.remainder,a.character),w=this._cells[b.index].document.validatePosition(f),E=this._cellLines.getPrefixSum(b.index-1);return new m.Position(E+w.line,w.character)}}e.ExtHostNotebookConcatDocument=T}),define(ge[202],pe([0,1,7,14,3]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(k){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let S=k==="light"?m.ColorThemeKind.Light:k==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=Ve([He(0,L.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(ge[64],pe([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,m.createDecorator)("IURITransformerService");class L{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=i=>i,this.transformOutgoing=i=>i,this.transformOutgoingURI=i=>i,this.transformOutgoingScheme=i=>i)}}e.URITransformerService=L}),define(ge[203],pe([0,1,22]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(S){let y=this.buffers.indexOf(S);return y<0&&(y=this.buffers.length,this.buffers.push(S)),y}}function D(k,S){if(S.serializeBuffersForPostMessage){const y=new L,T=(b,f)=>{if(f instanceof ArrayBuffer){const w=y.add(f);return{$$vscode_array_buffer_reference$$:!0,index:w}}else if(ArrayBuffer.isView(f)){const w=C(f);if(w){const E=y.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:E,view:{type:w,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},I=JSON.stringify(k,T),a=y.buffers.map(b=>{const f=new Uint8Array(b);return m.VSBuffer.wrap(f)});return{message:I,buffers:a}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=D;function C(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function i(k,S){const y=S.map(a=>{const b=new ArrayBuffer(a.byteLength);return new Uint8Array(b).set(a.buffer),b}),T=S.length?(a,b)=>{if(typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const f=b,{index:w}=f,E=y[w];if(f.view)switch(f.view.type){case 1:return new Int8Array(E,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(E,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(E,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(E,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(E,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(E,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(E,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(E,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(E,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(E,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(E,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return E}return b}:void 0;return{message:JSON.parse(k,T),arrayBuffers:y}}e.deserializeWebviewMessage=i}),define(ge[204],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var m;(function(L){function D(i){const k=new Map;return i.types.forEach((S,y)=>{k.set(S,{asString:async()=>i.items[y].asString})}),k}L.toITreeDataTransfer=D;async function C(i){const k={types:[],items:[]},S=Array.from(i.entries());for(const y of S)k.types.push(y[0]),k.items.push({asString:await y[1].asString()});return k}L.toTreeDataTransferDTO=C})(m=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ge[88],pe([0,1,10,2]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function D(k,S){return k.scheme===m.Schemas.http||k.scheme===m.Schemas.https?k:(S&&S.authority&&S.isRemote&&k.scheme===m.Schemas.file&&(k=L.URI.from({scheme:m.Schemas.vscodeRemote,authority:S.authority,path:k.path})),L.URI.from({scheme:m.Schemas.https,authority:`${k.scheme}+${C(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=D;function C(k){return k.replace(/./g,S=>{const y=S.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?S:"-"+y.toString(16).padStart(4,"0")})}function i(k){return k.replace(/-([0-9a-f]{4})/g,(S,y)=>String.fromCharCode(parseInt(y,16)))}e.decodeAuthority=i}),define(ge[205],pe([0,1,3,6,88]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(k,S,y){this._proxy=k,this._editors=S,this._initData=y,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const T=S.getVisibleTextEditors();for(const I of this._insets.values())T.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,S,y,T,I){let a;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===k){a=o;break}if(!a)throw new Error("not a visible editor");const b=this,f=this._handlePool++,w=new m.Emitter,E=new m.Emitter,P=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,D.asWebviewUri)(o,b._initData.remote)}get cspSource(){return D.webviewGenericCspSource}set options(o){this._options=o,b._proxy.$setOptions(f,o)}get options(){return this._options}set html(o){this._html=o,b._proxy.$setHtml(f,o)}get html(){return this._html}get onDidReceiveMessage(){return w.event}postMessage(o){return b._proxy.$postMessage(f,o)}},p=new class{constructor(){this.editor=k,this.line=S,this.height=y,this.webview=P,this.onDidDispose=E.event}dispose(){b._insets.has(f)&&(b._insets.delete(f),b._proxy.$disposeEditorInset(f),E.fire(),E.dispose(),w.dispose())}};return this._proxy.$createEditorInset(f,a.id,a.value.document.uri,S+1,y,T||{},I.identifier,I.extensionLocation),this._insets.set(f,{editor:k,inset:p,onDidReceiveMessage:w}),p}$onDidDispose(k){const S=this._insets.get(k);S&&S.inset.dispose()}$onDidReceiveMessage(k,S){const y=this._insets.get(k);y&&y.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=C}),define(ge[206],pe([0,1,171,13,2,6,4,61,51,42,17,10]),function(Y,e,m,L,D,C,i,k,S,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,m.localize)(0,null),providerDisplayName:(0,m.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,m.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,m.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,m.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,m.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,m.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new k.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,m.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,m.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,m.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,m.localize)(10,null)),e.SideBySideEditorActiveContext=new k.RawContextKey("sideBySideEditorActive",!1,(0,m.localize)(11,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,m.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,m.localize)(13,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,m.localize)(14,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,m.localize)(15,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,m.localize)(16,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,m.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,m.localize)(18,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,m.localize)(19,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,m.localize)(20,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,m.localize)(21,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,m.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function a(O,F,$){for(const M of $.visibleEditorPanes)if(M.group.id===F&&O.matches(M.input))return M.getViewState()}e.findViewStateForEditor=a;function b(O){if(g(O))return!1;const F=O;return D.URI.isUri(F?.resource)}e.isResourceEditorInput=b;function f(O){if(g(O))return!1;const F=O;return F?.original!==void 0&&F.modified!==void 0}e.isResourceDiffEditorInput=f;function w(O){if(g(O)||f(O))return!1;const F=O;return F?.primary!==void 0&&F.secondary!==void 0}e.isResourceSideBySideEditorInput=w;function E(O){if(g(O))return!1;const F=O;return F?F.resource===void 0||F.resource.scheme===I.Schemas.untitled||F.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=E;var P;(function(O){O[O.SHORT=0]="SHORT",O[O.MEDIUM=1]="MEDIUM",O[O.LONG=2]="LONG"})(P=e.Verbosity||(e.Verbosity={}));var p;(function(O){O[O.EXPLICIT=1]="EXPLICIT",O[O.AUTO=2]="AUTO",O[O.FOCUS_CHANGE=3]="FOCUS_CHANGE",O[O.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(p=e.SaveReason||(e.SaveReason={}));var o;(function(O){O[O.None=0]="None",O[O.Readonly=2]="Readonly",O[O.Untitled=4]="Untitled",O[O.Singleton=8]="Singleton",O[O.RequiresTrust=16]="RequiresTrust",O[O.CanSplitInGroup=32]="CanSplitInGroup",O[O.ForceDescription=64]="ForceDescription"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class r extends C.Disposable{}e.AbstractEditorInput=r;function g(O){return O instanceof r}e.isEditorInput=g;function s(O){const F=O;return D.URI.isUri(F?.preferredResource)}function v(O){const F=O;return g(F?.primary)&&g(F?.secondary)}e.isSideBySideEditorInput=v;function n(O){const F=O;return g(F?.modified)&&g(F?.original)}e.isDiffEditorInput=n;function t(O){return g(O?.editor)}e.isEditorInputWithOptions=t;function u(O){const F=O;return t(O)&&F?.group!==void 0}e.isEditorInputWithOptionsAndGroup=u;function d(O){const F=O;return typeof F?.groupId=="number"&&g(F.editor)}e.isEditorIdentifier=d;var l;(function(O){O[O.UNKNOWN=0]="UNKNOWN",O[O.REPLACE=1]="REPLACE",O[O.MOVE=2]="MOVE",O[O.UNPIN=3]="UNPIN"})(l=e.EditorCloseContext||(e.EditorCloseContext={}));var h;(function(O){O[O.PRIMARY=1]="PRIMARY",O[O.SECONDARY=2]="SECONDARY",O[O.BOTH=3]="BOTH",O[O.ANY=4]="ANY"})(h=e.SideBySideEditor||(e.SideBySideEditor={}));class c{getOriginalUri(F,$){if(!F)return;if($?.supportSideBySide){const{primary:B,secondary:U}=this.getSideEditors(F);if(B&&U){if($?.supportSideBySide===h.BOTH)return{primary:this.getOriginalUri(B,{filterByScheme:$.filterByScheme}),secondary:this.getOriginalUri(U,{filterByScheme:$.filterByScheme})};if($?.supportSideBySide===h.ANY)return this.getOriginalUri(B,{filterByScheme:$.filterByScheme})??this.getOriginalUri(U,{filterByScheme:$.filterByScheme});F=$.supportSideBySide===h.PRIMARY?B:U}}if(f(F)||w(F))return;const M=s(F)?F.preferredResource:F.resource;return!M||!$||!$.filterByScheme?M:this.filterUri(M,$.filterByScheme)}getSideEditors(F){return v(F)||w(F)?{primary:F.primary,secondary:F.secondary}:n(F)||f(F)?{primary:F.modified,secondary:F.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(F,$){if(!F)return;if($?.supportSideBySide){const{primary:B,secondary:U}=this.getSideEditors(F);if(B&&U){if($?.supportSideBySide===h.BOTH)return{primary:this.getCanonicalUri(B,{filterByScheme:$.filterByScheme}),secondary:this.getCanonicalUri(U,{filterByScheme:$.filterByScheme})};if($?.supportSideBySide===h.ANY)return this.getCanonicalUri(B,{filterByScheme:$.filterByScheme})??this.getCanonicalUri(U,{filterByScheme:$.filterByScheme});F=$.supportSideBySide===h.PRIMARY?B:U}}if(f(F)||w(F))return;const M=F.resource;return!M||!$||!$.filterByScheme?M:this.filterUri(M,$.filterByScheme)}filterUri(F,$){if(Array.isArray($)){if($.some(M=>F.scheme===M))return F}else if($===F.scheme)return F}}e.EditorResourceAccessor=new c;var _;(function(O){O[O.LEFT=0]="LEFT",O[O.RIGHT=1]="RIGHT"})(_=e.CloseDirection||(e.CloseDirection={}));class A{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(F){const $=this.instantiationService=F.get(i.IInstantiationService);for(const[M,B]of this.editorSerializerConstructors)this.createEditorSerializer(M,B,$);this.editorSerializerConstructors.clear()}createEditorSerializer(F,$,M){const B=M.createInstance($);this.editorSerializerInstances.set(F,B)}registerFileEditorFactory(F){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=F}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(F,$){if(this.editorSerializerConstructors.has(F)||this.editorSerializerInstances.has(F))throw new Error(`A editor serializer with type ID '${F}' was already registered.`);return this.instantiationService?this.createEditorSerializer(F,$,this.instantiationService):this.editorSerializerConstructors.set(F,$),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(F),this.editorSerializerInstances.delete(F)})}getEditorSerializer(F){return this.editorSerializerInstances.get(typeof F=="string"?F:F.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new A);async function R(O,F){if(!O||!O.length)return[];const $=await Promise.all(O.map(async M=>{const B=D.URI.revive(M.fileUri);if(!B||!await F.canHandleResource(B))return;let z=M.exists,K=M.type;if(typeof z!="boolean"||typeof K!="number")try{K=(await F.resolve(B)).isFile?y.FileType.File:y.FileType.Unknown,z=!0}catch{z=!1}if(!z&&M.openOnlyIfExists||K!==y.FileType.File)return;const N={selection:z?M.selection:void 0,pinned:!0,override:M.editorOverrideId};let j;return z?j={resource:B,options:N}:j={resource:B,options:N,forceUntitled:!0},j}));return(0,T.coalesce)($)}e.pathsToEditors=R;var x;(function(O){O[O.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",O[O.SEQUENTIAL=1]="SEQUENTIAL"})(x=e.EditorsOrder||(e.EditorsOrder={}))}),define(ge[123],pe([0,1,3,18,172]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,S,y,T){const I={command:k};if(S&&Object.keys(S).length>0&&(I.arguments=S),this.internalSend("request",I),typeof T=="number"){const a=setTimeout(()=>{clearTimeout(a);const b=this.pendingRequests.get(I.seq);if(b){this.pendingRequests.delete(I.seq);const f={type:"response",seq:0,request_seq:I.seq,success:!1,command:k,message:(0,D.localize)(0,null,T,k)};b(f)}},T)}return y&&this.pendingRequests.set(I.seq,y),I.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,S){return k.type!=="event"||S.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,L.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const S=k,y=this.pendingRequests.get(S.request_seq);y&&(this.pendingRequests.delete(S.request_seq),y(S));break}}}internalSend(k,S){S.type=k,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((S,y)=>k.set(y,S)),await(0,L.timeout)(500),k.forEach((S,y)=>{S({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(y)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(ge[207],pe([0,1,8,2,9,25,10]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function S(n,t,u){return n.replace(k,function(d,l){return t&&l.length>0&&l[0]!=="_"?d:u&&u.hasOwnProperty(l)?u[l]:d})}e.formatPII=S;function y(n){const t={};for(const u of Object.keys(n))u.startsWith("!")||(t[u]=n[u]);return t}e.filterExceptionsFromTelemetry=y;function T(n){return n.configuration.request==="attach"&&!I(n)&&(!n.parentSession||T(n.parentSession))}e.isSessionAttach=T;function I(n){let t=n.configuration.type;if(!!t)return t==="vslsShare"&&(t=n.configuration.adapterProxy.configuration.type),(0,m.equalsIgnoreCase)(t,"extensionhost")||(0,m.equalsIgnoreCase)(t,"pwa-extensionhost")?n:n.parentSession?I(n.parentSession):void 0}e.getExtensionHostDebugSession=I;function a(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=a;function b(n,t,u){let d,l=0,h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,c=null;for(;c=h.exec(n);){let _=c.index+1,A=_+c[0].length;if(_<=t&&A>=u){d=c[0],l=_;break}}if(d){let _=/\w+/g,A=null;for(;(A=_.exec(d))&&!(A.index+1+l+A[0].length>=u););A&&(d=d.substring(0,_.lastIndex))}return d?{start:l,end:l+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=b;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function w(n){return!!(n&&n.match(f))}e.isUri=w;function E(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(w(n.path))return L.URI.parse(n.path);if((0,D.isAbsolute)(n.path))return L.URI.file(n.path)}return n.path}function P(n){if(typeof n.path=="object"){const t=L.URI.revive(n.path);if(t)return t.scheme===i.Schemas.file?t.fsPath:t.toString()}return n.path}function p(n,t){const u=t?E:P,d=(0,C.deepClone)(n);return r(d,(l,h)=>{l&&h&&(h.path=u(h))}),d}e.convertToDAPaths=p;function o(n,t){const u=t?E:P,d=(0,C.deepClone)(n);return r(d,(l,h)=>{!l&&h&&(h.path=u(h))}),d}e.convertToVSCPaths=o;function r(n,t){switch(n.type){case"event":const u=n;switch(u.event){case"output":t(!1,u.body.source);break;case"loadedSource":t(!1,u.body.source);break;case"breakpoint":t(!1,u.body.breakpoint.source);break;default:break}break;case"request":const d=n;switch(d.command){case"setBreakpoints":t(!0,d.arguments.source);break;case"breakpointLocations":t(!0,d.arguments.source);break;case"source":t(!0,d.arguments.source);break;case"gotoTargets":t(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(h=>t(!1,h));break;default:break}break;case"response":const l=n;if(l.success&&l.body)switch(l.command){case"stackTrace":l.body.stackFrames.forEach(h=>t(!1,h.source));break;case"loadedSources":l.body.sources.forEach(h=>t(!1,h));break;case"scopes":l.body.scopes.forEach(h=>t(!1,h.source));break;case"setFunctionBreakpoints":l.body.breakpoints.forEach(h=>t(!1,h.source));break;case"setBreakpoints":l.body.breakpoints.forEach(h=>t(!1,h.source));break;default:break}break}}function g(n){return n.filter(t=>!t.presentation?.hidden).sort((t,u)=>t.presentation?u.presentation?t.presentation.group?u.presentation.group?t.presentation.group!==u.presentation.group?t.presentation.group.localeCompare(u.presentation.group):s(t.presentation.order,u.presentation.order):-1:u.presentation.group?1:s(t.presentation.order,u.presentation.order):-1:u.presentation?1:0)}e.getVisibleAndSorted=g;function s(n,t){return typeof n!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:n-t}async function v(n,t){const u=n.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorMode});if(u!=="none"&&(await t.saveAll(),u==="allEditorsInActiveGroup")){const d=t.activeEditorPane;d&&await t.save({editor:d.input,groupId:d.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=v}),define(ge[208],pe([0,1,28,37,173,124,9,8,25,12,183,123]),function(Y,e,m,L,D,C,i,k,S,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class a extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(p,o){this.outputStream=o,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,p.on("data",r=>this.handleData(r))}sendMessage(p){if(this.outputStream){const o=JSON.stringify(p);this.outputStream.write(`Content-Length: ${Buffer.byteLength(o,"utf8")}${a.TWO_CRLF}${o}`,"utf8")}}handleData(p){for(this.rawData=Buffer.concat([this.rawData,p]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const o=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,o.length>0)try{this.acceptMessage(JSON.parse(o))}catch(r){this._onError.fire(new Error((r.message||r)+`
`+o))}continue}}else{const o=this.rawData.indexOf(a.TWO_CRLF);if(o!==-1){const g=this.rawData.toString("utf8",0,o).split(a.HEADER_LINESEPARATOR);for(const s of g){const v=s.split(a.HEADER_FIELDSEPARATOR);v[0]==="Content-Length"&&(this.contentLength=Number(v[1]))}this.rawData=this.rawData.slice(o+a.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=a,a.TWO_CRLF=`\r
\r
`,a.HEADER_LINESEPARATOR=/\r?\n/,a.HEADER_FIELDSEPARATOR=/: */;class b extends a{startSession(){return new Promise((p,o)=>{let r=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),p(),r=!0}),this.socket.on("close",()=>{r?this._onError.fire(new Error("connection closed")):o(new Error("connection closed"))}),this.socket.on("error",g=>{r?this._onError.fire(g):o(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=b;class f extends b{constructor(p){super();this.adapterServer=p}createConnection(p){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",p)}}e.SocketDebugAdapter=f;class w extends b{constructor(p){super();this.adapterServer=p}createConnection(p){return C.createConnection(this.adapterServer.path,p)}}e.NamedPipeDebugAdapter=w;class E extends a{constructor(p,o,r){super();this.adapterExecutable=p,this.debugType=o,this.outputService=r}async startSession(){const p=this.adapterExecutable.command,o=this.adapterExecutable.args,r=this.adapterExecutable.options||{};try{if(p)if(i.isAbsolute(p)){if(!await m.Promises.exists(p))throw new Error(D.localize(0,null,p))}else p.indexOf("/")<0&&p.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.debugType));let g=process.env;if(r.env&&Object.keys(r.env).length>0&&(g=S.mixin(S.deepClone(process.env),r.env)),p==="node")if(Array.isArray(o)&&o.length>0){const v=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,n={env:g,execArgv:v?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};r.cwd&&(n.cwd=r.cwd);const t=L.fork(o[0],o.slice(1),n);if(!t.pid)throw new Error(D.localize(2,null,o[0]));this.serverProcess=t}else throw new Error(D.localize(3,null));else{const v={env:g};r.cwd&&(v.cwd=r.cwd),this.serverProcess=L.spawn(p,o,v)}this.serverProcess.on("error",v=>{this._onError.fire(v)}),this.serverProcess.on("exit",(v,n)=>{this._onExit.fire(v)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",v=>{this._onError.fire(v)}),this.serverProcess.stdin.on("error",v=>{this._onError.fire(v)});const s=this.outputService;if(s){const v=n=>n.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",n=>{const t=s.getChannel(T.ExtensionsChannelId);t&&t.append(v(n))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),y.isWindows?new Promise((p,o)=>{const r=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,s,v){if(g)return o(g)});r.on("exit",p),r.on("error",o)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(p,o){if(!p)return;const r=Object.create(null);p.runtime&&(p.runtime.indexOf("./")===0?r.runtime=i.join(o,p.runtime):r.runtime=p.runtime),p.runtimeArgs&&(r.runtimeArgs=p.runtimeArgs),p.program&&(i.isAbsolute(p.program)?r.program=p.program:r.program=i.join(o,p.program)),p.args&&(r.args=p.args);const g=p;return g.win&&(r.win=E.extract(g.win,o)),g.winx86&&(r.winx86=E.extract(g.winx86,o)),g.windows&&(r.windows=E.extract(g.windows,o)),g.osx&&(r.osx=E.extract(g.osx,o)),g.linux&&(r.linux=E.extract(g.linux,o)),r}static platformAdapterExecutable(p,o){let r=Object.create(null);o=o.toLowerCase();for(const u of p)if(u.contributes){const d=u.contributes.debuggers;d&&d.length>0&&d.filter(l=>typeof l.type=="string"&&k.equalsIgnoreCase(l.type,o)).forEach(l=>{const h=E.extract(l,u.extensionLocation.fsPath);r=S.mixin(r,h,u.isBuiltin)})}let g;y.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=r.winx86||r.win||r.windows:y.isWindows?g=r.win||r.windows:y.isMacintosh?g=r.osx:y.isLinux&&(g=r.linux),g=g||r;let s=g.program||r.program;const v=g.args||r.args;let n=g.runtime||r.runtime;const t=g.runtimeArgs||r.runtimeArgs;if(n)return{type:"executable",command:n,args:(t||[]).concat(typeof s=="string"?[s]:[]).concat(v||[])};if(s)return{type:"executable",command:s,args:v||[]}}}e.ExecutableDebugAdapter=E}),define(ge[209],pe([0,1,37,12,30,185]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function i(a,b){return new Promise((f,w)=>{let E="";const P=m.spawn(a,b);P.pid&&P.stdout.on("data",p=>{E+=p.toString()}),P.on("error",p=>{w(p)}),P.on("close",p=>{f(E)})})}let k;function S(a,b){if(!k)if(L.isWindows)k=new C.WindowsExternalTerminalService;else if(L.isMacintosh)k=new C.MacExternalTerminalService;else if(L.isLinux)k=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const f=b.getConfiguration("terminal");return k.runInTerminal(a.title,a.cwd,a.args,a.env||{},f.external||{})}e.runInExternalTerminal=S;async function y(a){if(a)if(L.isWindows){const b=await new Promise((f,w)=>{Y(["windows-process-tree"],f,w)});return new Promise(f=>{b.getProcessTree(a,w=>{f(w.children.length>0)})})}else return i("/usr/bin/pgrep",["-lP",String(a)]).then(b=>{const f=b.trim();return!(f.length===0||f.indexOf(" tmux")>=0)},b=>!0);return Promise.resolve(!0)}e.hasChildProcesses=y;var T;(function(a){a[a.cmd=0]="cmd",a[a.powershell=1]="powershell",a[a.bash=2]="bash"})(T||(T={}));function I(a,b,f,w){a=a.trim().toLowerCase();let E;a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0?E=1:a.indexOf("cmd.exe")>=0?E=0:a.indexOf("bash")>=0?E=2:L.isWindows?E=0:E=2;let P,p=" ";switch(E){case 1:if(P=r=>(r=r.replace(/\'/g,"''"),r.length>0&&r.charAt(r.length-1)==="\\"?`'${r}\\'`:`'${r}'`),f){const r=(0,D.getDriveLetter)(f);r&&(p+=`${r}:; `),p+=`cd ${P(f)}; `}if(w)for(let r in w){const g=w[r];g===null?p+=`Remove-Item env:${r}; `:p+=`\${env:${r}}='${g}'; `}if(b.length>0){const r=P(b.shift());p+=r[0]==="'"?`& ${r} `:`${r} `;for(let g of b)p+=`${P(g)} `}break;case 0:if(P=r=>(r=r.replace(/\"/g,'""'),r.indexOf(" ")>=0||r.indexOf('"')>=0||r.length===0?`"${r}"`:r),f){const r=(0,D.getDriveLetter)(f);r&&(p+=`${r}: && `),p+=`cd ${P(f)} && `}if(w){p+='cmd /C "';for(let r in w){let g=w[r];g===null?p+=`set "${r}=" && `:(g=g.replace(/[\^\&\|\<\>]/g,s=>`^${s}`),p+=`set "${r}=${g}" && `)}}for(let r of b)p+=`${P(r)} `;w&&(p+='"');break;case 2:P=r=>(r=r.replace(/(["'\\\$])/g,"\\$1"),r.indexOf(" ")>=0||r.indexOf(";")>=0||r.length===0?`"${r}"`:r);const o=r=>/[^\w@%\/+=,.:^-]/.test(r)?`'${r.replace(/'/g,"'\\''")}'`:r;if(f&&(p+=`cd ${P(f)} ; `),w){p+="/usr/bin/env";for(let r in w){const g=w[r];g===null?p+=` -u ${o(r)}`:p+=` ${o(`${r}=${g}`)}`}p+=" "}for(let r of b)p+=`${P(r)} `;break}return p}e.prepareCommand=I}),define(ge[125],pe([0,1,31,76,101,10,9,12,61]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var y;(function(_){_[_.Markup=1]="Markup",_[_.Code=2]="Code"})(y=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",D.Mimes.latex,D.Mimes.markdown,"image/png","image/jpeg",D.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[D.Mimes.latex,D.Mimes.markdown,"application/json",D.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(_){_[_.Running=1]="Running",_[_.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var I;(function(_){_[_.Pending=2]="Pending",_[_.Executing=3]="Executing"})(I=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var a;(function(_){_[_.WithHardKernelDependency=0]="WithHardKernelDependency",_[_.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",_[_.Pure=2]="Pure",_[_.Never=3]="Never"})(a=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var b;(function(_){_.Always="always",_.Never="never",_.Optional="optional"})(b=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(_){_[_.ModelChange=1]="ModelChange",_[_.Move=2]="Move",_[_.ChangeLanguage=5]="ChangeLanguage",_[_.Initialize=6]="Initialize",_[_.ChangeCellMetadata=7]="ChangeCellMetadata",_[_.Output=8]="Output",_[_.OutputItem=9]="OutputItem",_[_.ChangeCellContent=10]="ChangeCellContent",_[_.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",_[_.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",_[_.ChangeCellMime=13]="ChangeCellMime",_[_.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var w;(function(_){_[_.Handle=0]="Handle",_[_.Index=1]="Index"})(w=e.SelectionStateType||(e.SelectionStateType={}));var E;(function(_){_[_.Replace=1]="Replace",_[_.Output=2]="Output",_[_.Metadata=3]="Metadata",_[_.CellLanguage=4]="CellLanguage",_[_.DocumentMetadata=5]="DocumentMetadata",_[_.Move=6]="Move",_[_.OutputItems=7]="OutputItems",_[_.PartialMetadata=8]="PartialMetadata",_[_.PartialInternalMetadata=9]="PartialInternalMetadata"})(E=e.CellEditType||(e.CellEditType={}));var P;(function(_){_.scheme=C.Schemas.vscodeNotebookCell;const A=/^ch(\d{7,})/;function R(B,U){return B.with({scheme:_.scheme,fragment:`ch${U.toString().padStart(7,"0")}${B.scheme!==C.Schemas.file?B.scheme:""}`})}_.generate=R;function x(B){if(B.scheme!==_.scheme)return;const U=A.exec(B.fragment);return U?{handle:Number(U[1]),notebook:B.with({scheme:B.fragment.substr(U[0].length)||C.Schemas.file,fragment:null})}:void 0}_.parse=x;function O(B,U,z){return B.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`ch${U.toString().padStart(7,"0")},${z??""},${B.scheme!==C.Schemas.file?B.scheme:""}`})}_.generateCellOutputUri=O;function F(B){if(B.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const U=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(B.fragment);if(!U)return;const z=Number(U[1]),K=U[2]&&U[2]!==""?U[2]:void 0,N=U[3];return{handle:z,outputId:K,notebook:B.with({scheme:N||C.Schemas.file,fragment:null})}}_.parseCellOutputUri=F;function $(B,U,z){return B.with({scheme:z,fragment:`ch${U.toString().padStart(7,"0")}${B.scheme!==C.Schemas.file?B.scheme:""}`})}_.generateCellUri=$;function M(B,U){if(B.scheme!==U)return;const z=A.exec(B.fragment);return z?{handle:Number(z[1]),notebook:B.with({scheme:B.fragment.substr(z[0].length)||C.Schemas.file,fragment:null})}:void 0}_.parseCellUri=M})(P=e.CellUri||(e.CellUri={}));const p=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[D.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[D.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function o(_){return p.get(_)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=o;function r(_){return p.get(_)?.supportedByCore??!1}e.mimeTypeSupportedByCore=r;function g(_){return p.get(_)?.mergeable??!1}e.mimeTypeIsMergeable=g;const s=_=>k.isWindows?_.replace(/\//g,"\\"):_;class v{constructor(A=[],R=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=R,this.order=[...new Set(A)].map(x=>({pattern:x,matches:m.parse(s(x))}))}sort(A){const R=new Map(L.Iterable.map(A,O=>[O,s(O)]));let x=[];for(const{matches:O}of this.order)for(const[F,$]of R)if(O($)){x.push(F),R.delete(F);break}return R.size&&(x=x.concat([...R.keys()].sort((O,F)=>this.defaultOrder.indexOf(O)-this.defaultOrder.indexOf(F)))),x}prioritize(A,R){const x=this.findIndex(A);if(x===-1){this.order.unshift({pattern:A,matches:m.parse(s(A))});return}const O=new Set(R.map($=>this.findIndex($,x)));O.delete(-1);const F=Array.from(O).sort();this.order.splice(x+1,0,...F.map($=>this.order[$]));for(let $=F.length-1;$>=0;$--)this.order.splice(F[$],1)}toArray(){return this.order.map(A=>A.pattern)}findIndex(A,R=this.order.length){const x=s(A);for(let O=0;O<R;O++)if(this.order[O].matches(x))return O;return-1}}e.MimeTypeDisplayOrder=v;function n(_,A,R,x=(O,F)=>O===F){const O=[];function F(B,U,z){if(U===0&&z.length===0)return;const K=O[O.length-1];K&&K.start+K.deleteCount===B?(K.deleteCount+=U,K.toInsert.push(...z)):O.push({start:B,deleteCount:U,toInsert:z})}let $=0,M=0;for(;;){if($===_.length){F($,0,A.slice(M));break}if(M===A.length){F($,_.length-$,[]);break}const B=_[$],U=A[M];if(x(B,U)){$+=1,M+=1;continue}R(U)?(F($,1,[]),$+=1):(F($,0,[U]),M+=1)}return O}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(_){_.default="default",_.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(_){const A=_;return!!((typeof A.include=="string"||m.isRelativePattern(A.include))&&(typeof A.exclude=="string"||m.isRelativePattern(A.exclude)))}e.isDocumentExcludePattern=u;function d(_,A,R){if(Array.isArray(_.viewType)&&_.viewType.indexOf(A)>=0||_.viewType===A)return!0;if(_.filenamePattern){let x=u(_.filenamePattern)?_.filenamePattern.include:_.filenamePattern,O=u(_.filenamePattern)?_.filenamePattern.exclude:void 0;if(m.match(x,(0,i.basename)(R.fsPath).toLowerCase()))return!(O&&m.match(O,(0,i.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d;class l{constructor(A){this.textModel=A}getElements(){const A=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)A[R]=this.textModel.cells[R].getHashValue();return A}}e.CellSequence=l,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var h;(function(_){_[_.Left=1]="Left",_[_.Right=2]="Right"})(h=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class c{static create(A){return`${c._prefix}${A}`}static parse(A){if(A.startsWith(c._prefix))return A.substr(c._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=c,c._prefix="notebook/"}),define(ge[210],pe([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState",D[D.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,m.createDecorator)("INotebookExecutionService")}),define(ge[211],pe([0,1,4,61]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new L.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new L.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new L.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,m.createDecorator)(e.OUTPUT_SERVICE_ID);var D;(function(C){C[C.Append=1]="Append",C[C.Replace=2]="Replace",C[C.Clear=3]="Clear"})(D=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(ge[212],pe([0,1,175,4,61]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new D.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new D.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new D.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[213],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=m;function L(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=L}),define(ge[126],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var m;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(m=e.TestResultState||(e.TestResultState={}));var L;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var D;(function(I){I[I.Error=0]="Error",I[I.Info=1]="Info"})(D=e.TestMessageType||(e.TestMessageType={}));var C;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const i=(I,a)=>{a.expand!==void 0&&(I.expand=a.expand),a.item!==void 0&&(I.item=I.item?Object.assign(I.item,a.item):a.item)};e.applyTestItemUpdate=i;var k;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var S;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.Remove=2]="Remove",I[I.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",I[I.Retire=4]="Retire",I[I.AddTag=5]="AddTag",I[I.RemoveTag=6]="RemoveTag"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class y{add(a){}update(a){}remove(a,b){}complete(){}}e.IncrementalChangeCollector=y;class T{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(a){const b=this.createChangeCollector();for(const f of a)switch(f[0]){case 0:{const w=f[1];if(w.parent){if(this.items.has(w.parent)){const E=this.items.get(w.parent);E.children.add(w.item.extId);const P=this.createItem(w,E);this.items.set(w.item.extId,P),b.add(P)}}else{const E=this.createItem(w);this.roots.add(E),this.items.set(w.item.extId,E),b.add(E)}w.expand===2&&this.busyControllerCount++;break}case 1:{const w=f[1],E=this.items.get(w.extId);if(!E)break;w.expand!==void 0&&(E.expand===2&&this.busyControllerCount--,w.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(E,w),b.update(E);break}case 2:{const w=this.items.get(f[1]);if(!w)break;w.parent?this.items.get(w.parent).children.delete(w.item.extId):this.roots.delete(w);const E=[[f[1]]];for(;E.length;)for(const P of E.pop()){const p=this.items.get(P);p&&(E.push(p.children),this.items.delete(P),b.remove(p,p!==w),p.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(f[1]);break;case 3:this.updatePendingRoots(f[1]);break;case 5:this._tags.set(f[1].id,f[1]);break;case 6:this._tags.delete(f[1]);break}b.complete()}retireTest(a){}updatePendingRoots(a){this.pendingRootCount+=a}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=T}),define(ge[89],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var m;(function(C){C.Delimiter="\0"})(m=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class D{constructor(i,k=i.length){if(this.path=i,this.viewEnd=k,i.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(i,k,S=i.parent){if(i.id===k)return new D([k]);let y=[i.id];for(let T=S;T&&T.id!==k;T=T.parent)y.push(T.id);return y.push(k),new D(y.reverse())}static isRoot(i){return!i.includes("\0")}static fromString(i){return new D(i.split("\0"))}static join(i,k){return new D([...i.path,k])}static joinToString(i,k){return i.toString()+"\0"+k}static compare(i,k){return i===k?0:k.startsWith(i+"\0")?2:i.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let i=1;i<=this.viewEnd;i++)yield new D(this.path,i)}compare(i){if(typeof i=="string")return D.compare(this.toString(),i);for(let k=0;k<i.viewEnd&&k<this.viewEnd;k++)if(i.path[k]!==this.path[k])return 1;return i.viewEnd>this.viewEnd?2:i.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let i=1;i<this.viewEnd;i++)this.stringifed+="\0",this.stringifed+=this.path[i]}return this.stringifed}}e.TestId=D}),define(ge[214],pe([0,1,9,40,13,25,12,80,176]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class y{constructor(I,a,b){this._contributedVariables=new Map,this._context=I,this._labelService=a,b&&(this._envVariablesPromise=b.then(f=>this.prepareEnv(f)))}prepareEnv(I){if(i.isWindows){const a=Object.create(null);return Object.keys(I).forEach(b=>{a[b.toLowerCase()]=I[b]}),a}return I}resolveWithEnvironment(I,a,b){return this.recursiveResolve(this.prepareEnv(I),a?a.uri:void 0,b)}async resolveAsync(I,a){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,a)}async resolveAnyBase(I,a,b,f){const w=C.deepClone(a);return i.isWindows&&w.windows?Object.keys(w.windows).forEach(E=>w[E]=w.windows[E]):i.isMacintosh&&w.osx?Object.keys(w.osx).forEach(E=>w[E]=w.osx[E]):i.isLinux&&w.linux&&Object.keys(w.linux).forEach(E=>w[E]=w.linux[E]),delete w.windows,delete w.osx,delete w.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,w,b,f)}async resolveAnyAsync(I,a,b){return this.resolveAnyBase(I,a,b)}async resolveAnyMap(I,a,b){const f=new Map;return{newConfig:await this.resolveAnyBase(I,a,b,f),resolvedVariables:f}}resolveWithInteractionReplace(I,a,b,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,a,b,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,a){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,a)}recursiveResolve(I,a,b,f,w){if(D.isString(b))return this.resolveString(I,a,b,f,w);if(D.isArray(b))return b.map(E=>this.recursiveResolve(I,a,E,f,w));if(D.isObject(b)){let E=Object.create(null);return Object.keys(b).forEach(P=>{const p=this.resolveString(I,a,P,f,w);E[p]=this.recursiveResolve(I,a,b[P],f,w)}),E}return b}resolveString(I,a,b,f,w){return b.replace(y.VARIABLE_REGEXP,(P,p)=>{if(p.includes(y.VARIABLE_LHS))return P;let o=this.evaluateSingleVariable(I,P,p,a,f);return w&&w.set(p,o),o!==P&&D.isString(o)&&o.match(y.VARIABLE_REGEXP)&&(o=this.resolveString(I,a,o,f,w)),o})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,a,b,f,w){let E;const P=b.split(":");P.length>1&&(b=P[0],E=P[1]);const p=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error((0,S.localize)(0,null,a))},o=()=>{const g=p();if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return s}throw new Error((0,S.localize)(1,null,a,m.basename(g)))},r=()=>{if(E){const g=this._context.getFolderUri(E);if(g)return g;throw new Error((0,S.localize)(2,null,a,E))}if(f)return f;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,a)):new Error((0,S.localize)(4,null,a))};switch(b){case"env":if(E){if(I){const g=I[i.isWindows?E.toLowerCase():E];if(D.isString(g))return g}return""}throw new Error((0,S.localize)(5,null,a));case"config":if(E){const g=this._context.getConfigurationValue(f,E);if(D.isUndefinedOrNull(g))throw new Error((0,S.localize)(6,null,a,E));if(D.isObject(g))throw new Error((0,S.localize)(7,null,a,E));return g}throw new Error((0,S.localize)(8,null,a));case"command":return this.resolveFromMap(a,E,w,"command");case"input":return this.resolveFromMap(a,E,w,"input");default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(r()));case"cwd":return f||E?(0,k.normalizeDriveLetter)(this.fsPath(r())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(r()));case"lineNumber":const g=this._context.getLineNumber();if(g)return g;throw new Error((0,S.localize)(9,null,a));case"selectedText":const s=this._context.getSelectedText();if(s)return s;throw new Error((0,S.localize)(10,null,a));case"file":return p();case"fileWorkspaceFolder":return o();case"relativeFile":return f||E?m.relative(this.fsPath(r()),p()):p();case"relativeFileDirname":const v=m.dirname(p());if(f||E){const d=m.relative(this.fsPath(r()),v);return d.length===0?".":d}return v;case"fileDirname":return m.dirname(p());case"fileExtname":return m.extname(p());case"fileBasename":return m.basename(p());case"fileBasenameNoExtension":const n=m.basename(p());return n.slice(0,n.length-m.extname(n).length);case"fileDirnameBasename":return m.basename(m.dirname(p()));case"execPath":const t=this._context.getExecPath();return t||a;case"execInstallFolder":const u=this._context.getAppRoot();return u||a;case"pathSeparator":return m.sep;default:try{const d=E?`${b}:${E}`:b;return this.resolveFromMap(a,d,w,void 0)}catch(d){return a}}}}resolveFromMap(I,a,b,f){if(a&&b){const w=f===void 0?b[a]:b[f+":"+a];if(typeof w=="string")return w;throw new Error((0,S.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=y,y.VARIABLE_LHS="${",y.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[127],pe([0,1,4,206]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,m.createDecorator)("editorGroupsService");var D;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var C;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var i;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(i=e.GroupLocation||(e.GroupLocation={}));var k;(function(w){w[w.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function y(w){const E=w;return(0,L.isEditorInput)(E?.editor)&&(0,L.isEditorInput)(E?.replacement)}e.isEditorReplacement=y;var T;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(w){w[w.GROUP_ACTIVE=0]="GROUP_ACTIVE",w[w.GROUP_INDEX=1]="GROUP_INDEX",w[w.GROUP_LOCKED=2]="GROUP_LOCKED",w[w.EDITOR_OPEN=3]="EDITOR_OPEN",w[w.EDITOR_CLOSE=4]="EDITOR_CLOSE",w[w.EDITOR_MOVE=5]="EDITOR_MOVE",w[w.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",w[w.EDITOR_LABEL=7]="EDITOR_LABEL",w[w.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",w[w.EDITOR_PIN=9]="EDITOR_PIN",w[w.EDITOR_STICKY=10]="EDITOR_STICKY",w[w.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var a;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(a=e.OpenEditorContext||(e.OpenEditorContext={}));function b(w){const E=w;return!!E&&typeof E.id=="number"&&Array.isArray(E.editors)}e.isEditorGroup=b;function f(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=f}),define(ge[215],pe([0,1,4,127]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,m.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(C){const i=C;return typeof C=="number"||(0,L.isEditorGroup)(i)}e.isPreferredGroup=D}),define(ge[16],pe([0,1,17,22,97,290,59,25,13,2,41,84,177,116,63,125,89,215,7]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(ce){function _e(X){const{selectionStartLineNumber:De,selectionStartColumn:Le,positionLineNumber:et,positionColumn:qe}=X,mt=new p.Position(De-1,Le-1),_t=new p.Position(et-1,qe-1);return new p.Selection(mt,_t)}ce.to=_e;function le(X){const{anchor:De,active:Le}=X;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ce.from=le})(o=e.Selection||(e.Selection={}));var r;(function(ce){function _e(X){if(!X)return;const{start:De,end:Le}=X;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}ce.from=_e;function le(X){if(!X)return;const{startLineNumber:De,startColumn:Le,endLineNumber:et,endColumn:qe}=X;return new p.Range(De-1,Le-1,et-1,qe-1)}ce.to=le})(r=e.Range||(e.Range={}));var g;(function(ce){function _e(le){switch(le){case 1:return p.StandardTokenType.Comment;case 0:return p.StandardTokenType.Other;case 4:return p.StandardTokenType.RegEx;case 2:return p.StandardTokenType.String}}ce.to=_e})(g=e.TokenType||(e.TokenType={}));var s;(function(ce){function _e(X){return new p.Position(X.lineNumber-1,X.column-1)}ce.to=_e;function le(X){return{lineNumber:X.line+1,column:X.character+1}}ce.from=le})(s=e.Position||(e.Position={}));var v;(function(ce){function _e(De,Le){return(0,m.coalesce)((0,m.asArray)(De).map(et=>le(et,Le)))}ce.from=_e;function le(De,Le){if(typeof De=="string")return{$serialized:!0,language:De};if(De)return{$serialized:!0,language:De.language,scheme:X(De.scheme,Le),pattern:typeof De.pattern=="undefined"?void 0:Ge.from(De.pattern),exclusive:De.exclusive}}function X(De,Le){return Le&&typeof De=="string"?Le.transformOutgoingScheme(De):De}})(v=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(ce){function _e(X){switch(X){case p.DiagnosticTag.Unnecessary:return 1;case p.DiagnosticTag.Deprecated:return 2}}ce.from=_e;function le(X){switch(X){case 1:return p.DiagnosticTag.Unnecessary;case 2:return p.DiagnosticTag.Deprecated;default:return}}ce.to=le})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(ce){function _e(X){let De;return X.code&&((0,S.isString)(X.code)||(0,S.isNumber)(X.code)?De=String(X.code):De={value:String(X.code.value),target:X.code.target}),{...r.from(X.range),message:X.message,source:X.source,code:De,severity:d.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(u.from),tags:Array.isArray(X.tags)?(0,m.coalesce)(X.tags.map(n.from)):void 0}}ce.from=_e;function le(X){const De=new p.Diagnostic(r.to(X),X.message,d.to(X.severity));return De.source=X.source,De.code=(0,S.isString)(X.code)?X.code:X.code?.value,De.relatedInformation=X.relatedInformation&&X.relatedInformation.map(u.to),De.tags=X.tags&&(0,m.coalesce)(X.tags.map(n.to)),De}ce.to=le})(t=e.Diagnostic||(e.Diagnostic={}));var u;(function(ce){function _e(X){return{...r.from(X.location.range),message:X.message,resource:X.location.uri}}ce.from=_e;function le(X){return new p.DiagnosticRelatedInformation(new p.Location(X.resource,r.to(X)),X.message)}ce.to=le})(u=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var d;(function(ce){function _e(X){switch(X){case p.DiagnosticSeverity.Error:return b.MarkerSeverity.Error;case p.DiagnosticSeverity.Warning:return b.MarkerSeverity.Warning;case p.DiagnosticSeverity.Information:return b.MarkerSeverity.Info;case p.DiagnosticSeverity.Hint:return b.MarkerSeverity.Hint}return b.MarkerSeverity.Error}ce.from=_e;function le(X){switch(X){case b.MarkerSeverity.Info:return p.DiagnosticSeverity.Information;case b.MarkerSeverity.Warning:return p.DiagnosticSeverity.Warning;case b.MarkerSeverity.Error:return p.DiagnosticSeverity.Error;case b.MarkerSeverity.Hint:return p.DiagnosticSeverity.Hint;default:return p.DiagnosticSeverity.Error}}ce.to=le})(d=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var l;(function(ce){function _e(X){return typeof X=="number"&&X>=p.ViewColumn.One?X-1:X===p.ViewColumn.Beside?P.SIDE_GROUP:P.ACTIVE_GROUP}ce.from=_e;function le(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}ce.to=le})(l=e.ViewColumn||(e.ViewColumn={}));function h(ce){return typeof ce.range!="undefined"}function c(ce){return ce.length===0?!0:!!h(ce[0])}e.isDecorationOptionsArr=c;var _;(function(ce){function _e(qe){return qe.map(ce.from)}ce.fromMany=_e;function le(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function X(qe){let mt;if(le(qe)){const{language:gt,value:Et}=qe;mt={value:"```"+gt+`
`+Et+"\n```\n"}}else p.MarkdownString.isMarkdownString(qe)?mt={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml}:typeof qe=="string"?mt={value:qe}:mt={value:""};const _t=Object.create(null);mt.uris=_t;const kt=gt=>{try{let Et=y.URI.parse(gt,!0);Et=Et.with({query:De(Et.query,_t)}),_t[gt]=Et}catch(Et){}return""},bt=new C.Renderer;return bt.link=kt,bt.image=gt=>kt(D.parseHrefAndDimensions(gt).href),C(mt.value,{renderer:bt}),mt}ce.from=X;function De(qe,mt){if(!qe)return qe;let _t;try{_t=(0,i.parse)(qe)}catch(bt){}if(!_t)return qe;let kt=!1;return _t=(0,k.cloneAndChange)(_t,bt=>{if(y.URI.isUri(bt)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return mt[gt]=bt,kt=!0,gt}else return}),kt?JSON.stringify(_t):qe}function Le(qe){const mt=new p.MarkdownString(qe.value,qe.supportThemeIcons);return mt.isTrusted=qe.isTrusted,mt.supportHtml=qe.supportHtml,mt}ce.to=Le;function et(qe){if(!!qe)return typeof qe=="string"?qe:ce.from(qe)}ce.fromStrict=et})(_=e.MarkdownString||(e.MarkdownString={}));function A(ce){return c(ce)?ce.map(_e=>({range:r.from(_e.range),hoverMessage:Array.isArray(_e.hoverMessage)?_.fromMany(_e.hoverMessage):_e.hoverMessage?_.from(_e.hoverMessage):void 0,renderOptions:_e.renderOptions})):ce.map(_e=>({range:r.from(_e)}))}e.fromRangeOrRangeWithMessage=A;function R(ce){return typeof ce=="undefined"?ce:typeof ce=="string"?y.URI.file(ce):ce}e.pathOrURIToURI=R;var x;(function(ce){function _e(le){return typeof le=="undefined"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?R(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}ce.from=_e})(x=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var O;(function(ce){function _e(le){return typeof le=="undefined"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?R(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?x.from(le.before):void 0,after:le.after?x.from(le.after):void 0}}ce.from=_e})(O=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(ce){function _e(le){if(typeof le=="undefined")return le;switch(le){case p.DecorationRangeBehavior.OpenOpen:return 0;case p.DecorationRangeBehavior.ClosedClosed:return 1;case p.DecorationRangeBehavior.OpenClosed:return 2;case p.DecorationRangeBehavior.ClosedOpen:return 3}}ce.from=_e})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var $;(function(ce){function _e(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?F.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?O.from(le.light):void 0,dark:le.dark?O.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?R(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?x.from(le.before):void 0,after:le.after?x.from(le.after):void 0}}ce.from=_e})($=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var M;(function(ce){function _e(X){return{text:X.newText,eol:X.newEol&&Ae.from(X.newEol),range:r.from(X.range)}}ce.from=_e;function le(X){const De=new p.TextEdit(r.to(X.range),X.text);return De.newEol=typeof X.eol=="undefined"?void 0:Ae.to(X.eol),De}ce.to=le})(M=e.TextEdit||(e.TextEdit={}));var B;(function(ce){function _e(X,De,Le){const et={edits:[]};if(X instanceof p.WorkspaceEdit)for(let qe of X._allEntries())if(qe._type===1)et.edits.push({_type:1,oldUri:qe.from,newUri:qe.to,options:qe.options,metadata:qe.metadata});else if(qe._type===2){const mt=De?.getDocument(qe.uri);et.edits.push({_type:2,resource:qe.uri,edit:M.from(qe.edit),modelVersionId:mt?.version,metadata:qe.metadata})}else qe._type===3?et.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,edit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Le?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version}):qe._type===5&&et.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,notebookVersionId:Le?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(We.from)}});return et}ce.from=_e;function le(X){const De=new p.WorkspaceEdit;for(const Le of X.edits)Le.edit?De.replace(y.URI.revive(Le.resource),r.to(Le.edit.range),Le.edit.text):De.renameFile(y.URI.revive(Le.oldUri),y.URI.revive(Le.newUri),Le.options);return De}ce.to=le})(B=e.WorkspaceEdit||(e.WorkspaceEdit={}));var U;(function(ce){const _e=Object.create(null);_e[p.SymbolKind.File]=0,_e[p.SymbolKind.Module]=1,_e[p.SymbolKind.Namespace]=2,_e[p.SymbolKind.Package]=3,_e[p.SymbolKind.Class]=4,_e[p.SymbolKind.Method]=5,_e[p.SymbolKind.Property]=6,_e[p.SymbolKind.Field]=7,_e[p.SymbolKind.Constructor]=8,_e[p.SymbolKind.Enum]=9,_e[p.SymbolKind.Interface]=10,_e[p.SymbolKind.Function]=11,_e[p.SymbolKind.Variable]=12,_e[p.SymbolKind.Constant]=13,_e[p.SymbolKind.String]=14,_e[p.SymbolKind.Number]=15,_e[p.SymbolKind.Boolean]=16,_e[p.SymbolKind.Array]=17,_e[p.SymbolKind.Object]=18,_e[p.SymbolKind.Key]=19,_e[p.SymbolKind.Null]=20,_e[p.SymbolKind.EnumMember]=21,_e[p.SymbolKind.Struct]=22,_e[p.SymbolKind.Event]=23,_e[p.SymbolKind.Operator]=24,_e[p.SymbolKind.TypeParameter]=25;function le(De){return typeof _e[De]=="number"?_e[De]:6}ce.from=le;function X(De){for(const Le in _e)if(_e[Le]===De)return Number(Le);return p.SymbolKind.Property}ce.to=X})(U=e.SymbolKind||(e.SymbolKind={}));var z;(function(ce){function _e(X){switch(X){case p.SymbolTag.Deprecated:return 1}}ce.from=_e;function le(X){switch(X){case 1:return p.SymbolTag.Deprecated}}ce.to=le})(z=e.SymbolTag||(e.SymbolTag={}));var K;(function(ce){function _e(X){return{name:X.name,kind:U.from(X.kind),tags:X.tags&&X.tags.map(z.from),containerName:X.containerName,location:q.from(X.location)}}ce.from=_e;function le(X){const De=new p.SymbolInformation(X.name,U.to(X.kind),X.containerName,q.to(X.location));return De.tags=X.tags&&X.tags.map(z.to),De}ce.to=le})(K=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var N;(function(ce){function _e(X){const De={name:X.name||"!!MISSING: name!!",detail:X.detail,range:r.from(X.range),selectionRange:r.from(X.selectionRange),kind:U.from(X.kind),tags:X.tags?.map(z.from)??[]};return X.children&&(De.children=X.children.map(_e)),De}ce.from=_e;function le(X){const De=new p.DocumentSymbol(X.name,X.detail,U.to(X.kind),r.to(X.range),r.to(X.selectionRange));return(0,m.isNonEmptyArray)(X.tags)&&(De.tags=X.tags.map(z.to)),X.children&&(De.children=X.children.map(le)),De}ce.to=le})(N=e.DocumentSymbol||(e.DocumentSymbol={}));var j;(function(ce){function _e(X){const De=new p.CallHierarchyItem(U.to(X.kind),X.name,X.detail||"",y.URI.revive(X.uri),r.to(X.range),r.to(X.selectionRange));return De._sessionId=X._sessionId,De._itemId=X._itemId,De}ce.to=_e;function le(X,De,Le){if(De=De??X._sessionId,Le=Le??X._itemId,De===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Le,name:X.name,detail:X.detail,kind:U.from(X.kind),uri:X.uri,range:r.from(X.range),selectionRange:r.from(X.selectionRange),tags:X.tags?.map(z.from)}}ce.from=le})(j=e.CallHierarchyItem||(e.CallHierarchyItem={}));var H;(function(ce){function _e(le){return new p.CallHierarchyIncomingCall(j.to(le.from),le.fromRanges.map(X=>r.to(X)))}ce.to=_e})(H=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var V;(function(ce){function _e(le){return new p.CallHierarchyOutgoingCall(j.to(le.to),le.fromRanges.map(X=>r.to(X)))}ce.to=_e})(V=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var q;(function(ce){function _e(X){return{range:X.range&&r.from(X.range),uri:X.uri}}ce.from=_e;function le(X){return new p.Location(y.URI.revive(X.uri),r.to(X.range))}ce.to=le})(q=e.location||(e.location={}));var te;(function(ce){function _e(X){const De=X,Le=X;return{originSelectionRange:De.originSelectionRange?r.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:Le.uri,range:r.from(De.targetRange?De.targetRange:Le.range),targetSelectionRange:De.targetSelectionRange?r.from(De.targetSelectionRange):void 0}}ce.from=_e;function le(X){return{targetUri:y.URI.revive(X.uri),targetRange:r.to(X.range),targetSelectionRange:X.targetSelectionRange?r.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?r.to(X.originSelectionRange):void 0}}ce.to=le})(te=e.DefinitionLink||(e.DefinitionLink={}));var fe;(function(ce){function _e(X){return{range:r.from(X.range),contents:_.fromMany(X.contents)}}ce.from=_e;function le(X){return new p.Hover(X.contents.map(_.to),r.to(X.range))}ce.to=le})(fe=e.Hover||(e.Hover={}));var Ce;(function(ce){function _e(X){return{range:r.from(X.range),expression:X.expression}}ce.from=_e;function le(X){return new p.EvaluatableExpression(r.to(X.range),X.expression)}ce.to=le})(Ce=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ke;(function(ce){function _e(X){if(X instanceof p.InlineValueText)return{type:"text",range:r.from(X.range),text:X.text};if(X instanceof p.InlineValueVariableLookup)return{type:"variable",range:r.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof p.InlineValueEvaluatableExpression)return{type:"expression",range:r.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}ce.from=_e;function le(X){switch(X.type){case"text":return{range:r.to(X.range),text:X.text};case"variable":return{range:r.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:r.to(X.range),expression:X.expression}}}ce.to=le})(ke=e.InlineValue||(e.InlineValue={}));var Ue;(function(ce){function _e(X){return{frameId:X.frameId,stoppedLocation:r.from(X.stoppedLocation)}}ce.from=_e;function le(X){return new p.InlineValueContext(X.frameId,r.to(X.stoppedLocation))}ce.to=le})(Ue=e.InlineValueContext||(e.InlineValueContext={}));var xe;(function(ce){function _e(X){return{range:r.from(X.range),kind:X.kind}}ce.from=_e;function le(X){return new p.DocumentHighlight(r.to(X.range),X.kind)}ce.to=le})(xe=e.DocumentHighlight||(e.DocumentHighlight={}));var ze;(function(ce){function _e(le){switch(le){case 1:return p.CompletionTriggerKind.TriggerCharacter;case 2:return p.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return p.CompletionTriggerKind.Invoke}}ce.to=_e})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Q;(function(ce){function _e(le){return{triggerKind:ze.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}ce.to=_e})(Q=e.CompletionContext||(e.CompletionContext={}));var Z;(function(ce){function _e(X){switch(X){case p.CompletionItemTag.Deprecated:return 1}}ce.from=_e;function le(X){switch(X){case 1:return p.CompletionItemTag.Deprecated}}ce.to=le})(Z=e.CompletionItemTag||(e.CompletionItemTag={}));var re;(function(ce){const _e=new Map([[p.CompletionItemKind.Method,0],[p.CompletionItemKind.Function,1],[p.CompletionItemKind.Constructor,2],[p.CompletionItemKind.Field,3],[p.CompletionItemKind.Variable,4],[p.CompletionItemKind.Class,5],[p.CompletionItemKind.Interface,7],[p.CompletionItemKind.Struct,6],[p.CompletionItemKind.Module,8],[p.CompletionItemKind.Property,9],[p.CompletionItemKind.Unit,12],[p.CompletionItemKind.Value,13],[p.CompletionItemKind.Constant,14],[p.CompletionItemKind.Enum,15],[p.CompletionItemKind.EnumMember,16],[p.CompletionItemKind.Keyword,17],[p.CompletionItemKind.Snippet,27],[p.CompletionItemKind.Text,18],[p.CompletionItemKind.Color,19],[p.CompletionItemKind.File,20],[p.CompletionItemKind.Reference,21],[p.CompletionItemKind.Folder,23],[p.CompletionItemKind.Event,10],[p.CompletionItemKind.Operator,11],[p.CompletionItemKind.TypeParameter,24],[p.CompletionItemKind.Issue,26],[p.CompletionItemKind.User,25]]);function le(Le){return _e.get(Le)??9}ce.from=le;const X=new Map([[0,p.CompletionItemKind.Method],[1,p.CompletionItemKind.Function],[2,p.CompletionItemKind.Constructor],[3,p.CompletionItemKind.Field],[4,p.CompletionItemKind.Variable],[5,p.CompletionItemKind.Class],[7,p.CompletionItemKind.Interface],[6,p.CompletionItemKind.Struct],[8,p.CompletionItemKind.Module],[9,p.CompletionItemKind.Property],[12,p.CompletionItemKind.Unit],[13,p.CompletionItemKind.Value],[14,p.CompletionItemKind.Constant],[15,p.CompletionItemKind.Enum],[16,p.CompletionItemKind.EnumMember],[17,p.CompletionItemKind.Keyword],[27,p.CompletionItemKind.Snippet],[18,p.CompletionItemKind.Text],[19,p.CompletionItemKind.Color],[20,p.CompletionItemKind.File],[21,p.CompletionItemKind.Reference],[23,p.CompletionItemKind.Folder],[10,p.CompletionItemKind.Event],[11,p.CompletionItemKind.Operator],[24,p.CompletionItemKind.TypeParameter],[25,p.CompletionItemKind.User],[26,p.CompletionItemKind.Issue]]);function De(Le){return X.get(Le)??p.CompletionItemKind.Property}ce.to=De})(re=e.CompletionItemKind||(e.CompletionItemKind={}));var ue;(function(ce){function _e(le,X){const De=new p.CompletionItem(le.label);return De.insertText=le.insertText,De.kind=re.to(le.kind),De.tags=le.tags?.map(Z.to),De.detail=le.detail,De.documentation=D.isMarkdownString(le.documentation)?_.to(le.documentation):le.documentation,De.sortText=le.sortText,De.filterText=le.filterText,De.preselect=le.preselect,De.commitCharacters=le.commitCharacters,T.Range.isIRange(le.range)?De.range=r.to(le.range):typeof le.range=="object"&&(De.range={inserting:r.to(le.range.insert),replacing:r.to(le.range.replace)}),De.keepWhitespace=typeof le.insertTextRules=="undefined"?!1:Boolean(le.insertTextRules&1),typeof le.insertTextRules!="undefined"&&le.insertTextRules&4?De.insertText=new p.SnippetString(le.insertText):(De.insertText=le.insertText,De.textEdit=De.range instanceof p.Range?new p.TextEdit(De.range,De.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(De.additionalTextEdits=le.additionalTextEdits.map(Le=>M.to(Le))),De.command=X&&le.command?X.fromInternal(le.command):void 0,De}ce.to=_e})(ue=e.CompletionItem||(e.CompletionItem={}));var J;(function(ce){function _e(X){return{label:X.label,documentation:X.documentation?_.fromStrict(X.documentation):void 0}}ce.from=_e;function le(X){return{label:X.label,documentation:D.isMarkdownString(X.documentation)?_.to(X.documentation):X.documentation}}ce.to=le})(J=e.ParameterInformation||(e.ParameterInformation={}));var ie;(function(ce){function _e(X){return{label:X.label,documentation:X.documentation?_.fromStrict(X.documentation):void 0,parameters:Array.isArray(X.parameters)?X.parameters.map(J.from):[],activeParameter:X.activeParameter}}ce.from=_e;function le(X){return{label:X.label,documentation:D.isMarkdownString(X.documentation)?_.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(J.to):[],activeParameter:X.activeParameter}}ce.to=le})(ie=e.SignatureInformation||(e.SignatureInformation={}));var we;(function(ce){function _e(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(ie.from):[]}}ce.from=_e;function le(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(ie.to):[]}}ce.to=le})(we=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(ce){function _e(X){return{text:X.text,position:s.from(X.position),kind:je.from(X.kind??p.InlayHintKind.Other),whitespaceBefore:X.whitespaceBefore,whitespaceAfter:X.whitespaceAfter}}ce.from=_e;function le(X){const De=new p.InlayHint(X.text,s.to(X.position),je.to(X.kind));return De.whitespaceAfter=X.whitespaceAfter,De.whitespaceBefore=X.whitespaceBefore,De}ce.to=le})(Me=e.InlayHint||(e.InlayHint={}));var je;(function(ce){function _e(X){return X}ce.from=_e;function le(X){return X}ce.to=le})(je=e.InlayHintKind||(e.InlayHintKind={}));var Ke;(function(ce){function _e(X){return{range:r.from(X.range),url:X.target,tooltip:X.tooltip}}ce.from=_e;function le(X){let De;if(X.url)try{De=typeof X.url=="string"?y.URI.parse(X.url,!0):y.URI.revive(X.url)}catch(Le){}return new p.DocumentLink(r.to(X.range),De)}ce.to=le})(Ke=e.DocumentLink||(e.DocumentLink={}));var Ze;(function(ce){function _e(X){const De=new p.ColorPresentation(X.label);return X.textEdit&&(De.textEdit=M.to(X.textEdit)),X.additionalTextEdits&&(De.additionalTextEdits=X.additionalTextEdits.map(Le=>M.to(Le))),De}ce.to=_e;function le(X){return{label:X.label,textEdit:X.textEdit?M.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(De=>M.from(De)):void 0}}ce.from=le})(Ze=e.ColorPresentation||(e.ColorPresentation={}));var rt;(function(ce){function _e(X){return new p.Color(X[0],X[1],X[2],X[3])}ce.to=_e;function le(X){return[X.red,X.green,X.blue,X.alpha]}ce.from=le})(rt=e.Color||(e.Color={}));var ut;(function(ce){function _e(X){return{range:r.from(X.range)}}ce.from=_e;function le(X){return new p.SelectionRange(r.to(X.range))}ce.to=le})(ut=e.SelectionRange||(e.SelectionRange={}));var it;(function(ce){function _e(le){switch(le){case 2:return p.TextDocumentSaveReason.AfterDelay;case 1:return p.TextDocumentSaveReason.Manual;case 3:case 4:return p.TextDocumentSaveReason.FocusOut}}ce.to=_e})(it=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var st;(function(ce){function _e(X){switch(X){case p.TextEditorLineNumbersStyle.Off:return 0;case p.TextEditorLineNumbersStyle.Relative:return 2;case p.TextEditorLineNumbersStyle.On:default:return 1}}ce.from=_e;function le(X){switch(X){case 0:return p.TextEditorLineNumbersStyle.Off;case 2:return p.TextEditorLineNumbersStyle.Relative;case 1:default:return p.TextEditorLineNumbersStyle.On}}ce.to=le})(st=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ae;(function(ce){function _e(X){if(X===p.EndOfLine.CRLF)return 1;if(X===p.EndOfLine.LF)return 0}ce.from=_e;function le(X){if(X===1)return p.EndOfLine.CRLF;if(X===0)return p.EndOfLine.LF}ce.to=le})(Ae=e.EndOfLine||(e.EndOfLine={}));var wt;(function(ce){function _e(le){if(typeof le=="object")return le.viewId;switch(le){case p.ProgressLocation.SourceControl:return 3;case p.ProgressLocation.Window:return 10;case p.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ce.from=_e})(wt=e.ProgressLocation||(e.ProgressLocation={}));var ee;(function(ce){function _e(le){const X={start:le.start+1,end:le.end+1};return le.kind&&(X.kind=se.from(le.kind)),X}ce.from=_e})(ee=e.FoldingRange||(e.FoldingRange={}));var se;(function(ce){function _e(le){if(le)switch(le){case p.FoldingRangeKind.Comment:return I.FoldingRangeKind.Comment;case p.FoldingRangeKind.Imports:return I.FoldingRangeKind.Imports;case p.FoldingRangeKind.Region:return I.FoldingRangeKind.Region}}ce.from=_e})(se=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Se;(function(ce){function _e(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?r.from(le.selection):void 0,override:typeof le.override=="boolean"?a.EditorResolution.DISABLED:void 0}}ce.from=_e})(Se=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ge;(function(ce){function _e(X){return X instanceof p.RelativePattern||typeof X=="string"?X:le(X)?new p.RelativePattern(X.base,X.pattern):X}ce.from=_e;function le(X){const De=X;return De&&typeof De.base=="string"&&typeof De.pattern=="string"}})(Ge=e.GlobPattern||(e.GlobPattern={}));var Ye;(function(ce){function _e(le){if(le){if(Array.isArray(le))return le.map(_e);if(typeof le=="string")return le;{const X=le;return{language:X.language,scheme:X.scheme,pattern:typeof X.pattern=="undefined"?void 0:Ge.from(X.pattern),exclusive:X.exclusive}}}else return}ce.from=_e})(Ye=e.LanguageSelector||(e.LanguageSelector={}));var nt;(function(ce){function _e(X){return{start:X.start,end:X.end}}ce.from=_e;function le(X){return new p.NotebookRange(X.start,X.end)}ce.to=le})(nt=e.NotebookRange||(e.NotebookRange={}));var he;(function(ce){function _e(X){return{timing:typeof X.runStartTime=="number"&&typeof X.runEndTime=="number"?{startTime:X.runStartTime,endTime:X.runEndTime}:void 0,executionOrder:X.executionOrder,success:X.lastRunSuccess}}ce.to=_e;function le(X){return{lastRunSuccess:X.success,runStartTime:X.timing?.startTime,runEndTime:X.timing?.endTime,executionOrder:X.executionOrder}}ce.from=le})(he=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ie;(function(ce){function _e(X){switch(X){case p.NotebookCellKind.Markup:return w.CellKind.Markup;case p.NotebookCellKind.Code:default:return w.CellKind.Code}}ce.from=_e;function le(X){switch(X){case w.CellKind.Markup:return p.NotebookCellKind.Markup;case w.CellKind.Code:default:return p.NotebookCellKind.Code}}ce.to=le})(Ie=e.NotebookCellKind||(e.NotebookCellKind={}));var Be;(function(ce){function _e(X){const De={metadata:X.metadata??Object.create(null),cells:[]};for(let Le of X.cells)p.NotebookCellData.validate(Le),De.cells.push(We.from(Le));return De}ce.from=_e;function le(X){const De=new p.NotebookData(X.cells.map(We.to));return(0,S.isEmptyObject)(X.metadata)||(De.metadata=X.metadata),De}ce.to=le})(Be=e.NotebookData||(e.NotebookData={}));var We;(function(ce){function _e(X){return{cellKind:Ie.from(X.kind),language:X.languageId,mime:X.mime,source:X.value,metadata:X.metadata,internalMetadata:he.from(X.executionSummary??{}),outputs:X.outputs?X.outputs.map(Te.from):[]}}ce.from=_e;function le(X){return new p.NotebookCellData(Ie.to(X.cellKind),X.source,X.language,X.mime,X.outputs?X.outputs.map(Te.to):void 0,X.metadata,X.internalMetadata?he.to(X.internalMetadata):void 0)}ce.to=le})(We=e.NotebookCellData||(e.NotebookCellData={}));var tt;(function(ce){function _e(X){return{mime:X.mime,valueBytes:L.VSBuffer.wrap(X.data)}}ce.from=_e;function le(X){return new p.NotebookCellOutputItem(X.valueBytes.buffer,X.mime)}ce.to=le})(tt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Te;(function(ce){function _e(X){return{outputId:X.id,items:X.items.map(tt.from),metadata:X.metadata}}ce.from=_e;function le(X){const De=X.items.map(tt.to);return new p.NotebookCellOutput(De,X.outputId,X.metadata)}ce.to=le})(Te=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ye;(function(ce){function _e(Le){if(Le!=null){if(Le instanceof p.RelativePattern||typeof Le=="string")return Le;if(De(Le))return new p.RelativePattern(Le.base,Le.pattern);if(X(Le))return{include:Ge.from(Le.include)||void 0,exclude:Ge.from(Le.exclude)||void 0}}}ce.from=_e;function le(Le){return typeof Le=="string"?Le:De(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}ce.to=le;function X(Le){const et=Le,qe=Ge.from(et.include);if(!(qe&&qe instanceof p.RelativePattern||typeof qe=="string"))return!1;const mt=Ge.from(et.exclude);return!!(mt&&mt instanceof p.RelativePattern||typeof mt=="string")}function De(Le){const et=Le;return et&&typeof et.base=="string"&&typeof et.pattern=="string"}})(ye=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var be;(function(ce){function _e(le){return{backgroundColor:le.backgroundColor,borderColor:le.borderColor,top:le.top?x.from(le.top):void 0}}ce.from=_e})(be=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ae;(function(ce){function _e(le,X,De){const Le=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===p.NotebookCellStatusBarAlignment.Left?1:2,command:X.toInternal(Le,De),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}ce.from=_e})(ae=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var de;(function(ce){function _e(le){return{transientOutputs:le?.transientOutputs??!1,transientCellMetadata:le?.transientCellMetadata??{},transientDocumentMetadata:le?.transientDocumentMetadata??{}}}ce.from=_e})(de=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ve;(function(ce){function _e(X){return{uri:X.uri,provides:X.provides}}ce.from=_e;function le(X){return new p.NotebookRendererScript(y.URI.revive(X.uri),X.provides)}ce.to=le})(ve=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Ee;(function(ce){function _e(X){return{message:_.fromStrict(X.message)||"",type:0,expected:X.expectedOutput,actual:X.actualOutput,location:X.location?q.from(X.location):void 0}}ce.from=_e;function le(X){const De=new p.TestMessage(typeof X.message=="string"?X.message:_.to(X.message));return De.actualOutput=X.actual,De.expectedOutput=X.expected,De.location=X.location?q.to(X.location):void 0,De}ce.to=le})(Ee=e.TestMessage||(e.TestMessage={}));var Fe;(function(ce){let _e;(function(le){le.Delimiter="\0"})(_e||(_e={})),ce.namespace=(le,X)=>le+"\0"+X,ce.denamespace=le=>{const X=le.indexOf("\0");return{ctrlId:le.slice(0,X),tagId:le.slice(X+1)}}})(Fe=e.TestTag||(e.TestTag={}));var Qe;(function(ce){function _e(Le){const et=(0,f.getPrivateApiFor)(Le).controllerId;return{extId:E.TestId.fromExtHostTestItem(Le,et).toString(),label:Le.label,uri:Le.uri,tags:Le.tags.map(qe=>Fe.namespace(et,qe.id)),range:r.from(Le.range)||null,description:Le.description||null,error:Le.error&&_.fromStrict(Le.error)||null}}ce.from=_e;function le(Le){return{parent:void 0,error:void 0,id:E.TestId.fromString(Le.extId).localId,label:Le.label,uri:y.URI.revive(Le.uri),tags:(Le.tags||[]).map(et=>{const{tagId:qe}=Fe.denamespace(et);return new p.TestTag(qe)}),range:r.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0}}ce.toPlain=le;function X(Le){const et=E.TestId.fromString(Le.extId),qe=new f.TestItemImpl(et.controllerId,et.localId,Le.label,y.URI.revive(Le.uri));return qe.range=r.to(Le.range||void 0),qe.description=Le.description||void 0,qe}function De(Le){let et;for(const qe of Le.tests){const mt=X(qe.item);(0,f.getPrivateApiFor)(mt).parent=et,et=mt}return et}ce.toItemFromContext=De})(Qe=e.TestItem||(e.TestItem={})),function(ce){function _e(X){return{id:X.id}}ce.from=_e;function le(X){return new p.TestTag(X.id)}ce.to=le}(Fe=e.TestTag||(e.TestTag={}));var $e;(function(ce){const _e=(X,De)=>{const Le={...Qe.toPlain(X.item),parent:void 0,taskStates:X.tasks.map(et=>({state:et.state,duration:et.duration,messages:et.messages.filter(qe=>qe.type===0).map(Ee.to)})),children:X.children.map(et=>De.get(et)).filter(S.isDefined).map(et=>_e(et,De))};for(const et of Le.children)et.parent=Le;return Le};function le(X){const De=[],Le=new Map;for(const et of X.items)Le.set(et.item.extId,et),X.request.targets.some(qe=>qe.controllerId===et.controllerId&&qe.testIds.includes(et.item.extId))&&De.push(et);return{completedAt:X.completedAt,results:De.map(et=>_e(et,Le))}}ce.to=le})($e=e.TestResults||(e.TestResults={}));var Xe;(function(ce){function _e(Le){return{covered:Le.covered,total:Le.covered}}function le(Le){return"line"in Le?s.from(Le):r.from(Le)}function X(Le){return"branches"in Le?{count:Le.executionCount,location:le(Le.location),type:1,branches:Le.branches.length?Le.branches.map(et=>({count:et.executionCount,location:et.location&&le(et.location)})):void 0}:{type:0,count:Le.executionCount,location:le(Le.location)}}ce.fromDetailed=X;function De(Le){return{uri:Le.uri,statement:_e(Le.statementCoverage),branch:Le.branchCoverage&&_e(Le.branchCoverage),function:Le.functionCoverage&&_e(Le.functionCoverage),details:Le.detailedCoverage?.map(X)}}ce.fromFile=De})(Xe=e.TestCoverage||(e.TestCoverage={}));var at;(function(ce){function _e(le){switch(le){case 1:return p.CodeActionTriggerKind.Invoke;case 2:return p.CodeActionTriggerKind.Automatic}}ce.to=_e})(at=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var ct;(function(ce){function _e(X){const De=new p.TypeHierarchyItem(U.to(X.kind),X.name,X.detail||"",y.URI.revive(X.uri),r.to(X.range),r.to(X.selectionRange));return De._sessionId=X._sessionId,De._itemId=X._itemId,De}ce.to=_e;function le(X,De,Le){if(De=De??X._sessionId,Le=Le??X._itemId,De===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Le,kind:U.from(X.kind),name:X.name,detail:X.detail??"",uri:X.uri,range:r.from(X.range),selectionRange:r.from(X.selectionRange),tags:X.tags?.map(z.from)}}ce.from=le})(ct=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ge[216],pe([0,1,2,15,7,16,93]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(y,T,I,a={timeout:1500,errors:3}){this._logService=y,this._documents=T,this._mainThreadBulkEdits=I,this._thresholds=a,this._callbacks=new i.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(y){return(T,I,a)=>{const f={dispose:this._callbacks.push([T,I,y])};return Array.isArray(a)&&a.push(f),f}}async $participateInSave(y,T){const I=m.URI.revive(y);let a=!1;const b=setTimeout(()=>a=!0,this._thresholds.timeout),f=[];try{for(let w of[...this._callbacks]){if(a)break;const E=this._documents.getDocument(I),P=await this._deliverEventAsyncAndBlameBadListeners(w,{document:E,reason:C.TextDocumentSaveReason.to(T)});f.push(P)}}finally{clearTimeout(b)}return f}_deliverEventAsyncAndBlameBadListeners([y,T,I],a){const b=this._badListeners.get(y);return typeof b=="number"&&b>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,y,T,a).then(()=>!0,f=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const w=this._badListeners.get(y);this._badListeners.set(y,w?w+1:1),typeof w=="number"&&w>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(y,T,I,a){const b=[],f=Date.now(),{document:w,reason:E}=a,{version:P}=w,p=Object.freeze({document:w,reason:E,waitUntil(o){if(Object.isFrozen(b))throw(0,L.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(o))}});try{T.apply(I,[p])}catch(o){return Promise.reject(o)}return Object.freeze(b),new Promise((o,r)=>{const g=setTimeout(()=>r(new Error("timeout")),this._thresholds.timeout);return Promise.all(b).then(s=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(g),o(s)}).catch(s=>{clearTimeout(g),r(s)})}).then(o=>{const r={edits:[]};for(const g of o)if(Array.isArray(g)&&g.every(s=>s instanceof D.TextEdit))for(const{newText:s,newEol:v,range:n}of g)r.edits.push({_type:2,resource:w.uri,edit:{range:n&&C.Range.from(n),text:s,eol:v&&C.EndOfLine.from(v)}});if(r.edits.length!==0)return P===w.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(ge[217],pe([0,1,3,31,2,16,7]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class k{constructor(T,I,a,b,f){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,a&&(this._config+=1),b&&(this._config+=2),f&&(this._config+=4);const w=(0,L.parse)(I),E=T(P=>{if(!a)for(let p of P.created){const o=D.URI.revive(p);w(o.fsPath)&&this._onDidCreate.fire(o)}if(!b)for(let p of P.changed){const o=D.URI.revive(p);w(o.fsPath)&&this._onDidChange.fire(o)}if(!f)for(let p of P.deleted){const o=D.URI.revive(p);w(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=i.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,E)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(T,I,a){this._logService=I,this._extHostDocumentsAndEditors=a,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new m.AsyncEmitter,this._onWillCreateFile=new m.AsyncEmitter,this._onWillDeleteFile=new m.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(T,I,a,b){return new k(this._onFileSystemEvent.event,T,I,a,b)}$onFileEvent(T){this._onFileSystemEvent.fire(T)}$onDidRunFileOperation(T,I){switch(T){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(a=>({oldUri:D.URI.revive(a.source),newUri:D.URI.revive(a.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(a=>D.URI.revive(a.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:I.map(a=>D.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent(T){return this._createWillExecuteEvent(T,this._onWillRenameFile)}getOnWillCreateFileEvent(T){return this._createWillExecuteEvent(T,this._onWillCreateFile)}getOnWillDeleteFileEvent(T){return this._createWillExecuteEvent(T,this._onWillDeleteFile)}_createWillExecuteEvent(T,I){return(a,b,f)=>{const w=function(P){a.call(b,P)};return w.extension=T,I.event(w,void 0,f)}}async $onWillRunFileOperation(T,I,a,b){switch(T){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(f=>({oldUri:D.URI.revive(f.source),newUri:D.URI.revive(f.target)}))},a,b);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(f=>D.URI.revive(f.target))},a,b);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(f=>D.URI.revive(f.target))},a,b)}}async _fireWillEvent(T,I,a,b){const f=new Set,w=[];if(await T.fireAsync(I,b,async(P,p)=>{const o=Date.now(),r=await Promise.resolve(P);r instanceof i.WorkspaceEdit&&(w.push(r),f.add(p.extension.displayName??p.extension.identifier.value)),Date.now()-o>a&&this._logService.warn("SLOW file-participant",p.extension.identifier)}),b.isCancellationRequested||w.length===0)return;const E={edits:[]};for(let P of w){let{edits:p}=C.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);E.edits=E.edits.concat(p)}return{edit:E,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=S}),define(ge[218],pe([0,1,10,25,2,16,7,125]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(a,b,f,w){this.start=a,this.deletedCount=b,this.deletedItems=f,this.items=w}static asApiEvents(a){return a.map(b=>({start:b.start,deletedCount:b.deletedCount,deletedItems:b.deletedItems,items:b.items.map(f=>f.apiCell)}))}}class y{constructor(a,b,f){this.notebook=a,this._extHostDocument=b,this._cellData=f,this.handle=f.handle,this.uri=D.URI.revive(f.uri),this.cellKind=f.cellKind,this._outputs=f.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=f.internalMetadata??{},this._metadata=Object.freeze(f.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(f.internalMetadata??{}))}static asModelAddData(a,b){return{EOL:b.eol,lines:b.source,languageId:b.language,uri:b.uri,isDirty:!1,versionId:1,notebook:a}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const a=this,b=this._extHostDocument.getDocument(this.uri);if(!b)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return a.notebook.getCellIndex(a)},notebook:a.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:b.document,get mime(){return a._mime},set mime(f){a._mime=f},get outputs(){return a._outputs.slice(0)},get metadata(){return a._metadata},get executionSummary(){return a._previousResult}})}return this._apiCell}setOutputs(a){this._outputs=a.map(C.NotebookCellOutput.to)}setOutputItems(a,b,f){const w=f.map(C.NotebookCellOutputItem.to),E=this._outputs.find(P=>P.id===a);E&&(b||(E.items.length=0),E.items.push(...w))}setMetadata(a){this._metadata=Object.freeze(a)}setInternalMetadata(a){this._internalMetadata=a,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(a))}setMime(a){}}e.ExtHostCell=y;class T{constructor(a,b,f,w,E,P){this._proxy=a,this._textDocumentsAndEditors=b,this._textDocuments=f,this._emitter=w,this.uri=E,this.handle=T._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=P.viewType,this._metadata=Object.freeze(P.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,P.cells]],!0),this._versionId=P.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const a=this;this._notebook={get uri(){return a.uri},get version(){return a._versionId},get notebookType(){return a._notebookType},get isDirty(){return a._isDirty},get isUntitled(){return a.uri.scheme===m.Schemas.untitled},get isClosed(){return a._disposed},get metadata(){return a._metadata},get cellCount(){return a._cells.length},cellAt(b){return b=a._validateIndex(b),a._cells[b].apiCell},getCells(b){return(b?a._getCells(b):a._cells).map(w=>w.apiCell)},save(){return a._save()}}}return this._notebook}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(a){a.metadata&&(this._metadata=Object.freeze({...this._metadata,...a.metadata}))}acceptDirty(a){this._isDirty=a}acceptModelChanged(a,b){this._versionId=a.versionId,this._isDirty=b;for(const f of a.rawEvents)f.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(f.changes,!1):f.kind===k.NotebookCellsChangeType.Move?this._moveCell(f.index,f.newIdx):f.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(f.index,f.outputs):f.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(f.index,f.outputId,f.append,f.outputItems):f.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(f.index,f.language):f.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(f.index,f.mime):f.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(f.index,f.metadata):f.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(f.index,f.internalMetadata)}_validateIndex(a){return a=a|0,a<0?0:a>=this._cells.length?this._cells.length-1:a}_validateRange(a){let b=a.start|0,f=a.end|0;return b<0&&(b=0),f>this._cells.length&&(f=this._cells.length),a.with({start:b,end:f})}_getCells(a){a=this._validateRange(a);const b=[];for(let f=a.start;f<a.end;f++)b.push(this._cells[f]);return b}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(a,b){if(this._disposed)return;const f=[],w=[],E=[];a.reverse().forEach(P=>{const o=P[2].map(s=>{const v=new y(this,this._textDocumentsAndEditors,s);return b||w.push(y.asModelAddData(this.apiNotebook,s)),v}),r=new S(P[0],P[1],[],o),g=this._cells.splice(P[0],P[1],...o);for(const s of g)E.push(s.uri),r.deletedItems.push(s.apiCell);f.push(r)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:E}),b||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(f)}))}_moveCell(a,b){const f=this._cells.splice(a,1);this._cells.splice(b,0,...f);const w=[new S(a,1,f.map(E=>E.apiCell),[]),new S(b,0,[],f)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(w)}))}_setCellOutputs(a,b){const f=this._cells[a];f.setOutputs(b),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[f.apiCell]}))}_setCellOutputItems(a,b,f,w){const E=this._cells[a];E.setOutputItems(b,f,w),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[E.apiCell]}))}_changeCellLanguage(a,b){const f=this._cells[a];f.apiCell.document.languageId!==b&&this._textDocuments.$acceptModelModeChanged(f.uri,b)}_changeCellMime(a,b){const f=this._cells[a];f.apiCell.mime=b}_changeCellMetadata(a,b){const f=this._cells[a],w=f.apiCell.metadata;f.setMetadata(b);const E=f.apiCell.metadata;(0,L.equals)(w,E)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:f.apiCell}))}_changeCellInternalMetadata(a,b){const f=this._cells[a],w=f.internalMetadata;if(f.setInternalMetadata(b),w.runState!==b.runState){const E=b.runState??i.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:f.apiCell,state:E}))}}getCellFromApiCell(a){return this._cells.find(b=>b.apiCell===a)}getCellFromIndex(a){return this._cells[a]}getCell(a){return this._cells.find(b=>b.handle===a)}getCellIndex(a){return this._cells.indexOf(a)}}e.ExtHostNotebookDocument=T,T._handlePool=0}),define(ge[128],pe([0,1,7,16,15]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,y){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:y})}replaceCells(S,y,T){this._throwIfFinalized(),!(S===y&&T.length===0)&&this._collectedEdits.push({editType:1,index:S,count:y-S,cells:T.map(L.NotebookCellData.from)})}}class i{constructor(S,y,T,I,a,b){this.id=S,this._proxy=y,this.notebookData=T,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=a,this._visibleRanges=I,this._viewColumn=b}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(y){if(!Array.isArray(y)||!y.every(m.NotebookRange.isNotebookRange))throw(0,D.illegalArgument)("selections");S._selections=y,S._trySetSelections(y)},get visibleRanges(){return S._visibleRanges},revealRange(y,T){S._proxy.$tryRevealRange(S.id,L.NotebookRange.from(y),T??m.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(y){const T=new C(this.document.version);return y(T),S._applyEdit(T.finalize())},setDecorations(y,T){return S.setDecorations(y,T)}},i.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(L.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const y=[];let T=-1;for(let I=0;I<S.cellEdits.length;I++){if(T<0){y.push(S.cellEdits[I]),T++;continue}const b=y[T],f=S.cellEdits[I];if(b.editType===1&&f.editType===1&&b.index===f.index){b.cells.push(...S.cellEdits[I].cells),b.count+=S.cellEdits[I].count;continue}y.push(S.cellEdits[I]),T++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,y)}setDecorations(S,y){if(!(y.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return y.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(y),S.key)}}e.ExtHostNotebookEditor=i,i.apiEditorsToExtHost=new WeakMap}),define(ge[219],pe([0,1,16,117,164,21,57,15]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(a){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=a}async withProgress(a,b,f){const w=this._handles++,{title:E,location:P,cancellable:p}=b,o={label:(0,D.localize)(0,null,a.displayName||a.name),id:a.identifier.value};return this._proxy.$startProgress(w,{location:m.ProgressLocation.from(P),title:E,source:o,cancellable:p},a).catch(k.onUnexpectedExternalError),this._withProgress(w,f,!!p)}_withProgress(a,b,f){let w;f&&(w=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(a,w));const E=p=>{this._proxy.$progressEnd(p),this._mapHandleToCancellationSource.delete(p),w&&w.dispose()};let P;try{P=b(new T(this._proxy,a),f&&w?w.token:C.CancellationToken.None)}catch(p){throw E(a),p}return P.then(p=>E(a),p=>E(a)),P}$acceptProgressCanceled(a){const b=this._mapHandleToCancellationSource.get(a);b&&(b.cancel(),this._mapHandleToCancellationSource.delete(a))}}e.ExtHostProgress=S;function y(I,a){return I.message=a.message,typeof a.increment=="number"&&(typeof I.increment=="number"?I.increment+=a.increment:I.increment=a.increment),I}class T extends L.Progress{constructor(a,b){super(f=>this.throttledReport(f));this._proxy=a,this._handle=b}throttledReport(a){this._proxy.$progressReport(this._handle,a)}}Ve([(0,i.throttle)(100,(I,a)=>y(I,a),()=>Object.create(null))],T.prototype,"throttledReport",null)}),define(ge[129],pe([0,1,56,15,75,16,7]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(a,b,f){const w=k._Keys.nextId();a.$registerTextEditorDecorationType(b.identifier,w,C.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:w,dispose(){a.$removeTextEditorDecorationType(w)}})}}e.TextEditorDecorationType=k,k._Keys=new D.IdGenerator("TextEditorDecorationType");class S{constructor(a,b){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=a,this._documentVersionId=a.version,this._undoStopBefore=b.undoStopBefore,this._undoStopAfter=b.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(a,b){this._throwIfFinalized();let f=null;if(a instanceof i.Position)f=new i.Range(a,a);else if(a instanceof i.Range)f=a;else throw new Error("Unrecognized location");this._pushEdit(f,b,!1)}insert(a,b){this._throwIfFinalized(),this._pushEdit(new i.Range(a,a),b,!0)}delete(a){this._throwIfFinalized();let b=null;if(a instanceof i.Range)b=a;else throw new Error("Unrecognized location");this._pushEdit(b,null,!0)}_pushEdit(a,b,f){const w=this._document.validateRange(a);this._collectedEdits.push({range:w,text:b,forceMoveMarkers:f})}setEndOfLine(a){if(this._throwIfFinalized(),a!==i.EndOfLine.LF&&a!==i.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=a}}e.TextEditorEdit=S;class y{constructor(a,b,f,w){this._proxy=a,this._id=b,this._accept(f),this._logService=w;const E=this;this.value={get tabSize(){return E._tabSize},set tabSize(P){E._setTabSize(P)},get insertSpaces(){return E._insertSpaces},set insertSpaces(P){E._setInsertSpaces(P)},get cursorStyle(){return E._cursorStyle},set cursorStyle(P){E._setCursorStyle(P)},get lineNumbers(){return E._lineNumbers},set lineNumbers(P){E._setLineNumbers(P)}}}_accept(a){this._tabSize=a.tabSize,this._insertSpaces=a.insertSpaces,this._cursorStyle=a.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(a.lineNumbers)}_validateTabSize(a){if(a==="auto")return"auto";if(typeof a=="number"){const b=Math.floor(a);return b>0?b:null}if(typeof a=="string"){const b=parseInt(a,10);return isNaN(b)?null:b>0?b:null}return null}_setTabSize(a){const b=this._validateTabSize(a);if(b!==null){if(typeof b=="number"){if(this._tabSize===b)return;this._tabSize=b}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:b}))}}_validateInsertSpaces(a){return a==="auto"?"auto":a==="false"?!1:Boolean(a)}_setInsertSpaces(a){const b=this._validateInsertSpaces(a);if(typeof b=="boolean"){if(this._insertSpaces===b)return;this._insertSpaces=b}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:b}))}_setCursorStyle(a){this._cursorStyle!==a&&(this._cursorStyle=a,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:a})))}_setLineNumbers(a){this._lineNumbers!==a&&(this._lineNumbers=a,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(a)})))}assign(a){const b={};let f=!1;if(typeof a.tabSize!="undefined"){const w=this._validateTabSize(a.tabSize);w==="auto"?(f=!0,b.tabSize=w):typeof w=="number"&&this._tabSize!==w&&(this._tabSize=w,f=!0,b.tabSize=w)}if(typeof a.insertSpaces!="undefined"){const w=this._validateInsertSpaces(a.insertSpaces);w==="auto"?(f=!0,b.insertSpaces=w):this._insertSpaces!==w&&(this._insertSpaces=w,f=!0,b.insertSpaces=w)}typeof a.cursorStyle!="undefined"&&this._cursorStyle!==a.cursorStyle&&(this._cursorStyle=a.cursorStyle,f=!0,b.cursorStyle=a.cursorStyle),typeof a.lineNumbers!="undefined"&&this._lineNumbers!==a.lineNumbers&&(this._lineNumbers=a.lineNumbers,f=!0,b.lineNumbers=C.TextEditorLineNumbersStyle.from(a.lineNumbers)),f&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,b))}_warnOnError(a,b){b.catch(f=>{this._logService.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this._logService.warn(f)})}}e.ExtHostTextEditorOptions=y;class T{constructor(a,b,f,w,E,P,p,o){this.id=a,this._proxy=b,this._logService=f,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=E,this._options=new y(this._proxy,this.id,P,f),this._visibleRanges=p,this._viewColumn=o;const r=this;this.value=Object.freeze({get document(){return w.getValue()},set document(g){throw(0,L.readonly)("document")},get selection(){return r._selections&&r._selections[0]},set selection(g){if(!(g instanceof i.Selection))throw(0,L.illegalArgument)("selection");r._selections=[g],r._trySetSelection()},get selections(){return r._selections},set selections(g){if(!Array.isArray(g)||g.some(s=>!(s instanceof i.Selection)))throw(0,L.illegalArgument)("selections");r._selections=g,r._trySetSelection()},get visibleRanges(){return r._visibleRanges},set visibleRanges(g){throw(0,L.readonly)("visibleRanges")},get options(){return r._options.value},set options(g){r._disposed||r._options.assign(g)},get viewColumn(){return r._viewColumn},set viewColumn(g){throw(0,L.readonly)("viewColumn")},edit(g,s={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const v=new S(w.getValue(),s);return g(v),r._applyEdit(v)},insertSnippet(g,s,v={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!s||Array.isArray(s)&&s.length===0)n=r._selections.map(t=>C.Range.from(t));else if(s instanceof i.Position){const{lineNumber:t,column:u}=C.Position.from(s);n=[{startLineNumber:t,startColumn:u,endLineNumber:t,endColumn:u}]}else if(s instanceof i.Range)n=[C.Range.from(s)];else{n=[];for(const t of s)if(t instanceof i.Range)n.push(C.Range.from(t));else{const{lineNumber:u,column:d}=C.Position.from(t);n.push({startLineNumber:u,startColumn:d,endLineNumber:u,endColumn:d})}}return b.$tryInsertSnippet(a,g.value,n,v)},setDecorations(g,s){const v=s.length===0;v&&!r._hasDecorationsForKey.has(g.key)||(v?r._hasDecorationsForKey.delete(g.key):r._hasDecorationsForKey.add(g.key),r._runOnProxy(()=>{if(C.isDecorationOptionsArr(s))return b.$trySetDecorations(a,g.key,C.fromRangeOrRangeWithMessage(s));{const n=new Array(4*s.length);for(let t=0,u=s.length;t<u;t++){const d=s[t];n[4*t]=d.start.line+1,n[4*t+1]=d.start.character+1,n[4*t+2]=d.end.line+1,n[4*t+3]=d.end.character+1}return b.$trySetDecorationsFast(a,g.key,n)}}))},revealRange(g,s){r._runOnProxy(()=>b.$tryRevealRange(a,C.Range.from(g),s||i.TextEditorRevealType.Default))},show(g){b.$tryShowEditor(a,C.ViewColumn.from(g))},hide(){b.$tryHideEditor(a)}})}dispose(){(0,m.ok)(!this._disposed),this._disposed=!0}_acceptOptions(a){(0,m.ok)(!this._disposed),this._options._accept(a)}_acceptVisibleRanges(a){(0,m.ok)(!this._disposed),this._visibleRanges=a}_acceptViewColumn(a){(0,m.ok)(!this._disposed),this._viewColumn=a}_acceptSelections(a){(0,m.ok)(!this._disposed),this._selections=a}async _trySetSelection(){const a=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,a)),this.value}_applyEdit(a){const b=a.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const f=b.edits.map(E=>E.range);f.sort((E,P)=>E.end.line===P.end.line?E.end.character===P.end.character?E.start.line===P.start.line?E.start.character-P.start.character:E.start.line-P.start.line:E.end.character-P.end.character:E.end.line-P.end.line);for(let E=0,P=f.length-1;E<P;E++){const p=f[E].end;if(f[E+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=b.edits.map(E=>({range:C.Range.from(E.range),text:E.text,forceMoveMarkers:E.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,b.documentVersionId,w,{setEndOfLine:typeof b.setEndOfLine=="number"?C.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}_runOnProxy(a){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this._logService.warn(b),null))}}e.ExtHostTextEditor=T}),define(ge[220],pe([0,1,167,23,2,3,6,18,7,13,17,16,21,204]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(P,p){if((0,y.isString)(P))return{label:P};if(P&&typeof P=="object"&&typeof P.label=="string"){let o;return Array.isArray(P.highlights)&&(o=P.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),o=o.length?o:void 0),{label:P.label,highlights:o}}}class w{constructor(p,o,r){this._proxy=p,this.commands=o,this.logService=r,this.treeViews=new Map;function g(s){return s&&s.$treeViewId&&s.$treeItemHandle}o.registerArgumentProcessor({processArgument:s=>g(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(v=>g(v)?this.convertArgument(v):v):s})}registerTreeDataProvider(p,o,r){const g=this.createTreeView(p,{treeDataProvider:o},r);return{dispose:()=>g.dispose()}}createTreeView(p,o,r){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const g=o.dragAndDropController?.supportedMimeTypes,s=this._proxy.$registerTreeViewDataProvider(p,{showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,dragAndDropMimeTypes:g}),v=this.createExtHostTreeView(p,o,r);return{get onDidCollapseElement(){return v.onDidCollapseElement},get onDidExpandElement(){return v.onDidExpandElement},get selection(){return v.selectedElements},get onDidChangeSelection(){return v.onDidChangeSelection},get visible(){return v.visible},get onDidChangeVisibility(){return v.onDidChangeVisibility},get message(){return v.message},set message(n){v.message=n},get title(){return v.title},set title(n){v.title=n},get description(){return v.description},set description(n){v.description=n},reveal:(n,t)=>v.reveal(n,t),dispose:async()=>{await s,this.treeViews.delete(p),v.dispose()}}}$getChildren(p,o){const r=this.treeViews.get(p);return r?r.getChildren(o):Promise.reject(new Error((0,m.localize)(0,null,p)))}async $onDrop(p,o,r,g,s){const v=this.treeViews.get(p);if(!v)return Promise.reject(new Error((0,m.localize)(1,null,p)));const n=b.TreeDataTransferConverter.toITreeDataTransfer(o);if(g===p&&s){const t=await v.onWillDrop(s);t&&t.forEach((u,d)=>{u&&n.set(d,u)})}return v.onDrop(n,r)}async $hasResolve(p){const o=this.treeViews.get(p);if(!o)throw new Error((0,m.localize)(2,null,p));return o.hasResolve}$resolve(p,o,r){const g=this.treeViews.get(p);if(!g)throw new Error((0,m.localize)(3,null,p));return g.resolveTreeItem(o,r)}$setExpanded(p,o,r){const g=this.treeViews.get(p);if(!g)throw new Error((0,m.localize)(4,null,p));g.setExpanded(o,r)}$setSelection(p,o){const r=this.treeViews.get(p);if(!r)throw new Error((0,m.localize)(5,null,p));r.setSelection(o)}$setVisible(p,o){const r=this.treeViews.get(p);if(!r)throw new Error((0,m.localize)(6,null,p));r.setVisible(o)}createExtHostTreeView(p,o,r){const g=new E(p,o,this._proxy,this.commands.converter,this.logService,r);return this.treeViews.set(p,g),g}convertArgument(p){const o=this.treeViews.get(p.$treeViewId);return o?o.getExtensionElement(p.$treeItemHandle):null}}e.ExtHostTreeViews=w;class E extends i.Disposable{constructor(p,o,r,g,s,v){super();if(this.viewId=p,this.proxy=r,this.commands=g,this.logService=s,this.extension=v,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new a.CancellationTokenSource,v.contributes&&v.contributes.views)for(const u in v.contributes.views)for(const d of v.contributes.views[u])d.id===p&&(this._title=d.name);this.dataProvider=o.treeDataProvider,this.dndController=o.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(u=>this._onDidChangeData.fire({message:!1,element:u}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(u=>this._onDidChangeData.fire({message:!1,element:u})));let n,t;this._register(C.Event.debounce(this._onDidChangeData.event,(u,d)=>(u||(u={message:!1,elements:[]}),d.element!==!1&&(n||(n=new Promise(l=>t=l),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(d.element)?u.elements.push(...d.element):u.elements.push(d.element)),d.message&&(u.message=!0),u),200,!0)(({message:u,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const l=t;return n=null,this.refresh(d).then(()=>l())})),u&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(p=>this.getExtensionElement(p)).filter(p=>!(0,y.isUndefinedOrNull)(p))}async getChildren(p){const o=p?this.getExtensionElement(p):void 0;if(p&&!o)return this.logService.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let r=this.getChildrenNodes(p);return r||(r=await this.fetchChildrenNodes(o)),r?r.map(g=>g.item):void 0}getExtensionElement(p){return this.elements.get(p)}reveal(p,o){o=o||{select:!0,focus:!1};const r=(0,y.isUndefinedOrNull)(o.select)?!0:o.select,g=(0,y.isUndefinedOrNull)(o.focus)?!1:o.focus,s=(0,y.isUndefinedOrNull)(o.expand)?!1:o.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.refreshPromise.then(()=>this.resolveUnknownParentChain(p)).then(v=>this.resolveTreeNode(p,v[v.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:v.map(t=>t.item)},{select:r,focus:g,expand:s})),v=>this.logService.error(v)):this.proxy.$reveal(this.viewId,void 0,{select:r,focus:g,expand:s})}get message(){return this._message}set message(p){this._message=p,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(p){this._title=p,this.proxy.$setTitle(this.viewId,p,this._description)}get description(){return this._description}set description(p){this._description=p,this.proxy.$setTitle(this.viewId,this._title,p)}setExpanded(p,o){const r=this.getExtensionElement(p);r&&(o?this._onDidExpandElement.fire(Object.freeze({element:r})):this._onDidCollapseElement.fire(Object.freeze({element:r})))}setSelection(p){(0,T.equals)(this._selectedHandles,p)||(this._selectedHandles=p,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(p){p!==this._visible&&(this._visible=p,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(p){const o=[];for(const r of p){const g=this.getExtensionElement(r);g&&o.push(g)}if(!(!this.dndController?.onWillDrop||o.length===0))return this.dndController.onWillDrop(o)}async onDrop(p,o){const r=this.getExtensionElement(o);if(!!r)return(0,k.asPromise)(()=>this.dndController?.onDrop(p,r))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(p,o){if(!this.dataProvider.resolveTreeItem)return;const r=this.elements.get(p);if(r){const g=this.nodes.get(r);if(g){const s=await this.dataProvider.resolveTreeItem(g.extensionItem,r,o)??g.extensionItem;return g.item.tooltip=this.getTooltip(s.tooltip),g.item.command=this.getCommand(g.disposableStore,s.command),g.item}}}resolveUnknownParentChain(p){return this.resolveParent(p).then(o=>o?this.resolveUnknownParentChain(o).then(r=>this.resolveTreeNode(o,r[r.length-1]).then(g=>(r.push(g),r))):Promise.resolve([]))}resolveParent(p){const o=this.nodes.get(p);return o?Promise.resolve(o.parent?this.elements.get(o.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(p))}resolveTreeNode(p,o){const r=this.nodes.get(p);return r?Promise.resolve(r):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(g=>this.createHandle(p,g,o,!0)).then(g=>this.getChildren(o?o.item.handle:void 0).then(()=>{const s=this.getExtensionElement(g);if(s){const v=this.nodes.get(s);if(v)return Promise.resolve(v)}throw new Error(`Cannot resolve tree item for element ${g}`)}))}getChildrenNodes(p){if(p){let o;if(typeof p=="string"){const r=this.getExtensionElement(p);o=r?this.nodes.get(r):void 0}else o=p;return o&&o.children||void 0}return this.roots}async fetchChildrenNodes(p){this.clearChildren(p);const o=new a.CancellationTokenSource(this._refreshCancellationSource.token);try{const r=p?this.nodes.get(p):void 0,g=await this.dataProvider.getChildren(p);if(o.token.isCancellationRequested)return;const s=await Promise.all((0,T.coalesce)(g||[]).map(async v=>{const n=await this.dataProvider.getTreeItem(v);return n&&!o.token.isCancellationRequested?this.createAndRegisterTreeNode(v,n,r):null}));return o.token.isCancellationRequested?void 0:(0,T.coalesce)(s)}finally{o.dispose()}}refresh(p){if(p.some(r=>!r))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new a.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const r=this.getHandlesToRefresh(p);if(r.length)return this.refreshHandles(r)}return Promise.resolve(void 0)}getHandlesToRefresh(p){const o=new Set,r=p.map(s=>this.nodes.get(s));for(const s of r)if(s&&!o.has(s.item.handle)){let v=s;for(;v&&v.parent&&r.findIndex(n=>v&&v.parent&&n&&n.item.handle===v.parent.item.handle)===-1;){const n=this.elements.get(v.parent.item.handle);v=n?this.nodes.get(n):void 0}v&&!v.parent&&o.add(s.item.handle)}const g=[];return o.forEach(s=>{const v=this.elements.get(s);if(v){const n=this.nodes.get(v);n&&(!n.parent||!o.has(n.parent.item.handle))&&g.push(s)}}),g}refreshHandles(p){const o={};return Promise.all(p.map(r=>this.refreshNode(r).then(g=>{g&&(o[r]=g.item)}))).then(()=>Object.keys(o).length?this.proxy.$refresh(this.viewId,o):void 0)}refreshNode(p){const o=this.getExtensionElement(p);if(o){const r=this.nodes.get(o);if(r)return this.clearChildren(o),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(g=>{if(g){const s=this.createTreeNode(o,g,r.parent);return this.updateNodeCache(o,s,r,r.parent),r.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(p,o,r){const g=this.createTreeNode(p,o,r);if(o.id&&this.elements.has(g.item.handle))throw new Error((0,m.localize)(7,null,o.id));return this.addNodeToCache(p,g),this.addNodeToParentCache(g,r),g}getTooltip(p){return S.MarkdownString.isMarkdownString(p)?I.MarkdownString.from(p):p}getCommand(p,o){return o?this.commands.toInternal(o,p):void 0}createTreeNode(p,o,r){const g=new i.DisposableStore,s=this.createHandle(p,o,r),v=this.getLightIconPath(o);return{item:{handle:s,parentHandle:r?r.item.handle:void 0,label:f(o.label,this.extension),description:o.description,resourceUri:o.resourceUri,tooltip:this.getTooltip(o.tooltip),command:this.getCommand(g,o.command),contextValue:o.contextValue,icon:v,iconDark:this.getDarkIconPath(o)||v,themeIcon:this.getThemeIcon(o),collapsibleState:(0,y.isUndefinedOrNull)(o.collapsibleState)?S.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation},extensionItem:o,parent:r,children:void 0,disposableStore:g,dispose(){g.dispose()}}}getThemeIcon(p){return p.iconPath instanceof S.ThemeIcon?p.iconPath:void 0}createHandle(p,{id:o,label:r,resourceUri:g},s,v){if(o)return`${E.ID_HANDLE_PREFIX}/${o}`;const n=f(r,this.extension),t=s?s.item.handle:E.LABEL_HANDLE_PREFIX;let u=n?n.label:g?(0,L.basename)(g):"";u=u.indexOf("/")!==-1?u.replace("/","//"):u;const d=this.nodes.has(p)?this.nodes.get(p).item.handle:void 0,l=this.getChildrenNodes(s)||[];let h,c=0;do{if(h=`${t}/${c}:${u}`,v||!this.elements.has(h)||d===h)break;c++}while(c<=l.length);return h}getLightIconPath(p){if(p.iconPath&&!(p.iconPath instanceof S.ThemeIcon))return typeof p.iconPath=="string"||D.URI.isUri(p.iconPath)?this.getIconPath(p.iconPath):this.getIconPath(p.iconPath.light)}getDarkIconPath(p){if(p.iconPath&&!(p.iconPath instanceof S.ThemeIcon)&&p.iconPath.dark)return this.getIconPath(p.iconPath.dark)}getIconPath(p){return D.URI.isUri(p)?p:D.URI.file(p)}addNodeToCache(p,o){this.elements.set(o.item.handle,p),this.nodes.set(p,o)}updateNodeCache(p,o,r,g){this.elements.delete(o.item.handle),this.nodes.delete(p),o.item.handle!==r.item.handle&&this.elements.delete(r.item.handle),this.addNodeToCache(p,o);const s=this.getChildrenNodes(g)||[],v=s.filter(n=>n.item.handle===r.item.handle)[0];v&&s.splice(s.indexOf(v),1,o)}addNodeToParentCache(p,o){o?(o.children||(o.children=[]),o.children.push(p)):(this.roots||(this.roots=[]),this.roots.push(p))}clearChildren(p){if(p){const o=this.nodes.get(p);if(o){if(o.children)for(const r of o.children){const g=this.elements.get(r.item.handle);g&&this.clear(g)}o.children=void 0}}else this.clearAll()}clear(p){const o=this.nodes.get(p);if(o){if(o.children)for(const r of o.children){const g=this.elements.get(r.item.handle);g&&this.clear(g)}this.nodes.delete(p),this.elements.delete(o.item.handle),o.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(p=>p.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}E.LABEL_HANDLE_PREFIX="0",E.ID_HANDLE_PREFIX="1"}),define(ge[221],pe([0,1,18,3,6,13,63,16,126,89]),function(Y,e,m,L,D,C,i,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class T extends D.Disposable{constructor(a){super();this.controllerId=a,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new i.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(a){this._resolveHandler=a;for(const b of this.tree.values())this.updateExpandability(b)}collectDiff(){const a=this.diff;return this.diff=[],a}pushDiff(a){const b=this.diff[this.diff.length-1];if(b&&a[0]===1){if(b[0]===1&&b[1].extId===a[1].extId){(0,S.applyTestItemUpdate)(b[1],a[1]);return}if(b[0]===0&&b[1].item.extId===a[1].extId){(0,S.applyTestItemUpdate)(b[1],a[1]);return}}this.diff.push(a),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(a,b){const f=this.tree.get(a);if(!!f){if((f.expandLevels===void 0||b>f.expandLevels)&&(f.expandLevels=b),f.expand===1){const w=this.resolveChildren(f);return w.isOpen()?this.expandChildren(f,b-1):w.wait().then(()=>this.expandChildren(f,b-1))}else if(f.expand===3)return f.resolveBarrier?.isOpen()===!1?f.resolveBarrier.wait().then(()=>this.expandChildren(f,b-1)):this.expandChildren(f,b-1)}}dispose(){for(const a of this.tree.values())(0,i.getPrivateApiFor)(a.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(a,b){switch(b.op){case 2:this.pushDiff([4,a.fullId.toString()]);break;case 1:this.removeItem(y.TestId.joinToString(a.fullId,b.id));break;case 0:this.upsertItem(b.item,a);break;case 4:for(const p of b.ops)this.onTestItemEvent(a,p);break;case 3:const{key:f,value:w,previous:E}=b,P=a.fullId.toString();switch(f){case"canResolveChildren":this.updateExpandability(a);break;case"tags":this.diffTagRefs(w,E,P);break;case"range":this.pushDiff([1,{extId:P,item:{range:k.Range.from(w)}}]);break;case"error":this.pushDiff([1,{extId:P,item:{error:k.MarkdownString.fromStrict(w)||null}}]);break;default:this.pushDiff([1,{extId:P,item:{[f]:w??null}}]);break}break;default:(0,C.assertNever)(b)}}upsertItem(a,b){if(!(a instanceof i.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${a.id} did not`);const f=y.TestId.fromExtHostTestItem(a,this.root.id,b?.actual),w=(0,i.getPrivateApiFor)(a);w.parent&&w.parent!==b?.actual&&w.parent.children.delete(a.id);let E=this.tree.get(f.toString());if(!E){E={fullId:f,actual:a,parent:b?f.parentId:null,expandLevels:b?.expandLevels?b.expandLevels-1:void 0,expand:0},a.tags.forEach(this.incrementTagRefs,this),this.tree.set(E.fullId.toString(),E),this.setItemParent(a,b),this.pushDiff([0,{parent:E.parent&&E.parent.toString(),controllerId:this.controllerId,expand:E.expand,item:k.TestItem.from(a)}]),this.connectItemAndChildren(a,E,b);return}if(E.actual===a){this.connectItem(a,E,b);return}const P=E.actual.children,p=E.actual,o=(0,i.diffTestItems)(p,a);(0,i.getPrivateApiFor)(p).listener=void 0,E.actual=a,E.expand=0;for(const[r,g]of o)this.onTestItemEvent(E,{op:3,key:r,value:g,previous:p[r]});this.connectItemAndChildren(a,E,b);for(const r of P)a.children.get(r.id)||this.removeItem(y.TestId.joinToString(f,r.id))}diffTagRefs(a,b,f){const w=new Set(b.map(E=>E.id));for(const E of a)w.delete(E.id)||this.incrementTagRefs(E);this.pushDiff([1,{extId:f,item:{tags:a.map(E=>k.TestTag.namespace(this.controllerId,E.id))}}]),w.forEach(this.decrementTagRefs,this)}incrementTagRefs(a){const b=this.tags.get(a.id);b?b.refCount++:(this.tags.set(a.id,{refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,a.id),ctrlLabel:this.root.label}]))}decrementTagRefs(a){const b=this.tags.get(a);b&&!--b.refCount&&(this.tags.delete(a),this.pushDiff([6,k.TestTag.namespace(this.controllerId,a)]))}setItemParent(a,b){(0,i.getPrivateApiFor)(a).parent=b&&b.actual!==this.root?b.actual:void 0}connectItem(a,b,f){this.setItemParent(a,f);const w=(0,i.getPrivateApiFor)(a);w.parent=f?.actual,w.listener=E=>this.onTestItemEvent(b,E),this.updateExpandability(b)}connectItemAndChildren(a,b,f){this.connectItem(a,b,f);for(const w of a.children)this.upsertItem(w,b)}updateExpandability(a){let b;this._resolveHandler?a.resolveBarrier?b=a.resolveBarrier.isOpen()?3:2:b=a.actual.canResolveChildren?1:0:b=0,b!==a.expand&&(a.expand=b,this.pushDiff([1,{extId:a.fullId.toString(),expand:b}]),b===1&&a.expandLevels!==void 0&&this.resolveChildren(a))}expandChildren(a,b){if(b<0)return;const f=[];for(const w of a.actual.children){const E=this.expand(y.TestId.joinToString(a.fullId,w.id),b);(0,m.isThenable)(E)&&f.push(E)}if(f.length)return Promise.all(f).then(()=>{})}resolveChildren(a){if(a.resolveBarrier)return a.resolveBarrier;if(!this._resolveHandler){const E=new m.Barrier;return E.open(),E}a.expand=2,this.pushExpandStateUpdate(a);const b=a.resolveBarrier=new m.Barrier,f=E=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),a.actual!==this.root&&(a.actual.error=E.stack||E.message||String(E))};let w;try{w=this._resolveHandler(a.actual===this.root?void 0:a.actual)}catch(E){f(E)}return(0,m.isThenable)(w)?w.catch(f).then(()=>{b.open(),this.updateExpandability(a)}):(b.open(),this.updateExpandability(a)),a.resolveBarrier}pushExpandStateUpdate(a){this.pushDiff([1,{extId:a.fullId.toString(),expand:a.expand}])}removeItem(a){const b=this.tree.get(a);if(!b)throw new Error("attempting to remove non-existent child");this.pushDiff([2,a]);const f=[b];for(;f.length;){const w=f.pop();if(!!w){(0,i.getPrivateApiFor)(w.actual).listener=void 0;for(const E of w.actual.tags)this.decrementTagRefs(E.id);this.tree.delete(w.fullId.toString());for(const E of w.actual.children)f.push(this.tree.get(y.TestId.joinToString(w.fullId,E.id)))}}}flushDiff(){const a=this.collectDiff();a.length&&this.diffOpEmitter.fire(a)}}e.SingleUseTestCollection=T}),define(ge[222],pe([0,1,4,182]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,m.refineServiceDecorator)(L.IEnvironmentService)}),define(ge[223],pe([0,1,27,3,9]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(T){this.removedDueToLooping=T}}e.DeltaExtensionsResult=C;class i{constructor(T){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=T,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const T of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(T.identifier))){console.error("Extension `"+T.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(T.identifier),T),this._extensionsArr.push(T),Array.isArray(T.activationEvents))for(let I of T.activationEvents)I==="onUri"&&(I=`onUri:${m.ExtensionIdentifier.toKey(T.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(T)}}keepOnly(T){const I=new Set;T.forEach(a=>I.add(m.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>I.has(m.ExtensionIdentifier.toKey(a.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(T,I){T.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(T));const a=i._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(a.map(b=>b.identifier)),I.length>0){const b=new Set;I.forEach(f=>b.add(m.ExtensionIdentifier.toKey(f))),this._extensionDescriptions=this._extensionDescriptions.filter(f=>!b.has(m.ExtensionIdentifier.toKey(f.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(a)}static _findLoopingExtensions(T){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(E){this._nodesSet.has(E)||(this._nodesSet.add(E),this._nodesArr.push(E))}addArc(E,P){this.addNode(E),this.addNode(P),this._arcs.has(E)?this._arcs.get(E).push(P):this._arcs.set(E,[P])}getArcs(E){return this._arcs.has(E)?this._arcs.get(E):[]}hasOnlyGoodArcs(E,P){const p=I.getArcs(E);for(let o=0;o<p.length;o++)if(!P.has(p[o]))return!1;return!0}getNodes(){return this._nodesArr}};let a=new Map;for(let E of T){const P=m.ExtensionIdentifier.toKey(E.identifier);if(a.set(P,E),E.extensionDependencies)for(let p of E.extensionDependencies){const o=m.ExtensionIdentifier.toKey(p);I.addArc(P,o)}}let b=new Set;I.getNodes().filter(E=>I.getArcs(E).length===0).forEach(E=>b.add(E));let f=I.getNodes().filter(E=>!b.has(E)),w;do{w=!1;for(let E=0;E<f.length;E++){const P=f[E];I.hasOnlyGoodArcs(P,b)&&(f.splice(E,1),E--,b.add(P),w=!0)}}while(w);return f.map(E=>a.get(E))}containsActivationEvent(T){return this._activationMap.has(T)}containsExtension(T){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(T))}getExtensionDescriptionsForActivationEvent(T){const I=this._activationMap.get(T);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(T){const I=this._extensionsMap.get(m.ExtensionIdentifier.toKey(T));return I||void 0}}e.ExtensionDescriptionRegistry=i;var k;(function(y){y[y.Builtin=0]="Builtin",y[y.User=1]="User",y[y.Dev=2]="Dev"})(k||(k={}));function S(y,T){const I=y.isBuiltin?0:y.isUnderDevelopment?2:1,a=T.isBuiltin?0:T.isUnderDevelopment?2:1;if(I!==a)return I-a;const b=D.posix.basename(y.extensionLocation.path),f=D.posix.basename(T.extensionLocation.path);return b<f?-1:b>f?1:0}}),define(ge[224],pe([0,1,22]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var D;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(D=e.MessageType||(e.MessageType={}));function C(k){const S=m.VSBuffer.alloc(1);switch(k){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=C;function i(k,S){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=i}),define(ge[29],pe([0,1,3,2,4,27,193]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");var k;(function(r){r[r.None=0]="None",r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function S(r){switch(r){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=S;class y{constructor(g){this.dependency=g}}e.MissingExtensionDependency=y;var T;(function(r){r[r.LocalProcess=0]="LocalProcess",r[r.LocalWebWorker=1]="LocalWebWorker",r[r.Remote=2]="Remote"})(T=e.ExtensionHostKind||(e.ExtensionHostKind={}));function I(r){switch(r){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=I;function a(r,g){return r.enabledApiProposals?r.enabledApiProposals.includes(g):!1}e.isProposedApiEnabled=a;function b(r,g){if(!a(r,g))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${g}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${g}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=b;class f{constructor(g,s,v,n){this.codeLoadingTime=g,this.activateCallTime=s,this.activateResolvedTime=v,this.activationReason=n}}e.ActivationTimes=f;class w{constructor(g,s){this.description=g,this.value=s}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost";var E;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(E=e.ActivationKind||(e.ActivationKind={}));function P(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,i.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation}}e.toExtension=P;function p(r,g){return{identifier:new C.ExtensionIdentifier(r.identifier.id),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!g,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid}}e.toExtensionDescription=p;class o{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(g){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(g){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(g,s){return Promise.resolve()}_onWillActivateExtension(g){}_onDidActivateExtension(g,s,v,n,t){}_onDidActivateExtensionError(g,s){}_onExtensionRuntimeError(g,s){}_onExtensionHostExit(g){}}e.NullExtensionService=o}),define(ge[225],pe([0,1,15,27,29,11]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const i=Promise.resolve(void 0);class k{constructor(w,E,P,p){this.startup=w,this.codeLoadingTime=E,this.activateCallTime=P,this.activateResolvedTime=p}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class S{constructor(w){this._startup=w,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(w,E){return w===-1||E===-1?-1:E-w}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class y{constructor(w,E,P,p,o,r){this.activationFailed=w,this.activationFailedError=E,this.activationTimes=P,this.module=p,this.exports=o,this.subscriptions=r}}e.ActivatedExtension=y;class T extends y{constructor(w){super(!1,null,w,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class I extends y{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=I;class a extends y{constructor(w){super(!0,w,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=a;let b=class{constructor(w,E,P,p,o){this._logService=o,this._isDisposed=!1,this._registry=w,this._resolvedExtensionsSet=new Set,E.forEach(r=>this._resolvedExtensionsSet.add(L.ExtensionIdentifier.toKey(r))),this._hostExtensionsMap=new Map,P.forEach(r=>this._hostExtensionsMap.set(L.ExtensionIdentifier.toKey(r),r)),this._host=p,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(w){const E=L.ExtensionIdentifier.toKey(w);return this._activatedExtensions.has(E)}getActivatedExtension(w){const E=L.ExtensionIdentifier.toKey(w),P=this._activatedExtensions.get(E);if(!P)throw new Error("Extension `"+w.value+"` is not known or not activated");return P}activateByEvent(w,E){if(this._alreadyActivatedEvents[w])return i;const P=this._registry.getExtensionDescriptionsForActivationEvent(w);return this._activateExtensions(P.map(p=>({id:p.identifier,reason:{startup:E,extensionId:p.identifier,activationEvent:w}}))).then(()=>{this._alreadyActivatedEvents[w]=!0})}activateById(w,E){const P=this._registry.getExtensionDescription(w);if(!P)throw new Error("Extension `"+w+"` is not known");return this._activateExtensions([{id:P.identifier,reason:E}])}_handleActivateRequest(w,E,P){if(this._hostExtensionsMap.has(L.ExtensionIdentifier.toKey(w.id))){E[L.ExtensionIdentifier.toKey(w.id)]=w;return}const p=this._registry.getExtensionDescription(w.id);if(!p){const g=new Error(`Cannot activate unknown extension '${w.id.value}'`);this._host.onExtensionActivationError(w.id,g,new D.MissingExtensionDependency(w.id.value)),this._activatedExtensions.set(L.ExtensionIdentifier.toKey(w.id),new a(g));return}const o=typeof p.extensionDependencies=="undefined"?[]:p.extensionDependencies;let r=!0;for(let g=0,s=o.length;g<s;g++){const v=o[g];if(this._resolvedExtensionsSet.has(L.ExtensionIdentifier.toKey(v)))continue;const n=this._activatedExtensions.get(L.ExtensionIdentifier.toKey(v));if(n&&!n.activationFailed)continue;if(n&&n.activationFailed){const l=p.displayName||p.identifier.value,h=this._registry.getExtensionDescription(v),c=h&&h.displayName||v,_=new Error(`Cannot activate the '${l}' extension because its dependency '${c}' failed to activate`);_.detail=n.activationFailedError,this._host.onExtensionActivationError(p.identifier,_,null),this._activatedExtensions.set(L.ExtensionIdentifier.toKey(p.identifier),new a(_));return}if(this._hostExtensionsMap.has(L.ExtensionIdentifier.toKey(v))){r=!1,E[L.ExtensionIdentifier.toKey(v)]={id:this._hostExtensionsMap.get(L.ExtensionIdentifier.toKey(v)),reason:w.reason};continue}const t=this._registry.getExtensionDescription(v);if(t){if(!t.main&&!t.browser)continue;r=!1,E[L.ExtensionIdentifier.toKey(v)]={id:t.identifier,reason:w.reason};continue}const u=p.displayName||p.identifier.value,d=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${v}'`);this._host.onExtensionActivationError(p.identifier,d,new D.MissingExtensionDependency(v)),this._activatedExtensions.set(L.ExtensionIdentifier.toKey(p.identifier),new a(d));return}r?E[L.ExtensionIdentifier.toKey(p.identifier)]=w:P.push(w)}_activateExtensions(w){if(w.length===0||(w=w.filter(o=>!this._activatedExtensions.has(L.ExtensionIdentifier.toKey(o.id))),w.length===0))return Promise.resolve(void 0);const E=Object.create(null),P=[];for(let o=0,r=w.length;o<r;o++)this._handleActivateRequest(w[o],E,P);for(let o=0,r=P.length;o<r;o++){const g=L.ExtensionIdentifier.toKey(P[o].id);E[g]&&delete E[g]}const p=Object.keys(E).map(o=>E[o]);return P.length===0?Promise.all(p.map(o=>this._activateExtension(o.id,o.reason))).then(o=>{}):this._activateExtensions(p).then(o=>this._activateExtensions(P))}_activateExtension(w,E){const P=L.ExtensionIdentifier.toKey(w);if(this._activatedExtensions.has(P))return Promise.resolve(void 0);const p=this._activatingExtensions.get(P);if(p)return p;const o=this._host.actualActivateExtension(w,E).then(void 0,r=>{const g=new Error;return r&&r.name&&(g.name=r.name),r&&r.message?g.message=`Activating extension '${w.value}' failed: ${r.message}.`:g.message=`Activating extension '${w.value}' failed: ${r}.`,r&&r.stack&&(g.stack=r.stack),this._isDisposed&&m.isPromiseCanceledError(r)?new a(r):(this._host.onExtensionActivationError(w,g,null),this._logService.error(`Activating extension ${w.value} failed due to an error:`),this._logService.error(r),new a(r))}).then(r=>{this._activatedExtensions.set(P,r),this._activatingExtensions.delete(P)});return this._activatingExtensions.set(P,o),o}};b=Ve([He(4,C.ILogService)],b),e.ExtensionsActivator=b}),define(ge[226],pe([0,1,11,26,29]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends m.LogService{constructor(k,S){super(k.createLogger(S.logFile,{name:D.ExtensionHostLogFileName}))}};C=Ve([He(0,m.ILoggerService),He(1,L.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(ge[227],pe([0,1,15]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,i)=>{this._actualOk=C,this._actualErr=i,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,m.onUnexpectedError)(C))}then(C,i){return this._ensureActual().then(C,i)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=L}),define(ge[53],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(y,T){this._proxyIdentifierBrand=void 0,this.isMain=y,this.sid=T,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const L=[];function D(S){const y=new m(!0,S);return L[y.nid]=y,y}e.createMainContextProxyIdentifier=D;function C(S){const y=new m(!1,S);return L[y.nid]=y,y}e.createExtHostContextProxyIdentifier=C;function i(S){return L[S].sid}e.getStringIdentifierForProxy=i;class k{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=k}),define(ge[5],pe([0,1,59,2,53]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var i;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(i=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var a;(function(o){o.name="$ident";function r(s,v){return Object.defineProperty(s,o.name,{value:v,enumerable:!0}),s}o.mixin=r;function g(s){return s[o.name]}o.of=g})(a=e.ObjectIdentifier||(e.ObjectIdentifier={}));class b{static mixin(r){return r._id=b._n++,r}}e.IdObject=b,b._n=0;var f;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(E=e.WorkspaceEditType||(e.WorkspaceEditType={}));function P(o){if(o&&o.edits)for(const r of o.edits)typeof r.resource=="object"?r.resource=L.URI.revive(r.resource):(r.newUri=L.URI.revive(r.newUri),r.oldUri=L.URI.revive(r.oldUri)),r.metadata&&r.metadata.iconPath&&(r.metadata=(0,m.revive)(r.metadata));return o}e.reviveWorkspaceEditDto=P;var p;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,D.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,D.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,D.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,D.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,D.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,D.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,D.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,D.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,D.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,D.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,D.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,D.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,D.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,D.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,D.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,D.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,D.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,D.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,D.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,D.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ge[90],pe([0,1,5,3,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(k){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,S){return this._proxy.$getPassword(k,S)}store(k,S,y){return this._proxy.$setPassword(k,S,y)}delete(k,S){return this._proxy.$deletePassword(k,S)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(ge[65],pe([0,1,4,11,5,14]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,m.createDecorator)("IExtHostApiDeprecationService");let i=class{constructor(S,y){this._extHostLogService=y,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(D.MainContext.MainThreadTelemetry)}report(S,y,T){const I=this.getUsageKey(S,y);this._reportedUsages.has(I)||(this._reportedUsages.add(I),y.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${T}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:S}))}getUsageKey(S,y){return`${S}-${y.identifier.value}`}};i=Ve([He(0,C.IExtHostRpcService),He(1,L.ILogService)],i),e.ExtHostApiDeprecationService=i,e.NullApiDeprecationService=Object.freeze(new class{report(k,S,y){}})}),define(ge[228],pe([0,1,3,5,7,27]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class i{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,y,T,I={}){const a=C.ExtensionIdentifier.toKey(S.identifier),b=this._inFlightRequests.get(a)||[],f=[...T].sort().join(" ");let w=b.find(E=>E.scopes===f);if(w)return w.result;{const E=this._getSession(S,a,y,T,I);w={scopes:f,result:E},b.push(w),this._inFlightRequests.set(a,b);try{await E}finally{const P=b.findIndex(p=>p.scopes===f);P>-1&&(b.splice(P),this._inFlightRequests.set(a,b))}return E}}async _getSession(S,y,T,I,a={}){await this._proxy.$ensureProvider(T);const b=S.displayName||S.name;return this._proxy.$getSession(T,I,y,b,a)}async removeSession(S,y){const T=this._authenticationProviders.get(S);return T?T.provider.removeSession(y):this._proxy.$removeSession(S,y)}registerAuthenticationProvider(S,y,T,I){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:y,provider:T,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(b=>b.id===S)||this._providers.push({id:S,label:y});const a=T.onDidChangeSessions(b=>{this._proxy.$sendDidChangeSessions(S,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,y,I?.supportsMultipleAccounts??!1),new D.Disposable(()=>{a.dispose(),this._authenticationProviders.delete(S);const b=this._providers.findIndex(f=>f.id===S);b>-1&&this._providers.splice(b),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,y){const T=this._authenticationProviders.get(S);if(T)return Promise.resolve(T.provider.createSession(y));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,y){const T=this._authenticationProviders.get(S);if(T)return Promise.resolve(T.provider.removeSession(y));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,y){const T=this._authenticationProviders.get(S);if(T)return Promise.resolve(T.provider.getSessions(y));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,y){return this._onDidChangeSessions.fire({provider:{id:S,label:y}}),Promise.resolve()}}e.ExtHostAuthentication=i}),define(ge[229],pe([0,1,5,14,16]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(k,S){this._extHostDocumentsAndEditors=S,this._proxy=k.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const S=D.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};C=Ve([He(0,L.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(ge[230],pe([0,1,5]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(C){const i=C.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return i.$readText()},writeText(k){return i.$writeText(k)}})}}e.ExtHostClipboard=L}),define(ge[38],pe([0,1,13,7,16,25,5,17,11,59,41,49,2,6,4,14,63,22,53,50]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E,P,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(u,d){this._commands=new Map,this._apiCommands=new Map,this._proxy=u.getProxy(i.MainContext.MainThreadCommands),this._logService=d,this.converter=new g(this,l=>{const h=this._apiCommands.get(l);return h?.result===v.Void?h:void 0},d),this._argumentProcessors=[{processArgument(l){return(0,y.revive)(l)}},{processArgument(l){return(0,C.cloneAndChange)(l,function(h){if(T.Range.isIRange(h))return D.Range.to(h);if(I.Position.isIPosition(h))return D.Position.to(h);if(T.Range.isIRange(h.range)&&a.URI.isUri(h.uri))return D.location.to(h);if(h instanceof P.VSBuffer)return h.buffer.buffer;if(!Array.isArray(h))return h})}}]}registerArgumentProcessor(u){this._argumentProcessors.push(u)}registerApiCommand(u){const d=this.registerCommand(!1,u.id,async(...l)=>{const h=u.args.map((_,A)=>{if(!_.validate(l[A]))throw new Error(`Invalid argument '${_.name}' when running '${u.id}', received: ${l[A]}`);return _.convert(l[A])}),c=await this.executeCommand(u.internalId,...h);return u.result.convert(c,l,this.converter)},void 0,{description:u.description,args:u.args,returns:u.result.description});return this._apiCommands.set(u.id,u),new L.Disposable(()=>{d.dispose(),this._apiCommands.delete(u.id)})}registerCommand(u,d,l,h,c,_){if(this._logService.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this._commands.has(d))throw new Error(`command '${d}' already exists`);return this._commands.set(d,{callback:l,thisArg:h,description:c,extension:_}),u&&this._proxy.$registerCommand(d),new L.Disposable(()=>{this._commands.delete(d)&&u&&this._proxy.$unregisterCommand(d)})}executeCommand(u,...d){return this._logService.trace("ExtHostCommands#executeCommand",u),this._doExecuteCommand(u,d,!0)}async _doExecuteCommand(u,d,l){if(this._commands.has(u))return this._executeContributedCommand(u,d,!1);{let h=!1;const c=(0,C.cloneAndChange)(d,function(_){if(_ instanceof L.Position)return D.Position.from(_);if(_ instanceof L.Range)return D.Range.from(_);if(_ instanceof L.Location)return D.location.from(_);if(L.NotebookRange.isNotebookRange(_))return D.NotebookRange.from(_);if(_ instanceof ArrayBuffer)return h=!0,P.VSBuffer.wrap(new Uint8Array(_));if(_ instanceof Uint8Array)return h=!0,P.VSBuffer.wrap(_);if(!Array.isArray(_))return _});try{const _=await this._proxy.$executeCommand(u,h?new p.SerializableObjectWithBuffers(c):c,l);return(0,y.revive)(_)}catch(_){if(_ instanceof Error&&_.message==="$executeCommand:retry")return this._doExecuteCommand(u,d,!1);throw _}}}async _executeContributedCommand(u,d,l){const h=this._commands.get(u);if(!h)throw new Error("Unknown command");let{callback:c,thisArg:_,description:A}=h;if(A)for(let R=0;R<A.args.length;R++)try{(0,m.validateConstraint)(d[R],A.args[R].constraint)}catch(x){throw new Error(`Running the contributed command: '${u}' failed. Illegal argument '${A.args[R].name}' - ${A.args[R].description}`)}try{return await c.apply(_,d)}catch(R){if(u===this.converter.delegatingCommandId){const x=this.converter.getActualCommand(...d);x&&(u=x.command)}throw this._logService.error(R,u,h.extension?.identifier),l?new class extends Error{constructor(){super((0,o.toErrorMessage)(R));this.id=u,this.source=h.extension?.displayName??h.extension?.name}}:R}}$executeContributedCommand(u,...d){return this._logService.trace("ExtHostCommands#$executeContributedCommand",u),this._commands.has(u)?(d=d.map(l=>this._argumentProcessors.reduce((h,c)=>c.processArgument(h),l)),this._executeContributedCommand(u,d,!0)):Promise.reject(new Error(`Contributed command '${u}' does not exist.`))}getCommands(u=!1){return this._logService.trace("ExtHostCommands#getCommands",u),this._proxy.$getCommands().then(d=>(u&&(d=d.filter(l=>l[0]!=="_")),d))}$getContributedCommandHandlerDescriptions(){const u=Object.create(null);for(let[d,l]of this._commands){let{description:h}=l;h&&(u[d]=h)}return Promise.resolve(u)}};r=Ve([He(0,w.IExtHostRpcService),He(1,S.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class g{constructor(u,d,l){this._commands=u,this._lookupApiCommand=d,this._logService=l,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(u,d){if(!u)return;const l={$ident:void 0,id:u.command,title:u.title,tooltip:u.tooltip};if(!u.command)return l;const h=this._lookupApiCommand(u.command);if(h)l.id=h.internalId,l.arguments=h.args.map((c,_)=>c.convert(u.arguments&&u.arguments[_]));else if((0,k.isNonEmptyArray)(u.arguments)){const c=++this._cachIdPool;this._cache.set(c,u),d.add((0,b.toDisposable)(()=>{this._cache.delete(c),this._logService.trace("CommandsConverter#DISPOSE",c)})),l.$ident=c,l.id=this.delegatingCommandId,l.arguments=[c],this._logService.trace("CommandsConverter#CREATE",u.command,c)}return l}fromInternal(u){const d=i.ObjectIdentifier.of(u);return typeof d=="number"?this._cache.get(d):{command:u.id,title:u.title,arguments:u.arguments}}getActualCommand(...u){return this._cache.get(u[0])}_executeConvertedCommand(...u){const d=this.getActualCommand(...u);return this._logService.trace("CommandsConverter#EXECUTE",u[0],d?d.command:"MISSING"),d?this._commands.executeCommand(d.command,...d.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=g;class s{constructor(u,d,l,h){this.name=u,this.description=d,this.validate=l,this.convert=h}optional(){return new s(this.name,`(optional) ${this.description}`,u=>u==null||this.validate(u),u=>u===void 0?void 0:u===null?null:this.convert(u))}with(u,d){return new s(u??this.name,d??this.description,this.validate,this.convert)}}e.ApiCommandArgument=s,s.Uri=new s("uri","Uri of a text document",t=>a.URI.isUri(t),t=>t),s.Position=new s("position","A position in a text document",t=>L.Position.isPosition(t),D.Position.from),s.Range=new s("range","A range in a text document",t=>L.Range.isRange(t),D.Range.from),s.Selection=new s("selection","A selection in a text document",t=>L.Selection.isSelection(t),D.Selection.from),s.Number=new s("number","",t=>typeof t=="number",t=>t),s.String=new s("string","",t=>typeof t=="string",t=>t),s.CallHierarchyItem=new s("item","A call hierarchy item",t=>t instanceof L.CallHierarchyItem,D.CallHierarchyItem.from),s.TypeHierarchyItem=new s("item","A type hierarchy item",t=>t instanceof L.TypeHierarchyItem,D.TypeHierarchyItem.from),s.TestItem=new s("testItem","A VS Code TestItem",t=>t instanceof E.TestItemImpl,D.TestItem.from);class v{constructor(u,d){this.description=u,this.convert=d}}e.ApiCommandResult=v,v.Void=new v("no result",t=>t);class n{constructor(u,d,l,h,c){this.id=u,this.internalId=d,this.description=l,this.args=h,this.result=c}}e.ApiCommand=n}),define(ge[231],pe([0,1,16,7,84,38,17,110]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(m.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,b)=>{if((0,i.isFalsyOrEmpty)(a))return;class f extends L.SymbolInformation{static to(E){const P=new f(E.name,m.SymbolKind.to(E.kind),E.containerName||"",new L.Location(b[0],m.Range.to(E.range)));return P.detail=E.detail,P.range=P.location.range,P.selectionRange=m.Range.to(E.selectionRange),P.children=E.children?E.children.map(f.to):[],P}}return a.map(f.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new C.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(m.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(m.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(m.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(b=>L.Position.isPosition(b)),a=>a.map(m.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(b=>{let f;for(const w of b.reverse())f=new L.SelectionRange(m.Range.to(w),f);return f}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(m.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(m.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(m.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(m.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",a=>{if(!!a)return{range:m.Range.to(a.range),placeholder:a.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return m.WorkspaceEdit.to(a)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(m.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new L.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const b=(0,k.decodeSemanticTokensDto)(a);if(b.type==="full")return new L.SemanticTokens(b.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new L.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const b=(0,k.decodeSemanticTokensDto)(a);if(b.type==="full")return new L.SemanticTokens(b.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,b,f)=>{if(!a)return new L.CompletionList([]);const w=a.suggestions.map(E=>m.CompletionItem.to(E,f));return new L.CompletionList(w,a.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return m.SignatureHelp.to(a)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,b,f)=>T(w=>new L.CodeLens(m.Range.to(w.range),w.command&&f.fromInternal(w.command)))(a))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>L.Range.isRange(a),a=>L.Selection.isSelection(a)?m.Selection.from(a):m.Range.from(a)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,b,f)=>T(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(w.command)}else{const E=new L.CodeAction(w.title,w.kind?new L.CodeActionKind(w.kind):void 0);return w.edit&&(E.edit=m.WorkspaceEdit.to(w.edit)),w.command&&(E.command=f.fromInternal(w.command)),E.isPreferred=w.isPreferred,E}})(a))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(b=>new L.ColorInformation(m.Range.to(b.range),m.Color.to(b.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",a=>a instanceof L.Color,m.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:m.Range.from(a.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(m.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",a=>a.map(m.InlayHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(b=>m.NotebookExclusiveDocumentPattern.to(b))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(m.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[m.ViewColumn.from(a.viewColumn),m.TextEditorOpenOptions.from(a)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[m.ViewColumn.from(a.viewColumn),m.TextEditorOpenOptions.from(a)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[m.ViewColumn.from(a.viewColumn),m.TextEditorOpenOptions.from(a)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class y{static register(b){S.forEach(b.registerApiCommand,b)}}e.ExtHostApiCommands=y;function T(a){return b=>{if(Array.isArray(b))return b.map(a)}}function I(a){if(!Array.isArray(a))return;const b=[];for(const f of a)D.isLocationLink(f)?b.push(m.DefinitionLink.to(f)):b.push(m.location.to(f));return b}}),define(ge[232],pe([0,1,18,57,3,6,2,84,27,16,7,5]),function(Y,e,m,L,D,C,i,k,S,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function a(b,f,w){const E=b.getProxy(I.MainContext.MainThreadComments);class P{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,f.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const u=this._commentControllers.get(t.handle);return u||t}else if(t&&t.$mid===7){const u=this._commentControllers.get(t.commentControlHandle);if(!u)return t;const d=u.getCommentThread(t.commentThreadHandle);return d||t}else if(t&&t.$mid===8){const u=this._commentControllers.get(t.thread.commentControlHandle);if(!u)return t;const d=u.getCommentThread(t.thread.commentThreadHandle);return d?{thread:d,text:t.text}:t}else if(t&&t.$mid===9){const u=this._commentControllers.get(t.thread.commentControlHandle);if(!u)return t;const d=u.getCommentThread(t.thread.commentThreadHandle);if(!d)return t;let l=t.commentUniqueId,h=d.getCommentByUniqueId(l);return h||t}else if(t&&t.$mid===10){const u=this._commentControllers.get(t.thread.commentControlHandle);if(!u)return t;const d=u.getCommentThread(t.thread.commentThreadHandle);if(!d)return t;let l=t.text,h=t.commentUniqueId,c=d.getCommentByUniqueId(h);return c?(c.body=l,c):t}return t}})}createCommentController(t,u,d){const l=P.handlePool++,h=new o(t,l,u,d);this._commentControllers.set(h.handle,h);const c=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(t.identifier))||[];return c.push(h),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(t.identifier),c),h.value}$createCommentThreadTemplate(t,u,d){const l=this._commentControllers.get(t);!l||l.$createCommentThreadTemplate(u,d)}async $updateCommentThreadTemplate(t,u,d){const l=this._commentControllers.get(t);!l||l.$updateCommentThreadTemplate(u,d)}$deleteCommentThread(t,u){const d=this._commentControllers.get(t);d&&d.$deleteCommentThread(u)}$provideCommentingRanges(t,u,d){const l=this._commentControllers.get(t);if(!l||!l.commentingRangeProvider)return Promise.resolve(void 0);const h=w.getDocument(i.URI.revive(u));return(0,m.asPromise)(()=>l.commentingRangeProvider.provideCommentingRanges(h,d)).then(c=>c?c.map(_=>y.Range.from(_)):void 0)}$toggleReaction(t,u,d,l,h){const c=this._commentControllers.get(t);return!c||!c.reactionHandler?Promise.resolve(void 0):(0,m.asPromise)(()=>{const _=c.getCommentThread(u);if(_){const A=_.getCommentByUniqueId(l.uniqueIdInThread);if(c!==void 0&&A&&c.reactionHandler)return c.reactionHandler(A,s(h))}return Promise.resolve(void 0)})}dispose(){}}P.handlePool=0;class p{constructor(t,u,d,l,h,c,_){this._commentControllerHandle=u,this._id=d,this._uri=l,this._range=h,this._comments=c,this.handle=p._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),E.$createCommentThread(u,this.handle,this._id,this._uri,y.Range.from(this._range),_),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=c,this._localDisposables.push({dispose:()=>{E.$deleteCommentThread(u,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(R){A.range=R},get comments(){return A.comments},set comments(R){A.comments=R},get collapsibleState(){return A.collapsibleState},set collapsibleState(R){A.collapsibleState=R},get canReply(){return A.canReply},set canReply(R){A.canReply=R},get contextValue(){return A.contextValue},set contextValue(R){A.contextValue=R},get label(){return A.label},set label(R){A.label=R},dispose:()=>{A.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const t=d=>Object.prototype.hasOwnProperty.call(this.modifications,d),u={};t("range")&&(u.range=y.Range.from(this._range)),t("label")&&(u.label=this.label),t("contextValue")&&(u.contextValue=this.contextValue??null),t("comments")&&(u.comments=this._comments.map(d=>r(this,d,this._commentsMap))),t("collapsibleState")&&(u.collapseState=v(this._collapseState)),t("canReply")&&(u.canReply=this.canReply),this.modifications={},E.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,u)}getCommentByUniqueId(t){for(let u of this._commentsMap){let d=u[0],l=u[1];if(t===l)return d}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}p._handlePool=0,Ve([(0,L.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(t,u,d,l){this._extension=t,this._handle=u,this._id=d,this._label=l,this._threads=new Map,E.$registerCommentController(this.handle,d,l);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(c){h.options=c},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(c){h.commentingRangeProvider=c},get reactionHandler(){return h.reactionHandler},set reactionHandler(c){h.reactionHandler=c},createCommentThread(c,_,A){return h.createCommentThread(c,_,A).value},dispose:()=>{h.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{E.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,E.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,E.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,E.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,u,d,l){if(typeof t=="string"){const h=new p(this.id,this.handle,t,u,d,l,this._extension.identifier);return this._threads.set(h.handle,h),h}else{const h=new p(this.id,this.handle,void 0,t,u,d,this._extension.identifier);return this._threads.set(h.handle,h),h}}$createCommentThreadTemplate(t,u){const d=new p(this.id,this.handle,void 0,i.URI.revive(t),y.Range.to(u),[],this._extension.identifier);return d.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(d.handle,d),d}$updateCommentThreadTemplate(t,u){let d=this._threads.get(t);d&&(d.range=y.Range.to(u))}$deleteCommentThread(t){let u=this._threads.get(t);u&&u.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function r(n,t,u){let d=u.get(t);d||(d=++n.commentHandle,u.set(t,d));const l=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:d,body:y.MarkdownString.from(t.body),userName:t.author.name,userIconPath:l,label:t.label,commentReactions:t.reactions?t.reactions.map(h=>g(h)):void 0}}function g(n){return{label:n.label,iconPath:n.iconPath?y.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function s(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?i.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function v(n){if(n!==void 0)switch(n){case T.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new P}e.createExtHostComments=a}),define(ge[130],pe([0,1,2,5,7,4,14,11,17,8,9]),function(Y,e,m,L,D,C,i,k,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class bi{constructor(b,f){this._logService=f,this._provider=new Map,this._proxy=b.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(b,f){const w=bi._handlePool++;this._provider.set(w,{provider:b,extensionId:f}),this._proxy.$registerDecorationProvider(w,f.value);const E=b.onDidChangeFileDecorations&&b.onDidChangeFileDecorations(P=>{if(!P){this._proxy.$onDidChange(w,null);return}let p=(0,S.asArray)(P);if(p.length<=bi._maxEventSize){this._proxy.$onDidChange(w,p);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.value,p.length);const o=p.map(s=>({uri:s,rank:(0,y.count)(s.path,"/")})),r=(0,S.groupBy)(o,(s,v)=>s.rank-v.rank||(0,y.compare)(s.uri.path,v.uri.path));let g=[];e:for(let s of r){let v;for(let n of s){let t=(0,T.dirname)(n.uri.path);if(v!==t&&(v=t,g.push(n.uri)>=bi._maxEventSize))break e}}this._proxy.$onDidChange(w,g)});return new D.Disposable(()=>{E?.dispose(),this._proxy.$unregisterDecorationProvider(w),this._provider.delete(w)})}async $provideDecorations(b,f,w){if(!this._provider.has(b))return Object.create(null);const E=Object.create(null),{provider:P,extensionId:p}=this._provider.get(b);return await Promise.all(f.map(async o=>{try{const{uri:r,id:g}=o,s=await Promise.resolve(P.provideFileDecoration(m.URI.revive(r),w));if(!s)return;try{D.FileDecoration.validate(s),E[g]=[s.propagate,s.tooltip,s.badge,s.color]}catch(v){this._logService.warn(`INVALID decoration from extension '${p.value}': ${v}`)}}catch(r){this._logService.error(r)}})),E}};I._handlePool=0,I._maxEventSize=250,I=Ve([He(0,i.IExtHostRpcService),He(1,k.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[233],pe([0,1,162,116,2,5,7,16,3,11,24,44]),function(Y,e,m,L,D,C,i,k,S,y,T,I){"use strict";var a,b,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class w{constructor(p,o,r,g,s,v){this._name=p,this._owner=o,this._maxDiagnosticsPerFile=r,a.set(this,void 0),b.set(this,void 0),f.set(this,void 0),this._isDisposed=!1,ot(this,f,new T.ResourceMap(n=>g.getComparisonKey(n)),"f"),ot(this,a,s,"f"),ot(this,b,v,"f")}dispose(){this._isDisposed||(Oe(this,b,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,a,"f")&&Oe(this,a,"f").$clear(this._owner),Oe(this,f,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(p,o){if(!p){this.clear();return}this._checkDisposed();let r=[];if(D.URI.isUri(p)){if(!o){this.delete(p);return}Oe(this,f,"f").set(p,o.slice()),r=[p]}else if(Array.isArray(p)){r=[];let s;p=[...p].sort(w._compareIndexedTuplesByUri);for(const v of p){const[n,t]=v;if((!s||n.toString()!==s.toString())&&(s&&Oe(this,f,"f").get(s).length===0&&Oe(this,f,"f").delete(s),s=n,r.push(n),Oe(this,f,"f").set(n,[])),t){const u=Oe(this,f,"f").get(n);u&&u.push(...t)}else{const u=Oe(this,f,"f").get(n);u&&(u.length=0)}}}if(Oe(this,b,"f").fire(r),!Oe(this,a,"f"))return;const g=[];for(let s of r){let v=[];const n=Oe(this,f,"f").get(s);if(n)if(n.length>this._maxDiagnosticsPerFile){v=[];const t=[i.DiagnosticSeverity.Error,i.DiagnosticSeverity.Warning,i.DiagnosticSeverity.Information,i.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(let d of n)if(d.severity===t[u]&&v.push(k.Diagnostic.from(d))===this._maxDiagnosticsPerFile)break e;v.push({severity:L.MarkerSeverity.Info,message:(0,m.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:v[v.length-1].startLineNumber,startColumn:v[v.length-1].startColumn,endLineNumber:v[v.length-1].endLineNumber,endColumn:v[v.length-1].endColumn})}else v=n.map(t=>k.Diagnostic.from(t));g.push([s,v])}Oe(this,a,"f").$changeMany(this._owner,g)}delete(p){this._checkDisposed(),Oe(this,b,"f").fire([p]),Oe(this,f,"f").delete(p),Oe(this,a,"f")&&Oe(this,a,"f").$changeMany(this._owner,[[p,void 0]])}clear(){this._checkDisposed(),Oe(this,b,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,f,"f").clear(),Oe(this,a,"f")&&Oe(this,a,"f").$clear(this._owner)}forEach(p,o){this._checkDisposed();for(let r of Oe(this,f,"f").keys())p.apply(o,[r,this.get(r),this])}get(p){this._checkDisposed();const o=Oe(this,f,"f").get(p);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(p){return this._checkDisposed(),Array.isArray(Oe(this,f,"f").get(p))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(p,o){return p[0].toString()<o[0].toString()?-1:p[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=w,a=new WeakMap,b=new WeakMap,f=new WeakMap;let E=class ri{constructor(p,o,r){this._logService=o,this._fileSystemInfoService=r,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,ri._mapper),this._proxy=p.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(p){const o=new T.ResourceMap;for(const r of p)o.set(r,r);return{uris:Object.freeze(Array.from(o.values()))}}createDiagnosticCollection(p,o){const{_collections:r,_proxy:g,_onDidChangeDiagnostics:s,_logService:v,_fileSystemInfoService:n}=this,t=new class{$changeMany(l,h){g.$changeMany(l,h),v.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,l,h.length===0?"CLEARING":h)}$clear(l){g.$clear(l),v.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,l)}dispose(){g.dispose()}};let u;if(!o)o="_generated_diagnostic_collection_name_#"+ri._idPool++,u=o;else if(!r.has(o))u=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do u=o+ri._idPool++;while(r.has(u))}return new class extends w{constructor(){super(o,u,ri._maxDiagnosticsPerFile,n.extUri,t,s);r.set(u,this)}dispose(){super.dispose(),r.delete(u)}}}getDiagnostics(p){if(p)return this._getDiagnostics(p);{const o=new Map,r=[];for(const g of this._collections.values())g.forEach((s,v)=>{let n=o.get(s.toString());typeof n=="undefined"&&(n=r.length,o.set(s.toString(),n),r.push([s,[]])),r[n][1]=r[n][1].concat(...v)});return r}}_getDiagnostics(p){let o=[];for(let r of this._collections.values())r.has(p)&&(o=o.concat(r.get(p)));return o}$acceptMarkersChange(p){if(!this._mirrorCollection){const o="_generated_mirror",r=new w(o,o,ri._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,r),this._mirrorCollection=r}for(const[o,r]of p)this._mirrorCollection.set(D.URI.revive(o),r.map(k.Diagnostic.to))}};E._idPool=0,E._maxDiagnosticsPerFile=1e3,E=Ve([He(1,y.ILogService),He(2,I.IExtHostFileSystemInfo)],E),e.ExtHostDiagnostics=E}),define(ge[234],pe([0,1,2,5]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(i){this._proxy=i.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(i){return this._proxy.$showOpenDialog(i).then(k=>k?k.map(S=>m.URI.revive(S)):void 0)}showSaveDialog(i){return this._proxy.$showSaveDialog(i).then(k=>k?m.URI.revive(k):void 0)}}e.ExtHostDialogs=D}),define(ge[235],pe([0,1,15,2,7,5,10,21,8]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class y{constructor(I,a,b){this._documentsAndEditors=a,this._logService=b,this._documentContentProviders=new Map,this._proxy=I.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,a){if(Object.keys(i.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const b=y._handlePool++;this._documentContentProviders.set(b,a),this._proxy.$registerTextContentProvider(b,I);let f;return typeof a.onDidChange=="function"&&(f=a.onDidChange(w=>{if(w.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(w)&&this.$provideTextDocumentContent(b,w).then(E=>{if(!E&&typeof E!="string")return;const P=this._documentsAndEditors.getDocument(w);if(!P)return;const p=(0,S.splitLines)(E);if(!P.equalLines(p))return this._proxy.$onVirtualDocumentChange(w,E)},m.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(b)&&this._proxy.$unregisterTextContentProvider(b),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(I,a){const b=this._documentContentProviders.get(I);return b?Promise.resolve(b.provideTextDocumentContent(L.URI.revive(a),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.ExtHostDocumentContentProvider=y,y._handlePool=0}),define(ge[236],pe([0,1,3,6,2,5,122,16,13,25,7]),function(Y,e,m,L,D,C,i,k,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(b,f){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=b.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(w=>{for(const E of w)this._onDidRemoveDocument.fire(E.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(w=>{for(const E of w)this._onDidAddDocument.fire(E.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(b){if(!b)return;const f=this._documentsAndEditors.getDocument(b);if(f)return f}getDocument(b){const f=this.getDocumentData(b);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return f.document}ensureDocumentData(b){const f=this._documentsAndEditors.getDocument(b);if(f)return Promise.resolve(f);let w=this._documentLoader.get(b.toString());return w||(w=this._proxy.$tryOpenDocument(b).then(E=>{this._documentLoader.delete(b.toString());const P=D.URI.revive(E);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(P))},E=>(this._documentLoader.delete(b.toString()),Promise.reject(E))),this._documentLoader.set(b.toString(),w)),w}createDocumentData(b){return this._proxy.$tryCreateDocument(b).then(f=>D.URI.revive(f))}$acceptModelModeChanged(b,f){const w=D.URI.revive(b),E=this._documentsAndEditors.getDocument(w);if(!E)throw new Error("unknown document");this._onDidRemoveDocument.fire(E.document),E._acceptLanguageId(f),this._onDidAddDocument.fire(E.document)}$acceptModelSaved(b){const f=D.URI.revive(b),w=this._documentsAndEditors.getDocument(f);if(!w)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this._onDidSaveDocument.fire(w.document)}$acceptDirtyStateChanged(b,f){const w=D.URI.revive(b),E=this._documentsAndEditors.getDocument(w);if(!E)throw new Error("unknown document");E._acceptIsDirty(f),this._onDidChangeDocument.fire({document:E.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,f,w){const E=D.URI.revive(b),P=this._documentsAndEditors.getDocument(E);if(!P)throw new Error("unknown document");P._acceptIsDirty(w),P.onEvents(f);let p;f.isUndoing?p=T.TextDocumentChangeReason.Undo:f.isRedoing&&(p=T.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,y.deepFreeze)({document:P.document,contentChanges:f.changes.map(o=>({range:k.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:p}))}setWordDefinitionFor(b,f){(0,i.setWordDefinitionFor)(b,f)}}e.ExtHostDocuments=I}),define(ge[45],pe([0,1,56,3,6,2,4,5,122,14,129,16,11,24,10,76,140]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class P{constructor(r){this.value=r,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let p=class{constructor(r,g){this._extHostRpc=r,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new b.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const g=[],s=[],v=[];if(r.removedDocuments)for(const n of r.removedDocuments){const t=C.URI.revive(n),u=this._documents.get(t);u?.unref()&&(this._documents.delete(t),g.push(u.value))}if(r.addedDocuments)for(const n of r.addedDocuments){const t=C.URI.revive(n.uri);let u=this._documents.get(t);if(u&&t.scheme!==f.Schemas.vscodeNotebookCell&&t.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);u||(u=new P(new S.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),t,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(t,u),s.push(u.value)),u.ref()}if(r.removedEditors)for(const n of r.removedEditors){const t=this._editors.get(n);this._editors.delete(n),t&&v.push(t)}if(r.addedEditors)for(const n of r.addedEditors){const t=C.URI.revive(n.documentUri);m.ok(this._documents.has(t),`document '${t}' does not exist`),m.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const u=this._documents.get(t).value,d=new T.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new E.Lazy(()=>u.document),n.selections.map(I.Selection.to),n.options,n.visibleRanges.map(l=>I.Range.to(l)),typeof n.editorPosition=="number"?I.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,d)}r.newActiveEditor!==void 0&&(m.ok(r.newActiveEditor===null||this._editors.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this._activeEditorId=r.newActiveEditor),(0,D.dispose)(g),(0,D.dispose)(v),r.removedDocuments&&this._onDidRemoveDocuments.fire(g),r.addedDocuments&&this._onDidAddDocuments.fire(s),(r.removedEditors||r.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),r.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(r){return this._documents.get(r)?.value}allDocuments(){return w.Iterable.map(this._documents.values(),r=>r.value)}getEditor(r){return this._editors.get(r)}activeEditor(r){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return r?g:g?.value}allEditors(){return[...this._editors.values()]}};p=Ve([He(0,y.IExtHostRpcService),He(1,a.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,i.createDecorator)("IExtHostDocumentsAndEditors")}),define(ge[54],pe([0,1,16,5,2,3,4,14,18]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,i.createDecorator)("IExtHostEditorTabs");let y=class{constructor(I){this._onDidChangeTabs=new C.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new C.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=I.getProxy(L.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(I){let a=-1;this._tabs=I.map((f,w)=>(f.isActive&&(a=w),Object.freeze({label:f.label,viewColumn:m.ViewColumn.to(f.viewColumn),index:w,resource:D.URI.revive(f.resource),additionalResourcesAndViewIds:f.additionalResourcesAndViewIds.map(({resource:E,viewId:P})=>({resource:D.URI.revive(E),viewId:P})),viewId:f.editorId,isActive:f.isActive,move:async(E,P)=>{this._proxy.$moveTab(f,E,m.ViewColumn.from(P)),await(0,S.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(f),await(0,S.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((f,w)=>f.viewColumn===w.viewColumn?f.index-w.index:f.viewColumn-w.viewColumn);const b=this._activeTab;this._activeTab=a===-1?void 0:this._tabs[a],this._activeTab!==b&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};y=Ve([He(0,k.IExtHostRpcService)],y),e.ExtHostEditorTabs=y}),define(ge[237],pe([0,1,2,5,6,7,16,147,8,22,29]),function(Y,e,m,L,D,C,i,k,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class I{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const w=this._schemes.indexOf(f);w>=0&&(this._schemes.splice(w,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),w=[];let E,P,p=14,o=14;for(const r of f){let g=E?(0,S.commonPrefixLength)(E,r):0;for(g===0?P=1:P=o;g<r.length;g++)g+1===r.length?(p=o,o=9):o+=1,w.push([P,r.toUpperCase().charCodeAt(g),o]),w.push([P,r.toLowerCase().charCodeAt(g),o]),P=o;E=r,o=p}w.push([9,58,10]),w.push([10,47,12]),this._stateMachine=new k.StateMachine(w)}}provideDocumentLinks(f){this._initStateMachine();const w=[],E=k.LinkComputer.computeLinks({getLineContent(P){return f.lineAt(P-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const P of E){const p=i.DocumentLink.to(P);p.target&&w.push(p)}return w}}class a{constructor(f,w){this._extHostLanguageFeatures=w,this._linkProvider=new I,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,w,E,P={}){if(this._registeredSchemes.has(w))throw new Error(`a provider for the scheme '${w}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const p=this._handlePool++;this._linkProvider.add(w),this._registeredSchemes.add(w),this._fsProvider.set(p,E);let o=2;P.isCaseSensitive&&(o+=1024),P.isReadonly&&(o+=2048),typeof E.copy=="function"&&(o+=8),typeof E.open=="function"&&typeof E.close=="function"&&typeof E.read=="function"&&typeof E.write=="function"&&((0,T.checkProposedApiEnabled)(f,"fsChunks"),o+=4),this._proxy.$registerFileSystemProvider(p,w,o).catch(g=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${w}`),console.error(g)});const r=E.onDidChangeFile(g=>{const s=[];for(const v of g){let{uri:n,type:t}=v;if(n.scheme!==w)continue;let u;switch(t){case C.FileChangeType.Changed:u=0;break;case C.FileChangeType.Created:u=1;break;case C.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:n,type:u})}this._proxy.$onFileSystemChange(p,s)});return(0,D.toDisposable)(()=>{r.dispose(),this._linkProvider.delete(w),this._registeredSchemes.delete(w),this._fsProvider.delete(p),this._proxy.$unregisterProvider(p)})}static _asIStat(f){const{type:w,ctime:E,mtime:P,size:p,permissions:o}=f;return{type:w,ctime:E,mtime:P,size:p,permissions:o}}$stat(f,w){return Promise.resolve(this._getFsProvider(f).stat(m.URI.revive(w))).then(E=>a._asIStat(E))}$readdir(f,w){return Promise.resolve(this._getFsProvider(f).readDirectory(m.URI.revive(w)))}$readFile(f,w){return Promise.resolve(this._getFsProvider(f).readFile(m.URI.revive(w))).then(E=>y.VSBuffer.wrap(E))}$writeFile(f,w,E,P){return Promise.resolve(this._getFsProvider(f).writeFile(m.URI.revive(w),E.buffer,P))}$delete(f,w,E){return Promise.resolve(this._getFsProvider(f).delete(m.URI.revive(w),E))}$rename(f,w,E,P){return Promise.resolve(this._getFsProvider(f).rename(m.URI.revive(w),m.URI.revive(E),P))}$copy(f,w,E,P){const p=this._getFsProvider(f);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(m.URI.revive(w),m.URI.revive(E),P))}$mkdir(f,w){return Promise.resolve(this._getFsProvider(f).createDirectory(m.URI.revive(w)))}$watch(f,w,E,P){const p=this._getFsProvider(f).watch(m.URI.revive(E),P);this._watches.set(w,p)}$unwatch(f,w){const E=this._watches.get(w);E&&(E.dispose(),this._watches.delete(w))}$open(f,w,E){const P=this._getFsProvider(f);if(!P.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(P.open(m.URI.revive(w),E))}$close(f,w){const E=this._getFsProvider(f);if(!E.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(E.close(w))}$read(f,w,E,P){const p=this._getFsProvider(f);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const o=y.VSBuffer.alloc(P);return Promise.resolve(p.read(w,E,o.buffer,0,P)).then(r=>o.slice(0,r))}$write(f,w,E,P){const p=this._getFsProvider(f);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(w,E,P.buffer,0,P.byteLength))}_getFsProvider(f){const w=this._fsProvider.get(f);if(!w){const E=new Error;throw E.name="ENOPRO",E.message="no provider",E}return w}}e.ExtHostFileSystem=a}),define(ge[66],pe([0,1,5,42,7,22,4,14,44,6]),function(Y,e,m,L,D,C,i,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let T=class Wt{constructor(a,b){this._fileSystemProvider=new Map,this._proxy=a.getProxy(m.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(w){try{const E=f._fileSystemProvider.get(w.scheme);if(!E)return await f._proxy.$stat(w);await f._proxy.$ensureActivation(w.scheme);const P=await E.stat(w);return{type:P.type,ctime:P.ctime,mtime:P.mtime,size:P.size,permissions:P.permissions}}catch(E){Wt._handleError(E)}},async readDirectory(w){try{const E=f._fileSystemProvider.get(w.scheme);return E?(await f._proxy.$ensureActivation(w.scheme),(await E.readDirectory(w)).slice()):await f._proxy.$readdir(w)}catch(E){return Wt._handleError(E)}},async createDirectory(w){try{return await f._proxy.$mkdir(w)}catch(E){return Wt._handleError(E)}},async readFile(w){try{const E=f._fileSystemProvider.get(w.scheme);return E?(await f._proxy.$ensureActivation(w.scheme),(await E.readFile(w)).slice()):(await f._proxy.$readFile(w)).buffer}catch(E){return Wt._handleError(E)}},async writeFile(w,E){try{return await f._proxy.$writeFile(w,C.VSBuffer.wrap(E))}catch(P){return Wt._handleError(P)}},async delete(w,E){try{const P=f._fileSystemProvider.get(w.scheme);return P?(await f._proxy.$ensureActivation(w.scheme),await P.delete(w,{recursive:!1,...E})):await f._proxy.$delete(w,{recursive:!1,useTrash:!1,...E})}catch(P){return Wt._handleError(P)}},async rename(w,E,P){try{return await f._proxy.$rename(w,E,{overwrite:!1,...P})}catch(p){return Wt._handleError(p)}},async copy(w,E,P){try{return await f._proxy.$copy(w,E,{overwrite:!1,...P})}catch(p){return Wt._handleError(p)}},isWritableFileSystem(w){const E=b.getCapabilities(w);if(typeof E=="number")return!(E&2048)}})}static _handleError(a){if(a instanceof D.FileSystemError)throw a;if(!(a instanceof Error))throw new D.FileSystemError(String(a));if(a.name==="ENOPRO")throw D.FileSystemError.Unavailable(a.message);switch(a.name){case L.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(a.message);case L.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(a.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(a.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(a.message);case L.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(a.message);case L.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(a.message);default:throw new D.FileSystemError(a.message,a.name)}}addFileSystemProvider(a,b){return this._fileSystemProvider.set(a,b),(0,y.toDisposable)(()=>this._fileSystemProvider.delete(a))}};T=Ve([He(0,k.IExtHostRpcService),He(1,S.IExtHostFileSystemInfo)],T),e.ExtHostConsumerFileSystem=T,e.IExtHostConsumerFileSystem=(0,i.createDecorator)("IExtHostConsumerFileSystem")}),define(ge[238],pe([0,1,2,38]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(i,k,S,y){this._extHostNotebooks=k,this._textDocumentsAndEditors=S,this._commands=y;const T=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",I=>!0,I=>I),new L.ApiCommandArgument("resource","Interactive resource Uri",I=>!0,I=>I),new L.ApiCommandArgument("controllerId","Notebook controller Id",I=>!0,I=>I),new L.ApiCommandArgument("title","Interactive editor title",I=>!0,I=>I)],new L.ApiCommandResult("Notebook and input URI",I=>{if(I.notebookEditorId!==void 0){const a=this._extHostNotebooks.getEditorById(I.notebookEditorId);return{notebookUri:m.URI.revive(I.notebookUri),inputUri:m.URI.revive(I.inputUri),notebookEditor:a.apiEditor}}return{notebookUri:m.URI.revive(I.notebookUri),inputUri:m.URI.revive(I.inputUri)}}));this._commands.registerApiCommand(T)}$willAddInteractiveDocument(i,k,S,y){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:S,uri:i,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(m.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(i,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[i]})}}e.ExtHostInteractive=D}),define(ge[239],pe([0,1,6,5]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(i){this._handlePool=0,this._proxy=i.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(i){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,i),(0,m.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=D}),define(ge[240],pe([0,1,2,25,16,7,5,8,41,17,13,144,6,110,75,87,46,15,3]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideDocumentSymbols(Q,Z){const re=this._documents.getDocument(Q),ue=await this._provider.provideDocumentSymbols(re,Z);if(!(0,y.isFalsyOrEmpty)(ue))return ue[0]instanceof C.DocumentSymbol?ue.map(D.DocumentSymbol.from):o._asDocumentSymbolTree(ue)}static _asDocumentSymbolTree(Q){Q=Q.slice(0).sort((ue,J)=>{let ie=ue.location.range.start.compareTo(J.location.range.start);return ie===0&&(ie=J.location.range.end.compareTo(ue.location.range.end)),ie});const Z=[],re=[];for(const ue of Q){const J={name:ue.name||"!!MISSING: name!!",kind:D.SymbolKind.from(ue.kind),tags:ue.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:ue.containerName,range:D.Range.from(ue.location.range),selectionRange:D.Range.from(ue.location.range),children:[]};for(;;){if(re.length===0){re.push(J),Z.push(J);break}const ie=re[re.length-1];if(S.Range.containsRange(ie.range,J.range)&&!S.Range.equalsRange(ie.range,J.range)){ie.children&&ie.children.push(J),re.push(J);break}re.pop()}}return Z}}class r{constructor(Q,Z,re){this._documents=Q,this._commands=Z,this._provider=re,this._cache=new w.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(Q,Z){const re=this._documents.getDocument(Q),ue=await this._provider.provideCodeLenses(re,Z);if(!ue||Z.isCancellationRequested)return;const J=this._cache.add(ue),ie=new a.DisposableStore;this._disposables.set(J,ie);const we={cacheId:J,lenses:[]};for(let Me=0;Me<ue.length;Me++)we.lenses.push({cacheId:[J,Me],range:D.Range.from(ue[Me].range),command:this._commands.toInternal(ue[Me].command,ie)});return we}async resolveCodeLens(Q,Z){const re=Q.cacheId&&this._cache.get(...Q.cacheId);if(!re)return;let ue;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?ue=re:ue=await this._provider.resolveCodeLens(re,Z),ue||(ue=re),Z.isCancellationRequested)return;const J=Q.cacheId&&this._disposables.get(Q.cacheId[0]);if(!!J)return Q.command=this._commands.toInternal(ue.command??r._badCmd,J),Q}releaseCodeLenses(Q){this._disposables.get(Q)?.dispose(),this._disposables.delete(Q),this._cache.delete(Q)}}r._badCmd={command:"missing",title:"!!MISSING: command!!"};function g(ze){return Array.isArray(ze)?ze.map(D.DefinitionLink.from):ze?[D.DefinitionLink.from(ze)]:[]}class s{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideDefinition(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Position.to(Z),ie=await this._provider.provideDefinition(ue,J,re);return g(ie)}}class v{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideDeclaration(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Position.to(Z),ie=await this._provider.provideDeclaration(ue,J,re);return g(ie)}}class n{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideImplementation(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Position.to(Z),ie=await this._provider.provideImplementation(ue,J,re);return g(ie)}}class t{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideTypeDefinition(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Position.to(Z),ie=await this._provider.provideTypeDefinition(ue,J,re);return g(ie)}}class u{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideHover(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Position.to(Z),ie=await this._provider.provideHover(ue,J,re);if(!(!ie||(0,y.isFalsyOrEmpty)(ie.contents)))return ie.range||(ie.range=ue.getWordRangeAtPosition(J)),ie.range||(ie.range=new C.Range(J,J)),D.Hover.from(ie)}}class d{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideEvaluatableExpression(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Position.to(Z),ie=await this._provider.provideEvaluatableExpression(ue,J,re);if(ie)return D.EvaluatableExpression.from(ie)}}class l{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideInlineValues(Q,Z,re,ue){const J=this._documents.getDocument(Q),ie=await this._provider.provideInlineValues(J,D.Range.to(Z),D.InlineValueContext.to(re),ue);if(Array.isArray(ie))return ie.map(we=>D.InlineValue.from(we))}}class h{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideDocumentHighlights(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Position.to(Z),ie=await this._provider.provideDocumentHighlights(ue,J,re);if(Array.isArray(ie))return ie.map(D.DocumentHighlight.from)}}class c{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideLinkedEditingRanges(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Position.to(Z),ie=await this._provider.provideLinkedEditingRanges(ue,J,re);if(ie&&Array.isArray(ie.ranges))return{ranges:(0,y.coalesce)(ie.ranges.map(D.Range.from)),wordPattern:ie.wordPattern}}}class _{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideReferences(Q,Z,re,ue){const J=this._documents.getDocument(Q),ie=D.Position.to(Z),we=await this._provider.provideReferences(J,ie,re,ue);if(Array.isArray(we))return we.map(D.location.from)}}class A{constructor(Q,Z,re,ue,J,ie,we){this._documents=Q,this._commands=Z,this._diagnostics=re,this._provider=ue,this._logService=J,this._extension=ie,this._apiDeprecation=we,this._cache=new w.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(Q,Z,re,ue){const J=this._documents.getDocument(Q),ie=I.Selection.isISelection(Z)?D.Selection.to(Z):D.Range.to(Z),we=[];for(const ut of this._diagnostics.getDiagnostics(Q))if(ie.intersection(ut.range)&&we.push(ut)>A._maxCodeActionsPerFile)break;const Me={diagnostics:we,only:re.only?new C.CodeActionKind(re.only):void 0,triggerKind:D.CodeActionTriggerKind.to(re.trigger)},je=await this._provider.provideCodeActions(J,ie,Me,ue);if(!(0,y.isNonEmptyArray)(je)||ue.isCancellationRequested)return;const Ke=this._cache.add(je),Ze=new a.DisposableStore;this._disposables.set(Ke,Ze);const rt=[];for(let ut=0;ut<je.length;ut++){const it=je[ut];!it||(A._isCommand(it)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:it.title,command:this._commands.toInternal(it,Ze)})):(Me.only&&(it.kind?Me.only.contains(it.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${it.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[Ke,ut],title:it.title,command:it.command&&this._commands.toInternal(it.command,Ze),diagnostics:it.diagnostics&&it.diagnostics.map(D.Diagnostic.from),edit:it.edit&&D.WorkspaceEdit.from(it.edit),kind:it.kind&&it.kind.value,isPreferred:it.isPreferred,disabled:it.disabled?.reason})))}return{cacheId:Ke,actions:rt}}async resolveCodeAction(Q,Z){const[re,ue]=Q,J=this._cache.get(re,ue);if(!J||A._isCommand(J)||!this._provider.resolveCodeAction)return;const ie=await this._provider.resolveCodeAction(J,Z)??J;return ie?.edit?D.WorkspaceEdit.from(ie.edit):void 0}releaseCodeActions(Q){this._disposables.get(Q)?.dispose(),this._disposables.delete(Q),this._cache.delete(Q)}static _isCommand(Q){return typeof Q.command=="string"&&typeof Q.title=="string"}}A._maxCodeActionsPerFile=1e3;class R{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideDocumentFormattingEdits(Q,Z,re){const ue=this._documents.getDocument(Q),J=await this._provider.provideDocumentFormattingEdits(ue,Z,re);if(Array.isArray(J))return J.map(D.TextEdit.from)}}class x{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideDocumentRangeFormattingEdits(Q,Z,re,ue){const J=this._documents.getDocument(Q),ie=D.Range.to(Z),we=await this._provider.provideDocumentRangeFormattingEdits(J,ie,re,ue);if(Array.isArray(we))return we.map(D.TextEdit.from)}}class O{constructor(Q,Z){this._documents=Q,this._provider=Z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(Q,Z,re,ue,J){const ie=this._documents.getDocument(Q),we=D.Position.to(Z),Me=await this._provider.provideOnTypeFormattingEdits(ie,we,re,ue,J);if(Array.isArray(Me))return Me.map(D.TextEdit.from)}}class F{constructor(Q,Z){this._provider=Q,this._logService=Z,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(Q,Z){const re=i.IdObject.mixin({symbols:[]}),ue=await this._provider.provideWorkspaceSymbols(Q,Z);if((0,y.isNonEmptyArray)(ue))for(const J of ue){if(!J)continue;if(!J.name){this._logService.warn("INVALID SymbolInformation, lacks name",J);continue}const ie=i.IdObject.mixin(D.WorkspaceSymbol.from(J));this._symbolCache.set(ie._id,J),re.symbols.push(ie)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(Q,Z){if(typeof this._provider.resolveWorkspaceSymbol!="function")return Q;const re=this._symbolCache.get(Q._id);if(re){const ue=await this._provider.resolveWorkspaceSymbol(re,Z);return ue&&(0,L.mixin)(Q,D.WorkspaceSymbol.from(ue),!0)}}releaseWorkspaceSymbols(Q){const Z=this._resultCache.get(Q);if(Z){for(let[re,ue]=Z;re<=ue;re++)this._symbolCache.delete(re);this._resultCache.delete(Q)}}}class ${constructor(Q,Z,re){this._documents=Q,this._provider=Z,this._logService=re}static supportsResolving(Q){return typeof Q.prepareRename=="function"}async provideRenameEdits(Q,Z,re,ue){const J=this._documents.getDocument(Q),ie=D.Position.to(Z);try{const we=await this._provider.provideRenameEdits(J,ie,re,ue);return we?D.WorkspaceEdit.from(we):void 0}catch(we){const Me=$._asMessage(we);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(we)}}async resolveRenameLocation(Q,Z,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ue=this._documents.getDocument(Q),J=D.Position.to(Z);try{const ie=await this._provider.prepareRename(ue,J,re);let we,Me;if(C.Range.isRange(ie)?(we=ie,Me=ue.getText(ie)):(0,T.isObject)(ie)&&(we=ie.range,Me=ie.placeholder),!we||!Me)return;if(we.start.line>J.line||we.end.line<J.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(we),text:Me}}catch(ie){const we=$._asMessage(ie);return we?{rejectReason:we,range:void 0,text:void 0}:Promise.reject(ie)}}static _asMessage(Q){return typeof Q=="string"?Q:Q instanceof Error&&typeof Q.message=="string"?Q.message:void 0}}class M{constructor(Q,Z){this.resultId=Q,this.tokens=Z}}class B{constructor(Q,Z){this._documents=Q,this._provider=Z,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(Q,Z,re){const ue=this._documents.getDocument(Q),J=Z!==0?this._previousResults.get(Z):null;let ie=typeof J?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ue,J.resultId,re):await this._provider.provideDocumentSemanticTokens(ue,re);return J&&this._previousResults.delete(Z),ie?(ie=B._fixProvidedSemanticTokens(ie),this._send(B._convertToEdits(J,ie),ie)):null}async releaseDocumentSemanticColoring(Q){this._previousResults.delete(Q)}static _fixProvidedSemanticTokens(Q){return B._isSemanticTokens(Q)?B._isCorrectSemanticTokens(Q)?Q:new C.SemanticTokens(new Uint32Array(Q.data),Q.resultId):B._isSemanticTokensEdits(Q)?B._isCorrectSemanticTokensEdits(Q)?Q:new C.SemanticTokensEdits(Q.edits.map(Z=>new C.SemanticTokensEdit(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),Q.resultId):Q}static _isSemanticTokens(Q){return Q&&!!Q.data}static _isCorrectSemanticTokens(Q){return Q.data instanceof Uint32Array}static _isSemanticTokensEdits(Q){return Q&&Array.isArray(Q.edits)}static _isCorrectSemanticTokensEdits(Q){for(const Z of Q.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(Q,Z){if(!B._isSemanticTokens(Z)||!Q||!Q.tokens)return Z;const re=Q.tokens,ue=re.length,J=Z.data,ie=J.length;let we=0;const Me=Math.min(ue,ie);for(;we<Me&&re[we]===J[we];)we++;if(we===ue&&we===ie)return new C.SemanticTokensEdits([],Z.resultId);let je=0;const Ke=Me-we;for(;je<Ke&&re[ue-je-1]===J[ie-je-1];)je++;return new C.SemanticTokensEdits([{start:we,deleteCount:ue-we-je,data:J.subarray(we,ie-je)}],Z.resultId)}_send(Q,Z){if(B._isSemanticTokens(Q)){const re=this._nextResultId++;return this._previousResults.set(re,new M(Q.resultId,Q.data)),(0,b.encodeSemanticTokensDto)({id:re,type:"full",data:Q.data})}if(B._isSemanticTokensEdits(Q)){const re=this._nextResultId++;return B._isSemanticTokens(Z)?this._previousResults.set(re,new M(Z.resultId,Z.data)):this._previousResults.set(re,new M(Q.resultId)),(0,b.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(Q.edits||[]).map(ue=>({start:ue.start,deleteCount:ue.deleteCount,data:ue.data}))})}return null}}e.DocumentSemanticTokensAdapter=B;class U{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideDocumentRangeSemanticTokens(Q,Z,re){const ue=this._documents.getDocument(Q),J=await this._provider.provideDocumentRangeSemanticTokens(ue,D.Range.to(Z),re);return J?this._send(J):null}_send(Q){return(0,b.encodeSemanticTokensDto)({id:0,type:"full",data:Q.data})}}e.DocumentRangeSemanticTokensAdapter=U;class z{constructor(Q,Z,re,ue,J){this._documents=Q,this._commands=Z,this._provider=re,this._apiDeprecation=ue,this._extension=J,this._cache=new w.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(Q){return typeof Q.resolveCompletionItem=="function"}async provideCompletionItems(Q,Z,re,ue){const J=this._documents.getDocument(Q),ie=D.Position.to(Z),we=J.getWordRangeAtPosition(ie)||new C.Range(ie,ie),Me=we.with({end:ie}),je=new E.StopWatch(!0),Ke=await this._provider.provideCompletionItems(J,ie,ue,D.CompletionContext.to(re));if(!Ke||ue.isCancellationRequested)return;const Ze=Array.isArray(Ke)?new C.CompletionList(Ke):Ke,rt=z.supportsResolving(this._provider)?this._cache.add(Ze.items):this._cache.add([]),ut=new a.DisposableStore;this._disposables.set(rt,ut);const it=[],st={x:rt,b:it,a:{replace:D.Range.from(we),insert:D.Range.from(Me)},c:Ze.isIncomplete||void 0,d:je.elapsed()};for(let Ae=0;Ae<Ze.items.length;Ae++){const wt=Ze.items[Ae],ee=this._convertCompletionItem(wt,[rt,Ae],Me,we);it.push(ee)}return st}async resolveCompletionItem(Q,Z){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...Q);if(!re)return;const ue=await this._provider.resolveCompletionItem(re,Z);if(!!ue)return this._convertCompletionItem(ue,Q)}releaseCompletionItems(Q){this._disposables.get(Q)?.dispose(),this._disposables.delete(Q),this._cache.delete(Q)}_convertCompletionItem(Q,Z,re,ue){const J=this._disposables.get(Z[0]);if(!J)throw Error("DisposableStore is missing...");const ie={x:Z,a:Q.label,b:Q.kind!==void 0?D.CompletionItemKind.from(Q.kind):void 0,n:Q.tags&&Q.tags.map(D.CompletionItemTag.from),c:Q.detail,d:typeof Q.documentation=="undefined"?void 0:D.MarkdownString.fromStrict(Q.documentation),e:Q.sortText!==Q.label?Q.sortText:void 0,f:Q.filterText!==Q.label?Q.filterText:void 0,g:Q.preselect||void 0,i:Q.keepWhitespace?1:0,k:Q.commitCharacters,l:Q.additionalTextEdits&&Q.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(Q.command,J)};Q.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ie.h=Q.textEdit.newText):typeof Q.insertText=="string"?ie.h=Q.insertText:Q.insertText instanceof C.SnippetString&&(ie.h=Q.insertText.value,ie.i|=4);let we;return Q.textEdit?we=Q.textEdit.range:Q.range&&(we=Q.range),C.Range.isRange(we)?ie.j=D.Range.from(we):we&&(!re?.isEqual(we.inserting)||!ue?.isEqual(we.replacing))&&(ie.j={insert:D.Range.from(we.inserting),replace:D.Range.from(we.replacing)}),ie}}class K{constructor(Q,Z,re){this._documents=Q,this._provider=Z,this._commands=re,this._cache=new w.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(Q,Z,re,ue){const J=this._documents.getDocument(Q),ie=D.Position.to(Z),we=await this._provider.provideInlineCompletionItems(J,ie,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:D.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text,isSnippetText:re.selectedSuggestionInfo.isSnippetText,completionKind:D.CompletionItemKind.to(re.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:re.triggerKind},ue);if(!we||ue.isCancellationRequested)return;const Me=(0,T.isArray)(we)?{items:we}:we,je=this._cache.add(Me.items);let Ke;return{pid:je,items:Me.items.map((Ze,rt)=>{let ut;return Ze.command&&(Ke||(Ke=new a.DisposableStore,this._disposables.set(je,Ke)),ut=this._commands.toInternal(Ze.command,Ke)),{text:Ze.text,range:Ze.range?D.Range.from(Ze.range):void 0,command:ut,idx:rt}})}}disposeCompletions(Q){this._cache.delete(Q);const Z=this._disposables.get(Q);Z&&Z.clear(),this._disposables.delete(Q)}handleDidShowCompletionItem(Q,Z){const re=this._cache.get(Q,Z);re&&N.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class N{constructor(){this._onDidShowCompletionItemEmitter=new p.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(Q){let Z=N.map.get(Q);return Z||(Z=new N,N.map.set(Q,Z)),Z}fireOnDidShowCompletionItem(Q){this._onDidShowCompletionItemEmitter.fire(Q)}}e.InlineCompletionController=N,N.map=new WeakMap;class j{constructor(Q,Z){this._documents=Q,this._provider=Z,this._cache=new w.Cache("SignatureHelp")}async provideSignatureHelp(Q,Z,re,ue){const J=this._documents.getDocument(Q),ie=D.Position.to(Z),we=this.reviveContext(re),Me=await this._provider.provideSignatureHelp(J,ie,ue,we);if(Me){const je=this._cache.add([Me]);return{...D.SignatureHelp.from(Me),id:je}}}reviveContext(Q){let Z;if(Q.activeSignatureHelp){const re=D.SignatureHelp.to(Q.activeSignatureHelp),ue=this._cache.get(Q.activeSignatureHelp.id,0);ue?(Z=ue,Z.activeSignature=re.activeSignature,Z.activeParameter=re.activeParameter):Z=re}return{...Q,activeSignatureHelp:Z}}releaseSignatureHelp(Q){this._cache.delete(Q)}}class H{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideInlayHints(Q,Z,re){const ue=this._documents.getDocument(Q),J=await this._provider.provideInlayHints(ue,D.Range.to(Z),re);return J?{hints:J.map(D.InlayHint.from)}:void 0}}class V{constructor(Q,Z){this._documents=Q,this._provider=Z,this._cache=new w.Cache("DocumentLink")}async provideLinks(Q,Z){const re=this._documents.getDocument(Q),ue=await this._provider.provideDocumentLinks(re,Z);if(!(!Array.isArray(ue)||ue.length===0)&&!Z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ue.filter(V._validateLink).map(D.DocumentLink.from)};{const J=this._cache.add(ue),ie={links:[],id:J};for(let we=0;we<ue.length;we++){if(!V._validateLink(ue[we]))continue;const Me=D.DocumentLink.from(ue[we]);Me.cacheId=[J,we],ie.links.push(Me)}return ie}}}static _validateLink(Q){return Q.target&&Q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(Q,Z){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...Q);if(!re)return;const ue=await this._provider.resolveDocumentLink(re,Z);if(!(!ue||!V._validateLink(ue)))return D.DocumentLink.from(ue)}releaseLinks(Q){this._cache.delete(Q)}}class q{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideColors(Q,Z){const re=this._documents.getDocument(Q),ue=await this._provider.provideDocumentColors(re,Z);return Array.isArray(ue)?ue.map(ie=>({color:D.Color.from(ie.color),range:D.Range.from(ie.range)})):[]}async provideColorPresentations(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Range.to(Z.range),ie=D.Color.to(Z.color),we=await this._provider.provideColorPresentations(ie,{document:ue,range:J},re);if(!!Array.isArray(we))return we.map(D.ColorPresentation.from)}}class te{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideFoldingRanges(Q,Z,re){const ue=this._documents.getDocument(Q),J=await this._provider.provideFoldingRanges(ue,Z,re);if(!!Array.isArray(J))return J.map(D.FoldingRange.from)}}class fe{constructor(Q,Z,re){this._documents=Q,this._provider=Z,this._logService=re}async provideSelectionRanges(Q,Z,re){const ue=this._documents.getDocument(Q),J=Z.map(D.Position.to),ie=await this._provider.provideSelectionRanges(ue,J,re);if(!(0,y.isNonEmptyArray)(ie))return[];if(ie.length!==J.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const we=[];for(let Me=0;Me<J.length;Me++){const je=[];we.push(je);let Ke=J[Me],Ze=ie[Me];for(;;){if(!Ze.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(je.push(D.SelectionRange.from(Ze)),!Ze.parent)break;Ke=Ze.range,Ze=Ze.parent}}return we}}class Ce{constructor(Q,Z){this._documents=Q,this._provider=Z,this._idPool=new f.IdGenerator(""),this._cache=new Map}async prepareSession(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Position.to(Z),ie=await this._provider.prepareCallHierarchy(ue,J,re);if(!ie)return;const we=this._idPool.nextId();return this._cache.set(we,new Map),Array.isArray(ie)?ie.map(Me=>this._cacheAndConvertItem(we,Me)):[this._cacheAndConvertItem(we,ie)]}async provideCallsTo(Q,Z,re){const ue=this._itemFromCache(Q,Z);if(!ue)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyIncomingCalls(ue,re);if(!!J)return J.map(ie=>({from:this._cacheAndConvertItem(Q,ie.from),fromRanges:ie.fromRanges.map(we=>D.Range.from(we))}))}async provideCallsFrom(Q,Z,re){const ue=this._itemFromCache(Q,Z);if(!ue)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyOutgoingCalls(ue,re);if(!!J)return J.map(ie=>({to:this._cacheAndConvertItem(Q,ie.to),fromRanges:ie.fromRanges.map(we=>D.Range.from(we))}))}releaseSession(Q){this._cache.delete(Q)}_cacheAndConvertItem(Q,Z){const re=this._cache.get(Q),ue=D.CallHierarchyItem.from(Z,Q,re.size.toString(36));return re.set(ue._itemId,Z),ue}_itemFromCache(Q,Z){return this._cache.get(Q)?.get(Z)}}class ke{constructor(Q,Z){this._documents=Q,this._provider=Z,this._idPool=new f.IdGenerator(""),this._cache=new Map}async prepareSession(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Position.to(Z),ie=await this._provider.prepareTypeHierarchy(ue,J,re);if(!ie)return;const we=this._idPool.nextId();return this._cache.set(we,new Map),Array.isArray(ie)?ie.map(Me=>this._cacheAndConvertItem(we,Me)):[this._cacheAndConvertItem(we,ie)]}async provideSupertypes(Q,Z,re){const ue=this._itemFromCache(Q,Z);if(!ue)throw new Error("missing type hierarchy item");const J=await this._provider.provideTypeHierarchySupertypes(ue,re);if(!!J)return J.map(ie=>this._cacheAndConvertItem(Q,ie))}async provideSubtypes(Q,Z,re){const ue=this._itemFromCache(Q,Z);if(!ue)throw new Error("missing type hierarchy item");const J=await this._provider.provideTypeHierarchySubtypes(ue,re);if(!!J)return J.map(ie=>this._cacheAndConvertItem(Q,ie))}releaseSession(Q){this._cache.delete(Q)}_cacheAndConvertItem(Q,Z){const re=this._cache.get(Q),ue=D.TypeHierarchyItem.from(Z,Q,re.size.toString(36));return re.set(ue._itemId,Z),ue}_itemFromCache(Q,Z){return this._cache.get(Q)?.get(Z)}}class Ue{constructor(Q,Z){this.adapter=Q,this.extension=Z}}class xe{constructor(Q,Z,re,ue,J,ie,we){this._adapter=new Map,this._uriTransformer=Z,this._proxy=Q.getProxy(i.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=ue,this._diagnostics=J,this._logService=ie,this._apiDeprecation=we}_transformDocumentSelector(Q){return D.DocumentSelector.from(Q,this._uriTransformer)}_createDisposable(Q){return new C.Disposable(()=>{this._adapter.delete(Q),this._proxy.$unregister(Q)})}_nextHandle(){return xe._handlePool++}_withAdapter(Q,Z,re,ue,J=!1){const ie=this._adapter.get(Q);if(!ie)return Promise.resolve(ue);if(ie.adapter instanceof Z){let we;ie.extension&&(we=Date.now(),this._logService.trace(`[${ie.extension.identifier.value}] INVOKE provider '${Z.name}'`));const Me=re(ie.adapter,ie.extension),je=ie.extension;return je&&Promise.resolve(Me).then(()=>this._logService.trace(`[${je.identifier.value}] provider DONE after ${Date.now()-we}ms`),Ke=>{J&&Ke instanceof P.CancellationError||(this._logService.error(`[${je.identifier.value}] provider FAILED`),this._logService.error(Ke))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(Q,Z){const re=this._nextHandle();return this._adapter.set(re,new Ue(Q,Z)),re}static _extLabel(Q){return Q.displayName||Q.name}registerDocumentSymbolProvider(Q,Z,re,ue){const J=this._addNewAdapter(new o(this._documents,re),Q),ie=ue&&ue.label||xe._extLabel(Q);return this._proxy.$registerDocumentSymbolProvider(J,this._transformDocumentSelector(Z),ie),this._createDisposable(J)}$provideDocumentSymbols(Q,Z,re){return this._withAdapter(Q,o,ue=>ue.provideDocumentSymbols(m.URI.revive(Z),re),void 0)}registerCodeLensProvider(Q,Z,re){const ue=this._nextHandle(),J=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ue,new Ue(new r(this._documents,this._commands.converter,re),Q)),this._proxy.$registerCodeLensSupport(ue,this._transformDocumentSelector(Z),J);let ie=this._createDisposable(ue);if(J!==void 0){const we=re.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(J));ie=C.Disposable.from(ie,we)}return ie}$provideCodeLenses(Q,Z,re){return this._withAdapter(Q,r,ue=>ue.provideCodeLenses(m.URI.revive(Z),re),void 0)}$resolveCodeLens(Q,Z,re){return this._withAdapter(Q,r,ue=>ue.resolveCodeLens(Z,re),void 0)}$releaseCodeLenses(Q,Z){this._withAdapter(Q,r,re=>Promise.resolve(re.releaseCodeLenses(Z)),void 0)}registerDefinitionProvider(Q,Z,re){const ue=this._addNewAdapter(new s(this._documents,re),Q);return this._proxy.$registerDefinitionSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideDefinition(Q,Z,re,ue){return this._withAdapter(Q,s,J=>J.provideDefinition(m.URI.revive(Z),re,ue),[])}registerDeclarationProvider(Q,Z,re){const ue=this._addNewAdapter(new v(this._documents,re),Q);return this._proxy.$registerDeclarationSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideDeclaration(Q,Z,re,ue){return this._withAdapter(Q,v,J=>J.provideDeclaration(m.URI.revive(Z),re,ue),[])}registerImplementationProvider(Q,Z,re){const ue=this._addNewAdapter(new n(this._documents,re),Q);return this._proxy.$registerImplementationSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideImplementation(Q,Z,re,ue){return this._withAdapter(Q,n,J=>J.provideImplementation(m.URI.revive(Z),re,ue),[])}registerTypeDefinitionProvider(Q,Z,re){const ue=this._addNewAdapter(new t(this._documents,re),Q);return this._proxy.$registerTypeDefinitionSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideTypeDefinition(Q,Z,re,ue){return this._withAdapter(Q,t,J=>J.provideTypeDefinition(m.URI.revive(Z),re,ue),[])}registerHoverProvider(Q,Z,re,ue){const J=this._addNewAdapter(new u(this._documents,re),Q);return this._proxy.$registerHoverProvider(J,this._transformDocumentSelector(Z)),this._createDisposable(J)}$provideHover(Q,Z,re,ue){return this._withAdapter(Q,u,J=>J.provideHover(m.URI.revive(Z),re,ue),void 0)}registerEvaluatableExpressionProvider(Q,Z,re,ue){const J=this._addNewAdapter(new d(this._documents,re),Q);return this._proxy.$registerEvaluatableExpressionProvider(J,this._transformDocumentSelector(Z)),this._createDisposable(J)}$provideEvaluatableExpression(Q,Z,re,ue){return this._withAdapter(Q,d,J=>J.provideEvaluatableExpression(m.URI.revive(Z),re,ue),void 0)}registerInlineValuesProvider(Q,Z,re,ue){const J=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ie=this._addNewAdapter(new l(this._documents,re),Q);this._proxy.$registerInlineValuesProvider(ie,this._transformDocumentSelector(Z),J);let we=this._createDisposable(ie);if(J!==void 0){const Me=re.onDidChangeInlineValues(je=>this._proxy.$emitInlineValuesEvent(J));we=C.Disposable.from(we,Me)}return we}$provideInlineValues(Q,Z,re,ue,J){return this._withAdapter(Q,l,ie=>ie.provideInlineValues(m.URI.revive(Z),re,ue,J),void 0)}registerDocumentHighlightProvider(Q,Z,re){const ue=this._addNewAdapter(new h(this._documents,re),Q);return this._proxy.$registerDocumentHighlightProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideDocumentHighlights(Q,Z,re,ue){return this._withAdapter(Q,h,J=>J.provideDocumentHighlights(m.URI.revive(Z),re,ue),void 0)}registerLinkedEditingRangeProvider(Q,Z,re){const ue=this._addNewAdapter(new c(this._documents,re),Q);return this._proxy.$registerLinkedEditingRangeProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideLinkedEditingRanges(Q,Z,re,ue){return this._withAdapter(Q,c,async J=>{const ie=await J.provideLinkedEditingRanges(m.URI.revive(Z),re,ue);if(ie)return{ranges:ie.ranges,wordPattern:ie.wordPattern?xe._serializeRegExp(ie.wordPattern):void 0}},void 0)}registerReferenceProvider(Q,Z,re){const ue=this._addNewAdapter(new _(this._documents,re),Q);return this._proxy.$registerReferenceSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideReferences(Q,Z,re,ue,J){return this._withAdapter(Q,_,ie=>ie.provideReferences(m.URI.revive(Z),re,ue,J),void 0)}registerCodeActionProvider(Q,Z,re,ue){const J=new a.DisposableStore,ie=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,re,this._logService,Q,this._apiDeprecation),Q);return this._proxy.$registerQuickFixSupport(ie,this._transformDocumentSelector(Z),{providedKinds:ue?.providedCodeActionKinds?.map(we=>we.value),documentation:ue?.documentation?.map(we=>({kind:we.kind.value,command:this._commands.converter.toInternal(we.command,J)}))},xe._extLabel(Q),Boolean(re.resolveCodeAction)),J.add(this._createDisposable(ie)),J}$provideCodeActions(Q,Z,re,ue,J){return this._withAdapter(Q,A,ie=>ie.provideCodeActions(m.URI.revive(Z),re,ue,J),void 0)}$resolveCodeAction(Q,Z,re){return this._withAdapter(Q,A,ue=>ue.resolveCodeAction(Z,re),void 0)}$releaseCodeActions(Q,Z){this._withAdapter(Q,A,re=>Promise.resolve(re.releaseCodeActions(Z)),void 0)}registerDocumentFormattingEditProvider(Q,Z,re){const ue=this._addNewAdapter(new R(this._documents,re),Q);return this._proxy.$registerDocumentFormattingSupport(ue,this._transformDocumentSelector(Z),Q.identifier,Q.displayName||Q.name),this._createDisposable(ue)}$provideDocumentFormattingEdits(Q,Z,re,ue){return this._withAdapter(Q,R,J=>J.provideDocumentFormattingEdits(m.URI.revive(Z),re,ue),void 0)}registerDocumentRangeFormattingEditProvider(Q,Z,re){const ue=this._addNewAdapter(new x(this._documents,re),Q);return this._proxy.$registerRangeFormattingSupport(ue,this._transformDocumentSelector(Z),Q.identifier,Q.displayName||Q.name),this._createDisposable(ue)}$provideDocumentRangeFormattingEdits(Q,Z,re,ue,J){return this._withAdapter(Q,x,ie=>ie.provideDocumentRangeFormattingEdits(m.URI.revive(Z),re,ue,J),void 0)}registerOnTypeFormattingEditProvider(Q,Z,re,ue){const J=this._addNewAdapter(new O(this._documents,re),Q);return this._proxy.$registerOnTypeFormattingSupport(J,this._transformDocumentSelector(Z),ue,Q.identifier),this._createDisposable(J)}$provideOnTypeFormattingEdits(Q,Z,re,ue,J,ie){return this._withAdapter(Q,O,we=>we.provideOnTypeFormattingEdits(m.URI.revive(Z),re,ue,J,ie),void 0)}registerWorkspaceSymbolProvider(Q,Z){const re=this._addNewAdapter(new F(Z,this._logService),Q);return this._proxy.$registerNavigateTypeSupport(re,typeof Z.resolveWorkspaceSymbol=="function"),this._createDisposable(re)}$provideWorkspaceSymbols(Q,Z,re){return this._withAdapter(Q,F,ue=>ue.provideWorkspaceSymbols(Z,re),{symbols:[]})}$resolveWorkspaceSymbol(Q,Z,re){return this._withAdapter(Q,F,ue=>ue.resolveWorkspaceSymbol(Z,re),void 0)}$releaseWorkspaceSymbols(Q,Z){this._withAdapter(Q,F,re=>re.releaseWorkspaceSymbols(Z),void 0)}registerRenameProvider(Q,Z,re){const ue=this._addNewAdapter(new $(this._documents,re,this._logService),Q);return this._proxy.$registerRenameSupport(ue,this._transformDocumentSelector(Z),$.supportsResolving(re)),this._createDisposable(ue)}$provideRenameEdits(Q,Z,re,ue,J){return this._withAdapter(Q,$,ie=>ie.provideRenameEdits(m.URI.revive(Z),re,ue,J),void 0)}$resolveRenameLocation(Q,Z,re,ue){return this._withAdapter(Q,$,J=>J.resolveRenameLocation(m.URI.revive(Z),re,ue),void 0)}registerDocumentSemanticTokensProvider(Q,Z,re,ue){const J=this._nextHandle(),ie=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(J,new Ue(new B(this._documents,re),Q)),this._proxy.$registerDocumentSemanticTokensProvider(J,this._transformDocumentSelector(Z),ue,ie);let we=this._createDisposable(J);if(ie){const Me=re.onDidChangeSemanticTokens(je=>this._proxy.$emitDocumentSemanticTokensEvent(ie));we=C.Disposable.from(we,Me)}return we}$provideDocumentSemanticTokens(Q,Z,re,ue){return this._withAdapter(Q,B,J=>J.provideDocumentSemanticTokens(m.URI.revive(Z),re,ue),null,!0)}$releaseDocumentSemanticTokens(Q,Z){this._withAdapter(Q,B,re=>re.releaseDocumentSemanticColoring(Z),void 0)}registerDocumentRangeSemanticTokensProvider(Q,Z,re,ue){const J=this._addNewAdapter(new U(this._documents,re),Q);return this._proxy.$registerDocumentRangeSemanticTokensProvider(J,this._transformDocumentSelector(Z),ue),this._createDisposable(J)}$provideDocumentRangeSemanticTokens(Q,Z,re,ue){return this._withAdapter(Q,U,J=>J.provideDocumentRangeSemanticTokens(m.URI.revive(Z),re,ue),null,!0)}registerCompletionItemProvider(Q,Z,re,ue){const J=this._addNewAdapter(new z(this._documents,this._commands.converter,re,this._apiDeprecation,Q),Q);return this._proxy.$registerSuggestSupport(J,this._transformDocumentSelector(Z),ue,z.supportsResolving(re),`${Q.identifier.value}(${ue.join("")})`),this._createDisposable(J)}$provideCompletionItems(Q,Z,re,ue,J){return this._withAdapter(Q,z,ie=>ie.provideCompletionItems(m.URI.revive(Z),re,ue,J),void 0)}$resolveCompletionItem(Q,Z,re){return this._withAdapter(Q,z,ue=>ue.resolveCompletionItem(Z,re),void 0)}$releaseCompletionItems(Q,Z){this._withAdapter(Q,z,re=>re.releaseCompletionItems(Z),void 0)}registerInlineCompletionsProvider(Q,Z,re){const ue=this._addNewAdapter(new K(this._documents,re,this._commands.converter),Q);return this._proxy.$registerInlineCompletionsSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideInlineCompletions(Q,Z,re,ue,J){return this._withAdapter(Q,K,ie=>ie.provideInlineCompletions(m.URI.revive(Z),re,ue,J),void 0)}$handleInlineCompletionDidShow(Q,Z,re){this._withAdapter(Q,K,async ue=>{ue.handleDidShowCompletionItem(Z,re)},void 0)}$freeInlineCompletionsList(Q,Z){this._withAdapter(Q,K,async re=>{re.disposeCompletions(Z)},void 0)}registerSignatureHelpProvider(Q,Z,re,ue){const J=Array.isArray(ue)?{triggerCharacters:ue,retriggerCharacters:[]}:ue,ie=this._addNewAdapter(new j(this._documents,re),Q);return this._proxy.$registerSignatureHelpProvider(ie,this._transformDocumentSelector(Z),J),this._createDisposable(ie)}$provideSignatureHelp(Q,Z,re,ue,J){return this._withAdapter(Q,j,ie=>ie.provideSignatureHelp(m.URI.revive(Z),re,ue,J),void 0)}$releaseSignatureHelp(Q,Z){this._withAdapter(Q,j,re=>re.releaseSignatureHelp(Z),void 0)}registerInlayHintsProvider(Q,Z,re){const ue=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,J=this._addNewAdapter(new H(this._documents,re),Q);this._proxy.$registerInlayHintsProvider(J,this._transformDocumentSelector(Z),ue);let ie=this._createDisposable(J);if(ue!==void 0){const we=re.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(ue));ie=C.Disposable.from(ie,we)}return ie}$provideInlayHints(Q,Z,re,ue){return this._withAdapter(Q,H,J=>J.provideInlayHints(m.URI.revive(Z),re,ue),void 0)}registerDocumentLinkProvider(Q,Z,re){const ue=this._addNewAdapter(new V(this._documents,re),Q);return this._proxy.$registerDocumentLinkProvider(ue,this._transformDocumentSelector(Z),typeof re.resolveDocumentLink=="function"),this._createDisposable(ue)}$provideDocumentLinks(Q,Z,re){return this._withAdapter(Q,V,ue=>ue.provideLinks(m.URI.revive(Z),re),void 0)}$resolveDocumentLink(Q,Z,re){return this._withAdapter(Q,V,ue=>ue.resolveLink(Z,re),void 0)}$releaseDocumentLinks(Q,Z){this._withAdapter(Q,V,re=>re.releaseLinks(Z),void 0)}registerColorProvider(Q,Z,re){const ue=this._addNewAdapter(new q(this._documents,re),Q);return this._proxy.$registerDocumentColorProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideDocumentColors(Q,Z,re){return this._withAdapter(Q,q,ue=>ue.provideColors(m.URI.revive(Z),re),[])}$provideColorPresentations(Q,Z,re,ue){return this._withAdapter(Q,q,J=>J.provideColorPresentations(m.URI.revive(Z),re,ue),void 0)}registerFoldingRangeProvider(Q,Z,re){const ue=this._nextHandle(),J=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ue,new Ue(new te(this._documents,re),Q)),this._proxy.$registerFoldingRangeProvider(ue,this._transformDocumentSelector(Z),J);let ie=this._createDisposable(ue);if(J!==void 0){const we=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(J));ie=C.Disposable.from(ie,we)}return ie}$provideFoldingRanges(Q,Z,re,ue){return this._withAdapter(Q,te,J=>J.provideFoldingRanges(m.URI.revive(Z),re,ue),void 0)}registerSelectionRangeProvider(Q,Z,re){const ue=this._addNewAdapter(new fe(this._documents,re,this._logService),Q);return this._proxy.$registerSelectionRangeProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideSelectionRanges(Q,Z,re,ue){return this._withAdapter(Q,fe,J=>J.provideSelectionRanges(m.URI.revive(Z),re,ue),[])}registerCallHierarchyProvider(Q,Z,re){const ue=this._addNewAdapter(new Ce(this._documents,re),Q);return this._proxy.$registerCallHierarchyProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$prepareCallHierarchy(Q,Z,re,ue){return this._withAdapter(Q,Ce,J=>Promise.resolve(J.prepareSession(m.URI.revive(Z),re,ue)),void 0)}$provideCallHierarchyIncomingCalls(Q,Z,re,ue){return this._withAdapter(Q,Ce,J=>J.provideCallsTo(Z,re,ue),void 0)}$provideCallHierarchyOutgoingCalls(Q,Z,re,ue){return this._withAdapter(Q,Ce,J=>J.provideCallsFrom(Z,re,ue),void 0)}$releaseCallHierarchy(Q,Z){this._withAdapter(Q,Ce,re=>Promise.resolve(re.releaseSession(Z)),void 0)}registerTypeHierarchyProvider(Q,Z,re){const ue=this._addNewAdapter(new ke(this._documents,re),Q);return this._proxy.$registerTypeHierarchyProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$prepareTypeHierarchy(Q,Z,re,ue){return this._withAdapter(Q,ke,J=>Promise.resolve(J.prepareSession(m.URI.revive(Z),re,ue)),void 0)}$provideTypeHierarchySupertypes(Q,Z,re,ue){return this._withAdapter(Q,ke,J=>J.provideSupertypes(Z,re,ue),void 0)}$provideTypeHierarchySubtypes(Q,Z,re,ue){return this._withAdapter(Q,ke,J=>J.provideSubtypes(Z,re,ue),void 0)}$releaseTypeHierarchy(Q,Z){this._withAdapter(Q,ke,re=>Promise.resolve(re.releaseSession(Z)),void 0)}static _serializeRegExp(Q){return{pattern:Q.source,flags:(0,k.regExpFlags)(Q)}}static _serializeIndentationRule(Q){return{decreaseIndentPattern:xe._serializeRegExp(Q.decreaseIndentPattern),increaseIndentPattern:xe._serializeRegExp(Q.increaseIndentPattern),indentNextLinePattern:Q.indentNextLinePattern?xe._serializeRegExp(Q.indentNextLinePattern):void 0,unIndentedLinePattern:Q.unIndentedLinePattern?xe._serializeRegExp(Q.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(Q){return{beforeText:xe._serializeRegExp(Q.beforeText),afterText:Q.afterText?xe._serializeRegExp(Q.afterText):void 0,previousLineText:Q.previousLineText?xe._serializeRegExp(Q.previousLineText):void 0,action:Q.action}}static _serializeOnEnterRules(Q){return Q.map(xe._serializeOnEnterRule)}setLanguageConfiguration(Q,Z,re){let{wordPattern:ue}=re;if(ue&&(0,k.regExpLeadsToEndlessLoop)(ue))throw new Error(`Invalid language configuration: wordPattern '${ue}' is not allowed to match the empty string.`);ue?this._documents.setWordDefinitionFor(Z,ue):this._documents.setWordDefinitionFor(Z,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",Q,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",Q,"Do not use.");const J=this._nextHandle(),ie={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?xe._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?xe._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?xe._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(J,Z,ie),this._createDisposable(J)}$setWordDefinitions(Q){for(const Z of Q)this._documents.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.ExtHostLanguageFeatures=xe,xe._handlePool=0}),define(ge[241],pe([0,1,5,16,7,48,18,6]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(T,I,a,b){this._documents=I,this._commands=a,this._uriTransformer=b,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=T.getProxy(m.MainContext.MainThreadLanguages)}$acceptLanguageIds(T){this._languageIds=T}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(T,I){await this._proxy.$changeLanguage(T,I);const a=this._documents.getDocumentData(T);if(!a)throw new Error(`document '${T.toString}' NOT found`);return a.document}async tokenAtPosition(T,I){const a=T.version,b=L.Position.from(I),f=await this._proxy.$tokensAtPosition(T.uri,b),w={type:D.StandardTokenType.Other,range:T.getWordRangeAtPosition(I)??new D.Range(I.line,I.character,I.line,I.character)};if(!f)return w;const E={range:L.Range.to(f.range),type:L.TokenType.to(f.type)};return!E.range.contains(I)||a!==T.version?w:E}createLanguageStatusItem(T,I,a){const b=this._handlePool++,f=this._proxy,w=this._ids,E=`${T.identifier.value}/${I}`;if(w.has(E))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);w.add(E);const P={selector:a,id:I,name:T.displayName??T.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let p,o=new k.DisposableStore;const r=()=>{p?.dispose(),p=(0,i.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(b,{id:E,name:P.name??T.displayName??T.name,source:T.displayName??T.name,selector:L.DocumentSelector.from(P.selector,this._uriTransformer),label:P.text,detail:P.detail??"",severity:P.severity===D.LanguageStatusSeverity.Error?C.default.Error:P.severity===D.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info,command:P.command&&this._commands.toInternal(P.command,o),accessibilityInfo:P.accessibilityInformation})},0)},g={dispose(){o.dispose(),p?.dispose(),f.$removeLanguageStatus(b),w.delete(E)},get id(){return P.id},get name(){return P.name},set name(s){P.name=s,r()},get selector(){return P.selector},set selector(s){P.selector=s,r()},get text(){return P.text},set text(s){P.text=s,r()},get detail(){return P.detail},set detail(s){P.detail=s,r()},get severity(){return P.severity},set severity(s){P.severity=s,r()},get accessibilityInformation(){return P.accessibilityInformation},set accessibilityInformation(s){P.accessibilityInformation=s,r()},get command(){return P.command},set command(s){P.command=s,r()}};return r(),g}}e.ExtHostLanguages=S}),define(ge[131],pe([0,1,11,5,26,14,3]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends m.AbstractLoggerService{constructor(T,I){const a=new i.Emitter;super(I.logLevel,a.event);this._proxy=T.getProxy(L.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(a)}$setLevel(T){this._onDidChangeLogLevel.fire(T)}doCreateLogger(T,I,a){return new S(this._proxy,T,I,a)}};k=Ve([He(0,C.IExtHostRpcService),He(1,D.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class S extends m.AbstractMessageLogger{constructor(T,I,a,b){super(b?.always);this.proxy=T,this.file=I,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(a),this.proxy.$createLogger(I,b).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(T,I){const a=[[T,I]];this.isLoggerCreated?this.doLog(a):this.buffer.push(...a)}doLog(T){this.proxy.$log(this.file,T)}}}),define(ge[242],pe([0,1,5,11,29]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(k){return k&&k.title}let i=class{constructor(S,y){this._logService=y,this._proxy=S.getProxy(m.MainContext.MainThreadMessageService)}showMessage(S,y,T,I,a){const b={extension:S};let f;typeof I=="string"||C(I)?f=[I,...a]:(b.modal=I?.modal,b.useCustom=I?.useCustom,b.detail=I?.detail,f=a),b.useCustom&&(0,D.checkProposedApiEnabled)(S,"resolvers");const w=[];for(let E=0;E<f.length;E++){const P=f[E];if(typeof P=="string")w.push({title:P,handle:E,isCloseAffordance:!1});else if(typeof P=="object"){let{title:p,isCloseAffordance:o}=P;w.push({title:p,isCloseAffordance:!!o,handle:E})}else this._logService.warn("Invalid message item:",P)}return this._proxy.$showMessage(y,T,b,w).then(E=>{if(typeof E=="number")return f[E]})}};i=Ve([He(1,L.ILogService)],i),e.ExtHostMessageService=i}),define(ge[243],pe([0,1,22,3,47,6,24,8,13,2,87,5,16,7,53,218,128]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class P{constructor(o,r,g,s,v){this._textDocumentsAndEditors=g,this._textDocuments=s,this._extensionStoragePaths=v,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new i.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new T.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=r.converter,r.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===12){const t=n.notebookEditor?.notebookUri,u=n.cell.handle,l=this._documents.get(t)?.getCell(u);if(l)return l.apiCell}return n}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const r=this._editors.get(o);if(!r)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return r}getIdByEditor(o){for(const[r,g]of this._editors)if(g.apiEditor===o)return r}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,r){const g=this._documents.get(o);if(!g&&!r)throw new Error(`NO notebook document for '${o}'`);return g}_getProviderData(o){const r=this._notebookContentProviders.get(o);if(!r)throw new Error(`NO provider for '${o}'`);return r}registerNotebookContentProvider(o,r,g,s,v){if((0,k.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(r))throw new Error(`Notebook provider for '${r}' already registered`);this._notebookContentProviders.set(r,{extension:o,provider:g});let n;return g.onDidChangeNotebookContentOptions&&(n=g.onDidChangeNotebookContentOptions(()=>{const t=a.NotebookDocumentContentOptions.from(g.options);this._notebookProxy.$updateNotebookProviderOptions(r,t)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},r,a.NotebookDocumentContentOptions.from(s),P._convertNotebookRegistrationData(o,v)),new b.Disposable(()=>{n?.dispose(),this._notebookContentProviders.delete(r),this._notebookProxy.$unregisterNotebookProvider(r)})}static _convertNotebookRegistrationData(o,r){if(!r)return;const g=r.filenamePattern.map(s=>a.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(r.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${r.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:r.displayName,filenamePattern:g,exclusive:r.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,r,g){const s=P._notebookStatusBarItemProviderHandlePool++,v=typeof g.onDidChangeCellStatusBarItems=="function"?P._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(s,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(s,v,r);let n;return v!==void 0&&(n=g.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(v))),new b.Disposable(()=>{this._notebookStatusBarItemProviders.delete(s),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(s,v),n&&n.dispose()})}async createNotebookDocument(o){const r=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&a.NotebookData.from(o.content)});return y.URI.revive(r)}async openNotebookDocument(o){const r=this._documents.get(o);if(r)return r.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(o),s=this._documents.get(y.URI.revive(g));return(0,S.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(o,r){y.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let g;typeof r=="object"?g={position:a.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus,selections:r.selections&&r.selections.map(a.NotebookRange.from),pinned:typeof r.preview=="boolean"?!r.preview:void 0}:g={preserveFocus:!1};const s=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,g),v=s&&this._editors.get(s)?.apiEditor;if(v)return v;throw s?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,r,g,s){const v=this._notebookStatusBarItemProviders.get(o),n=y.URI.revive(r),t=this._documents.get(n);if(!t||!v)return;const u=t.getCellFromIndex(g);if(!u)return;const d=await v.provideCellStatusBarItems(u.apiCell,s);if(!d)return;const l=new C.DisposableStore,h=this._statusBarCache.add([l]),_=(Array.isArray(d)?d:[d]).map(A=>a.NotebookStatusBarItem.from(A,this._commandsConverter,l));return{cacheId:h,items:_}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,r,g,s,v){if((0,k.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");const n=this._handlePool++;return this._notebookSerializer.set(n,g),this._notebookProxy.$registerNotebookSerializer(n,{id:o.identifier,location:o.extensionLocation},r,a.NotebookDocumentContentOptions.from(s),P._convertNotebookRegistrationData(o,v)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(n)})}async $dataToNotebook(o,r,g){const s=this._notebookSerializer.get(o);if(!s)throw new Error("NO serializer found");const v=await s.deserializeNotebook(r.buffer,g);return new f.SerializableObjectWithBuffers(a.NotebookData.from(v))}async $notebookToData(o,r,g){const s=this._notebookSerializer.get(o);if(!s)throw new Error("NO serializer found");const v=await s.serializeNotebook(a.NotebookData.to(r.value),g);return m.VSBuffer.wrap(v)}async $openNotebook(o,r,g,s,v){const{provider:n}=this._getProviderData(o),t=await n.openNotebook(y.URI.revive(r),{backupId:g,untitledDocumentData:s?.buffer},v);return new f.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(a.NotebookCellData.from)})}async $saveNotebook(o,r,g){const s=this.getNotebookDocument(y.URI.revive(r)),{provider:v}=this._getProviderData(o);return await v.saveNotebook(s.apiNotebook,g),!0}async $saveNotebookAs(o,r,g,s){const v=this.getNotebookDocument(y.URI.revive(r)),{provider:n}=this._getProviderData(o);return await n.saveNotebookAs(y.URI.revive(g),v.apiNotebook,s),!0}async $backupNotebook(o,r,g){const s=this.getNotebookDocument(y.URI.revive(r)),v=this._getProviderData(o),n=this._extensionStoragePaths.workspaceValue(v.extension)??this._extensionStoragePaths.globalValue(v.extension),t=String((0,D.hash)([s.uri.toString(),this._backupIdPool++])),u=y.URI.joinPath(n,t),d=await v.provider.backupNotebook(s.apiNotebook,{destination:u},g);return s.updateBackup(d),d.id}_createExtHostEditor(o,r,g){if(this._editors.has(r))throw new Error(`editor with id ALREADY EXSIST: ${r}`);const s=new E.ExtHostNotebookEditor(r,this._notebookEditorsProxy,o,g.visibleRanges.map(a.NotebookRange.to),g.selections.map(a.NotebookRange.to),typeof g.viewColumn=="number"?a.ViewColumn.to(g.viewColumn):void 0);this._editors.set(r,s)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const g of o.value.removedDocuments){const s=y.URI.revive(g),v=this._documents.get(s);v&&(v.dispose(),this._documents.delete(s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(n=>n.document.uri)}),this._onDidCloseNotebookDocument.fire(v.apiNotebook));for(const n of this._editors.values())n.notebookData.uri.toString()===s.toString()&&this._editors.delete(n.id)}if(o.value.addedDocuments){const g=[];for(const s of o.value.addedDocuments){const v=y.URI.revive(s.uri);if(this._documents.has(v))throw new Error(`adding EXISTING notebook ${v} `);const n=this,t=new w.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(u){n._onDidChangeNotebookCells.fire(u)},emitCellOutputsChange(u){n._onDidChangeCellOutputs.fire(u)},emitCellMetadataChange(u){n._onDidChangeCellMetadata.fire(u)},emitCellExecutionStateChange(u){n._onDidChangeCellExecutionState.fire(u)}},v,s);g.push(...s.cells.map(u=>w.ExtHostCell.asModelAddData(t.apiNotebook,u))),this._documents.get(v)?.dispose(),this._documents.set(v,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(o.value.addedEditors)for(const g of o.value.addedEditors){if(this._editors.has(g.id))return;const s=y.URI.revive(g.documentUri),v=this._documents.get(s);v&&this._createExtHostEditor(v,g.id,g)}const r=[];if(o.value.removedEditors)for(const g of o.value.removedEditors){const s=this._editors.get(g);s&&(this._editors.delete(g),this._activeNotebookEditor?.id===s.id&&(this._activeNotebookEditor=void 0),r.push(s))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(s=>this._editors.get(s)).filter(s=>!!s);const g=new Set;this._visibleNotebookEditors.forEach(s=>g.add(s.id));for(const s of this._editors.values()){const v=g.has(s.id);s._acceptVisibility(v)}this._visibleNotebookEditors=[...this._editors.values()].map(s=>s).filter(s=>s.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=P,P._notebookStatusBarItemProviderHandlePool=0}),define(ge[244],pe([0,1,3,75,11,5,14,16]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(I,a){const b=S._Keys.nextId();I.$registerNotebookEditorDecorationType(b,k.NotebookDecorationRenderOptions.from(a)),this.value={key:b,dispose(){I.$removeNotebookEditorDecorationType(b)}}}}S._Keys=new L.IdGenerator("NotebookEditorDecorationType");let y=class{constructor(I,a,b){this._logService=I,this._extHostRpc=a,this._notebooksAndEditors=b,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new S(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,a){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,a);const b=this._notebooksAndEditors.getEditorById(I);a.visibleRanges&&b._acceptVisibleRanges(a.visibleRanges.ranges.map(k.NotebookRange.to)),a.selections&&b._acceptSelections(a.selections.selections.map(k.NotebookRange.to)),a.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:b.apiEditor,visibleRanges:b.apiEditor.visibleRanges}),a.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:b.apiEditor,selections:b.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const a in I)this._notebooksAndEditors.getEditorById(a)._acceptViewColumn(k.ViewColumn.to(I[a]))}};y=Ve([He(0,D.ILogService),He(1,i.IExtHostRpcService)],y),e.ExtHostNotebookEditors=y}),define(ge[245],pe([0,1,17,18,21,3,6,24,2,27,11,5,38,16,7,88,210,29,53]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let o=class{constructor(n,t,u,d,l){this._initData=t,this._extHostNotebook=u,this._commands=d,this._logService=l,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=n.getProxy(I.MainContext.MainThreadNotebookKernels);const h=new a.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.ApiCommandArgument("options","Select kernel options",c=>!0,c=>{if(c&&"notebookEditor"in c&&"id"in c){const _=this._extHostNotebook.getIdByEditor(c.notebookEditor);return{id:c.id,extension:c.extension,notebookEditorId:_}}else if(c&&"notebookEditor"in c){const _=this._extHostNotebook.getIdByEditor(c.notebookEditor);if(_===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${c.notebookEditor.document.uri.toString()}`);return{notebookEditorId:_}}return c})],a.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(n,t,u,d,l,h){for(let j of this._kernelData.values())if(j.controller.id===t&&y.ExtensionIdentifier.equals(n.identifier,j.extensionId))throw new Error(`notebook controller with id '${t}' ALREADY exist`);const c=this._handlePool++,_=this;this._logService.trace(`NotebookController[${c}], CREATED by ${n.identifier.value}, ${t}`);const A=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${n.identifier}'`);let R=!1;const x=new i.DisposableStore,O=new C.Emitter,F=new C.Emitter,$={id:`${n.identifier.value}/${t}`,notebookType:u,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:d||n.identifier.value,preloads:h?h.map(b.NotebookRendererScript.from):[]};let M=l??A,B;this._proxy.$addKernel(c,$).catch(j=>{console.log(j),R=!0});let U=0;const z=()=>{if(R)return;const j=++U;Promise.resolve().then(()=>{j===U&&this._proxy.$updateKernel(c,$)})},K=new k.ResourceMap,N={get id(){return t},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return $.label},set label(j){$.label=j??n.displayName??n.name,z()},get detail(){return $.detail??""},set detail(j){$.detail=j,z()},get description(){return $.description??""},set description(j){$.description=j,z()},get kind(){return(0,P.checkProposedApiEnabled)(n,"notebookControllerKind"),$.kind??""},set kind(j){(0,P.checkProposedApiEnabled)(n,"notebookControllerKind"),$.kind=j,z()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(j){$.supportedLanguages=j,z()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(j){$.supportsExecutionOrder=j,z()},get rendererScripts(){return $.preloads?$.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return M},set executeHandler(j){M=j??A},get interruptHandler(){return B},set interruptHandler(j){B=j,$.supportsInterrupt=Boolean(j),z()},createNotebookCellExecution(j){if(R)throw new Error("notebook controller is DISPOSED");if(!K.has(j.notebook.uri))throw _._logService.trace(`NotebookController[${c}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(K.keys()).map(H=>H.toString())),new Error(`notebook controller is NOT associated to notebook: ${j.notebook.uri.toString()}`);return _._createNotebookCellExecution(j)},dispose:()=>{R||(this._logService.trace(`NotebookController[${c}], DISPOSED`),R=!0,this._kernelData.delete(c),x.dispose(),O.dispose(),F.dispose(),this._proxy.$removeKernel(c))},updateNotebookAffinity(j,H){_._proxy.$updateNotebookPriority(c,j.uri,H)},onDidReceiveMessage:F.event,postMessage(j,H){return(0,P.checkProposedApiEnabled)(n,"notebookMessaging"),_._proxy.$postMessage(c,H&&_._extHostNotebook.getIdByEditor(H),j)},asWebviewUri(j){return(0,P.checkProposedApiEnabled)(n,"notebookMessaging"),(0,w.asWebviewUri)(j,_._initData.remote)}};return this._kernelData.set(c,{extensionId:n.identifier,controller:N,onDidReceiveMessage:F,onDidChangeSelection:O,associatedNotebooks:K}),N}$acceptNotebookAssociation(n,t,u){const d=this._kernelData.get(n);if(d){const l=this._extHostNotebook.getNotebookDocument(S.URI.revive(t));u?d.associatedNotebooks.set(l.uri,!0):d.associatedNotebooks.delete(l.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,l.uri.toString(),u),d.onDidChangeSelection.fire({selected:u,notebook:l.apiNotebook})}}async $executeCells(n,t,u){const d=this._kernelData.get(n);if(!d)return;const l=this._extHostNotebook.getNotebookDocument(S.URI.revive(t)),h=[];for(let c of u){const _=l.getCell(c);_&&h.push(_.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,l.uri.toString(),h.length),await d.controller.executeHandler.call(d.controller,h,l.apiNotebook,d.controller)}catch(c){this._logService.error(`NotebookController[${n}] execute cells FAILED`,c),console.error(c)}}async $cancelCells(n,t,u){const d=this._kernelData.get(n);if(!d)return;const l=this._extHostNotebook.getNotebookDocument(S.URI.revive(t));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,l.apiNotebook);else for(let h of u){const c=l.getCell(h);c&&this._activeExecutions.get(c.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,t,u){const d=this._kernelData.get(n);if(!d)return;const l=this._extHostNotebook.getEditorById(t);d.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:u}))}_createNotebookCellExecution(n){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!u)throw new Error("invalid cell");if(this._activeExecutions.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const d=new g(u.notebook,u,this._proxy);this._activeExecutions.set(u.uri,d);const l=d.onDidChangeState(()=>{d.state===r.Resolved&&(d.dispose(),l.dispose(),this._activeExecutions.delete(u.uri))});return d.asApiObject()}};o=Ve([He(4,T.ILogService)],o),e.ExtHostNotebookKernels=o;var r;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(r||(r={}));class g extends i.Disposable{constructor(n,t,u){super();this._document=n,this._cell=t,this._proxy=u,this._handle=g.HANDLE++,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._collector=new s(10,d=>this.update(d)),this._executionOrder=t.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const t=Array.isArray(n)?n:[n];return this._proxy.$updateExecutions(new p.SerializableObjectWithBuffers(t))}verifyStateForOutput(){if(this._state===r.Init)throw new Error("Must call start before modifying cell output");if(this._state===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(n){let t=this._cell;if(n&&(t=this._document.getCellFromApiCell(n)),!t)throw new Error("INVALID cell");return t.handle}validateAndConvertOutputs(n){return n.map(t=>{const u=f.NotebookCellOutput.ensureUniqueMimeTypes(t.items,!0);return u===t.items?b.NotebookCellOutput.from(t):b.NotebookCellOutput.from({items:u,id:t.id,metadata:t.metadata})})}async updateOutputs(n,t,u){const d=this.cellIndexToHandle(t),l=this.validateAndConvertOutputs((0,m.asArray)(n));return this.updateSoon({editType:E.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:d,append:u,outputs:l})}async updateOutputItems(n,t,u){return n=f.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(n),!0),this.updateSoon({editType:E.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:n.map(b.NotebookCellOutputItem.from),outputId:t.id,append:u})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(u){n._executionOrder=u,n.update([{editType:E.CellExecutionUpdateType.ExecutionState,executionHandle:n._handle,executionOrder:n._executionOrder}])},start(u){if(n._state===r.Resolved||n._state===r.Started)throw new Error("Cannot call start again");n._state=r.Started,n._onDidChangeState.fire(),n.update({editType:E.CellExecutionUpdateType.ExecutionState,executionHandle:n._handle,runStartTime:u})},end(u,d){if(n._state===r.Resolved)throw new Error("Cannot call resolve twice");n._state=r.Resolved,n._onDidChangeState.fire(),n.updateSoon({editType:E.CellExecutionUpdateType.Complete,executionHandle:n._handle,runEndTime:d,lastRunSuccess:u}),n._collector.flush(),n._proxy.$removeExecution(n._handle)},clearOutput(u){return n.verifyStateForOutput(),n.updateOutputs([],u,!1)},appendOutput(u,d){return n.verifyStateForOutput(),n.updateOutputs(u,d,!0)},replaceOutput(u,d){return n.verifyStateForOutput(),n.updateOutputs(u,d,!1)},appendOutputItems(u,d){return n.verifyStateForOutput(),n.updateOutputItems(u,d,!0)},replaceOutputItems(u,d){return n.verifyStateForOutput(),n.updateOutputItems(u,d,!1)}})}}g.HANDLE=0;class s{constructor(n,t){this.delay=n,this.callback=t,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const t=this.batch;return this.batch=[],this.callback(t).finally(()=>n.complete())}}}),define(ge[246],pe([0,1,3,5,128,29]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class i{constructor(S,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=S.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(S,y,T){const I=this._extHostNotebook.getEditorById(S);this._rendererMessageEmitters.get(y)?.fire({editor:I.apiEditor,message:T})}createRendererMessaging(S,y){if(!S.contributes?.notebookRenderer?.some(b=>b.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);const T=(0,C.isProposedApiEnabled)(S,"notebookEditor"),I=new WeakMap;return{onDidReceiveMessage:(b,f,w)=>{const E=T?b:P=>{const p={};I.set(p,P.editor),b({editor:p,message:P.message})};return this.getOrCreateEmitterFor(y).event(E,f,w)},postMessage:(b,f)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(b)&&([b,f]=[f,b]);const w=T?f:I.get(f),E=w&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.proxy.$postMessage(E?.id,y,b)}}}getOrCreateEmitterFor(S){let y=this._rendererMessageEmitters.get(S);return y||(y=new m.Emitter({onLastListenerRemove:()=>{y?.dispose(),this._rendererMessageEmitters.delete(S)}}),this._rendererMessageEmitters.set(S,y),y)}}e.ExtHostNotebookRenderers=i}),define(ge[132],pe([0,1,5,6,4,14,11,211,66,26,44,151,22]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class b extends L.Disposable{constructor(E,P,p,o){super();this.id=E,this.name=P,this.logger=p,this.proxy=o,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(E){this.append(E+`
`)}append(E){this.write(E),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const E=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,E)}replace(E){const P=this.offset;this.write(E),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,P),this.visible&&this.logger.flush()}show(E,P){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof E=="boolean"?E:P))}hide(){this.proxy.$close(this.id)}write(E){this.offset+=a.VSBuffer.fromString(E).byteLength,this.logger.info(E)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=b;let f=class{constructor(E,P,p,o,r){this.extHostFileSystem=p,this.extHostFileSystemInfo=o,this.loggerService=r,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=E.getProxy(m.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(P.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(E){this.visibleChannelId=E;for(const[P,p]of this.channels)p.visible=P===this.visibleChannelId}createOutputChannel(E,P){if(E=E.trim(),!E)throw new Error("illegal argument `name`. must not be falsy");const p=this.doCreateOutputChannel(E,P);return p.then(o=>{this.channels.set(o.id,o),o.visible=o.id===this.visibleChannelId}),this.createExtHostOutputChannel(E,p)}async doCreateOutputChannel(E,P){const p=await this.createOutputDirectory(),o=this.extHostFileSystemInfo.extUri.joinPath(p,`${this.namePool++}-${E.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.loggerService.createLogger(o,{always:!0,donotRotate:!0,donotUseFormatters:!0}),g=await this.proxy.$register(E,!1,o,P.identifier.value);return new b(g,E,r,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(E,P){let p=!1;const o=()=>{if(p)throw new Error("Channel has been closed")};return{get name(){return E},append(r){o(),P.then(g=>g.append(r))},appendLine(r){o(),P.then(g=>g.appendLine(r))},clear(){o(),P.then(r=>r.clear())},replace(r){o(),P.then(g=>g.replace(r))},show(r,g){o(),P.then(s=>s.show(r,g))},hide(){o(),P.then(r=>r.hide())},dispose(){p=!0,P.then(r=>r.dispose())}}}};f=Ve([He(0,C.IExtHostRpcService),He(1,y.IExtHostInitDataService),He(2,S.IExtHostConsumerFileSystem),He(3,T.IExtHostFileSystemInfo),He(4,i.ILoggerService)],f),e.ExtHostOutputService=f,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(ge[247],pe([0,1,18,21,3,6,5,2,7,15,17,48,86,29]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(w,E,P){const p=w.getProxy(i.MainContext.MainThreadQuickOpen);class o{constructor(l,h){this._sessions=new Map,this._instances=0,this._workspace=l,this._commands=h}showQuickPick(l,h,c=L.CancellationToken.None){this._onDidSelectItem=void 0;const _=Promise.resolve(l),A=++this._instances,R=p.$show(A,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},c),x={},O=R.then(()=>x);return Promise.race([O,_]).then(F=>{if(F!==x)return _.then($=>{const M=[];for(let B=0;B<$.length;B++){const U=$[B];typeof U=="string"?M.push({label:U,handle:B}):U.kind===S.QuickPickItemKind.Separator?M.push({type:"separator",label:U.label}):M.push({label:U.label,description:U.description,detail:U.detail,picked:U.picked,alwaysShow:U.alwaysShow,handle:B})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{h.onDidSelectItem($[B])}),p.$setItems(A,M),R.then(B=>{if(typeof B=="number")return $[B];if(Array.isArray(B))return B.map(U=>$[U])})})}).then(void 0,F=>{if(!(0,y.isPromiseCanceledError)(F))return p.$setError(A,F),Promise.reject(F)})}$onItemSelected(l){this._onDidSelectItem&&this._onDidSelectItem(l)}showInput(l,h=L.CancellationToken.None){return this._validateInput=l?l.validateInput:void 0,p.$input(l,typeof this._validateInput=="function",h).then(void 0,c=>{if(!(0,y.isPromiseCanceledError)(c))return Promise.reject(c)})}$validateInput(l){return this._validateInput?(0,m.asPromise)(()=>this._validateInput(l)):Promise.resolve(void 0)}async showWorkspaceFolderPick(l,h=L.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!c)return;const _=await this._workspace.getWorkspaceFolders2();if(!!_)return _.find(A=>A.uri.toString()===c.uri.toString())}createQuickPick(l){const h=new t(l,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(l){const h=new u(l,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}$onDidChangeValue(l,h){const c=this._sessions.get(l);c&&c._fireDidChangeValue(h)}$onDidAccept(l){const h=this._sessions.get(l);h&&h._fireDidAccept()}$onDidChangeActive(l,h){const c=this._sessions.get(l);c instanceof t&&c._fireDidChangeActive(h)}$onDidChangeSelection(l,h){const c=this._sessions.get(l);c instanceof t&&c._fireDidChangeSelection(h)}$onDidTriggerButton(l,h){const c=this._sessions.get(l);c&&c._fireDidTriggerButton(h)}$onDidTriggerItemButton(l,h,c){const _=this._sessions.get(l);_ instanceof t&&_._fireDidTriggerItemButton(h,c)}$onDidHide(l){const h=this._sessions.get(l);h&&h._fireDidHide()}}class r{constructor(l,h){this._extensionId=l,this._onDidDispose=h,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(l){this._title=l,this.update({title:l})}get step(){return this._steps}set step(l){this._steps=l,this.update({step:l})}get totalSteps(){return this._totalSteps}set totalSteps(l){this._totalSteps=l,this.update({totalSteps:l})}get enabled(){return this._enabled}set enabled(l){this._enabled=l,this.update({enabled:l})}get busy(){return this._busy}set busy(l){this._busy=l,this.update({busy:l})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(l){this._ignoreFocusOut=l,this.update({ignoreFocusOut:l})}get value(){return this._value}set value(l){this._value=l,this.update({value:l})}get placeholder(){return this._placeholder}set placeholder(l){this._placeholder=l,this.update({placeholder:l})}get buttons(){return this._buttons}set buttons(l){this._buttons=l.slice(),this._handlesToButtons.clear(),l.forEach((h,c)=>{const _=h===S.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(_,h)}),this.update({buttons:l.map((h,c)=>({...n(h),tooltip:h.tooltip,handle:h===S.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(l){this._value=l,this._onDidChangeValueEmitter.fire(l)}_fireDidTriggerButton(l){const h=this._handlesToButtons.get(l);h&&this._onDidTriggerButtonEmitter.fire(h)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),p.$dispose(this._id))}update(l){if(!this._disposed){for(const h of Object.keys(l)){const c=l[h];this._pendingUpdate[h]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){p.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}r._nextId=1;function g(d){if(d instanceof S.ThemeIcon)return{id:d.id};const l=v(d),h=s(d);return{dark:typeof l=="string"?k.URI.file(l):l,light:typeof h=="string"?k.URI.file(h):h}}function s(d){return typeof d=="object"&&"light"in d?d.light:d}function v(d){return typeof d=="object"&&"dark"in d?d.dark:d}function n(d){const l=g(d.iconPath);let h,c;return"id"in l?c=a.ThemeIcon.asClassName(l):h=l,{iconPath:h,iconClass:c}}class t extends r{constructor(l,h){super(l.identifier,h);this.extension=l,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this._onDidTriggerItemButtonEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(l){l.some(c=>c.kind!==void 0)&&(0,b.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=l.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),l.forEach((c,_)=>{this._handlesToItems.set(_,c),this._itemsToHandles.set(c,_)});const h=[];for(let c=0;c<l.length;c++){const _=l[c];_.kind===S.QuickPickItemKind.Separator?h.push({type:"separator",label:_.label}):h.push({handle:c,label:_.label,description:_.description,detail:_.detail,picked:_.picked,alwaysShow:_.alwaysShow,buttons:_.buttons?.map((A,R)=>({...n(A),tooltip:A.tooltip,handle:R}))})}this.update({items:h})}get canSelectMany(){return this._canSelectMany}set canSelectMany(l){this._canSelectMany=l,this.update({canSelectMany:l})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(l){this._matchOnDescription=l,this.update({matchOnDescription:l})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(l){this._matchOnDetail=l,this.update({matchOnDetail:l})}get sortByLabel(){return this._sortByLabel}set sortByLabel(l){this._sortByLabel=l,this.update({sortByLabel:l})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(l){this._keepScrollPosition=l,this.update({keepScrollPosition:l})}get activeItems(){return this._activeItems}set activeItems(l){this._activeItems=l.filter(h=>this._itemsToHandles.has(h)),this.update({activeItems:this._activeItems.map(h=>this._itemsToHandles.get(h))})}get selectedItems(){return this._selectedItems}set selectedItems(l){this._selectedItems=l.filter(h=>this._itemsToHandles.has(h)),this.update({selectedItems:this._selectedItems.map(h=>this._itemsToHandles.get(h))})}_fireDidChangeActive(l){const h=(0,T.coalesce)(l.map(c=>this._handlesToItems.get(c)));this._activeItems=h,this._onDidChangeActiveEmitter.fire(h)}_fireDidChangeSelection(l){const h=(0,T.coalesce)(l.map(c=>this._handlesToItems.get(c)));this._selectedItems=h,this._onDidChangeSelectionEmitter.fire(h)}_fireDidTriggerItemButton(l,h){const c=this._handlesToItems.get(l);if(!c||!c.buttons||!c.buttons.length)return;const _=c.buttons[h];_&&this._onDidTriggerItemButtonEmitter.fire({button:_,item:c})}}class u extends r{constructor(l,h){super(l,h);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(l){this._password=l,this.update({password:l})}get prompt(){return this._prompt}set prompt(l){this._prompt=l,this.update({prompt:l})}get validationMessage(){return this._validationMessage}set validationMessage(l){this._validationMessage=l,this.update({validationMessage:l,severity:l?I.default.Error:I.default.Ignore})}}return new o(E,P)}e.createExtHostQuickOpen=f}),define(ge[248],pe([0,1,2,3,57,6,18,5,17,99,11,27,86,16,29]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function w(d){if(d)return typeof d.iconPath=="string"?m.URI.file(d.iconPath):m.URI.isUri(d.iconPath)||a.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function E(d,l){if(!d.iconPath&&!l.iconPath)return 0;if(d.iconPath){if(!l.iconPath)return 1}else return-1;const h=typeof d.iconPath=="string"?d.iconPath:m.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,c=typeof l.iconPath=="string"?l.iconPath:m.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id;return(0,y.comparePaths)(h,c)}function P(d,l){let h=0;if(d.strikeThrough!==l.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==l.faded)return d.faded?1:-1;if(d.tooltip!==l.tooltip)return(d.tooltip||"").localeCompare(l.tooltip||"");if(h=E(d,l),h!==0)return h;if(d.light&&l.light)h=E(d.light,l.light);else{if(d.light)return 1;if(l.light)return-1}if(h!==0)return h;if(d.dark&&l.dark)h=E(d.dark,l.dark);else{if(d.dark)return 1;if(l.dark)return-1}return h}function p(d,l){if(d.command!==l.command)return d.command<l.command?-1:1;if(d.title!==l.title)return d.title<l.title?-1:1;if(d.tooltip!==l.tooltip){if(d.tooltip!==void 0&&l.tooltip!==void 0)return d.tooltip<l.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(d.arguments===l.arguments)return 0;if(d.arguments)if(l.arguments){if(d.arguments.length!==l.arguments.length)return d.arguments.length-l.arguments.length}else return 1;else return-1;for(let h=0;h<d.arguments.length;h++){const c=d.arguments[h],_=l.arguments[h];if(c!==_)return c<_?-1:1}return 0}function o(d,l){let h=(0,y.comparePaths)(d.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(h!==0)return h;if(d.command&&l.command)h=p(d.command,l.command);else{if(d.command)return 1;if(l.command)return-1}if(h!==0)return h;if(d.decorations&&l.decorations)h=P(d.decorations,l.decorations);else{if(d.decorations)return 1;if(l.decorations)return-1}return h}function r(d,l){for(let h=0;h<d.length;h++)if(d[h]!==l[h])return!1;return!0}function g(d,l){return d.command===l.command&&d.title===l.title&&d.tooltip===l.tooltip&&(d.arguments&&l.arguments?r(d.arguments,l.arguments):d.arguments===l.arguments)}function s(d,l){return(0,S.equals)(d,l,g)}class v{constructor(l,h,c){this._extension=l,this._proxy=h,this._sourceControlHandle=c,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(l){this._proxy.$setInputBoxValue(this._sourceControlHandle,l),this.updateValue(l)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(l){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,l),this._placeholder=l}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(l){if((0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),l&&typeof l!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=l,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!l)}get visible(){return this._visible}set visible(l){l=!!l,this._visible!==l&&(this._visible=l,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,l))}showValidationMessage(l,h){(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,l,h)}$onInputBoxValueChange(l){this.updateValue(l)}updateValue(l){this._value=l,this._onDidChange.fire(l)}}e.ExtHostSCMInputBox=v;class n{constructor(l,h,c,_,A){this._proxy=l,this._commands=h,this._sourceControlHandle=c,this._id=_,this._label=A,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=n._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(l){this._label=l,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,l)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(l){this._hideWhenEmpty=l,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(l){this._resourceStates=[...l],this._onDidUpdateResourceStates.fire()}getResourceState(l){return this._resourceStatesMap.get(l)}$executeResourceCommand(l,h){const c=this._resourceStatesCommandsMap.get(l);return c?(0,i.asPromise)(()=>this._commands.executeCommand(c.command,...c.arguments||[],h)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const l=[...this._resourceStates].sort(o),c=(0,S.sortedDiff)(this._resourceSnapshot,l,o).map(R=>{const x=R.toInsert.map(O=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,O);const $=O.resourceUri;let M;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const te=new C.DisposableStore;M=this._commands.converter.toInternal(O.command,te),this._resourceStatesDisposablesMap.set(F,te)}else this._resourceStatesCommandsMap.set(F,O.command);const B=w(O.decorations),U=O.decorations&&w(O.decorations.light)||B,z=O.decorations&&w(O.decorations.dark)||B,K=[U,z],N=O.decorations&&O.decorations.tooltip||"",j=O.decorations&&!!O.decorations.strikeThrough,H=O.decorations&&!!O.decorations.faded,V=O.contextValue||"";return{rawResource:[F,$,K,N,j,H,V,M],handle:F}});return{start:R.start,deleteCount:R.deleteCount,toInsert:x}}),_=c.map(({start:R,deleteCount:x,toInsert:O})=>[R,x,O.map(F=>F.rawResource)]),A=c.reverse();for(const{start:R,deleteCount:x,toInsert:O}of A){const F=O.map(M=>M.handle),$=this._handlesSnapshot.splice(R,x,...F);for(const M of $)this._resourceStatesMap.delete(M),this._resourceStatesCommandsMap.delete(M),this._resourceStatesDisposablesMap.get(M)?.dispose(),this._resourceStatesDisposablesMap.delete(M)}return this._resourceSnapshot=l,_}dispose(){this._disposed=!0,this._onDidDispose.fire()}}n._handlePool=0;class t{constructor(l,h,c,_,A,R){this._extension=l,this._proxy=h,this._commands=c,this._id=_,this._label=A,this._rootUri=R,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new C.MutableDisposable,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new v(l,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,_,A,R)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(l){this._count!==l&&(this._count=l,this._proxy.$updateSourceControl(this.handle,{count:l}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(l){this._quickDiffProvider=l,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!l})}get commitTemplate(){return this._commitTemplate}set commitTemplate(l){l!==this._commitTemplate&&(this._commitTemplate=l,this._proxy.$updateSourceControl(this.handle,{commitTemplate:l}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(l){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=l;const h=this._commands.converter.toInternal(l,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:h})}get actionButton(){return(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(l){(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new C.DisposableStore,this._actionButton=l;const h=l!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:h??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(l){if(this._statusBarCommands&&l&&s(this._statusBarCommands,l))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=l;const h=(l||[]).map(c=>this._commands.converter.toInternal(c,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:h})}get selected(){return this._selected}createResourceGroup(l,h){const c=new n(this._proxy,this._commands,this.handle,l,h),_=L.Event.once(c.onDidDispose)(()=>this.createdResourceGroups.delete(c));return this.createdResourceGroups.set(c,_),this.eventuallyAddResourceGroups(),c}eventuallyAddResourceGroups(){const l=[],h=[];for(const[c,_]of this.createdResourceGroups){_.dispose();const A=c.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(c),this.eventuallyUpdateResourceStates()});L.Event.once(c.onDidDispose)(()=>{this.updatedResourceGroups.delete(c),A.dispose(),this._groups.delete(c.handle),this._proxy.$unregisterGroup(this.handle,c.handle)}),l.push([c.handle,c.id,c.label,c.features]);const R=c._takeResourceStateSnapshot();R.length>0&&h.push([c.handle,R]),this._groups.set(c.handle,c)}this._proxy.$registerGroups(this.handle,l,h),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const l=[];this.updatedResourceGroups.forEach(h=>{const c=h._takeResourceStateSnapshot();c.length!==0&&l.push([h.handle,c])}),l.length>0&&this._proxy.$spliceResourceStates(this.handle,l),this.updatedResourceGroups.clear()}getResourceGroup(l){return this._groups.get(l)}setSelectionState(l){this._selected=l,this._onDidChangeSelection.fire(l)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(l=>l.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}t._handlePool=0,Ve([(0,D.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),Ve([(0,D.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let u=class Hi{constructor(l,h,c){this._commands=h,this.logService=c,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=l.getProxy(k.MainContext.MainThreadSCM),this._telemetry=l.getProxy(k.MainContext.MainThreadTelemetry),h.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===3){const A=this._sourceControls.get(_.sourceControlHandle);if(!A)return _;const R=A.getResourceGroup(_.groupHandle);return R?R.getResourceState(_.handle):_}else if(_&&_.$mid===4){const A=this._sourceControls.get(_.sourceControlHandle);return A?A.getResourceGroup(_.groupHandle):_}else if(_&&_.$mid===5){const A=this._sourceControls.get(_.handle);return A||_}return _}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(l,h,c,_){this.logService.trace("ExtHostSCM#createSourceControl",l.identifier.value,h,c,_),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const A=Hi._handlePool++,R=new t(l,this._proxy,this._commands,h,c,_);this._sourceControls.set(A,R);const x=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(l.identifier))||[];return x.push(R),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(l.identifier),x),R}getLastInputBox(l){this.logService.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const h=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(l.identifier)),c=h&&h[h.length-1];return c&&c.inputBox}$provideOriginalResource(l,h,c){const _=m.URI.revive(h);this.logService.trace("ExtHostSCM#$provideOriginalResource",l,_.toString());const A=this._sourceControls.get(l);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,i.asPromise)(()=>A.quickDiffProvider.provideOriginalResource(_,c)).then(R=>R||null)}$onInputBoxValueChange(l,h){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",l);const c=this._sourceControls.get(l);return c&&c.inputBox.$onInputBoxValueChange(h),Promise.resolve(void 0)}$executeResourceCommand(l,h,c,_){this.logService.trace("ExtHostSCM#$executeResourceCommand",l,h,c);const A=this._sourceControls.get(l);if(!A)return Promise.resolve(void 0);const R=A.getResourceGroup(h);return R?R.$executeResourceCommand(c,_):Promise.resolve(void 0)}$validateInput(l,h,c){this.logService.trace("ExtHostSCM#$validateInput",l);const _=this._sourceControls.get(l);return!_||!_.inputBox.validateInput?Promise.resolve(void 0):(0,i.asPromise)(()=>_.inputBox.validateInput(h,c)).then(A=>{if(!A)return Promise.resolve(void 0);const R=b.MarkdownString.fromStrict(A.message);return R?Promise.resolve([R,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(l){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&this._sourceControls.get(l)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=l,Promise.resolve(void 0)}};u._handlePool=0,u=Ve([He(2,T.ILogService)],u),e.ExtHostSCM=u});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[249],pe([0,1,7,5,165,6,16,13]),function(Y,e,m,L,D,C,i,k){"use strict";var S,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class T{constructor(f,w,E,P,p=m.StatusBarAlignment.Left,o){S.set(this,void 0),y.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,ot(this,S,f,"f"),ot(this,y,w,"f"),this._entryId=T.ID_GEN++,this._extension=E,this._id=P,this._alignment=p,this._priority=this.validatePriority(o)}validatePriority(f){if(!!(0,k.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!T.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Oe(this,y,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Oe(this,y,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let w;this._name?w=this._name:w=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let E=this._color;this._backgroundColor&&(E=T.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const P=this._tooltip?i.MarkdownString.fromStrict(this._tooltip):void 0;Oe(this,S,"f").$setEntry(this._entryId,f,w,this._text,P,this._command?.internal,E,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=T,S=new WeakMap,y=new WeakMap,T.ID_GEN=0,T.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new m.ThemeColor("statusBarItem.warningForeground")]]);class I{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const w={message:f};return this._messages.unshift(w),this._update(),new m.Disposable(()=>{const E=this._messages.indexOf(w);E>=0&&(this._messages.splice(E,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class a{constructor(f,w){this._proxy=f.getProxy(L.MainContext.MainThreadStatusBar),this._commands=w,this._statusMessage=new I(this)}createStatusBarEntry(f,w,E,P){return new T(this._proxy,this._commands,f,w,E,P)}setStatusBarMessage(f,w){const E=this._statusMessage.setMessage(f);let P;return typeof w=="number"?P=setTimeout(()=>E.dispose(),w):typeof w!="undefined"&&w.then(()=>E.dispose(),()=>E.dispose()),new m.Disposable(()=>{E.dispose(),clearTimeout(P)})}}e.ExtHostStatusBar=a}),define(ge[91],pe([0,1,5,3,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(k){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,S){this._proxy.$registerExtensionStorageKeysToSync(k,S)}getValue(k,S,y){return this._proxy.$getValue(k,S).then(T=>T||y)}setValue(k,S,y){return this._proxy.$setValue(k,S,y)}$acceptValue(k,S,y){this._onDidChangeStorage.fire({shared:k,key:S,value:y})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(ge[67],pe([0,1,4,26,11,66,2]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,m.createDecorator)("IExtensionStoragePaths");let k=class{constructor(y,T,I){this._logService=T,this._extHostFileSystem=I,this._workspace=y.workspace??void 0,this._environment=y.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(a=>this._value=a)}async _getWorkspaceStorageURI(y){return i.URI.joinPath(this._environment.workspaceStorageHome,y)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const y=this._workspace.id,T=await this._getWorkspaceStorageURI(y);try{return await this._extHostFileSystem.value.stat(T),this._logService.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",T),await this._extHostFileSystem.value.createDirectory(T),await this._extHostFileSystem.value.writeFile(i.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:i.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),T}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(y){if(this._value)return i.URI.joinPath(this._value,y.identifier.value)}globalValue(y){return i.URI.joinPath(this._environment.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=Ve([He(0,L.IExtHostInitDataService),He(1,D.ILogService),He(2,C.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(ge[34],pe([0,1,3,5,4,2,14,6,7,166,15,213,21,32,195,86,13,18]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class p{constructor(d,l,h,c){this._proxy=d,this._id=l,this._creationOptions=h,this._name=c,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(A=>this._pidPromiseComplete=A);const _=this;this.value={get name(){return _._name||""},get processId(){return _._pidPromise},get creationOptions(){return _._creationOptions},get exitStatus(){return _._exitStatus},get state(){return _._state},sendText(A,R=!0){_._checkDisposed(),_._proxy.$sendText(_._id,A,R)},show(A){_._checkDisposed(),_._proxy.$show(_._id,A)},hide(){_._checkDisposed(),_._proxy.$hide(_._id)},dispose(){_._disposed||(_._disposed=!0,_._proxy.$dispose(_._id))},get dimensions(){if(!(_._cols===void 0||_._rows===void 0))return{columns:_._cols,rows:_._rows}}}}async create(d,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:d.name,shellPath:(0,E.withNullAsUndefined)(d.shellPath),shellArgs:(0,E.withNullAsUndefined)(d.shellArgs),cwd:(0,E.withNullAsUndefined)(d.cwd),env:(0,E.withNullAsUndefined)(d.env),icon:(0,E.withNullAsUndefined)(n(d.iconPath)),color:w.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:(0,E.withNullAsUndefined)(d.message),strictEnv:(0,E.withNullAsUndefined)(d.strictEnv),hideFromUser:(0,E.withNullAsUndefined)(d.hideFromUser),isFeatureTerminal:(0,E.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,E.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this._serializeParentTerminal(d.location,l?.resolvedExtHostIdentifier)})}async createExtensionTerminal(d,l,h,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,color:w.ThemeColor.isThemeColor(c)?c.id:void 0,location:this._serializeParentTerminal(d,l)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(d,l){return typeof d=="object"?"parentTerminal"in d&&d.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in d?{viewColumn:d.viewColumn,preserveFocus:d.preserveFocus}:void 0:d}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(d){this._name=d}setExitCode(d){this._exitStatus=Object.freeze({code:d})}setDimensions(d,l){return d===this._cols&&l===this._rows||d===0||l===0?!1:(this._cols=d,this._rows=l,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(d){this._pidPromiseComplete?(this._pidPromiseComplete(d),this._pidPromiseComplete=void 0):this._pidPromise.then(l=>{l!==d&&(this._pidPromise=Promise.resolve(d))})}}e.ExtHostTerminal=p;class o{constructor(d){this._pty=d,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new m.Emitter,this._onDidChangeProperty=new m.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(d){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${d}`)}updateProperty(d,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${d}, value: ${l}`)}async start(){}shutdown(){this._pty.close()}input(d){this._pty.handleInput?.(d)}resize(d,l){this._pty.setDimensions?.({columns:d,rows:l})}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(d){this._pty.onDidWrite(l=>this._onProcessData.fire(l)),this._pty.onDidClose?.((l=void 0)=>{this._onProcessExit.fire(l===void 0?void 0:l)}),this._pty.onDidOverrideDimensions?.(l=>{l&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this._pty.onDidChangeName?.(l=>{this._onDidChangeProperty.fire({type:"title",value:l})}),this._pty.open(d||void 0),d&&this._pty.setDimensions?.(d),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=o;let r=1,g=class extends k.Disposable{constructor(d,l){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new m.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new m.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new m.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new m.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=l.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new f.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(d),this._register({dispose:()=>{for(const[h,c]of this._terminalProcesses)c.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(d=>d.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(d,l){const h=new p(this._proxy,(0,b.generateUuid)(),d,d.name),c=new o(d.pty);return h.createExtensionTerminal(d.location,this._serializeParentTerminal(d,l).resolvedExtHostIdentifier,n(d.iconPath),t(d.color)).then(_=>{const A=this._setupExtHostProcessListeners(_,c);this._terminalProcessDisposables[_]=A}),this._terminals.push(h),h.value}_serializeParentTerminal(d,l){if(l=l||{},d.location&&typeof d.location=="object"&&"parentTerminal"in d.location){const h=d.location.parentTerminal;if(h){const c=this._terminals.find(_=>_.value===h);c&&(l.resolvedExtHostIdentifier=c._id)}}else d.location&&typeof d.location!="object"?l.location=d.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(d,l){if(!this._getTerminalById(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const c=new o(l),_=this._setupExtHostProcessListeners(d,c);this._terminalProcessDisposables[d]=_}async $acceptActiveTerminalChanged(d){const l=this._activeTerminal;if(d===null){this._activeTerminal=void 0,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(d);h&&(this._activeTerminal=h,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(d,l){const h=this._getTerminalById(d);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:l})}async $acceptTerminalDimensions(d,l,h){const c=this._getTerminalById(d);c&&c.setDimensions(l,h)&&this._onDidChangeTerminalDimensions.fire({terminal:c.value,dimensions:c.value.dimensions})}async $acceptTerminalMaximumDimensions(d,l,h){this._terminalProcesses.get(d)?.resize(l,h)}async $acceptTerminalTitleChange(d,l){const h=this._getTerminalById(d);h&&(h.name=l)}async $acceptTerminalClosed(d,l){const h=this._getTerminalObjectIndexById(this._terminals,d);if(h!==null){const c=this._terminals.splice(h,1)[0];c.setExitCode(l),this._onDidCloseTerminal.fire(c.value)}}$acceptTerminalOpened(d,l,h,c){if(l){const R=this._getTerminalObjectIndexById(this._terminals,l);if(R!==null){this._terminals[R]._id=d,this._onDidOpenTerminal.fire(this.terminals[R]),this._terminals[R].isOpen=!0;return}}const _={name:c.name,shellPath:c.executable,shellArgs:c.args,cwd:typeof c.cwd=="string"?c.cwd:C.URI.revive(c.cwd),env:c.env,hideFromUser:c.hideFromUser},A=new p(this._proxy,d,_,h);this._terminals.push(A),this._onDidOpenTerminal.fire(A.value),A.isOpen=!0}async $acceptTerminalProcessId(d,l){const h=this._getTerminalById(d);h&&h._setProcessId(l)}async $startExtensionTerminal(d,l){const h=this._getTerminalById(d);if(!h)return{message:(0,y.localize)(0,null,d)};h.isOpen||await new Promise(_=>{const A=this.onDidOpenTerminal(async R=>{R===h.value&&(A.dispose(),_())})});const c=this._terminalProcesses.get(d);c?c.startSendingEvents(l):this._extensionTerminalAwaitingStart[d]={initialDimensions:l}}_setupExtHostProcessListeners(d,l){const h=new k.DisposableStore;h.add(l.onProcessReady(_=>this._proxy.$sendProcessReady(d,_.pid,_.cwd))),h.add(l.onDidChangeProperty(_=>this._proxy.$sendProcessProperty(d,_))),this._bufferer.startBuffering(d,l.onProcessData),h.add(l.onProcessExit(_=>this._onProcessExit(d,_))),this._terminalProcesses.set(d,l);const c=this._extensionTerminalAwaitingStart[d];return c&&l instanceof o&&(l.startSendingEvents(c.initialDimensions),delete this._extensionTerminalAwaitingStart[d]),h}$acceptProcessAckDataEvent(d,l){this._terminalProcesses.get(d)?.acknowledgeDataEvent(l)}$acceptProcessInput(d,l){this._terminalProcesses.get(d)?.input(l)}$acceptTerminalInteraction(d){const l=this._getTerminalById(d);l?.setInteractedWith()&&this._onDidChangeTerminalState.fire(l.value)}$acceptProcessResize(d,l,h){try{this._terminalProcesses.get(d)?.resize(l,h)}catch(c){if(c.code!=="EPIPE"&&c.code!=="ERR_IPC_CHANNEL_CLOSED")throw c}}$acceptProcessShutdown(d,l){this._terminalProcesses.get(d)?.shutdown(l)}$acceptProcessRequestInitialCwd(d){this._terminalProcesses.get(d)?.getInitialCwd().then(l=>this._proxy.$sendProcessProperty(d,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(d){this._terminalProcesses.get(d)?.getCwd().then(l=>this._proxy.$sendProcessProperty(d,{type:"cwd",value:l}))}$acceptProcessRequestLatency(d){return d}registerLinkProvider(d){return this._linkProviders.add(d),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(d),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(d,l,h){if(this._profileProviders.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this._profileProviders.set(l,h),this._proxy.$registerProfileProvider(l,d.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(l),this._proxy.$unregisterProfileProvider(l)})}async $createContributedProfileTerminal(d,l){const h=new a.CancellationTokenSource().token;let c=await this._profileProviders.get(d)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(c&&!("options"in c)&&(c={options:c}),!c||!("options"in c))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in c.options){this.createExtensionTerminal(c.options,l);return}this.createTerminalFromOptions(c.options,l)}}async $provideLinks(d,l){const h=this._getTerminalById(d);if(!h)return[];this._terminalLinkCache.delete(d);const c=this._terminalLinkCancellationSource.get(d);c&&c.dispose(!0);const _=new a.CancellationTokenSource;this._terminalLinkCancellationSource.set(d,_);const A=[],R={terminal:h.value,line:l},x=[];for(const $ of this._linkProviders)x.push(P.Promises.withAsyncBody(async M=>{_.token.onCancellationRequested(()=>M({provider:$,links:[]}));const B=await $.provideTerminalLinks(R,_.token)||[];_.token.isCancellationRequested||M({provider:$,links:B})}));const O=await Promise.all(x);if(_.token.isCancellationRequested)return[];const F=new Map;for(const $ of O)$&&$.links.length>0&&A.push(...$.links.map(M=>{const B={id:r++,startIndex:M.startIndex,length:M.length,label:M.tooltip};return F.set(B.id,{provider:$.provider,link:M}),B}));return this._terminalLinkCache.set(d,F),A}$activateLink(d,l){const h=this._terminalLinkCache.get(d)?.get(l);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(d,l){this._bufferer.stopBuffering(d),this._terminalProcesses.delete(d),delete this._extensionTerminalAwaitingStart[d];const h=this._terminalProcessDisposables[d];h&&(h.dispose(),delete this._terminalProcessDisposables[d]),this._proxy.$sendProcessExit(d,l)}_getTerminalById(d){return this._getTerminalObjectById(this._terminals,d)}_getTerminalObjectById(d,l){const h=this._getTerminalObjectIndexById(d,l);return h!==null?d[h]:null}_getTerminalObjectIndexById(d,l){let h=null;return d.some((c,_)=>c._id===l?(h=_,!0):!1),h}getEnvironmentVariableCollection(d){let l=this._environmentVariableCollections.get(d.identifier.value);return l||(l=new s,this._setEnvironmentVariableCollection(d.identifier.value,l)),l}_syncEnvironmentVariableCollection(d,l){const h=(0,I.serializeEnvironmentVariableCollection)(l.map);this._proxy.$setEnvironmentVariableCollection(d,l.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(d){d.forEach(l=>{const h=l[0],c=new s(l[1]);this._setEnvironmentVariableCollection(h,c)})}$acceptDefaultProfile(d,l){this._defaultProfile=d,this._defaultAutomationProfile=l}_setEnvironmentVariableCollection(d,l){this._environmentVariableCollections.set(d,l),l.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(d,l)})}};g=Ve([He(1,i.IExtHostRpcService)],g),e.BaseExtHostTerminalService=g;class s{constructor(d){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(d)}get persistent(){return this._persistent}set persistent(d){this._persistent=d,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(d,l){this._setIfDiffers(d,{value:l,type:S.EnvironmentVariableMutatorType.Replace})}append(d,l){this._setIfDiffers(d,{value:l,type:S.EnvironmentVariableMutatorType.Append})}prepend(d,l){this._setIfDiffers(d,{value:l,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(d,l){const h=this.map.get(d);(!h||h.value!==l.value||h.type!==l.type)&&(this.map.set(d,l),this._onDidChangeCollection.fire())}get(d){return this.map.get(d)}forEach(d,l){this.map.forEach((h,c)=>d.call(l,c,h,this))}delete(d){this.map.delete(d),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=s;let v=class extends g{constructor(d){super(!1,d)}createTerminal(d,l,h){throw new T.NotSupportedError}createTerminalFromOptions(d,l){throw new T.NotSupportedError}};v=Ve([He(0,i.IExtHostRpcService)],v),e.WorkerExtHostTerminalService=v;function n(u){if(!(!u||typeof u=="string"))return"id"in u?{id:u.id,color:u.color}:u}function t(u){return w.ThemeColor.isThemeColor(u)?u:void 0}});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[250],pe([0,1,17,22,21,3,74,47,6,25,13,32,5,14,63,16,7,221,126,89]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E,P,p,o){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let g=class{constructor(R,x){this.resultsChangedEmitter=new C.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(a.MainContext.MainThreadTesting),this.observer=new h(this.proxy),this.runTracker=new v(this.proxy),x.registerArgumentProcessor({processArgument:O=>O?.$mid===13?w.TestItem.toItemFromContext(O):O})}createTestController(R,x){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const O=new S.DisposableStore,F=O.add(new P.SingleUseTestCollection(R));F.root.label=x;const $=new Map,M=this.proxy,B={items:F.root.children,get label(){return x},set label(z){x=z,F.root.label=z,M.$updateControllerLabel(R,x)},get id(){return R},createRunProfile:(z,K,N,j,H)=>{let V=(0,k.hash)(z);for(;$.has(V);)V++;const q=new c(this.proxy,R,V,z,K,N,j,H);return $.set(V,q),q},createTestItem(z,K,N){return new f.TestItemImpl(R,z,K,N)},createTestRun:(z,K,N=!0)=>this.runTracker.createTestRun(R,F,z,K,N),set resolveHandler(z){F.resolveHandler=z},get resolveHandler(){return F.resolveHandler},dispose:()=>{O.dispose()}};B.createRunConfiguration=B.createRunProfile,M.$registerTestController(R,x),O.add((0,S.toDisposable)(()=>M.$unregisterTestController(R)));const U={controller:B,collection:F,profiles:$};return this.controllers.set(R,U),O.add((0,S.toDisposable)(()=>this.controllers.delete(R))),O.add(F.onDidGenerateDiff(z=>M.$publishDiff(R,z))),B}createTestObserver(){return this.observer.checkout()}async runTests(R,x=D.CancellationToken.None){const O=n(R);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(O.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map($=>$.id)??[F.collection.root.id],profileGroup:_[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:R.exclude?.map($=>$.id)},x)}$provideFileCoverage(R,x,O){return(0,m.mapFind)(this.runTracker.trackers,$=>$.id===R?$.getCoverage(x):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(R,x,O,F){return(0,m.mapFind)(this.runTracker.trackers,M=>M.id===R?M.getCoverage(x):void 0)?.resolveFileCoverage(O,F)??Promise.resolve([])}$configureRunProfile(R,x){this.controllers.get(R)?.profiles.get(x)?.configureHandler?.()}$publishTestResults(R){this.results=Object.freeze(R.map(x=>(0,y.deepFreeze)(w.TestResults.to(x))).concat(this.results).sort((x,O)=>O.completedAt-x.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,x){const O=this.controllers.get(o.TestId.fromString(R).controllerId)?.collection;O&&(await O.expand(R,x<0?Infinity:x),O.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,x){const O=this.controllers.get(R.controllerId);if(!O)return;const{collection:F,profiles:$}=O,M=$.get(R.profileId);if(!M)return;const B=R.testIds.map(N=>F.tree.get(N)).filter(T.isDefined),U=R.excludeExtIds.map(N=>O.collection.tree.get(N)).filter(T.isDefined).filter(N=>B.some(j=>j.fullId.compare(N.fullId)===2));if(!B.length)return;const z=new E.TestRunRequest(B.some(N=>N.actual instanceof f.TestItemRootImpl)?void 0:B.map(N=>N.actual),U.map(N=>N.actual),M),K=this.runTracker.prepareForMainThreadTestRun(z,t.fromInternal(R,O.collection),x);try{await M.runHandler(z,x)}finally{K.isRunning&&!x.isCancellationRequested&&await C.Event.toPromise(K.onEnd),K.dispose()}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};g=Ve([He(0,b.IExtHostRpcService)],g),e.ExtHostTesting=g;class s extends S.Disposable{constructor(R,x,O){super();this.dto=R,this.proxy=x,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new C.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new D.CancellationTokenSource(O)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const x=this.dto.id,O=this.dto.controllerId,F=(0,I.generateUuid)(),$=new u(this.proxy,x,F),M=K=>(N,...j)=>{if(U){console.warn(`Setting the state of test "${N.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(N)||(this.ensureTestIsKnown(N),K(N,...j))},B=(K,N)=>{const j=N instanceof Array?N.map(w.TestMessage.from):[w.TestMessage.from(N)];if(K.uri&&K.range){const H={range:w.Range.from(K.range),uri:K.uri};for(const V of j)V.location=V.location||H}this.proxy.$appendTestMessagesInRun(x,F,o.TestId.fromExtHostTestItem(K,O).toString(),j)};let U=!1;const z={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return $.coverageProvider},set coverageProvider(K){$.coverageProvider=K},enqueued:M(K=>{this.proxy.$updateTestStateInRun(x,F,o.TestId.fromExtHostTestItem(K,O).toString(),1)}),skipped:M(K=>{this.proxy.$updateTestStateInRun(x,F,o.TestId.fromExtHostTestItem(K,O).toString(),5)}),started:M(K=>{this.proxy.$updateTestStateInRun(x,F,o.TestId.fromExtHostTestItem(K,O).toString(),2)}),errored:M((K,N,j)=>{B(K,N),this.proxy.$updateTestStateInRun(x,F,o.TestId.fromExtHostTestItem(K,O).toString(),6,j)}),failed:M((K,N,j)=>{B(K,N),this.proxy.$updateTestStateInRun(x,F,o.TestId.fromExtHostTestItem(K,O).toString(),4,j)}),passed:M((K,N)=>{this.proxy.$updateTestStateInRun(x,F,o.TestId.fromExtHostTestItem(K,this.dto.controllerId).toString(),3,N)}),appendOutput:(K,N,j)=>{U||(j&&(this.dto.isIncluded(j)?this.ensureTestIsKnown(j):j=void 0),this.proxy.$appendOutputToRun(x,F,L.VSBuffer.fromString(K),N&&w.location.from(N),j&&o.TestId.fromExtHostTestItem(j,O).toString()))},end:()=>{U||(U=!0,this.proxy.$finishedTestRunTask(x,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:z,coverage:$}),this.proxy.$startedTestRunTask(x,{id:F,name:R,running:!0}),z}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof f.TestItemImpl))throw new f.InvalidTestItemError(R.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(R,this.dto.controllerId).toString()))return;const x=[],O=this.dto.colllection.root;for(;;){const F=w.TestItem.from(R);if(x.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),R===O))break;R=R.parent||O}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,x)}}class v{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,x,O){return this.getTracker(R,x,O)}cancelRunById(R){for(const x of this.tracked.values())if(x.id===R){x.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,x,O,F,$){const M=this.tracked.get(O);if(M)return M.createRun(F);const B=t.fromPublic(R,x,O,$),U=n(O);this.proxy.$startedExtensionTestRun({controllerId:R,profile:U&&{group:_[U.kind],id:U.profileId},exclude:O.exclude?.map(K=>K.id)??[],id:B.id,include:O.include?.map(K=>K.id)??[x.root.id],persist:$});const z=this.getTracker(O,B);return z.onEnd(()=>this.proxy.$finishedExtensionTestRun(B.id)),z.createRun(F)}getTracker(R,x,O){const F=new s(x,this.proxy,O);return this.tracked.set(R,F),F.onEnd(()=>this.tracked.delete(R)),F}}e.TestRunCoordinator=v;const n=A=>{if(!!A.profile){if(!(A.profile instanceof c))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return A.profile}};class t{constructor(R,x,O,F,$,M){this.controllerId=R,this.id=x,this.isPersisted=$,this.colllection=M,this.includePrefix=O.map(B=>B+"\0"),this.excludePrefix=F.map(B=>B+"\0")}static fromPublic(R,x,O,F){return new t(R,(0,I.generateUuid)(),O.include?.map($=>o.TestId.fromExtHostTestItem($,R).toString())??[R],O.exclude?.map($=>o.TestId.fromExtHostTestItem($,R).toString())??[],F,x)}static fromInternal(R,x){return new t(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,x)}isIncluded(R){const x=o.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const O of this.excludePrefix)if(x===O||x.startsWith(O))return!1;for(const O of this.includePrefix)if(x===O||x.startsWith(O))return!0;return!1}}e.TestRunDto=t;class u{constructor(R,x,O){this.proxy=R,this.runId=x,this.taskId=O}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(w.TestCoverage.fromFile)??[]}catch(x){throw this.fileCoverage=void 0,x}}async resolveFileCoverage(R,x){const O=await this.fileCoverage;let F=O?.[R];return!this._coverageProvider||!O||!F?[]:(F.detailedCoverage||(F=O[R]=await this._coverageProvider.resolveFileCoverage?.(F,x)??F),F.detailedCoverage?.map(w.TestCoverage.fromDetailed)??[])}}class d extends p.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,w.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:x,removed:O}=this;return{get added(){return[...R].map(F=>F.revived)},get updated(){return[...x].map(F=>F.revived)},get removed(){return[...O].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class l extends p.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new C.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,x){return{...R,revived:w.TestItem.toPlain(R.item),depth:x?x.depth+1:0,children:new Set}}createChangeCollector(){return new d(this.changeEmitter)}}e.MirroredTestCollection=l;class h{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(x=>x.revived)},dispose:(0,i.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new l;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class c{constructor(R,x,O,F,$,M,B=!1,U=void 0){this.controllerId=x,this.profileId=O,this._label=F,this.kind=$,this.runHandler=M,this._isDefault=B,this._tag=U,r.set(this,void 0),ot(this,r,R,"f");const z=_[$];if(typeof z!="number")throw new Error(`Unknown TestRunProfile.group ${$}`);Oe(this,r,"f").$publishTestRunProfile({profileId:O,controllerId:x,tag:U?w.TestTag.namespace(this.controllerId,U.id):null,label:F,group:z,isDefault:B,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?w.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){Oe(this,r,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=c,r=new WeakMap;const _={[E.TestRunProfileKind.Coverage]:8,[E.TestRunProfileKind.Debug]:4,[E.TestRunProfileKind.Run]:2}}),define(ge[251],pe([0,1,3,17,5,129,16,7]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(T,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=T.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(a=>this._onDidChangeVisibleTextEditors.fire(a)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(a=>this._onDidChangeActiveTextEditor.fire(a))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(T){const I=this._extHostDocumentsAndEditors.allEditors();return T?I:I.map(a=>a.value)}async showTextDocument(T,I,a){let b;typeof I=="number"?b={position:i.ViewColumn.from(I),preserveFocus:a}:typeof I=="object"?b={position:i.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?i.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:b={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(T.uri,b),w=f&&this._extHostDocumentsAndEditors.getEditor(f);if(w)return w.value;throw f?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T,I){return new C.TextEditorDecorationType(this._proxy,T,I).value}$acceptEditorPropertiesChanged(T,I){const a=this._extHostDocumentsAndEditors.getEditor(T);if(!a)throw new Error("unknown text editor");if(I.options&&a._acceptOptions(I.options),I.selections){const b=I.selections.selections.map(i.Selection.to);a._acceptSelections(b)}if(I.visibleRanges){const b=L.coalesce(I.visibleRanges.map(i.Range.to));a._acceptVisibleRanges(b)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:a.value,options:{...I.options,lineNumbers:i.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const b=k.TextEditorSelectionChangeKind.fromValue(I.selections.source),f=I.selections.selections.map(i.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:a.value,selections:f,kind:b})}if(I.visibleRanges){const b=L.coalesce(I.visibleRanges.map(i.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:a.value,visibleRanges:b})}}$acceptEditorPositionData(T){for(const I in T){const a=this._extHostDocumentsAndEditors.getEditor(I);if(!a)throw new Error("Unknown text editor");const b=i.ViewColumn.to(T[I]);a.value.viewColumn!==b&&(a._acceptViewColumn(b),this._onDidChangeTextEditorViewColumn.fire({textEditor:a.value,viewColumn:b}))}}getDiffInformation(T){return Promise.resolve(this._proxy.$getDiffInformation(T))}}e.ExtHostEditors=S}),define(ge[252],pe([0,1,2,4,5,6,7]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class k{constructor(T,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=T.getProxy(D.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===11){const b=a.uri===void 0?void 0:m.URI.revive(a.uri);return this._itemsBySourceAndUriMap.get(a.source)?.get(S(b))?.get(a.handle)}return a}})}async $getTimeline(T,I,a,b,f){return this._providers.get(T)?.provideTimeline(m.URI.revive(I),a,b,f)}registerTimelineProvider(T,I,a,b){const f=new C.DisposableStore,w=this.convertTimelineItem(I.id,b,f).bind(this);let E;I.onDidChange&&(E=I.onDidChange(p=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:I.id}),this));const P=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:T,onDidChange:void 0,async provideTimeline(p,o,r,g){g?.resetCache&&(f.clear(),P.get(I.id)?.clear());const s=await I.provideTimeline(p,o,r);if(s==null)return;const v=w(p,g);return{...s,source:I.id,items:s.items.map(v)}},dispose(){for(const p of P.values())p.get(I.id)?.clear();E?.dispose(),f.dispose()}})}convertTimelineItem(T,I,a){return(b,f)=>{let w;if(f?.cacheResults){let E=this._itemsBySourceAndUriMap.get(T);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(T,E));const P=S(b);w=E.get(P),w===void 0&&(w=new Map,E.set(P,w))}return E=>{const{iconPath:P,...p}=E,o=`${T}|${E.id??E.timestamp}`;w?.set(o,E);let r,g,s;return E.iconPath&&(P instanceof i.ThemeIcon?s={id:P.id,color:P.color}:m.URI.isUri(P)?(r=P,g=P):{light:r,dark:g}=P),{...p,id:p.id??void 0,handle:o,source:T,command:E.command?I.toInternal(E.command,a):void 0,icon:r,iconDark:g,themeIcon:s,accessibilityInformation:E.accessibilityInformation}}}}registerTimelineProviderCore(T){if(this._providers.get(T.id))throw new Error(`Timeline Provider ${T.id} already exists.`);return this._proxy.$registerTimelineProvider({id:T.id,label:T.label,scheme:T.scheme}),this._providers.set(T.id,T),(0,C.toDisposable)(()=>{for(const a of this._itemsBySourceAndUriMap.values())a.get(T.id)?.clear();this._providers.delete(T.id),this._proxy.$unregisterTimelineProvider(T.id),T.dispose()})}}e.ExtHostTimeline=k;function S(y){return y?.toString()}}),define(ge[253],pe([0,1,6,10,2,5]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class i{constructor(S){this._openers=new Map,this._proxy=S.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,y,T,I){if(this._openers.has(y))throw new Error(`Opener with id '${y}' already registered`);const a=I.schemes.find(b=>!i.supportedSchemes.has(b));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this._openers.set(y,T),this._proxy.$registerUriOpener(y,I.schemes,S,I.label),(0,m.toDisposable)(()=>{this._openers.delete(y),this._proxy.$unregisterUriOpener(y)})}async $canOpenUri(S,y,T){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener with id: ${S}`);const a=D.URI.revive(y);return I.canOpenExternalUri(a,T)}async $openUri(S,y,T){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener id: '${S}'`);return I.openExternalUri(D.URI.revive(y.resolvedUri),{sourceUri:D.URI.revive(y.sourceUri)},T)}}e.ExtHostUriOpeners=i,i.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(ge[254],pe([0,1,5,2,6,15,27]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(y){this.handles=new Set,this.handlers=new Map,this._proxy=y.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(y,T){if(this.handles.has(i.ExtensionIdentifier.toKey(y)))throw new Error(`Protocol handler already registered for extension ${y}`);const I=k.HandlePool++;return this.handles.add(i.ExtensionIdentifier.toKey(y)),this.handlers.set(I,T),this._proxy.$registerUriHandler(I,y),(0,D.toDisposable)(()=>{this.handles.delete(i.ExtensionIdentifier.toKey(y)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(y,T){const I=this.handlers.get(y);if(!I)return Promise.resolve(void 0);try{I.handleUri(L.URI.revive(T))}catch(a){(0,C.onUnexpectedError)(a)}return Promise.resolve(void 0)}async createAppUri(y){return L.URI.revive(await this._proxy.$createAppUri(y))}}e.ExtHostUrls=k,k.HandlePool=0});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[68],pe([0,1,3,10,2,178,203,88,5]),function(Y,e,m,L,D,C,i,k,S){"use strict";var y,T,I,a,b,f,w,E,P,p,o,r;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class g{constructor(h,c,_,A,R,x,O){y.set(this,void 0),T.set(this,void 0),I.set(this,void 0),a.set(this,void 0),b.set(this,void 0),f.set(this,void 0),w.set(this,""),E.set(this,void 0),P.set(this,!1),p.set(this,!1),o.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new m.Emitter),this._onDidDispose=Oe(this,r,"f").event,ot(this,y,h,"f"),ot(this,T,c,"f"),ot(this,E,_,"f"),ot(this,a,A,"f"),ot(this,b,R,"f"),ot(this,f,x,"f"),ot(this,o,s(x),"f"),ot(this,I,O,"f")}dispose(){ot(this,P,!0,"f"),Oe(this,r,"f").fire(),Oe(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return ot(this,p,!0,"f"),(0,k.asWebviewUri)(h,Oe(this,a,"f").remote)}get cspSource(){const h=Oe(this,f,"f").extensionLocation;if(h.scheme===L.Schemas.https||h.scheme===L.Schemas.http){let c=h.toString();return c.endsWith("/")||(c+="/"),c+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,w,"f")}set html(h){this.assertNotDisposed(),Oe(this,w,"f")!==h&&(ot(this,w,h,"f"),!Oe(this,p,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(ot(this,p,!0,"f"),Oe(this,I,"f").report("Webview vscode-resource: uris",Oe(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,T,"f").$setHtml(Oe(this,y,"f"),h))}get options(){return this.assertNotDisposed(),Oe(this,E,"f")}set options(h){this.assertNotDisposed(),Oe(this,T,"f").$setOptions(Oe(this,y,"f"),t(Oe(this,f,"f"),Oe(this,b,"f"),h)),ot(this,E,h,"f")}async postMessage(h){if(Oe(this,P,"f"))return!1;const c=(0,i.serializeWebviewMessage)(h,{serializeBuffersForPostMessage:Oe(this,o,"f")});return Oe(this,T,"f").$postMessage(Oe(this,y,"f"),c.message,...c.buffers)}assertNotDisposed(){if(Oe(this,P,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,y=new WeakMap,T=new WeakMap,I=new WeakMap,a=new WeakMap,b=new WeakMap,f=new WeakMap,w=new WeakMap,E=new WeakMap,P=new WeakMap,p=new WeakMap,o=new WeakMap,r=new WeakMap;function s(l){try{const h=(0,C.normalizeVersion)((0,C.parseVersion)(l.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;class v{constructor(h,c,_,A,R){this.initData=c,this.workspace=_,this._logService=A,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=h.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(h,c,..._){const A=this.getWebview(h);if(A){const{message:R}=(0,i.deserializeWebviewMessage)(c,_);A._onMessageEmitter.fire(R)}}$onMissingCsp(h,c){this._logService.warn(`${c} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,c,_){const A=new g(h,this._webviewProxy,u(c),this.initData,this.workspace,_,this._deprecationService);return this._webviews.set(h,A),A._onDidDispose(()=>{this._webviews.delete(h)}),A}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=v;function n(l){return{id:l.identifier,location:l.extensionLocation}}e.toExtensionData=n;function t(l,h,c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots||d(l,h)}}e.serializeWebviewOptions=t;function u(l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots?.map(h=>D.URI.from(h))}}e.reviveOptions=u;function d(l,h){return[...(h?.getWorkspaceFolders()||[]).map(c=>c.uri),l.extensionLocation]}}),define(ge[255],pe([0,1,21,47,6,10,23,2,16,68,87,5,7]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(s,v){this.document=s,this._storagePath=v,this._backupCounter=1,this._edits=new T.Cache("custom documents")}addEdit(s){return this._edits.add([s])}async undo(s,v){await this.getEdit(s).undo(),v||this.disposeBackup()}async redo(s,v){await this.getEdit(s).redo(),v||this.disposeBackup()}disposeEdits(s){for(const v of s)this._edits.delete(v)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const s=r(this.document.uri)+this._backupCounter++;return(0,i.joinPath)(this._storagePath,s)}updateBackup(s){this._backup?.delete(),this._backup=s}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(s){const v=this._edits.get(s,0);if(!v)throw new Error("No edit found");return v}}class f{constructor(){this._documents=new Map}get(s,v){return this._documents.get(this.key(s,v))}add(s,v,n){const t=this.key(s,v.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${s} resource:${v.uri}`);const u=new b(v,n);return this._documents.set(t,u),u}delete(s,v){const n=this.key(s,v.uri);this._documents.delete(n)}key(s,v){return`${s}@@@${v}`}}var w;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(w||(w={}));class E{constructor(){this._providers=new Map}addTextProvider(s,v,n){return this.add(0,s,v,n)}addCustomProvider(s,v,n){return this.add(1,s,v,n)}get(s){return this._providers.get(s)}add(s,v,n,t){if(this._providers.has(v))throw new Error(`Provider for viewType:${v} already registered`);return this._providers.set(v,{type:s,extension:n,provider:t}),new a.Disposable(()=>this._providers.delete(v))}}class P{constructor(s,v,n,t,u){this._extHostDocuments=v,this._extensionStoragePaths=n,this._extHostWebview=t,this._extHostWebviewPanels=u,this._editorProviders=new E,this._documents=new f,this._proxy=s.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,v,n,t){const u=new D.DisposableStore;return p(n)?(u.add(this._editorProviders.addTextProvider(v,s,n)),this._proxy.$registerTextEditorProvider((0,y.toExtensionData)(s),v,t.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,y.shouldSerializeBuffersForPostMessage)(s))):(u.add(this._editorProviders.addCustomProvider(v,s,n)),this.supportEditing(n)&&u.add(n.onDidChangeCustomDocument(d=>{const l=this.getCustomDocumentEntry(v,d.document.uri);if(o(d)){const h=l.addEdit(d);this._proxy.$onDidEdit(d.document.uri,v,h,d.label)}else this._proxy.$onContentChange(d.document.uri,v)})),this._proxy.$registerCustomEditorProvider((0,y.toExtensionData)(s),v,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,y.shouldSerializeBuffersForPostMessage)(s))),a.Disposable.from(u,new a.Disposable(()=>{this._proxy.$unregisterEditorProvider(v)}))}async $createCustomDocument(s,v,n,t,u){const d=this._editorProviders.get(v);if(!d)throw new Error(`No provider found for '${v}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${v}'`);const l=k.URI.revive(s),h=await d.provider.openCustomDocument(l,{backupId:n,untitledDocumentData:t?.buffer},u);let c;return this.supportEditing(d.provider)&&this._extensionStoragePaths&&(c=this._extensionStoragePaths.workspaceValue(d.extension)??this._extensionStoragePaths.globalValue(d.extension)),this._documents.add(v,h,c),{editable:this.supportEditing(d.provider)}}async $disposeCustomDocument(s,v){const n=this._editorProviders.get(v);if(!n)throw new Error(`No provider found for '${v}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${v}'`);const t=k.URI.revive(s),{document:u}=this.getCustomDocumentEntry(v,t);this._documents.delete(v,u),u.dispose()}async $resolveWebviewEditor(s,v,n,t,u,d){const l=this._editorProviders.get(n);if(!l)throw new Error(`No provider found for '${n}'`);const h=S.ViewColumn.to(u),c=this._extHostWebview.createNewWebview(v,t.webviewOptions,l.extension),_=this._extHostWebviewPanels.createNewWebviewPanel(v,n,t.title,h,t.panelOptions,c),A=k.URI.revive(s);switch(l.type){case 1:{const{document:R}=this.getCustomDocumentEntry(n,A);return l.provider.resolveCustomEditor(R,_,d)}case 0:{const R=this._extHostDocuments.getDocument(A);return l.provider.resolveCustomTextEditor(R,_,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,v,n){this.getCustomDocumentEntry(v,s).disposeEdits(n)}async $onMoveCustomEditor(s,v,n){const t=this._editorProviders.get(n);if(!t)throw new Error(`No provider found for '${n}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const u=this._extHostWebviewPanels.getWebviewPanel(s);if(!u)throw new Error("No webview found");const d=k.URI.revive(v),l=this._extHostDocuments.getDocument(d);await t.provider.moveCustomTextEditor(l,u,m.CancellationToken.None)}async $undo(s,v,n,t){return this.getCustomDocumentEntry(v,s).undo(n,t)}async $redo(s,v,n,t){return this.getCustomDocumentEntry(v,s).redo(n,t)}async $revert(s,v,n){const t=this.getCustomDocumentEntry(v,s);await this.getCustomEditorProvider(v).revertCustomDocument(t.document,n),t.disposeBackup()}async $onSave(s,v,n){const t=this.getCustomDocumentEntry(v,s);await this.getCustomEditorProvider(v).saveCustomDocument(t.document,n),t.disposeBackup()}async $onSaveAs(s,v,n,t){const u=this.getCustomDocumentEntry(v,s);return this.getCustomEditorProvider(v).saveCustomDocumentAs(u.document,k.URI.revive(n),t)}async $backup(s,v,n){const t=this.getCustomDocumentEntry(v,s),d=await this.getCustomEditorProvider(v).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},n);return t.updateBackup(d),d.id}getCustomDocumentEntry(s,v){const n=this._documents.get(s,k.URI.revive(v));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(s){const n=this._editorProviders.get(s)?.provider;if(!n||!this.supportEditing(n))throw new Error("Custom document is not editable");return n}supportEditing(s){return!!s.onDidChangeCustomDocument}}e.ExtHostCustomEditors=P;function p(g){return typeof g.resolveCustomTextEditor=="function"}function o(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function r(g){const s=g.scheme===C.Schemas.file||g.scheme===C.Schemas.untitled?g.fsPath:g.toString();return(0,L.hash)(s)+""}});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[256],pe([0,1,3,6,2,32,16,68,5,7]),function(Y,e,m,L,D,C,i,k,S,y){"use strict";var T,I,a,b,f,w,E,P,p,o,r,g,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class v extends L.Disposable{constructor(d,l,h,c,_,A,R){super();T.set(this,void 0),I.set(this,void 0),a.set(this,void 0),b.set(this,void 0),f.set(this,void 0),w.set(this,void 0),E.set(this,void 0),P.set(this,void 0),p.set(this,!0),o.set(this,!0),r.set(this,!1),g.set(this,this._register(new m.Emitter)),this.onDidDispose=Oe(this,g,"f").event,s.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Oe(this,s,"f").event,ot(this,T,d,"f"),ot(this,I,l,"f"),ot(this,a,h,"f"),ot(this,f,A,"f"),ot(this,P,_,"f"),ot(this,w,c,"f"),ot(this,b,R,"f")}dispose(){Oe(this,r,"f")||(ot(this,r,!0,"f"),Oe(this,g,"f").fire(),Oe(this,I,"f").$disposeWebview(Oe(this,T,"f")),Oe(this,b,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,b,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,a,"f")}get title(){return this.assertNotDisposed(),Oe(this,w,"f")}set title(d){this.assertNotDisposed(),Oe(this,w,"f")!==d&&(ot(this,w,d,"f"),Oe(this,I,"f").$setTitle(Oe(this,T,"f"),d))}get iconPath(){return this.assertNotDisposed(),Oe(this,E,"f")}set iconPath(d){this.assertNotDisposed(),Oe(this,E,"f")!==d&&(ot(this,E,d,"f"),Oe(this,I,"f").$setIconPath(Oe(this,T,"f"),D.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Oe(this,f,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,P,"f")=="number"&&Oe(this,P,"f")<0))return Oe(this,P,"f")}get active(){return this.assertNotDisposed(),Oe(this,o,"f")}get visible(){return this.assertNotDisposed(),Oe(this,p,"f")}_updateViewState(d){Oe(this,r,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(ot(this,o,d.active,"f"),ot(this,p,d.visible,"f"),ot(this,P,d.viewColumn,"f"),Oe(this,s,"f").fire({webviewPanel:this}))}reveal(d,l){this.assertNotDisposed(),Oe(this,I,"f").$reveal(Oe(this,T,"f"),{viewColumn:d?i.ViewColumn.from(d):void 0,preserveFocus:!!l})}assertNotDisposed(){if(Oe(this,r,"f"))throw new Error("Webview is disposed")}}T=new WeakMap,I=new WeakMap,a=new WeakMap,b=new WeakMap,f=new WeakMap,w=new WeakMap,E=new WeakMap,P=new WeakMap,p=new WeakMap,o=new WeakMap,r=new WeakMap,g=new WeakMap,s=new WeakMap;class n{constructor(d,l,h){this.webviews=l,this.workspace=h,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(d,l,h,c,_={}){const A=typeof c=="object"?c.viewColumn:c,R={viewColumn:i.ViewColumn.from(A),preserveFocus:typeof c=="object"&&!!c.preserveFocus},x=(0,k.shouldSerializeBuffersForPostMessage)(d),O=n.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(d),O,l,{title:h,panelOptions:t(_),webviewOptions:(0,k.serializeWebviewOptions)(d,this.workspace,_),serializeBuffersForPostMessage:x},R);const F=this.webviews.createNewWebview(O,_,d);return this.createNewWebviewPanel(O,l,h,A,_,F)}$onDidChangeWebviewPanelViewStates(d){const l=Object.keys(d);l.sort((h,c)=>{const _=d[h],A=d[c];return _.active?1:A.active?-1:+_.visible-+A.visible});for(const h of l){const c=this.getWebviewPanel(h);if(!c)continue;const _=d[h];c._updateViewState({active:_.active,visible:_.visible,viewColumn:i.ViewColumn.to(_.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,l,h){if(this._serializers.has(l))throw new Error(`Serializer for '${l}' already registered`);return this._serializers.set(l,{serializer:h,extension:d}),this._proxy.$registerSerializer(l,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(d)}),new y.Disposable(()=>{this._serializers.delete(l),this._proxy.$unregisterSerializer(l)})}async $deserializeWebviewPanel(d,l,h,c){const _=this._serializers.get(l);if(!_)throw new Error(`No serializer found for '${l}'`);const{serializer:A,extension:R}=_,x=this.webviews.createNewWebview(d,h.webviewOptions,R),O=this.createNewWebviewPanel(d,l,h.title,c,h.panelOptions,x);await A.deserializeWebviewPanel(O,h.state)}createNewWebviewPanel(d,l,h,c,_,A){const R=new v(d,this._proxy,l,h,c,_,A);return this._webviewPanels.set(d,R),R}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=n;function t(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[257],pe([0,1,3,6,68,5,7]),function(Y,e,m,L,D,C,i){"use strict";var k,S,y,T,I,a,b,f,w,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class P extends L.Disposable{constructor(r,g,s,v,n,t){super();k.set(this,void 0),S.set(this,void 0),y.set(this,void 0),T.set(this,void 0),I.set(this,!1),a.set(this,void 0),b.set(this,void 0),f.set(this,void 0),w.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Oe(this,w,"f").event,E.set(this,this._register(new m.Emitter)),this.onDidDispose=Oe(this,E,"f").event,ot(this,y,s,"f"),ot(this,b,v,"f"),ot(this,k,r,"f"),ot(this,S,g,"f"),ot(this,T,n,"f"),ot(this,a,t,"f")}dispose(){Oe(this,I,"f")||(ot(this,I,!0,"f"),Oe(this,E,"f").fire(),Oe(this,T,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,b,"f")}set title(r){this.assertNotDisposed(),Oe(this,b,"f")!==r&&(ot(this,b,r,"f"),Oe(this,S,"f").$setWebviewViewTitle(Oe(this,k,"f"),r))}get description(){return this.assertNotDisposed(),Oe(this,f,"f")}set description(r){this.assertNotDisposed(),Oe(this,f,"f")!==r&&(ot(this,f,r,"f"),Oe(this,S,"f").$setWebviewViewDescription(Oe(this,k,"f"),r))}get visible(){return Oe(this,a,"f")}get webview(){return Oe(this,T,"f")}get viewType(){return Oe(this,y,"f")}_setVisible(r){r===Oe(this,a,"f")||Oe(this,I,"f")||(ot(this,a,r,"f"),Oe(this,w,"f").fire())}show(r){this.assertNotDisposed(),Oe(this,S,"f").$show(Oe(this,k,"f"),!!r)}assertNotDisposed(){if(Oe(this,I,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,S=new WeakMap,y=new WeakMap,T=new WeakMap,I=new WeakMap,a=new WeakMap,b=new WeakMap,f=new WeakMap,w=new WeakMap,E=new WeakMap;class p{constructor(r,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,g,s,v){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:s,extension:r}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(r),g,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new i.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(r,g,s,v,n){const t=this._viewProviders.get(g);if(!t)throw new Error(`No view provider found for '${g}'`);const{provider:u,extension:d}=t,l=this._extHostWebview.createNewWebview(r,{},d),h=new P(r,this._proxy,g,s,l,!0);this._webviewViews.set(r,h),await u.resolveWebviewView(h,{state:v},n)}async $onDidChangeWebviewViewVisibility(r,g){this.getWebviewView(r)._setVisible(g)}async $disposeWebviewView(r){const g=this.getWebviewView(r);this._webviewViews.delete(r),g.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const g=this._webviewViews.get(r);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=p}),define(ge[133],pe([0,1,3,5,2,10,8,4,14]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let y=class zi{constructor(I){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=zi.InitialState,this._proxy=I.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(a=>this.$onDidChangeWindowFocus(a))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,a){let b;if(typeof I=="string"){b=I;try{I=D.URI.parse(I)}catch(f){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,i.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,b,a)}async asExternalUri(I,a){if((0,i.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this._proxy.$asExternalUri(I,a);return D.URI.from(b)}};y.InitialState={focused:!0},y=Ve([He(0,S.IExtHostRpcService)],y),e.ExtHostWindow=y,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(ge[258],pe([0,1,9,81,32,38,6,5,2,14]),function(Y,e,m,L,D,C,i,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let T=class extends i.Disposable{constructor(a,b){super();const f=a.getProxy(k.MainContext.MainThreadDownloadService);b.registerCommand(!1,"_workbench.downloadResource",async w=>{const E=S.URI.file((0,m.join)((0,L.tmpdir)(),(0,D.generateUuid)()));return await f.$download(w,E),E})}};T=Ve([He(0,y.IExtHostRpcService),He(1,C.IExtHostCommands)],T),e.ExtHostDownloadService=T}),define(ge[259],pe([0,1,131,10,187,32]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class i extends m.ExtHostLoggerService{doCreateLogger(S,y,T){return S.scheme===L.Schemas.file?new D.SpdLogLogger(T?.name||(0,C.generateUuid)(),S.fsPath,!T?.donotRotate,!!T?.donotUseFormatters,y):super.doCreateLogger(S,y,T)}}e.ExtHostLoggerService=i}),define(ge[260],pe([0,1,60,9,2,67,6,10,18,28]),function(Y,e,m,L,D,C,i,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class T extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(s){const v=await super._getWorkspaceStorageURI(s);if(v.scheme!==k.Schemas.file)return v;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${v.fsPath}.`),v;const n=v.fsPath;let t=0;do{let u;t===0?u=n:u=/[/\\]$/.test(n)?`${n.substr(0,n.length-1)}-${t}`:`${n}-${t}`,await I(u);const d=L.join(u,"vscode.lock"),l=await w(this._logService,d,!1);if(l)return this._workspaceStorageLock=l,process.on("exit",()=>{l.dispose()}),D.URI.file(u);t++}while(t<10);return v}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=T;async function I(g){try{await y.Promises.stat(g);return}catch{}try{await y.Promises.mkdir(g,{recursive:!0})}catch{}}const a=1e3,b=10*60*1e3;class f extends i.Disposable{constructor(s,v){super();this.logService=s,this.filename=v,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const n=await E(s,v);(!n||n.pid!==process.pid)&&(s.info(`Lock '${v}': The lock was lost unexpectedly.`),this._timer.cancel());try{await y.Promises.utimes(v,new Date,new Date)}catch(t){s.error(t),s.info(`Lock '${v}': Could not update mtime.`)}},a)}dispose(){super.dispose();try{m.unlinkSync(this.filename)}catch(s){}}async setWillRelease(s){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${s} ms.`);try{const v={pid:process.pid,willReleaseAt:Date.now()+s};await y.Promises.writeFile(this.filename,JSON.stringify(v),{flag:"w"})}catch(v){this.logService.error(v)}}}async function w(g,s,v){try{const t={pid:process.pid,willReleaseAt:0};await y.Promises.writeFile(s,JSON.stringify(t),{flag:"wx"})}catch(t){g.error(t)}const n=await E(g,s);return!n||n.pid!==process.pid?v?(g.info(`Lock '${s}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${s}': Could not acquire lock, checking if the file is stale.`),o(g,s)):(g.info(`Lock '${s}': Lock acquired.`),new f(g,s))}async function E(g,s){let v;try{v=await y.Promises.readFile(s)}catch(n){return g.error(n),null}try{return JSON.parse(String(v))}catch(n){return g.error(n),null}}async function P(g,s){let v;try{v=await y.Promises.stat(s)}catch(n){return g.error(n),0}return v.mtime.getTime()}function p(g){try{return process.kill(g,0),!0}catch(s){return!1}}async function o(g,s){const v=await E(g,s);if(!v)return g.info(`Lock '${s}': Could not read pid of lock holder.`),r(g,s);if(v.willReleaseAt){let l=v.willReleaseAt-Date.now();if(l<5e3){for(l>0?g.info(`Lock '${s}': The lockfile is scheduled to be released in ${l} ms.`):g.info(`Lock '${s}': The lockfile is scheduled to have been released.`);l>0;){if(await(0,S.timeout)(Math.min(100,l)),await P(g,s)===0)return r(g,s);l=v.willReleaseAt-Date.now()}return r(g,s)}}if(!p(v.pid))return g.info(`Lock '${s}': The pid ${v.pid} appears to be gone.`),r(g,s);const n=await P(g,s),t=Date.now()-n;if(t<=b)return g.info(`Lock '${s}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;g.info(`Lock '${s}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const u=await P(g,s),d=Date.now()-u;return d<=b?(g.info(`Lock '${s}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(g.info(`Lock '${s}': The lock looks stale even after waiting for 2s.`),r(g,s))}async function r(g,s){g.info(`Lock '${s}': Deleting a stale lock.`);try{await y.Promises.unlink(s)}catch(v){}return w(g,s,!0)}}),define(ge[261],pe([0,1,32,14,34]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends D.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,S,y){return this.createTerminalFromOptions({name:k,shellPath:S,shellArgs:y})}createTerminalFromOptions(k,S){const y=new D.ExtHostTerminal(this._proxy,(0,m.generateUuid)(),k,k.name);return this._terminals.push(y),y.create(k,this._serializeParentTerminal(k,S)),y.value}};C=Ve([He(0,L.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(ge[262],pe([0,1,5,14,170,6,26,2,37,23,28,7,12,52,3,120,77,11]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class p{constructor(h,c,_){this.remoteAddress=h,this.localAddress=c,this._dispose=_,this._onDispose=new f.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function o(l){const h=l.trim().split(`
`),c=[];return h.forEach(A=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(A);R&&R.length>=3&&c.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),c.reduce((A,R)=>(A[R.socket]=R,A),{})}e.getSockets=o;function r(...l){const h=[].concat(...l.map(s));return[...new Map(h.filter(c=>c.st==="0A").map(c=>{const _=c.local_address.split(":");return{socket:parseInt(c.inode,10),ip:g(_[0]),port:parseInt(_[1],16)}}).map(c=>[c.ip+":"+c.port,c])).values()]}e.loadListeningPorts=r;function g(l){let h="";if(l.length===8)for(let c=l.length-2;c>=0;c-=2)h+=parseInt(l.substr(c,2),16),c!==0&&(h+=".");else for(let c=l.length-4;c>=0;c-=4)h+=parseInt(l.substr(c,4),16).toString(16),c!==0&&(h+=":");return h}e.parseIpAddress=g;function s(l){const h=l.trim().split(`
`),c=h.shift().trim().split(/\s+/).filter(A=>A!=="rx_queue"&&A!=="tm->when");return h.map(A=>A.trim().split(/\s+/).reduce((R,x,O)=>(R[c[O]||O]=x,R),{}))}e.loadConnectionTable=s;function v(l){return!!l.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||l.indexOf("out/vs/server/main.js")!==-1||l.indexOf("_productName=VSCode")!==-1}function n(l){const h=l.trim().split(`
`),c=[];return h.forEach(_=>{const A=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(_);A&&A.length>=4&&c.push({pid:parseInt(A[1],10),ppid:parseInt(A[2]),cmd:A[3]})}),c}e.getRootProcesses=n;async function t(l,h,c){const _=c.reduce((R,x)=>(R[x.pid]=x,R),{}),A=[];return l.forEach(({socket:R,ip:x,port:O})=>{const F=h[R]?h[R].pid:void 0,$=F?_[F]?.cmd:void 0;F&&$&&!v($)&&A.push({host:x,port:O,detail:$,pid:F})}),A}e.findPorts=t;function u(l,h,c){const _=new Map,A=n(h);for(const R of l){const x=c.get(R.port);if(x){_.set(R.port,x);continue}const O=A.find(F=>F.cmd.includes(`${R.port}`));if(O){let F=O,$;do $=A.find(M=>M.ppid===F.pid),$&&(F=$);while($);_.set(R.port,{host:R.ip,port:R.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else _.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return _}e.tryFindRootPorts=u;let d=class extends C.Disposable{constructor(h,c,_){super();this.logService=_,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new f.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=h.getProxy(m.MainContext.MainThreadTunnelService),a.isLinux&&c.remote.isRemote&&c.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(h,c){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${h.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const _=await this._proxy.$openTunnel(c,h.displayName);if(_){const A=new p(_.remoteAddress,_.localAddress,()=>this._proxy.$closeTunnel(_.remoteAddress));return this._register(A),A}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(h){return Math.max(h*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(h,c){const _=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(_,{selector:h,provider:c}),this._proxy.$registerPortsAttributesProvider(h,_),new I.Disposable(()=>{this._portAttributesProviders.delete(_),this._proxy.$unregisterPortsAttributesProvider(_)})}async $providePortAttributes(h,c,_,A,R){const x=[];for(const F of h){const $=this._portAttributesProviders.get(F);if(!$)return[];x.push(...await Promise.all(c.map(async M=>$.provider.providePortAttributes(M,_,A,R))))}const O=x.filter(F=>!!F);return O.length>0?O.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(h){if(h&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=h;let c=new E.MovingAverage,_;for(;this._candidateFindingEnabled;){const A=new Date().getTime(),R=(await this.findCandidatePorts()).filter(O=>(0,w.isLocalhost)(O.host)||(0,w.isAllInterfaces)(O.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(O=>O.port).join(", ")}`);const x=new Date().getTime()-A;c.update(x),(!_||JSON.stringify(_)!==JSON.stringify(R))&&(_=R,await this._proxy.$onFoundNewCandidates(_)),await new Promise(O=>setTimeout(()=>O(),this.calculateDelay(c.value)))}}async setTunnelExtensionFunctions(h){if(h){if(h.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(h.candidatePortSource),h.showCandidatePort&&(this._showCandidatePort=h.showCandidatePort,this._proxy.$setCandidateFilter()),h.tunnelFactory){this._forwardPortProvider=h.tunnelFactory;let c=h.tunnelFeatures?.privacyOptions??[];h.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:D.localize(0,null),themeIcon:"lock"},{id:"public",label:D.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!h.tunnelFeatures?.elevation,public:!!h.tunnelFeatures?.public,privacyOptions:c})}}else this._forwardPortProvider=void 0;return(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(h,c){if(this._extensionTunnels.has(h.host)){const _=this._extensionTunnels.get(h.host);_.has(h.port)&&(c&&_.get(h.port).disposeListener.dispose(),await _.get(h.port).tunnel.dispose(),_.delete(h.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(h,c){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const _=this._forwardPortProvider(h,c);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),_!==void 0){const A=await _;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(h.remoteAddress.host)||this._extensionTunnels.set(h.remoteAddress.host,new Map);const R=this._register(A.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(A.remoteAddress))));return this._extensionTunnels.get(h.remoteAddress.host).set(h.remoteAddress.port,{tunnel:A,disposeListener:R}),b.TunnelDto.fromApiTunnel(A)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(_){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(h){const c=await Promise.all(h.map(A=>this._showCandidatePort(A.host,A.port,A.detail??""))),_=h.filter((A,R)=>c[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${h.map(A=>A.port).join(", ")} to ${_.map(A=>A.port).join(", ")}`),_}async findCandidatePorts(){let h="",c="";try{h=await T.Promises.readFile("/proc/net/tcp","utf8"),c=await T.Promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const _=r(h,c),A=await new Promise(U=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(z,K,N)=>{U(K)})}),R=o(A),x=await T.Promises.readdir("/proc"),O=[];for(let U of x)try{const z=Number(U),K=y.joinPath(k.URI.file("/proc"),U);if((await T.Promises.stat(K.fsPath)).isDirectory()&&!isNaN(z)){const j=await T.Promises.readlink(y.joinPath(K,"cwd").fsPath),H=await T.Promises.readFile(y.joinPath(K,"cmdline").fsPath,"utf8");O.push({pid:z,cwd:j,cmd:H})}}catch(z){}const F=[],$=_.filter(U=>{const z=R[U.socket];return z||F.push(U),z}),M=t($,R,O);let B;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const U=await new Promise(z=>{(0,S.exec)("ps -F -A -l | grep root",(K,N,j)=>{z(N)})});this._foundRootPorts=u(F,U,this._foundRootPorts),B=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${B.join(", ")}`)}return M.then(U=>B?U.concat(B):U)}};d=Ve([He(0,L.IExtHostRpcService),He(1,i.IExtHostInitDataService),He(2,P.ILogService)],d),e.ExtHostTunnelService=d}),define(ge[263],pe([0,1,18,22,21,15,3,6,102,227,53]),function(Y,e,m,L,D,C,i,k,S,y,T){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function a(_,A){try{return JSON.stringify(_,A)}catch(R){return"null"}}const b="$$ref$$",f={[b]:-1};class w{constructor(A,R){this.jsonString=A,this.referencedBuffers=R}}function E(_,A=null,R=!1){const x=[];return{jsonString:(R?a:JSON.stringify)(_,(F,$)=>{if(typeof $=="undefined")return f;if(typeof $=="object"){if($ instanceof L.VSBuffer){const M=x.push($)-1;return{[b]:M}}if(A)return A(F,$)}return $}),referencedBuffers:x}}e.stringifyJsonWithBufferRefs=E;function P(_,A,R){return JSON.parse(_,(x,O)=>{if(O){const F=O[b];if(typeof F=="number")return A[F];if(R&&O.$mid===1)return R.transformIncoming(O)}return O})}e.parseJsonAndRestoreBufferRefs=P;function p(_,A){return JSON.stringify(_,A)}function o(_){return _?(A,R)=>R&&R.$mid===1?_.transformOutgoing(R):R:null}var r;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(r=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(_){_[_.Responsive=0]="Responsive",_[_.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},v=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class t extends k.Disposable{constructor(A,R=null,x=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new i.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=A,this._logger=R,this._uriTransformer=x,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let O=0,F=T.ProxyIdentifier.count;O<F;O++)this._locals[O]=null,this._proxies[O]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(O=>this._receiveOneMessage(O))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(A=>{this._pendingRPCReplies[A].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(A){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(A){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(A){this._responsiveState!==A&&(this._responsiveState=A,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(A){return this._uriTransformer?(0,S.transformIncomingURIs)(A,this._uriTransformer):A}getProxy(A){const{nid:R,sid:x}=A;return this._proxies[R]||(this._proxies[R]=this._createProxy(R,x)),this._proxies[R]}_createProxy(A,R){let x={get:(O,F)=>(typeof F=="string"&&!O[F]&&F.charCodeAt(0)===36&&(O[F]=(...$)=>this._remoteCall(A,F,$)),F===n?R:O[F])};return new Proxy(Object.create(null),x)}set(A,R){return this._locals[A.nid]=R,R}assertRegistered(A){for(let R=0,x=A.length;R<x;R++){const O=A[R];if(!this._locals[O.nid])throw new Error(`Missing actor ${O.sid} (isMain: ${O.isMain})`)}}_receiveOneMessage(A){if(this._isDisposed)return;const R=A.byteLength,x=u.read(A,0),O=x.readUInt8(),F=x.readUInt32();switch(O){case 1:case 2:{let{rpcId:$,method:M,args:B}=l.deserializeRequestJSONArgs(x);this._uriTransformer&&(B=(0,S.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(R,F,$,M,B,O===2);break}case 3:case 4:{let{rpcId:$,method:M,args:B}=l.deserializeRequestMixedArgs(x);this._uriTransformer&&(B=(0,S.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(R,F,$,M,B,O===4);break}case 5:{this._logger&&this._logger.logIncoming(R,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(R,F);break}case 7:{this._receiveReply(R,F,void 0);break}case 9:{let $=l.deserializeReplyOKJSON(x);this._uriTransformer&&($=(0,S.transformIncomingURIs)($,this._uriTransformer)),this._receiveReply(R,F,$);break}case 10:{const $=l.deserializeReplyOKJSONWithBuffers(x,this._uriTransformer);this._receiveReply(R,F,$);break}case 8:{let $=l.deserializeReplyOKVSBuffer(x);this._receiveReply(R,F,$);break}case 11:{let $=l.deserializeReplyErrError(x);this._uriTransformer&&($=(0,S.transformIncomingURIs)($,this._uriTransformer)),this._receiveReplyErr(R,F,$);break}case 12:{this._receiveReplyErr(R,F,void 0);break}default:console.error("received unexpected message"),console.error(A)}}_receiveRequest(A,R,x,O,F,$){this._logger&&this._logger.logIncoming(A,R,1,`receiveRequest ${(0,T.getStringIdentifierForProxy)(x)}.${O}(`,F);const M=String(R);let B,U;if($){const K=new D.CancellationTokenSource;F.push(K.token),B=this._invokeHandler(x,O,F),U=()=>K.cancel()}else B=this._invokeHandler(x,O,F),U=s;this._cancelInvokedHandlers[M]=U;const z=l.serializeAcknowledged(R);this._logger&&this._logger.logOutgoing(z.byteLength,R,1,"ack"),this._protocol.send(z),B.then(K=>{delete this._cancelInvokedHandlers[M];const N=l.serializeReplyOK(R,K,this._uriReplacer);this._logger&&this._logger.logOutgoing(N.byteLength,R,1,"reply:",K),this._protocol.send(N)},K=>{delete this._cancelInvokedHandlers[M];const N=l.serializeReplyErr(R,K);this._logger&&this._logger.logOutgoing(N.byteLength,R,1,"replyErr:",K),this._protocol.send(N)})}_receiveCancel(A,R){this._logger&&this._logger.logIncoming(A,R,1,"receiveCancel");const x=String(R);this._cancelInvokedHandlers[x]&&this._cancelInvokedHandlers[x]()}_receiveReply(A,R,x){this._logger&&this._logger.logIncoming(A,R,0,"receiveReply:",x);const O=String(R);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const F=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O],F.resolveOk(x)}_receiveReplyErr(A,R,x){this._logger&&this._logger.logIncoming(A,R,0,"receiveReplyErr:",x);const O=String(R);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const F=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O];let $;x&&(x.$isError?($=new Error,$.name=x.name,$.message=x.message,$.stack=x.stack):$=x),F.resolveErr($)}_invokeHandler(A,R,x){try{return Promise.resolve(this._doInvokeHandler(A,R,x))}catch(O){return Promise.reject(O)}}_doInvokeHandler(A,R,x){const O=this._locals[A];if(!O)throw new Error("Unknown actor "+(0,T.getStringIdentifierForProxy)(A));let F=O[R];if(typeof F!="function")throw new Error("Unknown method "+R+" on actor "+(0,T.getStringIdentifierForProxy)(A));return F.apply(O,x)}_remoteCall(A,R,x){if(this._isDisposed)return Promise.reject(C.canceled());let O=null;if(x.length>0&&D.CancellationToken.isCancellationToken(x[x.length-1])&&(O=x.pop()),O&&O.isCancellationRequested)return Promise.reject(C.canceled());const F=l.serializeRequestArguments(x,this._uriReplacer),$=++this._lastMessageId,M=String($),B=new y.LazyPromise;O&&O.onCancellationRequested(()=>{const z=l.serializeCancel($);this._logger&&this._logger.logOutgoing(z.byteLength,$,0,"cancel"),this._protocol.send(l.serializeCancel($))}),this._pendingRPCReplies[M]=B,this._onWillSendRequest($);const U=l.serializeRequest($,A,R,F,!!O);return this._logger&&this._logger.logOutgoing(U.byteLength,$,0,`request: ${(0,T.getStringIdentifierForProxy)(A)}.${R}(`,x),this._protocol.send(U),B}}e.RPCProtocol=t,I=v,t.UNRESPONSIVE_TIME=3*1e3;class u{constructor(A,R){this._buff=A,this._offset=R}static alloc(A,R,x){let O=new u(L.VSBuffer.alloc(x+1+4),0);return O.writeUInt8(A),O.writeUInt32(R),O}static read(A,R){return new u(A,R)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(A){this._buff.writeUInt8(A,this._offset),this._offset+=1}readUInt8(){const A=this._buff.readUInt8(this._offset);return this._offset+=1,A}writeUInt32(A){this._buff.writeUInt32BE(A,this._offset),this._offset+=4}readUInt32(){const A=this._buff.readUInt32BE(this._offset);return this._offset+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this._buff.writeUInt8(A.byteLength,this._offset),this._offset+=1,this._buff.set(A,this._offset),this._offset+=A.byteLength}readShortString(){const A=this._buff.readUInt8(this._offset);this._offset+=1;const x=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,x}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readLongString(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const x=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,x}writeBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readVSBuffer(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+A);return this._offset+=A,R}static sizeMixedArray(A){let R=0;R+=1;for(let x=0,O=A.length;x<O;x++){const F=A[x];switch(R+=1,F.type){case 1:R+=this.sizeLongString(F.value);break;case 2:R+=this.sizeVSBuffer(F.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(F.value);for(let $=0;$<F.buffers.length;++$)R+=this.sizeVSBuffer(F.buffers[$]);break;case 4:break}}return R}writeMixedArray(A){this._buff.writeUInt8(A.length,this._offset),this._offset+=1;for(let R=0,x=A.length;R<x;R++){const O=A[R];switch(O.type){case 1:this.writeUInt8(1),this.writeLongString(O.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(O.value);break;case 3:this.writeUInt8(3),this.writeUInt32(O.buffers.length),this.writeLongString(O.value);for(let F=0;F<O.buffers.length;++F)this.writeBuffer(O.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this._buff.readUInt8(this._offset);this._offset+=1;let R=new Array(A);for(let x=0;x<A;x++)switch(this.readUInt8()){case 1:R[x]=this.readLongString();break;case 2:R[x]=this.readVSBuffer();break;case 3:const F=this.readUInt32(),$=this.readLongString(),M=[];for(let B=0;B<F;++B)M.push(this.readVSBuffer());R[x]=new T.SerializableObjectWithBuffers(P($,M,null));break;case 4:R[x]=void 0;break}return R}}u.sizeUInt32=4;var d;(function(_){_[_.Simple=0]="Simple",_[_.Mixed=1]="Mixed"})(d||(d={}));class l{static _useMixedArgSerialization(A){for(let R=0,x=A.length;R<x;R++)if(A[R]instanceof L.VSBuffer||A[R]instanceof T.SerializableObjectWithBuffers||typeof A[R]=="undefined")return!0;return!1}static serializeRequestArguments(A,R){if(this._useMixedArgSerialization(A)){const x=[];for(let O=0,F=A.length;O<F;O++){const $=A[O];if($ instanceof L.VSBuffer)x[O]={type:2,value:$};else if(typeof $=="undefined")x[O]={type:4};else if($ instanceof T.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:B}=E($.value,R);x[O]={type:3,value:L.VSBuffer.fromString(M),buffers:B}}else x[O]={type:1,value:L.VSBuffer.fromString(p($,R))}}return{type:1,args:x}}return{type:0,args:p(A,R)}}static serializeRequest(A,R,x,O,F){switch(O.type){case 0:return this._requestJSONArgs(A,R,x,O.args,F);case 1:return this._requestMixedArgs(A,R,x,O.args,F)}}static _requestJSONArgs(A,R,x,O,F){const $=L.VSBuffer.fromString(x),M=L.VSBuffer.fromString(O);let B=0;B+=u.sizeUInt8(),B+=u.sizeShortString($),B+=u.sizeLongString(M);let U=u.alloc(F?2:1,A,B);return U.writeUInt8(R),U.writeShortString($),U.writeLongString(M),U.buffer}static deserializeRequestJSONArgs(A){const R=A.readUInt8(),x=A.readShortString(),O=A.readLongString();return{rpcId:R,method:x,args:JSON.parse(O)}}static _requestMixedArgs(A,R,x,O,F){const $=L.VSBuffer.fromString(x);let M=0;M+=u.sizeUInt8(),M+=u.sizeShortString($),M+=u.sizeMixedArray(O);let B=u.alloc(F?4:3,A,M);return B.writeUInt8(R),B.writeShortString($),B.writeMixedArray(O),B.buffer}static deserializeRequestMixedArgs(A){const R=A.readUInt8(),x=A.readShortString(),O=A.readMixedArray(),F=new Array(O.length);for(let $=0,M=O.length;$<M;$++){const B=O[$];typeof B=="string"?F[$]=JSON.parse(B):F[$]=B}return{rpcId:R,method:x,args:F}}static serializeAcknowledged(A){return u.alloc(5,A,0).buffer}static serializeCancel(A){return u.alloc(6,A,0).buffer}static serializeReplyOK(A,R,x){if(typeof R=="undefined")return this._serializeReplyOKEmpty(A);if(R instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(A,R);if(R instanceof T.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:F}=E(R.value,x,!0);return this._serializeReplyOKJSONWithBuffers(A,O,F)}else return this._serializeReplyOKJSON(A,a(R,x))}static _serializeReplyOKEmpty(A){return u.alloc(7,A,0).buffer}static _serializeReplyOKVSBuffer(A,R){let x=0;x+=u.sizeVSBuffer(R);let O=u.alloc(8,A,x);return O.writeVSBuffer(R),O.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static _serializeReplyOKJSON(A,R){const x=L.VSBuffer.fromString(R);let O=0;O+=u.sizeLongString(x);let F=u.alloc(9,A,O);return F.writeLongString(x),F.buffer}static _serializeReplyOKJSONWithBuffers(A,R,x){const O=L.VSBuffer.fromString(R);let F=0;F+=u.sizeUInt32,F+=u.sizeLongString(O);for(const M of x)F+=u.sizeVSBuffer(M);let $=u.alloc(10,A,F);$.writeUInt32(x.length),$.writeLongString(O);for(const M of x)$.writeBuffer(M);return $.buffer}static deserializeReplyOKJSON(A){const R=A.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(A,R){const x=A.readUInt32(),O=A.readLongString(),F=[];for(let $=0;$<x;++$)F.push(A.readVSBuffer());return new T.SerializableObjectWithBuffers(P(O,F,R))}static serializeReplyErr(A,R){return R?this._serializeReplyErrEror(A,R):this._serializeReplyErrEmpty(A)}static _serializeReplyErrEror(A,R){const x=L.VSBuffer.fromString(a(C.transformErrorForSerialization(R),null));let O=0;O+=u.sizeLongString(x);let F=u.alloc(11,A,O);return F.writeLongString(x),F.buffer}static deserializeReplyErrError(A){const R=A.readLongString();return JSON.parse(R)}static _serializeReplyErrEmpty(A){return u.alloc(12,A,0).buffer}}var h;(function(_){_[_.RequestJSONArgs=1]="RequestJSONArgs",_[_.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",_[_.RequestMixedArgs=3]="RequestMixedArgs",_[_.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",_[_.Acknowledged=5]="Acknowledged",_[_.Cancel=6]="Cancel",_[_.ReplyOKEmpty=7]="ReplyOKEmpty",_[_.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",_[_.ReplyOKJSON=9]="ReplyOKJSON",_[_.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",_[_.ReplyErrError=11]="ReplyErrError",_[_.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var c;(function(_){_[_.String=1]="String",_[_.VSBuffer=2]="VSBuffer",_[_.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",_[_.Undefined=4]="Undefined"})(c||(c={}))}),define(ge[264],pe([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,m.createDecorator)("remoteAgentService")}),define(ge[265],pe([0,1,10,9,12,2,4,62,43,222,264]),function(Y,e,m,L,D,C,i,k,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,i.createDecorator)("pathService");let I=class Vi{constructor(b,f,w,E){this.localUserHome=b,this.remoteAgentService=f,this.environmentService=w,this.contextService=E,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||D.OS)(),this.resolveUserHome=(async()=>{const P=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=P?.userHome||b})()}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(b,f){if(b.remoteAuthority)return m.Schemas.vscodeRemote;const w=(0,k.getVirtualWorkspaceScheme)(f.getWorkspace());if(w)return w;const E=f.getWorkspace().folders[0];if(E)return E.uri.scheme;const P=f.getWorkspace().configuration;return P?P.scheme:m.Schemas.file}async userHome(b){return b?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(b=>b===1?L.win32:L.posix)}async fileURI(b){let f="";if(await this.resolveOS===1&&(b=b.replace(/\\/g,"/")),b[0]==="/"&&b[1]==="/"){const E=b.indexOf("/",2);E===-1?(f=b.substring(2),b="/"):(f=b.substring(2,E),b=b.substring(E)||"/")}return C.URI.from({scheme:m.Schemas.file,authority:f,path:b,query:"",fragment:""})}};I=Ve([He(1,T.IRemoteAgentService),He(2,y.IWorkbenchEnvironmentService),He(3,S.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(ge[69],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(i,k){this.line=i,this.character=k}isBefore(i){return!1}isBeforeOrEqual(i){return!1}isAfter(i){return!1}isAfterOrEqual(i){return!1}isEqual(i){return!1}compareTo(i){return 0}translate(i,k){return new m(0,0)}with(i){return new m(0,0)}}e.Position=m;class L{constructor(i,k,S,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(i,k),this.end=new m(S,y)}contains(i){return!1}isEqual(i){return!1}intersection(i){}union(i){return new L(0,0,0,0)}with(i){return new L(0,0,0,0)}}e.Range=L;var D;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ge[33],pe([0,1,17,31,25,30,8,4,9,15,69,13]),function(Y,e,m,L,D,C,i,k,S,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const a="\u27EA ",b=" characters skipped \u27EB",f=(a.length+b.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var w;(function(z){z[z.file=0]="file",z[z.text=1]="text"})(w=e.SearchProviderType||(e.SearchProviderType={}));var E;(function(z){z[z.File=1]="File",z[z.Text=2]="Text"})(E=e.QueryType||(e.QueryType={}));function P(z){return!!z.preview}e.resultIsMatch=P;function p(z){return!!z.resource}e.isFileMatch=p;function o(z){return!!z.message}e.isProgressMessage=o;var r;(function(z){z[z.Normal=0]="Normal",z[z.NewSearchStarted=1]="NewSearchStarted"})(r=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(K){this.resource=K,this.results=[]}}e.FileMatch=g;class s{constructor(K,N,j){this.ranges=N;const H=Array.isArray(N)?N:[N];if(j&&j.matchLines===1&&v(H)){K=(0,i.getNLines)(K,j.matchLines);let V="",q=0,te=0;const fe=Math.floor(j.charsPerLine/5),Ce=[];for(const ke of H){const Ue=Math.max(ke.startColumn-fe,0),xe=ke.startColumn+j.charsPerLine;if(Ue>te+fe+f){const ze=a+(Ue-te)+b;V+=ze+K.slice(Ue,xe),q+=Ue-(te+ze.length)}else V+=K.slice(te,xe);Ce.push(new t(0,ke.startColumn-q,ke.endColumn-q)),te=xe}this.preview={text:V,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const V=Array.isArray(N)?N[0].startLineNumber:N.startLineNumber;this.preview={text:K,matches:(0,m.mapArrayOrNot)(N,q=>new n(q.startLineNumber-V,q.startColumn,q.endLineNumber-V,q.endColumn))}}}}e.TextSearchMatch=s;function v(z){const K=z[0].startLineNumber;for(const N of z)if(N.startLineNumber!==K||N.endLineNumber!==K)return!1;return!0}class n{constructor(K,N,j,H){this.startLineNumber=K,this.startColumn=N,this.endLineNumber=j,this.endColumn=H}}e.SearchRange=n;class t extends n{constructor(K,N,j){super(K,N,K,j)}}e.OneLineRange=t;var u;(function(z){z.Default="default",z.FileNames="fileNames",z.Type="type",z.Modified="modified",z.CountDescending="countDescending",z.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function d(z,K=!0){const N=z&&z.files&&z.files.exclude,j=K&&z&&z.search&&z.search.exclude;if(!N&&!j)return;if(!N||!j)return N||j;let H=Object.create(null);return H=D.mixin(H,D.deepClone(N)),H=D.mixin(H,D.deepClone(j),!0),H}e.getExcludes=d;function l(z,K){return z.excludePattern&&L.match(z.excludePattern,K)?!1:z.includePattern||z.usingSearchPaths?z.includePattern&&L.match(z.includePattern,K)?!0:z.usingSearchPaths?!!z.folderQueries&&z.folderQueries.some(N=>{const j=N.folder.fsPath;if(C.isEqualOrParent(K,j)){const H=S.relative(j,K);return!N.includePattern||!!L.match(N.includePattern,H)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var h;(function(z){z[z.unknownEncoding=1]="unknownEncoding",z[z.regexParseError=2]="regexParseError",z[z.globParseError=3]="globParseError",z[z.invalidLiteral=4]="invalidLiteral",z[z.rgProcessError=5]="rgProcessError",z[z.other=6]="other",z[z.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class c extends Error{constructor(K,N){super(K);this.code=N}}e.SearchError=c;function _(z){const K=z.message;if((0,y.isPromiseCanceledError)(z))return new c(K,h.canceled);try{const N=JSON.parse(K);return new c(N.message,N.code)}catch(N){return new c(K,h.other)}}e.deserializeSearchError=_;function A(z){const K={message:z.message,code:z.code};return new Error(JSON.stringify(K))}e.serializeSearchError=A;function R(z){return z.type==="error"?!0:z.type==="success"}e.isSerializedSearchComplete=R;function x(z){return z.type==="success"}e.isSerializedSearchSuccess=x;function O(z){return!!z.path}e.isSerializedFileMatch=O;function F(z,K){const N=z.searchPath?z.searchPath:z.relativePath;return(0,i.fuzzyContains)(N,K)}e.isFilePatternMatch=F;class ${constructor(K){this.path=K,this.results=[]}addMatch(K){this.results.push(K)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=$;function M(z,K){const N={...z||{},...K||{}};return Object.keys(N).filter(j=>{const H=N[j];return typeof H=="boolean"&&H})}e.resolvePatternsForProvider=M;class B{constructor(K,N){this._parsedIncludeExpression=null,this._excludeExpression={...K.excludePattern||{},...N.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let j=K.includePattern;N.includePattern&&(j?j={...j,...N.includePattern}:j=N.includePattern),j&&(this._parsedIncludeExpression=L.parse(j))}matchesExcludesSync(K,N,j){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(K,N,j))}includedInQuerySync(K,N,j){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(K,N,j)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(K,N,j))}includedInQuery(K,N,j){const H=this._parsedExcludeExpression(K,N,j),V=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(K,N,j):!0;return(0,I.isPromise)(H)?H.then(q=>q?!1:V()):V()}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=B;function U(z){for(const K in z)if(typeof z[K]!="boolean")return!0;return!1}}),define(ge[35],pe([0,1,17,18,21,3,24,10,77,23,8,13,2,168,4,11,188,43,44,26,14,7,33,5]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E,P,p,o,r,g,s,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function n(A,R,x){return new y.ExtUri(O=>l(O,x)).isEqual(A,R)}function t(A,R,x){return n(A.uri,R.uri,x)?0:(0,T.compare)(A.uri.toString(),R.uri.toString())}function u(A,R,x){return A.index!==R.index?A.index<R.index?-1:1:n(A.uri,R.uri,x)?(0,T.compare)(A.name,R.name):(0,T.compare)(A.uri.toString(),R.uri.toString())}function d(A,R,x,O){const F=A.slice(0).sort((M,B)=>x(M,B,O)),$=R.slice(0).sort((M,B)=>x(M,B,O));return(0,m.delta)(F,$,(M,B)=>x(M,B,O))}function l(A,R){const x=R.getCapabilities(A.scheme);return!(x&&x&1024)}class h extends P.Workspace{constructor(R,x,O,F,$,M,B){super(R,O.map(U=>new P.WorkspaceFolder(U)),F,$,B);this._name=x,this._isUntitled=M,this._workspaceFolders=[],this._structure=i.TernarySearchTree.forUris(B),O.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(R,x,O,F){if(!R)return{workspace:null,added:[],removed:[]};const{id:$,name:M,folders:B,configuration:U,transient:z,isUntitled:K}=R,N=[],j=x;x?B.forEach((te,fe)=>{const Ce=a.URI.revive(te.uri),ke=h._findFolder(O||x,Ce,F);ke?(ke.name=te.name,ke.index=te.index,N.push(ke)):N.push({uri:Ce,name:te.name,index:fe})}):N.push(...B.map(({uri:te,name:fe,index:Ce})=>({uri:a.URI.revive(te),name:fe,index:Ce}))),N.sort((te,fe)=>te.index<fe.index?-1:1);const H=new h($,M,N,!!z,U?a.URI.revive(U):null,!!K,te=>l(te,F)),{added:V,removed:q}=d(j?j.workspaceFolders:[],H.workspaceFolders,t,F);return{workspace:H,added:V,removed:q}}static _findFolder(R,x,O){for(let F=0;F<R.folders.length;F++){const $=R.workspaceFolders[F];if(n($.uri,x,O))return $}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,x){return x&&this._structure.get(R)&&(R=(0,y.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let c=class{constructor(R,x,O,F){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=F,this._extHostFileSystemInfo=O,this._requestIdProvider=new S.Counter,this._barrier=new L.Barrier,this._proxy=R.getProxy(v.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(v.MainContext.MainThreadMessageService);const $=x.workspace;this._confirmedWorkspace=$?new h($.id,$.name,[],!!$.transient,$.configuration?a.URI.revive($.configuration):null,!!$.isUntitled,M=>l(M,O)):void 0}$initializeWorkspace(R,x){this._trusted=x,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?a.URI.from({scheme:k.Schemas.untitled,path:(0,y.basename)((0,y.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,x,O,...F){const $=[];if(Array.isArray(F)&&F.forEach(K=>{a.URI.isUri(K.uri)&&!$.some(N=>n(N.uri,K.uri,this._extHostFileSystemInfo))&&$.push({uri:K.uri,name:K.name||(0,y.basenameOrAuthority)(K.uri)})}),this._unconfirmedWorkspace||[x,O].some(K=>typeof K!="number"||K<0)||O===0&&$.length===0)return!1;const M=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(x+O>M.length)return!1;const B=M.slice(0);B.splice(x,O,...$.map(K=>({uri:K.uri,name:K.name||(0,y.basenameOrAuthority)(K.uri),index:void 0})));for(let K=0;K<B.length;K++){const N=B[K];if(B.some((j,H)=>H!==K&&n(N.uri,j.uri,this._extHostFileSystemInfo)))return!1}B.forEach((K,N)=>K.index=N);const{added:U,removed:z}=d(M,B,u,this._extHostFileSystemInfo);if(U.length===0&&z.length===0)return!1;if(this._proxy){const K=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(K,x,O,$).then(void 0,N=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(E.Severity.Error,(0,b.localize)(0,null,K,N.toString()),{extension:R},[])})}return this.trySetWorkspaceFolders(B),!0}getWorkspaceFolder(R,x){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,x)}async getWorkspaceFolder2(R,x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,x)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,x){let O,F="";if(typeof R=="string"?(O=a.URI.file(R),F=R):typeof R!="undefined"&&(O=R,F=R.fsPath),!O)return F;const $=this.getWorkspaceFolder(O,!0);if(!$)return F;typeof x=="undefined"&&this._actualWorkspace&&(x=this._actualWorkspace.folders.length>1);let M=(0,y.relativePath)($.uri,O);return x&&$.name&&(M=`${$.name}/${M}`),M}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=h.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:x,added:O,removed:F}=h.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=x||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:F}))}findFiles(R,x,O,F,$=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let M;if(x===null?M=!1:x&&(typeof x=="string"?M=x:M=x.pattern),$&&$.isCancellationRequested)return Promise.resolve([]);const{includePattern:B,folder:U}=_(R);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(B),(0,I.withUndefinedAsNull)(U),(0,I.withUndefinedAsNull)(M),(0,I.withUndefinedAsNull)(O),$).then(z=>Array.isArray(z)?z.map(K=>a.URI.revive(K)):[])}async findTextInFiles(R,x,O,F,$=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const M=this._requestIdProvider.getNext(),B=typeof x.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,{includePattern:U,folder:z}=_(x.include),K=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,N={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:B,afterContext:x.afterContext,beforeContext:x.beforeContext,includePattern:U,excludePattern:K},j=!1;if(this._activeSearchCallbacks[M]=H=>{if(j)return;const V=a.URI.revive(H.resource);H.results.forEach(q=>{(0,s.resultIsMatch)(q)?O({uri:V,preview:{text:q.preview.text,matches:(0,m.mapArrayOrNot)(q.preview.matches,te=>new g.Range(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))},ranges:(0,m.mapArrayOrNot)(q.ranges,te=>new g.Range(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))}):O({uri:V,text:q.text,lineNumber:q.lineNumber})})},$.isCancellationRequested)return{};try{const H=await this._proxy.$startTextSearch(R,(0,I.withUndefinedAsNull)(z),N,M,$);return delete this._activeSearchCallbacks[M],H||{}}catch(H){throw delete this._activeSearchCallbacks[M],H}}$handleTextSearchResult(R,x){this._activeSearchCallbacks[x]&&this._activeSearchCallbacks[x](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};c=Ve([He(0,r.IExtHostRpcService),He(1,o.IExtHostInitDataService),He(2,p.IExtHostFileSystemInfo),He(3,w.ILogService)],c),e.ExtHostWorkspace=c,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function _(A){let R,x;return A&&(typeof A=="string"?R=A:(R=A.pattern,x=A.baseFolder||a.URI.file(A.base))),{includePattern:R,folder:x}}}),define(ge[36],pe([0,1,25,3,35,5,7,192,118,13,18,4,14,11,2]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function w(v,n){if(n){const t=n.split(".");let u=v;for(let d=0;u&&d<t.length;d++)u=u[t[d]];return u}}function E(v){return v instanceof f.URI}function P(v){return v&&v.uri instanceof f.URI&&v.languageId&&typeof v.languageId=="string"}function p(v){return v&&!v.uri&&v.languageId&&typeof v.languageId=="string"}function o(v){return v&&v.uri instanceof f.URI&&(!v.name||typeof v.name=="string")&&(!v.index||typeof v.index=="number")}function r(v){if(E(v))return{resource:v};if(P(v))return{resource:v.uri,overrideIdentifier:v.languageId};if(p(v))return{overrideIdentifier:v.languageId};if(o(v))return{resource:v.uri};if(v===null)return{resource:null}}let g=class{constructor(n,t,u){this._proxy=n.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=u,this._barrier=new T.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new s(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,t){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(n,t))}};g=Ve([He(0,a.IExtHostRpcService),He(1,D.IExtHostWorkspace),He(2,b.ILogService)],g),e.ExtHostConfiguration=g;class s{constructor(n,t,u,d){this._onDidChangeConfiguration=new L.Emitter,this._proxy=n,this._logService=d,this._extHostWorkspace=t,this._configuration=k.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,t){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,u))}getConfiguration(n,t,u){const d=r(t)||{},l=this._toReadonlyValue(n?w(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,d,u?.identifier);function h(_){if(_==null)return null;if(typeof _=="boolean")return _?1:4;switch(_){case i.ConfigurationTarget.Global:return 1;case i.ConfigurationTarget.Workspace:return 4;case i.ConfigurationTarget.WorkspaceFolder:return 5}}const c={has(_){return typeof w(l,_)!="undefined"},get:(_,A)=>{this._validateConfigurationAccess(n?`${n}.${_}`:_,d,u?.identifier);let R=w(l,_);if(typeof R=="undefined")R=A;else{let x;const O=(F,$)=>{let M;const B=()=>{x=x||(0,m.deepClone)(l),M=M||w(x,$)};return(0,y.isObject)(F)?new Proxy(F,{get:(U,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return B(),()=>M;if(x)return M=M||w(x,$),M[z];const K=U[z];return typeof z=="string"?O(K,`${$}.${z}`):K},set:(U,z,K)=>(B(),M&&(M[z]=K),!0),deleteProperty:(U,z)=>(B(),M&&delete M[z],!0),defineProperty:(U,z,K)=>(B(),M&&Object.defineProperty(M,z,K),!0)}):F};R=O(R,_)}return R},update:(_,A,R,x)=>{_=n?`${n}.${_}`:_;const O=h(R);return A!==void 0?this._proxy.$updateConfigurationOption(O,_,A,d,x):this._proxy.$removeConfigurationOption(O,_,d,x)},inspect:_=>{_=n?`${n}.${_}`:_;const A=(0,m.deepClone)(this._configuration.inspect(_,d,this._extHostWorkspace.workspace));if(A)return{key:_,defaultValue:A.default?.value,globalValue:A.user?.value,workspaceValue:A.workspace?.value,workspaceFolderValue:A.workspaceFolder?.value,defaultLanguageValue:A.default?.override,globalLanguageValue:A.user?.override,workspaceLanguageValue:A.workspace?.override,workspaceFolderLanguageValue:A.workspaceFolder?.override,languageIds:A.overrideIdentifiers}}};return typeof l=="object"&&(0,m.mixin)(c,l,!1),Object.freeze(c)}_toReadonlyValue(n){const t=u=>(0,y.isObject)(u)?new Proxy(u,{get:(d,l)=>t(d[l]),set:(d,l,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(d,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(d,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return t(n)}_validateConfigurationAccess(n,t,u){const d=S.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),l=u?`[${u.value}] `:"";if(d===4){typeof t?.resource=="undefined"&&this._logService.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){t?.resource&&this._logService.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,t){const u=new k.ConfigurationChangeEvent(n,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,l)=>u.affectsConfiguration(d,r(l))})}_toMap(n){return n.reduce((t,u)=>(t.set(u[0],u[1]),t),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[70],pe([0,1,2,18,3,5,7,35,45,36,21,34,14,26,4,10,12,11,65,212,15]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E,P,p,o,r){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var s;(function($){function M(U){if(U!=null)return U}$.from=M;function B(U){if(U!=null)return U}$.to=B})(s=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var v;(function($){function M(U){if(U!=null)return U}$.from=M;function B(U){if(U!=null)return U}$.to=B})(v=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function($){function M(U){if(U!=null)return U}$.from=M;function B(U){if(U!=null)return U}$.to=B})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function($){function M(z){if(z){const K=z;return K&&!!K.process}else return!1}$.is=M;function B(z){if(z==null)return;const K={process:z.process,args:z.args};return z.options&&(K.options=n.from(z.options)),K}$.from=B;function U(z){if(z!=null)return new i.ProcessExecution(z.process,z.args,z.options)}$.to=U})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function($){function M(U){if(U!=null)return U}$.from=M;function B(U){if(U!=null)return U}$.to=B})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function($){function M(z){if(z){const K=z;return K&&(!!K.commandLine||!!K.command)}else return!1}$.is=M;function B(z){if(z==null)return;const K={};return z.commandLine!==void 0?K.commandLine=z.commandLine:(K.command=z.command,K.args=z.args),z.options&&(K.options=u.from(z.options)),K}$.from=B;function U(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new i.ShellExecution(z.commandLine,z.options):new i.ShellExecution(z.command,z.args?z.args:[],z.options)}$.to=U})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var l;(function($){function M(z){if(z){let K=z;return K&&K.customExecution==="customExecution"}else return!1}$.is=M;function B(z){return{customExecution:"customExecution"}}$.from=B;function U(z,K){return K.get(z)}$.to=U})(l=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function($){function M(B,U){let z;return B.scope!==void 0&&typeof B.scope!="number"?z=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===i.TaskScope.Workspace&&U&&U.workspaceFile?z=U.workspaceFile:z=o.USER_TASKS_GROUP_KEY),{id:B._id,workspaceFolder:z}}$.from=M})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var c;(function($){function M(B){if(B!=null)return{_id:B.id,isDefault:B.isDefault}}$.from=M})(c=e.TaskGroupDTO||(e.TaskGroupDTO={}));var _;(function($){function M(z,K){if(z==null)return[];const N=[];for(let j of z){const H=B(j,K);H&&N.push(H)}return N}$.fromMany=M;function B(z,K){if(z==null)return;let N;z.execution instanceof i.ProcessExecution?N=t.from(z.execution):z.execution instanceof i.ShellExecution?N=d.from(z.execution):z.execution&&z.execution instanceof i.CustomExecution&&(N=l.from(z.execution));const j=s.from(z.definition);let H;return z.scope?typeof z.scope=="number"?H=z.scope:H=z.scope.uri:H=i.TaskScope.Workspace,!j||!H?void 0:{_id:z._id,definition:j,name:z.name,source:{extensionId:K.identifier.value,label:z.source,scope:H},execution:N,isBackground:z.isBackground,group:c.from(z.group),presentationOptions:v.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}$.from=B;async function U(z,K,N){if(z==null)return;let j;t.is(z.execution)?j=t.to(z.execution):d.is(z.execution)?j=d.to(z.execution):l.is(z.execution)&&(j=l.to(z._id,N));const H=s.to(z.definition);let V;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?V=z.source.scope:V=await K.resolveWorkspaceFolder(m.URI.revive(z.source.scope)):V=i.TaskScope.Workspace),!H||!V)return;const q=new i.Task(H,V,z.name,z.source.label,j,z.problemMatchers);return z.isBackground!==void 0&&(q.isBackground=z.isBackground),z.group!==void 0&&(q.group=i.TaskGroup.from(z.group._id),q.group&&z.group.isDefault&&(q.group=new i.TaskGroup(q.group.id,q.group.label),z.group.isDefault&&(q.group.isDefault=z.group.isDefault))),z.presentationOptions&&(q.presentationOptions=v.to(z.presentationOptions)),z._id&&(q._id=z._id),z.detail&&(q.detail=z.detail),q}$.to=U})(_=e.TaskDTO||(e.TaskDTO={}));var A;(function($){function M(U){return U}$.from=M;function B(U){if(!!U)return Object.assign(Object.create(null),U)}$.to=B})(A=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(M,B,U){this._id=B,this._task=U,g.set(this,void 0),ot(this,g,M,"f")}get task(){return this._task}terminate(){Oe(this,g,"f").terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}g=new WeakMap;var x;(function($){function M(B){return{id:B._id,task:void 0}}$.from=M})(x=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let O=class{constructor(M,B,U,z,K,N,j,H){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=M.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=z,this._configurationService=K,this._terminalService=N,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=j,this._deprecationService=H,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(M,B,U){if(!U)return new i.Disposable(()=>{});const z=this.nextHandle();return this._handlers.set(z,{type:B,provider:U,extension:M}),this._proxy.$registerTaskProvider(z,B),new i.Disposable(()=>{this._handlers.delete(z),this._proxy.$unregisterTaskProvider(z)})}registerTaskSystem(M,B){this._proxy.$registerTaskSystem(M,B)}fetchTasks(M){return this._proxy.$fetchTasks(A.from(M)).then(async B=>{const U=[];for(let z of B){const K=await _.to(z,this._workspaceProvider,this._providedCustomExecutions2);K&&U.push(K)}return U})}get taskExecutions(){const M=[];return this._taskExecutions.forEach(B=>M.push(B)),M}terminateTask(M){if(!(M instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(M._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(M,B,U){const z=this._providedCustomExecutions2.get(M.id);z&&(this._activeCustomExecutions2.set(M.id,z),this._terminalService.attachPtyToTerminal(B,await z.callback(U))),this._lastStartedTask=M.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(M)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(M){const B=await this.getTaskExecution(M);this._taskExecutionPromises.delete(M.id),this._taskExecutions.delete(M.id),this.customExecutionComplete(M),this._onDidTerminateTask.fire({execution:B})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(M){const B=await this.getTaskExecution(M.id);this._onDidTaskProcessStarted.fire({execution:B,processId:M.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(M){const B=await this.getTaskExecution(M.id);this._onDidTaskProcessEnded.fire({execution:B,exitCode:M.exitCode})}$provideTasks(M,B){const U=this._handlers.get(M);if(!U)return Promise.reject(new Error("no handler found"));const z=[],K=(0,L.asPromise)(()=>U.provider.provideTasks(T.CancellationToken.None)).then(N=>this.provideTasksInternal(B,z,U,N));return new Promise(N=>{K.then(j=>{Promise.all(z).then(()=>{N(j)})})})}async $resolveTask(M,B){const U=this._handlers.get(M);if(!U)return Promise.reject(new Error("no handler found"));if(B.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${U.type}].`);const z=await _.to(B,this._workspaceProvider,this._providedCustomExecutions2);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const K=await U.provider.resolveTask(z,T.CancellationToken.None);if(!K)return;this.checkDeprecation(K,U);const N=_.from(K,U.extension);if(!N)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(N.execution)&&await this.addCustomExecution(N,K,!0),await this.resolveTaskInternal(N)}nextHandle(){return this._handleCounter++}async addCustomExecution(M,B,U){const z=await this._proxy.$createTaskId(M);!U&&!this._providedCustomExecutions2.has(z)&&(this._notProvidedCustomExecutions.add(z),this._activeCustomExecutions2.set(z,B.execution)),this._providedCustomExecutions2.set(z,B.execution)}async getTaskExecution(M,B){if(typeof M=="string"){const K=this._taskExecutionPromises.get(M);if(!K)throw new Error("Unexpected: The specified task is missing an execution");return K}let U=this._taskExecutionPromises.get(M.id);if(U)return U;const z=new Promise((K,N)=>{function j(H,V,q){q?K(new R(H,V.id,q)):N("Unexpected: Task does not exist.")}B?j(this,M,B):_.to(M.task,this._workspaceProvider,this._providedCustomExecutions2).then(H=>j(this,M,H))});return this._taskExecutionPromises.set(M.id,z),z.then(K=>(this._taskExecutions.set(M.id,K),K),K=>Promise.reject(K))}checkDeprecation(M,B){M._deprecated&&this._deprecationService.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(M){this._activeCustomExecutions2.get(M.id)&&this._activeCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.has(M.id)&&this._lastStartedTask!==M.id&&(this._providedCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.delete(M.id));let U=this._notProvidedCustomExecutions.values(),z=U.next();for(;!z.done;)!this._activeCustomExecutions2.has(z.value)&&this._lastStartedTask!==z.value&&(this._providedCustomExecutions2.delete(z.value),this._notProvidedCustomExecutions.delete(z.value)),z=U.next()}};O=Ve([He(0,a.IExtHostRpcService),He(1,b.IExtHostInitDataService),He(2,k.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,y.IExtHostConfiguration),He(5,I.IExtHostTerminalService),He(6,P.ILogService),He(7,p.IExtHostApiDeprecationService)],O),e.ExtHostTaskBase=O;let F=class extends O{constructor(M,B,U,z,K,N,j,H){super(M,B,U,z,K,N,j,H);this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:E.PlatformToString(0)})}async executeTask(M,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const U=_.from(B,M);if(U===void 0)throw new Error("Task is not valid");if(l.is(U.execution))await this.addCustomExecution(U,B,!1);else throw new r.NotSupportedError;const z=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),B);return this._proxy.$executeTask(U).catch(K=>{throw new Error(K)}),z}provideTasksInternal(M,B,U,z){const K=[];if(z)for(let N of z){this.checkDeprecation(N,U),(!N.definition||!M[N.definition.type])&&this._logService.warn(`The task [${N.source}, ${N.name}] uses an undefined task type. The task will be ignored in the future.`);const j=_.from(N,U.extension);j&&l.is(j.execution)?(K.push(j),B.push(this.addCustomExecution(j,N,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:K,extension:U.extension}}async resolveTaskInternal(M){if(l.is(M.execution))return M;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(M,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,B,U){}};F=Ve([He(0,a.IExtHostRpcService),He(1,b.IExtHostInitDataService),He(2,k.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,y.IExtHostConfiguration),He(5,I.IExtHostTerminalService),He(6,P.ILogService),He(7,p.IExtHostApiDeprecationService)],F),e.WorkerExtHostTask=F,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(ge[266],pe([0,1,17,73,31,80,24,10,9,23,8,13,2,145,174,115,43,127,265,33]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E,P,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let r=class{constructor(h,c,_,A){this.configurationService=h,this.workspaceContextService=c,this.editorGroupsService=_,this.pathService=A}text(h,c,_={}){h=this.getContentPattern(h,_);const A=this.configurationService.getValue(),R=c&&c.some(O=>!this.configurationService.getValue({resource:O}).search.useRipgrep);return{...this.commonQuery(c?.map(E.toWorkspaceFolder),_),type:2,contentPattern:h,previewOptions:_.previewOptions,maxFileSize:_.maxFileSize,usePCRE2:A.search.usePCRE2||R||!1,beforeContext:_.beforeContext,afterContext:_.afterContext,userDisabledExcludesAndIgnoreFiles:_.disregardExcludeSettings&&_.disregardIgnoreFiles}}getContentPattern(h,c){const _=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const A={...h,wordSeparators:_.editor.wordSeparators};return this.isCaseSensitive(h,c)&&(A.isCaseSensitive=!0),this.isMultiline(h)&&(A.isMultiline=!0),A}file(h,c={}){return{...this.commonQuery(h,c),type:1,filePattern:c.filePattern?c.filePattern.trim():c.filePattern,exists:c.exists,sortByScore:c.sortByScore,cacheKey:c.cacheKey}}handleIncludeExclude(h,c){return h?(h=Array.isArray(h)?h.map(t):t(h),c?this.parseSearchPaths(h):{pattern:s(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],c={}){const _=this.handleIncludeExclude(c.includePattern,c.expandPatterns),A=this.handleIncludeExclude(c.excludePattern,c.expandPatterns),R=h.length>1,x=(_.searchPaths&&_.searchPaths.length?_.searchPaths.map($=>this.getFolderQueryForSearchPath($,c,A)):h.map($=>this.getFolderQueryForRoot($,c,A,R))).filter($=>!!$),O={_reason:c._reason,folderQueries:x,usingSearchPaths:!!(_.searchPaths&&_.searchPaths.length),extraFileResources:c.extraFileResources,excludePattern:A.pattern,includePattern:_.pattern,onlyOpenEditors:c.onlyOpenEditors,maxResults:c.maxResults};if(c.onlyOpenEditors){const M=m.coalesce(m.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(z=>z.resource)))).filter(U=>(0,o.pathIncludedInQuery)(O,U.fsPath)),B=this.commonQueryFromFileList(M);return{...O,...B}}const F=c.extraFileResources&&c.extraFileResources.filter($=>(0,o.pathIncludedInQuery)(O,$.fsPath));return O.extraFileResources=F&&F.length?F:void 0,O}commonQueryFromFileList(h){const c=[],_=new i.ResourceMap,A={};let R=!1;return h.forEach(x=>{if(x.scheme===k.Schemas.walkThrough)return;if((0,y.isAbsolutePath)(x)){const F=this.workspaceContextService.getWorkspaceFolder(x)?.uri??x.with({path:S.dirname(x.fsPath)});let $=_.get(F);$||(R=!0,$={folder:F,includePattern:{}},c.push($),_.set(F,$));const M=S.relative(F.fsPath,x.fsPath);(0,I.assertIsDefined)($.includePattern)[M.replace(/\\/g,"/")]=!0}else x.fsPath&&(R=!0,A[x.fsPath]=!0)}),{folderQueries:c,includePattern:A,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(h,c){if(c.isSmartCase){if(h.isRegExp){if(T.containsUppercaseCharacter(h.pattern,!0))return!0}else if(T.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,b.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const c=B=>S.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),A=(Array.isArray(h)?h:v(h)).map(B=>{const U=this.pathService.resolvedUserHome;return U?(0,C.untildify)(B,U.scheme===k.Schemas.file?U.fsPath:U.path):B}),R=L.groupBy(A,B=>c(B)?"searchPaths":"exprSegments"),x=(R.exprSegments||[]).map(B=>T.rtrim(B,"/")).map(B=>T.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),n(B))),O={},F=this.expandSearchPathPatterns(R.searchPaths||[]);F&&F.length&&(O.searchPaths=F);const $=m.flatten(x),M=s(...$);return M&&(O.pattern=M),O}getExcludesForFolder(h,c){return c.disregardExcludeSettings?void 0:(0,o.getExcludes)(h,!c.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const c=m.flatten(h.map(A=>{let{pathPortion:R,globPortion:x}=g(A);x&&(x=u(x));const O=this.expandOneSearchPath(R);return m.flatten(O.map(F=>this.resolveOneSearchPathPattern(F,x)))})),_=new Map;return c.forEach(A=>{const R=A.searchPath.toString(),x=_.get(R);x?A.pattern&&(x.pattern=x.pattern||{},x.pattern[A.pattern]=!0):_.set(R,{searchPath:A.searchPath,pattern:A.pattern?s(A.pattern):void 0})}),Array.from(_.values())}expandOneSearchPath(h){if(S.isAbsolute(h)){const c=this.workspaceContextService.getWorkspace().folders;return c[0]&&c[0].uri.scheme!==k.Schemas.file?[{searchPath:c[0].uri.with({path:h})}]:[{searchPath:a.URI.file(S.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const c=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=t(h),h.startsWith("../")||h===".."){const A=S.posix.resolve(c.path,h);return[{searchPath:c.with({path:A})}]}const _=u(h);return[{searchPath:c,pattern:_}]}else{if(h==="./"||h===".\\")return[];{const c=h.replace(/^\.[\/\\]/,""),A=this.workspaceContextService.getWorkspace().folders.map(R=>{const x=c.match(new RegExp(`^${T.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return x?{match:x,folder:R}:null}).filter(I.isDefined);if(A.length)return A.map(R=>{const x=R.match[1];return{searchPath:R.folder.uri,pattern:x&&u(x)}});{const R=h.match(/\.[\/\\](.+)[\/\\]?/),x=R?R[1]:h,O=f.localize(0,null,x);throw new Error(O)}}}}resolveOneSearchPathPattern(h,c){const _=h.pattern&&c?`${h.pattern}/${c}`:h.pattern||c,A=[{searchPath:h.searchPath,pattern:_}];return _&&!_.endsWith("**")&&A.push({searchPath:h.searchPath,pattern:_+"/**"}),A}getFolderQueryForSearchPath(h,c,_){const A=this.getFolderQueryForRoot((0,E.toWorkspaceFolder)(h.searchPath),c,_,!1);return A?{...A,includePattern:h.pattern}:null}getFolderQueryForRoot(h,c,_,A){let R;const x=a.URI.isUri(h)?h:h.uri;if(_.searchPaths){const B=_.searchPaths.filter(U=>(0,y.isEqual)(U.searchPath,x))[0];if(B&&!B.pattern)return null;B&&(R=B.pattern)}const O=this.configurationService.getValue({resource:x}),$={...this.getExcludesForFolder(O,c)||{},...R||{}},M=a.URI.isUri(h)?(0,y.basename)(h):h.name;return{folder:x,folderName:A?M:void 0,excludePattern:Object.keys($).length>0?$:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof c.disregardIgnoreFiles=="boolean"?c.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof c.disregardGlobalIgnoreFiles=="boolean"?c.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof c.ignoreSymlinks=="boolean"?c.ignoreSymlinks:!O.search.followSymlinks}}};r=Ve([He(0,w.IConfigurationService),He(1,E.IWorkspaceContextService),He(2,P.IEditorGroupsService),He(3,p.IPathService)],r),e.QueryBuilder=r;function g(l){const h=l.match(/[\*\{\}\(\)\[\]\?]/);if(h){const c=h.index,_=l.substr(0,c).match(/[/|\\][^/\\]*$/);if(_){let A=l.substr(0,_.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:l.substr((_.index||0)+1)}}}return{pathPortion:l}}function s(...l){return l.length?l.reduce((h,c)=>(h[c]=!0,h),Object.create(null)):void 0}function v(l){return D.splitGlobAware(l,",").map(h=>h.trim()).filter(h=>!!h.length)}function n(l){return[`**/${l}/**`,`**/${l}`].map(c=>c.replace(/\*\*\/\*\*/g,"**"))}function t(l){return l.replace(/\\/g,"/")}function u(l){return t(l).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(l,h){l=m.distinct(l,A=>A.toString());const c=[],_=h.getWorkspace();return l&&l.forEach(A=>{let R;if(h.getWorkbenchState()===2)R=(0,y.relativePath)(_.folders[0].uri,A),R&&R!=="."&&(R="./"+R);else{const x=h.getWorkspaceFolder(A);if(x){const O=x.name;if(_.folders.filter($=>$.name===O).length===1){const $=(0,y.relativePath)(x.uri,A);$===""?R=`./${x.name}`:R=`./${x.name}/${$}`}else R=A.fsPath}}R&&c.push(R)}),c}e.resolveResourcesForSearchIncludes=d}),define(ge[267],pe([0,1,23,2,21,15,4,266,33,43]),function(Y,e,m,L,D,C,i,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const T=7e3;function I(w,E){const P=E.activationEvents;if(!P)return Promise.resolve(void 0);const p=[],o=[];for(const t of P)if(/^workspaceContains:/.test(t)){const u=t.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||w.forceUsingSearch?o.push(u):p.push(u)}if(p.length===0&&o.length===0)return Promise.resolve(void 0);let r;const g=new Promise((t,u)=>{r=t}),s=t=>r({activationEvent:t}),v=Promise.all(p.map(t=>a(w,t,s))).then(()=>{}),n=b(w,E.identifier,o,s);return Promise.all([v,n]).then(()=>{r(void 0)}),g}e.checkActivateWorkspaceContainsExtension=I;async function a(w,E,P){for(const p of w.folders)if(await w.exists(m.joinPath(L.URI.revive(p),E))){P(`workspaceContains:${E}`);return}}async function b(w,E,P,p){if(P.length===0)return Promise.resolve(void 0);const o=new D.CancellationTokenSource,r=w.checkExists(w.folders,P,o.token),g=setTimeout(async()=>{o.cancel(),w.logService.info(`Not activating extension '${E.value}': Timed out while searching for 'workspaceContains' pattern ${P.join(",")}`)},T);let s=!1;try{s=await r}catch(v){C.isPromiseCanceledError(v)||C.onUnexpectedError(v)}o.dispose(),clearTimeout(g),s&&p(`workspaceContains:${P.join(",")}`)}function f(w,E,P,p){const o=w.get(i.IInstantiationService),r=w.get(S.ISearchService),s=o.createInstance(k.QueryBuilder).file(E.map(v=>(0,y.toWorkspaceFolder)(L.URI.revive(v))),{_reason:"checkExists",includePattern:P,exists:!0});return r.fileSearch(s,p).then(v=>!!v.limitHit,v=>C.isPromiseCanceledError(v)?!1:Promise.reject(v))}e.checkGlobFileExists=f});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[39],pe([0,1,163,9,71,23,18,6,24,2,11,5,36,225,91,35,29,223,15,27,22,198,7,119,4,26,67,14,85,52,34,3,267,90,200,10]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E,P,p,o,r,g,s,v,n,t,u,d,l,h,c,_,A,R,x,O){"use strict";var F,$,M;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let B=class ji extends k.Disposable{constructor(N,j,H,V,q,te,fe,Ce,ke,Ue){super();this._onDidChangeRemoteConnectionData=this._register(new _.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=j,this._extHostContext=H,this._initData=fe,this._extHostWorkspace=V,this._extHostConfiguration=q,this._logService=te,this._extHostTunnelService=ke,this._extHostTerminalService=Ue,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new i.Barrier,this._readyToStartExtensionHost=new i.Barrier,this._readyToRunExtensions=new i.Barrier,this._eagerExtensionsActivated=new i.Barrier,this._registry=new P.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new f.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=Ce,this._instaService=N.createChild(new l.ServiceCollection([f.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const xe=new Set;this._initData.hostExtensions.forEach(ze=>xe.add(o.ExtensionIdentifier.toKey(ze))),this._activator=this._register(new b.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ze,Q,Z)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,p.transformErrorForSerialization(Q),Z)},actualActivateExtension:async(ze,Q)=>{if(xe.has(o.ExtensionIdentifier.toKey(ze)))return await this._mainThreadExtensionsProxy.$activateExtension(ze,Q),new b.HostExtension;const Z=this._registry.getExtensionDescription(ze);return this._activateExtension(Z,Q)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(N){p.onUnexpectedError(N)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let N=[];try{N=this._registry.getAllExtensionDescriptions().map(q=>q.identifier).filter(q=>this.isActivated(q)).map(q=>this._deactivate(q))}catch(j){}await Promise.all(N)}isActivated(N){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(N):!1}_activateByEvent(N,j){return this._activator.activateByEvent(N,j)}_activateById(N,j){return this._activator.activateById(N,j)}activateByIdWithErrors(N,j){return this._activateById(N,j).then(()=>{const H=this._activator.getActivatedExtension(N);if(H.activationFailed)return Promise.reject(H.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(N=>this._registry)}getExtensionExports(N){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(N).exports:null}async _realPathExtensionUri(N){if(N.scheme!==O.Schemas.file)return N;const j=await this._hostUtils.realpath(N.fsPath);return y.URI.file(j)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const N=S.TernarySearchTree.forUris(j=>C.extUriBiasedIgnorePathCase.ignorePathCasing(j));for(const j of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(j)){const H=await this._realPathExtensionUri(j.extensionLocation);N.set(H,j)}return N})()),this._extensionPathIndex}_deactivate(N){let j=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(N))return j;const H=this._activator.getActivatedExtension(N);if(!H)return j;try{typeof H.module.deactivate=="function"&&(j=Promise.resolve(H.module.deactivate()).then(void 0,V=>(this._logService.error(V),Promise.resolve(void 0))))}catch(V){this._logService.error(V)}try{(0,k.dispose)(H.subscriptions)}catch(V){this._logService.error(V)}return j}async _activateExtension(N,j){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier),this._doActivateExtension(N,j).then(H=>{const V=H.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(N.identifier,V.codeLoadingTime,V.activateCallTime,V.activateResolvedTime,j),this._logExtensionActivationTimes(N,j,"success",V),H},H=>{throw this._logExtensionActivationTimes(N,j,"failure"),H})}_logExtensionActivationTimes(N,j,H,V){const q=U(N,j);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...q,...V||{},outcome:H})}_doActivateExtension(N,j){const H=U(N,j);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",H);const V=this._getEntryPoint(N);if(!V)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${N.identifier.value}, startup: ${j.startup}, activationEvent: '${j.activationEvent}'${N.identifier.value!==j.extensionId.value?`, root cause: ${j.extensionId.value}`:""}`),this._logService.flush();const q=new b.ExtensionActivationTimesBuilder(j.startup);return Promise.all([this._loadCommonJSModule(N.identifier,(0,C.joinPath)(N.extensionLocation,V),q),this._loadExtensionContext(N)]).then(te=>(D.mark(`code/extHost/willActivateExtension/${N.identifier.value}`),ji._callActivate(this._logService,N.identifier,te[0],te[1],q))).then(te=>(D.mark(`code/extHost/didActivateExtension/${N.identifier.value}`),te))}_loadExtensionContext(N){const j=new g.ExtensionGlobalMemento(N,this._storage),H=new g.ExtensionMemento(N.identifier.value,!1,this._storage),V=new x.ExtensionSecrets(N,this._secretState),q=N.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,te=this._initData.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${N.identifier.value}`),Promise.all([j.whenReady,H.whenReady,this._storagePath.whenReady]).then(()=>{const fe=this;let Ce;return Object.freeze({globalState:j,workspaceState:H,secrets:V,subscriptions:[],get extensionUri(){return N.extensionLocation},get extensionPath(){return N.extensionLocation.fsPath},asAbsolutePath(ke){return L.join(N.extensionLocation.fsPath,ke)},get storagePath(){return fe._storagePath.workspaceValue(N)?.fsPath},get globalStoragePath(){return fe._storagePath.globalValue(N).fsPath},get logPath(){return L.join(fe._initData.logsLocation.fsPath,N.identifier.value)},get logUri(){return y.URI.joinPath(fe._initData.logsLocation,N.identifier.value)},get storageUri(){return fe._storagePath.workspaceValue(N)},get globalStorageUri(){return fe._storagePath.globalValue(N)},get extensionMode(){return q},get extension(){return Ce===void 0&&(Ce=new z(fe,N.identifier,N,te)),Ce},get extensionRuntime(){return(0,E.checkProposedApiEnabled)(N,"extensionRuntime"),fe.extensionRuntime},get environmentVariableCollection(){return fe._extHostTerminalService.getEnvironmentVariableCollection(N)}})})}static _callActivate(N,j,H,V,q){return H=H||{activate:void 0,deactivate:void 0},this._callActivateOptional(N,j,H,V,q).then(te=>new b.ActivatedExtension(!1,null,q.build(),H,te,V.subscriptions))}static _callActivateOptional(N,j,H,V,q){if(typeof H.activate=="function")try{q.activateCallStart(),N.trace(`ExtensionService#_callActivateOptional ${j.value}`);const te=typeof global=="object"?global:self,fe=H.activate.apply(te,[V]);return q.activateCallStop(),q.activateResolveStart(),Promise.resolve(fe).then(Ce=>(q.activateResolveStop(),Ce))}catch(te){return Promise.reject(te)}else return Promise.resolve(H)}_activateOneStartupFinished(N,j){this._activateById(N.identifier,{startup:!1,extensionId:N.identifier,activationEvent:j}).then(void 0,H=>{this._logService.error(H)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const N of this._registry.getAllExtensionDescriptions())if(N.activationEvents)for(const j of N.activationEvents)j==="onStartupFinished"&&this._activateOneStartupFinished(N,j)}_handleEagerExtensions(){const N=this._activateByEvent("*",!0).then(void 0,q=>{this._logService.error(q)});this._register(this._extHostWorkspace.onDidChangeWorkspace(q=>this._handleWorkspaceContainsEagerExtensions(q.added)));const j=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],H=this._handleWorkspaceContainsEagerExtensions(j),V=Promise.all([N,H]).then(()=>{});return Promise.race([V,(0,i.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),V}_handleWorkspaceContainsEagerExtensions(N){return N.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(j=>this._handleWorkspaceContainsEagerExtension(N,j))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(N,j){if(this.isActivated(j.identifier))return;const H=!this._initData.remote.isRemote&&!!this._initData.remote.authority,V={logService:this._logService,folders:N.map(te=>te.uri),forceUsingSearch:H,exists:te=>this._hostUtils.exists(te.fsPath),checkExists:(te,fe,Ce)=>this._mainThreadWorkspaceProxy.$checkExists(te,fe,Ce)},q=await(0,A.checkActivateWorkspaceContainsExtension)(V,j);if(!!q)return this._activateById(j.identifier,{startup:!0,extensionId:j.identifier,activationEvent:q.activationEvent}).then(void 0,te=>this._logService.error(te))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(N){throw console.error(N),N}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:N,extensionTestsLocationURI:j}=this._initData.environment;if(!N||!j)throw new Error(m.localize(0,null));const H=await this._loadCommonJSModule(null,j,new b.ExtensionActivationTimesBuilder(!1));if(!H||typeof H.run!="function")throw new Error(m.localize(1,null,j.toString()));return new Promise((V,q)=>{const te=(ke,Ue)=>{ke?q(ke):V(typeof Ue=="number"&&Ue>0?1:0)},fe=(0,C.originalFSPath)(j),Ce=H.run(fe,te);Ce&&Ce.then&&Ce.then(()=>{V(0)}).catch(ke=>{q(ke.toString())})})}async $extensionTestsExit(N){this._logService.info(`Extension host terminating: test runner requested exit with code ${N}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${N}`),this._logService.flush(),this._hostUtils.exit(N)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(N,j){return this._resolvers[N]=j,(0,k.toDisposable)(()=>{delete this._resolvers[N]})}async _activateAndGetResolver(N){const j=N.indexOf("+");if(j===-1)throw new Error("Not an authority that can be resolved!");const H=N.substr(0,j);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${H}`,!1),{authorityPrefix:H,resolver:this._resolvers[H]}}async $resolveAuthority(N,j){const{authorityPrefix:H,resolver:V}=await this._activateAndGetResolver(N);if(!V)return{type:"error",error:{code:v.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${H}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(V)),D.mark(`code/extHost/willResolveAuthority/${H}`);const q=await V.resolve(N,{resolveAttempt:j});D.mark(`code/extHost/didResolveAuthorityOK/${H}`);const te={authority:N,host:q.host,port:q.port,connectionToken:q.connectionToken},fe={extensionHostEnv:q.extensionHostEnv,isTrusted:q.isTrusted,authenticationSession:q.authenticationSessionForInitializingExtensions?{id:q.authenticationSessionForInitializingExtensions.id,providerId:q.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:te,options:fe,tunnelInformation:{environmentTunnels:q.environmentTunnels}}}}catch(q){if(D.mark(`code/extHost/didResolveAuthorityError/${H}`),q instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:q._code,message:q._message,detail:q._detail}};throw q}}async $getCanonicalURI(N,j){const{authorityPrefix:H,resolver:V}=await this._activateAndGetResolver(N);if(!V)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${H}`);const q=y.URI.revive(j);if(typeof V.getCanonicalURI=="undefined")return q;const te=await(0,i.asPromise)(()=>V.getCanonicalURI(q));return te||q}$startExtensionHost(N){return this._registry.keepOnly(N),this._startExtensionHost()}$activateByEvent(N,j){return j===1?this._activateByEvent(N,!1):this._readyToRunExtensions.wait().then(H=>this._activateByEvent(N,!1))}async $activate(N,j){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(N)?(await this._activateById(N,j),!0):!1}async $deltaExtensions(N,j){N.forEach(V=>V.extensionLocation=y.URI.revive(V.extensionLocation));const H=await this.getExtensionPathIndex();return await Promise.all(j.map(async V=>{const q=this._registry.getExtensionDescription(V);q&&H.delete(await this._realPathExtensionUri(q.extensionLocation))})),await Promise.all(N.map(async V=>{const q=await this._realPathExtensionUri(V.extensionLocation);H.set(q,V)})),this._registry.deltaExtensions(N,j),Promise.resolve(void 0)}async $test_latency(N){return N}async $test_up(N){return N.byteLength}async $test_down(N){let j=r.VSBuffer.alloc(N),H=Math.random()%256;for(let V=0;V<N;V++)j.writeUInt8(H,V);return j}async $updateRemoteConnectionData(N){this._remoteConnectionData=N,this._onDidChangeRemoteConnectionData.fire()}};B=Ve([He(0,n.IInstantiationService),He(1,e.IHostUtils),He(2,d.IExtHostRpcService),He(3,w.IExtHostWorkspace),He(4,a.IExtHostConfiguration),He(5,T.ILogService),He(6,t.IExtHostInitDataService),He(7,u.IExtensionStoragePaths),He(8,h.IExtHostTunnelService),He(9,c.IExtHostTerminalService)],B),e.AbstractExtHostExtensionService=B;function U(K,N){return{id:K.identifier.value,name:K.name,extensionVersion:K.version,publisherDisplayName:K.publisher,activationEvents:K.activationEvents?K.activationEvents.join(","):null,isBuiltin:K.isBuiltin,reason:N.activationEvent,reasonId:N.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class z{constructor(N,j,H,V){F.set(this,void 0),$.set(this,void 0),M.set(this,void 0),ot(this,F,N,"f"),ot(this,$,j,"f"),ot(this,M,H.identifier,"f"),this.id=H.identifier.value,this.extensionUri=H.extensionLocation,this.extensionPath=L.normalize((0,C.originalFSPath)(H.extensionLocation)),this.packageJSON=H,this.extensionKind=V}get isActive(){return Oe(this,F,"f").isActivated(Oe(this,M,"f"))}get exports(){if(this.packageJSON.api!=="none")return Oe(this,F,"f").getExtensionExports(Oe(this,M,"f"))}activate(){return Oe(this,F,"f").activateByIdWithErrors(Oe(this,M,"f"),{startup:!1,extensionId:Oe(this,$,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=z,F=new WeakMap,$=new WeakMap,M=new WeakMap}),define(ge[55],pe([0,1,9,2,3,18,5,7,123,35,39,45,214,36,207,14,4,13,40,54]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E,P,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let r=class{constructor(l,h,c,_,A,R){this._workspaceService=h,this._extensionService=c,this._editorsService=_,this._configurationService=A,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=l.getProxy(i.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new s(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(x=>{x.onDidChange(O=>{this.registerAllDebugTypes(x)}),this.registerAllDebugTypes(x)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(l,h){const c=l;if(typeof c.sourceReference=="number"&&c.sourceReference>0){let _=`debug:${encodeURIComponent(c.path||"")}`,A="?";return h&&(_+=`${A}session=${encodeURIComponent(h.id)}`,A="&"),_+=`${A}ref=${c.sourceReference}`,L.URI.parse(_)}else{if(c.path)return L.URI.file(c.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(l){const h=[];for(const c of l.getAllExtensionDescriptions())if(c.contributes){const _=c.contributes.debuggers;if(_&&_.length>0)for(const A of _)(0,f.isDebuggerMainContribution)(A)&&h.push(A.type)}this._debugServiceProxy.$registerDebugTypes(h)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const l=[];return this._breakpoints.forEach(h=>l.push(h)),l}addBreakpoints(l){this.startBreakpoints();const h=l.filter(A=>{const R=A.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,A),!0)});this.fireBreakpointChanges(h,[],[]);const c=[],_=new Map;for(const A of h)if(A instanceof k.SourceBreakpoint){let R=_.get(A.location.uri.toString());R||(R={type:"sourceMulti",uri:A.location.uri,lines:[]},_.set(A.location.uri.toString(),R),c.push(R)),R.lines.push({id:A.id,enabled:A.enabled,condition:A.condition,hitCondition:A.hitCondition,logMessage:A.logMessage,line:A.location.range.start.line,character:A.location.range.start.character})}else A instanceof k.FunctionBreakpoint&&c.push({type:"function",id:A.id,enabled:A.enabled,hitCondition:A.hitCondition,logMessage:A.logMessage,condition:A.condition,functionName:A.functionName});return this._debugServiceProxy.$registerBreakpoints(c)}removeBreakpoints(l){this.startBreakpoints();const h=l.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],h,[]);const c=h.filter(R=>R instanceof k.SourceBreakpoint).map(R=>R.id),_=h.filter(R=>R instanceof k.FunctionBreakpoint).map(R=>R.id),A=h.filter(R=>R instanceof k.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(c,_,A)}startDebugging(l,h,c){return this._debugServiceProxy.$startDebugging(l?l.uri:void 0,h,{parentSessionID:c.parentSession?c.parentSession.id:void 0,lifecycleManagedByParent:c.lifecycleManagedByParent,repl:c.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:c.noDebug,compact:c.compact,debugUI:c.debugUI,suppressSaveBeforeStart:c.suppressSaveBeforeStart})}stopDebugging(l){return this._debugServiceProxy.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,h,c){if(!h)return new k.Disposable(()=>{});const _=this._configProviderHandleCounter++;return this._configProviders.push({type:l,handle:_,provider:h}),this._debugServiceProxy.$registerDebugConfigurationProvider(l,c,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,_),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(A=>A.provider!==h),this._debugServiceProxy.$unregisterDebugConfigurationProvider(_)})}registerDebugAdapterDescriptorFactory(l,h,c){if(!c)return new k.Disposable(()=>{});if(!this.definesDebugType(l,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.getAdapterDescriptorFactoryByType(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const _=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:h,handle:_,factory:c}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(h,_),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(A=>A.factory!==c),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(_)})}registerDebugAdapterTrackerFactory(l,h){if(!h)return new k.Disposable(()=>{});const c=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:l,handle:c,factory:h}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(_=>_.factory!==h)})}async $runInTerminal(l,h){return Promise.resolve(void 0)}async $substituteVariables(l,h){if(!this._variableResolver){const[A,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(A||[],this._editorsService,R)}let c;const _=await this.getFolder(l);return _&&(c={uri:_.uri,name:_.name,index:_.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(c,h)}createDebugAdapter(l,h){if(l.type==="implementation")return new t(l.implementation)}createSignService(){}async $startDASession(l,h){const c=this,_=await this.getSession(h);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(_.type),_).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}' (extension might have failed to activate)`);const R=this.convertToDto(A),x=this.createDebugAdapter(R,_);if(!x)throw new Error(`Couldn't create a debug adapter for type '${_.type}'.`);const O=x;return this._debugAdapters.set(l,O),this.getDebugAdapterTrackers(_).then(F=>(F&&this._debugAdaptersTrackers.set(l,F),O.onMessage(async $=>{if($.type==="request"&&$.command==="handshake"){const M=$,B={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(M.arguments.value);B.body={signature:U},O.sendResponse(B)}else throw new Error("no signer")}catch(U){B.success=!1,B.message=U.message,O.sendResponse(B)}}else F&&F.onDidSendMessage&&F.onDidSendMessage($),$=(0,f.convertToVSCPaths)($,!0),c._debugServiceProxy.$acceptDAMessage(l,$)}),O.onError($=>{F&&F.onError&&F.onError($),this._debugServiceProxy.$acceptDAError(l,$.name,$.message,$.stack)}),O.onExit($=>{F&&F.onExit&&F.onExit((0,P.withNullAsUndefined)($),void 0),this._debugServiceProxy.$acceptDAExit(l,(0,P.withNullAsUndefined)($),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),O.startSession()))})}$sendDAMessage(l,h){h=(0,f.convertToDAPaths)(h,!1);const c=this._debugAdaptersTrackers.get(l);c&&c.onWillReceiveMessage&&c.onWillReceiveMessage(h);const _=this._debugAdapters.get(l);_&&_.sendMessage(h)}$stopDASession(l){const h=this._debugAdaptersTrackers.get(l);this._debugAdaptersTrackers.delete(l),h&&h.onWillStopSession&&h.onWillStopSession();const c=this._debugAdapters.get(l);return this._debugAdapters.delete(l),c?c.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const h=[],c=[],_=[];if(l.added)for(const A of l.added){const R=A.id;if(R&&!this._breakpoints.has(R)){let x;if(A.type==="function")x=new k.FunctionBreakpoint(A.functionName,A.enabled,A.condition,A.hitCondition,A.logMessage);else if(A.type==="data")x=new k.DataBreakpoint(A.label,A.dataId,A.canPersist,A.enabled,A.hitCondition,A.condition,A.logMessage);else{const O=L.URI.revive(A.uri);x=new k.SourceBreakpoint(new k.Location(O,new k.Position(A.line,A.character)),A.enabled,A.condition,A.hitCondition,A.logMessage)}x._id=R,this._breakpoints.set(R,x),h.push(x)}}if(l.removed)for(const A of l.removed){const R=this._breakpoints.get(A);R&&(this._breakpoints.delete(A),c.push(R))}if(l.changed){for(const A of l.changed)if(A.id){const R=this._breakpoints.get(A.id);if(R){if(R instanceof k.FunctionBreakpoint&&A.type==="function"){const x=R;x.enabled=A.enabled,x.condition=A.condition,x.hitCondition=A.hitCondition,x.logMessage=A.logMessage,x.functionName=A.functionName}else if(R instanceof k.SourceBreakpoint&&A.type==="source"){const x=R;x.enabled=A.enabled,x.condition=A.condition,x.hitCondition=A.hitCondition,x.logMessage=A.logMessage,x.location=new k.Location(L.URI.revive(A.uri),new k.Position(A.line,A.character))}_.push(R)}}}this.fireBreakpointChanges(h,c,_)}$provideDebugConfigurations(l,h,c){return(0,C.asPromise)(async()=>{const _=this.getConfigProviderByHandle(l);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const A=await this.getFolder(h);return _.provideDebugConfigurations(A,c)}).then(_=>{if(!_)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return _})}$resolveDebugConfiguration(l,h,c,_){return(0,C.asPromise)(async()=>{const A=this.getConfigProviderByHandle(l);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(h);return A.resolveDebugConfiguration(R,c,_)})}$resolveDebugConfigurationWithSubstitutedVariables(l,h,c,_){return(0,C.asPromise)(async()=>{const A=this.getConfigProviderByHandle(l);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(h);return A.resolveDebugConfigurationWithSubstitutedVariables(R,c,_)})}async $provideDebugAdapter(l,h){const c=this.getAdapterDescriptorFactoryByHandle(l);if(!c)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const _=await this.getSession(h);return this.getAdapterDescriptor(c,_).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}'`);return this.convertToDto(A)})}async $acceptDebugSessionStarted(l){const h=await this.getSession(l);this._onDidStartDebugSession.fire(h)}async $acceptDebugSessionTerminated(l){const h=await this.getSession(l);h&&(this._onDidTerminateDebugSession.fire(h),this._debugSessions.delete(h.id))}async $acceptDebugSessionActiveChanged(l){this._activeDebugSession=l?await this.getSession(l):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(l,h){const c=await this.getSession(l);c&&c._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(l,h){const _={session:await this.getSession(l),event:h.event,body:h.body};this._onDidReceiveDebugSessionCustomEvent.fire(_)}convertToDto(l){if(l instanceof k.DebugAdapterExecutable)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof k.DebugAdapterServer)return{type:"server",port:l.port,host:l.host};if(l instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:l.path};if(l instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(l){const h=this._adapterFactories.filter(c=>c.type===l);if(h.length>0)return h[0].factory}getAdapterDescriptorFactoryByHandle(l){const h=this._adapterFactories.filter(c=>c.handle===l);if(h.length>0)return h[0].factory}getConfigProviderByHandle(l){const h=this._configProviders.filter(c=>c.handle===l);if(h.length>0)return h[0].provider}definesDebugType(l,h){if(l.contributes){const c=l.contributes.debuggers;if(c&&c.length>0){for(const _ of c)if(_.label&&_.type&&_.type===h)return!0}}return!1}getDebugAdapterTrackers(l){const c=l.configuration.type,_=this._trackerFactories.filter(A=>A.type===c||A.type==="*").map(A=>(0,C.asPromise)(()=>A.factory.createDebugAdapterTracker(l)).then(R=>R,R=>null));return Promise.race([Promise.all(_).then(A=>{const R=A.filter(x=>!!x);if(R.length>0)return new n(R)}),new Promise((A,R)=>{const x=setTimeout(()=>{clearTimeout(x),R(new Error("timeout"))},1e3)})]).catch(A=>{})}async getAdapterDescriptor(l,h){const c=h.configuration.debugServer;if(typeof c=="number")return Promise.resolve(new k.DebugAdapterServer(c));if(l){const A=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>l.createDebugAdapterDescriptor(h,this.daExecutableFromPackage(h,A))).then(R=>{if(R)return R})}const _=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(h,_))}daExecutableFromPackage(l,h){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(l,h,c){(l.length>0||h.length>0||c.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:l,removed:h,changed:c}))}async getSession(l){if(l)if(typeof l=="string"){const h=this._debugSessions.get(l);if(h)return h}else{let h=this._debugSessions.get(l.id);if(!h){const c=await this.getFolder(l.folderUri),_=l.parent?this._debugSessions.get(l.parent):void 0;h=new g(this._debugServiceProxy,l.id,l.type,l.name,c,l.configuration,_),this._debugSessions.set(h.id,h),this._debugServiceProxy.$sessionCached(h.id)}return h}throw new Error("cannot find session")}getFolder(l){if(l){const h=L.URI.revive(l);return this._workspaceService.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};r=Ve([He(0,w.IExtHostRpcService),He(1,y.IExtHostWorkspace),He(2,T.IExtHostExtensionService),He(3,I.IExtHostDocumentsAndEditors),He(4,b.IExtHostConfiguration),He(5,o.IExtHostEditorTabs)],r),e.ExtHostDebugServiceBase=r;class g{constructor(l,h,c,_,A,R,x){this._debugServiceProxy=l,this._id=h,this._type=c,this._name=_,this._workspaceFolder=A,this._configuration=R,this._parentSession=x}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(l){this._name=l,this._debugServiceProxy.$setDebugSessionName(this._id,l)}get parentSession(){return this._parentSession}_acceptNameChanged(l){this._name=l}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(l,h){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,l,h)}getDebugProtocolBreakpoint(l){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,l.id)}}e.ExtHostDebugSession=g;class s{constructor(l){this.value=Object.freeze({append(h){l.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.ExtHostDebugConsole=s;class v extends a.AbstractVariableResolverService{constructor(l,h,c,_,A){function R(){if(h){const x=h.activeEditor();if(x)return x.document.uri;const O=_.tabs.filter(F=>F.isActive);if(O.length>0){const F=O[0].resource;return F&&(F.primary||F.secondary)?F.primary??F.secondary:O[0].resource}}}super({getFolderUri:x=>{const O=l.filter(F=>F.name===x);if(O&&O.length>0)return O[0].uri},getWorkspaceFolderCount:()=>l.length,getConfigurationValue:(x,O)=>c.getConfiguration(void 0,x).get(O),getAppRoot:()=>p.cwd(),getExecPath:()=>p.env.VSCODE_EXEC_PATH,getFilePath:()=>{const x=R();if(x)return m.normalize(x.fsPath)},getWorkspaceFolderPathForFile:()=>{if(A){const x=R();if(x){const O=A.getWorkspaceFolder(x);if(O)return m.normalize(O.uri.fsPath)}}},getSelectedText:()=>{if(h){const x=h.activeEditor();if(x&&!x.selection.isEmpty)return x.document.getText(x.selection)}},getLineNumber:()=>{if(h){const x=h.activeEditor();if(x)return String(x.selection.end.line+1)}}},void 0,Promise.resolve(p.env))}}e.ExtHostVariableResolverService=v;class n{constructor(l){this.trackers=l}onWillStartSession(){this.trackers.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.trackers.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.trackers.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(l):void 0)}onWillStopSession(){this.trackers.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.trackers.forEach(h=>h.onError?h.onError(l):void 0)}onExit(l,h){this.trackers.forEach(c=>c.onExit?c.onExit(l,h):void 0)}}class t extends S.AbstractDebugAdapter{constructor(l){super();this.implementation=l,l.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.implementation.handleMessage(l)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends r{constructor(l,h,c,_,A,R){super(l,h,c,_,A,R)}createVariableResolver(l,h,c){return new v(l,h,c,this._editorTabs)}};u=Ve([He(0,w.IExtHostRpcService),He(1,y.IExtHostWorkspace),He(2,T.IExtHostExtensionService),He(3,I.IExtHostDocumentsAndEditors),He(4,b.IExtHostConfiguration),He(5,o.IExtHostEditorTabs)],u),e.WorkerExtHostDebugService=u}),define(ge[268],pe([0,1,71,2,5,36,29,27,14,26,4,39,40,11]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let f=class{constructor(o,r,g,s,v,n,t){this._apiFactory=o,this._extensionRegistry=r,this._instaService=g,this._extHostConfiguration=s,this._extHostExtensionService=v,this._initData=n,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const r=await this._extHostExtensionService.getExtensionPathIndex();this.register(new w(this._apiFactory,r,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(E,r)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(P,r,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let r of o.nodeModuleName)this._factories.set(r,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(r=>o.alternativeModuleName(r))}};f=Ve([He(2,T.IInstantiationService),He(3,C.IExtHostConfiguration),He(4,I.IExtHostExtensionService),He(5,y.IExtHostInitDataService),He(6,b.ILogService)],f),e.RequireInterceptor=f;class w{constructor(o,r,g,s,v){this._apiFactory=o,this._extensionPaths=r,this._extensionRegistry=g,this._configProvider=s,this._logService=v,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,r){const g=this._extensionPaths.findSubstr(r);if(g){let s=this._extApiImpl.get(k.ExtensionIdentifier.toKey(g.identifier));return s||(s=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(g.identifier),s)),s}if(!this._defaultApiImpl){let s="";this._extensionPaths.forEach((v,n)=>s+=`	${n} -> ${v.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${s}`),this._defaultApiImpl=this._apiFactory(i.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let E=class{constructor(o,r,g){this._extensionPaths=o,this.nodeModuleName="keytar",this._mainThreadTelemetry=r.getProxy(D.MainContext.MainThreadTelemetry);const{environment:s}=g,v=r.getProxy(D.MainContext.MainThreadKeytar);if(s.appRoot){let n=s.appRoot.fsPath;a.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,t)=>v.$getPassword(n,t),setPassword:(n,t,u)=>v.$setPassword(n,t,u),deletePassword:(n,t)=>v.$deletePassword(n,t),findPassword:n=>v.$findPassword(n),findCredentials(n){return v.$findCredentials(n)}}}load(o,r){const g=this._extensionPaths.findSubstr(r);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:g?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(o){const r=o.length;if(r<=7||!this.alternativeNames)return;const g=r-7;if((o.charAt(g)==="/"||o.charAt(g)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};E=Ve([He(1,S.IExtHostRpcService),He(2,y.IExtHostInitDataService)],E);let P=class{constructor(o,r,g){this._extensionPaths=o,this._appUriScheme=r,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(D.MainContext.MainThreadTelemetry);const s=g.getProxy(D.MainContext.MainThreadWindow);this._impl=(v,n)=>{const t=L.URI.parse(v);return n?this.callOriginal(v,n):t.scheme==="http"||t.scheme==="https"?s.$openUri(t,v,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?s.$openUri(t,v,{}):this.callOriginal(v,n)}}load(o,r,g){const s=this._extensionPaths.findSubstr(r);return s&&(this._extensionId=s.identifier.value,this.sendShimmingTelemetry()),this._original=g(o),this._impl}callOriginal(o,r){return this.sendNoForwardTelemetry(),this._original(o,r)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};P=Ve([He(2,S.IExtHostRpcService)],P)}),define(ge[269],pe([0,1,169,12,7,208,35,39,45,36,34,14,55,194,18,209,54]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let P=class extends a.ExtHostDebugServiceBase{constructor(r,g,s,v,n,t,u){super(r,g,s,v,n,u);this._terminalService=t,this._integratedTerminalInstances=new p}createDebugAdapter(r,g){switch(r.type){case"server":return new C.SocketDebugAdapter(r);case"pipeServer":return new C.NamedPipeDebugAdapter(r);case"executable":return new C.ExecutableDebugAdapter(r,g.type)}return super.createDebugAdapter(r,g)}daExecutableFromPackage(r,g){const s=C.ExecutableDebugAdapter.platformAdapterExecutable(g.getAllExtensionDescriptions(),r.type);if(s)return new D.DebugAdapterExecutable(s.command,s.args,s.options)}createSignService(){return new b.SignService}async $runInTerminal(r,g){if(r.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(R=>{this._integratedTerminalInstances.onTerminalClosed(R)}));const s=await this._configurationService.getConfigProvider(),v=this._terminalService.getDefaultShell(!0),n=this._terminalService.getDefaultShellArgs(!0),t=r.title||m.localize(0,null),u=JSON.stringify({shell:v,shellArgs:n});let d=await this._integratedTerminalInstances.checkout(u,t),l,h=!1;if(d)l=r.cwd;else{const R={shellPath:v,shellArgs:n,cwd:r.cwd,name:t,iconPath:new D.ThemeIcon("debug")};h=!0,d=this._terminalService.createTerminalFromOptions(R,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(d,u)}d.show(!0);const c=await d.processId;h?await new Promise(R=>setTimeout(R,1e3)):s.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(v.indexOf("powershell")>=0||v.indexOf("pwsh")>=0||v.indexOf("cmd.exe")>=0?d.sendText("cls"):v.indexOf("bash")>=0?d.sendText("clear"):L.isWindows?d.sendText("cls"):d.sendText("clear"));const _=(0,w.prepareCommand)(v,r.args,l,r.env);d.sendText(_);const A=this.onDidTerminateDebugSession(R=>{R.id===g&&(this._integratedTerminalInstances.free(d),A.dispose())});return c}else if(r.kind==="external")return(0,w.runInExternalTerminal)(r,await this._configurationService.getConfigProvider());return super.$runInTerminal(r,g)}createVariableResolver(r,g,s){return new a.ExtHostVariableResolverService(r,g,s,this._editorTabs,this._workspaceService)}};P=Ve([He(0,I.IExtHostRpcService),He(1,i.IExtHostWorkspace),He(2,k.IExtHostExtensionService),He(3,S.IExtHostDocumentsAndEditors),He(4,y.IExtHostConfiguration),He(5,T.IExtHostTerminalService),He(6,E.IExtHostEditorTabs)],P),e.ExtHostDebugService=P;class p{constructor(){this._terminalInstances=new Map}async checkout(r,g){const v=[...this._terminalInstances.entries()].map(([n,t])=>(0,f.createCancelablePromise)(async u=>{if(n.name!==g||t.lastUsedAt!==-1&&await(0,w.hasChildProcesses)(await n.processId))return null;const d=Date.now();return t.lastUsedAt+p.minUseDelay>d||u.isCancellationRequested||t.config!==r?null:(t.lastUsedAt=d,n)}));return await(0,f.firstParallel)(v,n=>!!n)}insert(r,g){this._terminalInstances.set(r,{lastUsedAt:Date.now(),config:g})}free(r){const g=this._terminalInstances.get(r);g&&(g.lastUsedAt=-1)}onTerminalClosed(r){this._terminalInstances.delete(r)}}p.minUseDelay=1e3}),define(ge[270],pe([0,1,9,2,112,35,55,45,36,43,34,14,26,70,10,11,65,54,23,81]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E,P,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let r=class extends b.ExtHostTaskBase{constructor(s,v,n,t,u,d,l,h,c){super(s,v,n,t,u,d,l,h);this.workspaceService=n,this.editorTabs=c,v.remote.isRemote&&v.remote.authority?this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:v.remote.authority,platform:process.platform}):this.registerTaskSystem(f.Schemas.file,{scheme:f.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(s,v){const n=v;if(!v.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const t=b.TaskHandleDTO.from(n,this.workspaceService),u=await this._proxy.$getTaskExecution(t);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const d=await this.getTaskExecution(u,v);return this._proxy.$executeTask(t).catch(()=>{}),d}else{const t=b.TaskDTO.from(v,s);if(t===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,v,!1);const u=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),v);return this._proxy.$executeTask(t).catch(()=>{}),u}}provideTasksInternal(s,v,n,t){const u=[];if(t)for(let d of t){this.checkDeprecation(d,n),(!d.definition||!s[d.definition.type])&&this._logService.warn(`The task [${d.source}, ${d.name}] uses an undefined task type. The task will be ignored in the future.`);const l=b.TaskDTO.from(d,n.extension);l&&(u.push(l),b.CustomExecutionDTO.is(l.execution)&&v.push(this.addCustomExecution(l,d,!0)))}return{tasks:u,extension:n.extension}}async resolveTaskInternal(s){return s}async getVariableResolver(s){if(this._variableResolver===void 0){const v=await this._configurationService.getConfigProvider();this._variableResolver=new i.ExtHostVariableResolverService(s,this._editorService,v,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(s){let v=s&&s.length>0?s[0]:void 0;if(!v){const n=L.URI.file((0,o.homedir)());v=new y.WorkspaceFolder({uri:n,name:p.basename(n),index:0})}return{uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(s,v){const n=L.URI.revive(s),t={process:void 0,variables:Object.create(null)},u=await this._workspaceProvider.resolveWorkspaceFolder(n),d=await this._workspaceProvider.getWorkspaceFolders2()??[],l=await this.getVariableResolver(d),h=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(d);for(let c of v.variables)t.variables[c]=await l.resolveAsync(h,c);if(v.process!==void 0){let c;if(v.process.path!==void 0){c=v.process.path.split(m.delimiter);for(let _=0;_<c.length;_++)c[_]=await l.resolveAsync(h,c[_])}t.process=await D.win32.findExecutable(await l.resolveAsync(h,v.process.name),v.process.cwd!==void 0?await l.resolveAsync(h,v.process.cwd):void 0,c)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(s,v,n){return D.win32.findExecutable(s,v,n)}};r=Ve([He(0,I.IExtHostRpcService),He(1,a.IExtHostInitDataService),He(2,C.IExtHostWorkspace),He(3,k.IExtHostDocumentsAndEditors),He(4,S.IExtHostConfiguration),He(5,T.IExtHostTerminalService),He(6,w.ILogService),He(7,E.IExtHostApiDeprecationService),He(8,P.IExtHostEditorTabs)],r),e.ExtHostTask=r}),define(ge[271],pe([0,1,18,15,71,6,2,5,263,11,83,85,26,186,14,64,39,34]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class p{constructor(r,g,s,v){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=s,this._rpcProtocol=new S.RPCProtocol(r,null,v),g=p._transform(g,this._rpcProtocol);const n=new I.ServiceCollection(...(0,T.getSingletonServiceDescriptors)());n.set(a.IExtHostInitDataService,{_serviceBrand:void 0,...g}),n.set(f.IExtHostRpcService,new f.ExtHostRpcService(this._rpcProtocol)),n.set(w.IURITransformerService,new w.URITransformerService(v)),n.set(E.IHostUtils,s);const t=new b.InstantiationService(n,!0);this._disposables.add(t.invokeFunction(h=>h.get(P.IExtHostTerminalService))),this._disposables.add(t.invokeFunction(h=>h.get(E.IExtHostExtensionService))),this._logService=t.invokeFunction(h=>h.get(y.ILogService)),D.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",g),this._extensionService=t.invokeFunction(h=>h.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const u=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(c,_)=>{let A="",R,x;for(const O of _)A+=`
	at ${O.toString()}`,x=O.getFileName(),!R&&x&&(R=h.findSubstr(i.URI.file(x)));return u.set(c,R),`${c.name||"Error"}: ${c.message||""}${A}`}});const d=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),l=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(h=>{const c=L.transformErrorForSerialization(h),_=u.get(h);_?d.$onExtensionRuntimeError(_.identifier,c):l.$onUnexpectedError(c)})}terminate(r){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${r}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(s=>{this._logService.error(s)}),this._rpcProtocol.dispose();const g=this._extensionService.deactivateAll();Promise.race([(0,m.timeout)(5e3),g]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(r,g){r.extensions.forEach(v=>v.extensionLocation=i.URI.revive(g.transformIncomingURIs(v.extensionLocation))),r.environment.appRoot=i.URI.revive(g.transformIncomingURIs(r.environment.appRoot));const s=r.environment.extensionDevelopmentLocationURI;return s&&(r.environment.extensionDevelopmentLocationURI=s.map(v=>i.URI.revive(g.transformIncomingURIs(v)))),r.environment.extensionTestsLocationURI=i.URI.revive(g.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=i.URI.revive(g.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=i.URI.revive(g.transformIncomingURIs(r.environment.workspaceStorageHome)),r.logsLocation=i.URI.revive(g.transformIncomingURIs(r.logsLocation)),r.logFile=i.URI.revive(g.transformIncomingURIs(r.logFile)),r.workspace=g.transformIncomingURIs(r.workspace),r}}e.ExtensionHostMain=p}),define(ge[272],pe([0,1,9,21,50,31,23,46,33]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class y{constructor(a,b,f){this.config=a,this.provider=b,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=a.filePattern,this.includePattern=a.includePattern&&C.parse(a.includePattern),this.maxResults=a.maxResults||void 0,this.exists=a.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=a.excludePattern&&C.parse(a.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(a=>a.cancel()),this.activeCancellationTokens=new Set}search(a){const b=this.config.folderQueries||[];return new Promise((f,w)=>{const E=P=>{this.resultCount++,a(P)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(P=>{const p=P.toString(),o=m.basename(p);this.globalExcludePattern&&this.globalExcludePattern(p,o)||this.matchFile(E,{base:P,basename:o})}),Promise.all(b.map(P=>this.searchInFolder(P,E))).then(P=>{f({limitHit:this.isLimitHit,stats:P[0]||void 0})},P=>{w(new Error((0,D.toErrorMessage)(P)))})})}async searchInFolder(a,b){const f=new L.CancellationTokenSource,w=this.getSearchOptionsForFolder(a),E=this.initDirectoryTree(),P=new S.QueryGlobTester(this.config,a),p=!P.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(f),o=k.StopWatch.create();const r=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},w,f.token),g=o.elapsed(),s=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(v=>{const n=m.posix.relative(a.folder.path,v.path);if(p){const t=m.basename(v.path);this.matchFile(b,{base:a.folder,relativePath:n,basename:t});return}this.addDirectoryEntries(E,a.folder,n,b)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(E,P,b),{providerTime:g,postProcessTime:s.elapsed()})}finally{f.dispose(),this.activeCancellationTokens.delete(f)}}getSearchOptionsForFolder(a){const b=(0,S.resolvePatternsForProvider)(this.config.includePattern,a.includePattern),f=(0,S.resolvePatternsForProvider)(this.config.excludePattern,a.excludePattern);return{folder:a.folder,excludes:f,includes:b,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}addDirectoryEntries({pathToEntries:a},b,f,w){if(f===this.filePattern){const P=m.basename(this.filePattern);this.matchFile(w,{base:b,relativePath:this.filePattern,basename:P})}function E(P){const p=m.basename(P),o=m.dirname(P);let r=a[o];r||(r=a[o]=[],E(o)),r.push({base:b,relativePath:P,basename:p})}E(f)}matchDirectoryTree({rootEntries:a,pathToEntries:b},f,w){const E=this,P=this.filePattern;function p(o){const r=C.hasSiblingFn(()=>o.map(g=>g.basename));for(let g=0,s=o.length;g<s;g++){const v=o[g],{relativePath:n,basename:t}=v;if(f.matchesExcludesSync(n,t,P!==t?r:void 0))continue;const u=b[n];if(u)p(u);else{if(n===P)continue;E.matchFile(w,v)}if(E.isLimitHit)break}}p(a)}matchFile(a,b){(!this.includePattern||b.relativePath&&this.includePattern(b.relativePath,b.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||a(b))}}class T{constructor(){this.sessions=new Map}fileSearch(a,b,f,w){const E=this.getSessionTokenSource(a.cacheKey),P=new y(a,b,E&&E.token);let p=0;const o=r=>{p+=r.length,f(r.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(P,T.BATCH_SIZE,o,w).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:r.stats}}))}clearCache(a){const b=this.getSessionTokenSource(a);b&&b.cancel()}getSessionTokenSource(a){if(!!a)return this.sessions.has(a)||this.sessions.set(a,new L.CancellationTokenSource),this.sessions.get(a)}rawMatchToSearchItem(a){return a.relativePath?{resource:i.joinPath(a.base,a.relativePath)}:{resource:a.base}}doSearch(a,b,f,w){w.onCancellationRequested(()=>{a.cancel()});const E=p=>{p&&(P.push(p),b>0&&P.length>=b&&(f(P),P=[]))};let P=[];return a.search(E).then(p=>(P.length&&f(P),p),p=>(P.length&&f(P),Promise.reject(p)))}}e.FileSearchManager=T,T.BATCH_SIZE=512}),define(ge[134],pe([0,1,17,21,50,31,10,9,23,13,2,33]),function(Y,e,m,L,D,C,i,k,S,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class a{constructor(o,r,g,s){this.query=o,this.provider=r,this.fileUtils=g,this.processType=s,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,r){const g=this.query.folderQueries||[],s=new L.CancellationTokenSource;return r.onCancellationRequested(()=>s.cancel()),new Promise((v,n)=>{this.collector=new f(o);let t=!1;const u=(d,l)=>{if(!t&&!this.isLimitHit){const h=this.resultSize(d);E(d)&&typeof this.query.maxResults=="number"&&this.resultCount+h>this.query.maxResults&&(this.isLimitHit=!0,t=!0,s.cancel(),d=this.trimResultToSize(d,this.query.maxResults-this.resultCount));const c=this.resultSize(d);this.resultCount+=c,(c>0||!E(d))&&this.collector.add(d,l)}};Promise.all(g.map((d,l)=>this.searchInFolder(d,h=>u(h,l),s.token))).then(d=>{s.dispose(),this.collector.flush();const l=d.some(h=>!!h&&!!h.limitHit);v({limitHit:this.isLimitHit||l,messages:(0,m.flatten)(d.map(h=>h?.message?(0,y.isArray)(h.message)?h.message:[h.message]:[])),stats:{type:this.processType}})},d=>{s.dispose();const l=(0,D.toErrorMessage)(d);n(new Error(l))})})}resultSize(o){return E(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,r){const g=Array.isArray(o.ranges)?o.ranges:[o.ranges],s=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:g.slice(0,r),preview:{matches:s.slice(0,r),text:o.preview.text},uri:o.uri}}async searchInFolder(o,r,g){const s=new I.QueryGlobTester(this.query,o),v=[],n={report:d=>{if(!this.validateProviderResult(d))return;const l=o.folder.scheme===i.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(d.uri))):void 0,h=S.relativePath(o.folder,d.uri);if(h){const c=s.includedInQuery(h,k.basename(h),l);(0,y.isPromise)(c)?v.push(c.then(_=>{_&&r(d)})):c&&r(d)}}},t=this.getSearchOptionsForFolder(o),u=await this.provider.provideTextSearchResults(b(this.query.contentPattern),t,n,g);return v.length&&await Promise.all(v),u}validateProviderResult(o){if(E(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const r=(0,I.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),g=(0,I.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),s={folder:T.URI.from(o.folder),excludes:g,includes:r,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return s.usePCRE2=this.query.usePCRE2,s}}e.TextSearchManager=a;function b(p){return{isCaseSensitive:p.isCaseSensitive||!1,isRegExp:p.isRegExp||!1,isWordMatch:p.isWordMatch||!1,isMultiline:p.isMultiline||!1,pattern:p.pattern}}class f{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new P(512,r=>this.sendItems(r))}add(o,r){this._currentFileMatch&&(this._currentFolderIdx!==r||!S.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=r,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(w(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=f;function w(p){return E(p)?{preview:{matches:(0,m.mapArrayOrNot)(p.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:p.preview.text},ranges:(0,m.mapArrayOrNot)(p.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:p.text,lineNumber:p.lineNumber}}function E(p){return!!p.preview}e.extensionResultIsMatch=E;class P{constructor(o,r){this.maxBatchSize=o,this.cb=r,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,r){!o||this.addItemToBatch(o,r)}addItems(o,r){!o||this.addItemsToBatch(o,r)}addItemToBatch(o,r){this.batch.push(o),this.batchSize+=r,this.onUpdate()}addItemsToBatch(o,r){this.batch=this.batch.concat(o),this.batchSize+=r,this.onUpdate()}onUpdate(){this.totalNumberCompleted<P.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},P.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=P,P.TIMEOUT=4e3,P.START_BATCH_AFTER_COUNT=50}),define(ge[72],pe([0,1,6,5,4,272,14,64,11,2,134]),function(Y,e,m,L,D,C,i,k,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let I=class{constructor(w,E,P){this.extHostRpc=w,this._uriTransformer=E,this._logService=P,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}registerTextSearchProvider(w,E){if(this._textSearchUsedSchemes.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this._textSearchUsedSchemes.add(w);const P=this._handlePool++;return this._textSearchProvider.set(P,E),this._proxy.$registerTextSearchProvider(P,this._transformScheme(w)),(0,m.toDisposable)(()=>{this._textSearchUsedSchemes.delete(w),this._textSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}registerFileSearchProvider(w,E){if(this._fileSearchUsedSchemes.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this._fileSearchUsedSchemes.add(w);const P=this._handlePool++;return this._fileSearchProvider.set(P,E),this._proxy.$registerFileSearchProvider(P,this._transformScheme(w)),(0,m.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(w),this._fileSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}$provideFileSearchResults(w,E,P,p){const o=a(P),r=this._fileSearchProvider.get(w);if(r)return this._fileSearchManager.fileSearch(o,r,g=>{this._proxy.$handleFileMatch(w,E,g.map(s=>s.resource))},p);throw new Error("unknown provider: "+w)}$clearCache(w){return this._fileSearchManager.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,E,P,p){const o=this._textSearchProvider.get(w);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const r=a(P);return this.createTextSearchManager(r,o).search(s=>this._proxy.$handleTextMatch(w,E,s),p)}$enableExtensionHostSearch(){}createTextSearchManager(w,E){return new T.TextSearchManager(w,E,{readdir:P=>Promise.resolve([]),toCanonicalName:P=>P},"textSearchProvider")}};I=Ve([He(0,i.IExtHostRpcService),He(1,k.IURITransformerService),He(2,S.ILogService)],I),e.ExtHostSearch=I;function a(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(b),extraFileResources:f.extraFileResources&&f.extraFileResources.map(w=>y.URI.revive(w))}}e.reviveQuery=a;function b(f){return{...f,folder:y.URI.revive(f.folder)}}}),define(ge[273],pe([0,1,21,15,3,48,2,113,108,146,82,42,5,231,230,38,232,36,233,234,235,216,236,45,39,237,217,240,241,242,132,219,247,248,249,91,34,251,220,16,7,254,68,133,35,73,205,239,62,130,70,55,72,11,64,14,26,243,202,52,65,228,252,201,67,66,257,255,256,229,44,250,253,90,54,121,245,69,246,10,189,244,199,238,6,29]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E,P,p,o,r,g,s,v,n,t,u,d,l,h,c,_,A,R,x,O,F,$,M,B,U,z,K,N,j,H,V,q,te,fe,Ce,ke,Ue,xe,ze,Q,Z,re,ue,J,ie,we,Me,je,Ke,Ze,rt,ut,it,st,Ae,wt,ee,se,Se,Ge,Ye,nt,he,Ie,Be,We,tt,Te,ye,be){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ae(de){const ve=de.get(Z.IExtHostInitDataService),Ee=de.get(Ae.IExtHostFileSystemInfo),Fe=de.get(Ze.IExtHostConsumerFileSystem),Qe=de.get(n.IExtHostExtensionService),$e=de.get(j.IExtHostWorkspace),Xe=de.get(Ge.IExtHostTelemetry),at=de.get(P.IExtHostConfiguration),ct=de.get(ze.IURITransformerService),ce=de.get(Q.IExtHostRpcService),_e=de.get(O.IExtHostStorage),le=de.get(Ke.IExtensionStoragePaths),X=de.get(xe.ILoggerService),De=de.get(xe.ILogService),Le=de.get(J.IExtHostTunnelService),et=de.get(ie.IExtHostApiDeprecationService),qe=de.get(N.IExtHostWindow),mt=de.get(se.IExtHostSecretState),_t=de.get(Se.IExtHostEditorTabs);ce.set(a.ExtHostContext.ExtHostFileSystemInfo,Ee),ce.set(a.ExtHostContext.ExtHostLogLevelServiceShape,X),ce.set(a.ExtHostContext.ExtHostWorkspace,$e),ce.set(a.ExtHostContext.ExtHostConfiguration,at),ce.set(a.ExtHostContext.ExtHostExtensionService,Qe),ce.set(a.ExtHostContext.ExtHostStorage,_e),ce.set(a.ExtHostContext.ExtHostTunnelService,Le),ce.set(a.ExtHostContext.ExtHostWindow,qe),ce.set(a.ExtHostContext.ExtHostSecretState,mt),ce.set(a.ExtHostContext.ExtHostTelemetry,Xe),ce.set(a.ExtHostContext.ExtHostEditorTabs,_t);const kt=ce.set(a.ExtHostContext.ExtHostDecorations,de.get(fe.IExtHostDecorations)),bt=ce.set(a.ExtHostContext.ExtHostDocumentsAndEditors,de.get(v.IExtHostDocumentsAndEditors)),gt=ce.set(a.ExtHostContext.ExtHostCommands,de.get(w.IExtHostCommands)),Et=ce.set(a.ExtHostContext.ExtHostTerminalService,de.get(F.IExtHostTerminalService)),Ct=ce.set(a.ExtHostContext.ExtHostDebugService,de.get(ke.IExtHostDebugService)),Lt=ce.set(a.ExtHostContext.ExtHostSearch,de.get(Ue.IExtHostSearch)),yt=ce.set(a.ExtHostContext.ExtHostTask,de.get(Ce.IExtHostTask)),At=ce.set(a.ExtHostContext.ExtHostOutputService,de.get(c.IExtHostOutputService)),xt=ce.set(a.ExtHostContext.ExtHostUrls,new z.ExtHostUrls(ce)),Tt=ce.set(a.ExtHostContext.ExtHostDocuments,new s.ExtHostDocuments(ce,bt)),Bt=ce.set(a.ExtHostContext.ExtHostDocumentContentProviders,new r.ExtHostDocumentContentProvider(ce,bt,De)),Ht=ce.set(a.ExtHostContext.ExtHostDocumentSaveParticipant,new g.ExtHostDocumentSaveParticipant(De,Tt,ce.getProxy(a.MainContext.MainThreadBulkEdits))),St=ce.set(a.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(ce,gt,bt,Tt,le)),Qt=ce.set(a.ExtHostContext.ExtHostNotebookDocuments,new tt.ExtHostNotebookDocuments(De,St)),Vt=ce.set(a.ExtHostContext.ExtHostNotebookEditors,new We.ExtHostNotebookEditors(De,ce,St)),si=ce.set(a.ExtHostContext.ExtHostNotebookKernels,new Ye.ExtHostNotebookKernels(ce,ve,St,gt,De)),oi=ce.set(a.ExtHostContext.ExtHostNotebookRenderers,new he.ExtHostNotebookRenderers(ce,St)),Rt=ce.set(a.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(ce,bt)),Xt=ce.set(a.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(ce.getProxy(a.MainContext.MainThreadTreeViews),gt,De)),ai=ce.set(a.ExtHostContext.ExtHostEditorInsets,new V.ExtHostEditorInsets(ce.getProxy(a.MainContext.MainThreadEditorInsets),Rt,ve)),Yt=ce.set(a.ExtHostContext.ExtHostDiagnostics,new p.ExtHostDiagnostics(ce,De,Ee)),zt=ce.set(a.ExtHostContext.ExtHostLanguages,new l.ExtHostLanguages(ce,Tt,gt.converter,ct)),vt=ce.set(a.ExtHostContext.ExtHostLanguageFeatures,new d.ExtHostLanguageFeatures(ce,ct,Tt,gt,Yt,De,et)),li=ce.set(a.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(ce,vt)),Mt=ce.set(a.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(ce,De,bt)),jt=ce.set(a.ExtHostContext.ExtHostQuickOpen,(0,A.createExtHostQuickOpen)(ce,$e,gt)),Jt=ce.set(a.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(ce,gt,De)),ci=ce.set(a.ExtHostContext.ExtHostComments,(0,E.createExtHostComments)(ce,gt,Tt)),fi=ce.set(a.ExtHostContext.ExtHostProgress,new _.ExtHostProgress(ce.getProxy(a.MainContext.MainThreadProgress))),Ei=ce.set(a.ExtHostContext.ExtHosLabelService,new q.ExtHostLabelService(ce)),mi=ce.set(a.ExtHostContext.ExtHostTheming,new ue.ExtHostTheming(ce)),Zt=ce.set(a.ExtHostContext.ExtHostAuthentication,new we.ExtHostAuthentication(ce)),_i=ce.set(a.ExtHostContext.ExtHostTimeline,new Me.ExtHostTimeline(ce,gt)),qt=ce.set(a.ExtHostContext.ExtHostWebviews,new K.ExtHostWebviews(ce,{remote:ve.remote},$e,De,et)),Gt=ce.set(a.ExtHostContext.ExtHostWebviewPanels,new it.ExtHostWebviewPanels(ce,qt,$e)),Si=ce.set(a.ExtHostContext.ExtHostCustomEditors,new ut.ExtHostCustomEditors(ce,Tt,le,qt,Gt)),Ci=ce.set(a.ExtHostContext.ExtHostWebviewViews,new rt.ExtHostWebviewViews(ce,qt)),Kt=ce.set(a.ExtHostContext.ExtHostTesting,new wt.ExtHostTesting(ce,gt)),yi=ce.set(a.ExtHostContext.ExtHostUriOpeners,new ee.ExtHostUriOpeners(ce));ce.set(a.ExtHostContext.ExtHostInteractive,new Te.ExtHostInteractive(ce,St,bt,gt));const ei=(0,H.values)(a.ExtHostContext);ce.assertRegistered(ei);const Di=new st.ExtHostBulkEdits(ce,bt),ki=new f.ExtHostClipboard(ce),ui=new h.ExtHostMessageService(ce,De),ti=new o.ExtHostDialogs(ce),gi=new x.ExtHostStatusBar(ce,gt.converter);return b.ExtHostApiCommands.register(gt),function(Ne,Ot,pi){const pt=function(){let ne=!Ne.isUnderDevelopment;function me(){ne||(De.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Re(ht){if(Array.isArray(ht))ht.forEach(Re);else if(typeof ht=="string")me();else{const Dt=ht;typeof Dt.scheme=="undefined"&&me(),typeof Dt.exclusive=="boolean"&&(0,be.checkProposedApiEnabled)(Ne,"documentFiltersExclusive")}return ht}}(),ii={getSession(ne,me,Re){return Zt.getSession(Ne,ne,me,Re)},async hasSession(ne,me){return(0,be.checkProposedApiEnabled)(Ne,"authSession"),!!await Zt.getSession(Ne,ne,me,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(ne,me,Re,ht){return Zt.registerAuthenticationProvider(ne,me,Re,ht)}},Ii={registerCommand(ne,me,Re){return gt.registerCommand(!0,ne,me,Re,void 0,Ne)},registerTextEditorCommand(ne,me,Re){return gt.registerCommand(!0,ne,(...ht)=>{const Dt=Rt.getActiveTextEditor();if(!Dt){De.warn("Cannot execute "+ne+" because there is no active text editor.");return}return Dt.edit(It=>{me.apply(Re,[Dt,It,...ht])}).then(It=>{It||De.warn("Edits from command "+ne+" were not applied.")},It=>{De.warn("An error occurred while running command "+ne,It)})},void 0,void 0,Ne)},registerDiffInformationCommand:(ne,me,Re)=>((0,be.checkProposedApiEnabled)(Ne,"diffCommand"),gt.registerCommand(!0,ne,async(...ht)=>{const Dt=bt.activeEditor(!0);if(!Dt){De.warn("Cannot execute "+ne+" because there is no active text editor.");return}const It=await Rt.getDiffInformation(Dt.id);me.apply(Re,[It,...ht])},void 0,void 0,Ne)),executeCommand(ne,...me){return gt.executeCommand(ne,...me)},getCommands(ne=!1){return gt.getCommands(ne)}},vi={get machineId(){return ve.telemetryInfo.machineId},get sessionId(){return ve.telemetryInfo.sessionId},get language(){return ve.environment.appLanguage},get appName(){return ve.environment.appName},get appRoot(){return ve.environment.appRoot?.fsPath??""},get appHost(){return ve.environment.appHost},get uriScheme(){return ve.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return Et.getDefaultShell(!1)},get isTelemetryEnabled(){return Xe.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Xe.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ne=Date.now()-new Date(ve.telemetryInfo.firstSessionDate).getTime();return isNaN(ne)?!1:ne<1e3*60*60*24},openExternal(ne,me){return qe.openUri(ne,{allowTunneling:!!ve.remote.authority,allowContributedOpeners:me?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===ve.environment.appUriScheme)return xt.createAppUri(ne);try{return await qe.asExternalUri(ne,{allowTunneling:!!ve.remote.authority})}catch(me){if((0,Be.matchesScheme)(ne,Ie.Schemas.http)||(0,Be.matchesScheme)(ne,Ie.Schemas.https))return ne;throw me}},get remoteName(){return(0,te.getRemoteName)(ve.remote.authority)},get remoteAuthority(){return(0,be.checkProposedApiEnabled)(Ne,"resolvers"),ve.remote.authority},get uiKind(){return ve.uiKind}};ve.environment.extensionTestsLocationURI||Object.freeze(vi);const wi=ve.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,Pi={createTestController(ne,me){return Kt.createTestController(ne,me)},createTestObserver(){return(0,be.checkProposedApiEnabled)(Ne,"testObserver"),Kt.createTestObserver()},runTests(ne){return(0,be.checkProposedApiEnabled)(Ne,"testObserver"),Kt.runTests(ne)},get onDidChangeTestResults(){return(0,be.checkProposedApiEnabled)(Ne,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,be.checkProposedApiEnabled)(Ne,"testObserver"),Kt.results}},Ti={getExtension(ne){const me=Ot.getExtensionDescription(ne);if(me)return new n.Extension(Qe,Ne.identifier,me,wi)},get all(){return Ot.getAllExtensionDescriptions().map(ne=>new n.Extension(Qe,Ne.identifier,ne,wi))},get onDidChange(){return Ot.onDidChange}},Ai={createDiagnosticCollection(ne){return Yt.createDiagnosticCollection(Ne.identifier,ne)},get onDidChangeDiagnostics(){return Yt.onDidChangeDiagnostics},getDiagnostics:ne=>Yt.getDiagnostics(ne),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(ne,me){return zt.changeLanguage(ne.uri,me)},match(ne,me){return(0,T.score)(B.LanguageSelector.from(ne),me.uri,me.languageId,!0)},registerCodeActionsProvider(ne,me,Re){return vt.registerCodeActionProvider(Ne,pt(ne),me,Re)},registerCodeLensProvider(ne,me){return vt.registerCodeLensProvider(Ne,pt(ne),me)},registerDefinitionProvider(ne,me){return vt.registerDefinitionProvider(Ne,pt(ne),me)},registerDeclarationProvider(ne,me){return vt.registerDeclarationProvider(Ne,pt(ne),me)},registerImplementationProvider(ne,me){return vt.registerImplementationProvider(Ne,pt(ne),me)},registerTypeDefinitionProvider(ne,me){return vt.registerTypeDefinitionProvider(Ne,pt(ne),me)},registerHoverProvider(ne,me){return vt.registerHoverProvider(Ne,pt(ne),me,Ne.identifier)},registerEvaluatableExpressionProvider(ne,me){return vt.registerEvaluatableExpressionProvider(Ne,pt(ne),me,Ne.identifier)},registerInlineValuesProvider(ne,me){return vt.registerInlineValuesProvider(Ne,pt(ne),me,Ne.identifier)},registerDocumentHighlightProvider(ne,me){return vt.registerDocumentHighlightProvider(Ne,pt(ne),me)},registerLinkedEditingRangeProvider(ne,me){return vt.registerLinkedEditingRangeProvider(Ne,pt(ne),me)},registerReferenceProvider(ne,me){return vt.registerReferenceProvider(Ne,pt(ne),me)},registerRenameProvider(ne,me){return vt.registerRenameProvider(Ne,pt(ne),me)},registerDocumentSymbolProvider(ne,me,Re){return vt.registerDocumentSymbolProvider(Ne,pt(ne),me,Re)},registerWorkspaceSymbolProvider(ne){return vt.registerWorkspaceSymbolProvider(Ne,ne)},registerDocumentFormattingEditProvider(ne,me){return vt.registerDocumentFormattingEditProvider(Ne,pt(ne),me)},registerDocumentRangeFormattingEditProvider(ne,me){return vt.registerDocumentRangeFormattingEditProvider(Ne,pt(ne),me)},registerOnTypeFormattingEditProvider(ne,me,Re,...ht){return vt.registerOnTypeFormattingEditProvider(Ne,pt(ne),me,[Re].concat(ht))},registerDocumentSemanticTokensProvider(ne,me,Re){return vt.registerDocumentSemanticTokensProvider(Ne,pt(ne),me,Re)},registerDocumentRangeSemanticTokensProvider(ne,me,Re){return vt.registerDocumentRangeSemanticTokensProvider(Ne,pt(ne),me,Re)},registerSignatureHelpProvider(ne,me,Re,...ht){return typeof Re=="object"?vt.registerSignatureHelpProvider(Ne,pt(ne),me,Re):vt.registerSignatureHelpProvider(Ne,pt(ne),me,typeof Re=="undefined"?[]:[Re,...ht])},registerCompletionItemProvider(ne,me,...Re){return vt.registerCompletionItemProvider(Ne,pt(ne),me,Re)},registerInlineCompletionItemProvider(ne,me){return(0,be.checkProposedApiEnabled)(Ne,"inlineCompletions"),vt.registerInlineCompletionsProvider(Ne,pt(ne),me)},registerDocumentLinkProvider(ne,me){return vt.registerDocumentLinkProvider(Ne,pt(ne),me)},registerColorProvider(ne,me){return vt.registerColorProvider(Ne,pt(ne),me)},registerFoldingRangeProvider(ne,me){return vt.registerFoldingRangeProvider(Ne,pt(ne),me)},registerSelectionRangeProvider(ne,me){return vt.registerSelectionRangeProvider(Ne,ne,me)},registerCallHierarchyProvider(ne,me){return vt.registerCallHierarchyProvider(Ne,ne,me)},registerTypeHierarchyProvider(ne,me){return vt.registerTypeHierarchyProvider(Ne,ne,me)},setLanguageConfiguration:(ne,me)=>vt.setLanguageConfiguration(Ne,ne,me),getTokenInformationAtPosition(ne,me){return(0,be.checkProposedApiEnabled)(Ne,"tokenInformation"),zt.tokenAtPosition(ne,me)},registerInlayHintsProvider(ne,me){return(0,be.checkProposedApiEnabled)(Ne,"inlayHints"),vt.registerInlayHintsProvider(Ne,ne,me)},createLanguageStatusItem(ne,me){return(0,be.checkProposedApiEnabled)(Ne,"languageStatus"),zt.createLanguageStatusItem(Ne,ne,me)}},Ri={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return Et.activeTerminal},get terminals(){return Et.terminals},async showTextDocument(ne,me,Re){const ht=await(i.URI.isUri(ne)?Promise.resolve(ni.openTextDocument(ne)):Promise.resolve(ne));return Rt.showTextDocument(ht,me,Re)},createTextEditorDecorationType(ne){return Rt.createTextEditorDecorationType(Ne,ne)},onDidChangeActiveTextEditor(ne,me,Re){return Rt.onDidChangeActiveTextEditor(ne,me,Re)},onDidChangeVisibleTextEditors(ne,me,Re){return Rt.onDidChangeVisibleTextEditors(ne,me,Re)},onDidChangeTextEditorSelection(ne,me,Re){return Rt.onDidChangeTextEditorSelection(ne,me,Re)},onDidChangeTextEditorOptions(ne,me,Re){return Rt.onDidChangeTextEditorOptions(ne,me,Re)},onDidChangeTextEditorVisibleRanges(ne,me,Re){return Rt.onDidChangeTextEditorVisibleRanges(ne,me,Re)},onDidChangeTextEditorViewColumn(ne,me,Re){return Rt.onDidChangeTextEditorViewColumn(ne,me,Re)},onDidCloseTerminal(ne,me,Re){return Et.onDidCloseTerminal(ne,me,Re)},onDidOpenTerminal(ne,me,Re){return Et.onDidOpenTerminal(ne,me,Re)},onDidChangeActiveTerminal(ne,me,Re){return Et.onDidChangeActiveTerminal(ne,me,Re)},onDidChangeTerminalDimensions(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"terminalDimensions"),Et.onDidChangeTerminalDimensions(ne,me,Re)},onDidChangeTerminalState(ne,me,Re){return Et.onDidChangeTerminalState(ne,me,Re)},onDidWriteTerminalData(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"terminalDataWriteEvent"),Et.onDidWriteTerminalData(ne,me,Re)},get state(){return qe.state},onDidChangeWindowState(ne,me,Re){return qe.onDidChangeWindowState(ne,me,Re)},showInformationMessage(ne,...me){return ui.showMessage(Ne,C.default.Info,ne,me[0],me.slice(1))},showWarningMessage(ne,...me){return ui.showMessage(Ne,C.default.Warning,ne,me[0],me.slice(1))},showErrorMessage(ne,...me){return ui.showMessage(Ne,C.default.Error,ne,me[0],me.slice(1))},showQuickPick(ne,me,Re){return Array.isArray(ne)&&ne.some(ht=>ht.kind!==void 0)&&(0,be.checkProposedApiEnabled)(Ne,"quickPickSeparators"),jt.showQuickPick(ne,me,Re)},showWorkspaceFolderPick(ne){return jt.showWorkspaceFolderPick(ne)},showInputBox(ne,me){return jt.showInput(ne,me)},showOpenDialog(ne){return ti.showOpenDialog(ne)},showSaveDialog(ne){return ti.showSaveDialog(ne)},createStatusBarItem(ne,me,Re){let ht,Dt,It;return typeof ne=="string"?(ht=ne,Dt=me,It=Re):(Dt=ne,It=me),gi.createStatusBarEntry(Ne,ht,Dt,It)},setStatusBarMessage(ne,me){return gi.setStatusBarMessage(ne,me)},withScmProgress(ne){return et.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),fi.withProgress(Ne,{location:U.ProgressLocation.SourceControl},(me,Re)=>ne({report(ht){}}))},withProgress(ne,me){return fi.withProgress(Ne,ne,me)},createOutputChannel(ne){return At.createOutputChannel(ne,Ne)},createWebviewPanel(ne,me,Re,ht){return Gt.createWebviewPanel(Ne,ne,me,Re,ht)},createWebviewTextEditorInset(ne,me,Re,ht){return(0,be.checkProposedApiEnabled)(Ne,"editorInsets"),ai.createWebviewEditorInset(ne,me,Re,ht,Ne)},createTerminal(ne,me,Re){return typeof ne=="object"?("location"in ne&&(0,be.checkProposedApiEnabled)(Ne,"terminalLocation"),"pty"in ne?Et.createExtensionTerminal(ne):Et.createTerminalFromOptions(ne)):Et.createTerminal(ne,me,Re)},registerTerminalLinkProvider(ne){return Et.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,me){return Et.registerProfileProvider(Ne,ne,me)},registerTreeDataProvider(ne,me){return Xt.registerTreeDataProvider(ne,me,Ne)},createTreeView(ne,me){return Xt.createTreeView(ne,me,Ne)},registerWebviewPanelSerializer:(ne,me)=>Gt.registerWebviewPanelSerializer(Ne,ne,me),registerCustomEditorProvider:(ne,me,Re={})=>Si.registerCustomEditorProvider(Ne,ne,me,Re),registerFileDecorationProvider(ne){return kt.registerFileDecorationProvider(ne,Ne.identifier)},registerUriHandler(ne){return xt.registerUriHandler(Ne.identifier,ne)},createQuickPick(){return jt.createQuickPick(Ne)},createInputBox(){return jt.createInputBox(Ne.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(ne,me,Re){return mi.onDidChangeActiveColorTheme(ne,me,Re)},registerWebviewViewProvider(ne,me,Re){return Ci.registerWebviewViewProvider(Ne,ne,me,Re?.webviewOptions)},get activeNotebookEditor(){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),St.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),St.onDidChangeActiveNotebookEditor(ne,me,Re)},get visibleNotebookEditors(){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),Vt.onDidChangeNotebookEditorSelection(ne,me,Re)},onDidChangeNotebookEditorVisibleRanges(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),Vt.onDidChangeNotebookEditorVisibleRanges(ne,me,Re)},showNotebookDocument(ne,me){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),St.showNotebookDocument(ne,me)},registerExternalUriOpener(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"externalUriOpener"),yi.registerExternalUriOpener(Ne.identifier,ne,me,Re)},get tabs(){return(0,be.checkProposedApiEnabled)(Ne,"tabs"),_t.tabs},get activeTab(){return(0,be.checkProposedApiEnabled)(Ne,"tabs"),_t.activeTab},get onDidChangeTabs(){return(0,be.checkProposedApiEnabled)(Ne,"tabs"),_t.onDidChangeTabs},get onDidChangeActiveTab(){return(0,be.checkProposedApiEnabled)(Ne,"tabs"),_t.onDidChangeActiveTab},getInlineCompletionItemController(ne){return(0,be.checkProposedApiEnabled)(Ne,"inlineCompletions"),d.InlineCompletionController.get(ne)}},ni={get rootPath(){return et.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),$e.getPath()},set rootPath(ne){throw L.readonly()},getWorkspaceFolder(ne){return $e.getWorkspaceFolder(ne)},get workspaceFolders(){return $e.getWorkspaceFolders()},get name(){return $e.name},set name(ne){throw L.readonly()},get workspaceFile(){return $e.workspaceFile},set workspaceFile(ne){throw L.readonly()},updateWorkspaceFolders:(ne,me,...Re)=>$e.updateWorkspaceFolders(Ne,ne,me||0,...Re),onDidChangeWorkspaceFolders:function(ne,me,Re){return $e.onDidChangeWorkspace(ne,me,Re)},asRelativePath:(ne,me)=>$e.getRelativePath(ne,me),findFiles:(ne,me,Re,ht)=>$e.findFiles(B.GlobPattern.from(ne),B.GlobPattern.from(me),Re,Ne.identifier,ht),findTextInFiles:(ne,me,Re,ht)=>{(0,be.checkProposedApiEnabled)(Ne,"findTextInFiles");let Dt,It;return typeof me=="object"?(Dt=me,It=Re):(Dt={},It=me,ht=Re),$e.findTextInFiles(ne,Dt||{},It,Ne.identifier,ht)},saveAll:ne=>$e.saveAll(ne),applyEdit(ne){return Di.applyWorkspaceEdit(ne)},createFileSystemWatcher:(ne,me,Re,ht)=>Mt.createFileSystemWatcher(B.GlobPattern.from(ne),me,Re,ht),get textDocuments(){return Tt.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw L.readonly()},openTextDocument(ne){let me;const Re=ne;if(typeof ne=="string")me=Promise.resolve(i.URI.file(ne));else if(i.URI.isUri(ne))me=Promise.resolve(ne);else if(!Re||typeof Re=="object")me=Tt.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return me.then(ht=>Tt.ensureDocumentData(ht).then(Dt=>Dt.document))},onDidOpenTextDocument:(ne,me,Re)=>Tt.onDidAddDocument(ne,me,Re),onDidCloseTextDocument:(ne,me,Re)=>Tt.onDidRemoveDocument(ne,me,Re),onDidChangeTextDocument:(ne,me,Re)=>Tt.onDidChangeDocument(ne,me,Re),onDidSaveTextDocument:(ne,me,Re)=>Tt.onDidSaveDocument(ne,me,Re),onWillSaveTextDocument:(ne,me,Re)=>Ht.getOnWillSaveTextDocumentEvent(Ne)(ne,me,Re),get notebookDocuments(){return St.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,me){let Re;if(i.URI.isUri(ne))Re=ne,await St.openNotebookDocument(ne);else if(typeof ne=="string")Re=i.URI.revive(await St.createNotebookDocument({viewType:ne,content:me}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Re).apiNotebook},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(ne,me,Re,ht){return St.registerNotebookSerializer(Ne,ne,me,Re,(0,be.isProposedApiEnabled)(Ne,"notebookLiveShare")?ht:void 0)},registerNotebookContentProvider:(ne,me,Re,ht)=>((0,be.checkProposedApiEnabled)(Ne,"notebookContentProvider"),St.registerNotebookContentProvider(Ne,ne,me,Re,(0,be.isProposedApiEnabled)(Ne,"notebookLiveShare")?ht:void 0)),onDidChangeConfiguration:(ne,me,Re)=>pi.onDidChangeConfiguration(ne,me,Re),getConfiguration(ne,me){return me=arguments.length===1?void 0:me,pi.getConfiguration(ne,me,Ne)},registerTextDocumentContentProvider(ne,me){return Bt.registerTextDocumentContentProvider(ne,me)},registerTaskProvider:(ne,me)=>(et.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Ne,ne,me)),registerFileSystemProvider(ne,me,Re){return(0,ye.combinedDisposable)(li.registerFileSystemProvider(Ne,ne,me,Re),Fe.addFileSystemProvider(ne,me))},get fs(){return Fe.value},registerFileSearchProvider:(ne,me)=>((0,be.checkProposedApiEnabled)(Ne,"fileSearchProvider"),Lt.registerFileSearchProvider(ne,me)),registerTextSearchProvider:(ne,me)=>((0,be.checkProposedApiEnabled)(Ne,"textSearchProvider"),Lt.registerTextSearchProvider(ne,me)),registerRemoteAuthorityResolver:(ne,me)=>((0,be.checkProposedApiEnabled)(Ne,"resolvers"),Qe.registerRemoteAuthorityResolver(ne,me)),registerResourceLabelFormatter:ne=>((0,be.checkProposedApiEnabled)(Ne,"resolvers"),Ei.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,me,Re)=>Mt.onDidCreateFile(ne,me,Re),onDidDeleteFiles:(ne,me,Re)=>Mt.onDidDeleteFile(ne,me,Re),onDidRenameFiles:(ne,me,Re)=>Mt.onDidRenameFile(ne,me,Re),onWillCreateFiles:(ne,me,Re)=>Mt.getOnWillCreateFileEvent(Ne)(ne,me,Re),onWillDeleteFiles:(ne,me,Re)=>Mt.getOnWillDeleteFileEvent(Ne)(ne,me,Re),onWillRenameFiles:(ne,me,Re)=>Mt.getOnWillRenameFileEvent(Ne)(ne,me,Re),openTunnel:ne=>((0,be.checkProposedApiEnabled)(Ne,"resolvers"),Le.openTunnel(Ne,ne).then(me=>{if(!me)throw new Error("cannot open tunnel");return me})),get tunnels(){return(0,be.checkProposedApiEnabled)(Ne,"resolvers"),Le.getTunnels()},onDidChangeTunnels:(ne,me,Re)=>((0,be.checkProposedApiEnabled)(Ne,"resolvers"),Le.onDidChangeTunnels(ne,me,Re)),registerPortAttributesProvider:(ne,me)=>((0,be.checkProposedApiEnabled)(Ne,"portsAttributes"),Le.registerPortsAttributesProvider(ne,me)),registerTimelineProvider:(ne,me)=>((0,be.checkProposedApiEnabled)(Ne,"timeline"),_i.registerTimelineProvider(ne,me,Ne.identifier,gt.converter)),get isTrusted(){return $e.trusted},requestWorkspaceTrust:ne=>((0,be.checkProposedApiEnabled)(Ne,"workspaceTrust"),$e.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,me,Re)=>$e.onDidGrantWorkspaceTrust(ne,me,Re)},Li={get inputBox(){return et.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Ne)},createSourceControl(ne,me,Re){return Jt.createSourceControl(Ne,ne,me,Re)}},Fi={createCommentController(ne,me){return ci.createCommentController(Ne,ne,me)}},Mi={get activeDebugSession(){return Ct.activeDebugSession},get activeDebugConsole(){return Ct.activeDebugConsole},get breakpoints(){return Ct.breakpoints},onDidStartDebugSession(ne,me,Re){return Ct.onDidStartDebugSession(ne,me,Re)},onDidTerminateDebugSession(ne,me,Re){return Ct.onDidTerminateDebugSession(ne,me,Re)},onDidChangeActiveDebugSession(ne,me,Re){return Ct.onDidChangeActiveDebugSession(ne,me,Re)},onDidReceiveDebugSessionCustomEvent(ne,me,Re){return Ct.onDidReceiveDebugSessionCustomEvent(ne,me,Re)},onDidChangeBreakpoints(ne,me,Re){return Ct.onDidChangeBreakpoints(ne,me,Re)},registerDebugConfigurationProvider(ne,me,Re){return Ct.registerDebugConfigurationProvider(ne,me,Re||U.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,me){return Ct.registerDebugAdapterDescriptorFactory(Ne,ne,me)},registerDebugAdapterTrackerFactory(ne,me){return Ct.registerDebugAdapterTrackerFactory(ne,me)},startDebugging(ne,me,Re){return!Re||typeof Re=="object"&&"configuration"in Re?Ct.startDebugging(ne,me,{parentSession:Re}):Ct.startDebugging(ne,me,Re||{})},stopDebugging(ne){return Ct.stopDebugging(ne)},addBreakpoints(ne){return Ct.addBreakpoints(ne)},removeBreakpoints(ne){return Ct.removeBreakpoints(ne)},asDebugSourceUri(ne,me){return Ct.asDebugSourceUri(ne,me)}},Oi={registerTaskProvider:(ne,me)=>yt.registerTaskProvider(Ne,ne,me),fetchTasks:ne=>yt.fetchTasks(ne),executeTask:ne=>yt.executeTask(Ne,ne),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(ne,me,Re)=>yt.onDidStartTask(ne,me,Re),onDidEndTask:(ne,me,Re)=>yt.onDidEndTask(ne,me,Re),onDidStartTaskProcess:(ne,me,Re)=>yt.onDidStartTaskProcess(ne,me,Re),onDidEndTaskProcess:(ne,me,Re)=>yt.onDidEndTaskProcess(ne,me,Re)},Ni={createNotebookController(ne,me,Re,ht,Dt){return si.createNotebookController(Ne,ne,me,Re,ht,(0,be.isProposedApiEnabled)(Ne,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,me)=>St.registerNotebookCellStatusBarItemProvider(Ne,ne,me),get onDidSaveNotebookDocument(){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ne){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditorDecorationType"),Vt.createNotebookEditorDecorationType(ne)},createRendererMessaging(ne){return oi.createRendererMessaging(Ne,ne)},onDidChangeNotebookDocumentMetadata(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),Qt.onDidChangeNotebookDocumentMetadata(ne,me,Re)},onDidChangeNotebookCells(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),St.onDidChangeNotebookCells(ne,me,Re)},onDidChangeNotebookCellExecutionState(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"notebookCellExecutionState"),St.onDidChangeNotebookCellExecutionState(ne,me,Re)},onDidChangeCellOutputs(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),St.onDidChangeCellOutputs(ne,me,Re)},onDidChangeCellMetadata(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),St.onDidChangeCellMetadata(ne,me,Re)},createConcatTextDocument(ne,me){return(0,be.checkProposedApiEnabled)(Ne,"notebookConcatTextDocument"),new je.ExtHostNotebookConcatDocument(St,Tt,ne,me)}};return{version:ve.version,authentication:ii,commands:Ii,comments:Fi,debug:Mi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Li,tasks:Oi,tests:Pi,window:Ri,workspace:ni,Breakpoint:U.Breakpoint,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:a.CandidatePortSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTriggerKind:U.CodeActionTriggerKind,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:U.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,InlineValueText:U.InlineValueText,InlineValueVariableLookup:U.InlineValueVariableLookup,InlineValueEvaluatableExpression:U.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:U.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,InlineCompletionItem:U.InlineSuggestion,InlineCompletionList:U.InlineSuggestions,Hover:U.Hover,IndentAction:y.IndentAction,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:U.ParameterInformation,PortAutoForwardAction:U.PortAutoForwardAction,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TerminalLink:U.TerminalLink,TerminalLocation:U.TerminalLocation,TerminalProfile:U.TerminalProfile,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,TextDocumentChangeReason:U.TextDocumentChangeReason,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItemCollapsibleState:U.TreeItemCollapsibleState,TypeHierarchyItem:U.TypeHierarchyItem,UIKind:a.UIKind,Uri:i.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,InlayHint:U.InlayHint,InlayHintKind:U.InlayHintKind,RemoteAuthorityResolverError:U.RemoteAuthorityResolverError,ResolvedAuthority:U.ResolvedAuthority,SourceControlInputBoxValidationType:U.SourceControlInputBoxValidationType,ExtensionRuntime:U.ExtensionRuntime,TimelineItem:U.TimelineItem,NotebookRange:U.NotebookRange,NotebookCellKind:U.NotebookCellKind,NotebookCellExecutionState:U.NotebookCellExecutionState,NotebookCellData:U.NotebookCellData,NotebookData:U.NotebookData,NotebookRendererScript:U.NotebookRendererScript,NotebookCellStatusBarAlignment:U.NotebookCellStatusBarAlignment,NotebookEditorRevealType:U.NotebookEditorRevealType,NotebookCellOutput:U.NotebookCellOutput,NotebookCellOutputItem:U.NotebookCellOutputItem,NotebookCellStatusBarItem:U.NotebookCellStatusBarItem,NotebookControllerAffinity:U.NotebookControllerAffinity,PortAttributes:U.PortAttributes,LinkedEditingRanges:U.LinkedEditingRanges,TestResultState:U.TestResultState,TestRunRequest:U.TestRunRequest,TestMessage:U.TestMessage,TestTag:U.TestTag,TestRunProfileKind:U.TestRunProfileKind,TextSearchCompleteMessageType:nt.TextSearchCompleteMessageType,TreeDataTransfer:U.TreeDataTransfer,TreeDataTransferItem:U.TreeDataTransferItem,CoveredCount:U.CoveredCount,FileCoverage:U.FileCoverage,StatementCoverage:U.StatementCoverage,BranchCoverage:U.BranchCoverage,FunctionCoverage:U.FunctionCoverage,WorkspaceTrustState:U.WorkspaceTrustState,LanguageStatusSeverity:U.LanguageStatusSeverity,QuickPickItemKind:U.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=ae}),define(ge[274],pe([0,1,83,132,35,130,36,38,45,34,70,55,72,91,52,65,133,66,44,90,121,54,131,11,226]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E,P,p,o,r,g,s,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(v.ILoggerService,s.ExtHostLoggerService),(0,m.registerSingleton)(v.ILogService,n.ExtHostLogService),(0,m.registerSingleton)(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService),(0,m.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,m.registerSingleton)(i.IExtHostConfiguration,i.ExtHostConfiguration),(0,m.registerSingleton)(P.IExtHostConsumerFileSystem,P.ExtHostConsumerFileSystem),(0,m.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,m.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,m.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,m.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo),(0,m.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,m.registerSingleton)(a.IExtHostSearch,a.ExtHostSearch),(0,m.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage),(0,m.registerSingleton)(T.IExtHostTask,T.WorkerExtHostTask),(0,m.registerSingleton)(y.IExtHostTerminalService,y.WorkerExtHostTerminalService),(0,m.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService),(0,m.registerSingleton)(E.IExtHostWindow,E.ExtHostWindow),(0,m.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace),(0,m.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,m.registerSingleton)(r.IExtHostTelemetry,r.ExtHostTelemetry),(0,m.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs)}),define(ge[92],pe([0,1,17,11,33,69]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function i(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=i;function k(I,a,b,f){const w=(0,m.mapArrayOrNot)(b,S),E=new D.TextSearchMatch(a,w,f),P=E.preview.matches;return{ranges:(0,m.mapArrayOrNot)(w,y),uri:I,preview:{text:E.preview.text,matches:(0,m.mapArrayOrNot)(P,y)}}}e.createTextSearchResult=k;function S(I){return new D.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function y(I){return new C.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let T=class{constructor(a,b){this.prefix=a,this.logService=b}appendLine(a){this.logService.debug(`${this.prefix}#search`,a)}};T=Ve([He(1,L.ILogService)],T),e.OutputChannel=T}),define(ge[275],pe([0,1,95,22]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function D(s){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(v=>v===s)}e.isUTFEncoding=D,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,i=512,k=512*8,S=512*128;class y{constructor(v){this.iconvLiteDecoder=v}static async create(v){let n;if(v!==e.UTF8)n=(await new Promise((u,d)=>{Y(["iconv-lite-umd"],u,d)})).getDecoder(b(v));else{const t=new TextDecoder;n={write(u){return t.decode(u,{stream:!0})},end(){return t.decode()}}}return new y(n)}write(v){return this.iconvLiteDecoder.write(v)}end(){return this.iconvLiteDecoder.end()}}function T(s,v){const n=v.minBytesRequiredForDetection??v.guessEncoding?k:i;return new Promise((t,u)=>{const d=(0,m.newWriteableStream)(A=>A.join("")),l=[];let h=0,c;const _=async()=>{try{const A=await g({buffer:L.VSBuffer.concat(l),bytesRead:h},v.guessEncoding);A.encoding=await v.overwriteEncoding(A.encoding),c=await y.create(A.encoding);const R=c.write(L.VSBuffer.concat(l).buffer);d.write(R),l.length=0,h=0,t({stream:d,detected:A})}catch(A){u(A)}};(0,m.listenStream)(s,{onData:async A=>{c?d.write(c.write(A.buffer)):(l.push(A),h+=A.byteLength,h>=n&&(s.pause(),await _(),setTimeout(()=>s.resume())))},onError:A=>d.error(A),onEnd:async()=>{c||await _(),d.end(c?.end())}})})}e.toDecodeStream=T;async function I(s,v,n){const u=(await new Promise((h,c)=>{Y(["iconv-lite-umd"],h,c)})).getEncoder(b(v),n);let d=!1,l=!1;return{read(){if(l)return null;const h=s.read();if(typeof h!="string"){if(l=!0,!d&&n?.addBOM)switch(v){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const c=u.end();return c&&c.length>0?(d=!0,L.VSBuffer.wrap(c)):null}return d=!0,L.VSBuffer.wrap(u.write(h))}}}e.toEncodeReadable=I;async function a(s){return(await new Promise((n,t)=>{Y(["iconv-lite-umd"],n,t)})).encodingExists(b(s))}e.encodingExists=a;function b(s){return s===e.UTF8_with_bom||s===null?e.UTF8:s}e.toNodeEncoding=b;function f(s,v){if(!s||v<e.UTF16be_BOM.length)return null;const n=s.readUInt8(0),t=s.readUInt8(1);if(n===e.UTF16be_BOM[0]&&t===e.UTF16be_BOM[1])return e.UTF16be;if(n===e.UTF16le_BOM[0]&&t===e.UTF16le_BOM[1])return e.UTF16le;if(v<e.UTF8_BOM.length)return null;const u=s.readUInt8(2);return n===e.UTF8_BOM[0]&&t===e.UTF8_BOM[1]&&u===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=f;const w=["ascii","utf-16","utf-32"];async function E(s){const v=await new Promise((l,h)=>{Y(["jschardet"],l,h)}),n=s.slice(0,S),t=o(n.buffer),u=v.detect(t);if(!u||!u.encoding)return null;const d=u.encoding.toLowerCase();return 0<=w.indexOf(d)?null:p(u.encoding)}const P={ibm866:"cp866",big5:"cp950"};function p(s){const v=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return P[v]||v}function o(s){let v="";for(let n=0;n<s.length;n++)v+=String.fromCharCode(s[n]);return v}function r(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const v=s.match(/windows(\d+)/);return v?"windows-"+v[1]:s}}e.toCanonicalName=r;function g({buffer:s,bytesRead:v},n){let t=f(s,v),u=!1;if(t!==e.UTF16be&&t!==e.UTF16le&&s){let d=!0,l=!0,h=!1;for(let c=0;c<v&&c<C;c++){const _=c%2==1,A=s.readUInt8(c)===0;if(A&&(h=!0),d&&(_&&!A||!_&&A)&&(d=!1),l&&(_&&A||!_&&!A)&&(l=!1),A&&!d&&!l)break}h&&(d?t=e.UTF16le:l?t=e.UTF16be:u=!0)}return n&&!u&&!t&&s?E(s.slice(0,v)).then(d=>({seemsBinary:!1,encoding:d})):{seemsBinary:u,encoding:t}}e.detectEncodingFromBuffer=g,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[135],pe([0,1,275,28,134]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends D.TextSearchManager{constructor(k,S,y=L,T="searchProcess"){super(k,S,{readdir:I=>y.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,m.toCanonicalName)(I)},T)}}e.NativeTextSearchManager=C}),define(ge[276],pe([0,1,277,291,292,2,293]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(I,a,b,f,w,E){const P=E.environment.useHostProxy,p=typeof P=="boolean"?P:!E.remote.isRemote,o=(0,i.createProxyResolver)({resolveProxy:g=>I.resolveProxy(g),getHttpProxySetting:()=>a.getConfiguration("http").get("proxy"),log:(g,s,...v)=>{switch(g){case i.LogLevel.Trace:f.trace(s,...v);break;case i.LogLevel.Debug:f.debug(s,...v);break;case i.LogLevel.Info:f.info(s,...v);break;case i.LogLevel.Warning:f.warn(s,...v);break;case i.LogLevel.Error:f.error(s,...v);break;case i.LogLevel.Critical:f.critical(s,...v);break;case i.LogLevel.Off:break;default:n(g,s,v);break}function n(t,u,...d){f.error("Unknown log level",t),f.error(u,...d)}},getLogLevel:()=>f.getLevel(),proxyResolveTelemetry:g=>{w.$publicLog2("resolveProxy",g)},useHostProxy:p,env:process.env}),r=S(a,o);return T(b,r)}e.connectProxyResolver=k;function S(I,a){const b={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(w=>{b.config=I.getConfiguration("http").get("proxySupport")||"off"});const f={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(w=>{f.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},m,(0,i.createHttpPatch)(m,a,{config:"off"},f,!0)),on:Object.assign({},m,(0,i.createHttpPatch)(m,a,{config:"on"},f,!0)),override:Object.assign({},m,(0,i.createHttpPatch)(m,a,{config:"override"},f,!0)),onRequest:Object.assign({},m,(0,i.createHttpPatch)(m,a,b,f,!0)),default:Object.assign(m,(0,i.createHttpPatch)(m,a,b,f,!1))},https:{off:Object.assign({},L,(0,i.createHttpPatch)(L,a,{config:"off"},f,!0)),on:Object.assign({},L,(0,i.createHttpPatch)(L,a,{config:"on"},f,!0)),override:Object.assign({},L,(0,i.createHttpPatch)(L,a,{config:"override"},f,!0)),onRequest:Object.assign({},L,(0,i.createHttpPatch)(L,a,b,f,!0)),default:Object.assign(L,(0,i.createHttpPatch)(L,a,b,f,!1))},tls:Object.assign(D,(0,i.createTlsPatch)(D))}}const y=new Map;function T(I,a){return I.getExtensionPathIndex().then(b=>{const f=Y.__$__nodeRequire("module"),w=f._load;f._load=function(P,p,o){if(P==="tls")return a.tls;if(P!=="http"&&P!=="https")return w.apply(this,arguments);const r=a[P],g=b.findSubstr(C.URI.file(p.filename));let s=y.get(g);if(s||y.set(g,s={}),!s[P]){let v=r.default;s[P]={...v}}return s[P]}})}}),define(ge[278],pe([0,1,37,9,79,30,12,8,92,279]),function(Y,e,m,L,D,C,i,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const T=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(o,r,g,s){const v=a(o,r,g,s),n=r.folder.fsPath;return{cmd:m.spawn(T,v.args,{cwd:n}),rgDiskPath:T,siblingClauses:v.siblingClauses,rgArgs:v,cwd:n}}e.spawnRipgrepCmd=I;function a(o,r,g,s){const v=["--files","--hidden","--case-sensitive"];f([r],g,!1).forEach(t=>{const u=(0,S.anchorGlob)(t);if(v.push("-g",u),i.isMacintosh){const d=(0,D.normalizeNFD)(u);d!==u&&v.push("-g",d)}});const n=b([r],s,void 0,!1);return n.globArgs.forEach(t=>{const u=`!${(0,S.anchorGlob)(t)}`;if(v.push("-g",u),i.isMacintosh){const d=(0,D.normalizeNFD)(u);d!==u&&v.push("-g",d)}}),r.disregardIgnoreFiles!==!1?v.push("--no-ignore"):v.push("--no-ignore-parent"),r.ignoreSymlinks||v.push("--follow"),o.exists&&v.push("--quiet"),v.push("--no-config"),r.disregardGlobalIgnoreFiles&&v.push("--no-ignore-global"),{args:v,siblingClauses:n.siblingClauses}}function b(o,r,g,s=!0){const v=[];let n={};return o.forEach(t=>{const u=Object.assign({},t.excludePattern||{},r||{}),d=w(u,s?t.folder.fsPath:void 0,g);v.push(...d.globArgs),d.siblingClauses&&(n=Object.assign(n,d.siblingClauses))}),{globArgs:v,siblingClauses:n}}e.foldersToRgExcludeGlobs=b;function f(o,r,g=!0){const s=[];return o.forEach(v=>{const n=Object.assign({},r||{},v.includePattern||{}),t=w(n,g?v.folder.fsPath:void 0);s.push(...t.globArgs)}),s}e.foldersToIncludeGlobs=f;function w(o,r,g){const s=[],v={};return Object.keys(o).forEach(n=>{if(g&&g.has(n)||!n)return;const t=o[n];n=P(r?E(r,n):n),n.startsWith("\\\\")?n="\\\\"+n.substr(2).replace(/\\/g,"/"):n=n.replace(/\\/g,"/"),typeof t=="boolean"&&t?(n.startsWith("\\\\")&&(n+="**"),s.push(p(n))):t&&t.when&&(v[n]=t)}),{globArgs:s,siblingClauses:v}}function E(o,r){return L.isAbsolute(r)?r:L.join(o,r)}e.getAbsoluteGlob=E;function P(o){return o=k.rtrim(o,"\\"),k.rtrim(o,"/")}function p(o){return C.getRoot(o).toLowerCase()==="c:/"?o.replace(/^c:[/\\]/i,"/"):o}e.fixDriveC=p}),define(ge[280],pe([0,1,37,60,9,103,17,50,31,79,30,12,46,8,13,28,33,278,100]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const o=new Set;process.on("exit",()=>{o.forEach(n=>n())});class r{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&S.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,p.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&S.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(u=>{const d=Object.assign({},u.excludePattern||{},this.config.excludePattern||{}),l=u.folder.fsPath;t.folderQueries.map(h=>h.folder.fsPath).filter(h=>h!==l).forEach(h=>{(0,T.isEqualOrParent)(h,l)&&(d[D.relative(l,h)]=!0)}),this.folderExcludePatterns.set(l,new s(d,l))})}cancel(){this.isCanceled=!0,o.forEach(t=>t())}walk(t,u,d,l,h){if(this.fileWalkSW=a.StopWatch.create(!1),this.isCanceled)return h(null,this.isLimitHit);u.forEach(c=>{const _=D.basename(c.fsPath);this.globalExcludePattern&&this.globalExcludePattern(c.fsPath,_)||this.matchFile(d,{relativePath:c.fsPath,searchPath:void 0})}),this.cmdSW=a.StopWatch.create(!1),this.parallel(t,(c,_)=>{this.call(this.cmdTraversal,this,c,d,l,A=>{if(A){const R=(0,k.toErrorMessage)(A);console.error(R),this.errors.push(R),_(A,void 0)}else _(null,void 0)})},(c,_)=>{this.fileWalkSW.stop();const A=c?i.coalesce(c)[0]:null;h(A,this.isLimitHit)})}parallel(t,u,d){const l=new Array(t.length),h=new Array(t.length);let c=!1,_=0;if(t.length===0)return d(null,[]);t.forEach((A,R)=>{u(A,(x,O)=>{if(x?(c=!0,l[R]=null,h[R]=x):(l[R]=O,h[R]=null),++_===t.length)return d(c?h:null,l)})})}call(t,u,...d){try{t.apply(u,d)}catch(l){d[d.length-1](l)}}cmdTraversal(t,u,d,l){const h=t.folder.fsPath,c=I.isMacintosh;let _;const A=()=>_&&_.kill();o.add(A);let R=U=>{o.delete(A),R=()=>{},l(U)},x="";const O=this.initDirectoryTree();let F;const $=(0,P.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression);_=$.cmd,F=!Object.keys($.siblingClauses).length;const M=$.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let B=`${$.rgDiskPath} ${M}
 - cwd: ${$.cwd}`;$.rgArgs.siblingClauses&&(B+=`
 - Sibling clauses: ${JSON.stringify($.rgArgs.siblingClauses)}`),d({message:B}),this.cmdResultCount=0,this.collectStdout(_,"utf8",d,(U,z,K)=>{if(U){R(U);return}if(this.isLimitHit){R();return}const j=(x+(c?y.normalizeNFC(z||""):z)).split(`
`);if(K){const H=j.length;j[H-1]=j[H-1].trim(),j[H-1]||j.pop()}else x=j.pop()||"";if(j.length&&j[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=j.length,F){for(const H of j)if(this.matchFile(u,{base:h,relativePath:H,searchPath:this.getSearchPath(t,H)}),this.isLimitHit){A();break}(K||this.isLimitHit)&&R();return}this.addDirectoryEntries(t,O,h,j,u),K&&(this.matchDirectoryTree(O,h,u),R())})}spawnFindCmd(t){const u=this.folderExcludePatterns.get(t.folder.fsPath),d=u.getBasenameTerms(),l=u.getPathTerms(),h=["-L","."];if(d.length||l.length){h.push("-not","(","(");for(const c of d)h.push("-name",c),h.push("-o");for(const c of l)h.push("-path",c),h.push("-o");h.pop(),h.push(")","-prune",")")}return h.push("-type","f"),m.spawn("find",h,{cwd:t.folder.fsPath})}readStdout(t,u,d){let l="";this.collectStdout(t,u,()=>{},(h,c,_)=>{if(h){d(h);return}l+=c,_&&d(null,l)})}collectStdout(t,u,d,l){let h=(A,R,x)=>{(A||x)&&(h=()=>{},this.cmdSW&&this.cmdSW.stop()),l(A,R,x)},c=!1;t.stdout?(this.forwardData(t.stdout,u,h),t.stdout.once("data",()=>c=!0)):d({message:"stdout is null"});let _;t.stderr?_=this.collectData(t.stderr):d({message:"stderr is null"}),t.on("error",A=>{h(A)}),t.on("close",A=>{let R;!c&&(R=this.decodeData(_,u))&&v(R)?h(new Error(`command failed with error code ${A}: ${this.decodeData(_,u)}`)):(this.exists&&A===0&&(this.isLimitHit=!0),h(null,"",!0))})}forwardData(t,u,d){const l=new C.StringDecoder(u);return t.on("data",h=>{d(null,l.write(h))}),l}collectData(t){const u=[];return t.on("data",d=>{u.push(d)}),u}decodeData(t,u){const d=new C.StringDecoder(u);return t.map(l=>d.write(l)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:u},d,l,h){l.indexOf(this.filePattern)!==-1&&this.matchFile(h,{base:d,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const c=_=>{const A=D.basename(_),R=D.dirname(_);let x=u[R];x||(x=u[R]=[],c(R)),x.push({base:d,relativePath:_,basename:A,searchPath:this.getSearchPath(t,_)})};l.forEach(c)}matchDirectoryTree({rootEntries:t,pathToEntries:u},d,l){const h=this,c=this.folderExcludePatterns.get(d),_=this.filePattern;function A(R){h.directoriesWalked++;const x=S.hasSiblingFn(()=>R.map(O=>O.basename));for(let O=0,F=R.length;O<F;O++){const $=R[O],{relativePath:M,basename:B}=$;if(c.test(M,B,_!==B?x:void 0))continue;const U=u[M];if(U)A(U);else{if(h.filesWalked++,M===_)continue;h.matchFile(l,$)}if(h.isLimitHit)break}}A(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,u,d,l,h){const c=t.folder,_=S.hasSiblingFn(()=>d);this.parallel(d,(A,R)=>{if(this.isCanceled||this.isLimitHit)return R(null);const x=u?[u,A].join(D.sep):A;if(this.folderExcludePatterns.get(t.folder.fsPath).test(x,A,this.config.filePattern!==A?_:void 0))return R(null);const O=[c.fsPath,x].join(D.sep);L.lstat(O,(F,$)=>{if(F||this.isCanceled||this.isLimitHit)return R(null);this.statLinkIfNeeded(O,$,(M,B)=>M||this.isCanceled||this.isLimitHit?R(null):B.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(O,$,(U,z)=>U||this.isCanceled||this.isLimitHit||(z=z||"",this.walkedPaths[z])?R(null):(this.walkedPaths[z]=!0,w.Promises.readdir(O).then(K=>{if(this.isCanceled||this.isLimitHit)return R(null);this.doWalk(t,x,K,l,N=>R(N||null))},K=>{R(null)})))):(this.filesWalked++,x===this.filePattern||this.maxFilesize&&f.isNumber(B.size)&&B.size>this.maxFilesize||this.matchFile(l,{base:c.fsPath,relativePath:x,searchPath:this.getSearchPath(t,x)}),R(null,void 0)))})},A=>{const R=A&&i.coalesce(A);return h(R&&R.length>0?R[0]:void 0)})}matchFile(t,u){this.isFileMatch(u)&&(!this.includePattern||this.includePattern(u.relativePath,D.basename(u.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(u))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,E.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,u,d){return u.isSymbolicLink()?L.stat(t,d):d(null,u)}realPathIfNeeded(t,u,d){return u.isSymbolicLink()?L.realpath(t,(l,h)=>l?d(l):d(null,h)):d(null,t)}getSearchPath(t,u){return t.folderName?D.join(t.folderName,u):u}}e.FileWalker=r;class g{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new r(t)}search(t,u,d){this.walker.walk(this.folderQueries,this.extraFiles,t,u,(l,h)=>{d(l,{limitHit:h,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class s{constructor(t,u){this.expression=t,this.root=u,this.init(t)}init(t){let u,d;Object.keys(t).filter(l=>t[l]).forEach(l=>{D.isAbsolute(l)?(u=u||S.getEmptyExpression(),u[l]=t[l]):(d=d||S.getEmptyExpression(),d[l]=t[l])}),this.absoluteParsedExpr=u&&S.parse(u,{trimForExclusions:!0}),this.relativeParsedExpr=d&&S.parse(d,{trimForExclusions:!0})}test(t,u,d){return this.relativeParsedExpr&&this.relativeParsedExpr(t,u,d)||this.absoluteParsedExpr&&this.absoluteParsedExpr(D.join(this.root,t),u,d)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...S.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...S.getPathTerms(this.relativeParsedExpr)),t}}function v(n){const t=n.trim().split(`
`),u=t[0].trim();if(u.startsWith("Error parsing regex"))return u;if(u.startsWith("regex parse error"))return b.uppercaseFirstLetter(t[t.length-1].trim());if(u.startsWith("error parsing glob")||u.startsWith("unsupported encoding"))return u.charAt(0).toUpperCase()+u.substr(1);if(u==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(u.startsWith("Literal "))return u}e.rgErrorMsgForDisplay=v}),define(ge[136],pe([0,1,37,294,103,17,73,31,9,8,2,33,69,295,279,92]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const E=f.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class P{constructor(c){this.outputChannel=c}provideTextSearchResults(c,_,A,R){return this.outputChannel.appendLine(`provideTextSearchResults ${c.pattern}, ${JSON.stringify({..._,folder:_.folder.toString()})}`),new Promise((x,O)=>{R.onCancellationRequested(()=>N());const F=v(c,_),$=_.folder.fsPath,M=F.map(te=>te.match(/^-/)?te:`'${te}'`).join(" ");this.outputChannel.appendLine(`${E} ${M}
 - cwd: ${$}`);let B=m.spawn(E,F,{cwd:$});B.on("error",te=>{console.error(te),this.outputChannel.appendLine("Error: "+(te&&te.message)),O((0,I.serializeSearchError)(new I.SearchError(te&&te.message,I.SearchErrorCode.rgProcessError)))});let U=!1;const z=new r(_.maxResults,$,_.previewOptions);z.on("result",te=>{U=!0,H="",A.report(te)});let K=!1;const N=()=>{K=!0,B&&B.kill(),z&&z.cancel()};let j=!1;z.on("hitLimit",()=>{j=!0,N()});let H="";B.stdout.on("data",te=>{z.handleData(te),U||(H+=te)});let V=!1;B.stdout.once("data",()=>V=!0);let q="";B.stderr.on("data",te=>{const fe=te.toString();this.outputChannel.appendLine(fe),q+=fe}),B.on("close",()=>{if(this.outputChannel.appendLine(V?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),H&&this.outputChannel.appendLine(`Got data without result: ${H}`),this.outputChannel.appendLine(""),K)x({limitHit:j});else{z.flush(),B=null;let te;q&&!V&&(te=p(q))?O((0,I.serializeSearchError)(new I.SearchError(te.message,te.code))):x({limitHit:j})}})})}}e.RipgrepTextSearchEngine=P;function p(h){const c=h.split(`
`),_=c[0].trim();if(c.some(R=>R.startsWith("regex parse error")))return new I.SearchError(o(c),I.SearchErrorCode.regexParseError);const A=_.match(/grep config error: unknown encoding: (.*)/);if(A)return new I.SearchError(`Unknown encoding: ${A[1]}`,I.SearchErrorCode.unknownEncoding);if(_.startsWith("error parsing glob"))return new I.SearchError(_.charAt(0).toUpperCase()+_.substr(1),I.SearchErrorCode.globParseError);if(_.startsWith("the literal"))return new I.SearchError(_.charAt(0).toUpperCase()+_.substr(1),I.SearchErrorCode.invalidLiteral);if(_.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(_,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=p;function o(h){const c=["Regex parse error"],_=h.filter(A=>A.startsWith("PCRE2:"));if(_.length>=1){const A=_[0].replace("PCRE2:","");if(A.indexOf(":")!==-1&&A.split(":").length>=2){const R=A.split(":")[1];c.push(":"+R)}}return c.join("")}e.buildRegexParseError=o;class r extends L.EventEmitter{constructor(c,_,A){super();this.maxResults=c,this.rootFolder=_,this.previewOptions=A,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new D.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(c,_){return super.on(c,_),this}handleData(c){if(this.isDone)return;const _=typeof c=="string"?c:this.stringDecoder.write(c);this.handleDecodedData(_)}handleDecodedData(c){let _=c.indexOf(`
`);const A=this.remainder+c;if(_>=0)_+=this.remainder.length;else{this.remainder=A;return}let R=0;for(;_>=0;)this.handleLine(A.substring(R,_).trim()),R=_+1,_=A.indexOf(`
`,R);this.remainder=A.substring(R)}handleLine(c){if(this.isDone||!c)return;let _;try{_=JSON.parse(c)}catch(A){throw new Error(`malformed line from rg: ${c}`)}if(_.type==="match"){const A=g(_.data.path),R=T.URI.file(S.join(this.rootFolder,A)),x=this.createTextSearchMatch(_.data,R);this.onResult(x),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(_.type==="context"){const A=g(_.data.path),R=T.URI.file(S.join(this.rootFolder,A));this.createTextSearchContext(_.data,R).forEach(O=>this.onResult(O))}}createTextSearchMatch(c,_){const A=c.line_number-1,R=g(c.lines),x=Buffer.from(R);let O=0,F=0,$=A;c.submatches.length===0&&c.submatches.push(R.length?{start:0,end:1,match:{text:R[0]}}:{start:0,end:0,match:{text:""}});const M=(0,C.coalesce)(c.submatches.map((B,U)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const z=g(B.match),K=x.slice(O,B.start).toString().length,N=F+K,j=s(z),H=$,V=j.numLines+H,q=j.numLines>0?j.lastLineLength:j.lastLineLength+N;return O=B.end,F=q,$=V,new a.Range(H,N,V,q)}));return(0,w.createTextSearchResult)(_,R,M,this.previewOptions)}createTextSearchContext(c,_){const A=g(c.lines),R=c.line_number;return A.replace(/\r?\n$/,"").split(`
`).map((x,O)=>({text:x,uri:_,lineNumber:R+O}))}onResult(c){this.emit("result",c)}}e.RipgrepParser=r;function g(h){return h.bytes?Buffer.from(h.bytes,"base64").toString():h.text}function s(h){const c=/\n/g;let _=0,A=-1,R;for(;R=c.exec(h);)_++,A=R.index;const x=A>=0?h.length-A-1:h.length;return{numLines:_,lastLineLength:x}}function v(h,c){const _=["--hidden"];_.push(h.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:A,otherIncludes:R}=(0,i.groupBy)(c.includes,O=>O.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(R&&R.length){const O=new Set;R.forEach(F=>{O.add(F)}),_.push("-g","!*"),O.forEach(F=>{n(F).map(w.anchorGlob).forEach($=>{_.push("-g",$)})})}A&&A.length&&A.forEach(O=>{_.push("-g",O)}),c.excludes.map(w.anchorGlob).forEach(O=>_.push("-g",`!${O}`)),c.maxFileSize&&_.push("--max-filesize",c.maxFileSize+""),c.useIgnoreFiles?_.push("--no-ignore-parent"):_.push("--no-ignore"),c.followSymlinks&&_.push("--follow"),c.encoding&&c.encoding!=="utf8"&&_.push("--encoding",c.encoding),h.pattern==="--"&&(h.isRegExp=!0,h.pattern="\\-\\-"),h.isMultiline&&!h.isRegExp&&(h.pattern=(0,y.escapeRegExpCharacters)(h.pattern),h.isRegExp=!0),c.usePCRE2&&_.push("--pcre2"),_.push("--crlf"),h.isRegExp&&(h.pattern=t(h.pattern),_.push("--auto-hybrid-regex"));let x;if(h.isWordMatch){const F=(0,y.createRegExp)(h.pattern,!!h.isRegExp,{wholeWord:h.isWordMatch}).source.replace(/\\\//g,"/");_.push("--regexp",F)}else if(h.isRegExp){let O=d(h.pattern);O=l(O),_.push("--regexp",O)}else x=h.pattern,_.push("--fixed-strings");return _.push("--no-config"),c.useGlobalIgnoreFiles||_.push("--no-ignore-global"),_.push("--json"),h.isMultiline&&_.push("--multiline"),c.beforeContext&&_.push("--before-context",c.beforeContext+""),c.afterContext&&_.push("--after-context",c.afterContext+""),_.push("--"),x&&_.push(x),_.push("."),_}function n(h){const c=(0,k.splitGlobAware)(h,"/");return c.map((_,A)=>c.slice(0,A+1).join("/"))}e.spreadGlobComponents=n;function t(h){const c=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;h.match(c);)h=h.replace(c,"$1\\x{$2}");const _=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;h.match(_);)h=h.replace(_,"$1\\x{$2}");return h}e.unicodeEscapesToPCRE2=t;const u=h=>h.type==="Assertion"&&h.kind==="lookbehind";function d(h){let c;try{c=new b.RegExpParser().parsePattern(h)}catch{return h}let _="",A=0;const R=(F,$,M)=>{_+=h.slice(A,F)+M,A=$},x=[];return new b.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const $=x[0];if(!$)R(F.start,F.end,"\\r?\\n");else if(!x.some(u))if($.type==="CharacterClass")if($.negate){const M=h.slice($.start+2,F.start)+h.slice(F.end,$.end-1);if($.parent?.type==="Quantifier"){const B=$.parent;R(B.start,B.end,(M?`[^${M}]`:".")+(B.greedy?"+":"*"))}else R($.start,$.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=h.slice($.start+1,F.start)+h.slice(F.end,$.end-1);R($.start,$.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else $.type==="Quantifier"&&R(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){x.unshift(F)},onQuantifierLeave(){x.shift()},onCharacterClassRangeEnter(F){x.unshift(F)},onCharacterClassRangeLeave(){x.shift()},onCharacterClassEnter(F){x.unshift(F)},onCharacterClassLeave(){x.shift()},onAssertionEnter(F){u(F)&&x.push(F)},onAssertionLeave(F){x[0]===F&&x.shift()}}).visit(c),_+=h.slice(A),_}e.fixRegexNewline=d;function l(h){return h.replace(/\n/g,"\\r?\\n")}e.fixNewline=l}),define(ge[281],pe([0,1,21,136,117,10]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class i{constructor(y){this.outputChannel=y,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(y,T,I,a){const b=new L.RipgrepTextSearchEngine(this.outputChannel);if(T.folder.scheme===C.Schemas.userData){const f={...T,folder:T.folder.with({scheme:C.Schemas.file})},w=new D.Progress(E=>I.report({...E,uri:E.uri.with({scheme:T.folder.scheme})}));return this.withToken(a,E=>b.provideTextSearchResults(y,f,w,E))}else return this.withToken(a,f=>b.provideTextSearchResults(y,T,I,f))}async withToken(y,T){const I=k(y);this.inProgress.add(I);const a=await T(I.token);return this.inProgress.delete(I),a}dispose(){this.inProgress.forEach(y=>y.cancel())}}e.RipgrepSearchProvider=i;function k(S){const y=new m.CancellationTokenSource;return S.onCancellationRequested(()=>y.cancel()),y}}),define(ge[282],pe([0,1,28,136,135]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(S){this.query=S}search(S,y,T){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(b){T({message:b})}},a=new D.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(I),m);return new Promise((b,f)=>a.search(w=>{y(w.map(i))},S).then(w=>b({limitHit:w.limitHit,type:"success",stats:w.stats}),f))}}e.TextSearchEngineAdapter=C;function i(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((S,y)=>{if(y.ranges){const T=y;return S+(Array.isArray(T.ranges)?T.ranges.length:1)}else return S+1},0)}}}),define(ge[283],pe([0,1,17,18,15,3,100,9,46,2,42,33,280,282]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class f{constructor(r="searchProcess"){this.processType=r,this.caches=Object.create(null)}fileSearch(r){let g;const s=P(r),v=new C.Emitter({onFirstListenerDidAdd:()=>{g=(0,L.createCancelablePromise)(n=>this.doFileSearchWithEngine(a.Engine,s,t=>v.fire(t),n)),g.then(n=>v.fire(n),n=>v.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return v.event}textSearch(r){let g;const s=P(r),v=new C.Emitter({onFirstListenerDidAdd:()=>{g=(0,L.createCancelablePromise)(n=>this.ripgrepTextSearch(s,t=>v.fire(t),n)),g.then(n=>v.fire(n),n=>v.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return v.event}ripgrepTextSearch(r,g,s){return r.maxFileSize=(0,T.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new b.TextSearchEngineAdapter(r).search(s,g,g)}doFileSearch(r,g,s){return this.doFileSearchWithEngine(a.Engine,r,g,s)}doFileSearchWithEngine(r,g,s,v,n=f.BATCH_SIZE){let t=0;const u=l=>{Array.isArray(l)?(t+=l.length,s(l.map(h=>this.rawMatchToSearchItem(h)))):l.relativePath?(t++,s(this.rawMatchToSearchItem(l))):s(l)};if(g.sortByScore){let l=this.trySortedSearchFromCache(g,u,v);if(!l){const h=g.maxResults?Object.assign({},g,{maxResults:null}):g,c=new r(h);l=this.doSortedSearch(c,g,s,u,v)}return new Promise((h,c)=>{l.then(([_,A])=>{const R=A.map(x=>this.rawMatchToSearchItem(x));this.sendProgress(R,s,n),h(_)},c)})}const d=new r(g);return this.doSearch(d,u,n,v).then(l=>({limitHit:l.limitHit,type:"success",stats:{detailStats:l.stats,type:this.processType,fromCache:!1,resultCount:t,sortingTime:void 0}}))}rawMatchToSearchItem(r){return{path:r.base?(0,k.join)(r.base,r.relativePath):r.relativePath}}doSortedSearch(r,g,s,v,n){const t=new C.Emitter;let u=(0,L.createCancelablePromise)(l=>{let h=[];const c=_=>{Array.isArray(_)?h=_:(v(_),t.fire(_))};return this.doSearch(r,c,-1,l).then(_=>[_,h])}),d;if(g.cacheKey){d=this.getOrCreateCache(g.cacheKey);const l={promise:u,event:t.event,resolved:!1};d.resultsToSearchCache[g.filePattern||""]=l,u.then(()=>{l.resolved=!0},h=>{delete d.resultsToSearchCache[g.filePattern||""]}),u=this.preventCancellation(u)}return u.then(([l,h])=>{const c=d?d.scorerCache:Object.create(null),_=(typeof g.maxResults!="number"||g.maxResults>0)&&S.StopWatch.create(!1);return this.sortResults(g,h,c,n).then(A=>{const R=_?_.elapsed():-1;return[{type:"success",stats:{detailStats:l.stats,sortingTime:R,fromCache:!1,type:this.processType,workspaceFolderCount:g.folderQueries.length,resultCount:A.length},messages:l.messages,limitHit:l.limitHit||typeof g.maxResults=="number"&&h.length>g.maxResults},A]})})}getOrCreateCache(r){const g=this.caches[r];return g||(this.caches[r]=new w)}trySortedSearchFromCache(r,g,s){const v=r.cacheKey&&this.caches[r.cacheKey];if(!v)return;const n=this.getResultsFromCache(v,r.filePattern||"",g,s);if(n)return n.then(([t,u,d])=>{const l=S.StopWatch.create(!1);return this.sortResults(r,u,v.scorerCache,s).then(h=>{const c=l.elapsed(),_={fromCache:!0,detailStats:d,type:this.processType,resultCount:u.length,sortingTime:c};return[{type:"success",limitHit:t.limitHit||typeof r.maxResults=="number"&&u.length>r.maxResults,stats:_},h]})})}sortResults(r,g,s,v){const n=(0,i.prepareQuery)(r.filePattern||""),t=(d,l)=>(0,i.compareItemsByFuzzyScore)(d,l,n,!0,E,s),u=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return m.topAsync(g,t,u,1e4,v)}sendProgress(r,g,s){if(s&&s>0)for(let v=0;v<r.length;v+=s)g(r.slice(v,v+s));else g(r)}getResultsFromCache(r,g,s,v){const n=S.StopWatch.create(!1),t=g.indexOf(k.sep)>=0;let u;for(const c in r.resultsToSearchCache)if(g.startsWith(c)){if(t&&c.indexOf(k.sep)<0&&c!=="")continue;const _=r.resultsToSearchCache[c];u={promise:this.preventCancellation(_.promise),event:_.event,resolved:_.resolved};break}if(!u)return null;const d=n.elapsed(),l=S.StopWatch.create(!1),h=u.event(s);return v&&v.onCancellationRequested(()=>{h.dispose()}),u.promise.then(([c,_])=>{if(v&&v.isCancellationRequested)throw(0,D.canceled)();const A=[],R=(0,i.prepareQuery)(g).normalizedLowercase;for(const x of _)!(0,I.isFilePatternMatch)(x,R)||A.push(x);return[c,A,{cacheWasResolved:u.resolved,cacheLookupTime:d,cacheFilterTime:l.elapsed(),cacheEntryCount:_.length}]})}doSearch(r,g,s,v){return new Promise((n,t)=>{let u=[];v&&v.onCancellationRequested(()=>r.cancel()),r.search(d=>{d&&(s?(u.push(d),s>0&&u.length>=s&&(g(u),u=[])):g(d))},d=>{g(d)},(d,l)=>{u.length&&g(u),d?t(d):n(l)})})}clearCache(r){return delete this.caches[r],Promise.resolve(void 0)}preventCancellation(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,s){return r.then(g,s)}catch(g){return this.then(void 0,g)}finally(g){return r.finally(g)}}}}e.SearchService=f,f.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const E=new class{getItemLabel(o){return(0,k.basename)(o.relativePath)}getItemDescription(o){return(0,k.dirname)(o.relativePath)}getItemPath(o){return o.relativePath}};function P(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(p),extraFileResources:o.extraFileResources&&o.extraFileResources.map(r=>y.URI.revive(r))}}function p(o){return{...o,folder:y.URI.revive(o.folder)}}}),define(ge[284],pe([0,1,6,10,2,28,11,26,14,72,64,33,283,281,92,135]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let E=class extends y.ExtHostSearch{constructor(p,o,r,g){super(p,r,g);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const s=new f.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.userData,new b.RipgrepSearchProvider(s)),o.remote.isRemote&&o.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const p=new f.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new b.RipgrepSearchProvider(p)),this.registerInternalFileSearchProvider(L.Schemas.file,new a.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(p,o){const r=this._handlePool++;return this._internalFileSearchProvider=o,this._internalFileSearchHandle=r,this._proxy.$registerFileSearchProvider(r,this._transformScheme(p)),(0,m.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(r)})}$provideFileSearchResults(p,o,r,g){const s=(0,y.reviveQuery)(r);return p===this._internalFileSearchHandle?this.doInternalFileSearch(p,o,s,g):super.$provideFileSearchResults(p,o,r,g)}doInternalFileSearch(p,o,r,g){const s=v=>{if((0,I.isSerializedFileMatch)(v)&&(v=[v]),Array.isArray(v)){this._proxy.$handleFileMatch(p,o,v.map(n=>D.URI.file(n.path)));return}v.message&&this._logService.debug("ExtHostSearch",v.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(r,s,g)}$clearCache(p){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(p),super.$clearCache(p)}createTextSearchManager(p,o){return new w.NativeTextSearchManager(p,o,void 0,"textSearchProvider")}};E=Ve([He(0,S.IExtHostRpcService),He(1,k.IExtHostInitDataService),He(2,T.IURITransformerService),He(3,i.ILogService)],E),e.NativeExtHostSearch=E}),define(ge[137],pe([0,1,296,124,81,22,15,3,6,9,12,32,105,106,297]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(l){this.socket=l,this._errorListener=h=>{if(h){if(h.code==="EPIPE")return;(0,i.onUnexpectedError)(h)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(l){const h=c=>l(C.VSBuffer.wrap(c));return this.socket.on("data",h),{dispose:()=>this.socket.off("data",h)}}onClose(l){const h=c=>{l({type:0,hadError:c,error:void 0})};return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(l){return this.socket.on("end",l),{dispose:()=>this.socket.off("end",l)}}write(l){if(!this.socket.destroyed)try{this.socket.write(l.buffer,h=>{if(h){if(h.code==="EPIPE")return;(0,i.onUnexpectedError)(h)}})}catch(h){if(h.code==="EPIPE")return;(0,i.onUnexpectedError)(h)}}end(){this.socket.end()}drain(){return new Promise((l,h)=>{if(this.socket.bufferSize===0){l();return}const c=()=>{this.socket.off("close",c),this.socket.off("end",c),this.socket.off("error",c),this.socket.off("timeout",c),this.socket.off("drain",c),l()};this.socket.on("close",c),this.socket.on("end",c),this.socket.on("error",c),this.socket.on("timeout",c),this.socket.on("drain",c)})}}e.NodeSocket=w;var E;(function(d){d[d.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var P;(function(d){d[d.PeekHeader=1]="PeekHeader",d[d.ReadHeader=2]="ReadHeader",d[d.ReadBody=3]="ReadBody",d[d.Fin=4]="Fin"})(P||(P={}));class p extends S.Disposable{constructor(l,h,c,_){super();this._onDidZlibFlush=this._register(new k.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=h,this._recordInflateBytes=_,h?(this._zlibInflate=f.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",A=>{console.error(A),(0,i.onUnexpectedError)(A),this._onClose.fire({type:0,hadError:!0,error:A})}),this._zlibInflate.on("data",A=>{this._pendingInflateData.push(A)}),c&&(this._zlibInflate.write(c.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=f.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{console.error(A),(0,i.onUnexpectedError)(A),this._onClose.fire({type:0,hadError:!0,error:A})}),this._zlibDeflate.on("data",A=>{this._pendingDeflateData.push(A)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new b.ChunkStream,this._register(this.socket.onData(A=>this._acceptChunk(A))),this._register(this.socket.onClose(A=>this._onClose.fire(A)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this._onData.event(l)}onClose(l){return this._onClose.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){this._totalOutgoingDataBytes+=l.byteLength,this._zlibDeflate?(this._zlibDeflate.write(l.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let h=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,h=h.slice(0,h.length-4),this._isEnded||this._write(C.VSBuffer.wrap(h),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(l,!1)}_write(l,h){let c=2;l.byteLength<126?c+=0:l.byteLength<2**16?c+=2:c+=8;const _=C.VSBuffer.alloc(c);if(h?_.writeUInt8(194,0):_.writeUInt8(130,0),l.byteLength<126)_.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){_.writeUInt8(126,1);let A=1;_.writeUInt8(l.byteLength>>>8&255,++A),_.writeUInt8(l.byteLength>>>0&255,++A)}else{_.writeUInt8(127,1);let A=1;_.writeUInt8(0,++A),_.writeUInt8(0,++A),_.writeUInt8(0,++A),_.writeUInt8(0,++A),_.writeUInt8(l.byteLength>>>24&255,++A),_.writeUInt8(l.byteLength>>>16&255,++A),_.writeUInt8(l.byteLength>>>8&255,++A),_.writeUInt8(l.byteLength>>>0&255,++A)}this._totalOutgoingWireBytes+=_.byteLength+l.byteLength,this.socket.write(C.VSBuffer.concat([_,l]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(l){if(l.byteLength!==0){for(this._totalIncomingWireBytes+=l.byteLength,this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const h=this._incomingData.peek(this._state.readLen),c=h.readUInt8(0),_=(c&128)>>>7,A=(c&64)>>>6,R=h.readUInt8(1),x=(R&128)>>>7,O=R&127;this._state.state=2,this._state.readLen=2+(x?4:0)+(O===126?2:0)+(O===127?8:0),this._state.fin=_,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(A)),this._state.firstFrameOfMessage=Boolean(_),this._state.mask=0}else if(this._state.state===2){const h=this._incomingData.read(this._state.readLen),c=h.readUInt8(1),_=(c&128)>>>7;let A=c&127,R=1;A===126?A=h.readUInt8(++R)*2**8+h.readUInt8(++R):A===127&&(A=h.readUInt8(++R)*0+h.readUInt8(++R)*0+h.readUInt8(++R)*0+h.readUInt8(++R)*0+h.readUInt8(++R)*2**24+h.readUInt8(++R)*2**16+h.readUInt8(++R)*2**8+h.readUInt8(++R));let x=0;_&&(x=h.readUInt8(++R)*2**24+h.readUInt8(++R)*2**16+h.readUInt8(++R)*2**8+h.readUInt8(++R)),this._state.state=3,this._state.readLen=A,this._state.mask=x}else if(this._state.state===3){const h=this._incomingData.read(this._state.readLen);o(h,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(h.buffer)),this._zlibInflate.write(h.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const c=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=c.length,this._onData.fire(C.VSBuffer.wrap(c))})):(this._totalIncomingDataBytes+=h.byteLength,this._onData.fire(h))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await k.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=p;function o(d,l){if(l===0)return;let h=d.byteLength>>>2;for(let O=0;O<h;O++){const F=d.readUInt32BE(O*4);d.writeUInt32BE(F^l,O*4)}let c=h*4,_=d.byteLength-c;const A=l>>>24&255,R=l>>>16&255,x=l>>>8&255;_>=1&&d.writeUInt8(d.readUInt8(c)^A,c),_>=2&&d.writeUInt8(d.readUInt8(c+1)^R,c+1),_>=3&&d.writeUInt8(d.readUInt8(c+2)^x,c+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function g(){const d=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${d}-sock`;let l;return e.XDG_RUNTIME_DIR?l=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${d}.sock`):l=(0,y.join)((0,D.tmpdir)(),`vscode-ipc-${d}.sock`),v(l),l}e.createRandomIPCHandle=g;function s(d,l,h){const c=(0,m.createHash)("md5").update(d).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${c}-${h}-${l}-sock`;let _;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?_=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-${c.substr(0,8)}-${h}-${l}.sock`):_=(0,y.join)(d,`${h}-${l}.sock`),v(_),_}e.createStaticIPCHandle=s;function v(d){const l=r[T.platform];typeof l=="number"&&d.length>=l&&console.warn(`WARNING: IPC handle "${d}" is longer than ${l} chars, try a shorter --user-data-dir`)}class n extends a.IPCServer{constructor(l){super(n.toClientConnectionEvent(l));this.server=l}static toClientConnectionEvent(l){const h=k.Event.fromNodeEventEmitter(l,"connection");return k.Event.map(h,c=>({protocol:new b.Protocol(new w(c)),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(c,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function t(d){return new Promise((l,h)=>{const c=(0,L.createServer)();c.on("error",h),c.listen(d,()=>{c.removeListener("error",h),l(new n(c))})})}e.serve=t;function u(d,l){return new Promise((h,c)=>{const _=(0,L.createConnection)(d,()=>{_.removeListener("error",c),h(b.Client.fromSocket(new w(_),l))});_.once("error",c)})}e.connect=u}),define(ge[285],pe([0,1,137,277,60,38,2,197,11]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class y{constructor(a,b,f){this._commands=a,this.logService=b,this._ipcHandlePath=f,this._server=L.createServer((w,E)=>this.onRequest(w,E)),this.setup().catch(w=>(b.error(w),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",a=>this.logService.error(a))}catch(a){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(a,b){const f=[];a.setEncoding("utf8"),a.on("data",w=>f.push(w)),a.on("end",()=>{const w=JSON.parse(f.join(""));switch(w.type){case"open":this.open(w,b);break;case"openExternal":this.openExternal(w,b);break;case"status":this.getStatus(w,b);break;case"extensionManagement":this.manageExtensions(w,b).catch(this.logService.error);break;default:b.writeHead(404),b.write(`Unknown message type: ${w.type}`,E=>{E&&this.logService.error(E)}),b.end();break}})}open(a,b){const{fileURIs:f,folderURIs:w,forceNewWindow:E,diffMode:P,addMode:p,forceReuseWindow:o,gotoLineMode:r,waitMarkerFilePath:g,remoteAuthority:s}=a,v=[];if(Array.isArray(w))for(const d of w)try{v.push({folderUri:i.URI.parse(d)})}catch(l){}if(Array.isArray(f))for(const d of f)try{(0,k.hasWorkspaceFileExtension)(d)?v.push({workspaceUri:i.URI.parse(d)}):v.push({fileUri:i.URI.parse(d)})}catch(l){}const n=g?i.URI.file(g):void 0,u={forceNewWindow:E,diffMode:P,addMode:p,gotoLineMode:r,forceReuseWindow:o,preferNewWindow:!o&&!n&&!p,waitMarkerFileURI:n,remoteAuthority:s};this._commands.executeCommand("_remoteCLI.windowOpen",v,u),b.writeHead(200),b.end()}async openExternal(a,b){for(const f of a.uris){const w=i.URI.parse(f),E=w.scheme==="file"?w:f;await this._commands.executeCommand("_remoteCLI.openExternal",E)}b.writeHead(200),b.end()}async manageExtensions(a,b){try{const f=P=>P?.map(p=>/\.vsix$/i.test(p)?i.URI.parse(p):p),w={list:a.list,install:f(a.install),uninstall:f(a.uninstall),force:a.force},E=await this._commands.executeCommand("_remoteCLI.manageExtensions",w);b.writeHead(200),b.write(E)}catch(f){b.writeHead(500),b.write(String(f),w=>{w&&this.logService.error(w)})}b.end()}async getStatus(a,b){try{const f=await this._commands.executeCommand("_remoteCLI.getSystemStatus");b.writeHead(200),b.write(f),b.end()}catch(f){b.writeHead(500),b.write(String(f),w=>{w&&this.logService.error(w)}),b.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&D.existsSync(this._ipcHandlePath)&&D.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=y;let T=class extends y{constructor(a,b){super(a,b,(0,m.createRandomIPCHandle)())}};T=Ve([He(0,C.IExtHostCommands),He(1,S.ILogService)],T),e.CLIServer=T}),define(ge[286],pe([0,1,71,273,268,5,276,39,258,2,10,7,285,104]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class f extends D.RequireInterceptor{_installInterceptor(){const P=this,p=Y.__$__nodeRequire("module"),o=p._load;p._load=function(g,s,v){for(let n of P._alternatives){let t=n(g);if(t){g=t;break}}return P._factories.has(g)?P._factories.get(g).load(g,y.URI.file((0,b.realpathSync)(s.filename)),n=>o.apply(this,[n,s,v])):o.apply(this,arguments)}}}class w extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const P=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(S.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const s=this._instaService.createInstance(a.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=s.ipcHandlePath}await this._instaService.createInstance(f,P,this._registry).install(),m.mark("code/extHost/didInitAPI");const o=await this._extHostConfiguration.getConfigProvider();await(0,i.connectProxyResolver)(this._extHostWorkspace,o,this,this._logService,this._mainThreadTelemetryProxy,this._initData),m.mark("code/extHost/didInitProxyResolver");const r=process.send,g=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...s)=>s.length===0||!s[0]||s[0].type!=="__$console"?r.apply(process,s):(g.$logExtensionHostMessage(s[0]),!1)}_getEntryPoint(P){return P.main}_loadCommonJSModule(P,p,o){if(p.scheme!==T.Schemas.file)throw new Error(`Cannot load URI: '${p}', must be of file-scheme`);let r=null;o.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${p.toString(!0)}`),this._logService.flush();try{P&&m.mark(`code/extHost/willLoadExtensionCode/${P.value}`),r=Y.__$__nodeRequire(p.fsPath)}catch(g){return Promise.reject(g)}finally{P&&m.mark(`code/extHost/didLoadExtensionCode/${P.value}`),o.codeLoadingStop()}return Promise.resolve(r)}async $setRemoteEnvironment(P){if(!!this._initData.remote.isRemote)for(const p in P){const o=P[p];o===null?delete process.env[p]:process.env[p]=o}}}e.ExtHostExtensionService=w}),define(ge[287],pe([0,1,83,261,270,269,284,286,262,55,39,72,70,34,52,67,260,259,11]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(T.IExtHostExtensionService,k.ExtHostExtensionService),(0,m.registerSingleton)(p.ILoggerService,P.ExtHostLoggerService),(0,m.registerSingleton)(w.IExtensionStoragePaths,E.ExtensionStoragePaths),(0,m.registerSingleton)(y.IExtHostDebugService,C.ExtHostDebugService),(0,m.registerSingleton)(I.IExtHostSearch,i.NativeExtHostSearch),(0,m.registerSingleton)(a.IExtHostTask,D.ExtHostTask),(0,m.registerSingleton)(b.IExtHostTerminalService,L.ExtHostTerminalService),(0,m.registerSingleton)(f.IExtHostTunnelService,S.ExtHostTunnelService)}),define(ge[288],pe([0,1,124,298,71,15,106,137,190,224,271,22,102,28,104,18,113,274,287]),function(Y,e,m,L,D,C,i,k,S,y,T,I,a,b,f,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let u=0;u<process.execArgv.length;u++)process.execArgv[u]==="--inspect-port=0"&&(process.execArgv.splice(u,1),u--)}();const P=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const t=Y.__$__nodeRequire("module"),u=t._load;t._load=function(d){if(d==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return u.apply(this,arguments)}})();const p=process.exit.bind(process);function o(t){process.exit=function(u){if(t)p(u);else{const d=new Error("An extension called process.exit() and this was prevented.");console.warn(d.stack)}},process.crash=function(){const u=new Error("An extension called process.crash() and this was prevented.");console.warn(u.stack)}}let r=function(t){p()};function g(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((t,u)=>{let d=null,l=setTimeout(()=>{r("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const h=108e5,c=3e5,_=new w.ProcessTimeRunOnceScheduler(()=>r("renderer disconnected for too long (1)"),h),A=new w.ProcessTimeRunOnceScheduler(()=>r("renderer disconnected for too long (2)"),c);process.on("message",(x,O)=>{if(x&&x.type==="VSCODE_EXTHOST_IPC_SOCKET"){const F=I.VSBuffer.wrap(Buffer.from(x.initialDataChunk,"base64"));let $;if(x.skipWebSocketFrames)$=new k.NodeSocket(O);else{const M=I.VSBuffer.wrap(Buffer.from(x.inflateBytes,"base64"));$=new k.WebSocketNodeSocket(new k.NodeSocket(O),x.permessageDeflate,M,!1)}d?(_.cancel(),A.cancel(),d.beginAcceptReconnection($,F),d.endAcceptReconnection()):(clearTimeout(l),d=new i.PersistentProtocol($,F),d.onDidDispose(()=>r("renderer disconnected")),t(d),d.onSocketClose(()=>{_.schedule()}))}if(x&&x.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(A.isScheduled())return;_.isScheduled()&&A.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const t=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((u,d)=>{const l=m.createConnection(t,()=>{l.removeListener("error",d),u(new i.PersistentProtocol(new k.NodeSocket(l)))});l.once("error",d),l.on("close",()=>{r("renderer closed the socket")})})}}async function s(){const t=await g();return new class{constructor(){this._onMessage=new i.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,t.onMessage(u=>{(0,y.isMessageOfType)(u,2)?(this._terminating=!0,r("received terminate message from renderer")):this._onMessage.fire(u)})}send(u){this._terminating||t.send(u)}drain(){return t.drain()}}}function v(t){return new Promise(u=>{const d=t.onMessage(l=>{d.dispose();const h=JSON.parse(l.toString()),c=h.commit,_=S.default.commit;c&&_&&c!==_&&p(55);let A=0;setInterval(function(){try{process.kill(h.parentPid,0),A=0}catch(x){x&&x.code==="EPERM"?(A++,A>=3&&r(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${x.message} (code: ${x.code}) (errno: ${x.errno})`)):r(`parent process ${h.parentPid} does not exist anymore: ${x.message} (code: ${x.code}) (errno: ${x.errno})`)}},1e3);let R;try{R=Y.__$__nodeRequire("native-watchdog"),R.start(h.parentPid)}catch(x){(0,C.onUnexpectedError)(x)}t.send((0,y.createMessageOfType)(0)),u({protocol:t,initData:h})});t.send((0,y.createMessageOfType)(1))})}async function n(){const t=[];process.on("unhandledRejection",(A,R)=>{t.push(R),setTimeout(()=>{const x=t.indexOf(R);x>=0&&R.catch(O=>{t.splice(x,1),(0,C.isPromiseCanceledError)(O)||(console.warn(`rejected promise not handled within 1 second: ${O}`),O&&O.stack&&console.warn(`stack trace: ${O.stack}`),A&&(0,C.onUnexpectedError)(A))})},1e3)}),process.on("rejectionHandled",A=>{const R=t.indexOf(A);R>=0&&t.splice(R,1)}),process.on("uncaughtException",function(A){(0,C.onUnexpectedError)(A)}),D.mark("code/extHost/willConnectToRenderer");const u=await s();D.mark("code/extHost/didConnectToRenderer");const d=await v(u);D.mark("code/extHost/didWaitForInitData");const{initData:l}=d;o(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=P.useHostProxy!==void 0?P.useHostProxy!=="false":void 0,l.environment.skipWorkspaceStorageLock=(0,E.boolean)(P.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(R){p(R)}exists(R){return b.Promises.exists(R)}realpath(R){return(0,f.realpath)(R)}};let c=null;if(l.remote.authority&&P.uriTransformerPath)try{const R=Y.__$__nodeRequire(P.uriTransformerPath)(l.remote.authority);c=new a.URITransformer(R)}catch(A){console.error(A)}const _=new T.ExtensionHostMain(d.protocol,l,h,c);r=A=>_.terminate(A)}e.startExtensionHostProcess=n}),define(ge[299],pe([0,1,288]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1e473b624f088fc05269891170a8ffa1c84a35a6/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
